/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/base/common/charCode","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/base/common/extpath","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Te=function($e){for(var e=[],y=0,D=$e.length;y<D;y++)e[y]=Re[$e[y]];return e};define(Re[71],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=D,e.$bi=P,e.$ci=N;function y(R){return(O,p,s)=>{let I=null,b=null;if(typeof s.value=="function"?(I="value",b=s.value):typeof s.get=="function"&&(I="get",b=s.get),!b)throw new Error("not supported");s[I]=R(b,p)}}function D(R,O,p){let s=null,I=null;if(typeof p.value=="function"?(s="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(s="get",I=p.get),!I)throw new Error("not supported");const b=`$memoize$${O}`;p[s]=function(...u){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[b]}}function P(R,O,p){return y((s,I)=>{const b=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[b]),O&&(this[u]=O(this[u],...E),E=[this[u]]),this[b]=setTimeout(()=>{s.apply(this,E),this[u]=p?p():void 0},R)}})}function N(R,O,p){return y((s,I)=>{const b=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,E=`$throttle$lastRun$${I}`,f=`$throttle$pending$${I}`;return function(...r){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...r)),this[f])return;const c=this[E]+R;c<=Date.now()?(this[E]=Date.now(),s.apply(this,[this[u]]),this[u]=p?p():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),s.apply(this,[this[u]]),this[u]=p?p():void 0},c-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function($e,e,y,D){D===void 0&&(D=y);var P=Object.getOwnPropertyDescriptor(e,y);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[y]}}),Object.defineProperty($e,D,P)}:function($e,e,y,D){D===void 0&&(D=y),$e[D]=e[y]}),Kn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),qe=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var y in $e)y!=="default"&&Object.prototype.hasOwnProperty.call($e,y)&&Hn(e,$e,y);return Kn(e,$e),e};define(Re[136],Te([1,0,17]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=P,e.$$c=N,e.$_c=R,e.$ad=O,e.$bd=p,e.$cd=s,y=qe(y);const D=(E,f)=>E===f;e.$9c=D;function P(E=e.$9c){return(f,r)=>y.$wb(f,r,E)}function N(){return(E,f)=>JSON.stringify(E)===JSON.stringify(f)}function R(){return(E,f)=>E.equals(f)}function O(E,f,r){if(r!==void 0){const c=E;return c==null||f===void 0||f===null?f===c:r(c,f)}else{const c=E;return(l,h)=>l==null||h===void 0||h===null?h===l:c(l,h)}}function p(E,f){if(E===f)return!0;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let r=0;r<E.length;r++)if(!p(E[r],f[r]))return!1;return!0}if(E&&typeof E=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const r=E,c=f,l=Object.keys(r),h=Object.keys(c),i=new Set(h);if(l.length!==h.length)return!1;for(const n of l)if(!i.has(n)||!p(r[n],c[n]))return!1;return!0}return!1}function s(E){return JSON.stringify(u(E))}let I=0;const b=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const f=E,r=Object.create(null);for(const c of Object.keys(f).sort())r[c]=u(f[c]);return r}else{let f=b.get(E);return f===void 0&&(f=I++,b.set(E,f)),f+"----2b76a038c20c4bcc"}return E}}),define(Re[97],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=void 0;class y{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$IQ=y,e.$JQ=new y("id#")}),define(Re[137],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Zn=R,e.$1n=b,e.$2n=u,e.$3n=E,e.$4n=f,e.$5n=r,e.$6n=c,e.$7n=l,e.$8n=h,e.$9n=i,e.$0n=n;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,o=!1){let a=0;const m=t.length;let g="",d=0,S=D.Unknown,k=y.None;function v(L){let Z=0,J=0;for(;Z<L;){const U=t.charCodeAt(a);if(U>=I._0&&U<=I._9)J=J*16+U-I._0;else if(U>=I.A&&U<=I.F)J=J*16+U-I.A+10;else if(U>=I.a&&U<=I.f)J=J*16+U-I.a+10;else break;a++,Z++}return Z<L&&(J=-1),J}function C(L){a=L,g="",d=0,S=D.Unknown,k=y.None}function T(){const L=a;if(t.charCodeAt(a)===I._0)a++;else for(a++;a<t.length&&s(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===I.dot)if(a++,a<t.length&&s(t.charCodeAt(a)))for(a++;a<t.length&&s(t.charCodeAt(a));)a++;else return k=y.UnexpectedEndOfNumber,t.substring(L,a);let Z=a;if(a<t.length&&(t.charCodeAt(a)===I.E||t.charCodeAt(a)===I.e))if(a++,(a<t.length&&t.charCodeAt(a)===I.plus||t.charCodeAt(a)===I.minus)&&a++,a<t.length&&s(t.charCodeAt(a))){for(a++;a<t.length&&s(t.charCodeAt(a));)a++;Z=a}else k=y.UnexpectedEndOfNumber;return t.substring(L,Z)}function $(){let L="",Z=a;for(;;){if(a>=m){L+=t.substring(Z,a),k=y.UnexpectedEndOfString;break}const J=t.charCodeAt(a);if(J===I.doubleQuote){L+=t.substring(Z,a),a++;break}if(J===I.backslash){if(L+=t.substring(Z,a),a++,a>=m){k=y.UnexpectedEndOfString;break}switch(t.charCodeAt(a++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const V=v(4);V>=0?L+=String.fromCharCode(V):k=y.InvalidUnicode;break}default:k=y.InvalidEscapeCharacter}Z=a;continue}if(J>=0&&J<=31)if(p(J)){L+=t.substring(Z,a),k=y.UnexpectedEndOfString;break}else k=y.InvalidCharacter;a++}return L}function w(){if(g="",k=y.None,d=a,a>=m)return d=m,S=D.EOF;let L=t.charCodeAt(a);if(O(L)){do a++,g+=String.fromCharCode(L),L=t.charCodeAt(a);while(O(L));return S=D.Trivia}if(p(L))return a++,g+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(a)===I.lineFeed&&(a++,g+=`
`),S=D.LineBreakTrivia;switch(L){case I.openBrace:return a++,S=D.OpenBraceToken;case I.closeBrace:return a++,S=D.CloseBraceToken;case I.openBracket:return a++,S=D.OpenBracketToken;case I.closeBracket:return a++,S=D.CloseBracketToken;case I.colon:return a++,S=D.ColonToken;case I.comma:return a++,S=D.CommaToken;case I.doubleQuote:return a++,g=$(),S=D.StringLiteral;case I.slash:{const Z=a-1;if(t.charCodeAt(a+1)===I.slash){for(a+=2;a<m&&!p(t.charCodeAt(a));)a++;return g=t.substring(Z,a),S=D.LineCommentTrivia}if(t.charCodeAt(a+1)===I.asterisk){a+=2;const J=m-1;let U=!1;for(;a<J;){if(t.charCodeAt(a)===I.asterisk&&t.charCodeAt(a+1)===I.slash){a+=2,U=!0;break}a++}return U||(a++,k=y.UnexpectedEndOfComment),g=t.substring(Z,a),S=D.BlockCommentTrivia}return g+=String.fromCharCode(L),a++,S=D.Unknown}case I.minus:if(g+=String.fromCharCode(L),a++,a===m||!s(t.charCodeAt(a)))return S=D.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return g+=T(),S=D.NumericLiteral;default:for(;a<m&&M(L);)a++,L=t.charCodeAt(a);if(d!==a){switch(g=t.substring(d,a),g){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return g+=String.fromCharCode(L),a++,S=D.Unknown}}function M(L){if(O(L)||p(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function A(){let L;do L=w();while(L>=D.LineCommentTrivia&&L<=D.Trivia);return L}return{setPosition:C,getPosition:()=>a,scan:o?A:w,getToken:()=>S,getTokenValue:()=>g,getTokenOffset:()=>d,getTokenLength:()=>a-d,getTokenError:()=>k}}function O(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function b(t,o){const a=[],m=new Object;let g;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(v,C,T,$){d.value=v,d.offset=C,d.length=T,d.type=$,d.colonOffset=void 0,g=d}try{i(t,{onObjectBegin:(v,C)=>{if(o<=v)throw m;g=void 0,S=o>v,a.push("")},onObjectProperty:(v,C,T)=>{if(o<C||(k(v,C,T,"property"),a[a.length-1]=v,o<=C+T))throw m},onObjectEnd:(v,C)=>{if(o<=v)throw m;g=void 0,a.pop()},onArrayBegin:(v,C)=>{if(o<=v)throw m;g=void 0,a.push(0)},onArrayEnd:(v,C)=>{if(o<=v)throw m;g=void 0,a.pop()},onLiteralValue:(v,C,T)=>{if(o<C||(k(v,C,T,n(v)),o<=C+T))throw m},onSeparator:(v,C,T)=>{if(o<=C)throw m;if(v===":"&&g&&g.type==="property")g.colonOffset=C,S=!1,g=void 0;else if(v===","){const $=a[a.length-1];typeof $=="number"?a[a.length-1]=$+1:(S=!0,a[a.length-1]=""),g=void 0}}})}catch(v){if(v!==m)throw v}return{path:a,previousNode:g,isAtPropertyKey:S,matches:v=>{let C=0;for(let T=0;C<v.length&&T<a.length;T++)if(v[C]===a[T]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}function u(t,o=[],a=N.DEFAULT){let m=null,g=[];const d=[];function S(v){Array.isArray(g)?g.push(v):m!==null&&(g[m]=v)}return i(t,{onObjectBegin:()=>{const v={};S(v),d.push(g),g=v,m=null},onObjectProperty:v=>{m=v},onObjectEnd:()=>{g=d.pop()},onArrayBegin:()=>{const v=[];S(v),d.push(g),g=v,m=null},onArrayEnd:()=>{g=d.pop()},onLiteralValue:S,onError:(v,C,T)=>{o.push({error:v,offset:C,length:T})}},a),g[0]}function E(t,o=[],a=N.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(v){m.type==="property"&&(m.length=v-m.offset,m=m.parent)}function d(v){return m.children.push(v),v}i(t,{onObjectBegin:v=>{m=d({type:"object",offset:v,length:-1,parent:m,children:[]})},onObjectProperty:(v,C,T)=>{m=d({type:"property",offset:C,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:v,offset:C,length:T,parent:m})},onObjectEnd:(v,C)=>{m.length=v+C-m.offset,m=m.parent,g(v+C)},onArrayBegin:(v,C)=>{m=d({type:"array",offset:v,length:-1,parent:m,children:[]})},onArrayEnd:(v,C)=>{m.length=v+C-m.offset,m=m.parent,g(v+C)},onLiteralValue:(v,C,T)=>{d({type:n(v),offset:C,length:T,parent:m,value:v}),g(C+T)},onSeparator:(v,C,T)=>{m.type==="property"&&(v===":"?m.colonOffset=C:v===","&&g(C))},onError:(v,C,T)=>{o.push({error:v,offset:C,length:T})}},a);const k=m.children[0];return k&&delete k.parent,k}function f(t,o){if(!t)return;let a=t;for(const m of o)if(typeof m=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let g=!1;for(const d of a.children)if(Array.isArray(d.children)&&d.children[0].value===m){a=d.children[1],g=!0;break}if(!g)return}else{const g=m;if(a.type!=="array"||g<0||!Array.isArray(a.children)||g>=a.children.length)return;a=a.children[g]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;o.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&o.push(a)}return o}function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const a of t.children){const m=a.children[1];m&&(o[a.children[0].value]=c(m))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,o,a=!1){return o>=t.offset&&o<t.offset+t.length||a&&o===t.offset+t.length}function h(t,o,a=!1){if(l(t,o,a)){const m=t.children;if(Array.isArray(m))for(let g=0;g<m.length&&m[g].offset<=o;g++){const d=h(m[g],o,a);if(d)return d}return t}}function i(t,o,a=N.DEFAULT){const m=R(t,!1);function g(se){return se?()=>se(m.getTokenOffset(),m.getTokenLength()):()=>!0}function d(se){return se?ce=>se(ce,m.getTokenOffset(),m.getTokenLength()):()=>!0}const S=g(o.onObjectBegin),k=d(o.onObjectProperty),v=g(o.onObjectEnd),C=g(o.onArrayBegin),T=g(o.onArrayEnd),$=d(o.onLiteralValue),w=d(o.onSeparator),M=g(o.onComment),A=d(o.onError),L=a&&a.disallowComments,Z=a&&a.allowTrailingComma;function J(){for(;;){const se=m.scan();switch(m.getTokenError()){case y.InvalidUnicode:U(P.InvalidUnicode);break;case y.InvalidEscapeCharacter:U(P.InvalidEscapeCharacter);break;case y.UnexpectedEndOfNumber:U(P.UnexpectedEndOfNumber);break;case y.UnexpectedEndOfComment:L||U(P.UnexpectedEndOfComment);break;case y.UnexpectedEndOfString:U(P.UnexpectedEndOfString);break;case y.InvalidCharacter:U(P.InvalidCharacter);break}switch(se){case D.LineCommentTrivia:case D.BlockCommentTrivia:L?U(P.InvalidCommentToken):M();break;case D.Unknown:U(P.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return se}}}function U(se,ce=[],x=[]){if(A(se),ce.length+x.length>0){let we=m.getToken();for(;we!==D.EOF;){if(ce.indexOf(we)!==-1){J();break}else if(x.indexOf(we)!==-1)break;we=J()}}}function V(se){const ce=m.getTokenValue();return se?$(ce):k(ce),J(),!0}function Q(){switch(m.getToken()){case D.NumericLiteral:{let se=0;try{se=JSON.parse(m.getTokenValue()),typeof se!="number"&&(U(P.InvalidNumberFormat),se=0)}catch{U(P.InvalidNumberFormat)}$(se);break}case D.NullKeyword:$(null);break;case D.TrueKeyword:$(!0);break;case D.FalseKeyword:$(!1);break;default:return!1}return J(),!0}function ne(){return m.getToken()!==D.StringLiteral?(U(P.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(V(!1),m.getToken()===D.ColonToken?(w(":"),J(),ae()||U(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):U(P.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function ue(){S(),J();let se=!1;for(;m.getToken()!==D.CloseBraceToken&&m.getToken()!==D.EOF;){if(m.getToken()===D.CommaToken){if(se||U(P.ValueExpected,[],[]),w(","),J(),m.getToken()===D.CloseBraceToken&&Z)break}else se&&U(P.CommaExpected,[],[]);ne()||U(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),se=!0}return v(),m.getToken()!==D.CloseBraceToken?U(P.CloseBraceExpected,[D.CloseBraceToken],[]):J(),!0}function _(){C(),J();let se=!1;for(;m.getToken()!==D.CloseBracketToken&&m.getToken()!==D.EOF;){if(m.getToken()===D.CommaToken){if(se||U(P.ValueExpected,[],[]),w(","),J(),m.getToken()===D.CloseBracketToken&&Z)break}else se&&U(P.CommaExpected,[],[]);ae()||U(P.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),se=!0}return T(),m.getToken()!==D.CloseBracketToken?U(P.CloseBracketExpected,[D.CloseBracketToken],[]):J(),!0}function ae(){switch(m.getToken()){case D.OpenBracketToken:return _();case D.OpenBraceToken:return ue();case D.StringLiteral:return V(!0);default:return Q()}}return J(),m.getToken()===D.EOF?a.allowEmptyContent?!0:(U(P.ValueExpected,[],[]),!1):ae()?(m.getToken()!==D.EOF&&U(P.EndOfFileExpected,[],[]),!0):(U(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[138],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=y;function y(N){let R=!1;const O=new Map,p=new Map;if(P(N,r=>{if(N===r)return!0;const c=JSON.stringify(r);if(c.length<30)return!0;const l=O.get(c);if(!l){const h={schemas:[r]};return O.set(c,h),p.set(r,h),!0}return l.schemas.push(r),p.set(r,l),R=!0,!1}),O.clear(),!R)return JSON.stringify(N);let I="$defs";for(;N.hasOwnProperty(I);)I+="_";const b=[];function u(r){return JSON.stringify(r,(c,l)=>{if(l!==r){const h=p.get(l);if(h&&h.schemas.length>1)return h.id||(h.id=`_${b.length}`,b.push(h.schemas[0])),{$ref:`#/${I}/${h.id}`}}return l})}const E=u(N),f=[];for(let r=0;r<b.length;r++)f.push(`"_${r}":${u(b[r])}`);return f.length?`${E.substring(0,E.length-1)},"${I}":{${f.join(",")}}}`:E}function D(N){return typeof N=="object"&&N!==null}function P(N,R){if(!N||typeof N!="object")return;const O=(...E)=>{for(const f of E)D(f)&&b.push(f)},p=(...E)=>{for(const f of E)if(D(f))for(const r in f){const c=f[r];D(c)&&b.push(c)}},s=(...E)=>{for(const f of E)if(Array.isArray(f))for(const r of f)D(r)&&b.push(r)},I=E=>{if(Array.isArray(E))for(const f of E)D(f)&&b.push(f);else D(E)&&b.push(E)},b=[N];let u=b.pop();for(;u;)R(u)&&(O(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),p(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),s(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=b.pop()}}),function($e,e){typeof define=="function"&&define.amd?define(Re[139],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}$e.defaults=e();function y(Ye){$e.defaults=Ye}const D=/[&<>"']/,P=new RegExp(D.source,"g"),N=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,R=new RegExp(N.source,"g"),O={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=Ye=>O[Ye];function s(Ye,he){if(he){if(D.test(Ye))return Ye.replace(P,p)}else if(N.test(Ye))return Ye.replace(R,p);return Ye}const I=/(^|[^\[])\^/g;function b(Ye,he){let pe=typeof Ye=="string"?Ye:Ye.source;he=he||"";const ye={replace:(Ce,fe)=>{let be=typeof fe=="string"?fe:fe.source;return be=be.replace(I,"$1"),pe=pe.replace(Ce,be),ye},getRegex:()=>new RegExp(pe,he)};return ye}function u(Ye){try{Ye=encodeURI(Ye).replace(/%25/g,"%")}catch{return null}return Ye}const E={exec:()=>null};function f(Ye,he){const pe=Ye.replace(/\|/g,(fe,be,X)=>{let W=!1,de=be;for(;--de>=0&&X[de]==="\\";)W=!W;return W?"|":" |"}),ye=pe.split(/ \|/);let Ce=0;if(ye[0].trim()||ye.shift(),ye.length>0&&!ye[ye.length-1].trim()&&ye.pop(),he)if(ye.length>he)ye.splice(he);else for(;ye.length<he;)ye.push("");for(;Ce<ye.length;Ce++)ye[Ce]=ye[Ce].trim().replace(/\\\|/g,"|");return ye}function r(Ye,he,pe){const ye=Ye.length;if(ye===0)return"";let Ce=0;for(;Ce<ye;){const fe=Ye.charAt(ye-Ce-1);if(fe===he&&!pe)Ce++;else if(fe!==he&&pe)Ce++;else break}return Ye.slice(0,ye-Ce)}function c(Ye,he){if(Ye.indexOf(he[1])===-1)return-1;let pe=0;for(let ye=0;ye<Ye.length;ye++)if(Ye[ye]==="\\")ye++;else if(Ye[ye]===he[0])pe++;else if(Ye[ye]===he[1]&&(pe--,pe<0))return ye;return-1}function l(Ye,he,pe,ye){const Ce=he.href,fe=he.title?s(he.title):null,be=Ye[1].replace(/\\([\[\]])/g,"$1");if(Ye[0].charAt(0)!=="!"){ye.state.inLink=!0;const X={type:"link",raw:pe,href:Ce,title:fe,text:be,tokens:ye.inlineTokens(be)};return ye.state.inLink=!1,X}return{type:"image",raw:pe,href:Ce,title:fe,text:s(be)}}function h(Ye,he){const pe=Ye.match(/^(\s+)(?:```)/);if(pe===null)return he;const ye=pe[1];return he.split(`
`).map(Ce=>{const fe=Ce.match(/^\s+/);if(fe===null)return Ce;const[be]=fe;return be.length>=ye.length?Ce.slice(ye.length):Ce}).join(`
`)}class i{options;rules;lexer;constructor(he){this.options=he||$e.defaults}space(he){const pe=this.rules.block.newline.exec(he);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(he){const pe=this.rules.block.code.exec(he);if(pe){const ye=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ye:r(ye,`
`)}}}fences(he){const pe=this.rules.block.fences.exec(he);if(pe){const ye=pe[0],Ce=h(ye,pe[3]||"");return{type:"code",raw:ye,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Ce}}}heading(he){const pe=this.rules.block.heading.exec(he);if(pe){let ye=pe[2].trim();if(/#$/.test(ye)){const Ce=r(ye,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(ye=Ce.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:ye,tokens:this.lexer.inline(ye)}}}hr(he){const pe=this.rules.block.hr.exec(he);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(he){const pe=this.rules.block.blockquote.exec(he);if(pe){let ye=r(pe[0],`
`).split(`
`),Ce="",fe="";const be=[];for(;ye.length>0;){let X=!1;const W=[];let de;for(de=0;de<ye.length;de++)if(/^ {0,3}>/.test(ye[de]))W.push(ye[de]),X=!0;else if(!X)W.push(ye[de]);else break;ye=ye.slice(de);const je=W.join(`
`),Qe=je.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Ce=Ce?`${Ce}
${je}`:je,fe=fe?`${fe}
${Qe}`:Qe;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Qe,be,!0),this.lexer.state.top=st,ye.length===0)break;const ht=be[be.length-1];if(ht?.type==="code")break;if(ht?.type==="blockquote"){const gt=ht,Rt=gt.raw+`
`+ye.join(`
`),At=this.blockquote(Rt);be[be.length-1]=At,Ce=Ce.substring(0,Ce.length-gt.raw.length)+At.raw,fe=fe.substring(0,fe.length-gt.text.length)+At.text;break}else if(ht?.type==="list"){const gt=ht,Rt=gt.raw+`
`+ye.join(`
`),At=this.list(Rt);be[be.length-1]=At,Ce=Ce.substring(0,Ce.length-ht.raw.length)+At.raw,fe=fe.substring(0,fe.length-gt.raw.length)+At.raw,ye=Rt.substring(be[be.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Ce,tokens:be,text:fe}}}list(he){let pe=this.rules.block.list.exec(he);if(pe){let ye=pe[1].trim();const Ce=ye.length>1,fe={type:"list",raw:"",ordered:Ce,start:Ce?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Ce?`\\d{1,9}\\${ye.slice(-1)}`:`\\${ye}`,this.options.pedantic&&(ye=Ce?ye:"[*+-]");const be=new RegExp(`^( {0,3}${ye})((?:[	 ][^\\n]*)?(?:\\n|$))`);let X=!1;for(;he;){let W=!1,de="",je="";if(!(pe=be.exec(he))||this.rules.block.hr.test(he))break;de=pe[0],he=he.substring(de.length);let Qe=pe[2].split(`
`,1)[0].replace(/^\t+/,Qt=>" ".repeat(3*Qt.length)),st=he.split(`
`,1)[0],ht=!Qe.trim(),gt=0;if(this.options.pedantic?(gt=2,je=Qe.trimStart()):ht?gt=pe[1].length+1:(gt=pe[2].search(/[^ ]/),gt=gt>4?1:gt,je=Qe.slice(gt),gt+=pe[1].length),ht&&/^ *$/.test(st)&&(de+=st+`
`,he=he.substring(st.length+1),W=!0),!W){const Qt=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),_t=new RegExp(`^ {0,${Math.min(3,gt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Ze=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:\`\`\`|~~~)`),Ot=new RegExp(`^ {0,${Math.min(3,gt-1)}}#`);for(;he;){const Ut=he.split(`
`,1)[0];if(st=Ut,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(st)||Ot.test(st)||Qt.test(st)||_t.test(he))break;if(st.search(/[^ ]/)>=gt||!st.trim())je+=`
`+st.slice(gt);else{if(ht||Qe.search(/[^ ]/)>=4||Ze.test(Qe)||Ot.test(Qe)||_t.test(Qe))break;je+=`
`+st}!ht&&!st.trim()&&(ht=!0),de+=Ut+`
`,he=he.substring(Ut.length+1),Qe=st.slice(gt)}}fe.loose||(X?fe.loose=!0:/\n *\n *$/.test(de)&&(X=!0));let Rt=null,At;this.options.gfm&&(Rt=/^\[[ xX]\] /.exec(je),Rt&&(At=Rt[0]!=="[ ] ",je=je.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:!!Rt,checked:At,loose:!1,text:je,tokens:[]}),fe.raw+=de}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let W=0;W<fe.items.length;W++)if(this.lexer.state.top=!1,fe.items[W].tokens=this.lexer.blockTokens(fe.items[W].text,[]),!fe.loose){const de=fe.items[W].tokens.filter(Qe=>Qe.type==="space"),je=de.length>0&&de.some(Qe=>/\n.*\n/.test(Qe.raw));fe.loose=je}if(fe.loose)for(let W=0;W<fe.items.length;W++)fe.items[W].loose=!0;return fe}}html(he){const pe=this.rules.block.html.exec(he);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(he){const pe=this.rules.block.def.exec(he);if(pe){const ye=pe[1].toLowerCase().replace(/\s+/g," "),Ce=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:ye,raw:pe[0],href:Ce,title:fe}}}table(he){const pe=this.rules.block.table.exec(he);if(!pe||!/[:|]/.test(pe[2]))return;const ye=f(pe[1]),Ce=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],be={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(ye.length===Ce.length){for(const X of Ce)/^ *-+: *$/.test(X)?be.align.push("right"):/^ *:-+: *$/.test(X)?be.align.push("center"):/^ *:-+ *$/.test(X)?be.align.push("left"):be.align.push(null);for(let X=0;X<ye.length;X++)be.header.push({text:ye[X],tokens:this.lexer.inline(ye[X]),header:!0,align:be.align[X]});for(const X of fe)be.rows.push(f(X,be.header.length).map((W,de)=>({text:W,tokens:this.lexer.inline(W),header:!1,align:be.align[de]})));return be}}lheading(he){const pe=this.rules.block.lheading.exec(he);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(he){const pe=this.rules.block.paragraph.exec(he);if(pe){const ye=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:ye,tokens:this.lexer.inline(ye)}}}text(he){const pe=this.rules.block.text.exec(he);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(he){const pe=this.rules.inline.escape.exec(he);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(he){const pe=this.rules.inline.tag.exec(he);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(he){const pe=this.rules.inline.link.exec(he);if(pe){const ye=pe[2].trim();if(!this.options.pedantic&&/^</.test(ye)){if(!/>$/.test(ye))return;const be=r(ye.slice(0,-1),"\\");if((ye.length-be.length)%2===0)return}else{const be=c(pe[2],"()");if(be>-1){const W=(pe[0].indexOf("!")===0?5:4)+pe[1].length+be;pe[2]=pe[2].substring(0,be),pe[0]=pe[0].substring(0,W).trim(),pe[3]=""}}let Ce=pe[2],fe="";if(this.options.pedantic){const be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);be&&(Ce=be[1],fe=be[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(ye)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),l(pe,{href:Ce&&Ce.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(he,pe){let ye;if((ye=this.rules.inline.reflink.exec(he))||(ye=this.rules.inline.nolink.exec(he))){const Ce=(ye[2]||ye[1]).replace(/\s+/g," "),fe=pe[Ce.toLowerCase()];if(!fe){const be=ye[0].charAt(0);return{type:"text",raw:be,text:be}}return l(ye,fe,ye[0],this.lexer)}}emStrong(he,pe,ye=""){let Ce=this.rules.inline.emStrongLDelim.exec(he);if(!Ce||Ce[3]&&ye.match(/[\p{L}\p{N}]/u))return;if(!(Ce[1]||Ce[2]||"")||!ye||this.rules.inline.punctuation.exec(ye)){const be=[...Ce[0]].length-1;let X,W,de=be,je=0;const Qe=Ce[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Qe.lastIndex=0,pe=pe.slice(-1*he.length+be);(Ce=Qe.exec(pe))!=null;){if(X=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!X)continue;if(W=[...X].length,Ce[3]||Ce[4]){de+=W;continue}else if((Ce[5]||Ce[6])&&be%3&&!((be+W)%3)){je+=W;continue}if(de-=W,de>0)continue;W=Math.min(W,W+de+je);const st=[...Ce[0]][0].length,ht=he.slice(0,be+Ce.index+st+W);if(Math.min(be,W)%2){const Rt=ht.slice(1,-1);return{type:"em",raw:ht,text:Rt,tokens:this.lexer.inlineTokens(Rt)}}const gt=ht.slice(2,-2);return{type:"strong",raw:ht,text:gt,tokens:this.lexer.inlineTokens(gt)}}}}codespan(he){const pe=this.rules.inline.code.exec(he);if(pe){let ye=pe[2].replace(/\n/g," ");const Ce=/[^ ]/.test(ye),fe=/^ /.test(ye)&&/ $/.test(ye);return Ce&&fe&&(ye=ye.substring(1,ye.length-1)),ye=s(ye,!0),{type:"codespan",raw:pe[0],text:ye}}}br(he){const pe=this.rules.inline.br.exec(he);if(pe)return{type:"br",raw:pe[0]}}del(he){const pe=this.rules.inline.del.exec(he);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(he){const pe=this.rules.inline.autolink.exec(he);if(pe){let ye,Ce;return pe[2]==="@"?(ye=s(pe[1]),Ce="mailto:"+ye):(ye=s(pe[1]),Ce=ye),{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}url(he){let pe;if(pe=this.rules.inline.url.exec(he)){let ye,Ce;if(pe[2]==="@")ye=s(pe[0]),Ce="mailto:"+ye;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);ye=s(pe[0]),pe[1]==="www."?Ce="http://"+pe[0]:Ce=pe[0]}return{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}inlineText(he){const pe=this.rules.inline.text.exec(he);if(pe){let ye;return this.lexer.state.inRawBlock?ye=pe[0]:ye=s(pe[0]),{type:"text",raw:pe[0],text:ye}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,a=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,m=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,g=/(?:[*+-]|\d{1,9}[.)])/,d=b(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,g).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),S=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,v=/(?!\s*\])(?:\\.|[^\[\]\\])+/,C=b(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",v).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),T=b(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,g).getRegex(),$="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",w=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,M=b("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",w).replace("tag",$).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A=b(S).replace("hr",a).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),Z={blockquote:b(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",A).getRegex(),code:t,def:C,fences:o,heading:m,hr:a,html:M,lheading:d,list:T,newline:n,paragraph:A,table:E,text:k},J=b("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",a).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),U={...Z,table:J,paragraph:b(S).replace("hr",a).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",J).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex()},V={...Z,html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",w).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:b(S).replace("hr",a).replace("heading",` *#{1,6} *[^
]`).replace("lheading",d).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},Q=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,ne=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,ue=/^( {2,}|\\)\n(?!\s*$)/,_=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,ae="\\p{P}\\p{S}",se=b(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,ae).getRegex(),ce=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,x=b(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,ae).getRegex(),we=b("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,ae).getRegex(),Ie=b("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,ae).getRegex(),Y=b(/\\([punct])/,"gu").replace(/punct/g,ae).getRegex(),q=b(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),ie=b(w).replace("(?:-->|$)","-->").getRegex(),ve=b("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",ie).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),Pe=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Fe=b(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",Pe).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),Be=b(/^!?\[(label)\]\[(ref)\]/).replace("label",Pe).replace("ref",v).getRegex(),xe=b(/^!?\[(ref)\](?:\[\])?/).replace("ref",v).getRegex(),nt=b("reflink|nolink(?!\\()","g").replace("reflink",Be).replace("nolink",xe).getRegex(),ut={_backpedal:E,anyPunctuation:Y,autolink:q,blockSkip:ce,br:ue,code:ne,del:E,emStrongLDelim:x,emStrongRDelimAst:we,emStrongRDelimUnd:Ie,escape:Q,link:Fe,nolink:xe,punctuation:se,reflink:Be,reflinkSearch:nt,tag:ve,text:_,url:E},pt={...ut,link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",Pe).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Pe).getRegex()},lt={...ut,escape:b(Q).replace("])","~|])").getRegex(),url:b(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},et={...lt,br:b(ue).replace("{2,}","*").getRegex(),text:b(lt.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Ne={normal:Z,gfm:U,pedantic:V},Me={normal:ut,gfm:lt,breaks:et,pedantic:pt};class Le{tokens;options;state;tokenizer;inlineQueue;constructor(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||$e.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Ne.normal,inline:Me.normal};this.options.pedantic?(pe.block=Ne.pedantic,pe.inline=Me.pedantic):this.options.gfm&&(pe.block=Ne.gfm,this.options.breaks?pe.inline=Me.breaks:pe.inline=Me.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Ne,inline:Me}}static lex(he,pe){return new Le(pe).lex(he)}static lexInline(he,pe){return new Le(pe).inlineTokens(he)}lex(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const ye=this.inlineQueue[pe];this.inlineTokens(ye.src,ye.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(he,pe=[],ye=!1){this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,(X,W,de)=>W+"    ".repeat(de.length));let Ce,fe,be;for(;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(X=>(Ce=X.call({lexer:this},he,pe))?(he=he.substring(Ce.raw.length),pe.push(Ce),!0):!1))){if(Ce=this.tokenizer.space(he)){he=he.substring(Ce.raw.length),Ce.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Ce);continue}if(Ce=this.tokenizer.code(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(Ce=this.tokenizer.fences(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.heading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.hr(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.blockquote(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.list(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.html(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.def(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.lheading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(be=he,this.options.extensions&&this.options.extensions.startBlock){let X=1/0;const W=he.slice(1);let de;this.options.extensions.startBlock.forEach(je=>{de=je.call({lexer:this},W),typeof de=="number"&&de>=0&&(X=Math.min(X,de))}),X<1/0&&X>=0&&(be=he.substring(0,X+1))}if(this.state.top&&(Ce=this.tokenizer.paragraph(be))){fe=pe[pe.length-1],ye&&fe?.type==="paragraph"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce),ye=be.length!==he.length,he=he.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(he){const X="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,pe}inline(he,pe=[]){return this.inlineQueue.push({src:he,tokens:pe}),pe}inlineTokens(he,pe=[]){let ye,Ce,fe,be=he,X,W,de;if(this.tokens.links){const je=Object.keys(this.tokens.links);if(je.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)je.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,X.index)+"["+"a".repeat(X[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,X.index)+"["+"a".repeat(X[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.anyPunctuation.exec(be))!=null;)be=be.slice(0,X.index)+"++"+be.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;he;)if(W||(de=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(je=>(ye=je.call({lexer:this},he,pe))?(he=he.substring(ye.raw.length),pe.push(ye),!0):!1))){if(ye=this.tokenizer.escape(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.tag(he)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.link(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.emStrong(he,be,de)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.codespan(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.br(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.del(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.autolink(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(he))){he=he.substring(ye.raw.length),pe.push(ye);continue}if(fe=he,this.options.extensions&&this.options.extensions.startInline){let je=1/0;const Qe=he.slice(1);let st;this.options.extensions.startInline.forEach(ht=>{st=ht.call({lexer:this},Qe),typeof st=="number"&&st>=0&&(je=Math.min(je,st))}),je<1/0&&je>=0&&(fe=he.substring(0,je+1))}if(ye=this.tokenizer.inlineText(fe)){he=he.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(de=ye.raw.slice(-1)),W=!0,Ce=pe[pe.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(he){const je="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return pe}}class B{options;parser;constructor(he){this.options=he||$e.defaults}space(he){return""}code({text:he,lang:pe,escaped:ye}){const Ce=(pe||"").match(/^\S*/)?.[0],fe=he.replace(/\n$/,"")+`
`;return Ce?'<pre><code class="language-'+s(Ce)+'">'+(ye?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(ye?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:he}){return`<blockquote>
${this.parser.parse(he)}</blockquote>
`}html({text:he}){return he}heading({tokens:he,depth:pe}){return`<h${pe}>${this.parser.parseInline(he)}</h${pe}>
`}hr(he){return`<hr>
`}list(he){const pe=he.ordered,ye=he.start;let Ce="";for(let X=0;X<he.items.length;X++){const W=he.items[X];Ce+=this.listitem(W)}const fe=pe?"ol":"ul",be=pe&&ye!==1?' start="'+ye+'"':"";return"<"+fe+be+`>
`+Ce+"</"+fe+`>
`}listitem(he){let pe="";if(he.task){const ye=this.checkbox({checked:!!he.checked});he.loose?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",raw:ye+" ",text:ye+" "}):pe+=ye+" "}return pe+=this.parser.parse(he.tokens,!!he.loose),`<li>${pe}</li>
`}checkbox({checked:he}){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:he}){return`<p>${this.parser.parseInline(he)}</p>
`}table(he){let pe="",ye="";for(let fe=0;fe<he.header.length;fe++)ye+=this.tablecell(he.header[fe]);pe+=this.tablerow({text:ye});let Ce="";for(let fe=0;fe<he.rows.length;fe++){const be=he.rows[fe];ye="";for(let X=0;X<be.length;X++)ye+=this.tablecell(be[X]);Ce+=this.tablerow({text:ye})}return Ce&&(Ce=`<tbody>${Ce}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Ce+`</table>
`}tablerow({text:he}){return`<tr>
${he}</tr>
`}tablecell(he){const pe=this.parser.parseInline(he.tokens),ye=he.header?"th":"td";return(he.align?`<${ye} align="${he.align}">`:`<${ye}>`)+pe+`</${ye}>
`}strong({tokens:he}){return`<strong>${this.parser.parseInline(he)}</strong>`}em({tokens:he}){return`<em>${this.parser.parseInline(he)}</em>`}codespan({text:he}){return`<code>${he}</code>`}br(he){return"<br>"}del({tokens:he}){return`<del>${this.parser.parseInline(he)}</del>`}link({href:he,title:pe,tokens:ye}){const Ce=this.parser.parseInline(ye),fe=u(he);if(fe===null)return Ce;he=fe;let be='<a href="'+he+'"';return pe&&(be+=' title="'+pe+'"'),be+=">"+Ce+"</a>",be}image({href:he,title:pe,text:ye}){const Ce=u(he);if(Ce===null)return ye;he=Ce;let fe=`<img src="${he}" alt="${ye}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(he){return"tokens"in he&&he.tokens?this.parser.parseInline(he.tokens):he.text}}class j{strong({text:he}){return he}em({text:he}){return he}codespan({text:he}){return he}del({text:he}){return he}html({text:he}){return he}text({text:he}){return he}link({text:he}){return""+he}image({text:he}){return""+he}br(){return""}}class H{options;renderer;textRenderer;constructor(he){this.options=he||$e.defaults,this.options.renderer=this.options.renderer||new B,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new j}static parse(he,pe){return new H(pe).parse(he)}static parseInline(he,pe){return new H(pe).parseInline(he)}parse(he,pe=!0){let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const X=fe,W=this.options.extensions.renderers[X.type].call({parser:this},X);if(W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type)){ye+=W||"";continue}}const be=fe;switch(be.type){case"space":{ye+=this.renderer.space(be);continue}case"hr":{ye+=this.renderer.hr(be);continue}case"heading":{ye+=this.renderer.heading(be);continue}case"code":{ye+=this.renderer.code(be);continue}case"table":{ye+=this.renderer.table(be);continue}case"blockquote":{ye+=this.renderer.blockquote(be);continue}case"list":{ye+=this.renderer.list(be);continue}case"html":{ye+=this.renderer.html(be);continue}case"paragraph":{ye+=this.renderer.paragraph(be);continue}case"text":{let X=be,W=this.renderer.text(X);for(;Ce+1<he.length&&he[Ce+1].type==="text";)X=he[++Ce],W+=`
`+this.renderer.text(X);pe?ye+=this.renderer.paragraph({type:"paragraph",raw:W,text:W,tokens:[{type:"text",raw:W,text:W}]}):ye+=W;continue}default:{const X='Token with "'+be.type+'" type was not found.';if(this.options.silent)return console.error(X),"";throw new Error(X)}}}return ye}parseInline(he,pe){pe=pe||this.renderer;let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const X=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){ye+=X||"";continue}}const be=fe;switch(be.type){case"escape":{ye+=pe.text(be);break}case"html":{ye+=pe.html(be);break}case"link":{ye+=pe.link(be);break}case"image":{ye+=pe.image(be);break}case"strong":{ye+=pe.strong(be);break}case"em":{ye+=pe.em(be);break}case"codespan":{ye+=pe.codespan(be);break}case"br":{ye+=pe.br(be);break}case"del":{ye+=pe.del(be);break}case"text":{ye+=pe.text(be);break}default:{const X='Token with "'+be.type+'" type was not found.';if(this.options.silent)return console.error(X),"";throw new Error(X)}}}return ye}}class G{options;constructor(he){this.options=he||$e.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(he){return he}postprocess(he){return he}processAllTokens(he){return he}}class re{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Le.lex,H.parse);parseInline=this.parseMarkdown(Le.lexInline,H.parseInline);Parser=H;Renderer=B;TextRenderer=j;Lexer=Le;Tokenizer=i;Hooks=G;constructor(...he){this.use(...he)}walkTokens(he,pe){let ye=[];for(const Ce of he)switch(ye=ye.concat(pe.call(this,Ce)),Ce.type){case"table":{const fe=Ce;for(const be of fe.header)ye=ye.concat(this.walkTokens(be.tokens,pe));for(const be of fe.rows)for(const X of be)ye=ye.concat(this.walkTokens(X.tokens,pe));break}case"list":{const fe=Ce;ye=ye.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Ce;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(be=>{const X=fe[be].flat(1/0);ye=ye.concat(this.walkTokens(X,pe))}):fe.tokens&&(ye=ye.concat(this.walkTokens(fe.tokens,pe)))}}return ye}use(...he){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return he.forEach(ye=>{const Ce={...ye};if(Ce.async=this.defaults.async||Ce.async||!1,ye.extensions&&(ye.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const be=pe.renderers[fe.name];be?pe.renderers[fe.name]=function(...X){let W=fe.renderer.apply(this,X);return W===!1&&(W=be.apply(this,X)),W}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const be=pe[fe.level];be?be.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Ce.extensions=pe),ye.renderer){const fe=this.defaults.renderer||new B(this.defaults);for(const be in ye.renderer){if(!(be in fe))throw new Error(`renderer '${be}' does not exist`);if(["options","parser"].includes(be))continue;const X=be,W=ye.renderer[X],de=fe[X];fe[X]=(...je)=>{let Qe=W.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe||""}}Ce.renderer=fe}if(ye.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const be in ye.tokenizer){if(!(be in fe))throw new Error(`tokenizer '${be}' does not exist`);if(["options","rules","lexer"].includes(be))continue;const X=be,W=ye.tokenizer[X],de=fe[X];fe[X]=(...je)=>{let Qe=W.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.tokenizer=fe}if(ye.hooks){const fe=this.defaults.hooks||new G;for(const be in ye.hooks){if(!(be in fe))throw new Error(`hook '${be}' does not exist`);if(be==="options")continue;const X=be,W=ye.hooks[X],de=fe[X];G.passThroughHooks.has(be)?fe[X]=je=>{if(this.defaults.async)return Promise.resolve(W.call(fe,je)).then(st=>de.call(fe,st));const Qe=W.call(fe,je);return de.call(fe,Qe)}:fe[X]=(...je)=>{let Qe=W.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.hooks=fe}if(ye.walkTokens){const fe=this.defaults.walkTokens,be=ye.walkTokens;Ce.walkTokens=function(X){let W=[];return W.push(be.call(this,X)),fe&&(W=W.concat(fe.call(this,X))),W}}this.defaults={...this.defaults,...Ce}}),this}setOptions(he){return this.defaults={...this.defaults,...he},this}lexer(he,pe){return Le.lex(he,pe??this.defaults)}parser(he,pe){return H.parse(he,pe??this.defaults)}parseMarkdown(he,pe){return(Ce,fe)=>{const be={...fe},X={...this.defaults,...be},W=this.onError(!!X.silent,!!X.async);if(this.defaults.async===!0&&be.async===!1)return W(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Ce>"u"||Ce===null)return W(new Error("marked(): input parameter is undefined or null"));if(typeof Ce!="string")return W(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected"));if(X.hooks&&(X.hooks.options=X),X.async)return Promise.resolve(X.hooks?X.hooks.preprocess(Ce):Ce).then(de=>he(de,X)).then(de=>X.hooks?X.hooks.processAllTokens(de):de).then(de=>X.walkTokens?Promise.all(this.walkTokens(de,X.walkTokens)).then(()=>de):de).then(de=>pe(de,X)).then(de=>X.hooks?X.hooks.postprocess(de):de).catch(W);try{X.hooks&&(Ce=X.hooks.preprocess(Ce));let de=he(Ce,X);X.hooks&&(de=X.hooks.processAllTokens(de)),X.walkTokens&&this.walkTokens(de,X.walkTokens);let je=pe(de,X);return X.hooks&&(je=X.hooks.postprocess(je)),je}catch(de){return W(de)}}}onError(he,pe){return ye=>{if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,he){const Ce="<p>An error occurred:</p><pre>"+s(ye.message+"",!0)+"</pre>";return pe?Promise.resolve(Ce):Ce}if(pe)return Promise.reject(ye);throw ye}}}const ge=new re;function Ee(Ye,he){return ge.parse(Ye,he)}Ee.options=Ee.setOptions=function(Ye){return ge.setOptions(Ye),Ee.defaults=ge.defaults,y(Ee.defaults),Ee},Ee.getDefaults=e,Ee.defaults=$e.defaults,Ee.use=function(...Ye){return ge.use(...Ye),Ee.defaults=ge.defaults,y(Ee.defaults),Ee},Ee.walkTokens=function(Ye,he){return ge.walkTokens(Ye,he)},Ee.parseInline=ge.parseInline,Ee.Parser=H,Ee.parser=H.parse,Ee.Renderer=B,Ee.TextRenderer=j,Ee.Lexer=Le,Ee.lexer=Le.lex,Ee.Tokenizer=i,Ee.Hooks=G,Ee.parse=Ee;const Ue=Ee.options,Je=Ee.setOptions,_e=Ee.use,tt=Ee.walkTokens,at=Ee.parseInline,it=Ee,ot=H.parse,vt=Le.lex;$e.Hooks=G,$e.Lexer=Le,$e.Marked=re,$e.Parser=H,$e.Renderer=B,$e.TextRenderer=j,$e.Tokenizer=i,$e.getDefaults=e,$e.lexer=vt,$e.marked=Ee,$e.options=Ue,$e.parse=it,$e.parseInline=at,$e.parser=ot,$e.setOptions=Je,$e.use=_e,$e.walkTokens=tt}),define(Re[140],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=y;function y(r){const c=N(r);if(c&&c.length>0)return new Uint32Array(c)}let D=0;const P=new Uint32Array(10);function N(r){if(D=0,R(r,b,p.InitialConsonant),D>0||(R(r,u,p.Vowel),D>0)||(R(r,E,p.FinalConsonant),D>0)||(R(r,f,p.CompatibilityJamo),D))return P.subarray(0,D);if(r>=44032&&r<=55203){const c=r-44032,l=c%588,h=Math.floor(c/588),i=Math.floor(l/28),n=l%28-1;if(h<b.length?R(h,b,0):p.InitialConsonant+h-p.CompatibilityJamo<f.length&&R(p.InitialConsonant+h,f,p.CompatibilityJamo),i<u.length?R(i,u,0):p.Vowel+i-p.CompatibilityJamo<f.length&&R(p.Vowel+i-p.CompatibilityJamo,f,p.CompatibilityJamo),n>=0&&(n<E.length?R(n,E,0):p.FinalConsonant+n-p.CompatibilityJamo<f.length&&R(p.FinalConsonant+n-p.CompatibilityJamo,f,p.CompatibilityJamo)),D>0)return P.subarray(0,D)}}function R(r,c,l){r>=l&&r<l+c.length&&O(c[r-l])}function O(r){r!==s.NUL&&(P[D++]=r&255,r>>8&&(P[D++]=r>>8&255),r>>16&&(P[D++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const b=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),u=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),E=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),f=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Re[141],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=y,e.rot=D,e.$Tm=O;function y(p,s,I){return Math.min(Math.max(p,s),I)}function D(p,s){return(s+p%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=P;class N{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=N;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=R;function O(p,s,I,b,u,E,f,r){const c=f-I,l=r-b,h=u-I,i=E-b,n=p-I,t=s-b,o=c*c+l*l,a=c*h+l*i,m=c*n+l*t,g=h*h+i*i,d=h*n+i*t,S=1/(o*g-a*a),k=(g*m-a*d)*S,v=(o*d-a*m)*S;return k>=0&&v>=0&&k+v<1}}),define(Re[142],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=N,e.$fd=u;class y{constructor(f,r,c){this.owner=f,this.debugNameSource=r,this.referenceFn=c}getDebugName(f){return N(f,this)}}e.$dd=y;const D=new Map,P=new WeakMap;function N(E,f){const r=P.get(E);if(r)return r;const c=R(E,f);if(c){let l=D.get(c)??0;l++,D.set(c,l);const h=l===1?c:`${c}#${l}`;return P.set(E,h),h}}function R(E,f){const r=P.get(E);if(r)return r;const c=f.owner?I(f.owner)+".":"";let l;const h=f.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(l=h(),l!==void 0)return c+l}else return c+h;const i=f.referenceFn;if(i!==void 0&&(l=u(i),l!==void 0))return c+l;if(f.owner!==void 0){const n=O(f.owner,E);if(n!==void 0)return c+n}}function O(E,f){for(const r in E)if(E[r]===f)return r}const p=new Map,s=new WeakMap;function I(E){const f=s.get(E);if(f)return f;const r=b(E);let c=p.get(r)??0;c++,p.set(r,c);const l=c===1?r:`${r}#${c}`;return s.set(E,l),l}function b(E){const f=E.constructor;return f?f.name:"Object"}function u(E){const f=E.toString(),c=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(c?c[1]:void 0)?.trim()}}),define(Re[143],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Nd=D,e.$Od=P;let y;function D(r){y=r}function P(){return y}class N{constructor(){this.a=0,this.d=new WeakMap}b(c){return R([O(E("|  ",this.a)),c])}c(c){return c.hadValue?c.didChange?[O(" "),s(I(c.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),s(I(c.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),s(I(c.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(c,l){console.log(...this.b([p("observable value changed"),s(c.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(c){if(c.size!==0)return s(" (changed deps: "+[...c].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(c){const l=c.handleChange;this.d.set(c,new Set),c.handleChange=(h,i)=>(this.d.get(c).add(h),l.apply(c,[h,i]))}handleDerivedRecomputed(c,l){const h=this.d.get(c);console.log(...this.b([p("derived recomputed"),s(c.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(h),{data:[{fn:c._debugNameData.referenceFn??c._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(c,l){console.log(...this.b([p("observable from event triggered"),s(c.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:c._getValue}]}]))}handleAutorunCreated(c){const l=c.handleChange;this.d.set(c,new Set),c.handleChange=(h,i)=>(this.d.get(c).add(h),l.apply(c,[h,i]))}handleAutorunTriggered(c){const l=this.d.get(c);console.log(...this.b([p("autorun"),s(c.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:c._debugNameData.referenceFn??c._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(c){this.a--}handleBeginTransaction(c){let l=c.getDebugName();l===void 0&&(l=""),console.log(...this.b([p("transaction"),s(l,{color:"BlueViolet"}),{data:[{fn:c._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Pd=N;function R(r){const c=new Array,l=[];let h="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(h+=`%c${t.text}`,c.push(t.style),t.data&&l.push(...t.data)):"data"in t&&l.push(...t.data)}i(r);const n=[h,...c];return n.push(...l),n}function O(r){return s(r,{color:"black"})}function p(r){return s(f(`${r}: `,10),{color:"black",bold:!0})}function s(r,c={color:"black"}){function l(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const h={color:c.color};return c.strikeThrough&&(h["text-decoration"]="line-through"),c.bold&&(h["font-weight"]="bold"),{text:r,style:l(h)}}function I(r,c){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=c?`"${r}"`:`"${r.substr(0,c-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?b(r,c):u(r,c);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function b(r,c){let l="[ ",h=!0;for(const i of r){if(h||(l+=", "),l.length-5>c){l+="...";break}h=!1,l+=`${I(i,c-l.length)}`}return l+=" ]",l}function u(r,c){let l="{ ",h=!0;for(const[i,n]of Object.entries(r)){if(h||(l+=", "),l.length-5>c){l+="...";break}h=!1,l+=`${i}: ${I(n,c-l.length)}`}return l+=" }",l}function E(r,c){let l="";for(let h=1;h<=c;h++)l+=r;return l}function f(r,c){for(;r.length<c;)r+=" ";return r}}),define(Re[144],Te([1,0,136,142,143]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$0d=e.$8d=e.$3d=e.$2d=void 0,e.$Yd=R,e.$Zd=p,e.$1d=I,e.$4d=E,e.$5d=r,e.$6d=c,e.$7d=l,e.$9d=i,e.$$d=t;let N;function R(a){N=a}let O;function p(a){O=a}let s;function I(a){s=a}class b{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,g){const d=g===void 0?void 0:m,S=g===void 0?m:g;return s({owner:d,debugName:()=>{const k=(0,D.$fd)(S);if(k!==void 0)return k;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:S},k=>S(this.read(k),k))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},m=>this.read(m).read(m))}recomputeInitiallyAndOnChange(m,g){return m.add(N(this,g)),this}keepObserved(m){return m.add(O(this)),this}get a(){return this.get()}}e.$2d=b;class u extends b{constructor(){super(...arguments),this.b=new Set}addObserver(m){const g=this.b.size;this.b.add(m),g===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$3d=u;function E(a,m){const g=new h(a,m);try{a(g)}finally{g.finish()}}let f;function r(a){if(f)a(f);else{const m=new h(a,void 0);f=m;try{a(m)}finally{m.finish(),f=void 0}}}async function c(a,m){const g=new h(a,m);try{await a(g)}finally{g.finish()}}function l(a,m,g){a?m(a):E(m,g)}class h{constructor(m,g){this._fn=m,this.b=g,this.a=[],(0,P.$Od)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$fd)(this._fn)}updateObserver(m,g){this.a.push({observer:m,observable:g}),m.beginUpdate(g)}finish(){const m=this.a;for(let g=0;g<m.length;g++){const{observer:d,observable:S}=m[g];d.endUpdate(S)}this.a=null,(0,P.$Od)()?.handleEndTransaction()}}e.$8d=h;function i(a,m){let g;return typeof a=="string"?g=new D.$dd(void 0,a,void 0):g=new D.$dd(a,void 0,void 0),new n(g,m,y.$9c)}class n extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,g,d){super(),this.e=m,this.g=d,this.d=g}get(){return this.d}set(m,g,d){if(d===void 0&&this.g(this.d,m))return;let S;g||(g=S=new h(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(m),(0,P.$Od)()?.handleObservableChanged(this,{oldValue:k,newValue:m,change:d,didChange:!0,hadValue:!0});for(const v of this.b)g.updateObserver(v,this),v.handleChange(this,d)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$0d=n;function t(a,m){let g;return typeof a=="string"?g=new D.$dd(void 0,a,void 0):g=new D.$dd(a,void 0,void 0),new o(g,m,y.$9c)}class o extends n{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$_d=o}),function(){function $e(P){const N=[];typeof P=="number"&&N.push("code/timeOrigin",P);function R(p){N.push(p,Date.now())}function O(){const p=[];for(let s=0;s<N.length;s+=2)p.push({name:N[s],startTime:N[s+1]});return p}return{mark:R,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(P+R.startTime)});return N}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function y(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=y(D))}(),define(Re[145],Te([1,0,40]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=void 0;const D=Symbol("unset");class P{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||y.Iterable.empty()}get entries(){return this.a.children?.entries()||y.Iterable.empty()}insert(p,s,I){this.d(p,b=>b._value=s,I)}mutate(p,s){this.d(p,I=>I._value=s(I._value===D?void 0:I._value))}mutatePath(p,s){this.d(p,()=>{},I=>s(I))}delete(p){const s=this.c(p);if(!s)return;let I=s.length-1;const b=s[I].node._value;if(b!==D){for(this.b--,s[I].node._value=D;I>0;I--){const{node:u,part:E}=s[I];if(u.children?.size||u._value!==D)break;s[I-1].node.children.delete(E)}return b}}*deleteRecursive(p){const s=this.c(p);if(!s)return;const I=s[s.length-1].node;for(let b=s.length-1;b>0;b--){const u=s[b-1];if(u.node.children.delete(s[b].part),u.node.children.size>0||u.node._value!==D)break}for(const b of N(I))b._value!==D&&(this.b--,yield b._value)}find(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return;s=b}return s._value===D?void 0:s._value}hasKeyOrParent(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return!1;if(b._value!==D)return!0;s=b}return!1}hasKeyOrChildren(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return!1;s=b}return!0}hasKey(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return!1;s=b}return s._value!==D}c(p){const s=[{part:"",node:this.a}];let I=0;for(const b of p){const u=s[I].node.children?.get(b);if(!u)return;s.push({part:b,node:u}),I++}return s}d(p,s,I){let b=this.a;for(const f of p){if(b.children)if(b.children.has(f))b=b.children.get(f);else{const r=new R;b.children.set(f,r),b=r}else{const r=new R;b.children=new Map([[f,r]]),b=r}I?.(b)}const u=b._value===D?0:1;s(b);const E=b._value===D?0:1;this.b+=E-u}*values(){for(const{_value:p}of N(this.a))p!==D&&(yield p)}}e.$kJ=P;function*N(O){const p=[O];for(;p.length>0;){const s=p.pop();if(yield s,s.children)for(const I of s.children.values())p.push(I)}}class R{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value(p){this._value=p===void 0?D:p}}}),define(Re[146],Te([1,0,51,22]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=O,e.$Gr=p,e.$Hr=s,e.$Ir=I,e.$Jr=b,e.$Kr=u,e.$Lr=E,e.$Mr=f,e.$Nr=r,e.$Or=c,e.$Pr=d,e.$Qr=S,e.$Rr=k;const P=new y.$W(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),N=new y.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new y.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(v,C,T=!1){const $=v||"",w=C||"",M=P.value.collator.compare($,w);return P.value.collatorIsNumeric&&M===0&&$!==w?$<w?-1:1:M}function p(v,C){const T=N.value.collator;return v=v||"",C=C||"",n(T,v,C)}function s(v,C){const T=N.value.collator;return v=v||"",C=C||"",m(v,C)||n(T,v,C)}function I(v,C){const T=N.value.collator;return v=v||"",C=C||"",a(v,C)||n(T,v,C)}function b(v,C){return v=v||"",C=C||"",v===C?0:v<C?-1:1}function u(v,C){const[T,$]=h(v),[w,M]=h(C);let A=P.value.collator.compare($,M);if(A===0){if(P.value.collatorIsNumeric&&$!==M)return $<M?-1:1;if(A=P.value.collator.compare(T,w),P.value.collatorIsNumeric&&A===0&&T!==w)return T<w?-1:1}return A}function E(v,C){v=v||"",C=C||"";const T=i(v),$=i(C),w=N.value.collator,M=R.value.collator;return n(M,T,$)||n(w,v,C)}function f(v,C){v=v||"",C=C||"";const T=i(v),$=i(C),w=N.value.collator,M=R.value.collator;return n(M,T,$)||m(v,C)||n(w,v,C)}function r(v,C){v=v||"",C=C||"";const T=i(v),$=i(C),w=N.value.collator,M=R.value.collator;return n(M,T,$)||a(v,C)||n(w,v,C)}function c(v,C){v=v||"",C=C||"";const T=i(v).toLowerCase(),$=i(C).toLowerCase();return T!==$?T<$?-1:1:v!==C?v<C?-1:1:0}const l=/^(.*?)(\.([^.]*))?$/;function h(v,C=!1){const T=v?l.exec(v):[];let $=[T&&T[1]||"",T&&T[3]||""];return C&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function i(v){const C=v?l.exec(v):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(v,C,T){const $=v.compare(C,T);return $!==0?$:C.length!==T.length?C.length<T.length?-1:1:0}function t(v){const C=v.charAt(0);return C.toLocaleUpperCase()!==C}function o(v){const C=v.charAt(0);return C.toLocaleLowerCase()!==C}function a(v,C){return t(v)&&o(C)?-1:o(v)&&t(C)?1:0}function m(v,C){return o(v)&&t(C)?-1:t(v)&&o(C)?1:0}function g(v,C,T=!1){return T||(v=v&&v.toLowerCase(),C=C&&C.toLowerCase()),v===C?0:v<C?-1:1}function d(v,C,T=!1){const $=v.split(D.sep),w=C.split(D.sep),M=$.length-1,A=w.length-1;let L,Z;for(let J=0;;J++){if(L=M===J,Z=A===J,L&&Z)return O($[J],w[J],T);if(L)return-1;if(Z)return 1;const U=g($[J],w[J],T);if(U!==0)return U}}function S(v,C,T){const $=v.toLowerCase(),w=C.toLowerCase(),M=k(v,C,T);if(M)return M;const A=$.endsWith(T),L=w.endsWith(T);if(A!==L)return A?-1:1;const Z=O($,w);return Z!==0?Z:$.localeCompare(w)}function k(v,C,T){const $=v.toLowerCase(),w=C.toLowerCase(),M=$.startsWith(T),A=w.startsWith(T);if(M!==A)return M?-1:1;if(M&&A){if($.length<w.length)return-1;if($.length>w.length)return 1}return 0}}),define(Re[72],Te([1,0,22]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0,e.$et=N,e.$ft=R,e.$gt=O,e.$ht=s,e.$dt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(I){const b=(0,y.$rc)(I),u=D[b.toLowerCase()];return u!==void 0?u:R(I)}function R(I){const b=(0,y.$rc)(I);return P[b.toLowerCase()]}function O(I){for(const b in P)if(P[b]===I)return b}const p=/^(.+)\/(.+?)(;.+)?$/;function s(I,b){const u=p.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:b?void 0:I}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var D in y)(typeof exports=="object"?exports:$e)[D]=y[D]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function y(D){if(e[D])return e[D].exports;var P=e[D]={i:D,l:!1,exports:{}};return $e[D].call(P.exports,P,P.exports,y),P.l=!0,P.exports}return y.m=$e,y.c=e,y.d=function(D,P,N){y.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:N})},y.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},y.t=function(D,P){if(1&P&&(D=y(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(y.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var R in D)y.d(N,R,function(O){return D[O]}.bind(null,R));return N},y.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return y.d(P,"a",P),P},y.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},y.p="",y(y.s=0)}([function($e,e,y){(function(D){var P;e=$e.exports=we,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],p=e.src=[],s=0,I=s++;p[I]="0|[1-9]\\d*";var b=s++;p[b]="[0-9]+";var u=s++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=s++;p[E]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var f=s++;p[f]="("+p[b]+")\\.("+p[b]+")\\.("+p[b]+")";var r=s++;p[r]="(?:"+p[I]+"|"+p[u]+")";var c=s++;p[c]="(?:"+p[b]+"|"+p[u]+")";var l=s++;p[l]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var h=s++;p[h]="(?:-?("+p[c]+"(?:\\."+p[c]+")*))";var i=s++;p[i]="[0-9A-Za-z-]+";var n=s++;p[n]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=s++,o="v?"+p[E]+p[l]+"?"+p[n]+"?";p[t]="^"+o+"$";var a="[v=\\s]*"+p[f]+p[h]+"?"+p[n]+"?",m=s++;p[m]="^"+a+"$";var g=s++;p[g]="((?:<|>)?=?)";var d=s++;p[d]=p[b]+"|x|X|\\*";var S=s++;p[S]=p[I]+"|x|X|\\*";var k=s++;p[k]="[v=\\s]*("+p[S]+")(?:\\.("+p[S]+")(?:\\.("+p[S]+")(?:"+p[l]+")?"+p[n]+"?)?)?";var v=s++;p[v]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[h]+")?"+p[n]+"?)?)?";var C=s++;p[C]="^"+p[g]+"\\s*"+p[k]+"$";var T=s++;p[T]="^"+p[g]+"\\s*"+p[v]+"$";var $=s++;p[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=s++;p[w]="(?:~>?)";var M=s++;p[M]="(\\s*)"+p[w]+"\\s+",O[M]=new RegExp(p[M],"g");var A=s++;p[A]="^"+p[w]+p[k]+"$";var L=s++;p[L]="^"+p[w]+p[v]+"$";var Z=s++;p[Z]="(?:\\^)";var J=s++;p[J]="(\\s*)"+p[Z]+"\\s+",O[J]=new RegExp(p[J],"g");var U=s++;p[U]="^"+p[Z]+p[k]+"$";var V=s++;p[V]="^"+p[Z]+p[v]+"$";var Q=s++;p[Q]="^"+p[g]+"\\s*("+a+")$|^$";var ne=s++;p[ne]="^"+p[g]+"\\s*("+o+")$|^$";var ue=s++;p[ue]="(\\s*)"+p[g]+"\\s*("+a+"|"+p[k]+")",O[ue]=new RegExp(p[ue],"g");var _=s++;p[_]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var ae=s++;p[ae]="^\\s*("+p[v]+")\\s+-\\s+("+p[v]+")\\s*$";var se=s++;p[se]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)P(ce,p[ce]),O[ce]||(O[ce]=new RegExp(p[ce]));function x(j,H){if(j instanceof we)return j;if(typeof j!="string"||j.length>N||!(H?O[m]:O[t]).test(j))return null;try{return new we(j,H)}catch{return null}}function we(j,H){if(j instanceof we){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof we))return new we(j,H);P("SemVer",j,H),this.loose=H;var G=j.trim().match(H?O[m]:O[t]);if(!G)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<R)return ge}return re}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=x,e.valid=function(j,H){var G=x(j,H);return G?G.version:null},e.clean=function(j,H){var G=x(j.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof we||(j=new we(j,this.loose)),this.compareMain(j)||this.comparePre(j)},we.prototype.compareMain=function(j){return j instanceof we||(j=new we(j,this.loose)),Y(this.major,j.major)||Y(this.minor,j.minor)||Y(this.patch,j.patch)},we.prototype.comparePre=function(j){if(j instanceof we||(j=new we(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],re=j.prerelease[H];if(P("prerelease compare",H,G,re),G===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(G===void 0)return-1;if(G!==re)return Y(G,re)}while(++H)},we.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,G,re){typeof G=="string"&&(re=G,G=void 0);try{return new we(j,G).inc(H,re).version}catch{return null}},e.diff=function(j,H){if(Pe(j,H))return null;var G=x(j),re=x(H);if(G.prerelease.length||re.prerelease.length){for(var ge in G)if((ge==="major"||ge==="minor"||ge==="patch")&&G[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in G)if((ge==="major"||ge==="minor"||ge==="patch")&&G[ge]!==re[ge])return ge},e.compareIdentifiers=Y;var Ie=/^[0-9]+$/;function Y(j,H){var G=Ie.test(j),re=Ie.test(H);return G&&re&&(j=+j,H=+H),G&&!re?-1:re&&!G?1:j<H?-1:j>H?1:0}function q(j,H,G){return new we(j,G).compare(new we(H,G))}function ie(j,H,G){return q(j,H,G)>0}function ve(j,H,G){return q(j,H,G)<0}function Pe(j,H,G){return q(j,H,G)===0}function Fe(j,H,G){return q(j,H,G)!==0}function Be(j,H,G){return q(j,H,G)>=0}function xe(j,H,G){return q(j,H,G)<=0}function nt(j,H,G,re){var ge;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof G=="object"&&(G=G.version),ge=j===G;break;case"!==":typeof j=="object"&&(j=j.version),typeof G=="object"&&(G=G.version),ge=j!==G;break;case"":case"=":case"==":ge=Pe(j,G,re);break;case"!=":ge=Fe(j,G,re);break;case">":ge=ie(j,G,re);break;case">=":ge=Be(j,G,re);break;case"<":ge=ve(j,G,re);break;case"<=":ge=xe(j,G,re);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function ut(j,H){if(j instanceof ut){if(j.loose===H)return j;j=j.value}if(!(this instanceof ut))return new ut(j,H);P("comparator",j,H),this.loose=H,this.parse(j),this.semver===pt?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,H){return Y(H,j)},e.major=function(j,H){return new we(j,H).major},e.minor=function(j,H){return new we(j,H).minor},e.patch=function(j,H){return new we(j,H).patch},e.compare=q,e.compareLoose=function(j,H){return q(j,H,!0)},e.rcompare=function(j,H,G){return q(H,j,G)},e.sort=function(j,H){return j.sort(function(G,re){return e.compare(G,re,H)})},e.rsort=function(j,H){return j.sort(function(G,re){return e.rcompare(G,re,H)})},e.gt=ie,e.lt=ve,e.eq=Pe,e.neq=Fe,e.gte=Be,e.lte=xe,e.cmp=nt,e.Comparator=ut;var pt={};function lt(j,H){if(j instanceof lt)return j.loose===H?j:new lt(j.raw,H);if(j instanceof ut)return new lt(j.value,H);if(!(this instanceof lt))return new lt(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function et(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ne(j,H,G,re,ge,Ee,Ue,Je,_e,tt,at,it,ot){return((H=et(G)?"":et(re)?">="+G+".0.0":et(ge)?">="+G+"."+re+".0":">="+H)+" "+(Je=et(_e)?"":et(tt)?"<"+(+_e+1)+".0.0":et(at)?"<"+_e+"."+(+tt+1)+".0":it?"<="+_e+"."+tt+"."+at+"-"+it:"<="+Je)).trim()}function Me(j,H){for(var G=0;G<j.length;G++)if(!j[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<j.length;G++)if(P(j[G].semver),j[G].semver!==pt&&j[G].semver.prerelease.length>0){var re=j[G].semver;if(re.major===H.major&&re.minor===H.minor&&re.patch===H.patch)return!0}return!1}return!0}function Le(j,H,G){try{H=new lt(H,G)}catch{return!1}return H.test(j)}function B(j,H,G,re){var ge,Ee,Ue,Je,_e;switch(j=new we(j,re),H=new lt(H,re),G){case">":ge=ie,Ee=xe,Ue=ve,Je=">",_e=">=";break;case"<":ge=ve,Ee=Be,Ue=ie,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(j,H,re))return!1;for(var tt=0;tt<H.set.length;++tt){var at=H.set[tt],it=null,ot=null;if(at.forEach(function(vt){vt.semver===pt&&(vt=new ut(">=0.0.0")),it=it||vt,ot=ot||vt,ge(vt.semver,it.semver,re)?it=vt:Ue(vt.semver,ot.semver,re)&&(ot=vt)}),it.operator===Je||it.operator===_e||(!ot.operator||ot.operator===Je)&&Ee(j,ot.semver)||ot.operator===_e&&Ue(j,ot.semver))return!1}return!0}ut.prototype.parse=function(j){var H=this.loose?O[Q]:O[ne],G=j.match(H);if(!G)throw new TypeError("Invalid comparator: "+j);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new we(G[2],this.loose):this.semver=pt},ut.prototype.toString=function(){return this.value},ut.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===pt||(typeof j=="string"&&(j=new we(j,this.loose)),nt(j,this.operator,this.semver,this.loose))},ut.prototype.intersects=function(j,H){if(!(j instanceof ut))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new lt(j.value,H),Le(this.value,G,H);if(j.operator==="")return G=new lt(this.value,H),Le(j.semver,G,H);var re=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ee=this.semver.version===j.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Je=nt(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=nt(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return re||ge||Ee&&Ue||Je||_e},e.Range=lt,lt.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},lt.prototype.toString=function(){return this.range},lt.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),P("range",j,H);var G=H?O[ae]:O[_];j=j.replace(G,Ne),P("hyphen replace",j),j=j.replace(O[ue],"$1$2$3"),P("comparator trim",j,O[ue]),j=(j=(j=j.replace(O[M],"$1~")).replace(O[J],"$1^")).split(/\s+/).join(" ");var re=H?O[Q]:O[ne],ge=j.split(" ").map(function(Ee){return function(Ue,Je){return P("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(at){return function(it,ot){P("caret",it,ot);var vt=ot?O[V]:O[U];return it.replace(vt,function(Ye,he,pe,ye,Ce){var fe;return P("caret",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=he==="0"?">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+".0 <"+(+he+1)+".0.0":Ce?(P("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+Ce+" <"+(+he+1)+".0.0"):(P("no pr"),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+" <"+(+he+1)+".0.0"),P("caret return",fe),fe})}(at,tt)}).join(" ")}(Ue,Je),P("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(at){return function(it,ot){var vt=ot?O[L]:O[A];return it.replace(vt,function(Ye,he,pe,ye,Ce){var fe;return P("tilde",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":Ce?(P("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0"):fe=">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0",P("tilde return",fe),fe})}(at,tt)}).join(" ")}(Ue,Je),P("tildes",Ue),Ue=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(at){return function(it,ot){it=it.trim();var vt=ot?O[T]:O[C];return it.replace(vt,function(Ye,he,pe,ye,Ce,fe){P("xRange",it,Ye,he,pe,ye,Ce,fe);var be=et(pe),X=be||et(ye),W=X||et(Ce);return he==="="&&W&&(he=""),be?Ye=he===">"||he==="<"?"<0.0.0":"*":he&&W?(X&&(ye=0),W&&(Ce=0),he===">"?(he=">=",X?(pe=+pe+1,ye=0,Ce=0):W&&(ye=+ye+1,Ce=0)):he==="<="&&(he="<",X?pe=+pe+1:ye=+ye+1),Ye=he+pe+"."+ye+"."+Ce):X?Ye=">="+pe+".0.0 <"+(+pe+1)+".0.0":W&&(Ye=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),P("xRange return",Ye),Ye})}(at,tt)}).join(" ")}(Ue,Je),P("xrange",Ue),Ue=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(O[se],"")}(Ue,Je),P("stars",Ue),Ue}(Ee,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ee){return!!Ee.match(re)})),ge=ge.map(function(Ee){return new ut(Ee,H)})},lt.prototype.intersects=function(j,H){if(!(j instanceof lt))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(re){return j.set.some(function(ge){return ge.every(function(Ee){return re.intersects(Ee,H)})})})})},e.toComparators=function(j,H){return new lt(j,H).set.map(function(G){return G.map(function(re){return re.value}).join(" ").trim().split(" ")})},lt.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new we(j,this.loose));for(var H=0;H<this.set.length;H++)if(Me(this.set[H],j))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(j,H,G){var re=null,ge=null;try{var Ee=new lt(H,G)}catch{return null}return j.forEach(function(Ue){Ee.test(Ue)&&(re&&ge.compare(Ue)!==-1||(ge=new we(re=Ue,G)))}),re},e.minSatisfying=function(j,H,G){var re=null,ge=null;try{var Ee=new lt(H,G)}catch{return null}return j.forEach(function(Ue){Ee.test(Ue)&&(re&&ge.compare(Ue)!==1||(ge=new we(re=Ue,G)))}),re},e.validRange=function(j,H){try{return new lt(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,G){return B(j,H,"<",G)},e.gtr=function(j,H,G){return B(j,H,">",G)},e.outside=B,e.prerelease=function(j,H){var G=x(j,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(j,H,G){return j=new lt(j,G),H=new lt(H,G),j.intersects(H)},e.coerce=function(j){if(j instanceof we)return j;if(typeof j!="string")return null;var H=j.match(O[$]);return H==null?null:x((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,y(1))},function($e,e){var y,D,P=$e.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function O(c){if(y===setTimeout)return setTimeout(c,0);if((y===N||!y)&&setTimeout)return y=setTimeout,setTimeout(c,0);try{return y(c,0)}catch{try{return y.call(null,c,0)}catch{return y.call(this,c,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:N}catch{y=N}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var p,s=[],I=!1,b=-1;function u(){I&&p&&(I=!1,p.length?s=p.concat(s):b=-1,s.length&&E())}function E(){if(!I){var c=O(u);I=!0;for(var l=s.length;l;){for(p=s,s=[];++b<l;)p&&p[b].run();b=-1,l=s.length}p=null,I=!1,function(h){if(D===clearTimeout)return clearTimeout(h);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(h);try{D(h)}catch{try{return D.call(null,h)}catch{return D.call(this,h)}}}(c)}}function f(c,l){this.fun=c,this.array=l}function r(){}P.nextTick=function(c){var l=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)l[h-1]=arguments[h];s.push(new f(c,l)),s.length!==1||I||O(E)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Re[147],Te([1,0,6,4]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.$jt=e.$it=e.ScrollbarVisibility=void 0;var P;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class N{constructor(f,r,c,l,h,i,n){this.c=f,this._scrollStateBrand=void 0,this.c&&(r=r|0,c=c|0,l=l|0,h=h|0,i=i|0,n=n|0),this.rawScrollLeft=l,this.rawScrollTop=n,r<0&&(r=0),l+r>c&&(l=c-r),l<0&&(l=0),h<0&&(h=0),n+h>i&&(n=i-h),n<0&&(n=0),this.width=r,this.scrollWidth=c,this.scrollLeft=l,this.height=h,this.scrollHeight=i,this.scrollTop=n}equals(f){return this.rawScrollLeft===f.rawScrollLeft&&this.rawScrollTop===f.rawScrollTop&&this.width===f.width&&this.scrollWidth===f.scrollWidth&&this.scrollLeft===f.scrollLeft&&this.height===f.height&&this.scrollHeight===f.scrollHeight&&this.scrollTop===f.scrollTop}withScrollDimensions(f,r){return new N(this.c,typeof f.width<"u"?f.width:this.width,typeof f.scrollWidth<"u"?f.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof f.height<"u"?f.height:this.height,typeof f.scrollHeight<"u"?f.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(f){return new N(this.c,this.width,this.scrollWidth,typeof f.scrollLeft<"u"?f.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof f.scrollTop<"u"?f.scrollTop:this.rawScrollTop)}createScrollEvent(f,r){const c=this.width!==f.width,l=this.scrollWidth!==f.scrollWidth,h=this.scrollLeft!==f.scrollLeft,i=this.height!==f.height,n=this.scrollHeight!==f.scrollHeight,t=this.scrollTop!==f.scrollTop;return{inSmoothScrolling:r,oldWidth:f.width,oldScrollWidth:f.scrollWidth,oldScrollLeft:f.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:f.height,oldScrollHeight:f.scrollHeight,oldScrollTop:f.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:c,scrollWidthChanged:l,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$it=N;class R extends D.$Xc{constructor(f){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$oe),this.onScroll=this.j.event,this.c=f.smoothScrollDuration,this.f=f.scheduleAtNextAnimationFrame,this.g=new N(f.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(f){this.c=f}validateScrollPosition(f){return this.g.withScrollPosition(f)}getScrollDimensions(){return this.g}setScrollDimensions(f,r){const c=this.g.withScrollDimensions(f,r);this.n(c,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(f){const r=this.g.withScrollPosition(f);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(f,r){if(this.c===0)return this.setScrollPositionNow(f);if(this.h){f={scrollLeft:typeof f.scrollLeft>"u"?this.h.to.scrollLeft:f.scrollLeft,scrollTop:typeof f.scrollTop>"u"?this.h.to.scrollTop:f.scrollTop};const c=this.g.withScrollPosition(f);if(this.h.to.scrollLeft===c.scrollLeft&&this.h.to.scrollTop===c.scrollTop)return;let l;r?l=new I(this.h.from,c,this.h.startTime,this.h.duration):l=this.h.combine(this.g,c,this.c),this.h.dispose(),this.h=l}else{const c=this.g.withScrollPosition(f);this.h=I.start(this.g,c,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const f=this.h.tick(),r=this.g.withScrollPosition(f);if(this.n(r,!0),!!this.h){if(f.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(f,r){const c=this.g;c.equals(f)||(this.g=f,this.j.fire(this.g.createScrollEvent(c,r)))}}e.$jt=R;class O{constructor(f,r,c){this.scrollLeft=f,this.scrollTop=r,this.isDone=c}}e.$kt=O;function p(E,f){const r=f-E;return function(c){return E+r*u(c)}}function s(E,f,r){return function(c){return c<r?E(c/r):f((c-r)/(1-r))}}class I{constructor(f,r,c,l){this.from=f,this.to=r,this.duration=l,this.startTime=c,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(f,r,c){if(Math.abs(f-r)>2.5*c){let h,i;return f<r?(h=f+.75*c,i=r-.75*c):(h=f-.75*c,i=r+.75*c),s(p(f,h),p(i,r),.33)}return p(f,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(f){this.to=f.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(f){const r=(f-this.startTime)/this.duration;if(r<1){const c=this.c(r),l=this.d(r);return new O(c,l,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(f,r,c){return I.start(f,r,c)}static start(f,r,c){c=c+10;const l=Date.now()-10;return new I(f,r,l,c)}}e.$lt=I;function b(E){return Math.pow(E,3)}function u(E){return 1-b(1-E)}}),define(Re[148],Te([1,0,12,4]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=P,e.$Ce=N,e.$De=R,e.$Ee=O,e.$Fe=s,e.$Ge=I,e.$He=b,e.$Ie=u,e.$Je=E,e.$Ke=f,e.$Le=r,e.$Me=c,e.$Ne=l,e.$Oe=h,e.$Pe=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function N(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function R(n){const t=n;return t?N(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(n,t){return new p(n,t)}class p{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,y.$2)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let a;switch(t){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const m=a.indexOf(o);m>=0&&a.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const o=[];let a;for(;(a=n.read())!==null;)o.push(a);return t(o)}function I(n,t,o){const a=[];let m;for(;(m=n.read())!==null&&a.length<o;)a.push(m);return m===null&&a.length>0?t(a):{read:()=>{if(a.length>0)return a.shift();if(typeof m<"u"){const g=m;return m=void 0,g}return n.read()}}}function b(n,t){return new Promise((o,a)=>{const m=[];u(n,{onData:g=>{t&&m.push(g)},onError:g=>{t?a(g):o(void 0)},onEnd:()=>{o(t?t(m):void 0)}})})}function u(n,t,o){n.on("error",a=>{o?.isCancellationRequested||t.onError(a)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",a=>{o?.isCancellationRequested||t.onData(a)})}function E(n,t){return new Promise((o,a)=>{const m=new D.$Wc,g=[],d=v=>{if(g.push(v),g.length>t)return m.dispose(),n.pause(),o({stream:n,buffer:g,ended:!1})},S=v=>(m.dispose(),a(v)),k=()=>(m.dispose(),o({stream:n,buffer:g,ended:!0}));m.add((0,D.$Vc)(()=>n.removeListener("error",S))),n.on("error",S),m.add((0,D.$Vc)(()=>n.removeListener("end",k))),n.on("end",k),m.add((0,D.$Vc)(()=>n.removeListener("data",d))),n.on("data",d)})}function f(n,t){const o=O(t);return o.end(n),o}function r(){const n=O(()=>{throw new Error("not supported")});return n.end(),n}function c(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function l(n,t,o){const a=O(o);return u(n,{onData:m=>a.write(t.data(m)),onError:m=>a.error(t.error?t.error(m):m),onEnd:()=>a.end()}),a}function h(n,t,o){let a=!1;return{read:()=>{const m=t.read();return a?m:(a=!0,m!==null?o([n,m]):n)}}}function i(n,t,o){let a=!1;const m=O(o);return u(t,{onData:g=>a?m.write(g):(a=!0,m.write(o([n,g]))),onError:g=>m.error(g),onEnd:()=>{a||(a=!0,m.write(n)),m.end()}}),m}}),define(Re[20],Te([1,0,51,148]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=s,e.$Se=I,e.$Te=b,e.$Ue=u,e.$Ve=E,e.$We=f,e.$Xe=r,e.$Ye=c,e.$Ze=l,e.$1e=h,e.$2e=i,e.$3e=n,e.$4e=t,e.$5e=o,e.$6e=a,e.$7e=m,e.$8e=g,e.$9e=d,e.$0e=S,e.$$e=C,D=qe(D);const P=typeof Buffer<"u",N=new y.$W(()=>new Uint8Array(256));let R,O;class p{static alloc($){return P?new p(Buffer.allocUnsafe($)):new p(new Uint8Array($))}static wrap($){return P&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new p($)}static fromString($,w){return!(w?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from($)):(R||(R=new TextEncoder),new p(R.encode($)))}static fromByteArray($){const w=p.alloc($.length);for(let M=0,A=$.length;M<A;M++)w.buffer[M]=$[M];return w}static concat($,w){if(typeof w>"u"){w=0;for(let L=0,Z=$.length;L<Z;L++)w+=$[L].byteLength}const M=p.alloc(w);let A=0;for(let L=0,Z=$.length;L<Z;L++){const J=$[L];M.set(J,A),A+=J.byteLength}return M}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=p.alloc(this.byteLength);return $.set(this),$}toString(){return P?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice($,w){return new p(this.buffer.subarray($,w))}set($,w){if($ instanceof p)this.buffer.set($.buffer,w);else if($ instanceof Uint8Array)this.buffer.set($,w);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),w);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return u(this.buffer,$)}writeUInt32BE($,w){E(this.buffer,$,w)}readUInt32LE($){return f(this.buffer,$)}writeUInt32LE($,w){r(this.buffer,$,w)}readUInt8($){return c(this.buffer,$)}writeUInt8($,w){l(this.buffer,$,w)}indexOf($,w=0){return s(this.buffer,$ instanceof p?$.buffer:$,w)}}e.$Qe=p;function s(T,$,w=0){const M=$.byteLength,A=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf($[0]);if(M>A-w)return-1;const L=N.value;L.fill($.length);for(let V=0;V<$.length;V++)L[$[V]]=$.length-V-1;let Z=w+$.length-1,J=Z,U=-1;for(;Z<A;)if(T[Z]===$[J]){if(J===0){U=Z;break}Z--,J--}else Z+=Math.max($.length-J,L[T[Z]]),J=$.length-1;return U}function I(T,$){return T[$+0]<<0>>>0|T[$+1]<<8>>>0}function b(T,$,w){T[w+0]=$&255,$=$>>>8,T[w+1]=$&255}function u(T,$){return T[$]*2**24+T[$+1]*2**16+T[$+2]*2**8+T[$+3]}function E(T,$,w){T[w+3]=$,$=$>>>8,T[w+2]=$,$=$>>>8,T[w+1]=$,$=$>>>8,T[w]=$}function f(T,$){return T[$+0]<<0>>>0|T[$+1]<<8>>>0|T[$+2]<<16>>>0|T[$+3]<<24>>>0}function r(T,$,w){T[w+0]=$&255,$=$>>>8,T[w+1]=$&255,$=$>>>8,T[w+2]=$&255,$=$>>>8,T[w+3]=$&255}function c(T,$){return T[$]}function l(T,$,w){T[w]=$}function h(T){return D.$Fe(T,$=>p.concat($))}function i(T){return D.$Me(T)}function n(T){return D.$He(T,$=>p.concat($))}async function t(T){return T.ended?p.concat(T.buffer):p.concat([...T.buffer,await n(T.stream)])}function o(T){return D.$Ke(T,$=>p.concat($))}function a(T){return D.$Ne(T,{data:$=>typeof $=="string"?p.fromString($):p.wrap($)},$=>p.concat($))}function m(T){return D.$Ee($=>p.concat($),T)}function g(T,$){return D.$Oe(T,$,w=>p.concat(w))}function d(T,$){return D.$Pe(T,$,w=>p.concat(w))}function S(T){let $=0,w=0,M=0;const A=new Uint8Array(Math.floor(T.length/4*3)),L=J=>{switch(w){case 3:A[M++]=$|J,w=0;break;case 2:A[M++]=$|J>>>2,$=J<<6,w=3;break;case 1:A[M++]=$|J>>>4,$=J<<4,w=2;break;default:$=J<<2,w=1}};for(let J=0;J<T.length;J++){const U=T.charCodeAt(J);if(U>=65&&U<=90)L(U-65);else if(U>=97&&U<=122)L(U-97+26);else if(U>=48&&U<=57)L(U-48+52);else if(U===43||U===45)L(62);else if(U===47||U===95)L(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${T[J]}`)}}const Z=M;for(;w>0;)L(0);return p.wrap(A).slice(0,Z)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:T},$=!0,w=!1){const M=w?v:k;let A="";const L=T.byteLength%3;let Z=0;for(;Z<T.byteLength-L;Z+=3){const J=T[Z+0],U=T[Z+1],V=T[Z+2];A+=M[J>>>2],A+=M[(J<<4|U>>>4)&63],A+=M[(U<<2|V>>>6)&63],A+=M[V&63]}if(L===1){const J=T[Z+0];A+=M[J>>>2],A+=M[J<<4&63],$&&(A+="==")}else if(L===2){const J=T[Z+0],U=T[Z+1];A+=M[J>>>2],A+=M[(J<<4|U>>>4)&63],A+=M[U<<2&63],$&&(A+="=")}return A}}),define(Re[35],Te([1,0,98]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$9j=P;var D;(function(R){function O(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=O})(D||(e.ThemeColor=D={}));function P(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(h){const i=O.exec(h.id);if(!i)return p(y.$8j.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}R.asClassNameArray=p;function s(h){return p(h).join(" ")}R.asClassName=s;function I(h){return"."+p(h).join(".")}R.asCSSSelector=I;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||D.isThemeColor(h.color))}R.isThemeIcon=b;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(h){const i=u.exec(h);if(!i)return;const[,n]=i;return{id:n}}R.fromString=E;function f(h){return{id:h}}R.fromId=f;function r(h,i){let n=h.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}R.modify=r;function c(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}R.getModifier=c;function l(h,i){return h.id===i.id&&h.color?.id===i.color?.id}R.isEqual=l})(N||(e.ThemeIcon=N={}))}),define(Re[149],Te([1,0,30,27,140,13]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.FuzzyScore=e.$Lk=e.$Kk=void 0,e.or=R,e.$Mk=p,e.$Nk=s,e.$Ok=u,e.$Pk=k,e.$Qk=v,e.$Rk=A,e.$Sk=L,e.$Tk=Z,e.$Uk=J,e.$Vk=ie,e.$Xk=Be,e.$Yk=ut,e.$Zk=pt,N=qe(N);function R(...Ne){return function(Me,Le){for(let B=0,j=Ne.length;B<j;B++){const H=Ne[B](Me,Le);if(H)return H}return null}}e.$Kk=O.bind(void 0,!1),e.$Lk=O.bind(void 0,!0);function O(Ne,Me,Le){if(!Le||Le.length<Me.length)return null;let B;return Ne?B=N.$Jf(Le,Me):B=Le.indexOf(Me)===0,B?Me.length>0?[{start:0,end:Me.length}]:[]:null}function p(Ne,Me){const Le=Me.toLowerCase().indexOf(Ne.toLowerCase());return Le===-1?null:[{start:Le,end:Le+Ne.length}]}function s(Ne,Me){return I(Ne.toLowerCase(),Me.toLowerCase(),0,0)}function I(Ne,Me,Le,B){if(Le===Ne.length)return[];if(B===Me.length)return null;if(Ne[Le]===Me[B]){let j=null;return(j=I(Ne,Me,Le+1,B+1))?t({start:B,end:B+1},j):null}return I(Ne,Me,Le,B+1)}function b(Ne){return y.CharCode.a<=Ne&&Ne<=y.CharCode.z}function u(Ne){return y.CharCode.A<=Ne&&Ne<=y.CharCode.Z}function E(Ne){return y.CharCode.Digit0<=Ne&&Ne<=y.CharCode.Digit9}function f(Ne){return Ne===y.CharCode.Space||Ne===y.CharCode.Tab||Ne===y.CharCode.LineFeed||Ne===y.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ne=>r.add(Ne.charCodeAt(0)));function c(Ne){return f(Ne)||r.has(Ne)}function l(Ne,Me){return Ne===Me||c(Ne)&&c(Me)}const h=new Map;function i(Ne){if(h.has(Ne))return h.get(Ne);let Me;const Le=(0,P.$Ik)(Ne);return Le&&(Me=Le),h.set(Ne,Me),Me}function n(Ne){return b(Ne)||u(Ne)||E(Ne)}function t(Ne,Me){return Me.length===0?Me=[Ne]:Ne.end===Me[0].start?Me[0].start=Ne.start:Me.unshift(Ne),Me}function o(Ne,Me){for(let Le=Me;Le<Ne.length;Le++){const B=Ne.charCodeAt(Le);if(u(B)||E(B)||Le>0&&!n(Ne.charCodeAt(Le-1)))return Le}return Ne.length}function a(Ne,Me,Le,B){if(Le===Ne.length)return[];if(B===Me.length)return null;if(Ne[Le]!==Me[B].toLowerCase())return null;{let j=null,H=B+1;for(j=a(Ne,Me,Le+1,B+1);!j&&(H=o(Me,H))<Me.length;)j=a(Ne,Me,Le+1,H),H++;return j===null?null:t({start:B,end:B+1},j)}}function m(Ne){let Me=0,Le=0,B=0,j=0,H=0;for(let Ue=0;Ue<Ne.length;Ue++)H=Ne.charCodeAt(Ue),u(H)&&Me++,b(H)&&Le++,n(H)&&B++,E(H)&&j++;const G=Me/Ne.length,re=Le/Ne.length,ge=B/Ne.length,Ee=j/Ne.length;return{upperPercent:G,lowerPercent:re,alphaPercent:ge,numericPercent:Ee}}function g(Ne){const{upperPercent:Me,lowerPercent:Le}=Ne;return Le===0&&Me>.6}function d(Ne){const{upperPercent:Me,lowerPercent:Le,alphaPercent:B,numericPercent:j}=Ne;return Le>.2&&Me<.8&&B>.6&&j<.2}function S(Ne){let Me=0,Le=0,B=0,j=0;for(let H=0;H<Ne.length;H++)B=Ne.charCodeAt(H),u(B)&&Me++,b(B)&&Le++,f(B)&&j++;return(Me===0||Le===0)&&j===0?Ne.length<=30:Me<=5}function k(Ne,Me){if(!Me||(Me=Me.trim(),Me.length===0)||!S(Ne))return null;Me.length>60&&(Me=Me.substring(0,60));const Le=m(Me);if(!d(Le)){if(!g(Le))return null;Me=Me.toLowerCase()}let B=null,j=0;for(Ne=Ne.toLowerCase();j<Me.length&&(B=a(Ne,Me,0,j))===null;)j=o(Me,j+1);return B}function v(Ne,Me,Le=!1){if(!Me||Me.length===0)return null;let B=null,j=0;for(Ne=Ne.toLowerCase(),Me=Me.toLowerCase();j<Me.length&&(B=C(Ne,Me,0,j,Le),B===null);)j=T(Me,j+1);return B}function C(Ne,Me,Le,B,j){let H=0;if(Le===Ne.length)return[];if(B===Me.length)return null;if(!l(Ne.charCodeAt(Le),Me.charCodeAt(B))){const ge=i(Ne.charCodeAt(Le));if(!ge)return null;for(let Ee=0;Ee<ge.length;Ee++)if(!l(ge[Ee],Me.charCodeAt(B+Ee)))return null;H+=ge.length-1}let G=null,re=B+H+1;if(G=C(Ne,Me,Le+1,re,j),!j)for(;!G&&(re=T(Me,re))<Me.length;)G=C(Ne,Me,Le+1,re,j),re++;if(!G)return null;if(Ne.charCodeAt(Le)!==Me.charCodeAt(B)){const ge=i(Ne.charCodeAt(Le));if(!ge)return G;for(let Ee=0;Ee<ge.length;Ee++)if(ge[Ee]!==Me.charCodeAt(B+Ee))return G}return t({start:B,end:B+H+1},G)}function T(Ne,Me){for(let Le=Me;Le<Ne.length;Le++)if(c(Ne.charCodeAt(Le))||Le>0&&c(Ne.charCodeAt(Le-1)))return Le;return Ne.length}const $=R(e.$Lk,k,p),w=R(e.$Lk,k,s),M=new D.$Gc(1e4);function A(Ne,Me,Le=!1){if(typeof Ne!="string"||typeof Me!="string")return null;let B=M.get(Ne);B||(B=new RegExp(N.$rf(Ne),"i"),M.set(Ne,B));const j=B.exec(Me);return j?[{start:j.index,end:j.index+j[0].length}]:Le?w(Ne,Me):$(Ne,Me)}function L(Ne,Me){const Le=Be(Ne,Ne.toLowerCase(),0,Me,Me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?J(Le):null}function Z(Ne,Me,Le,B,j,H){const G=Math.min(13,Ne.length);for(;Le<G;Le++){const re=Be(Ne,Me,Le,B,j,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,H]}function J(Ne){if(typeof Ne>"u")return[];const Me=[],Le=Ne[1];for(let B=Ne.length-1;B>1;B--){const j=Ne[B]+Le,H=Me[Me.length-1];H&&H.end===j?H.end=j+1:Me.push({start:j,end:j+1})}return Me}const U=128;function V(){const Ne=[],Me=[];for(let Le=0;Le<=U;Le++)Me[Le]=0;for(let Le=0;Le<=U;Le++)Ne.push(Me.slice(0));return Ne}function Q(Ne){const Me=[];for(let Le=0;Le<=Ne;Le++)Me[Le]=0;return Me}const ne=Q(2*U),ue=Q(2*U),_=V(),ae=V(),se=V(),ce=!1;function x(Ne,Me,Le,B,j){function H(re,ge,Ee=" "){for(;re.length<ge;)re=Ee+re;return re}let G=` |   |${B.split("").map(re=>H(re,3)).join("|")}
`;for(let re=0;re<=Le;re++)re===0?G+=" |":G+=`${Me[re-1]}|`,G+=Ne[re].slice(0,j+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return G}function we(Ne,Me,Le,B){Ne=Ne.substr(Me),Le=Le.substr(B),console.log(x(ae,Ne,Ne.length,Le,Le.length)),console.log(x(se,Ne,Ne.length,Le,Le.length)),console.log(x(_,Ne,Ne.length,Le,Le.length))}function Ie(Ne,Me){if(Me<0||Me>=Ne.length)return!1;const Le=Ne.codePointAt(Me);switch(Le){case y.CharCode.Underline:case y.CharCode.Dash:case y.CharCode.Period:case y.CharCode.Space:case y.CharCode.Slash:case y.CharCode.Backslash:case y.CharCode.SingleQuote:case y.CharCode.DoubleQuote:case y.CharCode.Colon:case y.CharCode.DollarSign:case y.CharCode.LessThan:case y.CharCode.GreaterThan:case y.CharCode.OpenParen:case y.CharCode.CloseParen:case y.CharCode.OpenSquareBracket:case y.CharCode.CloseSquareBracket:case y.CharCode.OpenCurlyBrace:case y.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!N.$2f(Le)}}function Y(Ne,Me){if(Me<0||Me>=Ne.length)return!1;switch(Ne.charCodeAt(Me)){case y.CharCode.Space:case y.CharCode.Tab:return!0;default:return!1}}function q(Ne,Me,Le){return Me[Ne]!==Le[Ne]}function ie(Ne,Me,Le,B,j,H,G=!1){for(;Me<Le&&j<H;)Ne[Me]===B[j]&&(G&&(ne[Me]=j),Me+=1),j+=1;return Me===Le}var ve;(function(Ne){Ne[Ne.Diag=1]="Diag",Ne[Ne.Left=2]="Left",Ne[Ne.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Pe;(function(Ne){Ne.Default=[-100,0];function Me(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}Ne.isDefault=Me})(Pe||(e.FuzzyScore=Pe={}));class Fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Me,Le){this.firstMatchCanBeWeak=Me,this.boostFullMatch=Le}}e.$Wk=Fe;function Be(Ne,Me,Le,B,j,H,G=Fe.default){const re=Ne.length>U?U:Ne.length,ge=B.length>U?U:B.length;if(Le>=re||H>=ge||re-Le>ge-H||!ie(Me,Le,re,j,H,ge,!0))return;xe(re,ge,Le,H,Me,j);let Ee=1,Ue=1,Je=Le,_e=H;const tt=[!1];for(Ee=1,Je=Le;Je<re;Ee++,Je++){const Ye=ne[Je],he=ue[Je],pe=Je+1<re?ue[Je+1]:ge;for(Ue=Ye-H+1,_e=Ye;_e<pe;Ue++,_e++){let ye=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=he&&(ye=nt(Ne,Me,Je,Le,B,j,_e,ge,H,_[Ee-1][Ue-1]===0,tt));let fe=0;ye!==Number.MAX_SAFE_INTEGER&&(Ce=!0,fe=ye+ae[Ee-1][Ue-1]);const be=_e>Ye,X=be?ae[Ee][Ue-1]+(_[Ee][Ue-1]>0?-5:0):0,W=_e>Ye+1&&_[Ee][Ue-1]>0,de=W?ae[Ee][Ue-2]+(_[Ee][Ue-2]>0?-5:0):0;if(W&&(!be||de>=X)&&(!Ce||de>=fe))ae[Ee][Ue]=de,se[Ee][Ue]=ve.LeftLeft,_[Ee][Ue]=0;else if(be&&(!Ce||X>=fe))ae[Ee][Ue]=X,se[Ee][Ue]=ve.Left,_[Ee][Ue]=0;else if(Ce)ae[Ee][Ue]=fe,se[Ee][Ue]=ve.Diag,_[Ee][Ue]=_[Ee-1][Ue-1]+1;else throw new Error("not possible")}}if(ce&&we(Ne,Le,B,H),!tt[0]&&!G.firstMatchCanBeWeak)return;Ee--,Ue--;const at=[ae[Ee][Ue],H];let it=0,ot=0;for(;Ee>=1;){let Ye=Ue;do{const he=se[Ee][Ye];if(he===ve.LeftLeft)Ye=Ye-2;else if(he===ve.Left)Ye=Ye-1;else break}while(Ye>=1);it>1&&Me[Le+Ee-1]===j[H+Ue-1]&&!q(Ye+H-1,B,j)&&it+1>_[Ee][Ye]&&(Ye=Ue),Ye===Ue?it++:it=1,ot||(ot=Ye),Ee--,Ue=Ye-1,at.push(Ue)}ge-H===re&&G.boostFullMatch&&(at[0]+=2);const vt=ot-re;return at[0]-=vt,at}function xe(Ne,Me,Le,B,j,H){let G=Ne-1,re=Me-1;for(;G>=Le&&re>=B;)j[G]===H[re]&&(ue[G]=re,G--),re--}function nt(Ne,Me,Le,B,j,H,G,re,ge,Ee,Ue){if(Me[Le]!==H[G])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return G===Le-B?Je=Ne[Le]===j[G]?7:5:q(G,j,H)&&(G===0||!q(G-1,j,H))?(Je=Ne[Le]===j[G]?7:5,_e=!0):Ie(H,G)&&(G===0||!Ie(H,G-1))?Je=5:(Ie(H,G-1)||Y(H,G-1))&&(Je=5,_e=!0),Je>1&&Le===B&&(Ue[0]=!0),_e||(_e=q(G,j,H)||Ie(H,G-1)||Y(H,G-1)),Le===B?G>ge&&(Je-=_e?3:5):Ee?Je+=_e?2:0:Je+=_e?0:1,G+1===re&&(Je-=_e?3:5),Je}function ut(Ne,Me,Le,B,j,H,G){return lt(Ne,Me,Le,B,j,H,!0,G)}function pt(Ne,Me,Le,B,j,H,G){return lt(Ne,Me,Le,B,j,H,!1,G)}function lt(Ne,Me,Le,B,j,H,G,re){let ge=Be(Ne,Me,Le,B,j,H,re);if(ge&&!G)return ge;if(Ne.length>=3){const Ee=Math.min(7,Ne.length-1);for(let Ue=Le+1;Ue<Ee;Ue++){const Je=et(Ne,Ue);if(Je){const _e=Be(Je,Je.toLowerCase(),Le,B,j,H,re);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function et(Ne,Me){if(Me+1>=Ne.length)return;const Le=Ne[Me],B=Ne[Me+1];if(Le!==B)return Ne.slice(0,Me)+B+Le+Ne.slice(Me+2)}}),define(Re[99],Te([1,0,149,13,35]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=p,e.$2k=I,e.$3k=u,e.$4k=E,e.$5k=r,e.$6k=c;const N="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${R.source}`,"g");function p(l){return l.replace(O,(h,i)=>i?h:`\\${h}`)}const s=new RegExp(`\\\\${R.source}`,"g");function I(l){return l.replace(s,h=>`\\${h}`)}const b=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(l){return l.indexOf(N)===-1?l:l.replace(b,(h,i,n,t)=>n?h:i||t||"")}function E(l){return l?l.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(l){f.lastIndex=0;let h="";const i=[];let n=0;for(;;){const t=f.lastIndex,o=f.exec(l),a=l.substring(t,o?.index);if(a.length>0){h+=a;for(let m=0;m<a.length;m++)i.push(n)}if(!o)break;n+=o[0].length}return{text:h,iconOffsets:i}}function c(l,h,i=!1){const{text:n,iconOffsets:t}=h;if(!t||t.length===0)return(0,y.$Rk)(l,n,i);const o=(0,D.$pf)(n," "),a=n.length-o.length,m=(0,y.$Rk)(l,o,i);if(m)for(const g of m){const d=t[g.start+a]+a;g.start+=d,g.end+=d}return m}}),define(Re[36],Te([1,0,13]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),y=qe(y);var D;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(D||(D={})),function(P){const N="error",R="warning",O="warn",p="info",s="ignore";function I(u){return u?y.$If(N,u)?P.Error:y.$If(R,u)||y.$If(O,u)?P.Warning:y.$If(p,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function b(u){switch(u){case P.Error:return N;case P.Warning:return R;case P.Info:return p;default:return s}}P.toString=b}(D||(D={})),e.default=D}),define(Re[48],Te([1,0,17,30,13]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class N{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const r=f.charCodeAt(0),c=this.b.charCodeAt(this.c);return r-c}value(){return this.b[this.c]}}e.$Ki=N;class R{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,P.$Cf)(f,this.b,0,f.length,this.c,this.d):(0,P.$Ef)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=R;class O{constructor(f=!0,r=!0){this.f=f,this.g=r}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let r=f.length-1;r>=0;r--,this.c--){const c=this.b.charCodeAt(r);if(!(c===D.CharCode.Slash||this.f&&c===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,P.$Cf)(f,this.b,0,f.length,this.d,this.e):(0,P.$Ef)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=O;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class s{constructor(f,r){this.f=f,this.g=r,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,P.$Df)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Df)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,P.$Bf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$Bf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ni=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(b||(b={}));class u{static forUris(f=()=>!1,r=()=>!1){return new u(new s(f,r))}static forPaths(f=!1){return new u(new O(void 0,!f))}static forStrings(){return new u(new N)}static forConfigKeys(){return new u(new R)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,r){if(r){const c=r.slice(0);(0,y.$Yb)(c);for(const l of c)this.set(l,f)}else{const c=f.slice(0);(0,y.$Yb)(c);for(const l of c)this.set(l[0],l[1])}}set(f,r){const c=this.b.reset(f);let l;this.c||(this.c=new I,this.c.segment=c.value());const h=[];for(l=this.c;;){const n=c.cmp(l.segment);if(n>0)l.left||(l.left=new I,l.left.segment=c.value()),h.push([b.Left,l]),l=l.left;else if(n<0)l.right||(l.right=new I,l.right.segment=c.value()),h.push([b.Right,l]),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new I,l.mid.segment=c.value()),h.push([b.Mid,l]),l=l.mid;else break}const i=l.value;l.value=r,l.key=f;for(let n=h.length-1;n>=0;n--){const t=h[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const a=h[n][0],m=h[n+1][0];if(a===b.Right&&m===b.Right)h[n][1]=t.rotateLeft();else if(a===b.Left&&m===b.Left)h[n][1]=t.rotateRight();else if(a===b.Right&&m===b.Left)t.right=h[n+1][1]=h[n+1][1].rotateRight(),h[n][1]=t.rotateLeft();else if(a===b.Left&&m===b.Right)t.left=h[n+1][1]=h[n+1][1].rotateLeft(),h[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(h[n-1][0]){case b.Left:h[n-1][1].left=h[n][1];break;case b.Right:h[n-1][1].right=h[n][1];break;case b.Mid:h[n-1][1].mid=h[n][1];break}else this.c=h[0][1]}}return i}get(f){return this.d(f)?.value}d(f){const r=this.b.reset(f);let c=this.c;for(;c;){const l=r.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(f){const r=this.d(f);return!(r?.value===void 0&&r?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,r){const c=this.b.reset(f),l=[];let h=this.c;for(;h;){const i=c.cmp(h.segment);if(i>0)l.push([b.Left,h]),h=h.left;else if(i<0)l.push([b.Right,h]),h=h.right;else if(c.hasNext())c.next(),l.push([b.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:n,value:t,segment:o}=i;this.e(i.key,!1),h.key=n,h.value=t,h.segment=o}}else{const i=h.left??h.right;if(l.length>0){const[n,t]=l[l.length-1];switch(n){case b.Left:t.left=i;break;case b.Mid:t.mid=i;break;case b.Right:t.right=i;break}}else this.c=i}for(let i=l.length-1;i>=0;i--){const n=l[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),l[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),l[i][1]=n.rotateRight()),i>0)switch(l[i-1][0]){case b.Left:l[i-1][1].left=l[i][1];break;case b.Right:l[i-1][1].right=l[i][1];break;case b.Mid:l[i-1][1].mid=l[i][1];break}else this.c=l[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const r=this.b.reset(f);let c=this.c,l;for(;c;){const h=r.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(r.hasNext())r.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(f){return this.g(f,!1)}g(f,r){const c=this.b.reset(f);let l=this.c;for(;l;){const h=c.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else return l.mid?this.h(l.mid):r?l.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[r,c]of this)f(c,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const r=[];return this.j(f,r),r[Symbol.iterator]()}j(f,r){f&&(f.left&&this.j(f.left,r),f.value&&r.push([f.key,f.value]),f.mid&&this.j(f.mid,r),f.right&&this.j(f.right,r))}_isBalanced(){const f=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:f(r.left)&&f(r.right)};return f(this.c)}}e.$Oi=u}),define(Re[33],Te([1,0,20,2,37]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=N,e.$ei=R,e.$fi=p;function N(s){return JSON.stringify(s,O)}function R(s){let I=JSON.parse(s);return I=p(I),I}function O(s,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return D.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof y.$Qe||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let b=0;b<s.length;++b)s[b]=p(s[b],I+1);else for(const b in s)Object.hasOwnProperty.call(s,b)&&(s[b]=p(s[b],I+1))}return s}}),define(Re[41],Te([1,0,17,10,30,73,27,22,23,13]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=I,e.$Bk=r,e.$Ck=M,e.$Dk=A,e.$Ek=L,e.$Fk=Z,e.$Gk=J,e.$Hk=ne;function I(){return Object.create(null)}e.$zk="**",e.$Ak="/";const b="[/\\\\]",u="[^/\\\\]",E=/\//g;function f(ue,_){switch(ue){case 0:return"";case 1:return`${u}*?`;default:return`(?:${b}|${u}+${b}${_?`|${b}${u}+`:""})*?`}}function r(ue,_){if(!ue)return[];const ae=[];let se=!1,ce=!1,x="";for(const we of ue){switch(we){case _:if(!se&&!ce){ae.push(x),x="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}x+=we}return x&&ae.push(x),ae}function c(ue){if(!ue)return"";let _="";const ae=r(ue,e.$Ak);if(ae.every(se=>se===e.$zk))_=".*";else{let se=!1;ae.forEach((ce,x)=>{if(ce===e.$zk){if(se)return;_+=f(2,x===ae.length-1)}else{let we=!1,Ie="",Y=!1,q="";for(const ie of ce){if(ie!=="}"&&we){Ie+=ie;continue}if(Y&&(ie!=="]"||!q)){let ve;ie==="-"?ve=ie:(ie==="^"||ie==="!")&&!q?ve="^":ie===e.$Ak?ve="":ve=(0,s.$kf)(ie),q+=ve;continue}switch(ie){case"{":we=!0;continue;case"[":Y=!0;continue;case"}":{const Pe=`(?:${r(Ie,",").map(Fe=>c(Fe)).join("|")})`;_+=Pe,we=!1,Ie="";break}case"]":{_+="["+q+"]",Y=!1,q="";break}case"?":_+=u;continue;case"*":_+=f(1);continue;default:_+=(0,s.$kf)(ie)}}x<ae.length-1&&(ae[x+1]!==e.$zk||x+2<ae.length)&&(_+=b)}se=ce===e.$zk})}return _}const l=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new R.$Gc(1e4),m=function(){return!1},g=function(){return null};function d(ue,_){if(!ue)return g;let ae;typeof ue!="string"?ae=ue.pattern:ae=ue,ae=ae.trim();const se=`${ae}_${!!_.trimForExclusions}`;let ce=a.get(se);if(ce)return S(ce,ue);let x;return l.test(ae)?ce=v(ae.substr(4),ae):(x=h.exec(k(ae,_)))?ce=C(x[1],ae):(_.trimForExclusions?n:i).test(ae)?ce=T(ae,_):(x=t.exec(k(ae,_)))?ce=$(x[1].substr(1),ae,!0):(x=o.exec(k(ae,_)))?ce=$(x[1],ae,!1):ce=w(ae),a.set(se,ce),S(ce,ue)}function S(ue,_){if(typeof _=="string")return ue;const ae=function(se,ce){return(0,N.$Hg)(se,_.base,!p.$l)?ue((0,s.$pf)(se.substr(_.base.length),O.sep),ce):null};return ae.allBasenames=ue.allBasenames,ae.allPaths=ue.allPaths,ae.basenames=ue.basenames,ae.patterns=ue.patterns,ae}function k(ue,_){return _.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function v(ue,_){return function(ae,se){return typeof ae=="string"&&ae.endsWith(ue)?_:null}}function C(ue,_){const ae=`/${ue}`,se=`\\${ue}`,ce=function(we,Ie){return typeof we!="string"?null:Ie?Ie===ue?_:null:we===ue||we.endsWith(ae)||we.endsWith(se)?_:null},x=[ue];return ce.basenames=x,ce.patterns=[_],ce.allBasenames=x,ce}function T(ue,_){const ae=Q(ue.slice(1,-1).split(",").map(Ie=>d(Ie,_)).filter(Ie=>Ie!==g),ue),se=ae.length;if(!se)return g;if(se===1)return ae[0];const ce=function(Ie,Y){for(let q=0,ie=ae.length;q<ie;q++)if(ae[q](Ie,Y))return ue;return null},x=ae.find(Ie=>!!Ie.allBasenames);x&&(ce.allBasenames=x.allBasenames);const we=ae.reduce((Ie,Y)=>Y.allPaths?Ie.concat(Y.allPaths):Ie,[]);return we.length&&(ce.allPaths=we),ce}function $(ue,_,ae){const se=O.sep===O.$jc.sep,ce=se?ue:ue.replace(E,O.sep),x=O.sep+ce,we=O.$jc.sep+ue;let Ie;return ae?Ie=function(Y,q){return typeof Y=="string"&&(Y===ce||Y.endsWith(x)||!se&&(Y===ue||Y.endsWith(we)))?_:null}:Ie=function(Y,q){return typeof Y=="string"&&(Y===ce||!se&&Y===ue)?_:null},Ie.allPaths=[(ae?"*/":"./")+ue],Ie}function w(ue){try{const _=new RegExp(`^${c(ue)}$`);return function(ae){return _.lastIndex=0,typeof ae=="string"&&_.test(ae)?ue:null}}catch{return g}}function M(ue,_,ae){return!ue||typeof _!="string"?!1:A(ue)(_,void 0,ae)}function A(ue,_={}){if(!ue)return m;if(typeof ue=="string"||L(ue)){const ae=d(ue,_);if(ae===g)return m;const se=function(ce,x){return!!ae(ce,x)};return ae.allBasenames&&(se.allBasenames=ae.allBasenames),ae.allPaths&&(se.allPaths=ae.allPaths),se}return U(ue,_)}function L(ue){const _=ue;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}function Z(ue){return ue.allBasenames||[]}function J(ue){return ue.allPaths||[]}function U(ue,_){const ae=Q(Object.getOwnPropertyNames(ue).map(Ie=>V(Ie,ue[Ie],_)).filter(Ie=>Ie!==g)),se=ae.length;if(!se)return g;if(!ae.some(Ie=>!!Ie.requiresSiblings)){if(se===1)return ae[0];const Ie=function(ie,ve){let Pe;for(let Fe=0,Be=ae.length;Fe<Be;Fe++){const xe=ae[Fe](ie,ve);if(typeof xe=="string")return xe;(0,D.$uh)(xe)&&(Pe||(Pe=[]),Pe.push(xe))}return Pe?(async()=>{for(const Fe of Pe){const Be=await Fe;if(typeof Be=="string")return Be}return null})():null},Y=ae.find(ie=>!!ie.allBasenames);Y&&(Ie.allBasenames=Y.allBasenames);const q=ae.reduce((ie,ve)=>ve.allPaths?ie.concat(ve.allPaths):ie,[]);return q.length&&(Ie.allPaths=q),Ie}const ce=function(Ie,Y,q){let ie,ve;for(let Pe=0,Fe=ae.length;Pe<Fe;Pe++){const Be=ae[Pe];Be.requiresSiblings&&q&&(Y||(Y=(0,O.$qc)(Ie)),ie||(ie=Y.substr(0,Y.length-(0,O.$rc)(Ie).length)));const xe=Be(Ie,Y,ie,q);if(typeof xe=="string")return xe;(0,D.$uh)(xe)&&(ve||(ve=[]),ve.push(xe))}return ve?(async()=>{for(const Pe of ve){const Fe=await Pe;if(typeof Fe=="string")return Fe}return null})():null},x=ae.find(Ie=>!!Ie.allBasenames);x&&(ce.allBasenames=x.allBasenames);const we=ae.reduce((Ie,Y)=>Y.allPaths?Ie.concat(Y.allPaths):Ie,[]);return we.length&&(ce.allPaths=we),ce}function V(ue,_,ae){if(_===!1)return g;const se=d(ue,ae);if(se===g)return g;if(typeof _=="boolean")return se;if(_){const ce=_.when;if(typeof ce=="string"){const x=(we,Ie,Y,q)=>{if(!q||!se(we,Ie))return null;const ie=ce.replace("$(basename)",()=>Y),ve=q(ie);return(0,D.$uh)(ve)?ve.then(Pe=>Pe?ue:null):ve?ue:null};return x.requiresSiblings=!0,x}}return se}function Q(ue,_){const ae=ue.filter(Ie=>!!Ie.basenames);if(ae.length<2)return ue;const se=ae.reduce((Ie,Y)=>{const q=Y.basenames;return q?Ie.concat(q):Ie},[]);let ce;if(_){ce=[];for(let Ie=0,Y=se.length;Ie<Y;Ie++)ce.push(_)}else ce=ae.reduce((Ie,Y)=>{const q=Y.patterns;return q?Ie.concat(q):Ie},[]);const x=function(Ie,Y){if(typeof Ie!="string")return null;if(!Y){let ie;for(ie=Ie.length;ie>0;ie--){const ve=Ie.charCodeAt(ie-1);if(ve===P.CharCode.Slash||ve===P.CharCode.Backslash)break}Y=Ie.substr(ie)}const q=se.indexOf(Y);return q!==-1?ce[q]:null};x.basenames=se,x.patterns=ce,x.allBasenames=se;const we=ue.filter(Ie=>!Ie.basenames);return we.push(x),we}function ne(ue,_){return(0,y.$wb)(ue,_,(ae,se)=>typeof ae=="string"&&typeof se=="string"?ae===se:typeof ae!="string"&&typeof se!="string"?ae.base===se.base&&ae.pattern===se.pattern:!1)}}),define(Re[59],Te([1,0,12,99,24,13,2]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.MarkdownStringTextNewlineStyle=void 0,e.$8k=s,e.$9k=I,e.$0k=b,e.$$k=u,e.$_k=E,e.$al=f,e.$bl=r,e.$cl=c;var O;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class p{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,y.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=O.Paragraph){return this.value+=u(this.supportThemeIcons?(0,D.$1k)(h):h).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${E(i,h)}
`,this}appendLink(h,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(h,i){const n=new RegExp((0,N.$kf)(i),"g");return h.replace(n,(t,o)=>h.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$7k=p;function s(l){return I(l)?!l.value:Array.isArray(l)?l.every(s):!0}function I(l){return l instanceof p?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function b(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons&&l.supportHtml===h.supportHtml&&(l.baseUri===h.baseUri||!!l.baseUri&&!!h.baseUri&&(0,P.$ch)(R.URI.from(l.baseUri),R.URI.from(h.baseUri)))}function u(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(l,h){const i=l.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${h}`,l,`${"`".repeat(n)}`].join(`
`)}function f(l){return l.replace(/"/g,"&quot;")}function r(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function c(l){const h=[],i=l.split("|").map(t=>t.trim());l=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),a=t?t[1]:"",m=o?o[1]:"",g=isFinite(parseInt(m)),d=isFinite(parseInt(a));g&&h.push(`width="${m}"`),d&&h.push(`height="${a}"`)}return{href:l,dimensions:h}}}),define(Re[100],Te([1,0,17,73,22,23,24,13]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6w=p,e.$7w=I,e.$8w=u,e.$9w=E,e.$0w=l,e.$$w=i,e.$_w=n,e.$ax=t,e.$bx=o,e.$cx=a;function p(g,d){const{os:S,tildify:k,relative:v}=d;if(v){const $=s(g,v,S);if(typeof $=="string")return $}let C=g.fsPath;if(S===N.OperatingSystem.Windows&&!N.$j?C=C.replace(/\//g,"\\"):S!==N.OperatingSystem.Windows&&N.$j&&(C=C.replace(/\\/g,"/")),S!==N.OperatingSystem.Windows&&k?.userHome){const $=k.userHome.fsPath;let w;g.scheme!==k.userHome.scheme&&g.path[0]===P.$jc.sep&&g.path[1]!==P.$jc.sep?w=k.userHome.with({path:g.path}).fsPath:w=C,C=u(w,$,S)}return(S===N.OperatingSystem.Windows?P.$ic:P.$jc).normalize(I(C,S===N.OperatingSystem.Windows))}function s(g,d,S){const k=S===N.OperatingSystem.Windows?P.$ic:P.$jc,v=S===N.OperatingSystem.Linux?R.$_g:R.$bh,C=d.getWorkspace(),T=(0,y.$Qb)(C.folders);if(!T)return;g.scheme!==T.uri.scheme&&g.path[0]===P.$jc.sep&&g.path[1]!==P.$jc.sep&&(g=T.uri.with({path:g.path}));const $=d.getWorkspaceFolder(g);if(!$)return;let w;if(v.isEqual($.uri,g)?w="":w=v.relativePath($.uri,g)??"",w&&(w=k.normalize(w)),C.folders.length>1&&!d.noPrefix){const M=$.name?$.name:v.basenameOrAuthority($.uri);w=w?`${M} \u2022 ${w}`:M}return w}function I(g,d=N.$j){return(0,D.$Mg)(g,d)?g.charAt(0).toUpperCase()+g.slice(1):g}let b=Object.create(null);function u(g,d,S=N.OS){if(S===N.OperatingSystem.Windows||!g||!d)return g;let k=b.original===d?b.normalized:void 0;k||(k=d,N.$j&&(k=(0,D.$Bg)(k)),k=`${(0,O.$qf)(k,P.$jc.sep)}${P.$jc.sep}`,b={original:d,normalized:k});let v=g;return N.$j&&(v=(0,D.$Bg)(v)),(S===N.OperatingSystem.Linux?v.startsWith(k):(0,O.$Jf)(v,k))?`~/${v.substr(k.length)}`:g}function E(g,d){return g.replace(/^~($|\/|\\)/,`${d}$1`)}const f="\u2026",r="\\\\",c="~";function l(g,d=P.sep){const S=new Array(g.length);let k=!1;for(let v=0;v<g.length;v++){const C=g[v];if(C===""){S[v]=`.${d}`;continue}if(!C){S[v]=C;continue}k=!0;let T="",$=C;$.indexOf(r)===0?(T=$.substr(0,$.indexOf(r)+r.length),$=$.substr($.indexOf(r)+r.length)):$.indexOf(d)===0?(T=$.substr(0,$.indexOf(d)+d.length),$=$.substr($.indexOf(d)+d.length)):$.indexOf(c)===0&&(T=$.substr(0,$.indexOf(c)+c.length),$=$.substr($.indexOf(c)+c.length));const w=$.split(d);for(let M=1;k&&M<=w.length;M++)for(let A=w.length-M;k&&A>=0;A--){k=!1;let L=w.slice(A,A+M).join(d);for(let Z=0;!k&&Z<g.length;Z++)if(Z!==v&&g[Z]&&g[Z].indexOf(L)>-1){const J=A+M===w.length,U=A>0&&g[Z].indexOf(d)>-1?d+L:L,V=g[Z].endsWith(U);k=!J||V}if(!k){let Z="";(w[0].endsWith(":")||T!=="")&&(A===1&&(A=0,M++,L=w[0]+d+L),A>0&&(Z=w[0]+d),Z=T+Z),A>0&&(Z=Z+f+d),Z=Z+L,A+M<w.length&&(Z=Z+d+f),S[v]=Z}}k&&(S[v]=C)}return S}var h;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(g,d=Object.create(null)){const S=[];let k=!1,v="";for(const C of g)if(C==="$"||k&&C==="{")v&&S.push({value:v,type:h.TEXT}),v="",k=!0;else if(C==="}"&&k){const T=d[v];if(typeof T=="string")T.length&&S.push({value:T,type:h.VARIABLE});else if(T){const $=S[S.length-1];(!$||$.type!==h.SEPARATOR)&&S.push({value:T.label,type:h.SEPARATOR})}v="",k=!1}else v+=C;return v&&!k&&S.push({value:v,type:h.TEXT}),S.filter((C,T)=>{if(C.type===h.SEPARATOR){const $=S[T-1],w=S[T+1];return[$,w].every(M=>M&&(M.type===h.VARIABLE||M.type===h.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function n(g,d){return N.$k||d?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$k?"&":"&&"):g.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(g,d){return N.$k||d?g.replace(/\(&&\w\)|&&/g,""):N.$j?g.replace(/&&|&/g,S=>S==="&"?"&&":"&"):g.replace(/&&/g,"_")}function o(g){return g.replace(/&/g,"&&")}function a(g){if(g.endsWith("]")){const d=g.lastIndexOf(" [",g.length-2);if(d!==-1){const S=m(g.substring(0,d)),k=g.substring(d);return{name:S.name+k,parentPath:S.parentPath}}}return m(g)}function m(g){const d=g.indexOf("/")!==-1?P.$jc:P.$ic,S=d.basename(g),k=d.dirname(g);return S.length?{name:S,parentPath:k}:{name:k,parentPath:""}}}),define(Re[150],Te([1,0,20,37,2]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=void 0,e.$Rn=p,e.$Sn=I,e.$Tn=b;function N(u){return u.toJSON()}class R{constructor(E){this.a=E}transformIncoming(E){const f=this.a.transformIncoming(E);return f===E?E:N(P.URI.from(f))}transformOutgoing(E){const f=this.a.transformOutgoing(E);return f===E?E:N(P.URI.from(f))}transformOutgoingURI(E){const f=this.a.transformOutgoing(E);return f===E?E:P.URI.from(f)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Pn=R,e.$Qn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,E,f){if(!u||f>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return E.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const c=O(u[r],E,f+1);c!==null&&(u[r]=c)}}return null}function p(u,E){const f=O(u,E,0);return f===null?u:f}function s(u,E,f,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===D.MarshalledId.Uri)return f?P.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof y.$Qe)return null;for(const c in u)if(Object.hasOwnProperty.call(u,c)){const l=s(u[c],E,f,r+1);l!==null&&(u[c]=l)}}return null}function I(u,E){const f=s(u,E,!1,0);return f===null?u:f}function b(u,E){const f=s(u,E,!0,0);return f===null?u:f}}),define(Re[38],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=D;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(P){return y.test(P)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(O){for(let p=0;p<O.length;p++)O[p]=Math.floor(Math.random()*256);return O};const N=new Uint8Array(16),R=[];for(let O=0;O<256;O++)R.push(O.toString(16).padStart(2,"0"));return function(){P(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let p=0,s="";return s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s}}()}),define(Re[151],Te([1,0,17,40,38]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.$wu=void 0,e.$uu=N,e.$vu=R,e.$xu=s;function N(b){return{asString:async()=>b,asFile:()=>{},value:typeof b=="string"?b:void 0}}function R(b,u,E){const f={id:(0,P.$5g)(),name:b,uri:u,data:E};return{asString:async()=>"",asFile:()=>f,value:void 0}}class O{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return D.Iterable.some(this,([f,r])=>r.asFile())&&E.push("files"),I(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const f=this.a.get(u);f?f.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const f of E)yield[u,f]}b(u){return p(u)}}e.$wu=O;function p(b){return b.toLowerCase()}function s(b,u){return I(p(b),u.map(p))}function I(b,u){if(b==="*/*")return u.length>0;if(u.includes(b))return!0;const E=b.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[f,r,c]=E;return c==="*"?u.some(l=>l.startsWith(r+"/")):!1}e.$yu=Object.freeze({create:b=>(0,y.$Ob)(b.map(u=>u.toString())).join(`\r
`),split:b=>b.split(`\r
`),parse:b=>e.$yu.split(b).filter(u=>!u.startsWith("#"))})}),define(Re[152],Te([1,0,10,6,4,33,14]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.StorageState=e.StorageHint=void 0,e.$gq=p;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var s;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends P.$Xc{static{this.a=100}constructor(E,f=Object.create(null)){super(),this.r=E,this.s=f,this.b=this.B(new D.$re),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new y.$Gh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((f,r)=>this.w(r,f)),E.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(E,f){if(this.c===s.Closed)return;let r=!1;(0,R.$qg)(f)?r=this.f.delete(E):this.f.get(E)!==f&&(this.f.set(E,f),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,f){const r=this.f.get(E);return(0,R.$qg)(r)?f:r}getBoolean(E,f){const r=this.get(E);return(0,R.$qg)(r)?f:r==="true"}getNumber(E,f){const r=this.get(E);return(0,R.$qg)(r)?f:parseInt(r,10)}getObject(E,f){const r=this.get(E);return(0,R.$qg)(r)?f:(0,N.$ei)(r)}async set(E,f,r=!1){if(this.c===s.Closed)return;if((0,R.$qg)(f))return this.delete(E,r);const c=(0,R.$jg)(f)||Array.isArray(f)?(0,N.$di)(f):String(f);if(this.f.get(E)!==c)return this.f.set(E,c),this.j.set(E,c),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,f=!1){if(!(this.c===s.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:f}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===s.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$hq=I;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((f,r)=>this.a.set(r,f)),E.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$iq=b}),define(Re[153],Te([1,0,30]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Eu=P;var D;(function(N){N[N.Unknown=0]="Unknown",N[N.Invalid=3]="Invalid",N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function P(N){let R=0,O=0,p=0,s=D.Unknown;for(let I=0,b=N.length;I<b;I++){const u=N.charCodeAt(I);u===y.CharCode.CarriageReturn?(R===0&&(O=I),R++,I+1<b&&N.charCodeAt(I+1)===y.CharCode.LineFeed?(s|=D.CRLF,I++):s|=D.Invalid,p=I+1):u===y.CharCode.LineFeed&&(s|=D.LF,R===0&&(O=I),R++,p=I+1)}return R===0&&(O=N.length),[R,O,N.length-p,s]}}),define(Re[154],Te([1,0,13,23,20]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=void 0,e.$hu=I,e.$iu=b,y=qe(y),D=qe(D),P=qe(P);let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let O;function p(){return O||(O=new TextDecoder("UTF-16BE")),O}let s;function I(){return s||(s=D.$E()?R():p()),s}function b(f,r,c){const l=new Uint16Array(f.buffer,r,c);return c>0&&(l[0]===65279||l[0]===65534)?u(f,r,c):R().decode(l)}function u(f,r,c){const l=[];let h=0;for(let i=0;i<c;i++){const n=P.$Se(f,r);r+=2,l[h++]=String.fromCharCode(n)}return l.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const c=this.a-this.d;c<=1&&(c===0||y.$Mf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const c=r.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=r;return}for(let l=0;l<c;l++)this.b[this.d++]=r.charCodeAt(l)}}e.$ju=E}),define(Re[155],Te([1,0,20,154]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=void 0,e.$lu=R,y=qe(y);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,b,u){this.oldPosition=s,this.oldText=I,this.newPosition=b,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,b){const u=I.length;y.$Ve(s,u,b),b+=4;for(let E=0;E<u;E++)y.$Te(s,I.charCodeAt(E),b),b+=2;return b}static d(s,I){const b=y.$Ue(s,I);return I+=4,(0,D.$iu)(s,I,b)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(s,I){return y.$Ve(s,this.oldPosition,I),I+=4,y.$Ve(s,this.newPosition,I),I+=4,I=N.c(s,this.oldText,I),I=N.c(s,this.newText,I),I}static read(s,I,b){const u=y.$Ue(s,I);I+=4;const E=y.$Ue(s,I);I+=4;const f=N.d(s,I);I+=N.a(f);const r=N.d(s,I);return I+=N.a(r),b.push(new N(u,f,E,r)),I}}e.$ku=N;function R(p,s){return p===null||p.length===0?s:new O(p,s).compress()}class O{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,b=this.n(s),u=this.l(I);for(;s<this.f||I<this.h;){if(b===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(b),b=this.n(++s);continue}if(u.oldEnd<=b.newPosition){this.k(u),u=this.l(++I);continue}if(b.newEnd<=u.oldPosition){this.m(b),b=this.n(++s);continue}if(u.oldPosition<b.newPosition){const[l,h]=O.r(u,b.newPosition-u.oldPosition);this.k(l),u=h;continue}if(b.newPosition<u.oldPosition){const[l,h]=O.q(b,u.oldPosition-b.newPosition);this.m(l),b=h;continue}let r,c;if(u.oldEnd===b.newEnd)r=b,c=u,b=this.n(++s),u=this.l(++I);else if(u.oldEnd<b.newEnd){const[l,h]=O.q(b,u.oldLength);r=l,c=u,b=h,u=this.l(++I)}else{const[l,h]=O.r(u,b.newLength);r=b,c=l,b=this.n(++s),u=h}this.d[this.e++]=new N(r.oldPosition,r.oldText,c.newPosition,c.newText),this.g+=r.newLength-r.oldLength,this.j+=c.newLength-c.oldLength}const E=O.s(this.d);return O.t(E)}k(s){this.d[this.e++]=O.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=O.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new N(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new N(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const b=s.newText.substr(0,I),u=s.newText.substr(I);return[new N(s.oldPosition,s.oldText,s.newPosition,b),new N(s.oldEnd,"",s.newPosition+I,u)]}static r(s,I){const b=s.oldText.substr(0,I),u=s.oldText.substr(I);return[new N(s.oldPosition,b,s.newPosition,s.newText),new N(s.oldPosition+I,u,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let b=0,u=s[0];for(let E=1;E<s.length;E++){const f=s[E];u.oldEnd===f.oldPosition?u=new N(u.oldPosition,u.oldText+f.oldText,u.newPosition,u.newText+f.newText):(I[b++]=u,u=f)}return I[b++]=u,I}static t(s){if(s.length===0)return s;const I=[];let b=0;for(let u=0;u<s.length;u++){const E=s[u];E.oldText!==E.newText&&(I[b++]=E)}return I}}}),define(Re[156],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=void 0,e.$qt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[157],Te([1,0,41,22]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=P,e.$Cu=N;function P(R,O,p,s,I,b){if(Array.isArray(R)){let u=0;for(const E of R){const f=P(E,O,p,s,I,b);if(f===10)return f;f>u&&(u=f)}return u}else{if(typeof R=="string")return s?R==="*"?5:R===p?10:0:0;if(R){const{language:u,pattern:E,scheme:f,hasAccessToAllModels:r,notebookType:c}=R;if(!s&&!r)return 0;c&&I&&(O=I);let l=0;if(f)if(f===O.scheme)l=10;else if(f==="*")l=5;else return 0;if(u)if(u===p)l=10;else if(u==="*")l=Math.max(l,5);else return 0;if(c)if(c===b)l=10;else if(c==="*"&&b!==void 0)l=Math.max(l,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,D.$kc)(E.base)},h===O.fsPath||(0,y.$Ck)(h,O.fsPath))l=10;else return 0}return l}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Re[158],Te([1,0,30,159]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class N{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,b=s.notIn.length;I<b;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const b=s.findTokenIndexAtOffset(I-2),u=s.getStandardTokenType(b);return this.isOK(u)}g(s,I){for(let b=s;b<=I;b++){const u=String.fromCharCode(b);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(y.CharCode.Digit0,y.CharCode.Digit9)),this.e||(this.e=this.g(y.CharCode.a,y.CharCode.z)),this.e||(this.e=this.g(y.CharCode.A,y.CharCode.Z))),this.e}}e.$3u=N;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)O(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),O(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),O(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),O(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&O(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$4u=R;function O(p,s,I){p.has(s)?p.get(s).push(I):p.set(s,[I])}}),define(Re[160],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=e.NodeColor=e.$kD=void 0,e.$mD=P,e.$nD=N,e.$oD=s,e.$pD=I,e.$qD=b,e.$rD=u,e.$sD=E,e.$tD=f;class y{constructor(c,l){this.piece=c,this.color=l,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$lD)return P(this.right);let c=this;for(;c.parent!==e.$lD&&c.parent.left!==c;)c=c.parent;return c.parent===e.$lD?e.$lD:c.parent}prev(){if(this.left!==e.$lD)return N(this.left);let c=this;for(;c.parent!==e.$lD&&c.parent.right!==c;)c=c.parent;return c.parent===e.$lD?e.$lD:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$kD=y;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$lD=new y(null,D.Black),e.$lD.parent=e.$lD,e.$lD.left=e.$lD,e.$lD.right=e.$lD,e.$lD.color=D.Black;function P(r){for(;r.left!==e.$lD;)r=r.left;return r}function N(r){for(;r.right!==e.$lD;)r=r.right;return r}function R(r){return r===e.$lD?0:r.size_left+r.piece.length+R(r.right)}function O(r){return r===e.$lD?0:r.lf_left+r.piece.lineFeedCnt+O(r.right)}function p(){e.$lD.parent=e.$lD}function s(r,c){const l=c.right;l.size_left+=c.size_left+(c.piece?c.piece.length:0),l.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=l.left,l.left!==e.$lD&&(l.left.parent=c),l.parent=c.parent,c.parent===e.$lD?r.root=l:c.parent.left===c?c.parent.left=l:c.parent.right=l,l.left=c,c.parent=l}function I(r,c){const l=c.left;c.left=l.right,l.right!==e.$lD&&(l.right.parent=c),l.parent=c.parent,c.size_left-=l.size_left+(l.piece?l.piece.length:0),c.lf_left-=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),c.parent===e.$lD?r.root=l:c===c.parent.right?c.parent.right=l:c.parent.left=l,l.right=c,c.parent=l}function b(r,c){let l,h;if(c.left===e.$lD?(h=c,l=h.right):c.right===e.$lD?(h=c,l=h.left):(h=P(c.right),l=h.right),h===r.root){r.root=l,l.color=D.Black,c.detach(),p(),r.root.parent=e.$lD;return}const i=h.color===D.Red;if(h===h.parent.left?h.parent.left=l:h.parent.right=l,h===c?(l.parent=h.parent,f(r,l)):(h.parent===c?l.parent=h:l.parent=h.parent,f(r,l),h.left=c.left,h.right=c.right,h.parent=c.parent,h.color=c.color,c===r.root?r.root=h:c===c.parent.left?c.parent.left=h:c.parent.right=h,h.left!==e.$lD&&(h.left.parent=h),h.right!==e.$lD&&(h.right.parent=h),h.size_left=c.size_left,h.lf_left=c.lf_left,f(r,h)),c.detach(),l.parent.left===l){const t=R(l),o=O(l);if(t!==l.parent.size_left||o!==l.parent.lf_left){const a=t-l.parent.size_left,m=o-l.parent.lf_left;l.parent.size_left=t,l.parent.lf_left=o,E(r,l.parent,a,m)}}if(f(r,l.parent),i){p();return}let n;for(;l!==r.root&&l.color===D.Black;)l===l.parent.left?(n=l.parent.right,n.color===D.Red&&(n.color=D.Black,l.parent.color=D.Red,s(r,l.parent),n=l.parent.right),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,l=l.parent):(n.right.color===D.Black&&(n.left.color=D.Black,n.color=D.Red,I(r,n),n=l.parent.right),n.color=l.parent.color,l.parent.color=D.Black,n.right.color=D.Black,s(r,l.parent),l=r.root)):(n=l.parent.left,n.color===D.Red&&(n.color=D.Black,l.parent.color=D.Red,I(r,l.parent),n=l.parent.left),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,l=l.parent):(n.left.color===D.Black&&(n.right.color=D.Black,n.color=D.Red,s(r,n),n=l.parent.left),n.color=l.parent.color,l.parent.color=D.Black,n.left.color=D.Black,I(r,l.parent),l=r.root));l.color=D.Black,p()}function u(r,c){for(f(r,c);c!==r.root&&c.parent.color===D.Red;)if(c.parent===c.parent.parent.left){const l=c.parent.parent.right;l.color===D.Red?(c.parent.color=D.Black,l.color=D.Black,c.parent.parent.color=D.Red,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,s(r,c)),c.parent.color=D.Black,c.parent.parent.color=D.Red,I(r,c.parent.parent))}else{const l=c.parent.parent.left;l.color===D.Red?(c.parent.color=D.Black,l.color=D.Black,c.parent.parent.color=D.Red,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,I(r,c)),c.parent.color=D.Black,c.parent.parent.color=D.Red,s(r,c.parent.parent))}r.root.color=D.Black}function E(r,c,l,h){for(;c!==r.root&&c!==e.$lD;)c.parent.left===c&&(c.parent.size_left+=l,c.parent.lf_left+=h),c=c.parent}function f(r,c){let l=0,h=0;if(c!==r.root){for(;c!==r.root&&c===c.parent.right;)c=c.parent;if(c!==r.root)for(c=c.parent,l=R(c.left)-c.size_left,h=O(c.left)-c.lf_left,c.size_left+=l,c.lf_left+=h;c!==r.root&&(l!==0||h!==0);)c.parent.left===c&&(c.parent.size_left+=l,c.parent.lf_left+=h),c=c.parent}}}),define(Re[101],Te([1,0,30,102,32,52,160,103]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ED=e.$DD=e.$CD=void 0,e.$AD=b,e.$BD=u;const p=65535;function s(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class I{constructor(i,n,t,o,a){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=a}}function b(h,i=!0){const n=[0];let t=1;for(let o=0,a=h.length;o<a;o++){const m=h.charCodeAt(o);m===y.CharCode.CarriageReturn?o+1<a&&h.charCodeAt(o+1)===y.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:m===y.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function u(h,i){h.length=0,h[0]=0;let n=1,t=0,o=0,a=0,m=!0;for(let d=0,S=i.length;d<S;d++){const k=i.charCodeAt(d);k===y.CharCode.CarriageReturn?d+1<S&&i.charCodeAt(d+1)===y.CharCode.LineFeed?(a++,h[n++]=d+2,d++):(t++,h[n++]=d+1):k===y.CharCode.LineFeed?(o++,h[n++]=d+1):m&&k!==y.CharCode.Tab&&(k<32||k>126)&&(m=!1)}const g=new I(s(h),t,o,a,m);return h.length=0,g}class E{constructor(i,n,t,o,a){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=a}}e.$CD=E;class f{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$DD=f;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$lD&&i.iterate(i.root,t=>(t!==R.$lD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let o=0;o<t.length;o++){const a=t[o];if(a.node.parent===null||a.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const a of t)a!==null&&o.push(a);this.b=o}}}class l{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new f("",[0])],this.g={line:0,column:0},this.root=R.$lD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let o=null;for(let a=0,m=i.length;a<m;a++)if(i[a].buffer.length>0){i[a].lineStarts||(i[a].lineStarts=b(i[a].buffer));const g=new E(a+1,{line:0,column:0},{line:i[a].lineStarts.length-1,column:i[a].buffer.length-i[a].lineStarts[i[a].lineStarts.length-1]},i[a].lineStarts.length-1,i[a].buffer.length);this.a.push(i[a]),o=this.S(o,g)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,t=n-Math.floor(n/3),o=t*2;let a="",m=0;const g=[];if(this.iterate(this.root,d=>{const S=this.R(d),k=S.length;if(m<=t||m+k<o)return a+=S,m+=k,!0;const v=a.replace(/\r\n|\r|\n/g,i);return g.push(new f(v,b(v))),a=S,m=k,!0}),m>0){const d=a.replace(/\r\n|\r|\n/g,i);g.push(new f(d,b(d)))}this.create(g,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===R.$lD)return!0;const a=this.R(o),m=a.length,g=i.G(n),d=i.G(n+m),S=i.getValueInRange2(g,d);return n+=m,a===S})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==R.$lD;)if(o.left!==R.$lD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const a=this.B(o,i-o.lf_left-2);return t+=a+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==R.$lD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const a=this.A(n,i-n.size_left);if(t+=n.lf_left+a.index,a.index===0){const m=this.getOffsetAt(t+1,1),g=o-m;return new D.$St(t+1,g+1)}return new D.$St(t+1,a.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$lD){const a=this.getOffsetAt(t+1,1),m=o-i-a;return new D.$St(t+1,m+1)}else n=n.right;return new D.$St(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),a=this.getValueInRange2(t,o);return n?n!==this.d||!this.f?a.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?a:a.replace(/\r\n|\r|\n/g,n):a}getValueInRange2(i,n){if(i.node===n.node){const g=i.node,d=this.a[g.piece.bufferIndex].buffer,S=this.u(g.piece.bufferIndex,g.piece.start);return d.substring(S+i.remainder,S+n.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,a=this.u(t.piece.bufferIndex,t.piece.start);let m=o.substring(a+i.remainder,a+t.piece.length);for(t=t.next();t!==R.$lD;){const g=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){m+=g.substring(d,d+n.remainder);break}else m+=g.substr(d,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,a=>{if(a===R.$lD)return!0;const m=a.piece;let g=m.length;if(g===0)return!0;const d=this.a[m.bufferIndex].buffer,S=this.a[m.bufferIndex].lineStarts,k=m.start.line,v=m.end.line;let C=S[k]+m.start.column;if(o&&(d.charCodeAt(C)===y.CharCode.LineFeed&&(C++,g--),i[n++]=t,t="",o=!1,g===0))return!0;if(k===v)return!this.f&&d.charCodeAt(C+g-1)===y.CharCode.CarriageReturn?(o=!0,t+=d.substr(C,g-1)):t+=d.substr(C,g),!0;t+=this.f?d.substring(C,Math.max(C,S[k+1]-this.e)):d.substring(C,S[k+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let T=k+1;T<v;T++)t=this.f?d.substring(S[T],S[T+1]-this.e):d.substring(S[T],S[T+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&d.charCodeAt(S[v]+m.end.column-1)===y.CharCode.CarriageReturn?(o=!0,m.end.column===0?n--:t=d.substr(S[v],m.end.column-1)):t=d.substr(S[v],m.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===R.$lD)return"";const o=this.a[t.piece.bufferIndex],a=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(a,a+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start),a=o+n.remainder,m=o+n.node.piece.length;return t.buffer.substring(a,m)}}findMatchesInNode(i,n,t,o,a,m,g,d,S,k,v){const C=this.a[i.piece.bufferIndex],T=this.u(i.piece.bufferIndex,i.piece.start),$=this.u(i.piece.bufferIndex,a),w=this.u(i.piece.bufferIndex,m);let M;const A={line:0,column:0};let L,Z;n._wordSeparators?(L=C.buffer.substring($,w),Z=J=>J+$,n.reset(0)):(L=C.buffer,Z=J=>J,n.reset($));do if(M=n.next(L),M){if(Z(M.index)>=w)return k;this.s(i,Z(M.index)-T,A);const J=this.t(i.piece.bufferIndex,a,A),U=A.line===a.line?A.column-a.column+o:A.column+1,V=U+M[0].length;if(v[k++]=(0,O.$wD)(new P.$Tt(t+J,U,t+J,V),M,d),Z(M.index)+M[0].length>=w||k>=S)return k}while(M);return k}findMatchesLineByLine(i,n,t,o){const a=[];let m=0;const g=new O.$zD(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let k=this.s(d.node,d.remainder);const v=this.s(S.node,S.remainder);if(d.node===S.node)return this.findMatchesInNode(d.node,g,i.startLineNumber,i.startColumn,k,v,n,t,o,m,a),a;let C=i.startLineNumber,T=d.node;for(;T!==S.node;){const w=this.t(T.piece.bufferIndex,k,T.piece.end);if(w>=1){const A=this.a[T.piece.bufferIndex].lineStarts,L=this.u(T.piece.bufferIndex,T.piece.start),Z=A[k.line+w],J=C===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(T,g,C,J,k,this.s(T,Z-L),n,t,o,m,a),m>=o)return a;C+=w}const M=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const A=this.getLineContent(C).substring(M,i.endColumn-1);return m=this.n(n,g,A,i.endLineNumber,M,m,a,t,o),a}if(m=this.n(n,g,this.getLineContent(C).substr(M),C,M,m,a,t,o),m>=o)return a;C++,d=this.H(C,1),T=d.node,k=this.s(d.node,d.remainder)}if(C===i.endLineNumber){const w=C===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(C).substring(w,i.endColumn-1);return m=this.n(n,g,M,i.endLineNumber,w,m,a,t,o),a}const $=C===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(S.node,g,C,$,k,v,n,t,o,m,a),a}n(i,n,t,o,a,m,g,d,S){const k=i.wordSeparators;if(!d&&i.simpleSearch){const C=i.simpleSearch,T=C.length,$=t.length;let w=-T;for(;(w=t.indexOf(C,w+T))!==-1;)if((!k||(0,O.$yD)(k,t,$,w,T))&&(g[m++]=new N.$kw(new P.$Tt(o,w+1+a,o,w+1+T+a),null),m>=S))return m;return m}let v;n.reset(0);do if(v=n.next(t),v&&(g[m++]=(0,O.$wD)(new P.$Tt(o,v.index+1+a,o,v.index+1+v[0].length+a),v,d),m>=S))return m;while(v);return m}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$lD){const{node:o,remainder:a,nodeStartOffset:m}=this.G(i),g=o.piece,d=g.bufferIndex,S=this.s(o,a);if(o.piece.bufferIndex===0&&g.end.line===this.g.line&&g.end.column===this.g.column&&m+g.length===i&&n.length<p){this.F(o,n),this.y();return}if(m===i)this.o(n,o),this.h.validate(i);else if(m+o.piece.length>i){const k=[];let v=new E(g.bufferIndex,S,g.end,this.t(g.bufferIndex,S,g.end),this.u(d,g.end)-this.u(d,S));if(this.K()&&this.M(n)&&this.I(o,a)===10){const w={line:v.start.line+1,column:0};v=new E(v.bufferIndex,w,v.end,this.t(v.bufferIndex,w,v.end),v.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,a-1)===13){const w=this.s(o,a-1);this.C(o,w),n="\r"+n,o.piece.length===0&&k.push(o)}else this.C(o,S);else this.C(o,S);const C=this.w(n);v.length>0&&this.S(o,v);let T=o;for(let $=0;$<C.length;$++)T=this.S(T,C[$]);this.v(k)}else this.q(n,o)}else{const o=this.w(n);let a=this.T(null,o[0]);for(let m=1;m<o.length;m++)a=this.S(a,o[m])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$lD)return;const t=this.G(i),o=this.G(i+n),a=t.node,m=o.node;if(a===m){const C=this.s(a,t.remainder),T=this.s(a,o.remainder);if(t.nodeStartOffset===i){if(n===a.piece.length){const $=a.next();(0,R.$qD)(this,a),this.N($),this.y();return}this.D(a,T),this.h.validate(i),this.N(a),this.y();return}if(t.nodeStartOffset+a.piece.length===i+n){this.C(a,C),this.O(a),this.y();return}this.E(a,C,T),this.y();return}const g=[],d=this.s(a,t.remainder);this.C(a,d),this.h.validate(i),a.piece.length===0&&g.push(a);const S=this.s(m,o.remainder);this.D(m,S),m.piece.length===0&&g.push(m);const k=a.next();for(let C=k;C!==R.$lD&&C!==m;C=C.next())g.push(C);const v=a.piece.length===0?a.prev():a;this.v(g),this.O(v),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const m=n.piece,g={line:m.start.line+1,column:0},d=new E(m.bufferIndex,g,m.end,this.t(m.bufferIndex,g,m.end),m.length-1);n.piece=d,i+=`
`,(0,R.$sD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.w(i);let a=this.T(n,o[o.length-1]);for(let m=o.length-2;m>=0;m--)a=this.T(a,o[m]);this.N(a),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),o=this.S(n,t[0]);let a=o;for(let m=1;m<t.length;m++)a=this.S(a,t[m]);this.N(o)}s(i,n,t){const o=i.piece,a=i.piece.bufferIndex,m=this.a[a].lineStarts,d=m[o.start.line]+o.start.column+n;let S=o.start.line,k=o.end.line,v=0,C=0,T=0;for(;S<=k&&(v=S+(k-S)/2|0,T=m[v],v!==k);)if(C=m[v+1],d<T)k=v-1;else if(d>=C)S=v+1;else break;return t?(t.line=v,t.column=d-T,null):{line:v,column:d-T}}t(i,n,t){if(t.column===0)return t.line-n.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const a=o[t.line+1],m=o[t.line]+t.column;if(a>m+1)return t.line-n.line;const g=m-1;return this.a[i].buffer.charCodeAt(g)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$qD)(this,i[n])}w(i){if(i.length>p){const k=[];for(;i.length>p;){const C=i.charCodeAt(p-1);let T;C===y.CharCode.CarriageReturn||C>=55296&&C<=56319?(T=i.substring(0,p-1),i=i.substring(p-1)):(T=i.substring(0,p),i=i.substring(p));const $=b(T);k.push(new E(this.a.length,{line:0,column:0},{line:$.length-1,column:T.length-$[$.length-1]},$.length-1,T.length)),this.a.push(new f(T,$))}const v=b(i);return k.push(new E(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new f(i,v)),k}let n=this.a[0].buffer.length;const t=b(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let k=0;k<t.length;k++)t[k]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let k=0;k<t.length;k++)t[k]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const a=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,g=a-this.a[0].lineStarts[m],d={line:m,column:g},S=new E(0,o,d,this.t(0,o,d),a-n);return this.g=d,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const a=this.h.get2(i);if(a){t=a.node;const m=this.B(t,i-a.nodeStartLineNumber-1),g=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(a.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=g.substring(d+m,d+t.piece.length);else{const S=this.B(t,i-a.nodeStartLineNumber);return g.substring(d+m,d+S-n)}}else{let m=0;const g=i;for(;t!==R.$lD;)if(t.left!==R.$lD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const d=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),k=this.a[t.piece.bufferIndex].buffer,v=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:g-(i-1-t.lf_left)}),k.substring(v+d,v+S-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const d=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,k=this.u(t.piece.bufferIndex,t.piece.start);o=S.substring(k+d,k+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$lD;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const g=this.B(t,0),d=this.u(t.piece.bufferIndex,t.piece.start);return o+=m.substring(d,d+g-n),o}else{const g=this.u(t.piece.bufferIndex,t.piece.start);o+=m.substr(g,t.piece.length)}t=t.next()}return o}y(){let i=this.root,n=1,t=0;for(;i!==R.$lD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,o=this.s(i,n),a=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const m=this.t(i.piece.bufferIndex,t.start,o);if(m!==a)return{index:m,remainder:0}}return{index:a,remainder:o.column}}B(i,n){if(n<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,a=t.start.line+n+1;return a>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[a]-o[t.start.line]-t.start.column}C(i,n){const t=i.piece,o=t.lineFeedCnt,a=this.u(t.bufferIndex,t.end),m=n,g=this.u(t.bufferIndex,m),d=this.t(t.bufferIndex,t.start,m),S=d-o,k=g-a,v=t.length+k;i.piece=new E(t.bufferIndex,t.start,m,d,v),(0,R.$sD)(this,i,k,S)}D(i,n){const t=i.piece,o=t.lineFeedCnt,a=this.u(t.bufferIndex,t.start),m=n,g=this.t(t.bufferIndex,m,t.end),d=this.u(t.bufferIndex,m),S=g-o,k=a-d,v=t.length+k;i.piece=new E(t.bufferIndex,m,t.end,g,v),(0,R.$sD)(this,i,k,S)}E(i,n,t){const o=i.piece,a=o.start,m=o.end,g=o.length,d=o.lineFeedCnt,S=n,k=this.t(o.bufferIndex,o.start,S),v=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,a);i.piece=new E(o.bufferIndex,o.start,S,k,v),(0,R.$sD)(this,i,v-g,k-d);const C=new E(o.bufferIndex,t,m,this.t(o.bufferIndex,t,m),this.u(o.bufferIndex,m)-this.u(o.bufferIndex,t)),T=this.S(i,C);this.N(T)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const a=b(n,!1);for(let T=0;T<a.length;T++)a[T]+=o;if(t){const T=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-T}}this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1));const m=this.a[0].lineStarts.length-1,g=this.a[0].buffer.length-this.a[0].lineStarts[m],d={line:m,column:g},S=i.piece.length+n.length,k=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,d),C=v-k;i.piece=new E(i.piece.bufferIndex,i.piece.start,d,v,S),this.g=d,(0,R.$sD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==R.$lD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const a={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(a),a}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,o=0;for(;t!==R.$lD;)if(t.left!==R.$lD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const a=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(a+n-1,m),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const a=this.B(t,i-t.lf_left-2);if(a+n-1<=t.piece.length)return{node:t,remainder:a+n-1,nodeStartOffset:o};n-=t.piece.length-a;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$lD;){if(t.piece.lineFeedCnt>0){const a=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(n-1,a),nodeStartOffset:m}}else if(t.piece.length>=n-1){const a=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:a}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$lD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,o=n.start.line,a=t[o]+n.start.column;return o===t.length-1||t[o+1]>a+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(a)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$lD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let a;i.piece.end.column===0?a={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:a={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,g=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,a,g,m),(0,R.$sD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const d={line:n.piece.start.line+1,column:0},S=n.piece.length-1,k=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new E(n.piece.bufferIndex,d,n.piece.end,k,S),(0,R.$sD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const v=this.w(`\r
`);this.S(i,v[0]);for(let C=0;C<t.length;C++)(0,R.$qD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$qD)(this,t);else{const o=t.piece,a={line:o.start.line+1,column:0},m=o.length-1,g=this.t(o.bufferIndex,a,o.end);t.piece=new E(o.bufferIndex,a,o.end,g,m),(0,R.$sD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$lD)return n(R.$lD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$lD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),a=this.u(t.bufferIndex,t.end);return n.buffer.substring(o,a)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,o)}S(i,n){const t=new R.$kD(n,R.NodeColor.Red);if(t.left=R.$lD,t.right=R.$lD,t.parent=R.$lD,t.size_left=0,t.lf_left=0,this.root===R.$lD)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$lD)i.right=t,t.parent=i;else{const a=(0,R.$mD)(i.right);a.left=t,t.parent=a}return(0,R.$rD)(this,t),t}T(i,n){const t=new R.$kD(n,R.NodeColor.Red);if(t.left=R.$lD,t.right=R.$lD,t.parent=R.$lD,t.size_left=0,t.lf_left=0,this.root===R.$lD)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$lD)i.left=t,t.parent=i;else{const o=(0,R.$nD)(i.left);o.right=t,t.parent=o}return(0,R.$rD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$ED=l}),define(Re[161],Te([1,0,6,13,32,52,101,153,155,4]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=void 0,D=qe(D);class I extends s.$Xc{constructor(u,E,f,r,c,l,h){super(),this.m=this.B(new y.$oe),this.onDidChangeContent=this.m.event,this.f=E,this.j=!l,this.g=r,this.h=c,this.c=new R.$ED(u,f,h)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const f=u+E,r=this.getPositionAt(u),c=this.getPositionAt(f);return new P.$Tt(r.lineNumber,r.column,c.lineNumber,c.column)}getValueInRange(u,E=N.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const f=this.n(E);return this.c.getValueInRange(u,f)}getValueLengthInRange(u,E=N.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const f=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let c=0;const l=this.n(E),h=this.getEOL();if(l.length!==h.length){const i=l.length-h.length,n=u.endLineNumber-u.startLineNumber;c=i*n}return r-f+c}getCharacterCountInRange(u,E=N.EndOfLinePreference.TextDefined){if(this.j){let f=0;const r=u.startLineNumber,c=u.endLineNumber;for(let l=r;l<=c;l++){const h=this.getLineContent(l),i=l===r?u.startColumn-1:0,n=l===c?u.endColumn-1:h.length;for(let t=i;t<n;t++)D.$Mf(h.charCodeAt(t))?(f=f+1,t=t+1):f=f+1}return f+=this.n(E).length*(c-r),f}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=D.$xf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=D.$zf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case N.EndOfLinePreference.LF:return`
`;case N.EndOfLinePreference.CRLF:return`\r
`;case N.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,f){let r=this.g,c=this.h,l=this.j,h=!0,i=[];for(let d=0;d<u.length;d++){const S=u[d];h&&S._isTracked&&(h=!1);const k=S.range;if(S.text){let w=!0;l||(w=!D.$Xf(S.text),l=w),!r&&w&&(r=D.$Wf(S.text)),!c&&w&&(c=D.$Zf(S.text))}let v="",C=0,T=0,$=0;if(S.text){let w;[C,T,$,w]=(0,O.$Eu)(S.text);const M=this.getEOL(),A=M===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;w===O.StringEOL.Unknown||w===A?v=S.text:v=S.text.replace(/\r\n|\r|\n/g,M)}i[d]={sortIndex:d,identifier:S.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:v,eolCount:C,firstLineLength:T,lastLineLength:$,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let d=0,S=i.length-1;d<S;d++){const k=i[d].range.getEndPosition(),v=i[d+1].range.getStartPosition();if(v.isBeforeOrEqual(k)){if(v.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}h&&(i=this.s(i));const t=f||E?I._getInverseEditRanges(i):[],o=[];if(E)for(let d=0;d<i.length;d++){const S=i[d],k=t[d];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let v=k.startLineNumber;v<=k.endLineNumber;v++){let C="";v===k.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),D.$xf(C)!==-1)||o.push({lineNumber:v,oldContent:C})}}let a=null;if(f){let d=0;a=[];for(let S=0;S<i.length;S++){const k=i[S],v=t[S],C=this.getValueInRange(k.range),T=k.rangeOffset+d;d+=k.text.length-C.length,a[S]={sortIndex:k.sortIndex,identifier:k.identifier,range:v,text:C,textChange:new p.$ku(k.rangeOffset,C,T,k.text)}}n||a.sort((S,k)=>S.sortIndex-k.sortIndex)}this.g=r,this.h=c,this.j=l;const m=this.t(i);let g=null;if(E&&o.length>0){o.sort((d,S)=>S.lineNumber-d.lineNumber),g=[];for(let d=0,S=o.length;d<S;d++){const k=o[d].lineNumber;if(d>0&&o[d-1].lineNumber===k)continue;const v=o[d].oldContent,C=this.getLineContent(k);C.length===0||C===v||D.$xf(C)!==-1||g.push(k)}}return this.m.fire(),new N.$ow(a,m,g)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const f=u[0].range,r=u[u.length-1].range,c=new P.$Tt(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let l=f.startLineNumber,h=f.startColumn;const i=[];for(let m=0,g=u.length;m<g;m++){const d=u[m],S=d.range;E=E||d.forceMoveMarkers,i.push(this.getValueInRange(new P.$Tt(l,h,S.startLineNumber,S.startColumn))),d.text.length>0&&i.push(d.text),l=S.endLineNumber,h=S.endColumn}const n=i.join(""),[t,o,a]=(0,O.$Eu)(n);return{sortIndex:0,identifier:u[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,N.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:a,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const E=[];for(let f=0;f<u.length;f++){const r=u[f],c=r.range.startLineNumber,l=r.range.startColumn,h=r.range.endLineNumber,i=r.range.endColumn;if(c===h&&l===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Tt(c,l,h,i);E.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,f,r){return this.c.findMatchesLineByLine(u,E,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const f=u.startLineNumber,r=u.startColumn,[c,l,h]=(0,O.$Eu)(E);let i;if(E.length>0){const n=c+1;n===1?i=new P.$Tt(f,r,f,r+l):i=new P.$Tt(f,r,f+n-1,h+1)}else i=new P.$Tt(f,r,f,r);return i}static _getInverseEditRanges(u){const E=[];let f=0,r=0,c=null;for(let l=0,h=u.length;l<h;l++){const i=u[l];let n,t;c?c.range.endLineNumber===i.range.startLineNumber?(n=f,t=r+(i.range.startColumn-c.range.endColumn)):(n=f+(i.range.startLineNumber-c.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const a=i.eolCount+1;a===1?o=new P.$Tt(n,t,n,t+i.firstLineLength):o=new P.$Tt(n,t,n+a-1,i.lastLineLength+1)}else o=new P.$Tt(n,t,n,t);f=o.endLineNumber,r=o.endColumn,E.push(o),c=i}return E}static u(u,E){const f=P.$Tt.compareRangesUsingEnds(u.range,E.range);return f===0?u.sortIndex-E.sortIndex:f}static w(u,E){const f=P.$Tt.compareRangesUsingEnds(u.range,E.range);return f===0?E.sortIndex-u.sortIndex:-f}}e.$FD=I}),define(Re[162],Te([1,0,30,13,52,101,161]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GD=void 0,D=qe(D);class O{constructor(I,b,u,E,f,r,c,l,h){this.a=I,this.b=b,this.c=u,this.d=E,this.e=f,this.f=r,this.g=c,this.h=l,this.j=h}k(I){const b=this.c+this.d+this.e,u=this.c+this.e;return b===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:u>b/2?`\r
`:`
`}create(I){const b=this.k(I),u=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let f=0,r=u.length;f<r;f++){const c=u[f].buffer.replace(/\r\n|\r|\n/g,b),l=(0,N.$AD)(c);u[f]=new N.$DD(c,l)}const E=new R.$FD(u,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&D.$8f(I)&&(this.b=D.$7f,I=I.substr(1));const b=I.charCodeAt(I.length-1);b===y.CharCode.CarriageReturn||b>=55296&&b<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=b):(this.m(I,!1),this.c=!1,this.d=b)}m(I,b){!b&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const b=(0,N.$BD)(this.e,I);this.a.push(new N.$DD(I,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Wf(I)),this.k||(this.k=D.$Zf(I)))}finish(I=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const b=(0,N.$AD)(I.buffer);I.lineStarts=b,this.d===y.CharCode.CarriageReturn&&this.f++}}}e.$GD=p}),define(Re[104],Te([1,0,20,23]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oeb=p,e.$peb=I,D=qe(D);var P;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(P||(P={}));function N(b){for(let u=0,E=b.length;u<E;u+=4){const f=b[u+0],r=b[u+1],c=b[u+2],l=b[u+3];b[u+0]=l,b[u+1]=c,b[u+2]=r,b[u+3]=f}}function R(b){const u=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return D.$E()||N(u),y.$Qe.wrap(u)}function O(b){const u=b.buffer;if(D.$E()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(b){const u=new Uint32Array(s(b));let E=0;if(u[E++]=b.id,b.type==="full")u[E++]=P.Full,u[E++]=b.data.length,u.set(b.data,E),E+=b.data.length;else{u[E++]=P.Delta,u[E++]=b.deltas.length;for(const f of b.deltas)u[E++]=f.start,u[E++]=f.deleteCount,f.data?(u[E++]=f.data.length,u.set(f.data,E),E+=f.data.length):u[E++]=0}return R(u)}function s(b){let u=0;if(u+=2,b.type==="full")u+=1+b.data.length;else{u+=1,u+=3*b.deltas.length;for(const E of b.deltas)E.data&&(u+=E.data.length)}return u}function I(b){const u=O(b);let E=0;const f=u[E++];if(u[E++]===P.Full){const h=u[E++],i=u.subarray(E,E+h);return E+=h,{id:f,type:"full",data:i}}const c=u[E++],l=[];for(let h=0;h<c;h++){const i=u[E++],n=u[E++],t=u[E++];let o;t>0&&(o=u.subarray(E,E+t),E+=t),l[h]={start:i,deleteCount:n,data:o}}return{id:f,type:"delta",deltas:l}}}),define(Re[163],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dab=e.$cab=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$cab=y;class D{constructor(N){this.identifier=N}}e.$dab=D}),define(Re[164],Te([1,0,6,4,9]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0,e.$sj=I,P=qe(P);class N extends D.$Xc{constructor(u,E="",f="",r=!0,c){super(),this.j=this.B(new y.$oe),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=f,this.z=r,this.D=c}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$nj=N;class R extends D.$Xc{constructor(){super(...arguments),this.f=this.B(new y.$oe),this.onWillRun=this.f.event,this.m=this.B(new y.$oe),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let f;try{await this.u(u,E)}catch(r){f=r}this.m.fire({action:u,error:f})}async u(u,E){await u.run(E)}}e.$oj=R;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const f of u)f.length&&(E.length?E=[...E,new O,...f]:E=f);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$pj=O;class p{get actions(){return this.a}constructor(u,E,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=r,this.a=f}async run(){}}e.$qj=p;class s extends N{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(41,null),void 0,!1)}}e.$rj=s;function I(b){return{id:b.id,label:b.label,tooltip:b.tooltip??b.label,class:b.class,enabled:b.enabled??!0,checked:b.checked,run:async(...u)=>b.run(...u)}}}),define(Re[165],Te([1,0,9]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=s,e.$6m=I,e.$7m=b;const D=60,P=D*60,N=P*24,R=N*7,O=N*30,p=N*365;function s(u,E,f,r){typeof u!="number"&&(u=u.getTime());const c=Math.round((new Date().getTime()-u)/1e3);if(c<-30)return(0,y.localize)(42,null,s(new Date().getTime()+c*1e3,!1));if(!r&&c<30)return(0,y.localize)(43,null);let l;return c<D?(l=c,E?l===1?f?(0,y.localize)(44,null,l):(0,y.localize)(45,null,l):f?(0,y.localize)(46,null,l):(0,y.localize)(47,null,l):l===1?f?(0,y.localize)(48,null,l):(0,y.localize)(49,null,l):f?(0,y.localize)(50,null,l):(0,y.localize)(51,null,l)):c<P?(l=Math.floor(c/D),E?l===1?f?(0,y.localize)(52,null,l):(0,y.localize)(53,null,l):f?(0,y.localize)(54,null,l):(0,y.localize)(55,null,l):l===1?f?(0,y.localize)(56,null,l):(0,y.localize)(57,null,l):f?(0,y.localize)(58,null,l):(0,y.localize)(59,null,l)):c<N?(l=Math.floor(c/P),E?l===1?f?(0,y.localize)(60,null,l):(0,y.localize)(61,null,l):f?(0,y.localize)(62,null,l):(0,y.localize)(63,null,l):l===1?f?(0,y.localize)(64,null,l):(0,y.localize)(65,null,l):f?(0,y.localize)(66,null,l):(0,y.localize)(67,null,l)):c<R?(l=Math.floor(c/N),E?l===1?(0,y.localize)(68,null,l):(0,y.localize)(69,null,l):l===1?(0,y.localize)(70,null,l):(0,y.localize)(71,null,l)):c<O?(l=Math.floor(c/R),E?l===1?f?(0,y.localize)(72,null,l):(0,y.localize)(73,null,l):f?(0,y.localize)(74,null,l):(0,y.localize)(75,null,l):l===1?f?(0,y.localize)(76,null,l):(0,y.localize)(77,null,l):f?(0,y.localize)(78,null,l):(0,y.localize)(79,null,l)):c<p?(l=Math.floor(c/O),E?l===1?f?(0,y.localize)(80,null,l):(0,y.localize)(81,null,l):f?(0,y.localize)(82,null,l):(0,y.localize)(83,null,l):l===1?f?(0,y.localize)(84,null,l):(0,y.localize)(85,null,l):f?(0,y.localize)(86,null,l):(0,y.localize)(87,null,l)):(l=Math.floor(c/p),E?l===1?f?(0,y.localize)(88,null,l):(0,y.localize)(89,null,l):f?(0,y.localize)(90,null,l):(0,y.localize)(91,null,l):l===1?f?(0,y.localize)(92,null,l):(0,y.localize)(93,null,l):f?(0,y.localize)(94,null,l):(0,y.localize)(95,null,l))}function I(u,E){const f=Math.abs(u/1e3);return f<1?E?(0,y.localize)(96,null,u):(0,y.localize)(97,null,u):f<D?E?(0,y.localize)(98,null,Math.round(u)/1e3):(0,y.localize)(99,null,Math.round(u)/1e3):f<P?E?(0,y.localize)(100,null,Math.round(u/(1e3*D))):(0,y.localize)(101,null,Math.round(u/(1e3*D))):f<N?E?(0,y.localize)(102,null,Math.round(u/(1e3*P))):(0,y.localize)(103,null,Math.round(u/(1e3*P))):(0,y.localize)(104,null,Math.round(u/(1e3*N)))}function b(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[42],Te([1,0,17,14,9]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=p,e.$uj=s,e.$vj=I,y=qe(y),D=qe(D),P=qe(P);function N(b,u){return u&&(b.stack||b.stacktrace)?P.localize(105,null,O(b),R(b.stack)||R(b.stacktrace)):O(b)}function R(b){return Array.isArray(b)?b.join(`
`):b}function O(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(106,null,b.message):b.message||P.localize(107,null)}function p(b=null,u=!1){if(!b)return P.localize(108,null);if(Array.isArray(b)){const E=y.$Jb(b),f=p(E[0],u);return E.length>1?P.localize(109,null,f,E.length):f}if(D.$hg(b))return b;if(b.detail){const E=b.detail;if(E.error)return N(E.error,u);if(E.exception)return N(E.exception,u)}return b.stack?N(b,u):b.message?b.message:P.localize(110,null)}function s(b){const u=b;return u instanceof Error&&Array.isArray(u.actions)}function I(b,u){let E;return typeof b=="string"?E=new Error(b):E=b,E.actions=u,E}}),define(Re[166],Te([1,0,30,12,9]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var N;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(N||(e.TokenType=N={}));function R(...I){switch(I.length){case 1:return(0,P.localize)(1691,null,I[0]);case 2:return(0,P.localize)(1692,null,I[0],I[1]);case 3:return(0,P.localize)(1693,null,I[0],I[1],I[2]);default:return}}const O=(0,P.localize)(1694,null),p=(0,P.localize)(1695,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case N.LParen:return"(";case N.RParen:return")";case N.Neg:return"!";case N.Eq:return b.isTripleEq?"===":"==";case N.NotEq:return b.isTripleEq?"!==":"!=";case N.Lt:return"<";case N.LtEq:return"<=";case N.Gt:return">=";case N.GtEq:return">=";case N.RegexOp:return"=~";case N.RegexStr:return b.lexeme;case N.True:return"true";case N.False:return"false";case N.In:return"in";case N.Not:return"not";case N.And:return"&&";case N.Or:return"||";case N.Str:return b.lexeme;case N.QuotedStr:return b.lexeme;case N.Error:return b.lexeme;case N.EOF:return"EOF";default:throw(0,D.$0)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",N.Not],["in",N.In],["false",N.False],["true",N.True]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case y.CharCode.OpenParen:this.k(N.LParen);break;case y.CharCode.CloseParen:this.k(N.RParen);break;case y.CharCode.ExclamationMark:if(this.h(y.CharCode.Equals)){const u=this.h(y.CharCode.Equals);this.f.push({type:N.NotEq,offset:this.d,isTripleEq:u})}else this.k(N.Neg);break;case y.CharCode.SingleQuote:this.o();break;case y.CharCode.Slash:this.q();break;case y.CharCode.Equals:if(this.h(y.CharCode.Equals)){const u=this.h(y.CharCode.Equals);this.f.push({type:N.Eq,offset:this.d,isTripleEq:u})}else this.h(y.CharCode.Tilde)?this.k(N.RegexOp):this.l(R("==","=~"));break;case y.CharCode.LessThan:this.k(this.h(y.CharCode.Equals)?N.LtEq:N.Lt);break;case y.CharCode.GreaterThan:this.k(this.h(y.CharCode.Equals)?N.GtEq:N.Gt);break;case y.CharCode.Ampersand:this.h(y.CharCode.Ampersand)?this.k(N.And):this.l(R("&&"));break;case y.CharCode.Pipe:this.h(y.CharCode.Pipe)?this.k(N.Or):this.l(R("||"));break;case y.CharCode.Space:case y.CharCode.CarriageReturn:case y.CharCode.Tab:case y.CharCode.LineFeed:case y.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(N.EOF),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?y.CharCode.Null:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const u=this.d,E=this.c.substring(this.d,this.e),f={type:N.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:b}),this.f.push(f)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const u=this.c.substring(this.d,this.e),E=s.b.get(u);E?this.k(E):this.f.push({type:N.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==y.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:N.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,u=!1,E=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(p);return}const r=this.c.charCodeAt(b);if(u)u=!1;else if(r===y.CharCode.Slash&&!E){b++;break}else r===y.CharCode.OpenSquareBracket?E=!0:r===y.CharCode.Backslash?u=!0:r===y.CharCode.CloseSquareBracket&&(E=!1);b++}for(;b<this.c.length&&s.a.has(this.c.charCodeAt(b));)b++;this.e=b;const f=this.c.substring(this.d,this.e);this.f.push({type:N.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=s}),define(Re[105],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const y={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(y)}),define(Re[74],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class y{constructor(P,N=[],R=!1){this.ctor=P,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$Fi=y}),define(Re[60],Te([1,0,74]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ws=N,e.$Xs=R;const D=[];var P;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function N(O,p,s){p instanceof y.$Fi||(p=new y.$Fi(p,[],!!s)),D.push([O,p])}function R(){return D}}),define(Re[167],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class y{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$zr=y;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const O=this.lookupOrInsertNode(N),p=this.lookupOrInsertNode(R);O.outgoing.set(p.key,p),p.incoming.set(O.key,O)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const O of this.a.values())O.outgoing.delete(R),O.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let O=this.a.get(R);return O||(O=new y(R,N),this.a.set(R,O)),O}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,O]of this.a)N.push(`${R}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const O=new Set([N]),p=this.c(R,O);if(p)return p}}c(N,R){for(const[O,p]of N.outgoing){if(R.has(O))return[...R,O].join(" -> ");R.add(O);const s=this.c(p,R);if(s)return s;R.delete(O)}}}e.$Ar=D}),define(Re[3],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=P,e.$Ji=N;var y;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function O(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=O})(y||(e._util=y={})),e.$Hi=P("instantiationService");function D(R,O,p){O[y.DI_TARGET]===O?O[y.DI_DEPENDENCIES].push({id:R,index:p}):(O[y.DI_DEPENDENCIES]=[{id:R,index:p}],O[y.DI_TARGET]=O)}function P(R){if(y.serviceIds.has(R))return y.serviceIds.get(R);const O=function(p,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(O,p,I)};return O.toString=()=>R,y.serviceIds.set(R,O),O}function N(R){return R}}),define(Re[43],Te([1,0,14,2,3]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=N,e.$ej=R,e.$fj=p,e.$gj=s,e.$hj=I,e.$ij=b,e.$jj=u,e.$kj=f,e.$lj=r,e.$mj=c,y=qe(y),e.$cj=(0,P.$Ii)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}var O;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function p(l){switch(l){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function s(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function I(l,h){const i=Object.create(null);for(const n in l)b(i,n,l[n],h);return i}function b(l,h,i,n){const t=h.split("."),o=t.pop();let a=l;for(let m=0;m<t.length;m++){const g=t[m];let d=a[g];switch(typeof d){case"undefined":d=a[g]=Object.create(null);break;case"object":if(d===null){n(`Ignoring ${h} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:n(`Ignoring ${h} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify(d)}`);return}a=d}if(typeof a=="object"&&a!==null)try{a[o]=i}catch{n(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(a)}`)}else n(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(a)}`)}function u(l,h){const i=h.split(".");E(l,i)}function E(l,h){const i=h.shift();if(h.length===0){delete l[i];return}if(Object.keys(l).indexOf(i)!==-1){const n=l[i];typeof n=="object"&&!Array.isArray(n)&&(E(n,h),Object.keys(n).length===0&&delete l[i])}}function f(l,h,i){function n(a,m){let g=a;for(const d of m){if(typeof g!="object"||g===null)return;g=g[d]}return g}const t=h.split("."),o=n(l,t);return typeof o>"u"?i:o}function r(l,h,i){Object.keys(h).forEach(n=>{n!=="__proto__"&&(n in l?y.$jg(l[n])&&y.$jg(h[n])?r(l[n],h[n],i):i&&(l[n]=h[n]):l[n]=h[n])})}function c(l){return l.replace(/[\[\]]/g,"")}}),define(Re[31],Te([1,0,30,23,13,166,3,9,12]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=I,e.$Hj=m,e.$Ij=g,e.$2j=x;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",D.$k),s.set("isLinux",D.$l),s.set("isWindows",D.$j),s.set("isWeb",D.$p),s.set("isMacNative",D.$k&&!D.$p),s.set("isEdge",D.$I),s.set("isFirefox",D.$G),s.set("isChrome",D.$F),s.set("isSafari",D.$H);function I(Y,q){if(s.get(Y)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(Y,q)}const b=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(1671,null),r=(0,O.localize)(1672,null),c=(0,O.localize)(1673,null),l=(0,O.localize)(1674,null),h=(0,O.localize)(1675,null),i=(0,O.localize)(1676,null),n=(0,O.localize)(1677,null),t=(0,O.localize)(1678,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=E){this.k=q,this.d=new N.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ve=this.D(),Pe=ve.type===N.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:ve.offset,lexeme:N.$Dj.getLexeme(ve),additionalInfo:Pe}),o.c}return ie}catch(ie){if(ie!==o.c)throw ie;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(N.TokenType.Or);){const ie=this.o();q.push(ie)}return q.length===1?q[0]:a.or(...q)}o(){const q=[this.s()];for(;this.y(N.TokenType.And);){const ie=this.s();q.push(ie)}return q.length===1?q[0]:a.and(...q)}s(){if(this.y(N.TokenType.Neg)){const q=this.D();switch(q.type){case N.TokenType.True:return this.z(),S.INSTANCE;case N.TokenType.False:return this.z(),k.INSTANCE;case N.TokenType.LParen:{this.z();const ie=this.l();return this.A(N.TokenType.RParen,l),ie?.negate()}case N.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case N.TokenType.True:return this.z(),a.true();case N.TokenType.False:return this.z(),a.false();case N.TokenType.LParen:{this.z();const ie=this.l();return this.A(N.TokenType.RParen,l),ie}case N.TokenType.Str:{const ie=q.lexeme;if(this.z(),this.y(N.TokenType.RegexOp)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==N.TokenType.RegexStr)throw this.B("REGEX",Pe);const Fe=Pe.lexeme,Be=Fe.lastIndexOf("/"),xe=Be===Fe.length-1?void 0:this.w(Fe.substring(Be+1));let nt;try{nt=new RegExp(Fe.substring(1,Be),xe)}catch{throw this.B("REGEX",Pe)}return V.create(ie,nt)}switch(Pe.type){case N.TokenType.RegexStr:case N.TokenType.Error:{const Fe=[Pe.lexeme];this.z();let Be=this.D(),xe=0;for(let et=0;et<Pe.lexeme.length;et++)Pe.lexeme.charCodeAt(et)===y.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===y.CharCode.CloseParen&&xe--;for(;!this.E()&&Be.type!==N.TokenType.And&&Be.type!==N.TokenType.Or;){switch(Be.type){case N.TokenType.LParen:xe++;break;case N.TokenType.RParen:xe--;break;case N.TokenType.RegexStr:case N.TokenType.QuotedStr:for(let et=0;et<Be.lexeme.length;et++)Be.lexeme.charCodeAt(et)===y.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===y.CharCode.CloseParen&&xe--}if(xe<0)break;Fe.push(N.$Dj.getLexeme(Be)),this.z(),Be=this.D()}const nt=Fe.join(""),ut=nt.lastIndexOf("/"),pt=ut===nt.length-1?void 0:this.w(nt.substring(ut+1));let lt;try{lt=new RegExp(nt.substring(1,ut),pt)}catch{throw this.B("REGEX",Pe)}return a.regex(ie,lt)}case N.TokenType.QuotedStr:{const Fe=Pe.lexeme;this.z();let Be=null;if(!(0,P.$ff)(Fe)){const xe=Fe.indexOf("/"),nt=Fe.lastIndexOf("/");if(xe!==nt&&xe>=0){const ut=Fe.slice(xe+1,nt),pt=Fe[nt+1]==="i"?"i":"";try{Be=new RegExp(ut,pt)}catch{throw this.B("REGEX",Pe)}}}if(Be===null)throw this.B("REGEX",Pe);return V.create(ie,Be)}default:throw this.B("REGEX",this.D())}}if(this.y(N.TokenType.Not)){this.A(N.TokenType.In,c);const Pe=this.u();return a.notIn(ie,Pe)}switch(this.D().type){case N.TokenType.Eq:{this.z();const Pe=this.u();if(this.x().type===N.TokenType.QuotedStr)return a.equals(ie,Pe);switch(Pe){case"true":return a.has(ie);case"false":return a.not(ie);default:return a.equals(ie,Pe)}}case N.TokenType.NotEq:{this.z();const Pe=this.u();if(this.x().type===N.TokenType.QuotedStr)return a.notEquals(ie,Pe);switch(Pe){case"true":return a.not(ie);case"false":return a.has(ie);default:return a.notEquals(ie,Pe)}}case N.TokenType.Lt:return this.z(),J.create(ie,this.u());case N.TokenType.LtEq:return this.z(),U.create(ie,this.u());case N.TokenType.Gt:return this.z(),L.create(ie,this.u());case N.TokenType.GtEq:return this.z(),Z.create(ie,this.u());case N.TokenType.In:return this.z(),a.in(ie,this.u());default:return a.has(ie)}}case N.TokenType.EOF:throw this.h.push({message:n,offset:q.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case N.TokenType.Str:case N.TokenType.QuotedStr:return this.z(),q.lexeme;case N.TokenType.True:return this.z(),"true";case N.TokenType.False:return this.z(),"false";case N.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ie){if(this.C(q))return this.z();throw this.B(ie,this.D())}B(q,ie,ve){const Pe=(0,O.localize)(1679,null,q,N.$Dj.getLexeme(ie)),Fe=ie.offset,Be=N.$Dj.getLexeme(ie);return this.h.push({message:Pe,offset:Fe,lexeme:Be,additionalInfo:ve}),o.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===N.TokenType.EOF}}e.$Fj=o;class a{static false(){return S.INSTANCE}static true(){return k.INSTANCE}static has(q){return v.create(q)}static equals(q,ie){return C.create(q,ie)}static notEquals(q,ie){return w.create(q,ie)}static regex(q,ie){return V.create(q,ie)}static in(q,ie){return T.create(q,ie)}static notIn(q,ie){return $.create(q,ie)}static not(q){return M.create(q)}static and(...q){return ue.create(q,null,!0)}static or(...q){return _.create(q,null,!0)}static greater(q,ie){return L.create(q,ie)}static greaterEquals(q,ie){return Z.create(q,ie)}static smaller(q,ie){return J.create(q,ie)}static smallerEquals(q,ie){return U.create(q,ie)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Gj=a;function m(Y){const q=new o({regexParsingWithErrorRecovery:!1});return Y.map(ie=>(q.parse(ie),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,O.localize)(1680,null,ve.additionalInfo):(0,O.localize)(1681,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function g(Y,q){const ie=Y?Y.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!ie&&!ve?!0:!ie||!ve?!1:ie.equals(ve)}function d(Y,q){return Y.cmp(q)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return k.INSTANCE}}e.$Jj=S;class k{static{this.INSTANCE=new k}constructor(){this.type=u.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return S.INSTANCE}}e.$Kj=k;class v{static create(q,ie=null){const ve=s.get(q);return typeof ve=="boolean"?ve?k.INSTANCE:S.INSTANCE:new v(q,ie)}constructor(q,ie){this.key=q,this.c=ie,this.type=u.Defined}cmp(q){return q.type!==this.type?this.type-q.type:se(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=s.get(this.key);return typeof q=="boolean"?q?k.INSTANCE:S.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Lj=v;class C{static create(q,ie,ve=null){if(typeof ie=="boolean")return ie?v.create(q,ve):M.create(q,ve);const Pe=s.get(q);return typeof Pe=="boolean"?ie===(Pe?"true":"false")?k.INSTANCE:S.INSTANCE:new C(q,ie,ve)}constructor(q,ie,ve){this.c=q,this.d=ie,this.f=ve,this.type=u.Equals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ie=q?"true":"false";return this.d===ie?k.INSTANCE:S.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Mj=C;class T{static create(q,ie){return new T(q,ie)}constructor(q,ie){this.d=q,this.f=ie,this.type=u.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ie=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(ie)?ie.includes(ve):typeof ve=="string"&&typeof ie=="object"&&ie!==null?b.call(ie,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$Nj=T;class ${static create(q,ie){return new $(q,ie)}constructor(q,ie){this.d=q,this.f=ie,this.type=u.NotIn,this.c=T.create(q,ie)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=$;class w{static create(q,ie,ve=null){if(typeof ie=="boolean")return ie?M.create(q,ve):v.create(q,ve);const Pe=s.get(q);return typeof Pe=="boolean"?ie===(Pe?"true":"false")?S.INSTANCE:k.INSTANCE:new w(q,ie,ve)}constructor(q,ie,ve){this.c=q,this.d=ie,this.f=ve,this.type=u.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ie=q?"true":"false";return this.d===ie?S.INSTANCE:k.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Pj=w;class M{static create(q,ie=null){const ve=s.get(q);return typeof ve=="boolean"?ve?S.INSTANCE:k.INSTANCE:new M(q,ie)}constructor(q,ie){this.c=q,this.d=ie,this.type=u.Not}cmp(q){return q.type!==this.type?this.type-q.type:se(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=s.get(this.c);return typeof q=="boolean"?q?S.INSTANCE:k.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Qj=M;function A(Y,q){if(typeof Y=="string"){const ie=parseFloat(Y);isNaN(ie)||(Y=ie)}return typeof Y=="string"||typeof Y=="number"?q(Y):S.INSTANCE}class L{static create(q,ie,ve=null){return A(ie,Pe=>new L(q,Pe,ve))}constructor(q,ie,ve){this.c=q,this.d=ie,this.f=ve,this.type=u.Greater}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Rj=L;class Z{static create(q,ie,ve=null){return A(ie,Pe=>new Z(q,Pe,ve))}constructor(q,ie,ve){this.c=q,this.d=ie,this.f=ve,this.type=u.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Sj=Z;class J{static create(q,ie,ve=null){return A(ie,Pe=>new J(q,Pe,ve))}constructor(q,ie,ve){this.c=q,this.d=ie,this.f=ve,this.type=u.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Tj=J;class U{static create(q,ie,ve=null){return A(ie,Pe=>new U(q,Pe,ve))}constructor(q,ie,ve){this.c=q,this.d=ie,this.f=ve,this.type=u.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Uj=U;class V{static create(q,ie){return new V(q,ie)}constructor(q,ie){this.d=q,this.f=ie,this.type=u.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ie=this.f?this.f.source:"",ve=q.f?q.f.source:"";return ie<ve?-1:ie>ve?1:0}equals(q){if(q.type===this.type){const ie=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&ie===ve}return!1}substituteConstants(){return this}evaluate(q){const ie=q.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Vj=V;class Q{static create(q){return new Q(q)}constructor(q){this.c=q,this.type=u.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new Q(this.c.map(q))}negate(){return this.c}}e.$Wj=Q;function ne(Y){let q=null;for(let ie=0,ve=Y.length;ie<ve;ie++){const Pe=Y[ie].substituteConstants();if(Y[ie]!==Pe&&q===null){q=[];for(let Fe=0;Fe<ie;Fe++)q[Fe]=Y[Fe]}q!==null&&(q[ie]=Pe)}return q===null?Y:q}class ue{static create(q,ie,ve){return ue.d(q,ie,ve)}constructor(q,ie){this.expr=q,this.c=ie,this.type=u.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const Pe=d(this.expr[ie],q.expr[ie]);if(Pe!==0)return Pe}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(q.expr[ie]))return!1;return!0}return!1}substituteConstants(){const q=ne(this.expr);return q===this.expr?this:ue.create(q,this.c,!1)}evaluate(q){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].evaluate(q))return!1;return!0}static d(q,ie,ve){const Pe=[];let Fe=!1;for(const Be of q)if(Be){if(Be.type===u.True){Fe=!0;continue}if(Be.type===u.False)return S.INSTANCE;if(Be.type===u.And){Pe.push(...Be.expr);continue}Pe.push(Be)}if(Pe.length===0&&Fe)return k.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(d);for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const Be=Pe[Pe.length-1];if(Be.type!==u.Or)break;Pe.pop();const xe=Pe.pop(),nt=Pe.length===0,ut=_.create(Be.expr.map(pt=>ue.create([pt,xe],null,ve)),null,nt);ut&&(Pe.push(ut),Pe.sort(d))}if(Pe.length===1)return Pe[0];if(ve){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return S.INSTANCE;if(Pe.length===1)return Pe[0]}return new ue(Pe,ie)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ie of this.expr)q.push(...ie.keys());return q}map(q){return new ue(this.expr.map(ie=>ie.map(q)),null)}negate(){if(!this.c){const q=[];for(const ie of this.expr)q.push(ie.negate());this.c=_.create(q,this,!0)}return this.c}}e.$Xj=ue;class _{static create(q,ie,ve){return _.d(q,ie,ve)}constructor(q,ie){this.expr=q,this.c=ie,this.type=u.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const Pe=d(this.expr[ie],q.expr[ie]);if(Pe!==0)return Pe}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(q.expr[ie]))return!1;return!0}return!1}substituteConstants(){const q=ne(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(this.expr[ie].evaluate(q))return!0;return!1}static d(q,ie,ve){let Pe=[],Fe=!1;if(q){for(let Be=0,xe=q.length;Be<xe;Be++){const nt=q[Be];if(nt){if(nt.type===u.False){Fe=!0;continue}if(nt.type===u.True)return k.INSTANCE;if(nt.type===u.Or){Pe=Pe.concat(nt.expr);continue}Pe.push(nt)}}if(Pe.length===0&&Fe)return S.INSTANCE;Pe.sort(d)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];if(ve){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return k.INSTANCE;if(Pe.length===1)return Pe[0]}return new _(Pe,ie)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ie of this.expr)q.push(...ie.keys());return q}map(q){return new _(this.expr.map(ie=>ie.map(q)),null)}negate(){if(!this.c){const q=[];for(const ie of this.expr)q.push(ie.negate());for(;q.length>1;){const ie=q.shift(),ve=q.shift(),Pe=[];for(const Fe of Ie(ie))for(const Be of Ie(ve))Pe.push(ue.create([Fe,Be],null,!1));q.unshift(_.create(Pe,null,!1))}this.c=_.create(q,this,!0)}return this.c}}e.$Yj=_;class ae extends v{static{this.d=[]}static all(){return ae.d.values()}constructor(q,ie,ve){super(q,null),this.f=ie,typeof ve=="object"?ae.d.push({...ve,key:q}):ve!==!0&&ae.d.push({key:q,description:ve,type:ie!=null?typeof ie:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return C.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Zj=ae,e.$1j=(0,R.$Ii)("contextKeyService");function se(Y,q){return Y<q?-1:Y>q?1:0}function ce(Y,q,ie,ve){return Y<ie?-1:Y>ie?1:q<ve?-1:q>ve?1:0}function x(Y,q){if(Y.type===u.False||q.type===u.True)return!0;if(Y.type===u.Or)return q.type===u.Or?we(Y.expr,q.expr):!1;if(q.type===u.Or){for(const ie of q.expr)if(x(Y,ie))return!0;return!1}if(Y.type===u.And){if(q.type===u.And)return we(q.expr,Y.expr);for(const ie of Y.expr)if(x(ie,q))return!0;return!1}return Y.equals(q)}function we(Y,q){let ie=0,ve=0;for(;ie<Y.length&&ve<q.length;){const Pe=Y[ie].cmp(q[ve]);if(Pe<0)return!1;Pe===0&&ie++,ve++}return ie===Y.length}function Ie(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(Re[168],Te([1,0,31,3]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$xt=e.AccessibilitySupport=e.$wt=void 0,e.$yt=N,e.$wt=(0,D.$Ii)("accessibilityService");var P;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$xt=new y.$Zj("accessibilityModeEnabled",!1);function N(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$zt="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[106],Te([1,0,17,25,23,147,280,156,169,9,168]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=a,e.stringSet=d,e.cursorStyleToString=A,e.filterValidationDecorations=Me,y=qe(y),D=qe(D),P=qe(P),s=qe(s);var b;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(W){this.c=W}hasChanged(W){return this.c[W]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class f{constructor(W,de,je,Qe){this.id=W,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(W,de){return c(W,de)}compute(W,de,je){return je}}class r{constructor(W,de){this.newValue=W,this.didChange=de}}e.ApplyUpdateResult=r;function c(X,W){if(typeof X!="object"||typeof W!="object"||!X||!W)return new r(W,X!==W);if(Array.isArray(X)||Array.isArray(W)){const je=Array.isArray(X)&&Array.isArray(W)&&y.$wb(X,W);return new r(W,!je)}let de=!1;for(const je in W)if(W.hasOwnProperty(je)){const Qe=c(X[je],W[je]);Qe.didChange&&(X[je]=Qe.newValue,de=!0)}return new r(X,de)}class l{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,de){return c(W,de)}validate(W){return this.defaultValue}}class h{constructor(W,de,je,Qe){this.id=W,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(W,de){return c(W,de)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,de,je){return je}}function i(X,W){return typeof X>"u"?W:X==="false"?!1:!!X}class n extends h{constructor(W,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=je),super(W,de,je,Qe)}validate(W){return i(W,this.defaultValue)}}function t(X,W,de,je){if(typeof X>"u")return W;let Qe=parseInt(X,10);return isNaN(Qe)?W:(Qe=Math.max(de,Qe),Qe=Math.min(je,Qe),Qe|0)}class o extends h{static clampedInt(W,de,je,Qe){return t(W,de,je,Qe)}constructor(W,de,je,Qe,st,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=je,ht.minimum=Qe,ht.maximum=st),super(W,de,je,ht),this.minimum=Qe,this.maximum=st}validate(W){return o.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}function a(X,W,de,je){if(typeof X>"u")return W;const Qe=m.float(X,W);return m.clamp(Qe,de,je)}class m extends h{static clamp(W,de,je){return W<de?de:W>je?je:W}static float(W,de){if(typeof W=="number")return W;if(typeof W>"u")return de;const je=parseFloat(W);return isNaN(je)?de:je}constructor(W,de,je,Qe,st){typeof st<"u"&&(st.type="number",st.default=je),super(W,de,je,st),this.validationFn=Qe}validate(W){return this.validationFn(m.float(W,this.defaultValue))}}class g extends h{static string(W,de){return typeof W!="string"?de:W}constructor(W,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=je),super(W,de,je,Qe)}validate(W){return g.string(W,this.defaultValue)}}function d(X,W,de,je){return typeof X!="string"?W:je&&X in je?je[X]:de.indexOf(X)===-1?W:X}class S extends h{constructor(W,de,je,Qe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Qe,st.default=je),super(W,de,je,st),this.c=Qe}validate(W){return d(W,this.defaultValue,this.c)}}class k extends f{constructor(W,de,je,Qe,st,ht,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=st,gt.default=Qe),super(W,de,je,gt),this.c=st,this.d=ht}validate(W){return typeof W!="string"?this.defaultValue:this.c.indexOf(W)===-1?this.defaultValue:this.d(W)}}function v(X){switch(X){case"none":return b.None;case"keep":return b.Keep;case"brackets":return b.Brackets;case"advanced":return b.Advanced;case"full":return b.Full}}class C extends f{constructor(){super(be.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(300,null),s.localize(301,null),s.localize(302,null)],default:"auto",tags:["accessibility"],description:s.localize(303,null)})}validate(W){switch(W){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(W,de,je){return je===I.AccessibilitySupport.Unknown?W.accessibilitySupport:je}}class T extends f{constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(be.comments,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:s.localize(304,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:s.localize(305,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{insertSpace:i(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var $;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})($||(e.TextEditorCursorBlinkingStyle=$={}));function w(X){switch(X){case"blink":return $.Blink;case"smooth":return $.Smooth;case"phase":return $.Phase;case"expand":return $.Expand;case"solid":return $.Solid}}var M;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function A(X){switch(X){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(X){switch(X){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class Z extends l{constructor(){super(be.editorClassName)}compute(W,de,je){const Qe=["monaco-editor"];return de.get(be.extraEditorClassName)&&Qe.push(de.get(be.extraEditorClassName)),W.extraEditorClassName&&Qe.push(W.extraEditorClassName),de.get(be.mouseStyle)==="default"?Qe.push("mouse-default"):de.get(be.mouseStyle)==="copy"&&Qe.push("mouse-copy"),de.get(be.showUnused)&&Qe.push("showUnused"),de.get(be.showDeprecated)&&Qe.push("showDeprecated"),Qe.join(" ")}}class J extends n{constructor(){super(be.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(306,null)})}compute(W,de,je){return je&&W.emptySelectionClipboard}}class U extends f{constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(be.find,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:s.localize(307,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[s.localize(308,null),s.localize(309,null),s.localize(310,null)],description:s.localize(311,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[s.localize(312,null),s.localize(313,null),s.localize(314,null)],description:s.localize(315,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:s.localize(316,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:s.localize(317,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:s.localize(318,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{cursorMoveOnType:i(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":d(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":d(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(de.loop,this.defaultValue.loop)}}}class V extends f{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(be.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:s.localize(319,null)},{type:"string",description:s.localize(320,null)}],description:s.localize(321,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"||W.length===0?V.OFF:W==="true"?V.ON:W:W?V.ON:V.OFF}}e.EditorFontLigatures=V;class Q extends f{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(be.fontVariations,"fontVariations",Q.OFF,{anyOf:[{type:"boolean",description:s.localize(322,null)},{type:"string",description:s.localize(323,null)}],description:s.localize(324,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?Q.OFF:W==="true"?Q.TRANSLATE:W:W?Q.TRANSLATE:Q.OFF}compute(W,de,je){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=Q;class ne extends l{constructor(){super(be.fontInfo)}compute(W,de,je){return W.fontInfo}}class ue extends h{constructor(){super(be.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(325,null)})}validate(W){const de=m.float(W,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(de,6,100)}compute(W,de,je){return W.fontInfo.fontSize}}class _ extends f{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(be.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:_.d,maximum:_.e,errorMessage:s.localize(326,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:_.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(327,null)})}validate(W){return W==="normal"||W==="bold"?W:String(o.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,_.d,_.e))}}class ae extends f{constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[s.localize(328,null),s.localize(329,null),s.localize(330,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(be.gotoLocation,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(331,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(332,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(333,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(334,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(335,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(336,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:je,description:s.localize(337,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:je,description:s.localize(338,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:je,description:s.localize(339,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:je,description:s.localize(340,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:je,description:s.localize(341,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{multiple:d(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??d(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??d(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??d(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??d(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??d(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:de.multipleTests??d(de.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:g.string(de.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class se extends f{constructor(){const W={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(be.hover,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:s.localize(342,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:s.localize(343,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:s.localize(344,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:W.hidingDelay,description:s.localize(345,null)},"editor.hover.above":{type:"boolean",default:W.above,description:s.localize(346,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),delay:o.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:i(de.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(de.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(de.above,this.defaultValue.above)}}}var ce;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ce||(e.RenderMinimap=ce={}));class x extends l{constructor(){super(be.layoutInfo)}compute(W,de,je){return x.computeLayout(de,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio,glyphMarginDecorationLaneCount:W.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(W){const de=W.height/W.lineHeight,je=Math.floor(W.paddingTop/W.lineHeight);let Qe=Math.floor(W.paddingBottom/W.lineHeight);W.scrollBeyondLastLine&&(Qe=Math.max(Qe,de-1));const st=(je+W.viewLineCount+Qe)/(W.pixelRatio*W.height),ht=Math.floor(W.viewLineCount/st);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Qe,desiredRatio:st,minimapLineCount:ht}}static c(W,de){const je=W.outerWidth,Qe=W.outerHeight,st=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:ce.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ht=de.stableMinimapLayoutInput,gt=ht&&W.outerHeight===ht.outerHeight&&W.lineHeight===ht.lineHeight&&W.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&W.pixelRatio===ht.pixelRatio&&W.scrollBeyondLastLine===ht.scrollBeyondLastLine&&W.paddingTop===ht.paddingTop&&W.paddingBottom===ht.paddingBottom&&W.minimap.enabled===ht.minimap.enabled&&W.minimap.side===ht.minimap.side&&W.minimap.size===ht.minimap.size&&W.minimap.showSlider===ht.minimap.showSlider&&W.minimap.renderCharacters===ht.minimap.renderCharacters&&W.minimap.maxColumn===ht.minimap.maxColumn&&W.minimap.scale===ht.minimap.scale&&W.verticalScrollbarWidth===ht.verticalScrollbarWidth&&W.isViewportWrapping===ht.isViewportWrapping,Rt=W.lineHeight,At=W.typicalHalfwidthCharacterWidth,Qt=W.scrollBeyondLastLine,_t=W.minimap.renderCharacters;let Ze=st>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const Ot=W.minimap.maxColumn,Ut=W.minimap.size,$t=W.minimap.side,Pt=W.verticalScrollbarWidth,ei=W.viewLineCount,ti=W.remainingWidth,Ht=W.isViewportWrapping,wt=_t?2:3;let Nt=Math.floor(st*Qe);const ai=Nt/st;let Zt=!1,Ge=!1,ii=wt*Ze,ci=Ze/st,ui=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Gt,desiredRatio:li,minimapLineCount:Mt}=x.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:W.paddingTop,paddingBottom:W.paddingBottom,height:Qe,lineHeight:Rt,pixelRatio:st});if(ei/Mt>1)Zt=!0,Ge=!0,Ze=1,ii=1,ci=Ze/st;else{let bt=!1,Jt=Ze+1;if(Ut==="fit"){const St=Math.ceil((Kt+ei+Gt)*ii);Ht&&gt&&ti<=de.stableFitRemainingWidth?(bt=!0,Jt=de.stableFitMaxMinimapScale):bt=St>Nt}if(Ut==="fill"||bt){Zt=!0;const St=Ze;ii=Math.min(Rt*st,Math.max(1,Math.floor(1/li))),Ht&&gt&&ti<=de.stableFitRemainingWidth&&(Jt=de.stableFitMaxMinimapScale),Ze=Math.min(Jt,Math.max(1,Math.floor(ii/wt))),Ze>St&&(ui=Math.min(2,Ze/St)),ci=Ze/st/ui,Nt=Math.ceil(Math.max(ri,Kt+ei+Gt)*ii),Ht?(de.stableMinimapLayoutInput=W,de.stableFitRemainingWidth=ti,de.stableFitMaxMinimapScale=Ze):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Et=Math.floor(Ot*ci),jt=Math.min(Et,Math.max(0,Math.floor((ti-Pt-2)*ci/(At+ci)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(st*jt);const Bt=Lt/st;Lt=Math.floor(Lt*ui);const oi=_t?ce.Text:ce.Blocks,ni=$t==="left"?0:je-jt-Pt;return{renderMinimap:oi,minimapLeft:ni,minimapWidth:jt,minimapHeightIsEditorHeight:Zt,minimapIsSampling:Ge,minimapScale:Ze,minimapLineHeight:ii,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ai}}static computeLayout(W,de){const je=de.outerWidth|0,Qe=de.outerHeight|0,st=de.lineHeight|0,ht=de.lineNumbersDigitCount|0,gt=de.typicalHalfwidthCharacterWidth,Rt=de.maxDigitWidth,At=de.pixelRatio,Qt=de.viewLineCount,_t=W.get(be.wordWrapOverride2),Ze=_t==="inherit"?W.get(be.wordWrapOverride1):_t,Ot=Ze==="inherit"?W.get(be.wordWrap):Ze,Ut=W.get(be.wordWrapColumn),$t=de.isDominatedByLongLines,Pt=W.get(be.glyphMargin),ei=W.get(be.lineNumbers).renderType!==et.Off,ti=W.get(be.lineNumbersMinChars),Ht=W.get(be.scrollBeyondLastLine),wt=W.get(be.padding),Nt=W.get(be.minimap),ai=W.get(be.scrollbar),Zt=ai.verticalScrollbarSize,Ge=ai.verticalHasArrows,ii=ai.arrowSize,ci=ai.horizontalScrollbarSize,ui=W.get(be.folding),Et=W.get(be.showFoldingControls)!=="never";let jt=W.get(be.lineDecorationsWidth);ui&&Et&&(jt+=16);let Lt=0;if(ei){const Xt=Math.max(ht,ti);Lt=Math.round(Xt*Rt)}let Bt=0;Pt&&(Bt=st*de.glyphMarginDecorationLaneCount);let oi=0,ni=oi+Bt,ri=ni+Lt,Kt=ri+jt;const Gt=je-Bt-Lt-jt;let li=!1,Mt=!1,Dt=-1;Ze==="inherit"&&$t?(li=!0,Mt=!0):Ot==="on"||Ot==="bounded"?Mt=!0:Ot==="wordWrapColumn"&&(Dt=Ut);const bt=x.c({outerWidth:je,outerHeight:Qe,lineHeight:st,typicalHalfwidthCharacterWidth:gt,pixelRatio:At,scrollBeyondLastLine:Ht,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Nt,verticalScrollbarWidth:Zt,viewLineCount:Qt,remainingWidth:Gt,isViewportWrapping:Mt},de.memory||new E);bt.renderMinimap!==ce.None&&bt.minimapLeft===0&&(oi+=bt.minimapWidth,ni+=bt.minimapWidth,ri+=bt.minimapWidth,Kt+=bt.minimapWidth);const Jt=Gt-bt.minimapWidth,St=Math.max(1,Math.floor((Jt-Zt-2)/gt)),hi=Ge?ii:0;return Mt&&(Dt=Math.max(1,St),Ot==="bounded"&&(Dt=Math.min(Dt,Ut))),{width:je,height:Qe,glyphMarginLeft:oi,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Lt,decorationsLeft:ri,decorationsWidth:jt,contentLeft:Kt,contentWidth:Jt,minimap:bt,viewportColumn:St,isWordWrapMinified:li,isViewportWrapping:Mt,wrappingColumn:Dt,verticalScrollbarWidth:Zt,horizontalScrollbarHeight:ci,overviewRuler:{top:hi,width:Zt,height:Qe-2*hi,right:0}}}}e.EditorLayoutInfoComputer=x;class we extends f{constructor(){super(be.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(347,null),s.localize(348,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(349,null)}})}validate(W){return d(W,"simple",["simple","advanced"])}compute(W,de,je){return de.get(be.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":je}}var Ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(Ie||(e.ShowLightbulbIconMode=Ie={}));class Y extends f{constructor(){const W={enabled:Ie.OnCode};super(be.lightbulb,"lightbulb",W,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ie.Off,Ie.OnCode,Ie.On],default:W.enabled,enumDescriptions:[s.localize(350,null),s.localize(351,null),s.localize(352,null)],description:s.localize(353,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:d(W.enabled,this.defaultValue.enabled,[Ie.Off,Ie.OnCode,Ie.On])}}}class q extends f{constructor(){const W={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(be.stickyScroll,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:s.localize(354,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:20,description:s.localize(355,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:W.defaultModel,description:s.localize(356,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:W.scrollWithEditor,description:s.localize(357,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(de.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(de.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends f{constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(be.inlayHints,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:s.localize(358,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(359,null),s.localize(360,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(361,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(362,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:s.localize(363,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:s.localize(364,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:s.localize(365,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:d(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily),padding:i(de.padding,this.defaultValue.padding)}}}class ve extends f{constructor(){super(be.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(W){return typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)?-parseFloat(W.substring(0,W.length-2)):o.clampedInt(W,this.defaultValue,0,1e3)}compute(W,de,je){return je<0?o.clampedInt(-je*W.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class Pe extends m{constructor(){super(be.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>m.clamp(W,0,150),{markdownDescription:s.localize(366,null)})}compute(W,de,je){return W.fontInfo.lineHeight}}class Fe extends f{constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(be.minimap,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:s.localize(367,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:s.localize(368,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(369,null),s.localize(370,null),s.localize(371,null)],default:W.size,description:s.localize(372,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:s.localize(373,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:s.localize(374,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(375,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:s.localize(376,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:s.localize(377,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:W.showRegionSectionHeaders,description:s.localize(378,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:W.showMarkSectionHeaders,description:s.localize(379,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:W.sectionHeaderFontSize,description:s.localize(380,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:W.sectionHeaderLetterSpacing,description:s.localize(381,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),autohide:i(de.autohide,this.defaultValue.autohide),size:d(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(de.side,this.defaultValue.side,["right","left"]),showSlider:d(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(de.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(de.scale,1,1,3),maxColumn:o.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(de.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(de.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(de.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(de.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Be(X){return X==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class xe extends f{constructor(){super(be.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(382,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(383,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{top:o.clampedInt(de.top,0,0,1e3),bottom:o.clampedInt(de.bottom,0,0,1e3)}}}class nt extends f{constructor(){const W={enabled:!0,cycle:!0};super(be.parameterHints,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:s.localize(384,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:s.localize(385,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),cycle:i(de.cycle,this.defaultValue.cycle)}}}class ut extends l{constructor(){super(be.pixelRatio)}compute(W,de,je){return W.pixelRatio}}class pt extends f{constructor(){super(be.placeholder,"placeholder",void 0)}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W:this.defaultValue}}class lt extends f{constructor(){const W={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(386,null),s.localize(387,null),s.localize(388,null)]}];super(be.quickSuggestions,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:W.strings,description:s.localize(389,null)},comments:{anyOf:de,default:W.comments,description:s.localize(390,null)},other:{anyOf:de,default:W.other,description:s.localize(391,null)}},default:W,markdownDescription:s.localize(392,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const At=W?"on":"off";return{comments:At,strings:At,other:At}}if(!W||typeof W!="object")return this.defaultValue;const{other:de,comments:je,strings:Qe}=W,st=["on","inline","off"];let ht,gt,Rt;return typeof de=="boolean"?ht=de?"on":"off":ht=d(de,this.defaultValue.other,st),typeof je=="boolean"?gt=je?"on":"off":gt=d(je,this.defaultValue.comments,st),typeof Qe=="boolean"?Rt=Qe?"on":"off":Rt=d(Qe,this.defaultValue.strings,st),{other:ht,comments:gt,strings:Rt}}}var et;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(et||(e.RenderLineNumbersType=et={}));class Ne extends f{constructor(){super(be.lineNumbers,"lineNumbers",{renderType:et.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(393,null),s.localize(394,null),s.localize(395,null),s.localize(396,null)],default:"on",description:s.localize(397,null)})}validate(W){let de=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(de=et.Custom,je=W):W==="interval"?de=et.Interval:W==="relative"?de=et.Relative:W==="on"?de=et.On:de=et.Off),{renderType:de,renderFn:je}}}function Me(X){const W=X.get(be.renderValidationDecorations);return W==="editable"?X.get(be.readOnly):W!=="on"}class Le extends f{constructor(){const W=[],de={type:"number",description:s.localize(398,null)};super(be.rulers,"rulers",W,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(399,null),format:"color-hex"}}}]},default:W,description:s.localize(400,null)})}validate(W){if(Array.isArray(W)){const de=[];for(const je of W)if(typeof je=="number")de.push({column:o.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Qe=je;de.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return de.sort((je,Qe)=>je.column-Qe.column),de}return this.defaultValue}}class B extends f{constructor(){super(be.readOnlyMessage,"readOnlyMessage",void 0)}validate(W){return!W||typeof W!="object"?this.defaultValue:W}}function j(X,W){if(typeof X!="string")return W;switch(X){case"hidden":return N.ScrollbarVisibility.Hidden;case"visible":return N.ScrollbarVisibility.Visible;default:return N.ScrollbarVisibility.Auto}}class H extends f{constructor(){const W={vertical:N.ScrollbarVisibility.Auto,horizontal:N.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(be.scrollbar,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(401,null),s.localize(402,null),s.localize(403,null)],default:"auto",description:s.localize(404,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(405,null),s.localize(406,null),s.localize(407,null)],default:"auto",description:s.localize(408,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:s.localize(409,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:s.localize(410,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:s.localize(411,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:W.ignoreHorizontalScrollbarInContentHeight,description:s.localize(412,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W,je=o.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(de.vertical,this.defaultValue.vertical),horizontal:j(de.horizontal,this.defaultValue.horizontal),useShadows:i(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:o.clampedInt(de.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(de.verticalSliderSize,Qe,0,1e3),scrollByPage:i(de.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(de.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends f{constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(be.unicodeHighlighting,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:s.localize(413,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:s.localize(414,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:s.localize(418,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:s.localize(419,null)}})}applyUpdate(W,de){let je=!1;de.allowedCharacters&&W&&(D.$lo(W.allowedCharacters,de.allowedCharacters)||(W={...W,allowedCharacters:de.allowedCharacters},je=!0)),de.allowedLocales&&W&&(D.$lo(W.allowedLocales,de.allowedLocales)||(W={...W,allowedLocales:de.allowedLocales},je=!0));const Qe=super.applyUpdate(W,de);return je?new r(Qe.newValue,!0):Qe}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{nonBasicASCII:Je(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(W.allowedLocales,this.defaultValue.allowedLocales)}}c(W,de){if(typeof W!="object"||!W)return de;const je={};for(const[Qe,st]of Object.entries(W))st===!0&&(je[Qe]=!0);return je}}class re extends f{constructor(){const W={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(be.inlineSuggest,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:s.localize(420,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(421,null),s.localize(422,null),s.localize(423,null)],description:s.localize(424,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:W.suppressSuggestions,description:s.localize(425,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(426,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),mode:d(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(de.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends f{constructor(){const W={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(be.inlineEdit,"experimentalInlineEdit",W,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:W.enabled,description:s.localize(427,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(428,null),s.localize(429,null),s.localize(430,null)],description:s.localize(431,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(432,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ee extends f{constructor(){const W={enabled:O.$qt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$qt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(be.bracketPairColorization,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(433,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:s.localize(434,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends f{constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(be.guides,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(435,null),s.localize(436,null),s.localize(437,null)],default:W.bracketPairs,description:s.localize(438,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(439,null),s.localize(440,null),s.localize(441,null)],default:W.bracketPairsHorizontal,description:s.localize(442,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:s.localize(443,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:s.localize(444,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(445,null),s.localize(446,null),s.localize(447,null)],default:W.highlightActiveIndentation,description:s.localize(448,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{bracketPairs:Je(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(X,W,de){const je=de.indexOf(X);return je===-1?W:de[je]}class _e extends f{constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(be.suggest,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(449,null),s.localize(450,null)],default:W.insertMode,description:s.localize(451,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:s.localize(452,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:s.localize(453,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:s.localize(454,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(455,null),s.localize(456,null),s.localize(457,null),s.localize(458,null)],default:W.selectionMode,markdownDescription:s.localize(459,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:s.localize(460,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:s.localize(461,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:s.localize(462,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:s.localize(463,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:s.localize(464,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(465,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(466,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(467,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(468,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{insertMode:d(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(de.showIcons,this.defaultValue.showIcons),showStatusBar:i(de.showStatusBar,this.defaultValue.showStatusBar),preview:i(de.preview,this.defaultValue.preview),previewMode:d(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(de.showMethods,this.defaultValue.showMethods),showFunctions:i(de.showFunctions,this.defaultValue.showFunctions),showConstructors:i(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(de.showFields,this.defaultValue.showFields),showVariables:i(de.showVariables,this.defaultValue.showVariables),showClasses:i(de.showClasses,this.defaultValue.showClasses),showStructs:i(de.showStructs,this.defaultValue.showStructs),showInterfaces:i(de.showInterfaces,this.defaultValue.showInterfaces),showModules:i(de.showModules,this.defaultValue.showModules),showProperties:i(de.showProperties,this.defaultValue.showProperties),showEvents:i(de.showEvents,this.defaultValue.showEvents),showOperators:i(de.showOperators,this.defaultValue.showOperators),showUnits:i(de.showUnits,this.defaultValue.showUnits),showValues:i(de.showValues,this.defaultValue.showValues),showConstants:i(de.showConstants,this.defaultValue.showConstants),showEnums:i(de.showEnums,this.defaultValue.showEnums),showEnumMembers:i(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(de.showKeywords,this.defaultValue.showKeywords),showWords:i(de.showWords,this.defaultValue.showWords),showColors:i(de.showColors,this.defaultValue.showColors),showFiles:i(de.showFiles,this.defaultValue.showFiles),showReferences:i(de.showReferences,this.defaultValue.showReferences),showFolders:i(de.showFolders,this.defaultValue.showFolders),showTypeParameters:i(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(de.showSnippets,this.defaultValue.showSnippets),showUsers:i(de.showUsers,this.defaultValue.showUsers),showIssues:i(de.showIssues,this.defaultValue.showIssues)}}}class tt extends f{constructor(){super(be.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(497,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(498,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(W.selectSubwords,this.defaultValue.selectSubwords)}}}class at extends f{constructor(){const W=[];super(be.wordSegmenterLocales,"wordSegmenterLocales",W,{anyOf:[{description:s.localize(499,null),type:"string"},{description:s.localize(500,null),type:"array",items:{type:"string"}}]})}validate(W){if(typeof W=="string"&&(W=[W]),Array.isArray(W)){const de=[];for(const je of W)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&de.push(je)}catch{}return de}return this.defaultValue}}var it;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class ot extends f{constructor(){super(be.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(501,null),s.localize(502,null),s.localize(503,null),s.localize(504,null)],description:s.localize(505,null),default:"same"}})}validate(W){switch(W){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(W,de,je){return de.get(be.accessibilitySupport)===I.AccessibilitySupport.Enabled?it.None:je}}class vt extends l{constructor(){super(be.wrappingInfo)}compute(W,de,je){const Qe=de.get(be.layoutInfo);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class Ye extends f{constructor(){const W={enabled:!0,showDropSelector:"afterDrop"};super(be.dropIntoEditor,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(506,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(507,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(508,null),s.localize(509,null)],default:"afterDrop"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showDropSelector:d(de.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class he extends f{constructor(){const W={enabled:!0,showPasteSelector:"afterPaste"};super(be.pasteAs,"pasteAs",W,{"editor.pasteAs.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(510,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(511,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(512,null),s.localize(513,null)],default:"afterPaste"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showPasteSelector:d(de.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",ye="Menlo, Monaco, 'Courier New', monospace",Ce="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?ye:P.$l?Ce:pe,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(X){return e.editorOptionsRegistry[X.id]=X,X}var be;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.placeholder=88]="placeholder",X[X.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",X[X.quickSuggestions=90]="quickSuggestions",X[X.quickSuggestionsDelay=91]="quickSuggestionsDelay",X[X.readOnly=92]="readOnly",X[X.readOnlyMessage=93]="readOnlyMessage",X[X.renameOnType=94]="renameOnType",X[X.renderControlCharacters=95]="renderControlCharacters",X[X.renderFinalNewline=96]="renderFinalNewline",X[X.renderLineHighlight=97]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=99]="renderValidationDecorations",X[X.renderWhitespace=100]="renderWhitespace",X[X.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",X[X.roundedSelection=102]="roundedSelection",X[X.rulers=103]="rulers",X[X.scrollbar=104]="scrollbar",X[X.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=106]="scrollBeyondLastLine",X[X.scrollPredominantAxis=107]="scrollPredominantAxis",X[X.selectionClipboard=108]="selectionClipboard",X[X.selectionHighlight=109]="selectionHighlight",X[X.selectOnLineNumbers=110]="selectOnLineNumbers",X[X.showFoldingControls=111]="showFoldingControls",X[X.showUnused=112]="showUnused",X[X.snippetSuggestions=113]="snippetSuggestions",X[X.smartSelect=114]="smartSelect",X[X.smoothScrolling=115]="smoothScrolling",X[X.stickyScroll=116]="stickyScroll",X[X.stickyTabStops=117]="stickyTabStops",X[X.stopRenderingLineAfter=118]="stopRenderingLineAfter",X[X.suggest=119]="suggest",X[X.suggestFontSize=120]="suggestFontSize",X[X.suggestLineHeight=121]="suggestLineHeight",X[X.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",X[X.suggestSelection=123]="suggestSelection",X[X.tabCompletion=124]="tabCompletion",X[X.tabIndex=125]="tabIndex",X[X.unicodeHighlighting=126]="unicodeHighlighting",X[X.unusualLineTerminators=127]="unusualLineTerminators",X[X.useShadowDOM=128]="useShadowDOM",X[X.useTabStops=129]="useTabStops",X[X.wordBreak=130]="wordBreak",X[X.wordSegmenterLocales=131]="wordSegmenterLocales",X[X.wordSeparators=132]="wordSeparators",X[X.wordWrap=133]="wordWrap",X[X.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=136]="wordWrapColumn",X[X.wordWrapOverride1=137]="wordWrapOverride1",X[X.wordWrapOverride2=138]="wordWrapOverride2",X[X.wrappingIndent=139]="wrappingIndent",X[X.wrappingStrategy=140]="wrappingStrategy",X[X.showDeprecated=141]="showDeprecated",X[X.inlayHints=142]="inlayHints",X[X.editorClassName=143]="editorClassName",X[X.pixelRatio=144]="pixelRatio",X[X.tabFocusMode=145]="tabFocusMode",X[X.layoutInfo=146]="layoutInfo",X[X.wrappingInfo=147]="wrappingInfo",X[X.defaultColorDecorators=148]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(be||(e.EditorOption=be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(be.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(514,null)})),acceptSuggestionOnEnter:fe(new S(be.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(515,null),""],markdownDescription:s.localize(516,null)})),accessibilitySupport:fe(new C),accessibilityPageSize:fe(new o(be.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(517,null),tags:["accessibility"]})),ariaLabel:fe(new g(be.ariaLabel,"ariaLabel",s.localize(518,null))),ariaRequired:fe(new n(be.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(be.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(519,null),tags:["accessibility"]})),autoClosingBrackets:fe(new S(be.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(520,null),s.localize(521,null),""],description:s.localize(522,null)})),autoClosingComments:fe(new S(be.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(523,null),s.localize(524,null),""],description:s.localize(525,null)})),autoClosingDelete:fe(new S(be.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(526,null),""],description:s.localize(527,null)})),autoClosingOvertype:fe(new S(be.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingQuotes:fe(new S(be.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(530,null),s.localize(531,null),""],description:s.localize(532,null)})),autoIndent:fe(new k(be.autoIndent,"autoIndent",b.Full,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[s.localize(533,null),s.localize(534,null),s.localize(535,null),s.localize(536,null),s.localize(537,null)],description:s.localize(538,null)})),automaticLayout:fe(new n(be.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new S(be.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(539,null),s.localize(540,null),s.localize(541,null),""],description:s.localize(542,null)})),bracketPairColorization:fe(new Ee),bracketPairGuides:fe(new Ue),stickyTabStops:fe(new n(be.stickyTabStops,"stickyTabStops",!1,{description:s.localize(543,null)})),codeLens:fe(new n(be.codeLens,"codeLens",!0,{description:s.localize(544,null)})),codeLensFontFamily:fe(new g(be.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(545,null)})),codeLensFontSize:fe(new o(be.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(546,null)})),colorDecorators:fe(new n(be.colorDecorators,"colorDecorators",!0,{description:s.localize(547,null)})),colorDecoratorActivatedOn:fe(new S(be.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(548,null),s.localize(549,null),s.localize(550,null)],description:s.localize(551,null)})),colorDecoratorsLimit:fe(new o(be.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(552,null)})),columnSelection:fe(new n(be.columnSelection,"columnSelection",!1,{description:s.localize(553,null)})),comments:fe(new T),contextmenu:fe(new n(be.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(be.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(554,null)})),cursorBlinking:fe(new k(be.cursorBlinking,"cursorBlinking",$.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:s.localize(555,null)})),cursorSmoothCaretAnimation:fe(new S(be.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(556,null),s.localize(557,null),s.localize(558,null)],description:s.localize(559,null)})),cursorStyle:fe(new k(be.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:s.localize(560,null)})),cursorSurroundingLines:fe(new o(be.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(561,null)})),cursorSurroundingLinesStyle:fe(new S(be.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(562,null),s.localize(563,null)],markdownDescription:s.localize(564,null)})),cursorWidth:fe(new o(be.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(565,null)})),disableLayerHinting:fe(new n(be.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(be.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(be.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(be.dragAndDrop,"dragAndDrop",!0,{description:s.localize(566,null)})),emptySelectionClipboard:fe(new J),dropIntoEditor:fe(new Ye),stickyScroll:fe(new q),experimentalWhitespaceRendering:fe(new S(be.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(567,null),s.localize(568,null),s.localize(569,null)],description:s.localize(570,null)})),extraEditorClassName:fe(new g(be.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new m(be.fastScrollSensitivity,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:s.localize(571,null)})),find:fe(new U),fixedOverflowWidgets:fe(new n(be.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(be.folding,"folding",!0,{description:s.localize(572,null)})),foldingStrategy:fe(new S(be.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(573,null),s.localize(574,null)],description:s.localize(575,null)})),foldingHighlight:fe(new n(be.foldingHighlight,"foldingHighlight",!0,{description:s.localize(576,null)})),foldingImportsByDefault:fe(new n(be.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(577,null)})),foldingMaximumRegions:fe(new o(be.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(578,null)})),unfoldOnClickAfterEndOfLine:fe(new n(be.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(579,null)})),fontFamily:fe(new g(be.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(580,null)})),fontInfo:fe(new ne),fontLigatures2:fe(new V),fontSize:fe(new ue),fontWeight:fe(new _),fontVariations:fe(new Q),formatOnPaste:fe(new n(be.formatOnPaste,"formatOnPaste",!1,{description:s.localize(581,null)})),formatOnType:fe(new n(be.formatOnType,"formatOnType",!1,{description:s.localize(582,null)})),glyphMargin:fe(new n(be.glyphMargin,"glyphMargin",!0,{description:s.localize(583,null)})),gotoLocation:fe(new ae),hideCursorInOverviewRuler:fe(new n(be.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(584,null)})),hover:fe(new se),inDiffEditor:fe(new n(be.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new m(be.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>m.clamp(X,-5,20),{description:s.localize(585,null)})),lightbulb:fe(new Y),lineDecorationsWidth:fe(new ve),lineHeight:fe(new Pe),lineNumbers:fe(new Ne),lineNumbersMinChars:fe(new o(be.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(be.linkedEditing,"linkedEditing",!1,{description:s.localize(586,null)})),links:fe(new n(be.links,"links",!0,{description:s.localize(587,null)})),matchBrackets:fe(new S(be.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(588,null)})),minimap:fe(new Fe),mouseStyle:fe(new S(be.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new m(be.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:s.localize(589,null)})),mouseWheelZoom:fe(new n(be.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?s.localize(590,null):s.localize(591,null)})),multiCursorMergeOverlapping:fe(new n(be.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(592,null)})),multiCursorModifier:fe(new k(be.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Be,{markdownEnumDescriptions:[s.localize(593,null),s.localize(594,null)],markdownDescription:s.localize(595,null)})),multiCursorPaste:fe(new S(be.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(596,null),s.localize(597,null)],markdownDescription:s.localize(598,null)})),multiCursorLimit:fe(new o(be.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(599,null)})),occurrencesHighlight:fe(new S(be.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(600,null),s.localize(601,null),s.localize(602,null)],markdownDescription:s.localize(603,null)})),overviewRulerBorder:fe(new n(be.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(604,null)})),overviewRulerLanes:fe(new o(be.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new xe),pasteAs:fe(new he),parameterHints:fe(new nt),peekWidgetDefaultFocus:fe(new S(be.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(605,null),s.localize(606,null)],description:s.localize(607,null)})),placeholder:fe(new pt),definitionLinkOpensInPeek:fe(new n(be.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(608,null)})),quickSuggestions:fe(new lt),quickSuggestionsDelay:fe(new o(be.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(609,null)})),readOnly:fe(new n(be.readOnly,"readOnly",!1)),readOnlyMessage:fe(new B),renameOnType:fe(new n(be.renameOnType,"renameOnType",!1,{description:s.localize(610,null),markdownDeprecationMessage:s.localize(611,null)})),renderControlCharacters:fe(new n(be.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(612,null),restricted:!0})),renderFinalNewline:fe(new S(be.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:s.localize(613,null)})),renderLineHighlight:fe(new S(be.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(614,null)],description:s.localize(615,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(be.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(616,null)})),renderValidationDecorations:fe(new S(be.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new S(be.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(617,null),s.localize(618,null),s.localize(619,null),""],description:s.localize(620,null)})),revealHorizontalRightPadding:fe(new o(be.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(be.roundedSelection,"roundedSelection",!0,{description:s.localize(621,null)})),rulers:fe(new Le),scrollbar:fe(new H),scrollBeyondLastColumn:fe(new o(be.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(622,null)})),scrollBeyondLastLine:fe(new n(be.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(623,null)})),scrollPredominantAxis:fe(new n(be.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(624,null)})),selectionClipboard:fe(new n(be.selectionClipboard,"selectionClipboard",!0,{description:s.localize(625,null),included:P.$l})),selectionHighlight:fe(new n(be.selectionHighlight,"selectionHighlight",!0,{description:s.localize(626,null)})),selectOnLineNumbers:fe(new n(be.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new S(be.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(627,null),s.localize(628,null),s.localize(629,null)],description:s.localize(630,null)})),showUnused:fe(new n(be.showUnused,"showUnused",!0,{description:s.localize(631,null)})),showDeprecated:fe(new n(be.showDeprecated,"showDeprecated",!0,{description:s.localize(632,null)})),inlayHints:fe(new ie),snippetSuggestions:fe(new S(be.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(633,null),s.localize(634,null),s.localize(635,null),s.localize(636,null)],description:s.localize(637,null)})),smartSelect:fe(new tt),smoothScrolling:fe(new n(be.smoothScrolling,"smoothScrolling",!1,{description:s.localize(638,null)})),stopRenderingLineAfter:fe(new o(be.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new _e),inlineSuggest:fe(new re),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(be.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(639,null)})),suggestFontSize:fe(new o(be.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(640,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(be.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(641,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(be.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(642,null)})),suggestSelection:fe(new S(be.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(643,null),s.localize(644,null),s.localize(645,null)],description:s.localize(646,null)})),tabCompletion:fe(new S(be.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(647,null),s.localize(648,null),s.localize(649,null)],description:s.localize(650,null)})),tabIndex:fe(new o(be.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new G),unusualLineTerminators:fe(new S(be.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(651,null),s.localize(652,null),s.localize(653,null)],description:s.localize(654,null)})),useShadowDOM:fe(new n(be.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(be.useTabStops,"useTabStops",!0,{description:s.localize(655,null)})),wordBreak:fe(new S(be.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(656,null),s.localize(657,null)],description:s.localize(658,null)})),wordSegmenterLocales:fe(new at),wordSeparators:fe(new g(be.wordSeparators,"wordSeparators",p.$rt,{description:s.localize(659,null)})),wordWrap:fe(new S(be.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(660,null),s.localize(661,null),s.localize(662,null),s.localize(663,null)],description:s.localize(664,null)})),wordWrapBreakAfterCharacters:fe(new g(be.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new g(be.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(be.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(665,null)})),wordWrapOverride1:fe(new S(be.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new S(be.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new Z),defaultColorDecorators:fe(new n(be.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(666,null)})),pixelRatio:fe(new ut),tabFocusMode:fe(new n(be.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(667,null)})),layoutInfo:fe(new x),wrappingInfo:fe(new vt),wrappingIndent:fe(new ot),wrappingStrategy:fe(new we)}}),define(Re[107],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,y.$Ii)("environmentService"),e.$Qi=(0,y.$Ji)(e.$Pi)}),define(Re[28],Te([1,0,48,22,13,14,2,9,3,23,15,51]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=u,e.$fl=c,e.$gl=h,e.$hl=i,e.$il=n,e.$jl=t,e.$kl=o,e.$ll=a,e.$ml=m,e.$nl=g,e.$ol=d,e.$ql=v,e.$rl=C,e.$sl=T,e.$tl=$,e.$ul=w,e.$xl=J,e.$Jl=_,e.$Kl=ae,e.$Ml=ce,e.$dl=(0,p.$Ii)("fileService");function u(x){return x.create===!0}var E;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var f;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var r;(function(x){x[x.UPDATED=2]="UPDATED",x[x.ADDED=4]="ADDED",x[x.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function c(x){const we=x;return!!we&&typeof we.onDidChange=="function"}var l;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function h(x){return!!(x.capabilities&l.FileReadWrite)}function i(x){return!!(x.capabilities&l.FileFolderCopy)}function n(x){return!!(x.capabilities&l.FileClone)}function t(x){return!!(x.capabilities&l.FileOpenReadWriteClose)}function o(x){return!!(x.capabilities&l.FileReadStream)}function a(x){return h(x)?!!(x.capabilities&l.FileAtomicRead):!1}function m(x){return h(x)?!!(x.capabilities&l.FileAtomicWrite):!1}function g(x){return!!(x.capabilities&l.FileAtomicDelete)}function d(x){return!!(x.capabilities&l.Readonly)}var S;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class k extends Error{static create(we,Ie){const Y=new k(we.toString(),Ie);return T(Y,Ie),Y}constructor(we,Ie){super(we),this.code=Ie}}e.$pl=k;function v(x,we){return k.create(x,we)}function C(x){return x||v((0,O.localize)(1863,null),S.Unknown)}function T(x,we){return x.name=we?`${we} (FileSystemError)`:"FileSystemError",x}function $(x){if(!x)return S.Unknown;if(x instanceof k)return x.code;const we=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!we)return S.Unknown;switch(we[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function w(x){if(x instanceof U)return x.fileOperationResult;switch($(x)){case S.FileNotFound:return ne.FILE_NOT_FOUND;case S.FileIsADirectory:return ne.FILE_IS_DIRECTORY;case S.FileNotADirectory:return ne.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return ne.FILE_WRITE_LOCKED;case S.NoPermissions:return ne.FILE_PERMISSION_DENIED;case S.FileExists:return ne.FILE_MOVE_CONFLICT;case S.FileTooLarge:return ne.FILE_TOO_LARGE;default:return ne.FILE_OTHER_ERROR}}var M;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class A{constructor(we,Ie,Y){this.resource=we,this.operation=Ie,this.target=Y}isOperation(we){return this.operation===we}}e.$vl=A;var L;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class Z{static{this.a=null}constructor(we,Ie){this.c=Ie,this.b=void 0,this.d=new b.$W(()=>{const Y=y.$Oi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new b.$W(()=>{const Y=y.$Oi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new b.$W(()=>{const Y=y.$Oi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of we){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==Z.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=Z.a):this.b!==void 0&&(this.b=Z.a))}}contains(we,...Ie){return this.h(we,{includeChildren:!1},...Ie)}affects(we,...Ie){return this.h(we,{includeChildren:!0},...Ie)}h(we,Ie,...Y){if(!we)return!1;const q=Y.length>0;return!!((!q||Y.includes(L.ADDED))&&(this.d.value.get(we)||Ie.includeChildren&&this.d.value.findSuperstr(we))||(!q||Y.includes(L.UPDATED))&&(this.f.value.get(we)||Ie.includeChildren&&this.f.value.findSuperstr(we))||(!q||Y.includes(L.DELETED))&&(this.g.value.findSubstr(we)||Ie.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$wl=Z;function J(x,we,Ie){return!x||!we||x===we||we.length>x.length?!1:(we.charAt(we.length-1)!==D.sep&&(we+=D.sep),Ie?(0,P.$Jf)(x,we):x.indexOf(we)===0)}class U extends Error{constructor(we,Ie,Y){super(we),this.fileOperationResult=Ie,this.options=Y}}e.$yl=U;class V extends U{constructor(we,Ie,Y,q){super(we,Ie,q),this.fileOperationResult=Ie,this.size=Y}}e.$zl=V;class Q extends U{constructor(we,Ie,Y){super(we,ne.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Ie}}e.$Al=Q;var ne;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var ue;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Il="";function _(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}async function ae(x,we){if(!we.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(Ie=>{const Y=we.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===x.scheme&&q.added&&(Y.dispose(),Ie())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(we){return(0,N.$lg)(we)||(we=0),we<se.KB?(0,O.localize)(1864,null,we.toFixed(0)):we<se.MB?(0,O.localize)(1865,null,(we/se.KB).toFixed(2)):we<se.GB?(0,O.localize)(1866,null,(we/se.MB).toFixed(2)):we<se.TB?(0,O.localize)(1867,null,(we/se.GB).toFixed(2)):(0,O.localize)(1868,null,(we/se.TB).toFixed(2))}}e.$Ll=se;function ce(x){const we=typeof x=="string"||x?.scheme===I.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===I.Schemas.file?1024*se.MB:we?10*se.MB:s.$p?50*se.MB:1024*se.MB}}),define(Re[75],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class y{constructor(...P){this.a=new Map;for(const[N,R]of P)this.set(N,R)}set(P,N){const R=this.a.get(P);return this.a.set(P,N),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Gi=y}),define(Re[170],Te([1,0,10,12,4,74,167,3,75,171]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0;const I=!1;class b extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class u{constructor(c=new p.$Gi,l=!1,h,i=I){this.i=c,this.j=l,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Hi,this),this._globalGraph=i?h?._globalGraph??new R.$Ar(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Sc)(this.h),this.h.clear();for(const c of this.g)(0,P.$Rc)(c)&&c.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(c,l){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(c,this.j,this,this.l);return this.h.add(i),l?.add(i),i}invokeFunction(c,...l){this.m();const h=f.traceInvocation(this.l,c);let i=!1;try{return c({get:t=>{if(i)throw(0,D.$0)("service accessor is only valid during the invocation of its target method");const o=this.s(t,h);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...l)}finally{i=!0,h.stop()}}createInstance(c,...l){this.m();let h,i;return c instanceof N.$Fi?(h=f.traceCreation(this.l,c.ctor),i=this.o(c.ctor,c.staticArguments.concat(l),h)):(h=f.traceCreation(this.l,c),i=this.o(c,l,h)),h.stop(),i}o(c,l=[],h){const i=O._util.getServiceDependencies(c).sort((o,a)=>o.index-a.index),n=[];for(const o of i){const a=this.s(o.id,h);a||this.y(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(a)}const t=i.length>0?i[0].index:l.length;if(l.length!==t){console.trace(`[createInstance] First service dependency of ${c.name} at position ${t+1} conflicts with ${l.length} static arguments`);const o=t-l.length;o>0?l=l.concat(new Array(o)):l=l.slice(0,t)}return Reflect.construct(c,l.concat(n))}q(c,l){if(this.i.get(c)instanceof N.$Fi)this.i.set(c,l);else if(this.k)this.k.q(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(c){const l=this.i.get(c);return!l&&this.k?this.k.r(c):l}s(c,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const h=this.r(c);return h instanceof N.$Fi?this.u(c,h,l.branch(c,!0)):(l.branch(c,!1),h)}u(c,l,h){if(this.t.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.t.add(c);try{return this.v(c,l,h)}finally{this.t.delete(c)}}v(c,l,h){const i=new R.$Ar(a=>a.id.toString());let n=0;const t=[{id:c,desc:l,_trace:h}],o=new Set;for(;t.length;){const a=t.pop();if(!o.has(String(a.id))){if(o.add(String(a.id)),i.lookupOrInsertNode(a),n++>1e3)throw new b(i);for(const m of O._util.getServiceDependencies(a.desc.ctor)){const g=this.r(m.id);if(g||this.y(`[createInstance] ${c} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(m.id)),g instanceof N.$Fi){const d={id:m.id,desc:g,_trace:a._trace.branch(m.id,!0)};i.insertEdge(a,d),t.push(d)}}}}for(;;){const a=i.roots();if(a.length===0){if(!i.isEmpty())throw new b(i);break}for(const{data:m}of a){if(this.r(m.id)instanceof N.$Fi){const d=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,d)}i.removeNode(m)}}return this.r(c)}w(c,l,h=[],i,n){if(this.i.get(c)instanceof N.$Fi)return this.x(c,l,h,i,n,this.g);if(this.k)return this.k.w(c,l,h,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(c,l,h=[],i,n,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(c);const a=new Map,m=new y.$2h(()=>{const g=o.o(l,h,n);for(const[d,S]of a){const k=g[d];if(typeof k=="function")for(const v of S)v.disposable=k.apply(g,v.listener)}return a.clear(),t.add(g),g});return new Proxy(Object.create(null),{get(g,d){if(!m.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let v=a.get(d);return v||(v=new s.$8c,a.set(d,v)),(T,$,w)=>{if(m.isInitialized)return m.value[d](T,$,w);{const M={listener:[T,$,w],disposable:void 0},A=v.push(M);return(0,P.$Vc)(()=>{A(),M.disposable?.dispose()})}}}if(d in g)return g[d];const S=m.value;let k=S[d];return typeof k!="function"||(k=k.bind(S),g[d]=k),k},set(g,d,S){return m.value[d]=S,!0},getPrototypeOf(g){return l.prototype}})}else{const o=this.o(l,h,n);return t.add(o),o}}y(c,l){if(l&&console.warn(c),this.j)throw new Error(c)}}e.$Br=u;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(c,l){return c?new f(E.Invocation,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(c,l){return c?new f(E.Creation,l.name):f.c}static{this.f=0}constructor(c,l){this.type=c,this.name=l,this.g=Date.now(),this.h=[]}branch(c,l){const h=new f(E.Branch,c.toString());return this.h.push([c,l,h]),h}stop(){const c=Date.now()-this.g;f.f+=c;let l=!1;function h(n,t){const o=[],a=new Array(n+1).join("	");for(const[m,g,d]of t.h)if(g&&d){l=!0,o.push(`${a}CREATES -> ${m}`);const S=h(n+1,d);S&&o.push(S)}else o.push(`${a}uses -> ${m}`);return o.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(c>2||l)&&f.all.add(i.join(`
`))}}e.$Cr=f}),define(Re[11],Te([1,0,9,42,6,76,4,27,23,24,14,2,31,3]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=r,e.log=l,e.$rk=k,e.$sk=v,e.$tk=C,e.$uk=T,y=qe(y),e.$dk=(0,E.$Ii)("logService"),e.$ek=(0,E.$Ii)("loggerService");function f(){return new Date().toISOString()}function r($){return(0,I.$lg)($)}var c;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$gk=c.Info;function l($,w,M){switch(w){case c.Trace:$.trace(M);break;case c.Debug:$.debug(M);break;case c.Info:$.info(M);break;case c.Warning:$.warn(M);break;case c.Error:$.error(M);break;case c.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function h($,w=!1){let M="";for(let A=0;A<$.length;A++){let L=$[A];if(L instanceof Error&&(L=(0,D.$tj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(A>0?" ":"")+L}return M}class i extends R.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new P.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==c.Off&&this.b<=w}}e.$ik=i;class n extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f(c.Trace)&&this.g(c.Trace,h([w,...M],!0))}debug(w,...M){this.f(c.Debug)&&this.g(c.Debug,h([w,...M]))}info(w,...M){this.f(c.Info)&&this.g(c.Info,h([w,...M]))}warn(w,...M){this.f(c.Warning)&&this.g(c.Warning,h([w,...M]))}error(w,...M){if(this.f(c.Error))if(w instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=w.stack,this.g(c.Error,h(A))}else this.g(c.Error,h([w,...M]))}flush(){}}e.$jk=n;class t extends i{constructor(w=e.$gk){super(),this.setLevel(w),this.g=!p.$j}trace(w,...M){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}debug(w,...M){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}info(w,...M){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}warn(w,...M){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...M):console.warn(`[main ${f()}]`,w,...M))}error(w,...M){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...M):console.error(`[main ${f()}]`,w,...M))}flush(){}}e.$kk=t;class o extends i{constructor(w=e.$gk,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$lk=o;class a extends i{constructor(w,M=e.$gk){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(w),...M])}debug(w,...M){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(w),...M])}info(w,...M){this.f(c.Info)&&this.g.log(c.Info,[this.h(w),...M])}warn(w,...M){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(w),...M])}error(w,...M){this.f(c.Error)&&this.g.log(c.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,D.$tj)(w,this.f(c.Trace))}flush(){}}e.$mk=a;class m extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const A of this.g)A.trace(w,...M)}debug(w,...M){for(const A of this.g)A.debug(w,...M)}info(w,...M){for(const A of this.g)A.info(w,...M)}warn(w,...M){for(const A of this.g)A.warn(w,...M)}error(w,...M){for(const A of this.g)A.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$nk=m;class g extends R.$Xc{constructor(w,M,A){if(super(),this.h=w,this.j=M,this.b=new O.$Dc,this.c=this.B(new P.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$oe),this.onDidChangeVisibility=this.g.event,A)for(const L of A)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,I.$hg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const A=this.n(w),L=(0,I.$hg)(w)?w:M?.id??(0,N.$wj)(A.toString()).toString(16);let Z=this.b.get(A)?.logger;const J=M?.logLevel==="always"?c.Trace:M?.logLevel;Z||(Z=this.s(A,J??this.getLogLevel(A)??this.h,{...M,id:L}));const U={logger:Z,info:{resource:A,id:L,logLevel:J,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(U.info),this.b.set(A,U),Z}n(w){return(0,I.$hg)(w)?(0,s.$jh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(b.URI.isUri(w)){const A=w,L=M,Z=this.b.get(A);Z&&L!==Z.info.logLevel&&(Z.info.logLevel=L===this.h?void 0:L,Z.logger?.setLevel(L),this.b.set(Z.info.resource,Z),this.f.fire([A,L]))}else{this.h=w;for(const[A,L]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const A=this.m(w);A&&M!==!A.info.hidden&&(A.info.hidden=!M,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=g;class d{constructor(){this.onDidChangeLogLevel=new P.$oe().event}setLevel(w){}getLevel(){return c.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$pk=d;class S extends d{}e.$qk=S;function k($){if($.verbose)return c.Trace;if(typeof $.logLevel=="string"){const w=T($.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gk}function v($){switch($){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}function C($){switch($){case c.Trace:return{original:"Trace",value:y.localize(1957,null)};case c.Debug:return{original:"Debug",value:y.localize(1958,null)};case c.Info:return{original:"Info",value:y.localize(1959,null)};case c.Warning:return{original:"Warning",value:y.localize(1960,null)};case c.Error:return{original:"Error",value:y.localize(1961,null)};case c.Off:return{original:"Off",value:y.localize(1962,null)}}}function T($){switch($){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$vk=new u.$Zj("logLevel",v(c.Info))}),define(Re[172],Te([1,0,4,11]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class P extends y.$Xc{constructor(R,O=[]){super(),this.a=new D.$nk([R,...O]),this.B(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...O){this.a.trace(R,...O)}debug(R,...O){this.a.debug(R,...O)}info(R,...O){this.a.info(R,...O)}warn(R,...O){this.a.warn(R,...O)}error(R,...O){this.a.error(R,...O)}flush(){this.a.flush()}}e.$4R=P});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[108],Te([1,0,36,9,3]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,y=si(y);var N;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function s(f,r){return r-f}p.compare=s;const I=Object.create(null);I[p.Error]=(0,D.localize)(1963,null),I[p.Warning]=(0,D.localize)(1964,null),I[p.Info]=(0,D.localize)(1965,null);function b(f){return I[f]||""}p.toString=b;function u(f){switch(f){case y.default.Error:return p.Error;case y.default.Warning:return p.Warning;case y.default.Info:return p.Info;case y.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(f){switch(f){case p.Error:return y.default.Error;case p.Warning:return y.default.Warning;case p.Info:return y.default.Info;case p.Hint:return y.default.Ignore}}p.toSeverity=E}(R||(e.MarkerSeverity=R={}));var O;(function(p){const s="";function I(u){return b(u,!0)}p.makeKey=I;function b(u,E){const f=[s];return u.source?f.push(u.source.replace("\xA6","\\\xA6")):f.push(s),u.code?typeof u.code=="string"?f.push(u.code.replace("\xA6","\\\xA6")):f.push(u.code.value.replace("\xA6","\\\xA6")):f.push(s),u.severity!==void 0&&u.severity!==null?f.push(R.toString(u.severity)):f.push(s),u.message&&E?f.push(u.message.replace("\xA6","\\\xA6")):f.push(s),u.startLineNumber!==void 0&&u.startLineNumber!==null?f.push(u.startLineNumber.toString()):f.push(s),u.startColumn!==void 0&&u.startColumn!==null?f.push(u.startColumn.toString()):f.push(s),u.endLineNumber!==void 0&&u.endLineNumber!==null?f.push(u.endLineNumber.toString()):f.push(s),u.endColumn!==void 0&&u.endColumn!==null?f.push(u.endColumn.toString()):f.push(s),f.push(s),f.join("\xA6")}p.makeKeyOptionalMessage=b})(O||(e.IMarkerData=O={})),e.$Lu=(0,P.$Ii)("markerService")});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[173],Te([1,0,6,36,3]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$zw=e.Severity=void 0,e.$Aw=O,D=si(D),e.Severity=D.default,e.$zw=(0,P.$Ii)("notificationService");var N;(function(b){b[b.DEFAULT=0]="DEFAULT",b[b.SILENT=1]="SILENT",b[b.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(b){b[b.WORKSPACE=0]="WORKSPACE",b[b.PROFILE=1]="PROFILE",b[b.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function O(b){if(b){const u=b;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(b){b[b.OFF=0]="OFF",b[b.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class s{constructor(){this.progress=new I,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Bw=s;class I{infinite(){}done(){}total(u){}worked(u){}}e.$Cw=I}),define(Re[109],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,y.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function($e,e,y,D){var P=arguments.length,N=P<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,y):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate($e,e,y,D);else for(var O=$e.length-1;O>=0;O--)(R=$e[O])&&(N=(P<3?R(N):P>3?R(e,y,N):R(e,y))||N);return P>3&&N&&Object.defineProperty(e,y,N),N},We=this&&this.__param||function($e,e){return function(y,D){e(y,D,$e)}};define(Re[77],Te([1,0,10,19,4,3]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.ProgressLocation=e.$Dw=void 0,e.$Dw=(0,N.$Ii)("progressService");var R;(function(b){b[b.Explorer=1]="Explorer",b[b.Scm=3]="Scm",b[b.Extensions=5]="Extensions",b[b.Window=10]="Window",b[b.Notification=15]="Notification",b[b.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Ew=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Fw=O;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$Gw=p;let s=class extends P.$Xc{constructor(u,E){super(),this.a=new y.$6h,E.withProgress(u,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,P.$Vc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Hw=s,e.$Hw=s=Ke([We(1,e.$Dw)],s);class I extends P.$Xc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Wc)}start(u){this.stop();const E=++this.a,f=new D.$ze;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Vc)(()=>f.cancel())),this.b.add((0,P.$Vc)(()=>this.c?this.c.done():void 0)),{id:E,token:f.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Iw=I,e.$Jw=(0,N.$Ii)("editorProgressService")}),define(Re[29],Te([1,0,61,14]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,y=qe(y),D=qe(D);class P{constructor(){this.a=new Map}add(R,O){y.ok(D.$hg(R)),y.ok(D.$jg(O)),y.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,O)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$uo=new P}),define(Re[78],Te([1,0,6,138,29]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,P=qe(P),e.$vo={JSONContribution:"base.contributions.json"};function N(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this.b=new y.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,I){this.a[N(s)]=I,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const I=this.a[s];return I?(0,D.$$j)(I):void 0}hasSchemaContent(s){return!!this.a[s]}}const O=new R;P.$uo.add(e.$vo.JSONContribution,O)}),define(Re[53],Te([1,0,17,6,14,9,43,78,29]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ConfigurationScope=e.$zo=e.EditPresentationTypes=void 0,e.$Ko=r,e.$Lo=c,e.$Mo=l,e.$No=i,e.$Oo=n,e.$Po=t,e.$Qo=o,P=qe(P),N=qe(N);var s;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$zo={Configuration:"base.contributions.configuration"};var I;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go="vscode://schemas/settings/resourceLanguage",e.$Ho="vscode://schemas/settings/configurationDefaults";const b=p.$uo.as(O.$vo.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new D.$oe,this.onDidSchemaChange=this.j.event,this.k=new D.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:N.localize(1660,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},b.registerSchema(e.$Go,this.h),this.z()}registerConfiguration(m,g=!0){this.registerConfigurations([m],g)}registerConfigurations(m,g=!0){const d=new Set;this.r(m,g,d),b.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:d})}deregisterConfigurations(m){const g=new Set;this.s(m,g),b.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:g})}updateConfigurations({add:m,remove:g}){const d=new Set;this.s(g,d),this.r(m,!1,d),b.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:d})}registerDefaultConfigurations(m){const g=new Set;this.l(m,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:!0})}l(m,g){this.a.push(...m);const d=[];for(const{overrides:S,source:k}of m)for(const v in S){g.add(v);const C=this.b.get(v)??this.b.set(v,{configurationDefaultOverrides:[]}).get(v),T=S[v];if(C.configurationDefaultOverrides.push({value:T,source:k}),e.$Jo.test(v)){const $=this.o(v,T,k,C.configurationDefaultOverrideValue);if(!$)continue;C.configurationDefaultOverrideValue=$,this.n(v,$,k),d.push(...r(v))}else{const $=this.p(v,T,k,C.configurationDefaultOverrideValue);if(!$)continue;C.configurationDefaultOverrideValue=$;const w=this.e[v];w&&(this.A(v,w),this.w(v,w))}}this.q(d)}deregisterDefaultConfigurations(m){const g=new Set;this.m(m,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:!0})}m(m,g){for(const d of m){const S=this.a.indexOf(d);S!==-1&&this.a.splice(S,1)}for(const{overrides:d,source:S}of m)for(const k in d){const v=this.b.get(k);if(!v)continue;const C=v.configurationDefaultOverrides.findIndex(T=>S?T.source?.id===S.id:T.value===d[k]);if(C!==-1){if(v.configurationDefaultOverrides.splice(C,1),v.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Jo.test(k)){let T;for(const $ of v.configurationDefaultOverrides)T=this.o(k,$.value,$.source,T);T&&!P.$ug(T.value)?(v.configurationDefaultOverrideValue=T,this.n(k,T,S)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let T;for(const w of v.configurationDefaultOverrides)T=this.p(k,w.value,w.source,T);v.configurationDefaultOverrideValue=T;const $=this.e[k];$&&(this.A(k,$),this.w(k,$))}g.add(k)}}this.y()}n(m,g,d){const S={type:"object",default:g.value,description:N.localize(1661,null,(0,R.$mj)(m)),$ref:e.$Go,defaultDefaultValue:g.value,source:d,defaultValueSource:d};this.e[m]=S,this.c.properties[m]=S}o(m,g,d,S){const k=S?.value||{},v=S?.source??new Map;if(!(v instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(g)){const T=g[C];if(P.$jg(T)&&(P.$og(k[C])||P.$jg(k[C]))){if(k[C]={...k[C]??{},...T},d)for(const w in T)v.set(`${C}.${w}`,d)}else k[C]=T,d?v.set(C,d):v.delete(C)}return{value:k,source:v}}p(m,g,d,S){const k=this.e[m],v=S?.value??k?.defaultDefaultValue;let C=d;if(P.$jg(g)&&(k!==void 0&&k.type==="object"||k===void 0&&(P.$og(v)||P.$jg(v)))){if(C=S?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const $ in g)d&&C.set(`${m}.${$}`,d);g={...P.$jg(v)?v:{},...g}}return{value:g,source:C}}deltaConfiguration(m){let g=!1;const d=new Set;m.removedDefaults&&(this.m(m.removedDefaults,d),g=!0),m.addedDefaults&&(this.l(m.addedDefaults,d),g=!0),m.removedConfigurations&&this.s(m.removedConfigurations,d),m.addedConfigurations&&this.r(m.addedConfigurations,!1,d),this.j.fire(),this.k.fire({properties:d,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...m){this.j.fire()}registerOverrideIdentifiers(m){this.q(m),this.j.fire()}q(m){for(const g of m)this.i.add(g);this.y()}r(m,g,d){m.forEach(S=>{this.u(S,g,S.extensionInfo,S.restrictedProperties,void 0,d),this.d.push(S),this.v(S)})}s(m,g){const d=S=>{if(S.properties)for(const k in S.properties){g.add(k);const v=this.e[k];v?.policy?.name&&this.f.delete(v.policy.name),delete this.e[k],this.x(k,S.properties[k])}S.allOf?.forEach(k=>d(k))};for(const S of m){d(S);const k=this.d.indexOf(S);k!==-1&&this.d.splice(k,1)}}u(m,g=!0,d,S,k=I.WINDOW,v){k=P.$qg(m.scope)?k:m.scope;const C=m.properties;if(C)for(const $ in C){const w=C[$];if(g&&i($,w)){delete C[$];continue}if(w.source=d,w.defaultDefaultValue=C[$].default,this.A($,w),e.$Jo.test($)?w.scope=void 0:(w.scope=P.$qg(w.scope)?k:w.scope,w.restricted=P.$qg(w.restricted)?!!S?.includes($):w.restricted),C[$].hasOwnProperty("included")&&!C[$].included){this.g[$]=C[$],delete C[$];continue}else this.e[$]=C[$],C[$].policy?.name&&this.f.set(C[$].policy.name,$);!C[$].deprecationMessage&&C[$].markdownDeprecationMessage&&(C[$].deprecationMessage=C[$].markdownDeprecationMessage),v.add($)}const T=m.allOf;if(T)for(const $ of T)this.u($,g,d,S,k,v)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const m=new Map;for(const[g,d]of this.b)d.configurationDefaultOverrideValue&&m.set(g,d.configurationDefaultOverrideValue);return m}v(m){const g=d=>{const S=d.properties;if(S)for(const v in S)this.w(v,S[v]);d.allOf?.forEach(g)};g(m)}w(m,g){switch(e.$Ao.properties[m]=g,g.scope){case I.APPLICATION:e.$Bo.properties[m]=g;break;case I.MACHINE:e.$Co.properties[m]=g;break;case I.MACHINE_OVERRIDABLE:e.$Do.properties[m]=g;break;case I.WINDOW:e.$Eo.properties[m]=g;break;case I.RESOURCE:e.$Fo.properties[m]=g;break;case I.LANGUAGE_OVERRIDABLE:e.$Fo.properties[m]=g,this.h.properties[m]=g;break}}x(m,g){switch(delete e.$Ao.properties[m],g.scope){case I.APPLICATION:delete e.$Bo.properties[m];break;case I.MACHINE:delete e.$Co.properties[m];break;case I.MACHINE_OVERRIDABLE:delete e.$Do.properties[m];break;case I.WINDOW:delete e.$Eo.properties[m];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Fo.properties[m],delete this.h.properties[m];break}}y(){for(const m of this.i.values()){const g=`[${m}]`,d={type:"object",description:N.localize(1662,null),errorMessage:N.localize(1663,null),$ref:e.$Go};this.A(g,d),e.$Ao.properties[g]=d,e.$Bo.properties[g]=d,e.$Co.properties[g]=d,e.$Do.properties[g]=d,e.$Eo.properties[g]=d,e.$Fo.properties[g]=d}}z(){const m={type:"object",description:N.localize(1664,null),errorMessage:N.localize(1665,null),$ref:e.$Go};e.$Ao.patternProperties[e.$Io]=m,e.$Bo.patternProperties[e.$Io]=m,e.$Co.patternProperties[e.$Io]=m,e.$Do.patternProperties[e.$Io]=m,e.$Eo.patternProperties[e.$Io]=m,e.$Fo.patternProperties[e.$Io]=m,this.j.fire()}A(m,g){const d=this.b.get(m)?.configurationDefaultOverrideValue;let S,k;d&&(!g.disallowConfigurationDefault||!d.source)&&(S=d.value,k=d.source),P.$og(S)&&(S=g.defaultDefaultValue,k=void 0),P.$og(S)&&(S=l(g.type)),g.default=S,g.defaultValueSource=k}}const E="\\[([^\\]]+)\\]",f=new RegExp(E,"g");e.$Io=`^(${E})+$`,e.$Jo=new RegExp(e.$Io);function r(a){const m=[];if(e.$Jo.test(a)){let g=f.exec(a);for(;g?.length;){const d=g[1].trim();d&&m.push(d),g=f.exec(a)}}return(0,y.$Ob)(m)}function c(a){return a.reduce((m,g)=>`${m}[${g}]`,"")}function l(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$uo.add(e.$zo.Configuration,h);function i(a,m){return a.trim()?e.$Jo.test(a)?N.localize(1667,null,a):h.getConfigurationProperties()[a]!==void 0?N.localize(1668,null,a):m.policy?.name&&h.getPolicyConfigurations().get(m.policy?.name)!==void 0?N.localize(1669,null,a,m.policy?.name,h.getPolicyConfigurations().get(m.policy?.name)):null:N.localize(1666,null)}function n(){const a=[],m=h.getConfigurationProperties();for(const g of Object.keys(m))a.push([g,m[g].scope]);return a.push(["launch",I.RESOURCE]),a.push(["task",I.RESOURCE]),a}function t(a){const m={};for(const g of a){const d=g.properties;if(P.$jg(d))for(const S in d)m[S]=d[S];g.allOf&&Object.assign(m,t(g.allOf))}return m}function o(a){switch(a){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[174],Te([1,0,17,6,137,4,27,25,14,2,43,53,28,29]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Uo=e.$To=e.$So=e.$Ro=void 0,e.$Vo=n,y=qe(y),P=qe(P),O=qe(O),p=qe(p);function f(m){return Object.isFrozen(m)?m:O.$io(m)}class r{static createEmptyModel(g){return new r({},[],[],void 0,g)}constructor(g,d,S,k,v){this.b=g,this.c=d,this.d=S,this.raw=k,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const g=this.raw.map(d=>{if(d instanceof r)return d;const S=new c("",this.f);return S.parseRaw(d),S.configurationModel});this.g=g.reduce((d,S)=>S===d?S:d.merge(S),g[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(g){return g?(0,I.$kj)(this.contents,g):this.contents}inspect(g,d){const S=this;return{get value(){return f(S.rawConfiguration.getValue(g))},get override(){return d?f(S.rawConfiguration.getOverrideValue(g,d)):void 0},get merged(){return f(d?S.rawConfiguration.override(d).getValue(g):S.rawConfiguration.getValue(g))},get overrides(){const k=[];for(const{contents:v,identifiers:C,keys:T}of S.rawConfiguration.overrides){const $=new r(v,T,[],void 0,S.f).getValue(g);$!==void 0&&k.push({identifiers:C,value:$})}return k.length?f(k):void 0}}}getOverrideValue(g,d){const S=this.j(d);return S?g?(0,I.$kj)(S,g):S:void 0}getKeysForOverrideIdentifier(g){const d=[];for(const S of this.overrides)S.identifiers.includes(g)&&d.push(...S.keys);return y.$Ob(d)}getAllOverrideIdentifiers(){const g=[];for(const d of this.overrides)g.push(...d.identifiers);return y.$Ob(g)}override(g){let d=this.a.get(g);return d||(d=this.h(g),this.a.set(g,d)),d}merge(...g){const d=O.$ho(this.contents),S=O.$ho(this.overrides),k=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const C of g)if(v.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(d,C.contents);for(const T of C.overrides){const[$]=S.filter(w=>y.$wb(w.identifiers,T.identifiers));$?(this.i($.contents,T.contents),$.keys.push(...T.keys),$.keys=y.$Ob($.keys)):S.push(O.$ho(T))}for(const T of C.keys)k.indexOf(T)===-1&&k.push(T)}return new r(d,k,S,v.every(C=>C instanceof r)?void 0:v,this.f)}h(g){const d=this.j(g);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const S={};for(const k of y.$Ob([...Object.keys(this.contents),...Object.keys(d)])){let v=this.contents[k];const C=d[k];C&&(typeof v=="object"&&typeof C=="object"?(v=O.$ho(v),this.i(v,C)):v=C),S[k]=v}return new r(S,this.keys,this.overrides,void 0,this.f)}i(g,d){for(const S of Object.keys(d)){if(S in g&&p.$jg(g[S])&&p.$jg(d[S])){this.i(g[S],d[S]);continue}g[S]=O.$ho(d[S])}}j(g){let d=null,S=null;const k=v=>{v&&(S?this.i(S,v):S=O.$ho(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===g?d=v.contents:v.identifiers.includes(g)&&k(v.contents);return k(d),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(g,d){this.k(g,d,!0)}setValue(g,d){this.k(g,d,!1)}removeValue(g){const d=this.keys.indexOf(g);d!==-1&&(this.keys.splice(d,1),(0,I.$jj)(this.contents,g),b.$Jo.test(g)&&this.overrides.splice(this.overrides.findIndex(S=>y.$wb(S.identifiers,(0,b.$Ko)(g))),1))}k(g,d,S){if((0,I.$ij)(this.contents,g,d,k=>this.f.error(k)),S=S||this.keys.indexOf(g)===-1,S&&this.keys.push(g),b.$Jo.test(g)){const k=(0,b.$Ko)(g),v={identifiers:k,keys:Object.keys(this.contents[g]),contents:(0,I.$hj)(this.contents[g],T=>this.f.error(T))},C=this.overrides.findIndex(T=>y.$wb(T.identifiers,k));C!==-1?this.overrides[C]=v:this.overrides.push(v)}}}e.$Ro=r;class c{constructor(g,d){this.f=g,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(g,d){if(!p.$qg(g)){const S=this.h(g);this.parseRaw(S,d)}}reparse(g){this.a&&this.parseRaw(this.a,g)}parseRaw(g,d){this.a=g;const{contents:S,keys:k,overrides:v,restricted:C,hasExcludedProperties:T}=this.i(g,d);this.b=new r(S,k,v,T?[g]:void 0,this.g),this.c=C||[]}h(g){let d={},S=null,k=[];const v=[],C=[];function T(w){Array.isArray(k)?k.push(w):S!==null&&(k[S]=w)}const $={onObjectBegin:()=>{const w={};T(w),v.push(k),k=w,S=null},onObjectProperty:w=>{S=w},onObjectEnd:()=>{k=v.pop()},onArrayBegin:()=>{const w=[];T(w),v.push(k),k=w,S=null},onArrayEnd:()=>{k=v.pop()},onLiteralValue:T,onError:(w,M,A)=>{C.push({error:w,offset:M,length:A})}};if(g)try{P.$9n(g,$),d=k[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return d}i(g,d){const S=E.$uo.as(b.$zo.Configuration).getConfigurationProperties(),k=this.j(g,S,!0,d);g=k.raw;const v=(0,I.$hj)(g,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`)),C=Object.keys(g),T=this.l(g,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:v,keys:C,overrides:T,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(g,d,S,k){let v=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:g,restricted:[],hasExcludedProperties:v};const C={},T=[];for(const $ in g)if(b.$Jo.test($)&&S){const w=this.j(g[$],d,!1,k);C[$]=w.raw,v=v||w.hasExcludedProperties,T.push(...w.restricted)}else{const w=d[$],M=w?typeof w.scope<"u"?w.scope:b.ConfigurationScope.WINDOW:void 0;w?.restricted&&T.push($),!k.exclude?.includes($)&&(k.include?.includes($)||(M===void 0||k.scopes===void 0||k.scopes.includes(M))&&!(k.skipRestricted&&w?.restricted))?C[$]=g[$]:v=!0}return{raw:C,restricted:T,hasExcludedProperties:v}}l(g,d){const S=[];for(const k of Object.keys(g))if(b.$Jo.test(k)){const v={};for(const C in g[k])v[C]=g[k][C];S.push({identifiers:(0,b.$Ko)(k),keys:Object.keys(v),contents:(0,I.$hj)(v,d)})}return S}}e.$So=c;class l extends N.$Xc{constructor(g,d,S,k,v){super(),this.c=g,this.f=d,this.g=k,this.h=v,this.b=this.B(new D.$oe),this.onDidChange=this.b.event,this.a=new c(this.c.toString(),v),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&S.isEqual(C.resource,g)))(()=>this.b.fire()))}async loadConfiguration(){try{const g=await this.g.readFile(this.c);return this.a.parse(g.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(g){return g&&(this.f=g),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$To=l;class h{constructor(g,d,S,k,v,C,T,$,w,M,A,L,Z){this.a=g,this.b=d,this.c=S,this.overrideIdentifiers=k,this.d=v,this.f=C,this.g=T,this.h=$,this.i=w,this.j=M,this.k=A,this.l=L,this.m=Z}get value(){return f(this.c)}n(g){return g?.value!==void 0||g?.override!==void 0||g?.overrides!==void 0?g:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(g,d,S,k,v,C,T,$,w,M){this.j=g,this.l=d,this.m=S,this.n=k,this.p=v,this.q=C,this.r=T,this.s=$,this.t=w,this.u=M,this.h=null,this.i=new R.$Dc,this.v=null}getValue(g,d,S){return this.w(g,d,S).getValue(g)}updateValue(g,d,S={}){let k;S.resource?(k=this.t.get(S.resource),k||(k=r.createEmptyModel(this.u),this.t.set(S.resource,k))):k=this.s,d===void 0?k.removeValue(g):k.setValue(g,d),S.resource||(this.h=null)}inspect(g,d,S){const k=this.w(g,d,S),v=this.A(d.resource,S),C=d.resource?this.t.get(d.resource)||this.s:this.s,T=new Set;for(const $ of k.overrides)for(const w of $.identifiers)k.getOverrideValue(g,w)!==void 0&&T.add(w);return new h(g,d,k.getValue(g),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,v||void 0,C)}keys(g){const d=this.A(void 0,g);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(g){this.j=g,this.h=null,this.i.clear()}updatePolicyConfiguration(g){this.l=g}updateApplicationConfiguration(g){this.m=g,this.h=null,this.i.clear()}updateLocalUserConfiguration(g){this.n=g,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(g){this.p=g,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(g){this.q=g,this.h=null,this.i.clear()}updateFolderConfiguration(g,d){this.r.set(g,d),this.i.delete(g)}deleteFolderConfiguration(g){this.folderConfigurations.delete(g),this.i.delete(g)}compareAndUpdateDefaultConfiguration(g,d){const S=[];if(!d){const{added:k,updated:v,removed:C}=o(this.j,g);d=[...k,...v,...C]}for(const k of d)for(const v of(0,b.$Ko)(k)){const C=this.j.getKeysForOverrideIdentifier(v),T=g.getKeysForOverrideIdentifier(v),$=[...T.filter(w=>C.indexOf(w)===-1),...C.filter(w=>T.indexOf(w)===-1),...C.filter(w=>!O.$lo(this.j.override(v).getValue(w),g.override(v).getValue(w)))];S.push([v,$])}return this.updateDefaultConfiguration(g),{keys:d,overrides:S}}compareAndUpdatePolicyConfiguration(g){const{added:d,updated:S,removed:k}=o(this.l,g),v=[...d,...S,...k];return v.length&&this.updatePolicyConfiguration(g),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(g){const{added:d,updated:S,removed:k,overrides:v}=o(this.applicationConfiguration,g),C=[...d,...S,...k];return C.length&&this.updateApplicationConfiguration(g),{keys:C,overrides:v}}compareAndUpdateLocalUserConfiguration(g){const{added:d,updated:S,removed:k,overrides:v}=o(this.localUserConfiguration,g),C=[...d,...S,...k];return C.length&&this.updateLocalUserConfiguration(g),{keys:C,overrides:v}}compareAndUpdateRemoteUserConfiguration(g){const{added:d,updated:S,removed:k,overrides:v}=o(this.remoteUserConfiguration,g),C=[...d,...S,...k];return C.length&&this.updateRemoteUserConfiguration(g),{keys:C,overrides:v}}compareAndUpdateWorkspaceConfiguration(g){const{added:d,updated:S,removed:k,overrides:v}=o(this.workspaceConfiguration,g),C=[...d,...S,...k];return C.length&&this.updateWorkspaceConfiguration(g),{keys:C,overrides:v}}compareAndUpdateFolderConfiguration(g,d){const S=this.folderConfigurations.get(g),{added:k,updated:v,removed:C,overrides:T}=o(S,d),$=[...k,...v,...C];return($.length||!S)&&this.updateFolderConfiguration(g,d),{keys:$,overrides:T}}compareAndDeleteFolderConfiguration(g){const d=this.folderConfigurations.get(g);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(g);const{added:S,updated:k,removed:v,overrides:C}=o(d,void 0);return{keys:[...S,...k,...v],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(g,d,S){let k=this.x(d,S);return d.overrideIdentifier&&(k=k.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(g)!==void 0&&(k=k.merge(this.l)),k}x({resource:g},d){let S=this.y();if(d&&g){const k=d.getFolder(g);k&&(S=this.z(k.uri)||S);const v=this.t.get(g);v&&(S=S.merge(v))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(g){let d=this.i.get(g);if(!d){const S=this.y(),k=this.r.get(g);k?(d=S.merge(k),this.i.set(g,d)):d=S}return d}A(g,d){if(d&&g){const S=d.getFolder(g);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((g,d)=>{const{contents:S,overrides:k,keys:v}=this.r.get(d);return g.push([d,{contents:S,overrides:k,keys:v}]),g},[])}}allKeys(){const g=new Set;return this.j.keys.forEach(d=>g.add(d)),this.userConfiguration.keys.forEach(d=>g.add(d)),this.q.keys.forEach(d=>g.add(d)),this.r.forEach(d=>d.keys.forEach(S=>g.add(S))),[...g.values()]}B(){const g=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>g.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>g.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>g.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(S=>g.add(S))),[...g.values()]}D(g){const d=new Set;return this.j.getKeysForOverrideIdentifier(g).forEach(S=>d.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(g).forEach(S=>d.add(S)),this.q.getKeysForOverrideIdentifier(g).forEach(S=>d.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(g).forEach(k=>d.add(k))),[...d.values()]}static parse(g,d){const S=this.E(g.defaults,d),k=this.E(g.policy,d),v=this.E(g.application,d),C=this.E(g.user,d),T=this.E(g.workspace,d),$=g.folders.reduce((w,M)=>(w.set(s.URI.revive(M[0]),this.E(M[1],d)),w),new R.$Dc);return new i(S,k,v,C,r.createEmptyModel(d),T,$,r.createEmptyModel(d),new R.$Dc,d)}static E(g,d){return new r(g.contents,g.keys,g.overrides,void 0,d)}}e.$Uo=i;function n(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const g=new Set,d=new Map;for(const k of m)k.keys.forEach(v=>g.add(v)),k.overrides.forEach(([v,C])=>{const T=(0,R.$Ac)(d,v,new Set);C.forEach($=>T.add($))});const S=[];return d.forEach((k,v)=>S.push([v,[...k.values()]])),{keys:[...g.values()],overrides:S}}class t{constructor(g,d,S,k,v){this.change=g,this.f=d,this.g=S,this.h=k,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of g.keys)this.affectedKeys.add(C);for(const[,C]of g.overrides)for(const T of C)this.affectedKeys.add(T);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(g,d){const S=this.a+g,k=this.d.indexOf(S);if(k<0)return!1;const v=k+S.length;if(v>=this.d.length)return!1;const C=this.d.charCodeAt(v);if(C!==this.b&&C!==this.c)return!1;if(d){const T=this.previousConfiguration?this.previousConfiguration.getValue(g,d,this.f?.workspace):void 0,$=this.g.getValue(g,d,this.h);return!O.$lo(T,$)}return!0}}e.$Wo=t;function o(m,g){const{added:d,removed:S,updated:k}=a(g?.rawConfiguration,m?.rawConfiguration),v=[],C=m?.getAllOverrideIdentifiers()||[],T=g?.getAllOverrideIdentifiers()||[];if(g){const $=T.filter(w=>!C.includes(w));for(const w of $)v.push([w,g.getKeysForOverrideIdentifier(w)])}if(m){const $=C.filter(w=>!T.includes(w));for(const w of $)v.push([w,m.getKeysForOverrideIdentifier(w)])}if(g&&m){for(const $ of C)if(T.includes($)){const w=a({contents:m.getOverrideValue(void 0,$)||{},keys:m.getKeysForOverrideIdentifier($)},{contents:g.getOverrideValue(void 0,$)||{},keys:g.getKeysForOverrideIdentifier($)});v.push([$,[...w.added,...w.removed,...w.updated]])}}return{added:d,removed:S,updated:k,overrides:v}}function a(m,g){const d=m?g?m.keys.filter(v=>g.keys.indexOf(v)===-1):[...m.keys]:[],S=g?m?g.keys.filter(v=>m.keys.indexOf(v)===-1):[...g.keys]:[],k=[];if(m&&g){for(const v of g.keys)if(m.keys.indexOf(v)!==-1){const C=(0,I.$kj)(g.contents,v),T=(0,I.$kj)(m.contents,v);O.$lo(C,T)||k.push(v)}}return{added:d,removed:S,updated:k}}}),define(Re[110],Te([1,0,12,3]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=s,e.$Ul=(0,D.$Ii)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class N{constructor(b){this.id=b,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=N;class R{constructor(b,u){this.host=b,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=R;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class p extends y.$db{static isNotAvailable(b){return b instanceof p&&b._code===O.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof p&&b._code===O.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof p&&b._code===O.NoResolverFound}static isInvalidAuthority(b){return b instanceof p&&b._code===O.InvalidAuthority}static isHandled(b){return b instanceof p&&b.isHandled}constructor(b,u=O.Unknown,E){super(b),this._message=b,this._code=u,this._detail=E,this.isHandled=u===O.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Xl=p;function s(I){const b=I.indexOf("+");return b===-1?I:I.substring(0,b)}}),define(Re[62],Te([1,0,15]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=D,e.$ln=P,e.$mn=N,e.$nn=R;function D(p){return p.scheme===y.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const s=p.indexOf("+");return s<0?p:p.substr(0,s)}function N(p){const{host:s,port:I}=O(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function R(p,s){let{host:I,port:b}=O(p);return typeof b>"u"&&(b=s),{host:I,port:b}}function O(p){const s=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const b=p.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:p,port:void 0}}}),define(Re[18],Te([1,0,13,3,62]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$wn=e.$vn=e.$un=e.TargetPlatform=e.ExtensionType=e.$tn=e.$rn=e.$qn=e.$pn=e.$on=void 0,e.$sn=N,e.$xn=b,e.$yn=u,e.$zn=E,e.$An=f,e.$Bn=r,e.$Cn=c,y=qe(y),e.$on="extensions.user.cache",e.$pn="extensions.builtin.cache",e.$qn="undefined_publisher",e.$rn=["ui","workspace","web"];function N(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$tn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var O;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class p{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,i){if(typeof h>"u"||h===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof h=="string"||typeof i=="string"){const n=typeof h=="string"?h:h.value,t=typeof i=="string"?i:i.value;return y.$If(n,t)}return h._lower===i._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$un=p;class s{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const i of h)this.add(i)}add(h){this.c.add(p.toKey(h))}delete(h){return this.c.delete(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}}e.$vn=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(p.toKey(h))}get(h){return this.c.get(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}set(h,i){this.c.set(p.toKey(h),i)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wn=I;function b(l){return u(l)}function u(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}function E(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}function f(l,h){if(h){const i=`onResolveRemoteAuthority:${(0,P.$ln)(h)}`;return!!l.activationEvents?.includes(i)}return!1}function r(l){return l.map(h=>{const[i,n]=h.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function c(l){return l.map(h=>h.split("@")[0])}e.$Dn=(0,D.$Ii)("IBuiltinExtensionsScannerService")}),define(Re[111],Te([1,0,23,9,18,3]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.ExtensionManagementErrorCode=e.$pp=e.ExtensionGalleryErrorCode=e.$op=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=void 0,e.$ip=O,e.$jp=p,e.$kp=s,e.$lp=I,e.$mp=b,e.$np=u,e.$bp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$cp=new RegExp(e.$bp),e.$dp="__web_extension",e.$ep="skipWalkthrough",e.$fp="extensionInstallSource",e.$gp="dependecyOrPackExtensionInstall",e.$hp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function O(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case y.Platform.Windows:return o==="x64"?P.TargetPlatform.WIN32_X64:o==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case y.Platform.Linux:return o==="x64"?P.TargetPlatform.LINUX_X64:o==="arm64"?P.TargetPlatform.LINUX_ARM64:o==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?P.TargetPlatform.ALPINE_X64:o==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case y.Platform.Mac:return o==="x64"?P.TargetPlatform.DARWIN_X64:o==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case y.Platform.Web:return P.TargetPlatform.WEB}}function I(t,o){return o===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function b(t,o,a){return I(o,a)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===a}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var c;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$op=(0,N.$Ii)("extensionGalleryService");var l;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(l||(e.ExtensionGalleryErrorCode=l={}));class h extends Error{constructor(o,a){super(o),this.code=a,this.name=a}}e.$pp=h;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,a){super(o),this.code=a,this.name=a}}e.$qp=n,e.$rp=(0,N.$Ii)("extensionManagementService"),e.$sp="extensionsIdentifiers/disabled",e.$tp="extensionsIdentifiers/enabled",e.$up=(0,N.$Ii)("IGlobalExtensionEnablementService"),e.$vp=(0,N.$Ii)("IExtensionTipsService"),e.$wp=(0,D.localize2)(1778,"Extensions"),e.$xp=(0,D.localize2)(1779,"Preferences")}),define(Re[112],Te([1,0,12,18]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bH=e.$aH=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,O){this.a.set(R,O)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const O=Object.create(null);for(const p of R){const s=this.readActivationEvents(p);s.length>0&&(O[D.$un.toKey(p.identifier)]=s)}return O}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const O=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<O.length;p++)O[p]==="onUri"&&(O[p]=`onUri:${D.$un.toKey(R.identifier)}`);if(!R.contributes)return O;for(const p in R.contributes){const s=this.a.get(p);if(!s)continue;const I=R.contributes[p],b=Array.isArray(I)?I:[I];try{s(b,O)}catch(u){(0,y.$2)(u)}}return O}}e.$aH=P,e.$bH=new P});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[175],Te([1,0,24,36,9,281,18,105]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=I,e.$4p=b,e.$5p=u,e.$6p=E,e.$7p=f,e.$8p=r,e.$9p=c,e.$0p=l,D=si(D),P=qe(P),N=qe(N);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||p.test(n)}function b(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,a=n.minorBase;let m=n.minorMustEqual;const g=n.patchBase;let d=n.patchMustEqual;n.hasCaret&&(t===0||(m=!1),d=!1);let S=0;if(n.preRelease){const k=s.exec(n.preRelease);if(k){const[,v,C,T]=k;S=Date.UTC(Number(v),Number(C)-1,Number(T))}}return{majorBase:t,majorMustEqual:o,minorBase:a,minorMustEqual:m,patchBase:g,patchMustEqual:d,isMinimum:n.hasGreaterEquals,notBefore:S}}function E(n,t,o){let a;typeof n=="string"?a=u(b(n)):a=n;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let g;if(typeof o=="string"?g=u(b(o)):g=o,!a||!g)return!1;const d=a.majorBase,S=a.minorBase,k=a.patchBase;let v=g.majorBase,C=g.minorBase,T=g.patchBase;const $=g.notBefore;let w=g.majorMustEqual,M=g.minorMustEqual,A=g.patchMustEqual;return g.isMinimum?d>v?!0:d<v?!1:S>C?!0:S<C||m&&m<$?!1:k>=T:(d===1&&v===0&&(!w||!M||!A)&&(v=1,C=0,T=0,w=!0,M=!1,A=!1),d<v?!1:d>v?!w:S<C?!1:S>C?!M:k<T?!1:k>T?!A:!(m&&m<$))}function f(n,t,o,a,m,g){const d=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return d.push([D.default.Error,P.localize(1830,null)]),d;if(typeof a.name!="string")return d.push([D.default.Error,P.localize(1831,null,"name")]),d;if(typeof a.version!="string")return d.push([D.default.Error,P.localize(1832,null,"version")]),d;if(!a.engines)return d.push([D.default.Error,P.localize(1833,null,"engines")]),d;if(typeof a.engines.vscode!="string")return d.push([D.default.Error,P.localize(1834,null,"engines.vscode")]),d;if(typeof a.extensionDependencies<"u"&&!i(a.extensionDependencies))return d.push([D.default.Error,P.localize(1835,null,"extensionDependencies")]),d;if(typeof a.activationEvents<"u"){if(!i(a.activationEvents))return d.push([D.default.Error,P.localize(1836,null,"activationEvents")]),d;if(typeof a.main>"u"&&typeof a.browser>"u")return d.push([D.default.Error,P.localize(1837,null,"activationEvents","main","browser")]),d}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&d.push([D.default.Warning,P.localize(1838,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return d.push([D.default.Error,P.localize(1839,null,"main")]),d;{const v=(0,y.$jh)(o,a.main);(0,y.$dh)(v,o)||d.push([D.default.Warning,P.localize(1840,null,v.path,o.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return d.push([D.default.Error,P.localize(1841,null,"browser")]),d;{const v=(0,y.$jh)(o,a.browser);(0,y.$dh)(v,o)||d.push([D.default.Warning,P.localize(1842,null,v.path,o.path)])}}if(!N.valid(a.version))return d.push([D.default.Error,P.localize(1843,null)]),d;const S=[];if(!r(n,t,a,m,S))for(const v of S)d.push([D.default.Error,v]);if(g&&a.enabledApiProposals?.length){const v=[];if(!l([...a.enabledApiProposals],v))for(const C of v)d.push([D.default.Error,C])}return d}function r(n,t,o,a,m){return a||typeof o.main>"u"&&typeof o.browser>"u"?!0:h(n,t,o.engines.vscode,m)}function c(n,t,o){return n==="*"||h(t,o,n)}function l(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,a=(o?void 0:t)??O.allApiProposals,m=[],g=(0,R.$Bn)(n);for(const{proposalName:d,version:S}of g){const k=a[d];k&&S&&k.version!==S&&m.push(P.localize(1844,null,d))}return o?.push(...m),m.length===0}function h(n,t,o,a=[]){const m=u(b(o));if(!m)return a.push(P.localize(1845,null,o)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return a.push(P.localize(1846,null,o)),!1}else if(!m.majorMustEqual)return a.push(P.localize(1847,null,o)),!1;return E(n,t,m)?!0:(a.push(P.localize(1848,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Re[176],Te([1,0,20,12,4,9,53,3,11,29]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0,e.$aq=u,e.$bq=E,e.$cq=f,e.$dq=r,e.$eq=c,e.$fq=l,e.$$p=(0,O.$Ii)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class b extends P.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,N.localize)(2048,null),when:p.$vk.isEqualTo((0,p.$sk)(p.LogLevel.Trace)).serialize()})}async c(t,o,a){const m=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${m} - begin`,o.type,new I(o.headers??{}));try{const g=await a();return this.a.trace(`${m} - end`,o.type,g.res.statusCode,g.res.headers),g}catch(g){throw this.a.error(`${m} - error`,o.type,(0,D.$_)(g)),g}}}e.$_p=b;function u(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function E(n){return n.res.statusCode===204}async function f(n){return E(n)?null:(await(0,y.$3e)(n.stream)).toString()}async function r(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);return f(n)}async function c(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);if(E(n))return null;const o=(await(0,y.$3e)(n.stream)).toString();try{return JSON.parse(o)}catch(a){throw a.message+=`:
`+o,a}}function l(n){i(n)}let h;function i(n){const t=s.$uo.as(R.$zo.Configuration),o=h;h={id:"http",order:15,title:(0,N.localize)(2049,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2050,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(2051,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(2052,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,N.localize)(2053,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(2054,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(2055,null),(0,N.localize)(2056,null),(0,N.localize)(2057,null),(0,N.localize)(2058,null)],default:"override",description:(0,N.localize)(2059,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(2060,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(2061,null),restricted:!0}}},t.updateConfigurations({add:[h],remove:o?[o]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Re[177],Te([1,0,23,79,38]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=R,e.$zp=O;function N(p){if(y.$v===y.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,s,I,b,u,E,f,r,c,l){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=f,h["common.devDeviceId"]=r,h.sessionID=(0,P.$5g)()+Date.now(),h.commitHash=b,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,y.$i)(y.$v),h["common.nodePlatform"]=D.$gc,h["common.nodeArch"]=I,h["common.product"]=l||"desktop",c&&(h["common.msftInternal"]=c);let i=0;const n=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$m&&(h["common.snap"]="true");const t=N(s);return t&&(h["common.platformDetail"]=t),h}function O(p){const s=D.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return p.some(b=>I===b)}}),define(Re[113],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,y.$Ii)("telemetryService"),e.$dm=(0,y.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var P;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Re[63],Te([1,0,25,14,62,177,113]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Hp=I,e.$Ip=b,e.$Jp=u,e.$Kp=E,e.$Lp=r,e.$Mp=l,e.$Np=h,e.$Op=t;class O{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$Ap=O;class p{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Bp=p,e.$Cp=new p;class s{async publicLog(a,m,g){}async publicLogError(a,m,g){}}e.$Dp=s,e.$Ep="telemetry",e.$Fp="extensionTelemetryLog",e.$Gp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry)}function b(o,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const a=o.getValue(R.$lm),m=o.getValue(R.$mm);if(o.getValue(R.$nm)===!1||m===!1)return R.TelemetryLevel.NONE;switch(a??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function E(o){const a={},m={},g={};c(o,g);for(let d in g){d=d.length>150?d.substr(d.length-149):d;const S=g[d];typeof S=="number"?m[d]=S:typeof S=="boolean"?m[d]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${S.length}`),a[d]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(a[d]=S)}return{properties:a,measurements:m}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const a=(0,P.$ln)(o);return f.has(a)?a:"other"}function c(o,a,m=0,g){if(o)for(const d of Object.getOwnPropertyNames(o)){const S=o[d],k=g?g+d:d;Array.isArray(S)?a[k]=(0,y.$mo)(S):S instanceof Date?a[k]=S.toISOString():(0,D.$jg)(S)?m<2?c(S,a,m+1,k+"."):a[k]=(0,y.$mo)(S):a[k]=S}}function l(o,a){const m=o.msftInternalDomains||[],g=a.getValue("telemetry.internalTesting");return(0,N.$zp)(m)||g}function h(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let m=o;const g=[];for(const v of a)for(;;){const C=v.exec(o);if(!C)break;g.push([C.index,v.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(m="";;){const v=S.exec(o);if(!v)break;const C=g.some(([T,$])=>v.index<$&&T<S.lastIndex);!d.test(v[0])&&!C&&(m+=o.substring(k,v.index)+"<REDACTED: user-file-path>",k=S.lastIndex)}return k<o.length&&(m+=o.substr(k)),m}function n(o){if(!o)return o;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of a)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return o}function t(o,a){return(0,y.$jo)(o,m=>{if(m instanceof O||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let g=m.replaceAll("%20"," ");g=i(g,a);for(const d of a)g=g.replace(d,"");return g=n(g),g}})}}),define(Re[178],Te([1,0,13,111,18,23,2,12,79,63]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Qp=void 0,e.$Pp=I,e.$Rp=f,e.$Sp=r,e.$Tp=c,e.$Up=l,e.$Vp=h,e.$Wp=i,e.$Xp=n,e.$Zp=t,e.$1p=a;function I(m,g){return m.uuid&&g.uuid?m.uuid===g.uuid:m.id===g.id?!0:(0,y.$Df)(m.id,g.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(g){const d=g.manifest?g.manifest.version:g.version,S=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new u(g.identifier,d,S)}static parse(g){const d=b.exec(g);return d&&d[1]&&d[2]?new u({id:d[1]},d[2],d[4]||void 0):null}constructor(g,d,S=P.TargetPlatform.UNDEFINED){this.identifier=g,this.version=d,this.targetPlatform=S,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof u?I(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$Qp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(m){const g=E.exec(m);return g&&g[1]?[c(g[1]),g[2]]:[c(m),void 0]}function r(m,g){return`${m}.${g}`}function c(m){return m.toLowerCase()}function l(m,g){return c(r(m??P.$qn,g))}function h(m,g){const d=[],S=k=>{for(const v of d)if(v.some(C=>I(g(C),g(k))))return v;return null};for(const k of m){const v=S(k);v?v.push(k):d.push([k])}return d}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function n(m){return{id:new s.$Ap(m.identifier.id),name:new s.$Ap(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Yp=new P.$un("pprice.better-merge");function t(m,g){const d=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&d.every(v=>!I(v.identifier,{id:k}))){const v=m.filter(C=>I(C.identifier,{id:k}));v.length===1&&(d.push(v[0]),S.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function o(m,g){if(!N.$l)return!1;let d;try{d=(await m.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await m.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){g.debug("Error while getting the os-release file.",(0,O.$_)(k))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(m,g){const d=await o(m,g),S=(0,D.$kp)(d?"alpine":N.$v,p.$hc);return g.debug("ComputeTargetPlatform:",S),S}}),define(Re[179],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=y,e.$Ls=D,e.$Ms=P,e.$Ns=N,e.$Os=R,e.$Ps=O;function y(p){return[...p.entries()]}function D(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function N(p){return new Map(p??[])}function R(p){return Array.from(p.entries()).map(s=>[s[0],y(s[1].map),D(s[1].descriptionMap)])}function O(p){return new Map(p.map(s=>[s[0],{map:P(s[1]),descriptionMap:N(s[2])}]))}}),define(Re[180],Te([1,0,3,31,29]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$us=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ts=void 0,e.$ts=new D.$Zj("terminalTabFocusMode",!1,!0);var N;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(N||(e.TerminalSettingPrefix=N={}));var R;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var O;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(O||(e.PosixShellType=O={}));var p;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(p||(e.WindowsShellType=p={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var b;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var u;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$us=(0,y.$Ii)("ptyService");var E;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var f;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var c;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var l;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(l||(e.FlowControlConstants=l={}));var h;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$vs={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(a){const m=this.b(a.remoteAuthority);if(this.a.has(m))throw new Error(`A terminal backend with remote authority '${m}' was already registered.`);this.a.set(m,a)}getTerminalBackend(a){return this.a.get(this.b(a))}b(a){return a?.toLowerCase()??""}}P.$uo.add(e.$vs.Backend,new t),e.$ws=(0,y.$Ii)("localPtyService"),e.$xs=(0,y.$Ii)("terminalLogService")}),define(Re[181],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ryb=void 0;class y{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,N,R=5){const O=N(p=>{const s=typeof p=="string"?p:p.data;let I=this.a.get(P);if(I){I.data.push(s);return}const b=setTimeout(()=>this.flushBuffer(P),R);I={data:[s],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(P),O.dispose()}},this.a.set(P,I)});return O}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const N=this.a.get(P);N&&(this.a.delete(P),this.b(P,N.data.join("")))}}e.$ryb=y}),define(Re[182],Te([1,0,10,98,282,35,6,14,2,9,78,29]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ox=e.$Nx=e.$Mx=e.$Lx=e.$Kx=e.$Jx=e.IconFontDefinition=e.IconContribution=e.$Gx=void 0,e.$Hx=c,e.$Ix=l,b=qe(b),e.$Gx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(a,m){let g=a.defaults;for(;N.ThemeIcon.isThemeIcon(g);){const d=r.getIcon(g.id);if(!d)return;g=d.defaults}return g}t.getDefinition=o})(u||(e.IconContribution=u={}));var E;(function(t){function o(m){return{weight:m.weight,style:m.style,src:m.src.map(g=>({format:g.format,location:g.location.toString()}))}}t.toJSONObject=o;function a(m){const g=d=>(0,O.$hg)(d)?d:void 0;if(m&&Array.isArray(m.src)&&m.src.every(d=>(0,O.$hg)(d.format)&&(0,O.$hg)(d.location)))return{weight:g(m.weight),style:g(m.style),src:m.src.map(d=>({format:d.format,location:p.URI.parse(d.location)}))}}t.fromJSONObject=a})(E||(e.IconFontDefinition=E={}));class f{constructor(){this.a=new R.$oe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2362,null)},fontCharacter:{type:"string",description:(0,s.localize)(2363,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,a,m,g){const d=this.b[o];if(d){if(m&&!d.description){d.description=m,this.d.properties[o].markdownDescription=`${m} $(${o})`;const v=this.e.enum.indexOf(o);v!==-1&&(this.e.enumDescriptions[v]=m),this.a.fire()}return d}const S={id:o,description:m,defaults:a,deprecationMessage:g};this.b[o]=S;const k={$ref:"#/definitions/icons"};return g&&(k.deprecationMessage=g),m&&(k.markdownDescription=`${m}: $(${o})`),this.d.properties[o]=k,this.e.enum.push(o),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const a=this.e.enum.indexOf(o);a!==-1&&(this.e.enum.splice(a,1),this.e.enumDescriptions.splice(a,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,a){const m=this.f[o];return m||(this.f[o]=a,this.a.fire(),a)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(d,S)=>d.id.localeCompare(S.id),a=d=>{for(;N.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(d=>this.b[d]);for(const d of g.filter(S=>!!S.description).sort(o))m.push(`|<i class="${a(d)}"></i>|${d.id}|${N.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const d of g.filter(S=>!N.ThemeIcon.isThemeIcon(S.defaults)).sort(o))m.push(`|<i class="${a(d)}"></i>|${d.id}|`);return m.join(`
`)}}const r=new f;b.$uo.add(e.$Gx.IconContribution,r);function c(t,o,a,m){return r.registerIcon(t,o,a,m)}function l(){return r}function h(){const t=(0,P.$4j)();for(const o in t){const a="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:a})}}h(),e.$Jx="vscode://schemas/icons";const i=b.$uo.as(I.$vo.JSONContribution);i.registerSchema(e.$Jx,r.getIconSchema());const n=new y.$Uh(()=>i.notifySchemaChanged(e.$Jx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Kx=c("widget-close",D.$8j.close,(0,s.localize)(2364,null)),e.$Lx=c("goto-previous-location",D.$8j.arrowUp,(0,s.localize)(2365,null)),e.$Mx=c("goto-next-location",D.$8j.arrowDown,(0,s.localize)(2366,null)),e.$Nx=N.ThemeIcon.modify(D.$8j.sync,"spin"),e.$Ox=N.ThemeIcon.modify(D.$8j.loading,"spin")}),define(Re[183],Te([1,0,6,4,23,2,43,3,11]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Uw=e.$Rw=e.$Pw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Lw=e.$Kw=void 0,e.$Mw=b,e.$Nw=E,e.$Ow=f,e.$Qw=r,e.$Sw=c,e.$Tw=l,e.$Kw=(0,O.$Ii)("tunnelService"),e.$Lw=(0,O.$Ii)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function b(n){return!!n.forwardPort}var u;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function f(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const a=o.split("=")[1];if(/^https?:/.exec(a)){const m=E(N.URI.parse(a));if(m)return m}}}e.$Pw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Pw.indexOf(n)>=0}e.$Rw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(n){return e.$Rw.indexOf(n)>=0}function l(n,t,o,a){if(o===P.OperatingSystem.Windows)return!1;if(o===P.OperatingSystem.Macintosh&&c(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(m?.length===4&&parseInt(m[1])>=18)return!1}return n<1024}class h{constructor(t,o,a){this.remoteAddress=t,this.localAddress=o,this.b=a,this.a=new y.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uw=h;let i=class extends D.$Xc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new y.$oe,this.onTunnelOpened=this.a.event,this.b=new y.$oe,this.onTunnelClosed=this.b.event,this.c=new y.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const a of o){const m=Array.from(a.values());for(const g of m){const d=await g.value;d&&typeof d!="string"&&t.push(d)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,a,m,g){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:a,privacy:m,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(c(t)||r(t))&&(t=e.$Pw[0]);const a=this.D(t,o);if(a)return++a.refcount,a.value}openTunnel(t,o,a,m,g,d=!1,S,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${a} on local port ${g}.`);const v=this.g??t;if(!v)return;if(o||(o="localhost"),m||(m=this.t),this.g&&this.n.has(a)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(v,o,a,m,g,d,S,k);return C?C.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,a),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,a);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.w(T);return(T.tunnelRemoteHost!==o||T.tunnelRemotePort!==a)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&T.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const a=o.get(t.tunnelRemotePort);a&&(a.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async y(t,o,a){if(a.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const m=a.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),m}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const a=this.f.get(t);if(a&&a.has(o)){const m=a.get(o);m.refcount=0,await this.y(t,o,m)}}z(t,o,a){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:a})}async C(t,o){const a=this.f.get(t);if(a){const m=a.get(o),g=m?await m.value:void 0;(!g||typeof g=="string")&&a.delete(o),a.size===0&&this.f.delete(t)}}D(t,o){const a=[t];r(t)?(a.push(...e.$Pw),a.push(...e.$Rw)):c(t)&&a.push(...e.$Rw);const m=a.map(g=>this.f.get(g));for(const g of m){const d=g?.get(o);if(d)return d}}canTunnel(t){return!!E(t)}G(t,o,a,m,g,d,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${a} on local port ${m}.`);const k=a;this.n.add(k);const v=m===void 0?a:m,C={elevationRequired:g?this.isPortPrivileged(v):!1},T={remoteAddress:{host:o,port:a},localAddressPort:m,privacy:d,public:d?d!==I.Private:void 0,protocol:S},$=t.forwardPort(T,C);return $?(this.z(o,a,$),$.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),$}};e.$Vw=i,e.$Vw=i=Ke([We(0,p.$dk),We(1,R.$cj)],i)}),define(Re[114],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,y.$Ii)("IUriIdentityService")}),define(Re[184],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ww=void 0,e.$Ww=(0,y.$Ii)("editSessionIdentityService");var D;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Re[185],Te([1,0,15]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=D,e.$yN=P,e.$zN=N,e.$AN=R,e.$BN=O;function D(p){return p.scheme!==y.Schemas.file&&p.scheme!==y.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(s=>D(s.uri))?p.folders[0].uri:void 0;if(p.configuration&&D(p.configuration))return p.configuration}function N(p){return P(p)?.scheme}function R(p){return P(p)?.authority}function O(p){return P(p)!==void 0}}),define(Re[49],Te([1,0,9,22,48,24,2,3,15]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=s,e.$Ti=I,e.$Wi=b,e.$Xi=u,e.$Yi=E,e.$Zi=r,e.$1i=c,e.$4i=i,e.$9i=n,e.$0i=t,e.$_i=o,e.$aj=a,e.$bj=m,e.$Ri=(0,O.$Ii)("contextService");function s(g){const d=g;return typeof d?.id=="string"&&R.URI.isUri(d.uri)}function I(g){return typeof g?.id=="string"&&!s(g)&&!u(g)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function b(g,d){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,D.$qc)(g)}:d?e.$Ui:e.$Vi;const S=g;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(g){const d=g;return typeof d?.id=="string"&&R.URI.isUri(d.configPath)}function E(g){const d=g;if(d?.uri)return{id:d.id,uri:R.URI.revive(d.uri)};const S=g;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if(g?.id)return{id:g.id}}var f;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r(g){const d=g;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function c(g){const d=g;return!!(d&&typeof d=="object"&&R.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class l{constructor(d,S,k,v,C){this.h=d,this.j=k,this.k=v,this.l=C,this.c=P.$Oi.forUris(this.l,()=>!0),this.folders=S}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=P.$Oi.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=l;class h{constructor(d,S){this.raw=S,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,N.$jh)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=h;function i(g){return new h({uri:g,index:0,name:(0,N.$fh)(g)},{uri:g.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,y.localize)(2487,null),extensions:[e.$5i]}],e.$8i="workspace.json";function n(g,d){return N.$ah.isEqualOrParent(g,d.untitledWorkspacesHome)}function t(g){let d;return R.URI.isUri(g)?d=g:d=g.configuration,d?.scheme===p.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(g){return g.id===e.$$i}function a(g,d){return!n(g,d)&&!t(g)}function m(g){return(typeof g=="string"?(0,D.$rc)(g):(0,N.$hh)(g))===e.$6i}}),define(Re[115],Te([1,0,76,6,4,24,2,9,107,28,3,11,49,27,114,10,38,13,14]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=n,e.$Ql=t,e.$Rl=o;var i;(function(g){g.Settings="settings",g.Keybindings="keybindings",g.Snippets="snippets",g.Tasks="tasks",g.Extensions="extensions",g.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(g){const d=g;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&typeof d.isDefault=="boolean"&&typeof d.name=="string"&&R.URI.isUri(d.location)&&R.URI.isUri(d.globalStorageHome)&&R.URI.isUri(d.settingsResource)&&R.URI.isUri(d.keybindingsResource)&&R.URI.isUri(d.tasksResource)&&R.URI.isUri(d.snippetsHome)&&R.URI.isUri(d.extensionsResource))}e.$Pl=(0,I.$Ii)("IUserDataProfilesService");function t(g,d){return{id:g.id,isDefault:g.isDefault,name:g.name,shortName:g.shortName,icon:g.icon,location:R.URI.revive(g.location).with({scheme:d}),globalStorageHome:R.URI.revive(g.globalStorageHome).with({scheme:d}),settingsResource:R.URI.revive(g.settingsResource).with({scheme:d}),keybindingsResource:R.URI.revive(g.keybindingsResource).with({scheme:d}),tasksResource:R.URI.revive(g.tasksResource).with({scheme:d}),snippetsHome:R.URI.revive(g.snippetsHome).with({scheme:d}),extensionsResource:R.URI.revive(g.extensionsResource).with({scheme:d}),cacheHome:R.URI.revive(g.cacheHome).with({scheme:d}),useDefaultFlags:g.useDefaultFlags,isTransient:g.isTransient}}function o(g,d,S,k,v,C){return{id:g,name:d,location:S,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:C&&v?.useDefaultFlags?.globalState?C.globalStorageHome:(0,N.$jh)(S,"globalStorage"),settingsResource:C&&v?.useDefaultFlags?.settings?C.settingsResource:(0,N.$jh)(S,"settings.json"),keybindingsResource:C&&v?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,N.$jh)(S,"keybindings.json"),tasksResource:C&&v?.useDefaultFlags?.tasks?C.tasksResource:(0,N.$jh)(S,"tasks.json"),snippetsHome:C&&v?.useDefaultFlags?.snippets?C.snippetsHome:(0,N.$jh)(S,"snippets"),extensionsResource:C&&v?.useDefaultFlags?.extensions?C.extensionsResource:(0,N.$jh)(S,"extensions.json"),cacheHome:(0,N.$jh)(k,g),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let a=class extends P.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(d,S,k,v){super(),this.t=d,this.u=S,this.w=k,this.y=v,this.f=!0,this.h=this.B(new D.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Dc,workspaces:new E.$Dc,emptyWindows:new Map},this.profilesHome=(0,N.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(d){this.f!==d&&(this.z=void 0,this.f=d)}isEnabled(){return this.f}get C(){if(!this.z){const d=this.D(),S=[d];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,h.$hg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(o((0,N.$gh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},d))}}catch(C){this.y.error(C)}const k=new E.$Dc,v=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[T,$]of Object.entries(C.workspaces)){const w=R.URI.parse(T),M=S.find(A=>A.id===$);M&&k.set(w,M)}if(C.emptyWindows)for(const[T,$]of Object.entries(C.emptyWindows)){const w=S.find(M=>M.id===$);w&&v.set(T,w)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:k,emptyWindows:v}}return this.z}D(){const d=o("__default__profile__",(0,O.localize)(2440,null),this.t.userRoamingDataHome,this.g);return{...d,extensionsResource:this.S()??d.extensionsResource,isDefault:!0}}async createTransientProfile(d){const S="Temp",k=new RegExp(`${(0,l.$kf)(S)}\\s(\\d+)`);let v=0;for(const T of this.profiles){const $=k.exec(T.name),w=$?parseInt($[1]):0;v=w>v?w:v}const C=`${S} ${v+1}`;return this.createProfile((0,y.$wj)((0,c.$5g)()).toString(16),C,{transient:!0},d)}async createNamedProfile(d,S,k){return this.createProfile((0,y.$wj)((0,c.$5g)()).toString(16),d,S,k)}async createProfile(d,S,k,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(d,S,k);return v&&await this.setProfileForWorkspace(v,C),C}async F(d,S,k){if(!(0,h.$hg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(S);return v||(v=(async()=>{try{if(this.profiles.find(w=>w.name===S||w.id===d))throw new Error(`Profile with ${S} name already exists`);const T=o(d,S,(0,N.$jh)(this.profilesHome,d),this.g,k,this.defaultProfile);await this.u.createFolder(T.location);const $=[];return this.j.fire({profile:T,join(w){$.push(w)}}),await r.Promises.settled($),this.I([T],[],[]),T}finally{this.r.delete(S)}})(),this.r.set(S,v)),v}async updateProfile(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(v=>v.id===d.id);if(!k)throw new Error(`Profile '${d.name}' does not exist`);return k=o(k.id,S.name??k.name,k.location,this.g,{shortName:S.shortName??k.shortName,icon:S.icon===null?void 0:S.icon??k.icon,transient:S.transient??k.isTransient,useDefaultFlags:S.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(d.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(v=>v.id===d.id);if(!S)throw new Error(`Profile '${d.name}' does not exist`);const k=[];this.m.fire({profile:S,join(v){k.push(v)}});try{await Promise.allSettled(k)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(v){(0,s.$ul)(v)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(v)}}async setProfileForWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(v=>v.id===S.id);if(!k)throw new Error(`Profile '${S.name}' does not exist`);this.L(d,k)}unsetWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(d,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const d=await this.u.resolve(this.profilesHome);await Promise.all((d.children||[]).filter(S=>S.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const d=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(d.map(S=>this.removeProfile(S)))}getProfileForWorkspace(d){const S=this.G(d),k=R.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return k||((0,u.$Si)(d)?this.s.folders.get(d.uri):(0,u.$Xi)(d)?this.s.workspaces.get(d.configPath):this.s.emptyWindows.get(d.id))}G(d){return(0,u.$Si)(d)?d.uri:(0,u.$Xi)(d)?d.configPath:d.id}H(d){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,d.location)))}I(d,S,k){const v=[...this.profiles,...d],C=[],T=this.s.profiles;this.s.profiles=[];for(let $ of v){if($.isDefault||S.some(M=>$.id===M.id))continue;$=k.find(M=>$.id===M.id)??$;const w=T.find(M=>$.id===M.id);if($.isTransient)this.s.profiles.push($);else{if(w){for(const[M,A]of this.s.emptyWindows.entries())if($.id===A.id){this.L({id:M},$);break}for(const[M,A]of this.s.workspaces.entries())if($.id===A.id){this.L({id:"",configPath:M},$);break}for(const[M,A]of this.s.folders.entries())if($.id===A.id){this.L({id:"",uri:M},$);break}}C.push({location:$.location,name:$.name,shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(d,S,k)}J(d,S,k){this.h.fire({added:d,removed:S,updated:k,all:this.profiles})}L(d,S,k){if(k=S?.isTransient?!0:k,k)(0,u.$Si)(d)?(this.s.folders.delete(d.uri),S&&this.s.folders.set(d.uri,S)):(0,u.$Xi)(d)?(this.s.workspaces.delete(d.configPath),S&&this.s.workspaces.set(d.configPath,S)):(this.s.emptyWindows.delete(d.id),S&&this.s.emptyWindows.set(d.id,S));else{this.L(d,void 0,!0);const v=this.G(d);R.URI.isUri(v)?(this.C.workspaces.delete(v),S&&this.C.workspaces.set(v,S)):(this.C.emptyWindows.delete(v),S&&this.C.emptyWindows.set(v,S)),this.M()}}M(){const d={};for(const[k,v]of this.C.workspaces.entries())d[k.toString()]=v.id;const S={};for(const[k,v]of this.C.emptyWindows.entries())S[k.toString()]=v.id;this.R({workspaces:d,emptyWindows:S}),this.z=void 0}N(d){const S={},k=this.D();if(d.workspaces)for(const[C,T]of Object.entries(d.workspaces)){const $=R.URI.parse(T);S[C]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}const v={};if(d.emptyWindows)for(const[C,T]of Object.entries(d.emptyWindows)){const $=R.URI.parse(T);v[C]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}return{workspaces:S,emptyWindows:v}}O(){return[]}P(d){throw new Error("not implemented")}Q(){return{}}R(d){throw new Error("not implemented")}S(){}};e.$Sl=a,e.$Sl=a=Ke([We(0,p.$Pi),We(1,s.$dl),We(2,f.$Nl),We(3,b.$dk)],a);class m extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(d){this.a=d}Q(){return this.X}R(d){this.X=d}}e.$Tl=m}),define(Re[186],Te([1,0,10,6,4,64,14,152,3,115]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$nq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$lq=e.$kq=e.$jq=void 0,e.$mq=E,e.$oq=r,e.$qq=l,e.$jq="__$__isNewStorageMarker",e.$kq="__$__targetStorageMarker",e.$lq=(0,p.$Ii)("storageService");var I;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var b;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const i=h.get(e.$kq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends P.$Xc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new D.$re),this.c=this.B(new D.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new y.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return D.Event.filter(this.b.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}n(){this.j.value=(0,y.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:o}=n;if(t===e.$kq){switch(i){case b.APPLICATION:this.H=void 0;break;case b.PROFILE:this.F=void 0;break;case b.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,a=!1){if((0,R.$qg)(n)){this.remove(i,t,a);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,n,a)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],o=this.J(i);for(const a of Object.keys(o))o[a]===n&&t.push(a);return t}z(i,n,t,o=!1){const a=this.J(n);typeof t=="number"?a[i]!==t&&(a[i]=t,this.P(n)?.set(e.$kq,JSON.stringify(a),o)):typeof a[i]=="number"&&(delete a[i],this.P(n)?.set(e.$kq,JSON.stringify(a),o))}get D(){return this.C||(this.C=this.L(b.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(b.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(b.APPLICATION)),this.H}J(i){switch(i){case b.APPLICATION:return this.I;case b.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?E(n):Object.create(null)}isNew(i){return this.getBoolean(e.$jq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(b.APPLICATION),t=this.P(b.PROFILE),o=this.P(b.WORKSPACE);switch(i){case I.NONE:await y.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await y.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(b.APPLICATION)?.items??new Map,n=this.P(b.PROFILE)?.items??new Map,t=this.P(b.WORKSPACE)?.items??new Map;return l(i,n,t,this.Q(b.APPLICATION)??"",this.Q(b.PROFILE)??"",this.Q(b.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,s.$Ol)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const o=new Set;for(const[a,m]of i)o.add(a),n.get(a)!==m&&this.u(t,{key:a,external:!0});for(const[a]of n.items)o.has(a)||this.u(t,{key:a,external:!0})})}}e.$nq=f;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class c extends f{constructor(){super(),this.U=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(b.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(b.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(b.APPLICATION,i)))}P(i){switch(i){case b.APPLICATION:return this.U;case b.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case b.APPLICATION:return"inMemory (application)";case b.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$pq=c;async function l(h,i,n,t,o,a){const m=w=>{try{return JSON.parse(w)}catch{return w}},g=new Map,d=new Map;h.forEach((w,M)=>{g.set(M,w),d.set(M,m(w))});const S=new Map,k=new Map;i.forEach((w,M)=>{S.set(M,w),k.set(M,m(w))});const v=new Map,C=new Map;n.forEach((w,M)=>{v.set(M,w),C.set(M,m(w))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(g.forEach((w,M)=>{T.push({key:M,value:w})}),console.table(T),console.groupEnd(),console.log(d),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const w=[];S.forEach((M,A)=>{w.push({key:A,value:M})}),console.table(w),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${a})`);const $=[];v.forEach((w,M)=>{$.push({key:M,value:w})}),console.table($),console.groupEnd(),console.log(C)}}),define(Re[80],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class y{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const N=this.c++;return this.b.set(N,P),this.e(),N}get(P,N){return this.b.has(P)?this.b.get(P)[N]:void 0}delete(P){this.b.delete(P),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xqc=y}),define(Re[50],Te([1,0,15,24,28,3]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=e.$Cqc=void 0;class R{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new D.$$g(p=>{const s=this.b.get(p.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,s){s===null?this.b.delete(p.scheme):this.b.set(p.scheme,s)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Cqc=R,e.$Dqc=(0,N.$Ii)("IExtHostFileSystemInfo")}),define(Re[26],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0,e.$TQ=(0,y.$Ii)("IExtHostInitDataService")}),define(Re[187],Te([1,0,9,11,172,26]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsc=void 0;let R=class extends P.$4R{constructor(p,s,I){const b=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=I.remote.isRemote?(0,y.localize)(2704,null):p?(0,y.localize)(2705,null):(0,y.localize)(2706,null);super(s.createLogger(b,{name:u}))}};e.$Qsc=R,e.$Qsc=R=Ke([We(1,D.$ek),We(2,N.$TQ)],R)}),define(Re[188],Te([1,0,10]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=e.$irc=void 0;class D{constructor(R,O,p){this.h=new Map,this.a=R,this.b=O,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new y.$Uh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const b of s.values())b.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,O){let p=this.f[R];return typeof p>"u"&&(p=O),p}update(R,O){this.f[R]=O;const p=this.h.get(R);if(p!==void 0)return p.p;const s=new y.$6h;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$irc=D;class P extends D{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,O){super(R.identifier.value,!0,O),this.j=R}}e.$jrc=P}),define(Re[189],Te([1,0,6,2]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=void 0;class P{constructor(R){this.c=R,this.a=new y.$oe,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$oe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,O,p,s){const b=this.c.getNotebookDocument(D.URI.revive(R)).acceptModelChanged(O.value,p,s);this.b.fire(b)}$acceptDirtyStateChanged(R,O){this.c.getNotebookDocument(D.URI.revive(R)).acceptDirty(O)}$acceptModelSaved(R){const O=this.c.getNotebookDocument(D.URI.revive(R));this.a.fire(O.apiNotebook)}}e.$isc=P}),define(Re[16],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=void 0,e.$DQ=(0,y.$Ii)("IExtHostRpcService");class D{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$EQ=D}),define(Re[190],Te([1,0,18,6,4]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;class N{#e;constructor(O,p){this.disposables=new P.$Wc,this.a=y.$un.toKey(O.identifier),this.#e=p,this.onDidChange=D.Event.map(D.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,p){return this.#e.store(this.a,O,p)}delete(O){return this.#e.delete(this.a,O)}}e.$src=N}),define(Re[65],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=e.$Sqc=void 0,e.$Sqc=(0,y.$Ii)("IURITransformerService");class D{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Tqc=D});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[116],Te([1,0,9,14,2,4,3,29,28,15,42,164,36]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$DG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$tG=e.EditorInputCapabilities=e.$sG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=void 0,e.$jG=r,e.$kG=c,e.$lG=l,e.$mG=h,e.$nG=i,e.$oG=n,e.$pG=t,e.$qG=o,e.$rG=a,e.$uG=v,e.$vG=T,e.$wG=$,e.$xG=w,e.$yG=M,e.$zG=A,e.$AG=L,e.$BG=Z,e.$CG=ue,e.$EG=se,e.$FG=x,e.$GG=we,e.$HG=Ie,u=si(u),e.$eG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$fG={id:"default",displayName:(0,y.localize)(4053,null),providerDisplayName:(0,y.localize)(4054,null)},e.$gG="workbench.editor.sidebysideEditor",e.$hG="workbench.editors.textDiffEditor",e.$iG="workbench.editors.binaryResourceDiffEditor";var E;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var f;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function c(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function l(Y,q,ie){for(const ve of ie.visibleEditorPanes)if(ve.group.id===q&&Y.matches(ve.input))return ve.getViewState()}function h(Y){if(v(Y))return!1;const q=Y;return P.URI.isUri(q?.resource)}function i(Y){if(v(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function n(Y){if(v(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(v(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function o(Y){if(v(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===s.Schemas.untitled||q.forceUntitled===!0:!1}function a(Y){if(v(Y))return!1;const q=Y;return P.URI.isUri(q?.base?.resource)&&P.URI.isUri(q?.input1?.resource)&&P.URI.isUri(q?.input2?.resource)&&P.URI.isUri(q?.result?.resource)}var m;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var g;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g||(e.SaveReason=g={}));class d{constructor(){this.a=new Map}registerSource(q,ie){let ve=this.a.get(q);return ve||(ve={source:q,label:ie},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$sG=new d;var S;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class k extends N.$Xc{}e.$tG=k;function v(Y){return Y instanceof k}function C(Y){const q=Y;return P.URI.isUri(q?.preferredResource)}function T(Y){const q=Y;return v(q?.primary)&&v(q?.secondary)}function $(Y){const q=Y;return v(q?.modified)&&v(q?.original)}function w(Y,q,ie,ve,Pe){return Ie(ve,[(0,b.$sj)({id:"workbench.action.openLargeFile",label:(0,y.localize)(4055,null),run:()=>{const Fe={...ie,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,Fe)}}),(0,b.$sj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(4056,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(Y){return v(Y?.editor)}function A(Y){const q=Y;return M(Y)&&q?.group!==void 0}function L(Y){const q=Y;return typeof q?.groupId=="number"&&v(q.editor)}function Z(Y){return typeof Y?.groupId=="number"}var J;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(J||(e.EditorCloseContext=J={}));var U;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var V;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class Q{getOriginalUri(q,ie){if(!q)return;if(a(q))return e.$DG.getOriginalUri(q.result,ie);if(ie?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(q);if(Pe&&Fe){if(ie?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===V.ANY)return this.getOriginalUri(Pe,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:ie.filterByScheme});q=ie.supportSideBySide===V.PRIMARY?Pe:Fe}}if(i(q)||n(q)||t(q)||a(q))return;const ve=C(q)?q.preferredResource:q.resource;return!ve||!ie||!ie.filterByScheme?ve:this.b(ve,ie.filterByScheme)}a(q){return T(q)||t(q)?{primary:q.primary,secondary:q.secondary}:$(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,ie){if(!q)return;if(a(q))return e.$DG.getCanonicalUri(q.result,ie);if(ie?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(q);if(Pe&&Fe){if(ie?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===V.ANY)return this.getCanonicalUri(Pe,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:ie.filterByScheme});q=ie.supportSideBySide===V.PRIMARY?Pe:Fe}}if(i(q)||n(q)||t(q)||a(q))return;const ve=q.resource;return!ve||!ie||!ie.filterByScheme?ve:this.b(ve,ie.filterByScheme)}b(q,ie){if(Array.isArray(ie)){if(ie.some(ve=>q.scheme===ve))return q}else if(ie===q.scheme)return q}}var ne;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ne||(e.EditorCloseMethod=ne={}));function ue(Y,q,ie,ve){if(!Y.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return ie===ne.MOUSE||ie===ne.KEYBOARD;case"mouse":return ie===ne.MOUSE;case"keyboard":return ie===ne.KEYBOARD}return!1}e.$DG=new Q;var _;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(_||(e.CloseDirection=_={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(q){const ie=this.a=q.get(R.$Hi);for(const[ve,Pe]of this.c)this.e(ve,Pe,ie);this.c.clear()}e(q,ie,ve){const Pe=ve.createInstance(ie);this.d.set(q,Pe)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,D.$sg)(this.b)}registerEditorSerializer(q,ie){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,ie,this.a):this.c.set(q,ie),(0,N.$Vc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}O.$uo.add(e.$eG.EditorFactory,new ae);async function se(Y,q,ie){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const Pe=P.URI.revive(ve.fileUri);if(!Pe){ie.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(Pe)){ie.info("Cannot resolve the path because it cannot be handled",ve);return}let Be=ve.exists,xe=ve.type;if(typeof Be!="boolean"||typeof xe!="number")try{xe=(await q.stat(Pe)).isDirectory?p.FileType.Directory:p.FileType.Unknown,Be=!0}catch(ut){ie.error(ut),Be=!1}if(!Be&&ve.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",ve);return}if(xe===p.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",ve);return}const nt={...ve.options,pinned:!0};return Be?{resource:Pe,options:nt}:{resource:Pe,options:nt,forceUntitled:!0}}))}var ce;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function x(Y){const q=Y;if(!q)return!1;const ie=q;if(ie.modified)return x(ie.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function we(Y){return(0,I.$uj)(Y)}function Ie(Y,q,ie){const ve=(0,I.$vj)(Y,q);return ve.forceMessage=ie?.forceMessage,ve.forceSeverity=ie?.forceSeverity,ve.allowDialog=ie?.allowDialog,ve}}),define(Re[191],Te([1,0,6,9,3,4,27,29,25,98,182]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PG=e.$OG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$NG=e.ViewContentGroups=e.$LG=e.ViewContainerLocation=e.Extensions=e.$KG=e.$JG=e.$IG=void 0,e.$MG=E,e.$IG="views",e.$JG=(0,D.localize)(4216,null),e.$KG=(0,I.$Hx)("default-view-icon",s.$8j.window,(0,D.localize)(4217,null));var b;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$LG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class f extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new y.$oe),this.onDidRegister=this.c.event,this.f=this.B(new y.$oe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(a,m,g){const d=this.get(a.id);if(d)return d;const S=a;return S.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$Ac)(this.g,m,[]).push(S),g?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:m}),S}deregisterViewContainer(a){for(const m of this.g.keys()){const g=this.g.get(m),d=g?.indexOf(a);if(d!==-1){g?.splice(d,1),g.length===0&&this.g.delete(m),this.f.fire({viewContainer:a,viewContainerLocation:m});return}}}get(a){return this.all.filter(m=>m.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(g=>g?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(m=>this.getViewContainerLocation(m)===a)}}O.$uo.add(b.ViewContainersRegistry,new f);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function c(o,a){const m=o.group??r.More,g=a.group??r.More;return m!==g?m.localeCompare(g):(o.order??5)-(a.order??5)}class l extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new y.$oe),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$oe),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$oe),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$oe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Kc}registerViews(a,m){this.registerViews2([{views:a,viewContainer:m}])}registerViews2(a){a.forEach(({views:m,viewContainer:g})=>this.r(m,g)),this.c.fire(a)}deregisterViews(a,m){const g=this.s(a,m);g.length&&this.f.fire({views:g,viewContainer:m})}moveViews(a,m){for(const g of this.m.keys())if(g!==m){const d=this.s(a,g);d.length&&(this.r(d,m),this.g.fire({views:d,from:g,to:m}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const m of this.j){const g=(this.m.get(m)||[]).filter(d=>d.id===a)[0];if(g)return g}return null}getViewContainer(a){for(const m of this.j)if((this.m.get(m)||[]).filter(d=>d.id===a)[0])return m;return null}registerViewWelcomeContent(a,m){return this.n.add(a,m),this.h.fire(a),(0,N.$Vc)(()=>{this.n.delete(a,m),this.h.fire(a)})}registerViewWelcomeContent2(a,m){const g=new Map;for(const[d,S]of m)this.n.add(a,S),g.set(d,(0,N.$Vc)(()=>{this.n.delete(a,S),this.h.fire(a)}));return this.h.fire(a),g}getViewWelcomeContent(a){const m=[];return this.n.forEach(a,g=>m.push(g)),m.sort(c)}r(a,m){let g=this.m.get(m);g||(g=[],this.m.set(m,g),this.j.push(m));for(const d of a){if(this.getView(d.id)!==null)throw new Error((0,D.localize)(4218,null,d.id));g.push(d)}}s(a,m){const g=this.m.get(m);if(!g)return[];const d=[],S=[];for(const k of g)a.includes(k)?d.push(k):S.push(k);return d.length&&(S.length?this.m.set(m,S):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),d}}O.$uo.add(b.ViewsRegistry,new l),e.$NG=(0,P.$Ii)("viewDescriptorService");var h;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(a,m){this.c=!1,this.d=!1,(0,p.$ko)(this,a),this.d=!!m,this.resolve=async g=>{if(m&&!this.c){const d=await m(g);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$OG=n;class t extends Error{constructor(a){super((0,D.localize)(4219,null,a)),this.name="NoTreeViewError"}static is(a){return!!a&&a.name==="NoTreeViewError"}}e.$PG=t}),define(Re[192],Te([1,0,9,31]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=void 0,e.$TG=new D.$Zj("chatSessionResponseVote","",{type:"string",description:(0,y.localize)(4702,null)}),e.$UG=new D.$Zj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,y.localize)(4703,null)}),e.$VG=new D.$Zj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,y.localize)(4704,null)}),e.$WG=new D.$Zj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,y.localize)(4705,null)}),e.$XG=new D.$Zj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,y.localize)(4706,null)}),e.$YG=new D.$Zj("chatSessionResponseError",!1,{type:"boolean",description:(0,y.localize)(4707,null)}),e.$ZG=new D.$Zj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,y.localize)(4708,null)}),e.$1G=new D.$Zj("chatResponse",!1,{type:"boolean",description:(0,y.localize)(4709,null)}),e.$2G=new D.$Zj("chatRequest",!1,{type:"boolean",description:(0,y.localize)(4710,null)}),e.$3G=new D.$Zj("chatEditApplied",!1,{type:"boolean",description:(0,y.localize)(4711,null)}),e.$4G=new D.$Zj("chatInputHasText",!1,{type:"boolean",description:(0,y.localize)(4712,null)}),e.$5G=new D.$Zj("chatInputHasFocus",!1,{type:"boolean",description:(0,y.localize)(4713,null)}),e.$6G=new D.$Zj("inChatInput",!1,{type:"boolean",description:(0,y.localize)(4714,null)}),e.$7G=new D.$Zj("inChat",!1,{type:"boolean",description:(0,y.localize)(4715,null)}),e.$8G=new D.$Zj("chatIsEnabled",!1,{type:"boolean",description:(0,y.localize)(4716,null)}),e.$9G=new D.$Zj("chatCursorAtTop",!1),e.$0G=new D.$Zj("chatInputHasAgent",!1),e.$$G=new D.$Zj("chatLocation",void 0),e.$_G=new D.$Zj("quickChatHasFocus",!1,{type:"boolean",description:(0,y.localize)(4717,null)})}),define(Re[117],Te([1,0,283,10,19,6,40,4,33,144,13,31,18,3,11,109,176,186,192]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.ChatAgentLocation=void 0,e.$iI=m,e.$jI=g;var n;(function(d){d.Panel="panel",d.Terminal="terminal",d.Notebook="notebook",d.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(d){function S(k){switch(k){case"panel":return d.Panel;case"terminal":return d.Terminal;case"notebook":return d.Notebook;case"editor":return d.Editor}return d.Panel}d.fromRaw=S}(n||(e.ChatAgentLocation=n={})),e.$dI=(0,E.$Ii)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new N.$oe,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=h.$8G.bindTo(this.f)}registerAgent(S,k){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const C=this,T=k.slashCommands;k={...k,get slashCommands(){return T.filter(w=>!w.when||C.f.contextMatchesRules(b.$Gj.deserialize(w.when)))}};const $={data:k};return this.b.set(S,$),(0,O.$Vc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,k){const v=this.b.get(S);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return v.data.isDefault&&this.e.set(!0),v.impl=k,this.d.fire(new o(v.data,k)),(0,O.$Vc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,k){S.isDynamic=!0;const v={data:S,impl:k};return this.b.set(S.id,v),this.d.fire(new o(S,k)),(0,O.$Vc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,k){return this.g.set(S,k),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,k,v){return await this.g.get(S)?.(k,v)??[]}updateAgent(S,k){const v=this.b.get(S);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);v.data.metadata={...v.data.metadata,...k},this.d.fire(new o(v.data,v.impl))}getDefaultAgent(S){return(0,y.$hb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(S))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const k=this.b.get(S);return!k?.data.when||this.f.contextMatchesRules(b.$Gj.deserialize(k.data.when))}getAgentByFullyQualifiedId(S){const k=R.Iterable.find(this.b.values(),v=>m(v.data)===S)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new o(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(k=>k.name===S)}agentHasDupeName(S){const k=this.getAgent(S);return k?this.getAgentsByName(k.name).filter(v=>v.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(S,k,v,C,T){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return await $.impl.invoke(k,v,C,T)}async getFollowups(S,k,v,C,T){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return $.impl?.provideFollowups?$.impl.provideFollowups(k,v,C,T):[]}async getChatTitle(S,k,v){const C=this.b.get(S);if(!C?.impl)throw new Error(`No activated agent with id "${S}"`);if(C.impl?.provideChatTitle)return C.impl.provideChatTitle(k,v)}registerChatParticipantDetectionProvider(S,k){return this.i.set(S,k),(0,O.$Vc)(()=>{this.i.delete(S)})}hasChatParticipantDetectionProviders(){return this.i.size>0}async detectAgentOrCommand(S,k,v,C){const T=R.Iterable.first(this.i.values());if(!T)return;const $=this.getAgents().reduce((L,Z)=>{L.push({participant:Z.id,disambiguation:Z.disambiguation??[]});for(const J of Z.slashCommands)L.push({participant:Z.id,command:J.name,disambiguation:[]});return L},[]),w=await T.provideParticipantDetection(S,k,{...v,participants:$},C);if(!w)return;const M=this.getAgent(w.participant);if(!M)return;if(!w.command)return{agent:M};const A=M?.slashCommands.find(L=>L.name===w.command);if(A)return{agent:M,command:A}}};e.$eI=t,e.$eI=t=Ke([We(0,b.$1j)],t);class o{constructor(S,k){this.b=S,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(S,k,v,C){return this.d.invoke(S,k,v,C)}async provideFollowups(S,k,v,C){return this.d.provideFollowups?this.d.provideFollowups(S,k,v,C):[]}provideWelcomeMessage(S,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,k)}provideSampleQuestions(S,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,k)}toJSON(){return this.b}}e.$fI=o,e.$gI=(0,E.$Ii)("chatAgentNameService");let a=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,k,v,C){if(this.g=k,this.h=v,this.i=C,this.e=(0,s.$9d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const T=C.get(i.b,l.StorageScope.APPLICATION);try{this.e.set(JSON.parse(T??"{}"),void 0)}catch{C.remove(i.b,l.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,D.$Jh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,c.$eq)(S);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const v=k.restrictedChatParticipants;this.e.set(v,void 0),this.i.store(i.b,JSON.stringify(v),l.StorageScope.APPLICATION,l.StorageTarget.MACHINE)}getAgentNameRestriction(S){const k=this.l(S.name,S).get(),v=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return k&&v}l(S,k){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(T=>(0,I.$If)(T,T.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$hI=a,e.$hI=a=i=Ke([We(0,r.$wk),We(1,c.$$p),We(2,f.$dk),We(3,l.$lq)],a);function m(d){return`${d.extensionId.value}.${d.id}`}function g(d){const S="name"in d?d:{...d,name:d.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$un("")),(0,p.$fi)(S)}}),define(Re[193],Te([1,0,2,32,3]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$IH=N,e.$JH=R;function N(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof y.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(D.$Tt.isIRange)}function R(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(N)}var O;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var s;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(s||(e.ChatCopyKind=s={})),e.$KH=(0,P.$Ii)("IChatService"),e.$LH="accessibility.voice.keywordActivation"}),define(Re[194],Te([1,0,6,10,9]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dub=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new y.$oe,this.o=new y.$oe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,p,s,I){const b={command:O};if(p&&Object.keys(p).length>0&&(b.arguments=p),this.u("request",b),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(b.seq);if(E){this.f.delete(b.seq);const f={type:"response",seq:0,request_seq:b.seq,success:!1,command:O,message:(0,P.localize)(5715,null,I,O)};E(f)}},I)}return s&&this.f.set(b.seq,s),b.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,p){return O.type!=="event"||p.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,D.$Jh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const p=O,s=this.f.get(p.request_seq);s&&(this.f.delete(p.request_seq),s(p));break}}}}u(O,p){p.type=O,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((p,s)=>O.set(s,p)),await(0,D.$Jh)(500),O.forEach((p,s)=>{p({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Dub=N}),define(Re[81],Te([1,0,2,9,31,3]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$7K=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$5K=e.MemoryRangeType=e.State=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=void 0,e.$4K=p,e.$6K=I,D=qe(D),e.$RJ="workbench.view.debug",e.$SJ="workbench.debug.variablesView",e.$TJ="workbench.debug.watchExpressionsView",e.$UJ="workbench.debug.callStackView",e.$VJ="workbench.debug.loadedScriptsView",e.$WJ="workbench.debug.breakPointsView",e.$XJ="workbench.debug.disassemblyView",e.$YJ="workbench.panel.repl",e.$ZJ="workbench.panel.repl.view",e.$1J=new P.$Zj("debugType",void 0,{type:"string",description:D.localize(5716,null)}),e.$2J=new P.$Zj("debugConfigurationType",void 0,{type:"string",description:D.localize(5717,null)}),e.$3J=new P.$Zj("debugState","inactive",{type:"string",description:D.localize(5718,null)}),e.$4J="debugUx",e.$5J=new P.$Zj(e.$4J,"default",{type:"string",description:D.localize(5719,null)}),e.$6J=new P.$Zj("hasDebugged",!1,{type:"boolean",description:D.localize(5720,null)}),e.$7J=new P.$Zj("inDebugMode",!1,{type:"boolean",description:D.localize(5721,null)}),e.$8J=new P.$Zj("inDebugRepl",!1,{type:"boolean",description:D.localize(5722,null)}),e.$9J=new P.$Zj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(5723,null)}),e.$0J=new P.$Zj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(5724,null)}),e.$$J=new P.$Zj("breakpointsFocused",!0,{type:"boolean",description:D.localize(5725,null)}),e.$_J=new P.$Zj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(5726,null)}),e.$aK=new P.$Zj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(5727,null)}),e.$bK=new P.$Zj("variablesFocused",!0,{type:"boolean",description:D.localize(5728,null)}),e.$cK=new P.$Zj("expressionSelected",!1,{type:"boolean",description:D.localize(5729,null)}),e.$dK=new P.$Zj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(5730,null)}),e.$eK=new P.$Zj("callStackItemType",void 0,{type:"string",description:D.localize(5731,null)}),e.$fK=new P.$Zj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(5732,null)}),e.$gK=new P.$Zj("callStackItemStopped",!1,{type:"boolean",description:D.localize(5733,null)}),e.$hK=new P.$Zj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(5734,null)}),e.$iK=new P.$Zj("watchItemType",void 0,{type:"string",description:D.localize(5735,null)}),e.$jK=new P.$Zj("canViewMemory",void 0,{type:"boolean",description:D.localize(5736,null)}),e.$kK=new P.$Zj("breakpointItemType",void 0,{type:"string",description:D.localize(5737,null)}),e.$lK=new P.$Zj("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(5738,null)}),e.$mK=new P.$Zj("breakpointHasModes",!1,{type:"boolean",description:D.localize(5739,null)}),e.$nK=new P.$Zj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(5740,null)}),e.$oK=new P.$Zj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(5741,null)}),e.$pK=new P.$Zj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(5742,null)}),e.$qK=new P.$Zj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(5743,null)}),e.$rK=new P.$Zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(5744,null)}),e.$sK=new P.$Zj("stepBackSupported",!1,{type:"boolean",description:D.localize(5745,null)}),e.$tK=new P.$Zj("restartFrameSupported",!1,{type:"boolean",description:D.localize(5746,null)}),e.$uK=new P.$Zj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(5747,null)}),e.$vK=new P.$Zj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(5748,null)}),e.$wK=new P.$Zj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(5749,null)}),e.$xK=new P.$Zj("breakpointsExist",!1,{type:"boolean",description:D.localize(5750,null)}),e.$yK=new P.$Zj("debuggersAvailable",!1,{type:"boolean",description:D.localize(5751,null)}),e.$zK=new P.$Zj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(5752,null)}),e.$AK=new P.$Zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(5753,null)}),e.$BK=new P.$Zj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(5754,null)}),e.$CK=new P.$Zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(5755,null)}),e.$DK=new P.$Zj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(5756,null)}),e.$EK=new P.$Zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(5757,null)}),e.$FK=new P.$Zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(5758,null)}),e.$GK=new P.$Zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(5759,null)}),e.$HK=new P.$Zj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(5760,null)}),e.$IK=new P.$Zj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(5761,null)}),e.$JK=new P.$Zj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(5762,null)}),e.$KK=new P.$Zj("variableIsReadonly",!1,{type:"boolean",description:D.localize(5763,null)}),e.$LK=new P.$Zj("variableValue",!1,{type:"string",description:D.localize(5764,null)}),e.$MK=new P.$Zj("variableType",!1,{type:"string",description:D.localize(5765,null)}),e.$NK=new P.$Zj("variableInterfaces",!1,{type:"array",description:D.localize(5766,null)}),e.$OK=new P.$Zj("variableName",!1,{type:"string",description:D.localize(5767,null)}),e.$PK=new P.$Zj("variableLanguage",!1,{type:"string",description:D.localize(5768,null)}),e.$QK=new P.$Zj("variableExtensionId",!1,{type:"string",description:D.localize(5769,null)}),e.$RK=new P.$Zj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(5770,null)}),e.$SK=new P.$Zj("multiSessionRepl",!1,{type:"boolean",description:D.localize(5771,null)}),e.$TK=new P.$Zj("multiSessionDebug",!1,{type:"boolean",description:D.localize(5772,null)}),e.$UK=new P.$Zj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(5773,null)}),e.$VK=new P.$Zj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(5774,null)}),e.$WK=new P.$Zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(5775,null)}),e.$XK=new P.$Zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(5776,null)});const R=i=>D.localize(5777,null,i);e.$YK=R,e.$ZK="editor.contrib.debug",e.$1K="editor.contrib.breakpoint",e.$2K="debug",e.$3K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(5778,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function p(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$5K="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var b;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(b||(e.DataBreakpointSetType=b={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$7K=(0,N.$Ii)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var c;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(c||(e.DebugTreeItemCollapsibleState=c={}));var l;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(l||(e.IDebugVisualizationTreeItem=l={}));var h;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:y.URI.revive(n.iconPath.light),dark:y.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(h||(e.IDebugVisualization=h={}))}),define(Re[195],Te([1,0,13,2,22,25,15,32,19,17]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=void 0,e.$mI=b,e.$nI=u,e.$oI=E,e.$pI=f,e.$qI=r,e.$rI=c,e.$sI=l,e.$tI=i,e.$uI=o,e.$vI=a,e.$wI=g,e.$xI=S;const I=/{([^}]+)}/g;function b(v,C,T){return v.replace(I,function($,w){return C&&w.length>0&&w[0]!=="_"?$:T&&T.hasOwnProperty(w)?T[w]:$})}function u(v){const C={};for(const T of Object.keys(v))T.startsWith("!")||(C[T]=v[T]);return C}function E(v){return v.configuration.request==="attach"&&!f(v)&&(!v.parentSession||E(v.parentSession))}function f(v){let C=v.configuration.type;if(C)return C==="vslsShare"&&(C=v.configuration.adapterProxy.configuration.type),(0,y.$If)(C,"extensionhost")||(0,y.$If)(C,"pwa-extensionhost")?v:v.parentSession?f(v.parentSession):void 0}function r(v){return v.type&&(v.label||v.program||v.runtime)}function c(v,C,T){let $,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let A=null;for(;A=M.exec(v);){const L=A.index+1,Z=L+A[0].length;if(L<=C&&Z>=T){$=A[0],w=L;break}}if($){const L=/(\w|\p{L})+/gu;let Z=null;for(;(Z=L.exec($))&&!(Z.index+1+w+Z[0].length>=T););Z&&($=$.substring(0,L.lastIndex))}return $?{start:w,end:w+$.length-1}:{start:0,end:0}}async function l(v,C,T,$){if(v.evaluatableExpressionProvider.has(C)){const w=v.evaluatableExpressionProvider.ordered(C),M=(0,s.$Jb)(await Promise.all(w.map(async A=>{try{return await A.provideEvaluatableExpression(C,T,$??p.CancellationToken.None)}catch{return}})));if(M.length>0){let A=M[0].expression;const L=M[0].range;return A||(A=C.getLineContent(T.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:A}}}else{const w=C.getLineContent(T.lineNumber),{start:M,end:A}=c(w,T.column,T.column),L=w.substring(M-1,A);return{matchingExpression:L,range:new O.$Tt(T.lineNumber,M,T.lineNumber,M+L.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(v){return!!(v&&v.match(h))}function n(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(i(v.path))return D.URI.parse(v.path);if((0,P.$lc)(v.path))return D.URI.file(v.path)}return v.path}function t(v){if(typeof v.path=="object"){const C=D.URI.revive(v.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return v.path}function o(v,C){const T=C?n:t,$=(0,N.$ho)(v);return m($,(w,M)=>{w&&M&&(M.path=T(M))}),$}function a(v,C){const T=C?n:t,$=(0,N.$ho)(v);return m($,(w,M)=>{!w&&M&&(M.path=T(M))}),$}function m(v,C){switch(v.type){case"event":{const T=v;switch(T.event){case"output":C(!1,T.body.source);break;case"loadedSource":C(!1,T.body.source);break;case"breakpoint":C(!1,T.body.breakpoint.source);break;default:break}break}case"request":{const T=v;switch(T.command){case"setBreakpoints":C(!0,T.arguments.source);break;case"breakpointLocations":C(!0,T.arguments.source);break;case"source":C(!0,T.arguments.source);break;case"gotoTargets":C(!0,T.arguments.source);break;case"launchVSCode":T.arguments.args.forEach($=>C(!1,$));break;default:break}break}case"response":{const T=v;if(T.success&&T.body)switch(T.command){case"stackTrace":T.body.stackFrames.forEach($=>C(!1,$.source));break;case"loadedSources":T.body.sources.forEach($=>C(!1,$));break;case"scopes":T.body.scopes.forEach($=>C(!1,$.source));break;case"setFunctionBreakpoints":T.body.breakpoints.forEach($=>C(!1,$.source));break;case"setBreakpoints":T.body.breakpoints.forEach($=>C(!1,$.source));break;case"disassemble":T.body?.instructions.forEach(w=>C(!1,w.location));break;default:break}break}}}function g(v){return v.filter(C=>!C.presentation?.hidden).sort((C,T)=>C.presentation?T.presentation?C.presentation.group?T.presentation.group?C.presentation.group!==T.presentation.group?C.presentation.group.localeCompare(T.presentation.group):d(C.presentation.order,T.presentation.order):-1:T.presentation.group?1:d(C.presentation.order,T.presentation.order):-1:T.presentation?1:0)}function d(v,C){return typeof v!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:v-C}async function S(v,C){const T=v.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(T!=="none"&&(await C.saveAll(),T==="allEditorsInActiveGroup")){const $=C.activeEditorPane;$&&$.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:$.input,groupId:$.group.id})}await v.reloadConfiguration()}const k=(v,C)=>!v||!C?v===C:v.name===C.name&&v.path===C.path&&v.sourceReference===C.sourceReference;e.$yI=k}),define(Re[196],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cL=e.CellExecutionUpdateType=void 0;var D;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$cL=(0,y.$Ii)("INotebookExecutionService")}),define(Re[197],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.$fL=e.ProxyKernelState=e.$eL=void 0,e.$eL=100;var D;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$fL=(0,y.$Ii)("INotebookKernelService"),e.$gL=(0,y.$Ii)("INotebookKernelHistoryService")}),define(Re[198],Te([1,0,4,32,52,162,103]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t2b=void 0;class O extends y.$Xc{constructor(s,I,b){super(),this._source=s,this.b=I,this.c=b,this.a=void 0}f(s){const I=s.getLineCount();return new D.$Tt(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new N.$GD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:b,disposable:u}=I.create(P.DefaultEndOfLine.LF);this.b=b,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new N.$GD;I.acceptChunk(s);const b=I.finish(!0),{textBuffer:u,disposable:E}=b.create(P.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(s){const b=new R.$uD(s,!1,!1,null).parseSearchRequest();if(!b)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,b,!0,5e3)}findInOutputs(s){const b=new R.$uD(s,!1,!1,null).parseSearchRequest();return b?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),b,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$t2b=O}),define(Re[54],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(N){N.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var D;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class P{static fromExtHostTestItem(R,O,p=R.parent){if(R._isRoot)return new P([O]);const s=[R.id];for(let I=p;I&&I.id!==O;I=I.parent)s.push(I.id);return s.push(O),new P(s.reverse())}static isRoot(R){return!R.includes(y.Delimiter)}static root(R){const O=R.indexOf(y.Delimiter);return O===-1?R:R.slice(0,O)}static fromString(R){return new P(R.split(y.Delimiter))}static join(R,O){return new P([...R.path,O])}static joinToString(R,O){return R.toString()+y.Delimiter+O}static parentId(R){const O=R.lastIndexOf(y.Delimiter);return O===-1?void 0:R.slice(0,O)}static localId(R){const O=R.lastIndexOf(y.Delimiter);return O===-1?R:R.slice(O+y.Delimiter.length)}static isChild(R,O){return O[R.length]===y.Delimiter&&O.startsWith(R)}static compare(R,O){return R===O?D.IsSame:P.isChild(R,O)?D.IsChild:P.isChild(O,R)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(R,O){if(R===0)return 0;let p=0;for(;p<R-1;){for(let s=1;s<R;s++){const I=O(s-1),b=O(s);if(I.path[p]!==b.path[p])return p}p++}return p}constructor(R,O=R.length){if(this.path=R,this.d=O,R.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let O=0;O<R.d&&O<this.d;O++)if(R.path[O]!==this.path[O])return D.Disconnected;return R.d>this.d?D.IsChild:R.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=y.Delimiter,this.c+=this.path[R]}return this.c}}e.$lJ=P}),define(Re[55],Te([1,0,2,102,32,54]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$tJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$sJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$rJ=e.$qJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$pJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$oJ=e.$nJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$mJ=e.TestResultState=void 0;var R;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$mJ={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var O;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var p;(function(V){V[V.Refresh=2]="Refresh",V[V.CodeRelatedToTest=4]="CodeRelatedToTest",V[V.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var s;(function(V){V[V.Run=2]="Run",V[V.Debug=4]="Debug",V[V.Coverage=8]="Coverage",V[V.HasNonDefaultProfile=16]="HasNonDefaultProfile",V[V.HasConfigurable=32]="HasConfigurable",V[V.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$nJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=V=>"runId"in V;e.$oJ=I;var b;(function(V){V.serialize=Q=>({range:Q.range.toJSON(),uri:Q.uri.toJSON()}),V.deserialize=(Q,ne)=>({range:P.$Tt.lift(ne.range),uri:Q.asCanonicalUri(y.URI.revive(ne.uri))})})(b||(e.IRichLocation=b={}));var u;(function(V){V[V.Error=0]="Error",V[V.Output=1]="Output"})(u||(e.TestMessageType=u={}));var E;(function(V){V.serialize=Q=>({label:Q.label,uri:Q.uri?.toJSON(),position:Q.position?.toJSON()}),V.deserialize=(Q,ne)=>({label:ne.label,uri:ne.uri?Q.asCanonicalUri(y.URI.revive(ne.uri)):void 0,position:ne.position?D.$St.lift(ne.position):void 0})})(E||(e.ITestMessageStackFrame=E={}));var f;(function(V){V.serialize=Q=>({message:Q.message,type:u.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&b.serialize(Q.location),stackTrace:Q.stackTrace?.map(E.serialize)}),V.deserialize=(Q,ne)=>({message:ne.message,type:u.Error,expected:ne.expected,actual:ne.actual,contextValue:ne.contextValue,location:ne.location&&b.deserialize(Q,ne.location),stackTrace:ne.stackTrace&&ne.stackTrace.map(ue=>E.deserialize(Q,ue))})})(f||(e.ITestErrorMessage=f={}));const r=(V,Q)=>`${Q?"s":"e"}${V}`;e.$pJ=r;var c;(function(V){V.serialize=Q=>({message:Q.message,type:u.Output,offset:Q.offset,length:Q.length,location:Q.location&&b.serialize(Q.location)}),V.deserialize=(Q,ne)=>({message:ne.message,type:u.Output,offset:ne.offset,length:ne.length,location:ne.location&&b.deserialize(Q,ne.location)})})(c||(e.ITestOutputMessage=c={}));var l;(function(V){V.serialize=Q=>Q.type===u.Error?f.serialize(Q):c.serialize(Q),V.deserialize=(Q,ne)=>ne.type===u.Error?f.deserialize(Q,ne):c.deserialize(Q,ne),V.isDiffable=Q=>Q.type===u.Error&&Q.actual!==void 0&&Q.expected!==void 0})(l||(e.ITestMessage=l={}));var h;(function(V){V.serializeWithoutMessages=Q=>({state:Q.state,duration:Q.duration,messages:[]}),V.serialize=Q=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(l.serialize)}),V.deserialize=(Q,ne)=>({state:ne.state,duration:ne.duration,messages:ne.messages.map(ue=>l.deserialize(Q,ue))})})(h||(e.ITestTaskState=h={}));const i="\0",n=(V,Q)=>V+i+Q;e.$qJ=n;const t=V=>{const Q=V.indexOf(i);return{ctrlId:V.slice(0,Q),tagId:V.slice(Q+1)}};e.$rJ=t;var o;(function(V){V.serialize=Q=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?.toJSON(),range:Q.range?.toJSON()||null,description:Q.description,error:Q.error,sortText:Q.sortText}),V.deserialize=(Q,ne)=>({extId:ne.extId,label:ne.label,tags:ne.tags,busy:ne.busy,children:void 0,uri:ne.uri?Q.asCanonicalUri(y.URI.revive(ne.uri)):void 0,range:ne.range?P.$Tt.lift(ne.range):null,description:ne.description,error:ne.error,sortText:ne.sortText})})(o||(e.ITestItem=o={}));var a;(function(V){V[V.NotExpandable=0]="NotExpandable",V[V.Expandable=1]="Expandable",V[V.BusyExpanding=2]="BusyExpanding",V[V.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var m;(function(V){V.serialize=Q=>({expand:Q.expand,item:o.serialize(Q.item)}),V.deserialize=(Q,ne)=>({controllerId:N.$lJ.root(ne.item.extId),expand:ne.expand,item:o.deserialize(Q,ne.item)})})(m||(e.InternalTestItem=m={}));var g;(function(V){V.serialize=Q=>{let ne;return Q.item&&(ne={},Q.item.label!==void 0&&(ne.label=Q.item.label),Q.item.tags!==void 0&&(ne.tags=Q.item.tags),Q.item.busy!==void 0&&(ne.busy=Q.item.busy),Q.item.uri!==void 0&&(ne.uri=Q.item.uri?.toJSON()),Q.item.range!==void 0&&(ne.range=Q.item.range?.toJSON()),Q.item.description!==void 0&&(ne.description=Q.item.description),Q.item.error!==void 0&&(ne.error=Q.item.error),Q.item.sortText!==void 0&&(ne.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ne}},V.deserialize=Q=>{let ne;return Q.item&&(ne={},Q.item.label!==void 0&&(ne.label=Q.item.label),Q.item.tags!==void 0&&(ne.tags=Q.item.tags),Q.item.busy!==void 0&&(ne.busy=Q.item.busy),Q.item.range!==void 0&&(ne.range=Q.item.range?P.$Tt.lift(Q.item.range):null),Q.item.description!==void 0&&(ne.description=Q.item.description),Q.item.error!==void 0&&(ne.error=Q.item.error),Q.item.sortText!==void 0&&(ne.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ne}}})(g||(e.ITestItemUpdate=g={}));const d=(V,Q)=>{Q.expand!==void 0&&(V.expand=Q.expand),Q.item!==void 0&&(V.item=V.item?Object.assign(V.item,Q.item):Q.item)};e.$sJ=d;var S;(function(V){V.serializeWithoutMessages=Q=>({...m.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(h.serializeWithoutMessages)}),V.serialize=Q=>({...m.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(h.serialize)}),V.deserialize=(Q,ne)=>({...m.deserialize(Q,ne),ownComputedState:ne.ownComputedState,computedState:ne.computedState,tasks:ne.tasks.map(ue=>h.deserialize(Q,ue)),retired:!0})})(S||(e.TestResultItem=S={}));var k;(function(V){V.empty=()=>({covered:0,total:0}),V.sum=(Q,ne)=>{Q.covered+=ne.covered,Q.total+=ne.total}})(k||(e.ICoverageCount=k={}));var v;(function(V){V.serialize=Q=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:Q.uri.toJSON()}),V.deserialize=(Q,ne)=>({id:ne.id,statement:ne.statement,branch:ne.branch,declaration:ne.declaration,testIds:ne.testIds,uri:Q.asCanonicalUri(y.URI.revive(ne.uri))}),V.empty=(Q,ne)=>({id:Q,uri:ne,statement:k.empty()})})(v||(e.IFileCoverage=v={}));function C(V){return{...V,location:V.location?.toJSON()}}function T(V){return V.location=V.location?D.$St.isIPosition(V.location)?D.$St.lift(V.location):P.$Tt.lift(V.location):void 0,V}e.$tJ=3;var $;(function(V){V[V.Declaration=0]="Declaration",V[V.Statement=1]="Statement",V[V.Branch=2]="Branch"})($||(e.DetailType=$={}));var w;(function(V){V.serialize=Q=>Q.type===$.Declaration?A.serialize(Q):L.serialize(Q),V.deserialize=Q=>Q.type===$.Declaration?A.deserialize(Q):L.deserialize(Q)})(w||(e.CoverageDetails=w={}));var M;(function(V){V.serialize=C,V.deserialize=T})(M||(e.IBranchCoverage=M={}));var A;(function(V){V.serialize=C,V.deserialize=T})(A||(e.IDeclarationCoverage=A={}));var L;(function(V){V.serialize=Q=>({...C(Q),branches:Q.branches?.map(M.serialize)}),V.deserialize=Q=>({...T(Q),branches:Q.branches?.map(M.deserialize)})})(L||(e.IStatementCoverage=L={}));var Z;(function(V){V[V.Add=0]="Add",V[V.Update=1]="Update",V[V.DocumentSynced=2]="DocumentSynced",V[V.Remove=3]="Remove",V[V.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",V[V.Retire=5]="Retire",V[V.AddTag=6]="AddTag",V[V.RemoveTag=7]="RemoveTag"})(Z||(e.TestDiffOpType=Z={}));var J;(function(V){V.deserialize=(Q,ne)=>ne.op===Z.Add?{op:ne.op,item:m.deserialize(Q,ne.item)}:ne.op===Z.Update?{op:ne.op,item:g.deserialize(ne.item)}:ne.op===Z.DocumentSynced?{op:ne.op,uri:Q.asCanonicalUri(y.URI.revive(ne.uri)),docv:ne.docv}:ne,V.serialize=Q=>Q.op===Z.Add?{op:Q.op,item:m.serialize(Q.item)}:Q.op===Z.Update?{op:Q.op,item:g.serialize(Q.item)}:Q})(J||(e.TestsDiffOp=J={}));class U{constructor(Q){this.l=Q,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(Q){const ne=this.x();for(const ue of Q)switch(ue.op){case Z.Add:this.p(m.deserialize(this.l,ue.item),ne);break;case Z.Update:this.q(g.deserialize(ue.item),ne);break;case Z.Remove:this.v(ue.itemId,ne);break;case Z.Retire:this.w(ue.itemId);break;case Z.IncrementPendingExtHosts:this.updatePendingRoots(ue.amount);break;case Z.AddTag:this.f.set(ue.tag.id,ue.tag);break;case Z.RemoveTag:this.f.delete(ue.id);break}ne.complete?.()}p(Q,ne){const ue=N.$lJ.parentId(Q.item.extId)?.toString();let _;if(!ue)_=this.y(Q),this.h.add(_),this.g.set(Q.item.extId,_);else if(this.g.has(ue)){const ae=this.g.get(ue);ae.children.add(Q.item.extId),_=this.y(Q,ae),this.g.set(Q.item.extId,_)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(Q)}`);return}return ne.add?.(_),Q.expand===a.BusyExpanding&&this.j++,_}q(Q,ne){const ue=this.g.get(Q.extId);if(ue)return Q.expand!==void 0&&(ue.expand===a.BusyExpanding&&this.j--,Q.expand===a.BusyExpanding&&this.j++),(0,e.$sJ)(ue,Q),ne.update?.(ue),ue}v(Q,ne){const ue=this.g.get(Q);if(!ue)return;const _=N.$lJ.parentId(ue.item.extId)?.toString();_?this.g.get(_).children.delete(ue.item.extId):this.h.delete(ue);const ae=[[Q]];for(;ae.length;)for(const se of ae.pop()){const ce=this.g.get(se);ce&&(ae.push(ce.children),this.g.delete(se),ne.remove?.(ce,ce!==ue),ce.expand===a.BusyExpanding&&this.j--)}}w(Q){}updatePendingRoots(Q){this.k+=Q}x(){return{}}}e.$uJ=U}),define(Re[199],Te([1,0,99,9,55]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$lHb=e.$kHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var N;(function(b){b.ViewletId="workbench.view.extension.test",b.ExplorerViewId="workbench.view.testing",b.OutputPeekContributionId="editor.contrib.testingOutputPeek",b.DecorationsContributionId="editor.contrib.testingDecorations",b.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",b.CoverageViewId="workbench.view.testCoverage",b.ResultsPanelId="workbench.panel.testResults",b.ResultsViewId="workbench.panel.testResults.view",b.MessageLanguageId="vscodeInternalTestMessage"})(N||(e.Testing=N={}));var R;(function(b){b.List="list",b.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var O;(function(b){b.ByLocation="location",b.ByStatus="status",b.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const p={[P.TestResultState.Errored]:(0,D.localize)(10838,null),[P.TestResultState.Failed]:(0,D.localize)(10839,null),[P.TestResultState.Passed]:(0,D.localize)(10840,null),[P.TestResultState.Queued]:(0,D.localize)(10841,null),[P.TestResultState.Running]:(0,D.localize)(10842,null),[P.TestResultState.Skipped]:(0,D.localize)(10843,null),[P.TestResultState.Unset]:(0,D.localize)(10844,null)},s=(b,u)=>(0,D.localize)(10845,null,(0,y.$3k)(b),p[u]);e.$kHb=s,e.$lHb={[P.TestRunProfileBitset.Debug]:(0,D.localize)(10846,null),[P.TestRunProfileBitset.Run]:(0,D.localize)(10847,null),[P.TestRunProfileBitset.Coverage]:(0,D.localize)(10848,null)};var I;(function(b){b.CancelTestRefreshAction="testing.cancelTestRefresh",b.CancelTestRunAction="testing.cancelRun",b.ClearTestResultsAction="testing.clearTestResults",b.CollapseAllAction="testing.collapseAll",b.ConfigureTestProfilesAction="testing.configureProfile",b.ContinousRunUsingForTest="testing.continuousRunUsingForTest",b.CoverageAtCursor="testing.coverageAtCursor",b.CoverageByUri="testing.coverage.uri",b.CoverageClear="testing.coverage.close",b.CoverageCurrentFile="testing.coverageCurrentFile",b.CoverageFilterToTest="testing.coverageFilterToTest",b.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",b.CoverageLastRun="testing.coverageLastRun",b.CoverageSelectedAction="testing.coverageSelected",b.CoverageToggleToolbar="testing.coverageToggleToolbar",b.CoverageViewChangeSorting="testing.coverageViewChangeSorting",b.DebugAction="testing.debug",b.DebugAllAction="testing.debugAll",b.DebugAtCursor="testing.debugAtCursor",b.DebugByUri="testing.debug.uri",b.DebugCurrentFile="testing.debugCurrentFile",b.DebugFailedTests="testing.debugFailTests",b.DebugLastRun="testing.debugLastRun",b.DebugSelectedAction="testing.debugSelected",b.FilterAction="workbench.actions.treeView.testExplorer.filter",b.GetExplorerSelection="_testing.getExplorerSelection",b.GetSelectedProfiles="testing.getSelectedProfiles",b.GoToTest="testing.editFocusedTest",b.GoToRelatedTest="testing.goToRelatedTest",b.PeekRelatedTest="testing.peekRelatedTest",b.GoToRelatedCode="testing.goToRelatedCode",b.PeekRelatedCode="testing.peekRelatedCode",b.HideTestAction="testing.hideTest",b.OpenCoverage="testing.openCoverage",b.OpenOutputPeek="testing.openOutputPeek",b.RefreshTestsAction="testing.refreshTests",b.ReRunFailedTests="testing.reRunFailTests",b.ReRunLastRun="testing.reRunLastRun",b.RunAction="testing.run",b.RunAllAction="testing.runAll",b.RunAllWithCoverageAction="testing.coverageAll",b.RunAtCursor="testing.runAtCursor",b.RunByUri="testing.run.uri",b.RunCurrentFile="testing.runCurrentFile",b.RunSelectedAction="testing.runSelected",b.RunUsingProfileAction="testing.runUsing",b.RunWithCoverageAction="testing.coverage",b.SearchForTestExtension="testing.searchForTestExtension",b.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",b.ShowMostRecentOutputAction="testing.showMostRecentOutput",b.StartContinousRun="testing.startContinuousRun",b.StopContinousRun="testing.stopContinuousRun",b.TestingSortByDurationAction="testing.sortByDuration",b.TestingSortByLocationAction="testing.sortByLocation",b.TestingSortByStatusAction="testing.sortByStatus",b.TestingViewAsListAction="testing.viewAsList",b.TestingViewAsTreeAction="testing.viewAsTree",b.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",b.ToggleInlineTestOutput="testing.toggleInlineTestOutput",b.UnhideAllTestsAction="testing.unhideAllTests",b.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[82],Te([1,0,10,6,4,61,55,54]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const s=(h,i)=>h===i,b=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(h,i)=>!(h.length!==i.length||h.some(n=>!i.includes(n)))}),u=(h,i)=>{let n;for(const[t,o]of b)o(h[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class E extends P.$Xc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new y.$Uh(()=>this.flushDiff(),200)),this.g=this.B(new D.$oe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===R.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===R.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,R.$sJ)(n.item,i.item);return}if(n.op===R.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,R.$sJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===R.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,n-1):o.wait().then(()=>this.L(t,n-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case p.RemoveChild:this.O(O.$lJ.joinToString(i.fullId,n.id));break;case p.Upsert:this.z(n.item,i);break;case p.Bulk:for(const t of n.ops)this.w(i,t);break;case p.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,N.$hd)(n)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=O.$lJ.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.s.getChildren(o.parent).delete(i.id);let a=this.tree.get(t.toString());if(!a){a={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(a.fullId.toString(),a),this.G(i,n),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(i)}}),this.I(i,a,n);return}if(a.actual===i){this.H(i,a,n);return}if(a.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const m=this.s.getChildren(a.actual),g=a.actual,d=u(this.s.toITestItem(g),this.s.toITestItem(i));this.s.getApiFor(g).listener=void 0,a.actual=i,a.resolveBarrier=void 0,a.expand=R.TestItemExpandState.NotExpandable,d&&(d.hasOwnProperty("tags")&&(this.C(i.tags,g.tags,t.toString()),delete d.tags),this.w(a,{op:p.SetProp,update:d})),this.I(i,a,n);for(const[k,v]of m)this.s.getChildren(i).get(v.id)||this.O(O.$lJ.joinToString(t,v.id));const S=a.expandLevels;S!==void 0&&queueMicrotask(()=>{a.expand===R.TestItemExpandState.Expandable&&(a.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(a.actual.uri)}C(i,n,t){const o=new Set(n.map(a=>a.id));for(const a of i)o.delete(a.id)||this.D(a);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(a=>(0,R.$qJ)(this.s.controllerId,a.id))}}}),o.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$qJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$qJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=a=>this.w(n,a),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[o,a]of this.s.getChildren(i))this.z(a,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:n=R.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[o,a]of this.s.getChildren(i.actual)){const m=this.expand(O.$lJ.joinToString(i.fullId,a.id),n);(0,y.$uh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const a=new y.$Hh;return a.open(),a}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new y.$Hh,t=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(a){t(a)}return(0,y.$uh)(o)?o.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const a of o.actual.tags)this.F(a.id);this.tree.delete(o.fullId.toString());for(const[a,m]of this.s.getChildren(o.actual))t.push(this.tree.get(O.$lJ.joinToString(o.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$tQ=E;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$uQ=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vQ=r;class c extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$wQ=c;const l=(h,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,a){for(const m of t.values())o.call(a,m,this)},[Symbol.iterator](){return t.entries()},replace(o){const a=new Map,m=new Set(t.keys()),g={op:p.Bulk,ops:[]};for(const d of o){if(!(d instanceof n))throw new r(d.id);const S=i(d).controllerId;if(S!==h.controllerId)throw new c(d.id,S,h.controllerId);if(a.has(d.id))throw new f(d.id);a.set(d.id,d),m.delete(d.id),g.ops.push({op:p.Upsert,item:d})}for(const d of m.keys())g.ops.push({op:p.RemoveChild,id:d});h.listener?.(g),t=a},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),h.listener?.({op:p.Upsert,item:o})},delete(o){t.delete(o)&&h.listener?.({op:p.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$xQ=l}),define(Re[118],Te([1,0,82]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0;const D=new WeakMap,P=(R,O)=>{const p={controllerId:O};return D.set(R,p),p};e.$yQ=P;const N=R=>{const O=D.get(R);if(!O)throw new y.$vQ(R?.id||"<unknown>");return O};e.$zQ=N}),define(Re[83],Te([1,0,30,15,2]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dEb=e.$cEb=e.$bEb=void 0,e.$eEb=N,e.$fEb=O,e.$bEb="vscode-cdn.net",e.$cEb=`vscode-resource.${e.$bEb}`,e.$dEb=`'self' https://*.${e.$bEb}`;function N(p,s){return p.scheme===D.Schemas.http||p.scheme===D.Schemas.https?p:(s&&s.authority&&s.isRemote&&p.scheme===D.Schemas.file&&(p=P.URI.from({scheme:D.Schemas.vscodeRemote,authority:s.authority,path:p.path})),P.URI.from({scheme:D.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.$cEb}`,path:p.path,fragment:p.fragment,query:p.query}))}function R(p){return p.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=y.CharCode.a&&I<=y.CharCode.z||I>=y.CharCode.A&&I<=y.CharCode.Z||I>=y.CharCode.Digit0&&I<=y.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function O(p){return p.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[200],Te([1,0,6,4,83]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class N{constructor(O,p,s){this.d=O,this.e=p,this.f=s,this.a=0,this.b=new D.$Wc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const b of this.c.values())I.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,p,s,I,b){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,f=this.a++,r=new y.$oe,c=new y.$oe,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$eEb)(i,E.f)}get cspSource(){return P.$dEb}set options(i){this.b=i,E.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return E.d.$postMessage(f,i)}},h=new class{constructor(){this.editor=O,this.line=p,this.height=s,this.webview=l,this.onDidDispose=c.event}dispose(){E.c.has(f)&&(E.c.delete(f),E.d.$disposeEditorInset(f),c.fire(),c.dispose(),r.dispose())}};return this.d.$createEditorInset(f,u.id,u.value.document.uri,p+1,s,I||{},b.identifier,b.extensionLocation),this.c.set(f,{editor:O,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(O){const p=this.c.get(O);p&&p.inset.dispose()}$onDidReceiveMessage(O,p){this.c.get(O)?.onDidReceiveMessage.fire(p)}}e.$Qqc=N}),define(Re[119],Te([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.$4M=void 0,e.$4M="__",e.$5M=(0,y.$Ii)("IAuthenticationService"),e.$6M=(0,y.$Ii)("IAuthenticationExtensionsService")}),define(Re[201],Te([1,0,3,12]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=e.VariableKind=e.$rR=void 0,e.$rR=(0,y.$Ii)("configurationResolverService");var P;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class N extends D.$db{constructor(O,p){super(p),this.variable=O}}e.$sR=N}),define(Re[202],Te([1,0,22,79,14,25,23,100,9,201,13]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0,y=qe(y),D=qe(D),P=qe(P),N=qe(N);class b{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,f,r,c){this.h=new Map,this.a=E,this.b=f,this.g=r,c&&(this.c=c.then(l=>this.i(l)))}i(E){if(R.$j){const f=Object.create(null);return Object.keys(E).forEach(r=>{f[r.toLowerCase()]=E[r]}),f}return E}resolveWithEnvironment(E,f,r){return this.l({env:this.i(E),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(E,f){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,f)}async j(E,f,r,c){const l=N.$ho(f);R.$j&&l.windows?Object.keys(l.windows).forEach(i=>l[i]=l.windows[i]):R.$k&&l.osx?Object.keys(l.osx).forEach(i=>l[i]=l.osx[i]):R.$l&&l.linux&&Object.keys(l.linux).forEach(i=>l[i]=l.linux[i]),delete l.windows,delete l.osx,delete l.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,l,r,c)}async resolveAnyAsync(E,f,r){return this.j(E,f,r)}async resolveAnyMap(E,f,r){const c=new Map;return{newConfig:await this.j(E,f,r,c),resolvedVariables:c}}resolveWithInteractionReplace(E,f,r,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,f,r,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,f){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,f)}async l(E,f,r,c,l){if(P.$hg(r))return this.m(E,f,r,c,l);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(E,f,h,c,l)));if(P.$jg(r)){const h=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(E,f,n,c,l),await this.l(E,f,r[n],c,l)]));for(const[n,t]of i)h[n]=t;return h}return r}m(E,f,r,c,l){return(0,I.$Af)(r,b.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(b.VARIABLE_LHS))return h;let n=await this.o(E,h,i,f,c);return l?.set(i,n),n!==h&&P.$hg(n)&&n.match(b.VARIABLE_REGEXP)&&(n=await this.m(E,f,n,c,l)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,f,r,c,l){let h;const i=r.split(":");i.length>1&&(r=i[0],h=i[1]);const n=a=>{const m=this.a.getFilePath();if(m)return(0,O.$7w)(m);throw new s.$sR(a,(0,p.localize)(12146,null,f))},t=a=>{const m=n(a);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,O.$7w)(g)}throw new s.$sR(a,(0,p.localize)(12147,null,f,y.$qc(m)))},o=a=>{if(h){const m=this.a.getFolderUri(h);if(m)return m;throw new s.$sR(a,(0,p.localize)(12148,null,f,h))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new s.$sR(a,(0,p.localize)(12149,null,f)):new s.$sR(a,(0,p.localize)(12150,null,f))};switch(r){case"env":if(h){if(E.env){const a=E.env[R.$j?h.toLowerCase():h];if(P.$hg(a))return a}return""}throw new s.$sR(s.VariableKind.Env,(0,p.localize)(12151,null,f));case"config":if(h){const a=this.a.getConfigurationValue(c,h);if(P.$qg(a))throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12152,null,f,h));if(P.$jg(a))throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12153,null,f,h));return a}throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12154,null,f));case"command":return this.p(s.VariableKind.Command,f,h,l,"command");case"input":return this.p(s.VariableKind.Input,f,h,l,"input");case"extensionInstallFolder":if(h){const a=await this.a.getExtension(h);if(!a)throw new s.$sR(s.VariableKind.ExtensionInstallFolder,(0,p.localize)(12155,null,f,h));return this.n(a.extensionLocation)}throw new s.$sR(s.VariableKind.ExtensionInstallFolder,(0,p.localize)(12156,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,O.$7w)(this.n(o(s.VariableKind.WorkspaceFolder)));case"cwd":return c||h?(0,O.$7w)(this.n(o(s.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$7w)(y.$qc(this.n(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new s.$sR(s.VariableKind.UserHome,(0,p.localize)(12157,null,f))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new s.$sR(s.VariableKind.LineNumber,(0,p.localize)(12158,null,f))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new s.$sR(s.VariableKind.SelectedText,(0,p.localize)(12159,null,f))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$qc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||h?y.$oc(this.n(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const a=y.$pc(n(s.VariableKind.RelativeFileDirname));if(c||h){const m=y.$oc(this.n(o(s.VariableKind.RelativeFileDirname)),a);return m.length===0?".":m}return a}case"fileDirname":return y.$pc(n(s.VariableKind.FileDirname));case"fileExtname":return y.$rc(n(s.VariableKind.FileExtname));case"fileBasename":return y.$qc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=y.$qc(n(s.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-y.$rc(a).length)}case"fileDirnameBasename":return y.$qc(y.$pc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||f}case"execInstallFolder":{const a=this.a.getAppRoot();return a||f}case"pathSeparator":case"/":return y.sep;default:try{const a=h?`${r}:${h}`:r;return this.p(s.VariableKind.Unknown,f,a,l,void 0)}catch{return f}}}}p(E,f,r,c,l){if(r&&c){const h=l===void 0?c[r]:c[l+":"+r];if(typeof h=="string")return h;throw new s.$sR(E,(0,p.localize)(12160,null,f))}return f}}e.$HR=b}),define(Re[120],Te([1,0,3,116]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$IE=void 0,e.$JE=s,e.$KE=u,e.$LE=E,e.$IE=(0,y.$Ii)("editorGroupsService");var P;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var p;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function s(f){const r=f;return(0,D.$uG)(r?.editor)&&(0,D.$uG)(r?.replacement)}var I;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var b;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(b||(e.OpenEditorContext=b={}));function u(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Re[203],Te([1,0,3,120]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=e.$OE=e.$NE=e.$ME=void 0,e.$QE=P,e.$ME=(0,y.$Ii)("editorService"),e.$NE=-1,e.$OE=-2,e.$PE=-3;function P(N){const R=N;return typeof N=="number"||(0,D.$KE)(R)}}),define(Re[204],Te([1,0,3,107]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0,e.$lN=(0,y.$Ji)(D.$Pi)}),define(Re[121],Te([1,0,18,6,22,4,10]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=e.$Pec=e.$Oec=e.$Nec=void 0,P=qe(P);class O{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$Nec=O;class p{static isHostExtension(h,i,n){if(i.getExtensionDescription(h))return!1;const t=n.getExtensionDescription(h);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(h,i){this.j=h,this.c=new D.$oe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new y.$wn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=c(this.e,i),this.e=this.e.concat(h);const n=p.l(this.e);return this.e=c(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,n)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,g){this.addNode(m),this.addNode(g),this.c.has(m)?this.c.get(m).push(g):this.c.set(m,[g])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,g){const d=i.getArcs(m);for(let S=0;S<d.length;S++)if(!g.has(d[S]))return!1;return!0}getNodes(){return this.e}},n=new y.$wn;for(const m of h)if(n.set(m.identifier,m),m.extensionDependencies)for(const g of m.extensionDependencies)i.addArc(y.$un.toKey(m.identifier),y.$un.toKey(g));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const o=i.getNodes().filter(m=>!t.has(m));let a;do{a=!1;for(let m=0;m<o.length;m++){const g=o[m];i.hasOnlyGoodArcs(g,t)&&(o.splice(m,1),m--,t.add(g),a=!0)}}while(a);return o.map(m=>n.get(m))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Oec=p;class s{constructor(h,i){this.versionId=h,this.extensions=i}}e.$Pec=s;class I{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new b(this,i)}deltaExtensions(h,i,n){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$Qec=I;class b extends N.$Xc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Rec=b;class u{constructor(h){this.name=h;const i=(0,R.$Bh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};h.resolve((0,N.$Vc)(t))}}var f;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(f||(f={}));function r(l,h){const i=l.isBuiltin?f.Builtin:l.isUnderDevelopment?f.Dev:f.User,n=h.isBuiltin?f.Builtin:h.isUnderDevelopment?f.Dev:f.User;if(i!==n)return i-n;const t=P.$jc.basename(l.extensionLocation.path),o=P.$jc.basename(h.extensionLocation.path);return t<o?-1:t>o?1:0}function c(l,h){const i=new y.$vn(h);return l.filter(n=>!i.has(n.identifier))}}),define(Re[84],Te([1,0,20]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$En=R,e.$Fn=O;var D;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(D||(e.UIKind=D={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var N;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(s){const I=y.$Qe.alloc(1);switch(s){case N.Initialized:I.writeUInt8(1,0);break;case N.Ready:I.writeUInt8(2,0);break;case N.Terminate:I.writeUInt8(3,0);break}return I}function O(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===N.Initialized;case 2:return I===N.Ready;case 3:return I===N.Terminate;default:return!1}}var p;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Re[66],Te([1,0,3,6,113,11,26,84,62,63,25,2,4,9]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$VQ=e.$UQ=void 0,e.$WQ=c;let f=class extends u.$Xc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new D.$oe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$oe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=b.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Fp,name:(0,E.localize)(2711,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,N.$fk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===N.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),a=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...a,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(h,i,n){this.f=h,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$ln)((0,s.$Lp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const o=n.filter(a=>!a.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const t=this.r.get(h.value)?.filter(a=>!a.isDisposed);if(!t)return this.r.delete(h.value),!1;let o=!1;for(const a of t)a.ignoreUnhandledExtHostErrors||(a.logError(i),o=!0);return o}};e.$UQ=f,e.$UQ=f=Ke([We(0,R.$TQ),We(1,N.$ek)],f);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,n,t,o,a,m){this.g=n,this.h=t,this.i=o,this.j=a,this.a=new D.$oe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,s.$Op)(i,[]),this.c&&(i=(0,I.$ko)(i,this.c)),this.b||(i=(0,I.$ko)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const n={name:h.name,message:h.message,stack:h.stack,cause:h.cause},t=(0,s.$Op)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$VQ=r;function c(l){const h=Date.now()-new Date(l).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$XQ=(0,y.$Ii)("IExtHostTelemetry")}),define(Re[21],Te([1,0,6,2,178,112,18,3]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AH=e.ActivationKind=e.$xH=e.$wH=e.$tH=e.ExtensionHostStartup=e.$sH=e.$rH=e.$qH=e.$pH=void 0,e.$uH=u,e.$vH=E,e.$yH=l,e.$zH=h,e.$pH=Object.freeze({identifier:new R.$un("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$qH="extensions.webWorker",e.$rH=(0,O.$Ii)("extensionService");class p{constructor(t){this.dependency=t}}e.$sH=p;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,a){this.c=t,this.d=o.slice(0),this.e=a.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$bH.createActivationEventsMap(this.d)}}set(t,o,a){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],g=[],d=[],S=[],k=b(this.d),v=b(o),C=(A,L)=>A.extensionLocation.toString()===L.extensionLocation.toString()||A.isBuiltin===L.isBuiltin||A.isUserBuiltin===L.isUserBuiltin||A.isUnderDevelopment===L.isUnderDevelopment;for(const A of this.d){const L=v.get(A.identifier);if(!L){m.push(A.identifier),k.delete(A.identifier);continue}if(!C(A,L)){m.push(A.identifier),k.delete(A.identifier);continue}}for(const A of o){const L=k.get(A.identifier);if(!L){g.push(A);continue}if(!C(L,A)){m.push(L.identifier),k.delete(L.identifier);continue}}const T=new R.$vn(this.e),$=new R.$vn(a);for(const A of this.e)$.has(A)||d.push(A);for(const A of a)T.has(A)||S.push(A);const w=N.$bH.createActivationEventsMap(g),M={versionId:t,toRemove:m,toAdd:g,addActivationEvents:w,myToRemove:d,myToAdd:S};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:a,myToRemove:m,myToAdd:g}=t,d=new R.$vn(o),S=new R.$vn(m);for(let k=0;k<this.d.length;k++)d.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)S.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of a)this.d.push(k);for(const k of g)this.e.push(k);return this.f=null,t}containsExtension(t){for(const o of this.e)if(R.$un.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const a=N.$bH.readActivationEvents(o);for(const m of a)t.add(m)}return t}}e.$tH=I;function b(n){const t=new R.$wn;for(const o of n)t.set(o.identifier,o);return t}function u(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function E(n,t){if(!u(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class f{constructor(t,o,a,m){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=a,this.activationReason=m}}e.$wH=f;class r{constructor(t,o){this.description=t,this.value=o}}e.$xH=r;var c;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function l(n){return{type:n.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Up)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function h(n,t){const o=(0,P.$Sp)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new R.$un(o),isBuiltin:n.type===R.ExtensionType.System,isUserBuiltin:n.type===R.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$AH=i}),define(Re[205],Te([1,0,12,4,121,18,21,11,10]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=e.$drc=e.$crc=e.$brc=e.$arc=void 0,y=qe(y);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(h,i,n,t){this.startup=h,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$arc=s;class I{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,i){return h===-1||i===-1?-1:i-h}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$brc=I;class b{constructor(h,i,n,t,o,a){this.activationFailed=h,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=a}}e.$crc=b;class u extends b{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}e.$drc=u;class E extends b{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}e.$erc=E;class f extends b{constructor(h){super(!0,h,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}let r=class{constructor(h,i,n,t){this.g=t,this.a=h,this.b=i,this.c=n,this.d=new N.$wn,this.f=Object.create(null)}dispose(){for(const[h,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const h=[];for(const[i,n]of this.d)h.push(n.wait());await Promise.all(h)}isActivated(h){const i=this.d.get(h);return!!(i&&i.value)}getActivatedExtension(h){const i=this.d.get(h);if(!i||!i.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return i.value}async activateByEvent(h,i){if(this.f[h])return;const n=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,i){const n=this.a.getExtensionDescription(h);if(!n)throw new Error(`Extension '${h.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(h){const i=h.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(h){if(this.d.has(h.id))return this.d.get(h.id);if(this.l(h.id))return this.k(h,null,[],null);const i=this.a.getExtensionDescription(h.id);if(!i){const o=new Error(`Cannot activate unknown extension '${h.id.value}'`),a=this.k(h,null,[],new f(o));return this.c.onExtensionActivationError(h.id,o,new R.$sH(h.id.value)),a}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const a=this.d.get(o);if(a){n.push(a);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:h.reason}));continue}const m=this.a.getExtensionDescription(o);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:h.reason}));continue}const g=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${o}'`),S=this.k(h,i.displayName,[],new f(d));return this.c.onExtensionActivationError(i.identifier,d,new R.$sH(o)),S}return this.k(h,i.displayName,n,null)}k(h,i,n,t){const o=new c(h.id,i,h.reason,n,t,this.c,this.g);return this.d.set(h.id,o),o}l(h){return P.$Oec.isHostExtension(h,this.a,this.b)}m(h){const i=this.b.getExtensionDescription(h);return i?!i.main&&!i.browser:!1}};e.$frc=r,e.$frc=r=Ke([We(3,O.$dk)],r);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,i,n,t,o,a,m){this.c=h,this.d=i,this.f=n,this.g=t,this.h=o,this.j=a,this.k=m,this.a=new p.$Hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const i=this.g[h];if(i.value&&!i.value.activationFailed){this.g.splice(h,1),h--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new f(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const i=new Error;if(h&&h.name&&(i.name=h.name),h&&h.message?i.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(i.stack=h.stack),this.h=new f(i),this.b&&y.$6(h))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};c=Ke([We(6,O.$dk)],c)});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[122],Te([1,0,9,12,36,111,78,29,18,109,112,105]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=void 0,y=qe(y),P=si(P);const u=O.$uo.as(R.$vo.JSONContribution);class E{constructor(t,o,a){this.a=t,this.b=o,this.c=a}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$jH=E;class f{static a(t){const o=new p.$vn;for(let a=0,m=t.length;a<m;a++)o.add(t[a].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new f(o,[]);if(!o||!o.length)return new f([],t);const a=this.a(t),m=this.a(o),g=o.filter(S=>!a.has(S.description.identifier)),d=t.filter(S=>!m.has(S.description.identifier));return new f(g,d)}constructor(t,o){this.added=t,this.removed=o}}e.$kH=f;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=f.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,D.$2)(t)}}}e.$lH=r;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(12315,null),y.localize(12316,null)]},l="vscode://schemas/vscode-extensions";e.$mH={properties:{engines:{type:"object",description:y.localize(12317,null),properties:{vscode:{type:"string",description:y.localize(12318,null),default:"^1.22.0"}}},publisher:{description:y.localize(12319,null),type:"string"},displayName:{description:y.localize(12320,null),type:"string"},categories:{description:y.localize(12321,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$tn},{type:"string",const:"Languages",deprecationMessage:y.localize(12322,null)}]}},galleryBanner:{type:"object",description:y.localize(12323,null),properties:{color:{description:y.localize(12324,null),type:"string"},theme:{description:y.localize(12325,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(12326,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12327,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(12328,null)},enabledApiProposals:{markdownDescription:y.localize(12329,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(b.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:y.localize(12330,null),type:"string",enum:["none"],enumDescriptions:[y.localize(12331,null)]},activationEvents:{description:y.localize(12332,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(12333,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(12334,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(12335,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(12336,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(12337,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(12338,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(12339,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(12340,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(12341,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(12342,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(12343,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(12344,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(12345,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(12346,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(12347,null)},{label:"onUri",body:"onUri",description:y.localize(12348,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(12349,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(12350,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(12351,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(12352,null)},{label:"onRenderer",description:y.localize(12353,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(12354,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(12355,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(12356,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(12357,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:y.localize(12358,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:y.localize(12359,null)},{label:"*",description:y.localize(12360,null),body:"*"}]}},badges:{type:"array",description:y.localize(12361,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(12362,null)},href:{type:"string",description:y.localize(12363,null)},description:{type:"string",description:y.localize(12364,null)}}}},markdown:{type:"string",description:y.localize(12365,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(12366,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(12367,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$bp}},extensionPack:{description:y.localize(12368,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$bp}},extensionKind:{description:y.localize(12369,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(12370,null)},{body:["workspace"],description:y.localize(12371,null)},{body:["ui","workspace"],description:y.localize(12372,null)},{body:["workspace","ui"],description:y.localize(12373,null)},{body:[],description:y.localize(12374,null)}]},capabilities:{description:y.localize(12375,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(12376,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(12377,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(12378,null),y.localize(12379,null),y.localize(12380,null)]},description:{type:"string",markdownDescription:y.localize(12381,null)}}},untrustedWorkspaces:{description:y.localize(12382,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(12383,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(12384,null),y.localize(12385,null),y.localize(12386,null)]},restrictedConfigurations:{description:y.localize(12387,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(12388,null)}}}}},sponsor:{description:y.localize(12389,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(12390,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(12391,null),type:"string"},"vscode:uninstall":{description:y.localize(12392,null),type:"string"}}},icon:{type:"string",description:y.localize(12393,null)},l10n:{type:"string",description:y.localize(12394,null)},pricing:{type:"string",markdownDescription:y.localize(12395,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$bH.register(t.extensionPoint,t.activationEventsGenerator),e.$mH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(l,e.$mH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$nH=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$uo.add(i.ExtensionsRegistry,new h),e.$oH=O.$uo.as(i.ExtensionsRegistry),u.registerSchema(l,e.$mH),u.registerSchema(s.$xk,{properties:{extensionEnabledApiProposals:{description:y.localize(12396,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Re[206],Te([1,0,6,40,4,13,9,18,3,11,21,122]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DH=e.$CH=e.$BH=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$BH=(0,p.$Ii)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(4723,null)}}};e.$CH=b.$oH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(4724,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,c)=>{for(const l of r)c.push(`onLanguageModelChat:${l.vendor}`)}});let f=class{constructor(c,l){this.e=c,this.f=l,this.a=new P.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new y.$oe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$CH.setHandler(h=>{this.c.clear();for(const n of h){if(!(0,I.$uH)(n.description,"chatProvider")){n.collector.error((0,R.localize)(4725,null));continue}for(const t of D.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,R.localize)(4726,null,t.vendor));continue}if((0,N.$ff)(t.vendor)){n.collector.error((0,R.localize)(4727,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,R.localize)(4728,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(c){return this.b.get(c)?.metadata}async selectLanguageModels(c){if(c.vendor)await this.e.activateByEvent(`onLanguageModelChat:${c.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const l=[];for(const[h,i]of this.b)(c.vendor===void 0||i.metadata.vendor===c.vendor)&&(c.family===void 0||i.metadata.family===c.family)&&(c.version===void 0||i.metadata.version===c.version)&&(c.identifier===void 0||i.metadata.id===c.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>O.$un.equals(n,c.extension)))&&l.push(h);return this.f.trace("[LM] selected language models",c,l),l}registerLanguageModelChat(c,l){if(this.f.trace("[LM] registering language model chat",c,l.metadata),!this.c.has(l.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${l.metadata.vendor}.`);if(this.b.has(c))throw new Error(`Chat response provider with identifier ${c} is already registered.`);return this.b.set(c,l),this.d.fire({added:[{identifier:c,metadata:l.metadata}]}),(0,P.$Vc)(()=>{this.b.delete(c)&&(this.d.fire({removed:[c]}),this.f.trace("[LM] UNregistered language model chat",c,l.metadata))})}async sendChatRequest(c,l,h,i,n){const t=this.b.get(c);if(!t)throw new Error(`Chat response provider with identifier ${c} is not registered.`);return t.sendChatRequest(h,l,i,n)}computeTokenLength(c,l,h){const i=this.b.get(c);if(!i)throw new Error(`Chat response provider with identifier ${c} is not registered.`);return i.provideTokenCount(l,h)}};e.$DH=f,e.$DH=f=Ke([We(0,I.$rH),We(1,s.$dk)],f)}),define(Re[207],Te([1,0,9,14,25,122,31,6]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=void 0,y=qe(y),D=qe(D),P=qe(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(9876,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(9877,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(9878,null),default:""}}};var s;(function(u){function E(f,r,c){if(!f)return;const l=D.$hg(f.type)?f.type:void 0;if(!l||l.length===0){c.error(y.localize(9879,null));return}const h=[];if(Array.isArray(f.required))for(const i of f.required)D.$hg(i)&&h.push(i);return{extensionId:r.value,taskType:l,required:h,properties:f.properties?P.$ho(f.properties):{},when:f.when?R.$Gj.deserialize(f.when):void 0}}u.from=E})(s||(s={}));const I=N.$oH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const f of u)f.type&&E.push(`onTaskType:${f.type}`)},jsonSchema:{description:y.localize(9880,null),type:"array",items:p}});class b{constructor(){this.d=new O.$oe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,f)=>{I.setHandler((r,c)=>{this.c=void 0;try{for(const l of c.removed){const h=l.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const l of c.added){const h=l.value;for(const i of h){const n=s.from(i,l.description.identifier,l.collector);n&&(this.a[n.taskType]=n)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=P.$ho(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$_I=new b}),define(Re[208],Te([1,0,9,14,24,25,31,207,43]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$jJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$dJ=e.ShellQuoting=e.$cJ=e.$bJ=e.$aJ=void 0,y=qe(y),D=qe(D),P=qe(P),N=qe(N),e.$aJ="settings",e.$bJ=new R.$Zj("taskRunning",!1,y.localize(9881,null)),e.$cJ=y.localize2(9883,"Tasks");var s;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$dJ="$customized",function(U){function V(Q){if(!Q)return U.Strong;switch(Q.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=V}(s||(e.ShellQuoting=s={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var b;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(b||(e.RevealKind=b={})),function(U){function V(Q){switch(Q.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=V}(b||(e.RevealKind=b={}));var u;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(U){function V(Q){switch(Q.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=V}(u||(e.RevealProblemKind=u={}));var E;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(E||(e.PanelKind=E={})),function(U){function V(Q){switch(Q.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=V}(E||(e.PanelKind=E={}));var f;(function(U){U.defaults={echo:!0,reveal:b.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(f||(e.PresentationOptions=f={}));var r;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(U){function V(ne){switch(ne.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=V;function Q(ne){switch(ne){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=Q}(r||(e.RuntimeType=r={}));var c;(function(U){function V(Q){return D.$hg(Q)?Q:Q.value}U.value=V})(c||(e.CommandString=c={}));var l;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function V(ne){return ne===U.Clean._id||ne===U.Build._id||ne===U.Rebuild._id||ne===U.Test._id}U.is=V;function Q(ne){if(ne!==void 0)return D.$hg(ne)?V(ne)?{_id:ne,isDefault:!1}:void 0:ne}U.from=Q})(l||(e.TaskGroup=l={}));var h;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function V(Q){switch(Q){case U.User:return p.ConfigurationTarget.USER;case U.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}U.toConfigurationTarget=V})(i||(e.TaskSourceKind=i={}));var n;(function(U){U.parallel="parallel",U.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class a{constructor(V,Q,ne,ue,_,ae){this._label="",this._id=V,Q&&(this._label=Q),ne&&(this.type=ne),this.runOptions=ue,this.configurationProperties=_,this._source=ae}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,Q=!1){if(V===void 0)return!1;if(D.$hg(V))return V===this._label||V===this.configurationProperties.identifier||Q&&V===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$eJ=a;class m extends a{constructor(V,Q,ne,ue,_,ae,se,ce){super(V,ne,void 0,se,ce,Q),this.command={},this._source=Q,this.hasDefinedMatchers=ae,_&&(this.command=_)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let Q;switch(this.command?this.command.runtime:void 0){case r.Shell:Q="shell";break;case r.Process:Q="process";break;case r.CustomExecution:Q="customExecution";break;case void 0:Q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Q,_key:this._id,id:this._id}}}static is(V){return V instanceof m}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$aJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ne={type:e.$dJ,folder:V,id:Q};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$gh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new m(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$fJ=m;class g extends a{constructor(V,Q,ne,ue,_,ae,se){super(V,ne,ue,ae,se,Q),this._source=Q,this.configures=_}static is(V){return V instanceof g}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$gh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$aJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ne={type:e.$dJ,folder:V,id:Q};return JSON.stringify(ne)}}e.$gJ=g;class d extends a{constructor(V,Q,ne,ue,_,ae,se,ce,x){super(V,ne,ue,ce,x,Q),this.defines=_,this.hasDefinedMatchers=se,this.command=ae,this.icon=x.icon,this.hide=x.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof d}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new d(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$hJ=d;class S extends a{constructor(V,Q,ne,ue,_,ae){super(V,ne,ue,_,ae,Q),this._source=Q}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new S(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$iJ=S;var k;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(U){U._default=U.Terminal}(k||(e.ExecutionEngine=k={}));var v;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class C{constructor(V){this.c=new Map;for(let Q=0;Q<V.length;Q++)this.c.set(V[Q].uri.toString(),Q)}compare(V,Q){const ne=V.getWorkspaceFolder(),ue=Q.getWorkspaceFolder();if(ne&&ue){let _=this.c.get(ne.uri.toString());_=_===void 0?0:_+1;let ae=this.c.get(ue.uri.toString());return ae=ae===void 0?0:ae+1,_===ae?V._label.localeCompare(Q._label):_-ae}else return!ne&&ue?-1:ne&&!ue?1:0}}e.$jJ=C;var T;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(T||(e.TaskEventKind=T={}));var $;(function(U){U.SingleRun="singleRun",U.Background="background"})($||(e.TaskRunType=$={}));var w;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(U){function V(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?$.Background:$.SingleRun,group:ce.configurationProperties.group,__task:ce}}function Q(ce,x,we){return{...V(ce),kind:T.Start,terminalId:x,resolvedVariables:we}}U.start=Q;function ne(ce,x,we){return{...V(ce),kind:T.ProcessStarted,terminalId:x,processId:we}}U.processStarted=ne;function ue(ce,x,we){return{...V(ce),kind:T.ProcessEnded,terminalId:x,exitCode:we}}U.processEnded=ue;function _(ce,x,we){return{...V(ce),kind:T.Terminated,exitReason:we,terminalId:x}}U.terminated=_;function ae(ce,x,we){return{...V(x),kind:ce,terminalId:we}}U.general=ae;function se(){return{kind:T.Changed}}U.changed=se})(M||(e.TaskEvent=M={}));var A;(function(U){function V(ne){const ue=Object.keys(ne).sort();let _="";for(const ae of ue){let se=ne[ae];se instanceof Object?se=V(se):typeof se=="string"&&(se=se.replace(/,/g,",,")),_+=ae+","+se+","}return _}function Q(ne){const _={_key:V(ne),type:ne.taskType};return Object.assign(_,ne),_}U.create=Q})(A||(e.KeyedTaskIdentifier=A={}));var L;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection",U.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var Z;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(Z||(e.TasksSchemaProperties=Z={}));var J;(function(U){function V(Q,ne){const ue=O.$_I.get(Q.type);if(ue===void 0){const ce=N.$ho(Q);return delete ce._key,A.create(ce)}const _=Object.create(null);_.type=ue.taskType;const ae=new Set;ue.required.forEach(ce=>ae.add(ce));const se=ue.properties;for(const ce of Object.keys(se)){const x=Q[ce];if(x!=null)_[ce]=x;else if(ae.has(ce)){const we=se[ce];if(we.default!==void 0)_[ce]=N.$ho(we.default);else switch(we.type){case"boolean":_[ce]=!1;break;case"number":case"integer":_[ce]=0;break;case"string":_[ce]="";break;default:ne.error(y.localize(9882,null,JSON.stringify(Q,void 0,0),ce));return}}}return A.create(_)}U.createTaskIdentifier=V})(J||(e.TaskDefinition=J={}))}),define(Re[209],Te([1,0,12]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,O)=>{this.b=R,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,y.$2)(R))}then(R,O){return this.j().then(R,O)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$Sec=D;class P extends D{constructor(){super(),this.h=!0,this.i=new y.$7}}e.$Tec=P}),define(Re[39],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4w=e.$1w=void 0,e.$2w=P,e.$3w=N;class y{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++y.count}}e.$1w=y;const D=[];function P(O){const p=new y(O);return D[p.nid]=p,p}function N(O){return D[O].sid}class R{constructor(p){this.value=p}}e.$4w=R}),define(Re[5],Te([1,0,39]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$2N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var O;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class b{static{this.a=0}static mixin(c){return c._id=b.a++,c}}e.$2N=b;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$3N={MainThreadAuthentication:(0,y.$2w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$2w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,y.$2w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,y.$2w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,y.$2w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$2w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,y.$2w)("MainThreadChatSkills"),MainThreadClipboard:(0,y.$2w)("MainThreadClipboard"),MainThreadCommands:(0,y.$2w)("MainThreadCommands"),MainThreadComments:(0,y.$2w)("MainThreadComments"),MainThreadConfiguration:(0,y.$2w)("MainThreadConfiguration"),MainThreadConsole:(0,y.$2w)("MainThreadConsole"),MainThreadDebugService:(0,y.$2w)("MainThreadDebugService"),MainThreadDecorations:(0,y.$2w)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$2w)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$2w)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$2w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$2w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$2w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$2w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$2w)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$2w)("MainThreadErrors"),MainThreadTreeViews:(0,y.$2w)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$2w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$2w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$2w)("MainThreadLanguages"),MainThreadLogger:(0,y.$2w)("MainThreadLogger"),MainThreadMessageService:(0,y.$2w)("MainThreadMessageService"),MainThreadOutputService:(0,y.$2w)("MainThreadOutputService"),MainThreadProgress:(0,y.$2w)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$2w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$2w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$2w)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$2w)("MainThreadSecretState"),MainThreadStorage:(0,y.$2w)("MainThreadStorage"),MainThreadSpeech:(0,y.$2w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$2w)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$2w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,y.$2w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,y.$2w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$2w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$2w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$2w)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$2w)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$2w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$2w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$2w)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$2w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$2w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$2w)("MainThreadExtensionService"),MainThreadSCM:(0,y.$2w)("MainThreadSCM"),MainThreadSearch:(0,y.$2w)("MainThreadSearch"),MainThreadShare:(0,y.$2w)("MainThreadShare"),MainThreadTask:(0,y.$2w)("MainThreadTask"),MainThreadWindow:(0,y.$2w)("MainThreadWindow"),MainThreadLabelService:(0,y.$2w)("MainThreadLabelService"),MainThreadNotebook:(0,y.$2w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$2w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$2w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$2w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$2w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$2w)("MainThreadInteractive"),MainThreadTheming:(0,y.$2w)("MainThreadTheming"),MainThreadTunnelService:(0,y.$2w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$2w)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$2w)("MainThreadTimeline"),MainThreadTesting:(0,y.$2w)("MainThreadTesting"),MainThreadLocalization:(0,y.$2w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$2w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$2w)("MainThreadAiEmbeddingVector")},e.$4N={ExtHostCommands:(0,y.$2w)("ExtHostCommands"),ExtHostConfiguration:(0,y.$2w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$2w)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$2w)("ExtHostDebugService"),ExtHostDecorations:(0,y.$2w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$2w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$2w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$2w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$2w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$2w)("ExtHostEditors"),ExtHostTreeViews:(0,y.$2w)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$2w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$2w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$2w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$2w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$2w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$2w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$2w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$2w)("ExtHostStatusBar"),ExtHostShare:(0,y.$2w)("ExtHostShare"),ExtHostExtensionService:(0,y.$2w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$2w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$2w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,y.$2w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,y.$2w)("ExtHostSCM"),ExtHostSearch:(0,y.$2w)("ExtHostSearch"),ExtHostTask:(0,y.$2w)("ExtHostTask"),ExtHostWorkspace:(0,y.$2w)("ExtHostWorkspace"),ExtHostWindow:(0,y.$2w)("ExtHostWindow"),ExtHostWebviews:(0,y.$2w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$2w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$2w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$2w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$2w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$2w)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$2w)("ExtHostProgress"),ExtHostComments:(0,y.$2w)("ExtHostComments"),ExtHostSecretState:(0,y.$2w)("ExtHostSecretState"),ExtHostStorage:(0,y.$2w)("ExtHostStorage"),ExtHostUrls:(0,y.$2w)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$2w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$2w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$2w)("ExtHostOutputService"),ExtHostLabelService:(0,y.$2w)("ExtHostLabelService"),ExtHostNotebook:(0,y.$2w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$2w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$2w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$2w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$2w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$2w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$2w)("ExtHostInteractive"),ExtHostChatAgents2:(0,y.$2w)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$2w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,y.$2w)("ExtHostChatSkills"),ExtHostChatProvider:(0,y.$2w)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$2w)("ExtHostSpeech"),ExtHostEmbeddings:(0,y.$2w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,y.$2w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$2w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$2w)("ExtHostTheming"),ExtHostTunnelService:(0,y.$2w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$2w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$2w)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$2w)("ExtHostTimeline"),ExtHostTesting:(0,y.$2w)("ExtHostTesting"),ExtHostTelemetry:(0,y.$2w)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$2w)("ExtHostLocalization")}}),define(Re[85],Te([1,0,3,11,5,16]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=e.$zqc=void 0,P=qe(P),e.$zqc=(0,y.$Ii)("IExtHostApiDeprecationService");let R=class{constructor(p,s){this.c=s,this.a=new Set,this.b=p.getProxy(P.$3N.MainThreadTelemetry)}report(p,s,I){const b=this.d(p,s);this.a.has(b)||(this.a.add(b),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:p}))}d(p,s){return`${p}-${s.identifier.value}`}};e.$Aqc=R,e.$Aqc=R=Ke([We(0,N.$DQ),We(1,D.$dk)],R),e.$Bqc=Object.freeze(new class{report(O,p,s){}})}),define(Re[210],Te([1,0,5]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0;class D{constructor(N){const R=N.getProxy(y.$3N.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(O){return R.$writeText(O)}})}}e.$Oqc=D}),define(Re[211],Te([1,0,25,5,26,16]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;let R=class{constructor(I,b){this.a=I.getProxy(D.$3N.MainThreadConsole),this.b=b.consoleForward.includeStack,this.c=b.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,b){const u=this,E=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,b,E,arguments)}})}e(I,b,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:b,arguments:p(E,this.b)}),this.c&&this.f(I,u,E)}};e.$Psc=R,e.$Psc=R=Ke([We(0,N.$DQ),We(1,P.$TQ)],R);const O=1e5;function p(s,I){const b=[];if(s.length)for(let u=0;u<s.length;u++){let E=s[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const f=E;f.stack?E=f.stack:E=f.toString()}b.push(E)}if(I){const u=new Error().stack;u&&b.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$mo)(b);return u.length>O?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[212],Te([1,0,2,5,21]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=void 0;class N{constructor(O){this.a=O.getProxy(D.$3N.MainThreadDialogs)}showOpenDialog(O,p){return p?.allowUIResources&&(0,P.$vH)(O,"showLocal"),this.a.$showOpenDialog(p).then(s=>s?s.map(I=>y.URI.revive(I)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(p=>p?y.URI.revive(p):void 0)}}e.$Qrc=N}),define(Re[213],Te([1,0,19,6,4,5]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=void 0;class R{constructor(p){this.b=new Map,this.c=new D.$oe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(N.$3N.MainThreadEmbeddings)}registerEmbeddingsProvider(p,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const b=this.e++;return this.a.$registerEmbeddingProvider(b,s),this.b.set(b,{id:s,provider:I}),(0,P.$Vc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(b),this.b.delete(b)})}async computeEmbeddings(p,s,I){I??=y.CancellationToken.None;let b=!1;typeof s=="string"&&(s=[s],b=!0);const u=await this.a.$computeEmbeddings(p,s,I);if(u.length!==s.length)throw new Error;if(b){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,s,I){const b=this.b.get(p);if(!b)return[];const u=await b.provider.provideEmbeddings(s,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Trc=R}),define(Re[214],Te([1,0,4,5]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(D.$3N.MainThreadLabelService)}$registerResourceLabelFormatter(R){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,R),(0,y.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$dsc=P}),define(Re[86],Te([1,0,23,13,2,3,11,5,26,16]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0;let I=class{constructor(u,E,f){this.f=f,this.d=new Map,this.a=E.getProxy(O.$3N.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$h}getMessage(u,E){const{message:f,args:r,comment:c}=E;if(this.c)return(0,D.$hf)(f,r??{});let l=f;c&&c.length>0&&(l+=`/${Array.isArray(c)?c.join(""):c}`);const h=this.d.get(u)?.contents[l];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,D.$hf)(h??f,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const f=await this.g(u);if(!f){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),c=JSON.parse(r);E=u.isBuiltin?c.contents?.bundle:c}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${f}: ${r.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:f})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(E)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$trc=I,e.$trc=I=Ke([We(0,p.$TQ),We(1,s.$DQ),We(2,R.$dk)],I),e.$urc=(0,N.$Ii)("IExtHostLocalizationService")}),define(Re[215],Te([1,0,11,5,26,16,2,33]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;let p=class extends y.$ok{constructor(b,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,O.$fi)(E))),this.r=b.getProxy(D.$3N.MainThreadLogger)}$setLogLevel(b,u){u?this.setLogLevel(R.URI.revive(u),b):this.setLogLevel(b)}setVisibility(b,u){super.setVisibility(b,u),this.r.$setVisibility(b,u)}s(b,u,E){return new s(this.r,b,u,E)}};e.$Osc=p,e.$Osc=p=Ke([We(0,N.$DQ),We(1,P.$TQ)],p);class s extends y.$jk{constructor(b,u,E,f){super(f?.logLevel==="always"),this.r=b,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,f).then(()=>{this.u(this.n),this.m=!0})}g(b,u){const E=[[b,u]];this.m?this.u(E):this.n.push(...E)}u(b){this.r.$log(this.s,b)}flush(){this.r.$flush(this.s)}}}),define(Re[87],Te([1,0,5,3,4,16,20]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=e.$vrc=void 0,e.$vrc=(0,D.$Ii)("IExtHostManagedSockets");let O=class{constructor(b){this.b=0,this.c=null,this.d=new Map,this.a=b.getProxy(y.$3N.MainThreadManagedSockets)}setFactory(b,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(b,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(b){if(!this.c||this.c.socketFactoryId!==b)throw new Error(`No socket factory with id ${b}`);const u=++this.b,E=await this.c.makeConnection(),f=new P.$Wc;return this.d.set(u,new s(u,E,f)),f.add((0,P.$Vc)(()=>this.d.delete(u))),f.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),f.dispose()})),f.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),f.dispose()})),f.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,R.$Qe.wrap(r)))),u}$remoteSocketWrite(b,u){this.d.get(b)?.actual.send(u.buffer)}$remoteSocketEnd(b){const u=this.d.get(b);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(b){await this.d.get(b)?.actual.drain?.()}};e.$wrc=O,e.$wrc=O=Ke([We(0,N.$DQ)],O);class p{constructor(b,u){this.socketFactoryId=b,this.makeConnection=u}}class s extends P.$Xc{constructor(b,u,E){super(),this.socketId=b,this.actual=u,this.B(E)}}}),define(Re[216],Te([1,0,5,11,21]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=void 0;function N(O){return O&&O.title}let R=class{constructor(p,s){this.b=s,this.a=p.getProxy(y.$3N.MainThreadMessageService)}showMessage(p,s,I,b,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let f;typeof b=="string"||N(b)?f=[b,...u]:(E.modal=b?.modal,E.useCustom=b?.useCustom,E.detail=b?.detail,f=u),E.useCustom&&(0,P.$vH)(p,"resolvers");const r=[];let c=!1;for(let l=0;l<f.length;l++){const h=f[l];if(typeof h=="string")r.push({title:h,handle:l,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:n}=h;r.push({title:i,isCloseAffordance:!!n,handle:l}),n&&(c?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):c=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(s,I,E,r).then(l=>{if(typeof l=="number")return f[l]})}};e.$gsc=R,e.$gsc=R=Ke([We(1,D.$dk)],R)}),define(Re[217],Te([1,0,4,14,2,21,5]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class O{constructor(s){this.b=new Map,this.a=s.getProxy(R.$3N.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,b){if((0,N.$vH)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,b),this.a.$registerProfileContentHandler(I,b.name,b.description,s.identifier.value),(0,y.$Vc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,b,u){const E=this.b.get(s);if(!E)throw new Error(`Unknown handler with id: ${s}`);return E.saveProfile(I,b,u)}async $readProfile(s,I,b){const u=this.b.get(s);if(!u)throw new Error(`Unknown handler with id: ${s}`);return u.readProfile((0,D.$hg)(I)?I:P.URI.revive(I),b)}}e.$psc=O}),define(Re[88],Te([1,0,5,6,3]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$qrc=void 0;class N{constructor(O){this.b=new D.$oe,this.onDidChangePassword=this.b.event,this.a=O.getProxy(y.$3N.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,p){return this.a.$getPassword(O,p)}store(O,p,s){return this.a.$setPassword(O,p,s)}delete(O,p){return this.a.$deletePassword(O,p)}}e.$qrc=N,e.$rrc=(0,P.$Ii)("IExtHostSecretState")}),define(Re[218],Te([1,0,19,4,5]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsc=void 0;class N{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(P.$3N.MainThreadSpeech)}async $createSpeechToTextSession(O,p,s){const I=this.c.get(O);if(!I)return;const b=new D.$Wc,u=new y.$ze;this.d.set(p,u);const E=await I.provideSpeechToTextSession(u.token,s?{language:s}:void 0);E&&(b.add(E.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,f)})),b.add(u.token.onCancellationRequested(()=>b.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,p,s){const I=this.c.get(O);if(!I)return;const b=new D.$Wc,u=new y.$ze;this.d.set(p,u);const E=await I.provideTextToSpeechSession(u.token,s?{language:s}:void 0);E&&(this.f.set(p,E),b.add(E.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,f)})),b.add(u.token.onCancellationRequested(()=>b.dispose())))}async $synthesizeSpeech(O,p){this.f.get(O)?.synthesize(p)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,p){const s=this.c.get(O);if(!s)return;const I=new D.$Wc,b=new y.$ze;this.d.set(p,b);const u=await s.provideKeywordRecognitionSession(b.token);u&&(I.add(u.onDidChange(E=>{b.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),I.add(b.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,p,s){const I=N.a++;return this.c.set(I,s),this.b.$registerProvider(I,p,{extension:O,displayName:O.value}),(0,D.$Vc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$wsc=N}),define(Re[89],Te([1,0,5,6,3]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0;class N{constructor(O,p){this.c=p,this.b=new D.$oe,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(y.$3N.MainThreadStorage)}registerExtensionStorageKeysToSync(O,p){this.a.$registerExtensionStorageKeysToSync(O,p)}async initializeExtensionStorage(O,p,s){const I=await this.a.$initializeExtensionStorage(O,p);let b;return I&&(b=this.d(O,p,I)),b||s}setValue(O,p,s){return this.a.$setValue(O,p,s)}$acceptValue(O,p,s){const I=this.d(O,p,s);I&&this.b.fire({shared:O,key:p,value:I})}d(O,p,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${O}): ${I}`)}}}e.$grc=N,e.$hrc=(0,P.$Ii)("IExtHostStorage")}),define(Re[219],Te([1,0,4,15,2,5]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0;class R{static{this.a=new Set([D.Schemas.http,D.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(N.$3N.MainThreadUriOpeners)}registerExternalUriOpener(p,s,I,b){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const u=b.schemes.find(E=>!R.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,b.schemes,p,b.label),(0,y.$Vc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(p,s,I){const b=this.c.get(p);if(!b)throw new Error(`Unknown opener with id: ${p}`);const u=P.URI.revive(s);return b.canOpenExternalUri(u,I)}async $openUri(p,s,I){const b=this.c.get(p);if(!b)throw new Error(`Unknown opener id: '${p}'`);return b.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},I)}}e.$Isc=R}),define(Re[220],Te([1,0,5,2,4,12,18]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class O{static{this.a=0}constructor(s){this.c=new R.$vn,this.d=new Map,this.b=s.getProxy(y.$3N.MainThreadUrls)}registerUriHandler(s,I){const b=s.identifier;if(this.c.has(b))throw new Error(`Protocol handler already registered for extension ${b}`);const u=O.a++;return this.c.add(b),this.d.set(u,I),this.b.$registerUriHandler(u,b,s.displayName||s.name),(0,P.$Vc)(()=>{this.c.delete(b),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(s,I){const b=this.d.get(s);if(!b)return Promise.resolve(void 0);try{b.handleUri(D.URI.revive(I))}catch(u){(0,N.$2)(u)}return Promise.resolve(void 0)}async createAppUri(s){return D.URI.revive(await this.b.$createAppUri(s))}}e.$Jsc=O}),define(Re[221],Te([1,0,20,5]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qub=N,e.$rub=O,D=qe(D);class P{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function N(p,s){if(s.serializeBuffersForPostMessage){const I=new P,u=JSON.stringify(p,(f,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const c=R(r);if(c)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:c,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=I.buffers.map(f=>{const r=new Uint8Array(f);return y.$Qe.wrap(r)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function R(p){switch(p.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function O(p,s){const I=s.map(E=>{const f=new ArrayBuffer(E.byteLength);return new Uint8Array(f).set(E.buffer),f}),b=s.length?(E,f)=>{if(f&&typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:c}=r,l=I[c];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(l,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(l,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(l,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(l,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(l,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(l,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(l,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(l,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(l,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(l,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(l,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return f}:void 0;return{message:JSON.parse(p,b),arrayBuffers:I}}}),define(Re[67],Te([1,0,6,4,15,25,2,175,221,83,5]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=e.$4qc=void 0,e.$5qc=u,e.$7qc=r,e.$8qc=c,N=qe(N),I=qe(I);class b{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,o,a,m,g,d){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new y.$oe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$oe,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=o,this.#n=a,this.#s=m,this.#r=g,this.#u=u(g),this.#d=E(g),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$eEb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$dEb}return s.$dEb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),N.$lo(this.#o,n)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,p.$qub)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,m,g,d,S,k)=>{const v=R.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),C=(0,s.$eEb)(v,{isRemote:t,authority:o}).toString();return`${m}${C}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,m,g,d,S,k)=>{const v=R.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),C=(0,s.$eEb)(v,{isRemote:t,authority:o}).toString();return`${m}${C}${k}`})}}e.$4qc=b;function u(i){try{const n=(0,O.$5p)((0,O.$4p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function E(i){try{const n=(0,O.$5p)((0,O.$4p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class f extends D.$Xc{constructor(n,t,o,a,m){super(),this.c=t,this.f=o,this.g=a,this.h=m,this.b=new Map,this.a=n.getProxy(I.$3N.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,o){const a=this.j(n);if(a){const{message:m}=(0,p.$rub)(t,o.value);a._onMessageEmitter.fire(m)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const a=new b(n,this.a,l(t),this.c,this.f,o,this.h);this.b.set(n,a);const m=a._onDidDispose(()=>{m.dispose(),this.deleteWebview(n)});return a}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$6qc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function c(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||h(i,n)}}function l(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>R.URI.from(n))}}function h(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[123],Te([1,0,6,15,13,2,3,16,5]),function($e,e,y,D,P,N,R,O,p){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=e.$Lsc=void 0;let I=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new y.$oe,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=u.getProxy(p.$3N.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:f})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let f;if(typeof u=="string"){f=u;try{u=N.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$ff)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,f,E)}async asExternalUri(u,E){if((0,P.$ff)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(u,E);return N.URI.from(f)}};e.$Lsc=I,e.$Lsc=I=s=Ke([We(0,O.$DQ)],I),e.$Msc=(0,R.$Ii)("IExtHostWindow")}),define(Re[222],Te([1,0,211,26,16]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2uc=void 0;let N=class extends y.$Psc{constructor(O,p){super(O,p)}f(O,p,s){p.apply(console,s)}};e.$2uc=N,e.$2uc=N=Ke([We(0,P.$DQ),We(1,D.$TQ)],N)}),define(Re[223],Te([1,0,10,20,19,30,12,6,4,37,150,209,39]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.ResponsiveState=e.RequestInitiator=void 0,e.$Uec=h,e.$Vec=i,R=qe(R);function f(M,A){try{return JSON.stringify(M,A)}catch{return"null"}}const r="$$ref$$",c={[r]:-1};class l{constructor(A,L){this.jsonString=A,this.referencedBuffers=L}}function h(M,A=null,L=!1){const Z=[];return{jsonString:(L?f:JSON.stringify)(M,(U,V)=>{if(typeof V>"u")return c;if(typeof V=="object"){if(V instanceof D.$Qe){const Q=Z.push(V)-1;return{[r]:Q}}if(A)return A(U,V)}return V}),referencedBuffers:Z}}function i(M,A,L){return JSON.parse(M,(Z,J)=>{if(J){const U=J[r];if(typeof U=="number")return A[U];if(L&&J.$mid===s.MarshalledId.Uri)return L.transformIncoming(J)}return J})}function n(M,A){return JSON.stringify(M,A)}function t(M){return M?(A,L)=>L&&L.$mid===s.MarshalledId.Uri?M.transformOutgoing(L):L:null}var o;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const m=()=>{},g=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class S extends p.$Xc{static{E=g}static{this.a=3*1e3}constructor(A,L=null,Z=null){super(),this[E]=!0,this.b=this.B(new O.$oe),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=L,this.g=Z,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let J=0,U=u.$1w.count;J<U;J++)this.m[J]=null,this.s[J]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=a.Responsive,this.z=0,this.C=0,this.D=this.B(new y.$Uh(()=>this.H(),1e3)),this.B(this.c.onMessage(J=>this.L(J)))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const L=this.w[A];delete this.w[A],L.resolveErr(R.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(a.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(a.Unresponsive):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,I.$Sn)(A,this.g):A}getProxy(A){const{nid:L,sid:Z}=A;return this.s[L]||(this.s[L]=this.J(L,Z)),this.s[L]}J(A,L){const Z={get:(J,U)=>(typeof U=="string"&&!J[U]&&U.charCodeAt(0)===N.CharCode.DollarSign&&(J[U]=(...V)=>this.U(A,U,V)),U===d?L:J[U])};return new Proxy(Object.create(null),Z)}set(A,L){return this.m[A.nid]=L,L}assertRegistered(A){for(let L=0,Z=A.length;L<Z;L++){const J=A[L];if(!this.m[J.nid])throw new Error(`Missing proxy instance ${J.sid}`)}}L(A){if(this.j)return;const L=A.byteLength,Z=v.read(A,0),J=Z.readUInt8(),U=Z.readUInt32();switch(J){case $.RequestJSONArgs:case $.RequestJSONArgsWithCancellation:{let{rpcId:V,method:Q,args:ne}=T.deserializeRequestJSONArgs(Z);this.g&&(ne=(0,I.$Sn)(ne,this.g)),this.M(L,U,V,Q,ne,J===$.RequestJSONArgsWithCancellation);break}case $.RequestMixedArgs:case $.RequestMixedArgsWithCancellation:{let{rpcId:V,method:Q,args:ne}=T.deserializeRequestMixedArgs(Z);this.g&&(ne=(0,I.$Sn)(ne,this.g)),this.M(L,U,V,Q,ne,J===$.RequestMixedArgsWithCancellation);break}case $.Acknowledged:{this.f?.logIncoming(L,U,o.LocalSide,"ack"),this.G(U);break}case $.Cancel:{this.N(L,U);break}case $.ReplyOKEmpty:{this.O(L,U,void 0);break}case $.ReplyOKJSON:{let V=T.deserializeReplyOKJSON(Z);this.g&&(V=(0,I.$Sn)(V,this.g)),this.O(L,U,V);break}case $.ReplyOKJSONWithBuffers:{const V=T.deserializeReplyOKJSONWithBuffers(Z,this.g);this.O(L,U,V);break}case $.ReplyOKVSBuffer:{const V=T.deserializeReplyOKVSBuffer(Z);this.O(L,U,V);break}case $.ReplyErrError:{let V=T.deserializeReplyErrError(Z);this.g&&(V=(0,I.$Sn)(V,this.g)),this.P(L,U,V);break}case $.ReplyErrEmpty:{this.P(L,U,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,L,Z,J,U,V){this.f?.logIncoming(A,L,o.OtherSide,`receiveRequest ${(0,u.$3w)(Z)}.${J}(`,U);const Q=String(L);let ne,ue;if(V){const ae=new P.$ze;U.push(ae.token),ne=this.Q(Z,J,U),ue=()=>ae.cancel()}else ne=this.Q(Z,J,U),ue=m;this.u[Q]=ue;const _=T.serializeAcknowledged(L);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"ack"),this.c.send(_),ne.then(ae=>{delete this.u[Q];const se=T.serializeReplyOK(L,ae,this.h);this.f?.logOutgoing(se.byteLength,L,o.OtherSide,"reply:",ae),this.c.send(se)},ae=>{delete this.u[Q];const se=T.serializeReplyErr(L,ae);this.f?.logOutgoing(se.byteLength,L,o.OtherSide,"replyErr:",ae),this.c.send(se)})}N(A,L){this.f?.logIncoming(A,L,o.OtherSide,"receiveCancel");const Z=String(L);this.u[Z]?.()}O(A,L,Z){this.f?.logIncoming(A,L,o.LocalSide,"receiveReply:",Z);const J=String(L);if(!this.w.hasOwnProperty(J))return;const U=this.w[J];delete this.w[J],U.resolveOk(Z)}P(A,L,Z){this.f?.logIncoming(A,L,o.LocalSide,"receiveReplyErr:",Z);const J=String(L);if(!this.w.hasOwnProperty(J))return;const U=this.w[J];delete this.w[J];let V;Z&&(Z.$isError?(V=new Error,V.name=Z.name,V.message=Z.message,V.stack=Z.stack):V=Z),U.resolveErr(V)}Q(A,L,Z){try{return Promise.resolve(this.S(A,L,Z))}catch(J){return Promise.reject(J)}}S(A,L,Z){const J=this.m[A];if(!J)throw new Error("Unknown actor "+(0,u.$3w)(A));const U=J[L];if(typeof U!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$3w)(A));return U.apply(J,Z)}U(A,L,Z){if(this.j)return new b.$Tec;let J=null;if(Z.length>0&&P.CancellationToken.isCancellationToken(Z[Z.length-1])&&(J=Z.pop()),J&&J.isCancellationRequested)return Promise.reject(R.$8());const U=T.serializeRequestArguments(Z,this.h),V=++this.t,Q=String(V),ne=new b.$Sec,ue=new p.$Wc;J&&ue.add(J.onCancellationRequested(()=>{const ae=T.serializeCancel(V);this.f?.logOutgoing(ae.byteLength,V,o.LocalSide,"cancel"),this.c.send(T.serializeCancel(V))})),this.w[Q]=new k(ne,ue),this.F(V);const _=T.serializeRequest(V,A,L,U,!!J);return this.f?.logOutgoing(_.byteLength,V,o.LocalSide,`request: ${(0,u.$3w)(A)}.${L}(`,Z),this.c.send(_),ne}}e.$Wec=S;class k{constructor(A,L){this.a=A,this.b=L}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class v{static alloc(A,L,Z){const J=new v(D.$Qe.alloc(Z+1+4),0);return J.writeUInt8(A),J.writeUInt32(L),J}static read(A,L){return new v(A,L)}get buffer(){return this.a}constructor(A,L){this.a=A,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+A).toString();return this.b+=A,Z}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+A).toString();return this.b+=A,Z}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+A);return this.b+=A,L}static sizeMixedArray(A){let L=0;L+=1;for(let Z=0,J=A.length;Z<J;Z++){const U=A[Z];switch(L+=1,U.type){case w.String:L+=this.sizeLongString(U.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(U.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(U.value);for(let V=0;V<U.buffers.length;++V)L+=this.sizeVSBuffer(U.buffers[V]);break;case w.Undefined:break}}return L}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let L=0,Z=A.length;L<Z;L++){const J=A[L];switch(J.type){case w.String:this.writeUInt8(w.String),this.writeLongString(J.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(J.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(J.buffers.length),this.writeLongString(J.value);for(let U=0;U<J.buffers.length;++U)this.writeBuffer(J.buffers[U]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const L=new Array(A);for(let Z=0;Z<A;Z++)switch(this.readUInt8()){case w.String:L[Z]=this.readLongString();break;case w.VSBuffer:L[Z]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const U=this.readUInt32(),V=this.readLongString(),Q=[];for(let ne=0;ne<U;++ne)Q.push(this.readVSBuffer());L[Z]=new u.$4w(i(V,Q,null));break}case w.Undefined:L[Z]=void 0;break}return L}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class T{static a(A){for(let L=0,Z=A.length;L<Z;L++)if(A[L]instanceof D.$Qe||A[L]instanceof u.$4w||typeof A[L]>"u")return!0;return!1}static serializeRequestArguments(A,L){if(this.a(A)){const Z=[];for(let J=0,U=A.length;J<U;J++){const V=A[J];if(V instanceof D.$Qe)Z[J]={type:w.VSBuffer,value:V};else if(typeof V>"u")Z[J]={type:w.Undefined};else if(V instanceof u.$4w){const{jsonString:Q,referencedBuffers:ne}=h(V.value,L);Z[J]={type:w.SerializedObjectWithBuffers,value:D.$Qe.fromString(Q),buffers:ne}}else Z[J]={type:w.String,value:D.$Qe.fromString(n(V,L))}}return{type:C.Mixed,args:Z}}return{type:C.Simple,args:n(A,L)}}static serializeRequest(A,L,Z,J,U){switch(J.type){case C.Simple:return this.b(A,L,Z,J.args,U);case C.Mixed:return this.c(A,L,Z,J.args,U)}}static b(A,L,Z,J,U){const V=D.$Qe.fromString(Z),Q=D.$Qe.fromString(J);let ne=0;ne+=v.sizeUInt8(),ne+=v.sizeShortString(V),ne+=v.sizeLongString(Q);const ue=v.alloc(U?$.RequestJSONArgsWithCancellation:$.RequestJSONArgs,A,ne);return ue.writeUInt8(L),ue.writeShortString(V),ue.writeLongString(Q),ue.buffer}static deserializeRequestJSONArgs(A){const L=A.readUInt8(),Z=A.readShortString(),J=A.readLongString();return{rpcId:L,method:Z,args:JSON.parse(J)}}static c(A,L,Z,J,U){const V=D.$Qe.fromString(Z);let Q=0;Q+=v.sizeUInt8(),Q+=v.sizeShortString(V),Q+=v.sizeMixedArray(J);const ne=v.alloc(U?$.RequestMixedArgsWithCancellation:$.RequestMixedArgs,A,Q);return ne.writeUInt8(L),ne.writeShortString(V),ne.writeMixedArray(J),ne.buffer}static deserializeRequestMixedArgs(A){const L=A.readUInt8(),Z=A.readShortString(),J=A.readMixedArray(),U=new Array(J.length);for(let V=0,Q=J.length;V<Q;V++){const ne=J[V];typeof ne=="string"?U[V]=JSON.parse(ne):U[V]=ne}return{rpcId:L,method:Z,args:U}}static serializeAcknowledged(A){return v.alloc($.Acknowledged,A,0).buffer}static serializeCancel(A){return v.alloc($.Cancel,A,0).buffer}static serializeReplyOK(A,L,Z){if(typeof L>"u")return this.d(A);if(L instanceof D.$Qe)return this.e(A,L);if(L instanceof u.$4w){const{jsonString:J,referencedBuffers:U}=h(L.value,Z,!0);return this.g(A,J,U)}else return this.f(A,f(L,Z))}static d(A){return v.alloc($.ReplyOKEmpty,A,0).buffer}static e(A,L){let Z=0;Z+=v.sizeVSBuffer(L);const J=v.alloc($.ReplyOKVSBuffer,A,Z);return J.writeVSBuffer(L),J.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,L){const Z=D.$Qe.fromString(L);let J=0;J+=v.sizeLongString(Z);const U=v.alloc($.ReplyOKJSON,A,J);return U.writeLongString(Z),U.buffer}static g(A,L,Z){const J=D.$Qe.fromString(L);let U=0;U+=v.sizeUInt32,U+=v.sizeLongString(J);for(const Q of Z)U+=v.sizeVSBuffer(Q);const V=v.alloc($.ReplyOKJSONWithBuffers,A,U);V.writeUInt32(Z.length),V.writeLongString(J);for(const Q of Z)V.writeBuffer(Q);return V.buffer}static deserializeReplyOKJSON(A){const L=A.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(A,L){const Z=A.readUInt32(),J=A.readLongString(),U=[];for(let V=0;V<Z;++V)U.push(A.readVSBuffer());return new u.$4w(i(J,U,L))}static serializeReplyErr(A,L){const Z=L?f(R.$4(L),null):void 0;if(typeof Z!="string")return this.h(A);const J=D.$Qe.fromString(Z);let U=0;U+=v.sizeLongString(J);const V=v.alloc($.ReplyErrError,A,U);return V.writeLongString(J),V.buffer}static deserializeReplyErrError(A){const L=A.readLongString();return JSON.parse(L)}static h(A){return v.alloc($.ReplyErrEmpty,A,0).buffer}}var $;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Re[224],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4uc=void 0;const y=function(N){const R=O=>{globalThis.removeEventListener("message",R);const p=O.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){p.postMessage(s,I)}},onmessage:{get(){return p.onmessage},set(s){p.onmessage=s}}}),p.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class D extends EventTarget{constructor(N,R,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${y})('${R}'))`,s=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(s),b=new MessageChannel,u=I,E={type:"_newWorker",id:u,port:b.port2,url:I,options:O};N(E,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(I),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(f){b.port1.onmessage=f}},onmessageerror:{get(){return b.port1.onmessageerror},set(f){b.port1.onmessageerror=f}}}),b.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),b.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),b.port1.start()}}e.$4uc=D}),define(Re[225],Te([1,0,20,27,15,60,3]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.$IL=void 0,e.$JL=I,e.$KL=b,e.$IL=(0,R.$Ii)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${O.join("")}]+`),s=7;function I(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const f=E.fragment.indexOf("s");if(f<0)return;const r=parseInt(E.fragment.substring(0,f).replace(p,""),s),c=(0,y.$0e)(E.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:E.with({scheme:c,fragment:null})}}function b(E,f){const r=f.toString(s),l=`${r.length<O.length?O[r.length-1]:"z"}${r}s${(0,y.$$e)(y.$Qe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:l})}class u{constructor(){this.a=new D.$Dc}getNotebook(f){if(f.scheme===P.Schemas.vscodeNotebookCell){const r=I(f);if(r){const c=this.a.get(r.notebook);if(c)return c}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$LL=u,(0,N.$Ws)(e.$IL,u,N.InstantiationType.Delayed)}),define(Re[90],Te([1,0,20,41,40,72,15,22,23,31,225]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$3L=e.CellStatusbarAlignment=e.$2L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$YL=e.$XL=e.$VL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UL=e.$TL=e.$SL=e.$RL=e.CellKind=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=void 0,e.$WL=a,e.$ZL=d,e.$1L=S,e.$4L=C,e.$5L=$,D=qe(D),e.$ML="workbench.editor.notebook",e.$NL="workbench.editor.notebookTextDiffEditor",e.$OL="workbench.editor.interactive",e.$PL="workbench.editor.repl",e.$QL="replNotebook.input.execute";var b;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(b||(e.CellKind=b={})),e.$RL=["application/json","application/javascript","text/html","image/svg+xml",N.$dt.latex,N.$dt.markdown,"image/png","image/jpeg",N.$dt.text],e.$SL=[N.$dt.latex,N.$dt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$dt.text],e.$TL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UL="_notAvailable";var u;(function(Q){Q[Q.Running=1]="Running",Q[Q.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var f;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(Q){Q[Q.WithHardKernelDependency=0]="WithHardKernelDependency",Q[Q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Q[Q.Pure=2]="Pure",Q[Q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var c;(function(Q){Q.Always="always",Q.Never="never",Q.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var l;(function(Q){Q[Q.ModelChange=1]="ModelChange",Q[Q.Move=2]="Move",Q[Q.ChangeCellLanguage=5]="ChangeCellLanguage",Q[Q.Initialize=6]="Initialize",Q[Q.ChangeCellMetadata=7]="ChangeCellMetadata",Q[Q.Output=8]="Output",Q[Q.OutputItem=9]="OutputItem",Q[Q.ChangeCellContent=10]="ChangeCellContent",Q[Q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Q[Q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Q[Q.ChangeCellMime=13]="ChangeCellMime",Q[Q.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var h;(function(Q){Q[Q.Handle=0]="Handle",Q[Q.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Output=2]="Output",Q[Q.Metadata=3]="Metadata",Q[Q.CellLanguage=4]="CellLanguage",Q[Q.DocumentMetadata=5]="DocumentMetadata",Q[Q.Move=6]="Move",Q[Q.OutputItems=7]="OutputItems",Q[Q.PartialMetadata=8]="PartialMetadata",Q[Q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Q){Q.scheme=R.Schemas.vscodeNotebookCell;function ne(x,we){return(0,I.$KL)(x,we)}Q.generate=ne;function ue(x){return(0,I.$JL)(x)}Q.parse=ue;function _(x,we){return x.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${x.scheme!==R.Schemas.file?x.scheme:""}`})}Q.generateCellOutputUri=_;function ae(x){if(x.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!we)return;const Ie=we[1]&&we[1]!==""?we[1]:void 0,Y=we[2];return{outputId:Ie,notebook:x.with({scheme:Y||R.Schemas.file,fragment:null})}}Q.parseCellOutputUri=ae;function se(x,we,Ie){return Q.generate(x,we).with({scheme:Ie})}Q.generateCellPropertyUri=se;function ce(x,we){if(x.scheme===we)return Q.parse(x.with({scheme:Q.scheme}))}Q.parseCellPropertyUri=ce})(n||(e.CellUri=n={}));const t=Q=>p.$j?Q.replace(/\//g,"\\"):Q;class o{constructor(ne=[],ue=e.$RL){this.e=ue,this.d=[...new Set(ne)].map(_=>({pattern:_,matches:D.$Dk(t(_))}))}sort(ne){const ue=new Map(P.Iterable.map(ne,ae=>[ae,t(ae)]));let _=[];for(const{matches:ae}of this.d)for(const[se,ce]of ue)if(ae(ce)){_.push(se),ue.delete(se);break}return ue.size&&(_=_.concat([...ue.keys()].sort((ae,se)=>this.e.indexOf(ae)-this.e.indexOf(se)))),_}prioritize(ne,ue){const _=this.f(ne);if(_===-1){this.d.unshift({pattern:ne,matches:D.$Dk(t(ne))});return}const ae=new Set(ue.map(ce=>this.f(ce,_)));ae.delete(-1);const se=Array.from(ae).sort();this.d.splice(_+1,0,...se.map(ce=>this.d[ce]));for(let ce=se.length-1;ce>=0;ce--)this.d.splice(se[ce],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,ue=this.d.length){const _=t(ne);for(let ae=0;ae<ue;ae++)if(this.d[ae].matches(_))return ae;return-1}}e.$VL=o;function a(Q,ne,ue,_=(ae,se)=>ae===se){const ae=[];function se(we,Ie,Y){if(Ie===0&&Y.length===0)return;const q=ae[ae.length-1];q&&q.start+q.deleteCount===we?(q.deleteCount+=Ie,q.toInsert.push(...Y)):ae.push({start:we,deleteCount:Ie,toInsert:Y})}let ce=0,x=0;for(;;){if(ce===Q.length){se(ce,0,ne.slice(x));break}if(x===ne.length){se(ce,Q.length-ce,[]);break}const we=Q[ce],Ie=ne[x];if(_(we,Ie)){ce+=1,x+=1;continue}ue(Ie)?(se(ce,1,[]),ce+=1):(se(ce,0,[Ie]),x+=1)}return ae}e.$XL=new s.$Zj("notebookEditorCursorAtBoundary","none"),e.$YL=new s.$Zj("notebookEditorCursorAtLineBoundary","none");var m;(function(Q){Q.default="default",Q.option="option"})(m||(e.NotebookEditorPriority=m={}));var g;(function(Q){Q.Cells="cells",Q.Text="text",Q.None="none"})(g||(e.NotebookFindScopeType=g={}));function d(Q){const ne=Q;return!!((typeof ne.include=="string"||D.$Ek(ne.include))&&(typeof ne.exclude=="string"||D.$Ek(ne.exclude)))}function S(Q,ne,ue){if(Array.isArray(Q.viewType)&&Q.viewType.indexOf(ne)>=0||Q.viewType===ne)return!0;if(Q.filenamePattern){const _=d(Q.filenamePattern)?Q.filenamePattern.include:Q.filenamePattern,ae=d(Q.filenamePattern)?Q.filenamePattern.exclude:void 0;if(D.$Ck(_,(0,O.$qc)(ue.fsPath).toLowerCase()))return!(ae&&D.$Ck(ae,(0,O.$qc)(ue.fsPath).toLowerCase()))}return!1}e.$2L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var k;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(k||(e.CellStatusbarAlignment=k={}));class v{static{this.d="notebook/"}static create(ne){return`${v.d}${ne}`}static parse(ne){if(ne.startsWith(v.d))return ne.substring(v.d.length)}}e.$3L=v;function C(Q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Q)}const T=new TextDecoder;function $(Q){const ne=[];let ue=!1;for(const ce of Q)(ne.length===0||ue)&&(ne.push(ce),ue=!0);let _=A(ne);const ae=y.$Qe.concat(ne.map(ce=>y.$Qe.wrap(ce))),se=V(ae);return _=_||se.byteLength!==ae.byteLength,{data:se,didCompression:_}}e.$6L="\x1B[A";const w=e.$6L.split("").map(Q=>Q.charCodeAt(0)),M=10;function A(Q){let ne=!1;return Q.forEach((ue,_)=>{if(_===0||ue.length<e.$6L.length)return;const ae=Q[_-1],se=ue.subarray(0,e.$6L.length);if(se[0]===w[0]&&se[1]===w[1]&&se[2]===w[2]){const ce=ae.lastIndexOf(M);if(ce===-1)return;ne=!0,Q[_-1]=ae.subarray(0,ce),Q[_]=ue.subarray(e.$6L.length)}}),ne}function L(Q){let ne=Q;do Q=ne,ne=Q.replace(/[^\n]\x08/gm,"");while(ne.length<Q.length);return Q}function Z(Q){for(Q=Q.replace(/\r+\n/gm,`
`);Q.search(/\r[^$]/g)>-1;){const ne=Q.match(/^(.*)\r+/m)[1];let ue=Q.match(/\r+(.*)$/m)[1];ue=ue+ne.slice(ue.length,ne.length),Q=Q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return Q}const J=8,U=13;function V(Q){return!Q.buffer.includes(J)&&!Q.buffer.includes(U)?Q:y.$Qe.fromString(Z(L(T.decode(Q.buffer))))}}),define(Re[7],Te([1,0,17,12,59,27,72,13,14,2,38,18,28,110,90]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f){"use strict";var r,c,l,h,i,n,t,o,a,m,g,d,S,k,v,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$sQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.LanguageModelChatMessageRole=e.$jQ=e.$iQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$4P=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$QP=e.$PP=e.$OP=e.$NP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.TestRunProfileKind=e.TestResultState=e.$GP=e.$FP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$EP=e.NotebookVariablesRequestKind=e.$DP=e.$CP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$BP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.ColorThemeKind=e.$vP=e.$uP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$tP=e.QuickInputButtonLocation=e.$sP=e.DebugConsoleMode=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mP=e.$lP=e.FileChangeType=e.$kP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$jP=e.$iP=e.$hP=e.$gP=e.InlineCompletionTriggerKind=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$6O=e.ConfigurationTarget=e.$5O=e.$4O=e.$3O=e.$2O=e.DocumentPasteTriggerKind=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UO=e.ViewBadge=e.ProgressLocation=e.$TO=e.$SO=e.TaskScope=e.ShellQuoting=e.$RO=e.$QO=e.$PO=e.TaskPanelKind=e.TaskRevealKind=e.$OO=e.TerminalLocation=e.$NO=e.$MO=e.$LO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KO=e.$JO=e.$IO=e.$HO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BO=e.$AO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.LanguageStatusSeverity=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.CodeActionTriggerKind=e.$oO=e.$nO=e.SymbolTag=e.SymbolKind=e.$mO=e.$lO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.DiagnosticSeverity=e.DiagnosticTag=e.$fO=e.$eO=e.FileEditType=e.$dO=e.$cO=e.$bO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$aO=e.$_N=e.$$N=e.$8N=e.$7N=e.$6N=e.$5N=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=U,e.$0N=V,e.$GO=ht,e.$7O=ji,e.$MP=Cn;function $(z){return Object.assign(z,{apply:function(...te){if(te.length===0)return Reflect.construct(z,[]);{const Se=te.length===1?[]:te[1];return Reflect.construct(z,Se,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(z,[]);{const[Se,...He]=te;return Reflect.construct(z,He,Se.constructor)}}})}var w;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let A=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$5N=A,e.$5N=A=r=Ke([$],A);let L=c=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const He=F[Se];He.isBefore(te)&&(te=He)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const He=F[Se];He.isAfter(te)&&(te=He)}return te}static isPosition(F){if(!F)return!1;if(F instanceof c)return!0;const{line:te,character:Se}=F;return typeof te=="number"&&typeof Se=="number"}static of(F){if(F instanceof c)return F;if(this.isPosition(F))return new c(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,D.$9)("line must be non-negative");if(te<0)throw(0,D.$9)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,D.$9)();let Se;return typeof F>"u"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&te===0?this:new c(this.line+Se,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,D.$9)();let Se;return typeof F>"u"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Se===this.line&&te===this.character?this:new c(Se,te)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$6N=L,e.$6N=L=c=Ke([$],L);let Z=l=class{static isRange(F){return F instanceof l?!0:F?L.isPosition(F.start)&&L.isPosition(F.end):!1}static of(F){if(F instanceof l)return F;if(this.isRange(F))return new l(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Se,He){let rt,mt;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof He=="number"?(rt=new L(F,te),mt=new L(Se,He)):L.isPosition(F)&&L.isPosition(te)&&(rt=L.of(F),mt=L.of(te)),!rt||!mt)throw new Error("Invalid arguments");rt.isBefore(mt)?(this.c=rt,this.e=mt):(this.c=mt,this.e=rt)}contains(F){return l.isRange(F)?this.contains(F.start)&&this.contains(F.end):L.isPosition(F)?!(L.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=L.Max(F.start,this.c),Se=L.Min(F.end,this.e);if(!te.isAfter(Se))return new l(te,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=L.Min(F.start,this.c),Se=L.Max(F.end,this.end);return new l(te,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,D.$9)();let Se;return F?L.isPosition(F)?Se=F:(Se=F.start||this.start,te=F.end||this.end):Se=this.start,Se.isEqual(this.c)&&te.isEqual(this.end)?this:new l(Se,te)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return U(this)}};e.$7N=Z,e.$7N=Z=l=Ke([$],Z);let J=h=class extends Z{static isSelection(F){return F instanceof h?!0:F?Z.isRange(F)&&L.isPosition(F.anchor)&&L.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Se,He){let rt,mt;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof He=="number"?(rt=new L(F,te),mt=new L(Se,He)):L.isPosition(F)&&L.isPosition(te)&&(rt=L.of(F),mt=L.of(te)),!rt||!mt)throw new Error("Invalid arguments");super(rt,mt),this.f=rt,this.g=mt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return V(this)}};e.$8N=J,e.$8N=J=h=Ke([$],J);function U(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function V(z){let F=U(z);return z.isEmpty||(z.active.isEqual(z.start)?F=`|${F}`:F=`${F}|`),F}const Q=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,D.$9)("connectionToken")};class ne{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Se){if(typeof F!="string"||F.length===0)throw(0,D.$9)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,D.$9)("port");typeof Se<"u"&&Q(Se),this.host=F,this.port=Math.round(te),this.connectionToken=Se}}e.$$N=ne;class ue{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&Q(te)}}e.$_N=ue;class _ extends Error{static NotAvailable(F,te){return new _(F,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new _(F,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F),this._message=F,this._code=te,this._detail=Se,Object.setPrototypeOf(this,_.prototype)}}e.$aO=_;var ae;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ae||(e.EndOfLine=ae={}));var se;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(se||(e.EnvironmentVariableMutatorType=se={}));let ce=i=class{static isTextEdit(F){return F instanceof i?!0:F?Z.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new Z(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new Z(new L(0,0),new L(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!Z.isRange(F))throw(0,D.$9)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,D.$9)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,D.$9)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$bO=ce,e.$bO=ce=i=Ke([$],ce);let x=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?ki.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new n(F,te)}static insertCells(F,te){return new n(new ki(F,F),te)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,te){const Se=new n(new ki(F,F),[]);return Se.newCellMetadata=te,Se}static updateNotebookMetadata(F){const te=new n(new ki(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$cO=x,e.$cO=x=n=Ke([$],x);class we{static isSnippetTextEdit(F){return F instanceof we?!0:F?Z.isRange(F.range)&&q.isSnippetString(F.snippet):!1}static replace(F,te){return new we(F,te)}static insert(F,te){return we.replace(new Z(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$dO=we;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Se,He){this.c.push({_type:Ie.File,from:F,to:te,options:Se,metadata:He})}createFile(F,te,Se){this.c.push({_type:Ie.File,from:void 0,to:F,options:te,metadata:Se})}deleteFile(F,te,Se){this.c.push({_type:Ie.File,from:F,to:void 0,options:te,metadata:Se})}e(F,te,Se){this.c.push({_type:Ie.Cell,metadata:Se,uri:F,edit:{editType:f.CellEditType.DocumentMetadata,metadata:te},notebookMetadata:te})}f(F,te,Se,He){const rt=te.start,mt=te.end;(rt!==mt||Se.length>0)&&this.c.push({_type:Ie.CellReplace,uri:F,index:rt,count:mt-rt,cells:Se,metadata:He})}g(F,te,Se,He){this.c.push({_type:Ie.Cell,metadata:He,uri:F,edit:{editType:f.CellEditType.Metadata,index:te,metadata:Se}})}replace(F,te,Se,He){this.c.push({_type:Ie.Text,uri:F,edit:new ce(te,Se),metadata:He})}insert(F,te,Se,He){this.replace(F,new Z(te,te),Se,He)}delete(F,te,Se){this.replace(F,te,"",Se)}has(F){return this.c.some(te=>te._type===Ie.Text&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Se of te){if(!Se)continue;let He,rt;Array.isArray(Se)?(He=Se[0],rt=Se[1]):He=Se,x.isNotebookCellEdit(He)?He.newCellMetadata?this.g(F,He.range.start,He.newCellMetadata,rt):He.newNotebookMetadata?this.e(F,He.newNotebookMetadata,rt):this.f(F,He.range,He.newCells,rt):we.isSnippetTextEdit(He)?this.c.push({_type:Ie.Snippet,uri:F,range:He.range,edit:He.snippet,metadata:rt}):this.c.push({_type:Ie.Text,uri:F,edit:He,metadata:rt})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case Ie.Text:case Ie.Snippet:case Ie.Cell:case Ie.CellReplace:He.uri.toString()===F.toString()&&(this.c[Se]=void 0);break}}(0,y.$Kb)(this.c)}}get(F){const te=[];for(const Se of this.c)Se._type===Ie.Text&&Se.uri.toString()===F.toString()&&te.push(Se.edit);return te}entries(){const F=new N.$Dc;for(const te of this.c)if(te._type===Ie.Text){let Se=F.get(te.uri);Se||(Se=[te.uri,[]],F.set(te.uri,Se)),Se[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$eO=Y,e.$eO=Y=Ke([$],Y);let q=t=class{static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=t.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Se=new t;Se.e=this.e,F(Se),this.e=Se.e,F=Se.value}else F=t.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Se=F.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Se=new t;Se.e=this.e,te(Se),this.e=Se.e,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$fO=q,e.$fO=q=t=Ke([$],q);var ie;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var ve;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let Pe=o=class{static isLocation(F){return F instanceof o?!0:F?Z.isRange(F.range)&&s.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(Z.isRange(te))this.range=Z.of(te);else if(L.isPosition(te))this.range=new Z(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$gO=Pe,e.$gO=Pe=o=Ke([$],Pe);let Fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&Z.isRange(F.location.range)&&s.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$hO=Fe,e.$hO=Fe=Ke([$],Fe);let Be=class{constructor(F,te,Se=ve.Error){if(!Z.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Se}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,y.$wb)(F.tags,te.tags)&&(0,y.$wb)(F.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$iO=Be,e.$iO=Be=Ke([$],Be);let xe=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$jO=xe,e.$jO=xe=Ke([$],xe);let nt=class extends xe{constructor(F,te,Se,He){super(F,te),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=He}};e.$kO=nt,e.$kO=nt=Ke([$],nt);var ut;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(ut||(e.HoverVerbosityAction=ut={}));var pt;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(pt||(e.DocumentHighlightKind=pt={}));let lt=class{constructor(F,te=pt.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:pt[this.kind]}}};e.$lO=lt,e.$lO=lt=Ke([$],lt);let et=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$mO=et,e.$mO=et=Ke([$],et);var Ne;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var Me;(function(z){z[z.Deprecated=1]="Deprecated"})(Me||(e.SymbolTag=Me={}));let Le=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Se,He,rt){this.name=F,this.kind=te,this.containerName=rt,typeof Se=="string"&&(this.containerName=Se),He instanceof Pe?this.location=He:Se instanceof Z&&(this.location=new Pe(He,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$nO=Le,e.$nO=Le=a=Ke([$],Le);let B=m=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(m.validate)}constructor(F,te,Se,He,rt){this.name=F,this.detail=te,this.kind=Se,this.range=He,this.selectionRange=rt,this.children=[],m.validate(this)}};e.$oO=B,e.$oO=B=m=Ke([$],B);var j;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let H=class{constructor(F,te){this.title=F,this.kind=te}};e.$pO=H,e.$pO=H=Ke([$],H);let G=class{static{g=this}static{this.c="."}constructor(F){this.value=F}append(F){return new g(this.value?this.value+g.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+g.c)}};e.$qO=G,e.$qO=G=g=Ke([$],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let re=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rO=re,e.$rO=re=Ke([$],re);class ge{constructor(F,te,Se,He,rt,mt){this.kind=F,this.name=te,this.detail=Se,this.uri=He,this.range=rt,this.selectionRange=mt}}e.$sO=ge;class Ee{constructor(F,te){this.fromRanges=te,this.from=F}}e.$tO=Ee;class Ue{constructor(F,te){this.fromRanges=te,this.to=F}}e.$uO=Ue;var Je;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Je||(e.LanguageStatusSeverity=Je={}));let _e=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$vO=_e,e.$vO=_e=Ke([$],_e);let tt=d=class{#e;static isMarkdownString(F){return F instanceof d?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new P.$7k(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$wO=tt,e.$wO=tt=d=Ke([$],tt);let at=class{constructor(F,te){this.label=F,this.documentation=te}};e.$xO=at,e.$xO=at=Ke([$],at);let it=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$yO=it,e.$yO=it=Ke([$],it);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zO=ot,e.$zO=ot=Ke([$],ot);var vt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(vt||(e.SignatureHelpTriggerKind=vt={}));var Ye;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ye||(e.InlayHintKind=Ye={}));let he=class{constructor(F){this.value=F}};e.$AO=he,e.$AO=he=Ke([$],he);let pe=class{constructor(F,te,Se){this.position=F,this.label=te,this.kind=Se}};e.$BO=pe,e.$BO=pe=Ke([$],pe);var ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Ce;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ce||(e.CompletionItemKind=Ce={}));var fe;(function(z){z[z.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let be=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CO=be,e.$CO=be=Ke([$],be);let X=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$DO=X,e.$DO=X=Ke([$],X);let W=class{constructor(F,te,Se){this.insertText=F,this.range=te,this.command=Se}};e.$EO=W,e.$EO=W=Ke([$],W);let de=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$FO=de,e.$FO=de=Ke([$],de);var je;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(je||(e.PartialAcceptTriggerKind=je={}));var Qe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var st;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function ht(z,F){return`${b.$un.toKey(z)}.${F}`}var gt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var Rt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var At;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var Qt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Ze;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Ze||(e.DecorationRangeBehavior=Ze={})),function(z){function F(te){switch(te){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Ot;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(z){function F(te){switch(te){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=F}(Ot||(e.SyntaxTokenType=Ot={}));let Ut=class{constructor(F,te){if(te&&!s.URI.isUri(te))throw(0,D.$9)("target");if(!Z.isRange(F)||F.isEmpty)throw(0,D.$9)("range");this.range=F,this.target=te}};e.$HO=Ut,e.$HO=Ut=Ke([$],Ut);let $t=class{constructor(F,te,Se,He){this.red=F,this.green=te,this.blue=Se,this.alpha=He}};e.$IO=$t,e.$IO=$t=Ke([$],$t);let Pt=class{constructor(F,te){if(te&&!(te instanceof $t))throw(0,D.$9)("color");if(!Z.isRange(F)||F.isEmpty)throw(0,D.$9)("range");this.range=F,this.color=te}};e.$JO=Pt,e.$JO=Pt=Ke([$],Pt);let ei=class{constructor(F){if(!F||typeof F!="string")throw(0,D.$9)("label");this.label=F}};e.$KO=ei,e.$KO=ei=Ke([$],ei);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var Ht;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var wt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Nt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Nt||(e.TerminalShellExecutionCommandLineConfidence=Nt={}));class ai{constructor(F,te,Se){if(this.startIndex=F,this.length=te,this.tooltip=Se,typeof F!="number"||F<0)throw(0,D.$9)("startIndex");if(typeof te!="number"||te<1)throw(0,D.$9)("length");if(Se!==void 0&&typeof Se!="string")throw(0,D.$9)("tooltip")}}e.$LO=ai;class Zt{constructor(F){this.uri=F}}e.$MO=Zt;class Ge{constructor(F){this.terminalCommand=F}}e.$NO=Ge;var ii;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class ci{constructor(F){if(this.options=F,typeof F!="object")throw(0,D.$9)("options")}}e.$OO=ci;var ui;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(ui||(e.TaskRevealKind=ui={}));var Et;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Et||(e.TaskPanelKind=Et={}));let jt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(F){switch(F){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,D.$9)("name");this.c=F}get id(){return this.c}};e.$PO=jt,e.$PO=jt=S=Ke([$],jt);function Lt(z){let F="";for(let te=0;te<z.length;te++)F+=z[te].replace(/,/g,",,")+",";return F}let Bt=class{constructor(F,te,Se){if(typeof F!="string")throw(0,D.$9)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Se):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,D.$9)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Lt(F)}};e.$QO=Bt,e.$QO=Bt=Ke([$],Bt);let oi=class{constructor(F,te,Se){if(this.f=[],Array.isArray(te)){if(!F)throw(0,D.$9)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,D.$9)("command");this.e=F,this.f=te,this.g=Se}else{if(typeof F!="string")throw(0,D.$9)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,D.$9)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,D.$9)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Lt(F)}};e.$RO=oi,e.$RO=oi=Ke([$],oi);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Kt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,I.$5g)()}set callback(F){this.c=F}get callback(){return this.c}}e.$SO=Kt;let Gt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Se,He,rt,mt){this.k=!1,this.l=this.definition=F;let yt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Se,this.execution=He,yt=rt,this.k=!0):te===ri.Global||te===ri.Workspace?(this.target=te,this.o=this.name=Se,this.w=this.source=He,this.execution=rt,yt=mt):(this.target=te,this.o=this.name=Se,this.w=this.source=He,this.execution=rt,yt=mt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof oi?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,I.$5g)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,D.$9)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,D.$9)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(k.g===te||k.e===te||k.f===te||k.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,D.$9)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$TO=Gt,e.$TO=Gt=k=Ke([$],Gt);var li;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(li||(e.ProgressLocation=li={}));var Mt;(function(z){function F(te){const Se=te;return(0,p.$lg)(Se.value)?Se.tooltip&&!(0,p.$hg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let Dt=v=class{static isTreeItem(F,te){const Se=F;if(Se.checkboxState!==void 0){const He=(0,p.$lg)(Se.checkboxState)?Se.checkboxState:(0,p.$jg)(Se.checkboxState)&&(0,p.$lg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,rt=!(0,p.$lg)(Se.checkboxState)&&(0,p.$jg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==Jt.Checked&&He!==Jt.Unchecked||rt!==void 0&&!(0,p.$hg)(rt))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(F instanceof v)return!0;if(Se.label!==void 0&&!(0,p.$hg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$hg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$hg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$hg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,p.$hg)(He.light)&&!s.URI.isUri(He.light)&&!(0,p.$hg)(He.dark)&&!s.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$hg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$hg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<bt.None&&Se.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$hg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(F,te=bt.None){this.collapsibleState=te,s.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$UO=Dt,e.$UO=Dt=v=Ke([$],Dt);var bt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Jt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Jt||(e.TreeItemCheckboxState=Jt={}));let St=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$VO=St,e.$VO=St=Ke([$],St);class hi extends St{}e.$WO=hi;class Xt extends hi{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$XO=Xt;class Mi{constructor(F,te,Se,He){this.name=F,this.uri=te,this._itemId=Se,this.c=He}data(){return this.c()}}e.$YO=Mi;let di=class{#e=new Map;constructor(F){for(const[te,Se]of F??[]){const He=this.#e.get(this.#t(te));He?He.push(Se):this.#e.set(this.#t(te),[Se])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Se,He]of this.#e)for(const rt of He)F.call(te,rt,Se,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Se of te)yield[F,Se]}#t(F){return F.toLowerCase()}};e.$ZO=di,e.$ZO=di=Ke([$],di);let yi=class{constructor(F,te,Se){this.insertText=F,this.title=te,this.kind=Se}};e.$1O=yi,e.$1O=yi=Ke([$],yi);var qt;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(qt||(e.DocumentPasteTriggerKind=qt={}));class fi{static{this.c="."}constructor(F){this.value=F}append(...F){return new fi((this.value?[this.value,...F]:F).join(fi.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+fi.c)}}e.$2O=fi,fi.Empty=new fi("");class Fi{constructor(F,te,Se){this.title=te,this.insertText=F,this.kind=Se}}e.$3O=Fi;let Ct=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$4O=Ct,e.$4O=Ct=Ke([$],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Si=class{constructor(F){this.id=F}};e.$5O=Si,e.$5O=Si=Ke([$],Si);var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let gi=class{get base(){return this.c}set base(F){this.c=F,this.e=s.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!s.URI.isUri(F)&&!s.URI.isUri(F.uri)))throw(0,D.$9)("base");if(typeof te!="string")throw(0,D.$9)("pattern");typeof F=="string"?this.baseUri=s.URI.file(F):s.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$6O=gi,e.$6O=gi=Ke([$],gi);const zi=new WeakMap;function ji(z,F){zi.set(z,F)}let zt=class{constructor(F,te,Se,He,rt){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=zi.get(this)??(0,I.$5g)()),this.c}};e.$8O=zt,e.$8O=zt=Ke([$],zt);let Pi=class extends zt{constructor(F,te,Se,He,rt,mt){if(super(te,Se,He,rt,mt),F===null)throw(0,D.$9)("location");this.location=F}};e.$9O=Pi,e.$9O=Pi=Ke([$],Pi);let Di=class extends zt{constructor(F,te,Se,He,rt,mt){super(te,Se,He,rt,mt),this.functionName=F}};e.$0O=Di,e.$0O=Di=Ke([$],Di);let wi=class extends zt{constructor(F,te,Se,He,rt,mt,yt,xt){if(super(He,rt,mt,yt,xt),!te)throw(0,D.$9)("dataId");this.label=F,this.dataId=te,this.canPersist=Se}};e.$$O=wi,e.$$O=wi=Ke([$],wi);let bi=class{constructor(F,te,Se){this.command=F,this.args=te||[],this.options=Se}};e.$_O=bi,e.$_O=bi=Ke([$],bi);let me=class{constructor(F,te){this.port=F,this.host=te}};e.$aP=me,e.$aP=me=Ke([$],me);let De=class{constructor(F){this.path=F}};e.$bP=De,e.$bP=De=Ke([$],De);let oe=class{constructor(F){this.implementation=F}};e.$cP=oe,e.$cP=oe=Ke([$],oe);class K{constructor(F,te,Se){this.session=F,this.threadId=te,this.frameId=Se}}e.$dP=K;class ke{constructor(F,te){this.session=F,this.threadId=te}}e.$eP=ke;let ze=class{constructor(F,te){this.range=F,this.expression=te}};e.$fP=ze,e.$fP=ze=Ke([$],ze);var Xe;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Xe||(e.InlineCompletionTriggerKind=Xe={}));let Ve=class{constructor(F,te){this.range=F,this.text=te}};e.$gP=Ve,e.$gP=Ve=Ke([$],Ve);let ft=class{constructor(F,te,Se=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Se}};e.$hP=ft,e.$hP=ft=Ke([$],ft);let Tt=class{constructor(F,te){this.range=F,this.expression=te}};e.$iP=Tt,e.$iP=Tt=Ke([$],Tt);let Yt=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$jP=Yt,e.$jP=Yt=Ke([$],Yt);var Vt;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var Wt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Wt||(e.NewSymbolNameTriggerKind=Wt={}));class Ni{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$kP=Ni;var en;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=C=class extends Error{static FileExists(F){return new C(F,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(F){return new C(F,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(F){return new C(F,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(F){return new C(F,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(F){return new C(F,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(F){return new C(F,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(F)?F.toString(!0):F),this.code=Se?.name??"Unknown",(0,u.$sl)(this,te),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$lP=Vi,e.$lP=Vi=C=Ke([$],Vi);let Ei=class{constructor(F,te,Se){this.start=F,this.end=te,this.kind=Se}};e.$mP=Ei,e.$mP=Ei=Ke([$],Ei);var tn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Qi;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));var sn;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$nP=on;function wn(z){return typeof z>"u"||(0,p.$ig)(z)}class Ci{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Se=F.tokenTypes.length;te<Se;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Se=F.tokenModifiers.length;te<Se;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Se,He,rt){if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(F,te,Se,He,rt);if(Z.isRange(F)&&typeof te=="string"&&wn(Se))return this.o(F,te,Se);throw(0,D.$9)()}o(F,te,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const He=F.start.line,rt=F.start.character,mt=F.end.character-F.start.character,yt=this.k.get(te);let xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get($i);xt|=1<<vi>>>0}this.q(He,rt,mt,yt,xt)}q(F,te,Se,He,rt){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const xt=this.g.length/5|0;let $i=0,vi=0;for(let Ii=0;Ii<xt;Ii++){let Oi=this.g[5*Ii],xi=this.g[5*Ii+1];Oi===0?(Oi=$i,xi+=vi):Oi+=$i,this.g[5*Ii]=Oi,this.g[5*Ii+1]=xi,$i=Oi,vi=xi}}let mt=F,yt=te;this.f&&this.j>0&&(mt-=this.c,mt===0&&(yt-=this.e)),this.g[this.j++]=mt,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=rt,this.c=F,this.e=te}static r(F){const te=[],Se=F.length/5|0;for(let yt=0;yt<Se;yt++)te[yt]=yt;te.sort((yt,xt)=>{const $i=F[5*yt],vi=F[5*xt];if($i===vi){const Ii=F[5*yt+1],Oi=F[5*xt+1];return Ii-Oi}return $i-vi});const He=new Uint32Array(F.length);let rt=0,mt=0;for(let yt=0;yt<Se;yt++){const xt=5*te[yt],$i=F[xt+0],vi=F[xt+1],Ii=F[xt+2],Oi=F[xt+3],xi=F[xt+4],Qn=$i-rt,Mr=Qn===0?vi-mt:vi,_i=5*yt;He[_i+0]=Qn,He[_i+1]=Mr,He[_i+2]=Ii,He[_i+3]=Oi,He[_i+4]=xi,rt=$i,mt=vi}return He}build(F){return this.f?new Hi(new Uint32Array(this.g),F):new Hi(Ci.r(this.g),F)}}e.$oP=Ci;class Hi{constructor(F,te){this.resultId=te,this.data=F}}e.$pP=Hi;class bn{constructor(F,te,Se){this.start=F,this.deleteCount=te,this.data=Se}}e.$qP=bn;class vn{constructor(F,te){this.resultId=te,this.edits=F}}e.$rP=vn;var Wi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Wi||(e.DebugConsoleMode=Wi={}));class an{constructor(F){this.name=F}}e.$sP=an;var Ae;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Ae||(e.QuickInputButtonLocation=Ae={}));let mi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$tP=mi,e.$tP=mi=Ke([$],mi);var Ki;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var ct;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ct||(e.InputBoxValidationSeverity=ct={}));var kt;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(kt||(e.ExtensionKind=kt={}));class yn{static validate(F){if(typeof F.badge=="string"){let te=(0,O.$Sf)(F.badge,0);if(te<F.badge.length&&(te+=(0,O.$Sf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ct.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Se){this.badge=F,this.tooltip=te,this.color=Se}}e.$uP=yn;let Gi=class{constructor(F){this.kind=F}};e.$vP=Gi,e.$vP=Gi=Ke([$],Gi);var Ji;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(F){return F instanceof ki?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,D.$9)("start must be positive");if(te<0)throw(0,D.$9)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Se=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Se=F.end),te===this.c&&Se===this.e?this:new ki(te,Se)}}e.$wP=ki;class Ri{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>Ri.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Se,He,rt,mt,yt){this.kind=F,this.value=te,this.languageId=Se,this.mime=He,this.outputs=rt??[],this.metadata=mt,this.executionSummary=yt,Ri.validate(this)}}e.$xP=Ri;class Sn{constructor(F){this.cells=F}}e.$yP=Sn;class pi{static isNotebookCellOutputItem(F){return F instanceof pi?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return pi.json(te,"application/vnd.code.notebook.error")}static stdout(F){return pi.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return pi.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new pi(F,te)}static#e=new TextEncoder;static text(F,te=R.$dt.text){const Se=pi.#e.encode(String(F));return new pi(Se,te)}static json(F,te="text/x-json"){const Se=JSON.stringify(F,void 0,"	");return pi.text(Se,te)}constructor(F,te){this.data=F,this.mime=te;const Se=(0,R.$ht)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$zP=pi;class qi{static isNotebookCellOutput(F){return F instanceof qi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Se=new Set,He=new Set;for(let rt=0;rt<F.length;rt++){const mt=F[rt],yt=(0,R.$ht)(mt.mime);if(!Se.has(yt)||(0,f.$4L)(yt)){Se.add(yt);continue}He.add(rt),te&&console.warn(`DUPLICATED mime type '${mt.mime}' will be dropped`)}return He.size===0?F:F.filter((rt,mt)=>!He.has(mt))}constructor(F,te,Se){this.items=qi.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,I.$5g)(),this.metadata=te??Se)}}e.$AP=qi;var Zi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Zi||(e.NotebookCellKind=Zi={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class En{constructor(F,te){this.text=F,this.alignment=te}}e.$BP=En;var hn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(F,te=[]){this.uri=F,this.provides=(0,y.$4b)(te)}}e.$CP=kn;class In{constructor(F){this.label=F}}e.$DP=In;var fn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Xi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$EP=Xi,e.$EP=Xi=Ke([$],Xi);var gn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var ee;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(ee||(e.ExtensionRuntime=ee={}));var le;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(le||(e.StandardTokenType=le={}));class Oe{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$FP=Oe;class dt{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$GP=dt;var It;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(It||(e.TestResultState=It={}));var Ft;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Ti=class{constructor(F=void 0,te=void 0,Se=void 0,He=!1,rt=!0){this.include=F,this.exclude=te,this.profile=Se,this.continuous=He,this.preserveFocus=rt}};e.$HP=Ti,e.$HP=Ti=Ke([$],Ti);let Yi=T=class{static diff(F,te,Se){const He=new T(F);return He.expectedOutput=te,He.actualOutput=Se,He}constructor(F){this.message=F}};e.$IP=Yi,e.$IP=Yi=T=Ke([$],Yi);let Pn=class{constructor(F){this.id=F}};e.$JP=Pn,e.$JP=Pn=Ke([$],Pn);class Gn{constructor(F,te,Se){this.label=F,this.uri=te,this.position=Se}}e.$KP=Gn;class mn{constructor(F,te){this.covered=F,this.total=te,Cn(this)}}e.$LP=mn;function Cn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Dn{static fromDetails(F,te){const Se=new mn(0,0),He=new mn(0,0),rt=new mn(0,0);for(const yt of te)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const xt of yt.branches)He.total+=1,He.covered+=xt.executed?1:0}else rt.total+=1,rt.covered+=yt.executed?1:0;const mt=new Dn(F,Se,He.total>0?He:void 0,rt.total>0?rt:void 0);return mt.detailedCoverage=te,mt}constructor(F,te,Se,He,rt=[]){this.uri=F,this.statementCoverage=te,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=rt}}e.$NP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se=[]){this.executed=F,this.location=te,this.branches=Se}}e.$OP=Jn;class Zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se){this.executed=F,this.location=te,this.label=Se}}e.$PP=Zn;class Xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se){this.name=F,this.executed=te,this.location=Se}}e.$QP=Xn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var Tn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(F,te,Se,He,rt,mt){this.kind=F,this.name=te,this.detail=Se,this.uri=He,this.range=rt,this.selectionRange=mt}}e.$RP=Yn;class xn{constructor(F){this.uri=F}}e.$SP=xn;class _n{constructor(F,te){this.original=F,this.modified=te}}e.$TP=_n;class er{constructor(F,te,Se,He){this.base=F,this.input1=te,this.input2=Se,this.result=He}}e.$UP=er;class tr{constructor(F,te){this.uri=F,this.viewType=te}}e.$VP=tr;class ir{constructor(F){this.viewType=F}}e.$WP=ir;class nr{constructor(F,te){this.uri=F,this.notebookType=te}}e.$XP=nr;class rr{constructor(F,te,Se){this.original=F,this.modified=te,this.notebookType=Se}}e.$YP=rr;class sr{constructor(){}}e.$ZP=sr;class or{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$1P=or;class ar{constructor(){}}e.$2P=ar;class cr{constructor(F){this.textDiffs=F}}e.$3P=cr;var An;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Nn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Ln;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class lr{constructor(F,te,Se){this.id=F,this.label=te,this.values=Se}}e.$4P=lr;var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$5P=ur;class hr{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F,this.vulnerabilities=te}}e.$6P=hr;class dr{constructor(F,te){this.participant=F,this.command=te}}e.$7P=dr;class fr{constructor(F,te,Se,He){this.title=F,this.message=te,this.data=Se,this.buttons=He}}e.$8P=fr;class gr{constructor(F,te){this.value=F,this.baseUri=te}}e.$9P=gr;class mr{constructor(F,te){this.value=F,this.title=te}}e.$0P=mr;class pr{constructor(F){this.value=F}}e.$$P=pr;class $r{constructor(F,te){this.value=F,this.task=te}}e.$_P=$r;class wr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$aQ=wr;class br{constructor(F){this.value=F}}e.$bQ=br;class vr{constructor(F,te,Se){this.value=F,this.iconPath=te,this.options=Se}}e.$cQ=vr;class yr{constructor(F,te,Se){this.value=F,this.license=te,this.snippet=Se}}e.$dQ=yr;class Sr{constructor(F,te){this.uri=F,this.range=te}}e.$eQ=Sr;class Er{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$fQ=Er;class kr{constructor(F,te,Se,He){this.prompt=F,this.command=te,this.references=Se,this.participant=He}}e.$gQ=kr;class Ir{constructor(F,te,Se,He){this.response=F,this.result=te,this.participant=Se,this.command=He}}e.$hQ=Ir;var zn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Un;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Pr{constructor(F,te,Se){this.document=F,this.selection=te,this.wholeRange=Se}}e.$iQ=Pr;class Dr{constructor(F){this.cell=F}}e.$jQ=Dr;var pn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(F,te,Se){this.name=F,this.content=te,this.isError=Se??!1}}e.$kQ=Cr;class $n{static User(F,te){const Se=new $n(pn.User,typeof F=="string"?F:"",te);return Se.content2=F,Se}static Assistant(F,te){return new $n(pn.Assistant,F,te)}constructor(F,te,Se){this.role=F,this.content=te,this.content2=te,this.name=Se}}e.$lQ=$n;class Rr{constructor(F,te){this.name=F,this.parameters=te}}e.$mQ=Rr;class Tr{constructor(F){this.value=F}}e.$nQ=Tr;class Or{constructor(F){this.content=F}}e.$oQ=Or;class Ar{constructor(F,te){this.content=F,this.name=te}}e.$pQ=Ar;class Nr{constructor(F,te){this.content=F,this.name=te}}e.$qQ=Nr;class Li extends Error{static NotFound(F){return new Li(F,Li.NotFound.name)}static NoPermissions(F){return new Li(F,Li.NoPermissions.name)}static Blocked(F){return new Li(F,Li.Blocked.name)}constructor(F,te,Se){super(F,{cause:Se}),this.name="LanguageModelError",this.code=te??""}}e.$rQ=Li;var jn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var Wn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var qn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Lr{constructor(F,te){this.text=F,this.range=te}}e.$sQ=Lr;var Vn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[226],Te([1,0,5,7]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$3N.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,O,p){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(O,p)??[]}getRelatedInformation(R,O,p){return this.c.$getAiRelatedInformation(O,p)}registerRelatedInformationProvider(R,O,p){const s=this.b;return this.b++,this.a.set(s,p),this.c.$registerAiRelatedInformationProvider(s,O),new D.$5N(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$yqc=P}),define(Re[91],Te([1,0,6,5,7,18,119,3,16]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=e.$Jqc=void 0,e.$Jqc=(0,O.$Ii)("IExtHostAuthentication");let s=class{constructor(u){this.b=new Map,this.c=new y.$oe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(D.$3N.MainThreadAuthentication)}async getSession(u,E,f,r={}){const c=N.$un.toKey(u.identifier),l=[...f].sort().join(" ");return await this.d.getOrCreate(`${c} ${E} ${l}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,f,c,h,r)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const f=this.b.get(u);return f?f.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,f,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:f,options:r??{supportsMultipleAccounts:!1}});const c=f.onDidChangeSessions(l=>this.a.$sendDidChangeSessions(u,l));return this.a.$registerAuthenticationProvider(u,E,r?.supportsMultipleAccounts??!1),new P.$5N(()=>{c.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,f){const r=this.b.get(u);if(r)return await r.provider.createSession(E,f);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const f=this.b.get(u);if(f)return await f.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,f){const r=this.b.get(u);if(r)return await r.provider.getSessions(E,f);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(R.$4M)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$Kqc=s,e.$Kqc=s=Ke([We(0,p.$DQ)],s);class I{constructor(){this.a=new Map}getOrCreate(u,E){const f=this.a.get(u);if(f)return f;const r=E().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Re[124],Te([1,0,2,5,7,3,16,11,17,13,22,21]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=e.$Orc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,c){this.h=c,this.f=new Map,this.g=r.getProxy(D.$3N.MainThreadDecorations)}registerFileDecorationProvider(r,c){const l=u.c++;this.f.set(l,{provider:r,extensionDescription:c}),this.g.$registerDecorationProvider(l,c.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(l,null);return}const n=(0,p.$4b)(i);if(n.length<=u.d){this.g.$onDidChange(l,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,n.length);const t=n.map(m=>({uri:m,rank:(0,s.$lf)(m.path,"/")})),o=(0,p.$Bb)(t,(m,g)=>m.rank-g.rank||(0,s.$Bf)(m.uri.path,g.uri.path)),a=[];e:for(const m of o){let g;for(const d of m){const S=(0,I.$pc)(d.uri.path);if(g!==S&&(g=S,a.push(d.uri)>=u.d))break e}}this.g.$onDidChange(l,a)});return new P.$5N(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(l),this.f.delete(l)})}async $provideDecorations(r,c,l){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(c.map(async t=>{try{const{uri:o,id:a}=t,m=await Promise.resolve(i.provideFileDecoration(y.URI.revive(o),l));if(!m)return;try{P.$uP.validate(m),m.badge&&typeof m.badge!="string"&&(0,b.$vH)(n,"codiconDecoration"),h[a]=[m.propagate,m.tooltip,m.badge,m.color]}catch(g){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${g}`)}}catch(o){this.h.error(o)}})),h}};e.$Orc=E,e.$Orc=E=u=Ke([We(0,R.$DQ),We(1,O.$dk)],E),e.$Prc=(0,N.$Ii)("IExtHostDecorations")}),define(Re[227],Te([1,0,12,2,7,5,15,19,13]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=void 0;class s{static{this.a=0}constructor(b,u,E){this.d=u,this.e=E,this.b=new Map,this.c=b.getProxy(N.$3N.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,u){if(Object.keys(R.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const E=s.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,b);let f;if(typeof u.onDidChange=="function"){let r;f=u.onDidChange(async c=>{if(c.scheme!==b){this.e.warn(`Provider for scheme '${b}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(c))return;r&&await r;const l=this.$provideTextDocumentContent(E,c).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(c);if(!i)return;const n=(0,p.$vf)(h);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(c,h)}).catch(y.$2).finally(()=>{r===l&&(r=void 0)});r=l})}return new P.$5N(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(b,u){const E=this.b.get(b);return E?Promise.resolve(E.provideTextDocumentContent(D.URI.revive(u),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Rrc=s}),define(Re[125],Te([1,0,61,15,13,284,169,7,17]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=void 0,e.$FQ=I;const s=new Map;function I(f,r){r?s.set(f,r):s.delete(f)}function b(f){return s.get(f)}class u extends N.$vw{constructor(r,c,l,h,i,n,t){super(c,l,h,i),this.o=r,this.p=n,this.q=t,this.n=!1}dispose(){(0,y.ok)(!this.n),this.n=!0,this.q=!1}equalLines(r){return(0,p.$wb)(this.b,r)}get document(){if(!this.m){const r=this;this.m={get uri(){return r.a},get fileName(){return r.a.fsPath},get isUntitled(){return r.a.scheme===D.Schemas.untitled},get languageId(){return r.p},get version(){return r.d},get isClosed(){return r.n},get isDirty(){return r.q},save(){return r.r()},getText(c){return c?r.s(c):r.getText()},get eol(){return r.c===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return r.b.length},lineAt(c){return r.t(c)},offsetAt(c){return r.u(c)},positionAt(c){return r.v(c)},validateRange(c){return r.w(c)},validatePosition(c){return r.x(c)},getWordRangeAtPosition(c,l){return r.y(c,l)},[Symbol.for("debug.description")](){return`TextDocument(${r.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(r){(0,y.ok)(!this.n),this.p=r}_acceptIsDirty(r){(0,y.ok)(!this.n),this.q=r}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(r){const c=this.w(r);if(c.isEmpty)return"";if(c.isSingleLine)return this.b[c.start.line].substring(c.start.character,c.end.character);const l=this.c,h=c.start.line,i=c.end.line,n=[];n.push(this.b[h].substring(c.start.character));for(let t=h+1;t<i;t++)n.push(this.b[t]);return n.push(this.b[i].substring(0,c.end.character)),n.join(l)}t(r){let c;if(r instanceof O.$6N?c=r.line:typeof r=="number"&&(c=r),typeof c!="number"||c<0||c>=this.b.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new E(c,this.b[c],c===this.b.length-1)}u(r){return r=this.x(r),this.h(),this.f.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.h();const c=this.f.getIndexOf(r),l=this.b[c.index].length;return new O.$6N(c.index,Math.min(c.remainder,l))}w(r){if(!(r instanceof O.$7N))throw new Error("Invalid argument");const c=this.x(r.start),l=this.x(r.end);return c===r.start&&l===r.end?r:new O.$7N(c.line,c.character,l.line,l.character)}x(r){if(!(r instanceof O.$6N))throw new Error("Invalid argument");if(this.b.length===0)return r.with(0,0);let{line:c,character:l}=r,h=!1;if(c<0)c=0,l=0,h=!0;else if(c>=this.b.length)c=this.b.length-1,l=this.b[c].length,h=!0;else{const i=this.b[c].length;l<0?(l=0,h=!0):l>i&&(l=i,h=!0)}return h?new O.$6N(c,l):r}y(r,c){const l=this.x(r);if(!c)c=b(this.p);else if((0,P.$uf)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const h=(0,R.$vt)(l.character+1,(0,R.$tt)(c),this.b[l.line],0);if(h)return new O.$7N(l.line,h.startColumn-1,l.line,h.endColumn-1)}}e.$GQ=u;class E{constructor(r,c,l){this.a=r,this.b=c,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$7N(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$7N(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HQ=E}),define(Re[228],Te([1,0,5,7]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$3N.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,O,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(O,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,O,p){const s=this.b;return this.b++,this.a.set(s,p),this.c.$registerAiEmbeddingVectorProvider(O,s),new D.$5N(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$Urc=P}),define(Re[68],Te([1,0,5,28,7,20,3,16,50,4,10,24,15]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=e.$Zqc=void 0,D=qe(D);let f=E=class{constructor(c,l){this.b=new Map,this.c=new I.$Rh,this.a=c.getProxy(y.$3N.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let n;const t=h.b.get(i.scheme);return t?(await h.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await h.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===D.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(i){try{const n=h.b.get(i.scheme);return n?(await h.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(n){return E.e(n)}},async createDirectory(i){try{const n=h.b.get(i.scheme);return n&&!n.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(n.impl,n.extUri,i)):await h.a.$mkdir(i)}catch(n){return E.e(n)}},async readFile(i){try{const n=h.b.get(i.scheme);return n?(await h.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(n){return E.e(n)}},async writeFile(i,n){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(t.impl,t.extUri,t.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,N.$Qe.wrap(n))}catch(t){return E.e(t)}},async delete(i,n){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await h.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return E.e(t)}},async rename(i,n,t){try{return await h.a.$rename(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},async copy(i,n,t){try{return await h.a.$copy(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},isWritableFileSystem(i){const n=l.getCapabilities(i);if(typeof n=="number")return!(n&D.FileSystemProviderCapabilities.Readonly)}})}async d(c,l,h){const i=[];for(;!l.isEqual(h,l.dirname(h));)try{if(!((await c.stat(h)).type&D.FileType.Directory))throw P.$lP.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(D.$tl(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(l.basename(h)),h=l.dirname(h)}for(let n=i.length-1;n>=0;n--){h=l.joinPath(h,i[n]);try{await c.createDirectory(h)}catch(t){if(D.$tl(t)!==D.FileSystemProviderErrorCode.FileExists)throw t}}}static e(c){if(c instanceof P.$lP)throw c;if(c instanceof D.$pl)switch(c.code){case D.FileSystemProviderErrorCode.FileExists:throw P.$lP.FileExists(c.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$lP.FileNotFound(c.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$lP.FileNotADirectory(c.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$lP.FileIsADirectory(c.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$lP.NoPermissions(c.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$lP.Unavailable(c.message);default:throw new P.$lP(c.message,c.name)}if(!(c instanceof Error))throw new P.$lP(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw P.$lP.Unavailable(c.message);switch(c.name){case D.FileSystemProviderErrorCode.FileExists:throw P.$lP.FileExists(c.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$lP.FileNotFound(c.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$lP.FileNotADirectory(c.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$lP.FileIsADirectory(c.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$lP.NoPermissions(c.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$lP.Unavailable(c.message);default:throw new P.$lP(c.message,c.name)}}addFileSystemProvider(c,l,h){return this.b.set(c,{impl:l,extUri:h?.isCaseSensitive?b.$_g:b.$bh,isReadonly:!!h?.isReadonly}),(0,s.$Vc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??b.$_g}};e.$Zqc=f,e.$Zqc=f=E=Ke([We(0,O.$DQ),We(1,p.$Dqc)],f),e.$1qc=(0,R.$Ii)("IExtHostConsumerFileSystem")}),define(Re[92],Te([1,0,3,26,11,68,2]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=e.$2qc=void 0,e.$2qc=(0,y.$Ii)("IExtensionStoragePaths");let O=class{constructor(s,I,b){this.d=I,this.f=b,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(b){this.d.error("[ExtHostStorage]",b);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$3qc=O,e.$3qc=O=Ke([We(0,D.$TQ),We(1,P.$dk),We(2,N.$1qc)],O)}),define(Re[229],Te([1,0,7,16,6]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;let N=class{constructor(O){this.a=new y.$vP(y.ColorThemeKind.Dark),this.b=new P.$oe}get activeColorTheme(){return this.a}$onColorThemeChange(O){let p;switch(O){case"light":p=y.ColorThemeKind.Light;break;case"hcDark":p=y.ColorThemeKind.HighContrast;break;case"hcLight":p=y.ColorThemeKind.HighContrastLight;break;default:p=y.ColorThemeKind.Dark}this.a=new y.$vP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Esc=N,e.$Esc=N=Ke([We(0,D.$DQ)],N)}),define(Re[93],Te([1,0,19,6,4,9,3,11,183,5,26,16,7]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UGb=e.$TGb=e.TunnelDtoConverter=void 0,N=qe(N),u=qe(u);class E extends p.$Uw{}var f;(function(c){function l(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}c.fromApiTunnel=l;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}c.fromServiceTunnel=h})(f||(e.TunnelDtoConverter=f={})),e.$TGb=(0,R.$Ii)("IExtHostTunnelService");let r=class extends P.$Xc{constructor(l,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$oe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=l.getProxy(s.$3N.MainThreadTunnelService)}async openTunnel(l,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,l.displayName);if(i){const n=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(l,h){l.portRange===void 0&&l.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:l,provider:h}),this.a.$registerPortsAttributesProvider(l,i),new u.$5N(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(l,h,i,n,t){const o=[];for(const m of l){const g=this.r.get(m);if(!g)return[];o.push(...await Promise.all(h.map(async d=>{let S;try{S=await g.provider.providePortAttributes({port:d,pid:i,commandLine:n},t)}catch{S=await g.provider.providePortAttributes(d,i,n,t)}return{providedAttributes:S,port:d}})))}const a=o.filter(m=>!!m.providedAttributes);return a.length>0?a.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(l){}registerTunnelProvider(l,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await l.provideTunnel(n,t,y.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(l,h){if(l){l.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this.f=l.showCandidatePort,this.a.$setCandidateFilter());const i=l.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let n=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:N.localize(2714,null),themeIcon:"lock"},{id:"public",label:N.localize(2715,null),themeIcon:"eye"}]);const t=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Vc)(()=>{this.b=void 0})}w(l){}async $closeTunnel(l,h){if(this.g.has(l.host)){const i=this.g.get(l.host);i.has(l.port)&&(h&&i.get(l.port).disposeListener.dispose(),await i.get(l.port).tunnel.dispose(),i.delete(l.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(l,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(l,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(l.remoteAddress.host)||this.g.set(l.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:n,disposeListener:t}),f.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(l){const h=await Promise.all(l.map(n=>this.f(n.host,n.port,n.detail??""))),i=l.filter((n,t)=>h[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$UGb=r,e.$UGb=r=Ke([We(0,b.$DQ),We(1,I.$TQ),We(2,O.$dk)],r)}),define(Re[8],Te([1,0,17,20,151,230,59,27,139,33,72,25,145,24,35,14,2,106,32,159,94,52,108,77,118,116,117,206,81,90,54,55,203,7]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g,d,S,k,v,C,T,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$AQ=se,e.$BQ=x,e.$CQ=we,R=qe(R),p=qe(p),h=qe(h),i=qe(i),n=qe(n),S=qe(S),v=qe(v),w=qe(w);var M;(function(me){function De(K){const{selectionStartLineNumber:ke,selectionStartColumn:ze,positionLineNumber:Xe,positionColumn:Ve}=K,ft=new w.$6N(ke-1,ze-1),Tt=new w.$6N(Xe-1,Ve-1);return new w.$8N(ft,Tt)}me.to=De;function oe(K){const{anchor:ke,active:ze}=K;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}me.from=oe})(M||(e.Selection=M={}));var A;(function(me){function De(K){if(!K)return;const{start:ke,end:ze}=K;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}me.from=De;function oe(K){if(!K)return;const{startLineNumber:ke,startColumn:ze,endLineNumber:Xe,endColumn:Ve}=K;return new w.$7N(ke-1,ze-1,Xe-1,Ve-1)}me.to=oe})(A||(e.Range=A={}));var L;(function(me){function De(K){return{uri:K.uri,range:A.from(K.range)}}me.from=De;function oe(K){return new w.$gO(c.URI.revive(K.uri),A.to(K.range))}me.to=oe})(L||(e.Location=L={}));var Z;(function(me){function De(oe){switch(oe){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}me.to=De})(Z||(e.TokenType=Z={}));var J;(function(me){function De(K){return new w.$6N(K.lineNumber-1,K.column-1)}me.to=De;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}me.from=oe})(J||(e.Position=J={}));var U;(function(me){function De(ke,ze,Xe){return(0,y.$Jb)((0,y.$4b)(ke).map(Ve=>oe(Ve,ze,Xe)))}me.from=De;function oe(ke,ze,Xe){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Xe?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:K(ke.scheme,ze),pattern:Qe.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Xe?.isBuiltin}}function K(ke,ze){return ze&&typeof ke=="string"?ze.transformOutgoingScheme(ke):ke}})(U||(e.DocumentSelector=U={}));var V;(function(me){function De(K){switch(K){case w.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=De;function oe(K){switch(K){case o.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}me.to=oe})(V||(e.DiagnosticTag=V={}));var Q;(function(me){function De(K){let ke;return K.code&&((0,r.$hg)(K.code)||(0,r.$lg)(K.code)?ke=String(K.code):ke={value:String(K.code.value),target:K.code.target}),{...A.from(K.range),message:K.message,source:K.source,code:ke,severity:ue.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(ne.from),tags:Array.isArray(K.tags)?(0,y.$Jb)(K.tags.map(V.from)):void 0}}me.from=De;function oe(K){const ke=new w.$iO(A.to(K),K.message,ue.to(K.severity));return ke.source=K.source,ke.code=(0,r.$hg)(K.code)?K.code:K.code?.value,ke.relatedInformation=K.relatedInformation&&K.relatedInformation.map(ne.to),ke.tags=K.tags&&(0,y.$Jb)(K.tags.map(V.to)),ke}me.to=oe})(Q||(e.Diagnostic=Q={}));var ne;(function(me){function De(K){return{...A.from(K.location.range),message:K.message,resource:K.location.uri}}me.from=De;function oe(K){return new w.$hO(new w.$gO(K.resource,A.to(K)),K.message)}me.to=oe})(ne||(e.DiagnosticRelatedInformation=ne={}));var ue;(function(me){function De(K){switch(K){case w.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=De;function oe(K){switch(K){case o.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}me.to=oe})(ue||(e.DiagnosticSeverity=ue={}));var _;(function(me){function De(K){return typeof K=="number"&&K>=w.ViewColumn.One?K-1:K===w.ViewColumn.Beside?$.$OE:$.$NE}me.from=De;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=oe})(_||(e.ViewColumn=_={}));function ae(me){return typeof me.range<"u"}function se(me){return me.length===0?!0:!!ae(me[0])}var ce;(function(me){function De(Ve){return Ve.map(me.from)}me.fromMany=De;function oe(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function K(Ve){let ft;if(oe(Ve)){const{language:Vt,value:Wt}=Ve;ft={value:"```"+Vt+`
`+Wt+"\n```\n"}}else w.$wO.isMarkdownString(Ve)?ft={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?ft={value:Ve}:ft={value:""};const Tt=Object.create(null);ft.uris=Tt;const Yt=({href:Vt})=>{try{let Wt=c.URI.parse(Vt,!0);Wt=Wt.with({query:ke(Wt.query,Tt)}),Tt[Vt]=Wt}catch{}return""};return p.marked.walkTokens(p.marked.lexer(ft.value),Vt=>{Vt.type==="link"?Yt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Yt(R.$cl(Vt.href))}),ft}me.from=K;function ke(Ve,ft){if(!Ve)return Ve;let Tt;try{Tt=(0,s.$ei)(Ve)}catch{}if(!Tt)return Ve;let Yt=!1;return Tt=(0,b.$jo)(Tt,Vt=>{if(c.URI.isUri(Vt)){const Wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Wt]=Vt,Yt=!0,Wt}else return}),Yt?JSON.stringify(Tt):Ve}function ze(Ve){const ft=new w.$wO(Ve.value,Ve.supportThemeIcons);return ft.isTrusted=Ve.isTrusted,ft.supportHtml=Ve.supportHtml,ft.baseUri=Ve.baseUri?c.URI.from(Ve.baseUri):void 0,ft}me.to=ze;function Xe(Ve){if(Ve)return typeof Ve=="string"?Ve:me.from(Ve)}me.fromStrict=Xe})(ce||(e.MarkdownString=ce={}));function x(me){return se(me)?me.map(De=>({range:A.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ce.fromMany(De.hoverMessage):De.hoverMessage?ce.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:A.from(De)}))}function we(me){return typeof me>"u"?me:typeof me=="string"?c.URI.file(me):me}var Ie;(function(me){function De(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?we(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}me.from=De})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var Y;(function(me){function De(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?we(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?Ie.from(oe.before):void 0,after:oe.after?Ie.from(oe.after):void 0}}me.from=De})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(me){function De(oe){if(typeof oe>"u")return oe;switch(oe){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=De})(q||(e.DecorationRangeBehavior=q={}));var ie;(function(me){function De(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?q.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?Y.from(oe.light):void 0,dark:oe.dark?Y.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?we(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?Ie.from(oe.before):void 0,after:oe.after?Ie.from(oe.after):void 0}}me.from=De})(ie||(e.DecorationRenderOptions=ie={}));var ve;(function(me){function De(K){return{text:K.newText,eol:K.newEol&&be.from(K.newEol),range:A.from(K.range)}}me.from=De;function oe(K){const ke=new w.$bO(A.to(K.range),K.text);return ke.newEol=typeof K.eol>"u"?void 0:be.to(K.eol),ke}me.to=oe})(ve||(e.TextEdit=ve={}));var Pe;(function(me){function De(K,ke){const ze={edits:[]};if(K instanceof w.$eO){const Xe=new O.$Ec;for(const Ve of K._allEntries())Ve._type===w.FileEditType.File&&c.URI.isUri(Ve.to)&&Ve.from===void 0&&Xe.add(Ve.to);for(const Ve of K._allEntries())if(Ve._type===w.FileEditType.File){let ft;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?ft={type:"base64",value:(0,D.$$e)(D.$Qe.wrap(Ve.options.contents))}:ft={type:"dataTransferItem",id:Ve.options.contents._itemId}),ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:ft},metadata:Ve.metadata})}else Ve._type===w.FileEditType.Text?ze.edits.push({resource:Ve.uri,textEdit:ve.from(Ve.edit),versionId:Xe.has(Ve.uri)?void 0:ke?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===w.FileEditType.Snippet?ze.edits.push({resource:Ve.uri,textEdit:{range:A.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ve.uri)?void 0:ke?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===w.FileEditType.Cell?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===w.FileEditType.CellReplace&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:v.CellEditType.Replace,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Ze.from)}})}return ze}me.from=De;function oe(K){const ke=new w.$eO,ze=new O.$Dc;for(const Xe of K.edits)if(Xe.textEdit){const Ve=Xe,ft=c.URI.revive(Ve.resource),Tt=A.to(Ve.textEdit.range),Yt=Ve.textEdit.text,Vt=Ve.textEdit.insertAsSnippet;let Wt;Vt?Wt=w.$dO.replace(Tt,new w.$fO(Yt)):Wt=w.$bO.replace(Tt,Yt);const Ni=ze.get(ft);Ni?Ni.push(Wt):ze.set(ft,[Wt])}else ke.renameFile(c.URI.revive(Xe.oldResource),c.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ve]of ze)ke.set(Xe,Ve);return ke}me.to=oe})(Pe||(e.WorkspaceEdit=Pe={}));var Fe;(function(me){const De=Object.create(null);De[w.SymbolKind.File]=n.SymbolKind.File,De[w.SymbolKind.Module]=n.SymbolKind.Module,De[w.SymbolKind.Namespace]=n.SymbolKind.Namespace,De[w.SymbolKind.Package]=n.SymbolKind.Package,De[w.SymbolKind.Class]=n.SymbolKind.Class,De[w.SymbolKind.Method]=n.SymbolKind.Method,De[w.SymbolKind.Property]=n.SymbolKind.Property,De[w.SymbolKind.Field]=n.SymbolKind.Field,De[w.SymbolKind.Constructor]=n.SymbolKind.Constructor,De[w.SymbolKind.Enum]=n.SymbolKind.Enum,De[w.SymbolKind.Interface]=n.SymbolKind.Interface,De[w.SymbolKind.Function]=n.SymbolKind.Function,De[w.SymbolKind.Variable]=n.SymbolKind.Variable,De[w.SymbolKind.Constant]=n.SymbolKind.Constant,De[w.SymbolKind.String]=n.SymbolKind.String,De[w.SymbolKind.Number]=n.SymbolKind.Number,De[w.SymbolKind.Boolean]=n.SymbolKind.Boolean,De[w.SymbolKind.Array]=n.SymbolKind.Array,De[w.SymbolKind.Object]=n.SymbolKind.Object,De[w.SymbolKind.Key]=n.SymbolKind.Key,De[w.SymbolKind.Null]=n.SymbolKind.Null,De[w.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,De[w.SymbolKind.Struct]=n.SymbolKind.Struct,De[w.SymbolKind.Event]=n.SymbolKind.Event,De[w.SymbolKind.Operator]=n.SymbolKind.Operator,De[w.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function oe(ke){return typeof De[ke]=="number"?De[ke]:n.SymbolKind.Property}me.from=oe;function K(ke){for(const ze in De)if(De[ze]===ke)return Number(ze);return w.SymbolKind.Property}me.to=K})(Fe||(e.SymbolKind=Fe={}));var Be;(function(me){function De(K){switch(K){case w.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=De;function oe(K){switch(K){case n.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}me.to=oe})(Be||(e.SymbolTag=Be={}));var xe;(function(me){function De(K){return{name:K.name,kind:Fe.from(K.kind),tags:K.tags&&K.tags.map(Be.from),containerName:K.containerName,location:et.from(K.location)}}me.from=De;function oe(K){const ke=new w.$nO(K.name,Fe.to(K.kind),K.containerName,et.to(K.location));return ke.tags=K.tags&&K.tags.map(Be.to),ke}me.to=oe})(xe||(e.WorkspaceSymbol=xe={}));var nt;(function(me){function De(K){const ke={name:K.name||"!!MISSING: name!!",detail:K.detail,range:A.from(K.range),selectionRange:A.from(K.selectionRange),kind:Fe.from(K.kind),tags:K.tags?.map(Be.from)??[]};return K.children&&(ke.children=K.children.map(De)),ke}me.from=De;function oe(K){const ke=new w.$oO(K.name,K.detail,Fe.to(K.kind),A.to(K.range),A.to(K.selectionRange));return(0,y.$Nb)(K.tags)&&(ke.tags=K.tags.map(Be.to)),K.children&&(ke.children=K.children.map(oe)),ke}me.to=oe})(nt||(e.DocumentSymbol=nt={}));var ut;(function(me){function De(K){const ke=new w.$sO(Fe.to(K.kind),K.name,K.detail||"",c.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function oe(K,ke,ze){if(ke=ke??K._sessionId,ze=ze??K._itemId,ke===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:ze,name:K.name,detail:K.detail,kind:Fe.from(K.kind),uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=oe})(ut||(e.CallHierarchyItem=ut={}));var pt;(function(me){function De(oe){return new w.$tO(ut.to(oe.from),oe.fromRanges.map(K=>A.to(K)))}me.to=De})(pt||(e.CallHierarchyIncomingCall=pt={}));var lt;(function(me){function De(oe){return new w.$uO(ut.to(oe.to),oe.fromRanges.map(K=>A.to(K)))}me.to=De})(lt||(e.CallHierarchyOutgoingCall=lt={}));var et;(function(me){function De(K){return{range:K.range&&A.from(K.range),uri:K.uri}}me.from=De;function oe(K){return new w.$gO(c.URI.revive(K.uri),A.to(K.range))}me.to=oe})(et||(e.location=et={}));var Ne;(function(me){function De(K){const ke=K,ze=K;return{originSelectionRange:ke.originSelectionRange?A.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:ze.uri,range:A.from(ke.targetRange?ke.targetRange:ze.range),targetSelectionRange:ke.targetSelectionRange?A.from(ke.targetSelectionRange):void 0}}me.from=De;function oe(K){return{targetUri:c.URI.revive(K.uri),targetRange:A.to(K.range),targetSelectionRange:K.targetSelectionRange?A.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?A.to(K.originSelectionRange):void 0}}me.to=oe})(Ne||(e.DefinitionLink=Ne={}));var Me;(function(me){function De(K){return{range:A.from(K.range),contents:ce.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}me.from=De;function oe(K){const ke=K.contents.map(ce.to),ze=A.to(K.range),Xe=K.canIncreaseVerbosity,Ve=K.canDecreaseVerbosity;return new w.$kO(ke,ze,Xe,Ve)}me.to=oe})(Me||(e.Hover=Me={}));var Le;(function(me){function De(K){return{range:A.from(K.range),expression:K.expression}}me.from=De;function oe(K){return new w.$fP(A.to(K.range),K.expression)}me.to=oe})(Le||(e.EvaluatableExpression=Le={}));var B;(function(me){function De(K){if(K instanceof w.$gP)return{type:"text",range:A.from(K.range),text:K.text};if(K instanceof w.$hP)return{type:"variable",range:A.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof w.$iP)return{type:"expression",range:A.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function oe(K){switch(K.type){case"text":return{range:A.to(K.range),text:K.text};case"variable":return{range:A.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:A.to(K.range),expression:K.expression}}}me.to=oe})(B||(e.InlineValue=B={}));var j;(function(me){function De(K){return{frameId:K.frameId,stoppedLocation:A.from(K.stoppedLocation)}}me.from=De;function oe(K){return new w.$jP(K.frameId,A.to(K.stoppedLocation))}me.to=oe})(j||(e.InlineValueContext=j={}));var H;(function(me){function De(K){return{range:A.from(K.range),kind:K.kind}}me.from=De;function oe(K){return new w.$lO(A.to(K.range),K.kind)}me.to=oe})(H||(e.DocumentHighlight=H={}));var G;(function(me){function De(K){return{uri:K.uri,highlights:K.highlights.map(H.from)}}me.from=De;function oe(K){return new w.$mO(c.URI.revive(K.uri),K.highlights.map(H.to))}me.to=oe})(G||(e.MultiDocumentHighlight=G={}));var re;(function(me){function De(oe){switch(oe){case n.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}me.to=De})(re||(e.CompletionTriggerKind=re={}));var ge;(function(me){function De(oe){return{triggerKind:re.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}me.to=De})(ge||(e.CompletionContext=ge={}));var Ee;(function(me){function De(K){switch(K){case w.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=De;function oe(K){switch(K){case n.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}me.to=oe})(Ee||(e.CompletionItemTag=Ee={}));var Ue;(function(me){const De=new Map([[w.CompletionItemKind.Method,n.CompletionItemKind.Method],[w.CompletionItemKind.Function,n.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,n.CompletionItemKind.Field],[w.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[w.CompletionItemKind.Class,n.CompletionItemKind.Class],[w.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[w.CompletionItemKind.Module,n.CompletionItemKind.Module],[w.CompletionItemKind.Property,n.CompletionItemKind.Property],[w.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[w.CompletionItemKind.Value,n.CompletionItemKind.Value],[w.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,n.CompletionItemKind.Text],[w.CompletionItemKind.Color,n.CompletionItemKind.Color],[w.CompletionItemKind.File,n.CompletionItemKind.File],[w.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[w.CompletionItemKind.Event,n.CompletionItemKind.Event],[w.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[w.CompletionItemKind.User,n.CompletionItemKind.User]]);function oe(ze){return De.get(ze)??n.CompletionItemKind.Property}me.from=oe;const K=new Map([[n.CompletionItemKind.Method,w.CompletionItemKind.Method],[n.CompletionItemKind.Function,w.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,w.CompletionItemKind.Field],[n.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[n.CompletionItemKind.Class,w.CompletionItemKind.Class],[n.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[n.CompletionItemKind.Module,w.CompletionItemKind.Module],[n.CompletionItemKind.Property,w.CompletionItemKind.Property],[n.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[n.CompletionItemKind.Value,w.CompletionItemKind.Value],[n.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,w.CompletionItemKind.Text],[n.CompletionItemKind.Color,w.CompletionItemKind.Color],[n.CompletionItemKind.File,w.CompletionItemKind.File],[n.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[n.CompletionItemKind.Event,w.CompletionItemKind.Event],[n.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,w.CompletionItemKind.User],[n.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function ke(ze){return K.get(ze)??w.CompletionItemKind.Property}me.to=ke})(Ue||(e.CompletionItemKind=Ue={}));var Je;(function(me){function De(oe,K){const ke=new w.$CO(oe.label);return ke.insertText=oe.insertText,ke.kind=Ue.to(oe.kind),ke.tags=oe.tags?.map(Ee.to),ke.detail=oe.detail,ke.documentation=R.$9k(oe.documentation)?ce.to(oe.documentation):oe.documentation,ke.sortText=oe.sortText,ke.filterText=oe.filterText,ke.preselect=oe.preselect,ke.commitCharacters=oe.commitCharacters,h.$Tt.isIRange(oe.range)?ke.range=A.to(oe.range):typeof oe.range=="object"&&(ke.range={inserting:A.to(oe.range.insert),replacing:A.to(oe.range.replace)}),ke.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof oe.insertTextRules<"u"&&oe.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ke.insertText=new w.$fO(oe.insertText):(ke.insertText=oe.insertText,ke.textEdit=ke.range instanceof w.$7N?new w.$bO(ke.range,ke.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(ke.additionalTextEdits=oe.additionalTextEdits.map(ze=>ve.to(ze))),ke.command=K&&oe.command?K.fromInternal(oe.command):void 0,ke}me.to=De})(Je||(e.CompletionItem=Je={}));var _e;(function(me){function De(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ce.fromStrict(K.documentation)}}me.from=De;function oe(K){return{label:K.label,documentation:R.$9k(K.documentation)?ce.to(K.documentation):K.documentation}}me.to=oe})(_e||(e.ParameterInformation=_e={}));var tt;(function(me){function De(K){return{label:K.label,documentation:ce.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(_e.from):[],activeParameter:K.activeParameter}}me.from=De;function oe(K){return{label:K.label,documentation:R.$9k(K.documentation)?ce.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(_e.to):[],activeParameter:K.activeParameter}}me.to=oe})(tt||(e.SignatureInformation=tt={}));var at;(function(me){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.from):[]}}me.from=De;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.to):[]}}me.to=oe})(at||(e.SignatureHelp=at={}));var it;(function(me){function De(oe,K){const ke=new w.$BO(J.to(K.position),typeof K.label=="string"?K.label:K.label.map(ot.to.bind(void 0,oe)),K.kind&&vt.to(K.kind));return ke.textEdits=K.textEdits&&K.textEdits.map(ve.to),ke.tooltip=R.$9k(K.tooltip)?ce.to(K.tooltip):K.tooltip,ke.paddingLeft=K.paddingLeft,ke.paddingRight=K.paddingRight,ke}me.to=De})(it||(e.InlayHint=it={}));var ot;(function(me){function De(oe,K){const ke=new w.$AO(K.label);return ke.tooltip=R.$9k(K.tooltip)?ce.to(K.tooltip):K.tooltip,n.Command.is(K.command)&&(ke.command=oe.fromInternal(K.command)),K.location&&(ke.location=et.to(K.location)),ke}me.to=De})(ot||(e.InlayHintLabelPart=ot={}));var vt;(function(me){function De(K){return K}me.from=De;function oe(K){return K}me.to=oe})(vt||(e.InlayHintKind=vt={}));var Ye;(function(me){function De(K){return{range:A.from(K.range),url:K.target,tooltip:K.tooltip}}me.from=De;function oe(K){let ke;if(K.url)try{ke=typeof K.url=="string"?c.URI.parse(K.url,!0):c.URI.revive(K.url)}catch{}const ze=new w.$HO(A.to(K.range),ke);return ze.tooltip=K.tooltip,ze}me.to=oe})(Ye||(e.DocumentLink=Ye={}));var he;(function(me){function De(K){const ke=new w.$KO(K.label);return K.textEdit&&(ke.textEdit=ve.to(K.textEdit)),K.additionalTextEdits&&(ke.additionalTextEdits=K.additionalTextEdits.map(ze=>ve.to(ze))),ke}me.to=De;function oe(K){return{label:K.label,textEdit:K.textEdit?ve.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(ke=>ve.from(ke)):void 0}}me.from=oe})(he||(e.ColorPresentation=he={}));var pe;(function(me){function De(K){return new w.$IO(K[0],K[1],K[2],K[3])}me.to=De;function oe(K){return[K.red,K.green,K.blue,K.alpha]}me.from=oe})(pe||(e.Color=pe={}));var ye;(function(me){function De(K){return{range:A.from(K.range)}}me.from=De;function oe(K){return new w.$rO(A.to(K.range))}me.to=oe})(ye||(e.SelectionRange=ye={}));var Ce;(function(me){function De(oe){switch(oe){case g.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case g.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case g.SaveReason.FOCUS_CHANGE:case g.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}me.to=De})(Ce||(e.TextDocumentSaveReason=Ce={}));var fe;(function(me){function De(K){switch(K){case w.TextEditorLineNumbersStyle.Off:return l.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return l.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return l.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return l.RenderLineNumbersType.On}}me.from=De;function oe(K){switch(K){case l.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case l.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case l.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case l.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}me.to=oe})(fe||(e.TextEditorLineNumbersStyle=fe={}));var be;(function(me){function De(K){if(K===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===w.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=De;function oe(K){if(K===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return w.EndOfLine.LF}me.to=oe})(be||(e.EndOfLine=be={}));var X;(function(me){function De(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case w.ProgressLocation.SourceControl:return a.ProgressLocation.Scm;case w.ProgressLocation.Window:return a.ProgressLocation.Window;case w.ProgressLocation.Notification:return a.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(X||(e.ProgressLocation=X={}));var W;(function(me){function De(K){const ke={start:K.start+1,end:K.end+1};return K.kind&&(ke.kind=de.from(K.kind)),ke}me.from=De;function oe(K){const ke={start:K.start-1,end:K.end-1};return K.kind&&(ke.kind=de.to(K.kind)),ke}me.to=oe})(W||(e.FoldingRange=W={}));var de;(function(me){function De(K){if(K)switch(K){case w.FoldingRangeKind.Comment:return n.$Uu.Comment;case w.FoldingRangeKind.Imports:return n.$Uu.Imports;case w.FoldingRangeKind.Region:return n.$Uu.Region}}me.from=De;function oe(K){if(K)switch(K.value){case n.$Uu.Comment.value:return w.FoldingRangeKind.Comment;case n.$Uu.Imports.value:return w.FoldingRangeKind.Imports;case n.$Uu.Region.value:return w.FoldingRangeKind.Region}}me.to=oe})(de||(e.FoldingRangeKind=de={}));var je;(function(me){function De(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?A.from(oe.selection):void 0,override:typeof oe.override=="boolean"?g.$fG.id:void 0}}me.from=De})(je||(e.TextEditorOpenOptions=je={}));var Qe;(function(me){function De(ze){return ze instanceof w.$6O?ze.toJSON():typeof ze=="string"?ze:oe(ze)||K(ze)?new w.$6O(ze.baseUri??ze.base,ze.pattern).toJSON():ze}me.from=De;function oe(ze){const Xe=ze;return Xe?c.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function K(ze){const Xe=ze;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ke(ze){return typeof ze=="string"?ze:new w.$6O(c.URI.revive(ze.baseUri),ze.pattern)}me.to=ke})(Qe||(e.GlobPattern=Qe={}));var st;(function(me){function De(oe){if(oe){if(Array.isArray(oe))return oe.map(De);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:Qe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}me.from=De})(st||(e.LanguageSelector=st={}));var ht;(function(me){function De(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(ke=>Array.isArray(ke)&&ke.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&c.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Xe=>Xe instanceof w.$7N)))}me.is=De;function oe(K){return{documents:K.documents.map(ke=>ke.map(ze=>({uri:c.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Xe=>A.from(Xe))})))}}me.from=oe})(ht||(e.MappedEditsContext=ht={}));var gt;(function(me){function De(K){return{start:K.start,end:K.end}}me.from=De;function oe(K){return new w.$wP(K.start,K.end)}me.to=oe})(gt||(e.NotebookRange=gt={}));var Rt;(function(me){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}me.to=De;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}me.from=oe})(Rt||(e.NotebookCellExecutionSummary=Rt={}));var At;(function(me){function De(oe){if(oe===v.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(oe===v.NotebookCellExecutionState.Pending)return;if(oe===v.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}me.to=De})(At||(e.NotebookCellExecutionState=At={}));var Qt;(function(me){function De(K){switch(K){case w.NotebookCellKind.Markup:return v.CellKind.Markup;case w.NotebookCellKind.Code:default:return v.CellKind.Code}}me.from=De;function oe(K){switch(K){case v.CellKind.Markup:return w.NotebookCellKind.Markup;case v.CellKind.Code:default:return w.NotebookCellKind.Code}}me.to=oe})(Qt||(e.NotebookCellKind=Qt={}));var _t;(function(me){function De(K){const ke={metadata:K.metadata??Object.create(null),cells:[]};for(const ze of K.cells)w.$xP.validate(ze),ke.cells.push(Ze.from(ze));return ke}me.from=De;function oe(K){const ke=new w.$yP(K.cells.map(Ze.to));return(0,r.$ug)(K.metadata)||(ke.metadata=K.metadata),ke}me.to=oe})(_t||(e.NotebookData=_t={}));var Ze;(function(me){function De(K){return{cellKind:Qt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Rt.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ut.from):[]}}me.from=De;function oe(K){return new w.$xP(Qt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ut.to):void 0,K.metadata,K.internalMetadata?Rt.to(K.internalMetadata):void 0)}me.to=oe})(Ze||(e.NotebookCellData=Ze={}));var Ot;(function(me){function De(K){return{mime:K.mime,valueBytes:D.$Qe.wrap(K.data)}}me.from=De;function oe(K){return new w.$zP(K.valueBytes.buffer,K.mime)}me.to=oe})(Ot||(e.NotebookCellOutputItem=Ot={}));var Ut;(function(me){function De(K){return{outputId:K.id,items:K.items.map(Ot.from),metadata:K.metadata}}me.from=De;function oe(K){const ke=K.items.map(Ot.to);return new w.$AP(ke,K.outputId,K.metadata)}me.to=oe})(Ut||(e.NotebookCellOutput=Ut={}));var $t;(function(me){function De(ke){return K(ke)?{include:Qe.from(ke.include)??void 0,exclude:Qe.from(ke.exclude)??void 0}:Qe.from(ke)??void 0}me.from=De;function oe(ke){return K(ke)?{include:Qe.to(ke.include),exclude:Qe.to(ke.exclude)}:Qe.to(ke)}me.to=oe;function K(ke){const ze=ke;return ze?!(0,r.$qg)(ze.include)&&!(0,r.$qg)(ze.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var Pt;(function(me){function De(oe,K,ke){const ze=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===w.NotebookCellStatusBarAlignment.Left?v.CellStatusbarAlignment.Left:v.CellStatusbarAlignment.Right,command:K.toInternal(ze,ke),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}me.from=De})(Pt||(e.NotebookStatusBarItem=Pt={}));var ei;(function(me){function De(oe,K,ke){const ze=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:K.toInternal(ze,ke),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}me.from=De})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function De(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}me.from=De})(ti||(e.NotebookDocumentContentOptions=ti={}));var Ht;(function(me){function De(K){return{uri:K.uri,provides:K.provides}}me.from=De;function oe(K){return new w.$CP(c.URI.revive(K.uri),K.provides)}me.to=oe})(Ht||(e.NotebookRendererScript=Ht={}));var wt;(function(me){function De(K){return{message:ce.fromStrict(K.message)||"",type:T.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:A.from(K.location.range),uri:K.location.uri},stackTrace:K.stackTrace?.map(ke=>({label:ke.label,position:ke.position&&J.from(ke.position),uri:ke.uri&&c.URI.revive(ke.uri).toJSON()}))}}me.from=De;function oe(K){const ke=new w.$IP(typeof K.message=="string"?K.message:ce.to(K.message));return ke.actualOutput=K.actual,ke.expectedOutput=K.expected,ke.contextValue=K.contextValue,ke.location=K.location?et.to(K.location):void 0,ke}me.to=oe})(wt||(e.TestMessage=wt={}));var Nt;(function(me){me.namespace=T.$qJ,me.denamespace=T.$rJ})(Nt||(e.TestTag=Nt={}));var ai;(function(me){function De(K){const ke=(0,m.$zQ)(K).controllerId;return{extId:C.$lJ.fromExtHostTestItem(K,ke).toString(),label:K.label,uri:c.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(ze=>Nt.namespace(ke,ze.id)),range:h.$Tt.lift(A.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ce.fromStrict(K.error)||null}}me.from=De;function oe(K){return{parent:void 0,error:void 0,id:C.$lJ.fromString(K.extId).localId,label:K.label,uri:c.URI.revive(K.uri),tags:(K.tags||[]).map(ke=>{const{tagId:ze}=Nt.denamespace(ke);return new w.$JP(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:A.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}me.toPlain=oe})(ai||(e.TestItem=ai={})),function(me){function De(K){return{id:K.id}}me.from=De;function oe(K){return new w.$JP(K.id)}me.to=oe}(Nt||(e.TestTag=Nt={}));var Zt;(function(me){const De=(K,ke)=>{const ze=K.value;if(!ze)return;const Xe={...ai.toPlain(ze.item),parent:ke,taskStates:ze.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(ft=>ft.type===T.TestMessageType.Error).map(wt.to)})),children:[]};if(K.children)for(const Ve of K.children.values()){const ft=De(Ve,Xe);ft&&Xe.children.push(ft)}return Xe};function oe(K){const ke=new u.$kJ;for(const Ve of K.items)ke.insert(C.$lJ.fromString(Ve.item.extId).path,Ve);const ze=[ke.nodes],Xe=[];for(;ze.length;)for(const Ve of ze.pop())Ve.value?Xe.push(Ve):Ve.children&&ze.push(Ve.children.values());return{completedAt:K.completedAt,results:Xe.map(Ve=>De(Ve)).filter(r.$pg)}}me.to=oe})(Zt||(e.TestResults=Zt={}));var Ge;(function(me){function De(ze){return{covered:ze.covered,total:ze.total}}function oe(ze){return"line"in ze?J.from(ze):A.from(ze)}function K(ze){if(typeof ze.executed=="number"&&ze.executed<0)throw new Error(`Invalid coverage count ${ze.executed}`);return"branches"in ze?{count:ze.executed,location:oe(ze.location),type:T.DetailType.Statement,branches:ze.branches.length?ze.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&oe(Xe.location),label:Xe.label})):void 0}:{type:T.DetailType.Declaration,name:ze.name,count:ze.executed,location:oe(ze.location)}}me.fromDetails=K;function ke(ze,Xe,Ve){return w.$MP(Ve.statementCoverage),w.$MP(Ve.branchCoverage),w.$MP(Ve.declarationCoverage),{id:Xe,uri:Ve.uri,statement:De(Ve.statementCoverage),branch:Ve.branchCoverage&&De(Ve.branchCoverage),declaration:Ve.declarationCoverage&&De(Ve.declarationCoverage),testIds:Ve instanceof w.$NP&&Ve.fromTests.length?Ve.fromTests.map(ft=>C.$lJ.fromExtHostTestItem(ft,ze).toString()):void 0}}me.fromFile=ke})(Ge||(e.TestCoverage=Ge={}));var ii;(function(me){function De(oe){switch(oe){case n.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}me.to=De})(ii||(e.CodeActionTriggerKind=ii={}));var ci;(function(me){function De(K){const ke=new w.$RP(Fe.to(K.kind),K.name,K.detail||"",c.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function oe(K,ke,ze){if(ke=ke??K._sessionId,ze=ze??K._itemId,ke===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:ze,kind:Fe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=oe})(ci||(e.TypeHierarchyItem=ci={}));var ui;(function(me){function De(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}me.from=De})(ui||(e.ViewBadge=ui={}));var Et;(function(me){function De(ze,Xe,Ve){const ft=Xe.fileData;return ft?new w.$XO(new w.$YO(ft.name,c.URI.revive(ft.uri),ft.id,(0,N.$fb)(()=>Ve(ft.id)))):ze===I.$dt.uriList&&Xe.uriListData?new w.$WO(ke(Xe.uriListData)):new w.$WO(Xe.asString)}me.to=De;async function oe(ze,Xe){const Ve=await Xe.asString();if(ze===I.$dt.uriList)return{asString:Ve,fileData:void 0,uriListData:K(Ve)};const ft=Xe.asFile();return{asString:Ve,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}me.from=oe;function K(ze){return P.$yu.split(ze).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return c.URI.parse(Xe)}catch{}return Xe})}function ke(ze){return P.$yu.create(ze.map(Xe=>typeof Xe=="string"?Xe:c.URI.revive(Xe)))}})(Et||(e.DataTransferItem=Et={}));var jt;(function(me){function De(K,ke){const ze=K.items.map(([Xe,Ve])=>[Xe,Et.to(Xe,Ve,ke)]);return new w.$ZO(ze)}me.toDataTransfer=De;async function oe(K){const ke={items:[]},ze=[];for(const[Xe,Ve]of K)ze.push((async()=>{ke.items.push([Xe,await Et.from(Xe,Ve)])})());return await Promise.all(ze),ke}me.from=oe})(jt||(e.DataTransfer=jt={}));var Lt;(function(me){function De(K,ke){return{kind:"reply",agentId:K.participant??ke?.agentId??"",subCommand:K.command??ke?.command,message:K.prompt,title:K.label}}me.from=De;function oe(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}me.to=oe})(Lt||(e.ChatFollowup=Lt={}));var Bt;(function(me){function De(K){switch(K){case S.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}me.to=De;function oe(K){switch(K){case w.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}me.from=oe})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var oi;(function(me){function De(K){let ke="",ze;K.content.type==="text"?ke=K.content.value:ze=new w.$kQ(K.content.name,K.content.value,K.content.isError);const Xe=Bt.to(K.role),Ve=new w.$lQ(Xe,ke,K.name);return ze!==void 0&&(Ve.content2=ze),Ve}me.to=De;function oe(K){const ke=Bt.from(K.role),ze=K.name;let Xe;return K.content2 instanceof w.$kQ?Xe={type:"function_result",name:K.content2.name,value:K.content2.content,isError:K.content2.isError}:Xe={type:"text",value:K.content},{role:ke,name:ze,content:Xe}}me.from=oe})(oi||(e.LanguageModelChatMessage=oi={}));var ni;(function(me){function De(K){return{kind:"markdownContent",content:ce.from(K.value)}}me.from=De;function oe(K){return new w.$5P(ce.to(K.content))}me.to=oe})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function De(K){return{kind:"markdownVuln",content:ce.from(K.value),vulnerabilities:K.vulnerabilities}}me.from=De;function oe(K){return new w.$6P(ce.to(K.content),K.vulnerabilities)}me.to=oe})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Kt;(function(me){function De(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}me.from=De;function oe(K){return new w.$7P(K.agentId,K.command)}me.to=oe})(Kt||(e.ChatResponseDetectedParticipantPart=Kt={}));var Gt;(function(me){function De(oe){return{kind:"confirmation",title:oe.title,message:oe.message,data:oe.data,buttons:oe.buttons}}me.from=De})(Gt||(e.ChatResponseConfirmationPart=Gt={}));var li;(function(me){function De(K){const{value:ke,baseUri:ze}=K;function Xe(Ve,ft){return Ve.map(Tt=>{const Yt=c.URI.joinPath(ft,Tt.name);return{label:Tt.name,uri:Yt,children:Tt.children&&Xe(Tt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,E.$gh)(ze),uri:ze,children:Xe(ke,ze)}}}me.from=De;function oe(K){const ke=(0,s.$fi)(K.treeData);function ze(ft){return ft.map(Tt=>({name:Tt.label,children:Tt.children&&ze(Tt.children)}))}const Xe=ke.uri,Ve=ke.children?ze(ke.children):[];return new w.$9P(Ve,Xe)}me.to=oe})(li||(e.ChatResponseFilesPart=li={}));var Mt;(function(me){function De(K){const ke=ze=>c.URI.isUri(ze);return{kind:"inlineReference",name:K.title,inlineReference:ke(K.value)?K.value:L.from(K.value)}}me.from=De;function oe(K){const ke=(0,s.$fi)(K);return new w.$0P(c.URI.isUri(ke.inlineReference)?ke.inlineReference:L.to(ke.inlineReference),K.name)}me.to=oe})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Dt;(function(me){function De(K){return{kind:"progressMessage",content:ce.from(K.value)}}me.from=De;function oe(K){return new w.$$P(K.content.value)}me.to=oe})(Dt||(e.ChatResponseProgressPart=Dt={}));var bt;(function(me){function De(K){return{kind:"warning",content:ce.from(K.value)}}me.from=De;function oe(K){return new w.$aQ(K.content.value)}me.to=oe})(bt||(e.ChatResponseWarningPart=bt={}));var Jt;(function(me){function De(K){return{kind:"move",uri:K.uri,range:A.from(K.range)}}me.from=De;function oe(K){return new w.$eQ(c.URI.revive(K.uri),A.to(K.range))}me.to=oe})(Jt||(e.ChatResponseMovePart=Jt={}));var St;(function(me){function De(oe){return{kind:"progressTask",content:ce.from(oe.value)}}me.from=De})(St||(e.ChatTask=St={}));var hi;(function(me){function De(oe){return{kind:"progressTaskResult",content:typeof oe=="string"?ce.from(oe):void 0}}me.from=De})(hi||(e.ChatTaskResult=hi={}));var Xt;(function(me){function De(K,ke,ze){return{kind:"command",command:ke.toInternal(K.value,ze)??{command:K.value.command,title:K.value.title}}}me.from=De;function oe(K,ke){return new w.$bQ(ke.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}me.to=oe})(Xt||(e.ChatResponseCommandButtonPart=Xt={}));var Mi;(function(me){function De(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(ke=>ve.from(ke))}}me.from=De;function oe(K){return new w.$fQ(c.URI.revive(K.uri),K.edits.map(ke=>ve.to(ke)))}me.to=oe})(Mi||(e.ChatResponseTextEditPart=Mi={}));var di;(function(me){function De(K){const ke=f.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:c.URI.isUri(K.iconPath)?{light:c.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&c.URI.isUri(K.iconPath.light)&&c.URI.isUri(K.iconPath.dark)?{light:c.URI.revive(K.iconPath.light),dark:c.URI.revive(K.iconPath.dark)}:void 0;return typeof K.value=="object"&&"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:c.URI.isUri(K.value.value)||!K.value.value?K.value.value:L.from(K.value.value)},iconPath:ke,options:K.options}:{kind:"reference",reference:c.URI.isUri(K.value)||typeof K.value=="string"?K.value:L.from(K.value),iconPath:ke,options:K.options}}me.from=De;function oe(K){const ke=(0,s.$fi)(K),ze=Xe=>c.URI.isUri(Xe)?Xe:L.to(Xe);return new w.$cQ(typeof ke.reference=="string"?ke.reference:"variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&ze(ke.reference.value)}:ze(ke.reference))}me.to=oe})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(me){function De(oe){return{kind:"codeCitation",value:oe.value,license:oe.license,snippet:oe.snippet}}me.from=De})(yi||(e.ChatResponseCodeCitationPart=yi={}));var qt;(function(me){function De(ke,ze,Xe){return ke instanceof w.$5P?ni.from(ke):ke instanceof w.$0P?Mt.from(ke):ke instanceof w.$cQ?di.from(ke):ke instanceof w.$$P?Dt.from(ke):ke instanceof w.$9P?li.from(ke):ke instanceof w.$bQ?Xt.from(ke,ze,Xe):ke instanceof w.$fQ?Mi.from(ke):ke instanceof w.$6P?ri.from(ke):ke instanceof w.$7P?Kt.from(ke):ke instanceof w.$aQ?bt.from(ke):ke instanceof w.$8P?Gt.from(ke):ke instanceof w.$dQ?yi.from(ke):ke instanceof w.$eQ?Jt.from(ke):{kind:"markdownContent",content:ce.from("")}}me.from=De;function oe(ke,ze){switch(ke.kind){case"reference":return di.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(ke,ze)}}me.to=oe;function K(ke,ze){switch(ke.kind){case"markdownContent":return ni.to(ke);case"inlineReference":return Mt.to(ke);case"progressMessage":return;case"treeData":return li.to(ke);case"command":return Xt.to(ke,ze)}}me.toContent=K})(qt||(e.ChatResponsePart=qt={}));var fi;(function(me){function De(oe,K){const ke=oe.variables.variables.filter(Xe=>Xe.isTool),ze=oe.variables.variables.filter(Xe=>!Xe.isTool);return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,references:ze.map(Ct.to),toolReferences:ke.map(Si.to),location:Fi.to(oe.location),acceptedConfirmationData:oe.acceptedConfirmationData,rejectedConfirmationData:oe.rejectedConfirmationData,location2:K}}me.to=De})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function De(K){switch(K){case d.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}me.to=De;function oe(K){switch(K){case w.ChatLocation.Notebook:return d.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return d.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return d.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return d.ChatAgentLocation.Editor}}me.from=oe})(Fi||(e.ChatLocation=Fi={}));var Ct;(function(me){function De(oe){const K=oe.value;if(!K)throw new Error("Invalid value reference");return{id:oe.id,name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],value:(0,c.$yc)(K)?c.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,c.$yc)(K.uri)?L.to((0,s.$fi)(K)):K,modelDescription:oe.modelDescription}}me.to=De})(Ct||(e.ChatPromptReference=Ct={}));var Si;(function(me){function De(oe){if(oe.value)throw new Error("Invalid tool reference");return{id:oe.id,range:oe.range&&[oe.range.start,oe.range.endExclusive]}}me.to=De})(Si||(e.ChatLanguageModelToolReference=Si={}));var Ai;(function(me){function De(oe,K,ke){return{id:oe.id,label:oe.label,fullName:oe.fullName,icon:oe.icon?.id,value:oe.values[0].value,insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:K.toInternal(oe.command,ke)}}me.from=De})(Ai||(e.ChatAgentCompletionItem=Ai={}));var gi;(function(me){function De(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata,nextQuestion:oe.nextQuestion}}me.to=De})(gi||(e.ChatAgentResult=gi={}));var zi;(function(me){function De(oe,K,ke){if(K.action.kind==="vote")return;const ze=gi.to(oe);if(K.action.kind==="command"){const Xe=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:ze}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(K.action.followup)},result:ze}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:ze}:{action:K.action,result:ze}}me.to=De})(zi||(e.ChatAgentUserActionEvent=zi={}));var ji;(function(me){function De(K){return{...K,string:K.toString()}}me.from=De;function oe(K){const ke={...K,toString:()=>K.string};return delete ke.string,ke}me.to=oe})(ji||(e.LanguageModelToolResult=ji={}));var zt;(function(me){function De(oe,K,ke){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:K.toInternal(oe,ke)}me.from=De})(zt||(e.TerminalQuickFix=zt={}));var Pi;(function(me){function De(oe){return{kind:Di.to(oe.kind)}}me.to=De})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(me){function De(oe){switch(oe){case n.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}me.to=De})(Di||(e.PartialAcceptTriggerKind=Di={}));var wi;(function(me){function De(oe,K){return{id:K,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:oe.contextValue}}me.from=De})(wi||(e.DebugTreeItem=wi={}));var bi;(function(me){function De(oe){return{id:oe.id,modelDescription:oe.modelDescription,parametersSchema:oe.parametersSchema,displayName:oe.displayName}}me.to=De})(bi||(e.LanguageModelToolDescription=bi={}))}),define(Re[231],Te([1,0,5,16,8,39]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0;let R=class{constructor(p,s){this.a=p.getProxy(y.$3N.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,s,I){const b=new N.$4w(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(b,void 0,I?.isRefactoring??!1)}};e.$Lqc=R,e.$Lqc=R=Ke([We(0,D.$DQ)],R)}),define(Re[232],Te([1,0,17,10,42,6,40,4,33,69,14,2,18,5,8,7,117,193,21]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0,f=qe(f),r=qe(r);class i{constructor(a,m,g,d,S){this.j=a,this.k=m,this.l=g,this.m=d,this.n=S,this.b=s.$ie.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let m=function(d){if(a.c){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,d),S}};const a=this;this.b.reset();const g=(d,S)=>{if(typeof this.d>"u"&&(d.kind==="markdownContent"||d.kind==="markdownVuln")&&(this.d=this.b.elapsed()),S){const k=this.l.$handleProgressChunk(this.k.requestId,d),v={report:C=>{k?.then(T=>{T&&(r.$wO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseWarningPart.from(C),T):this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseReferencePart.from(C),T))})}};Promise.all([k,S?.(v)]).then(([C,T])=>{C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,f.ChatTaskResult.from(T),C)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){m(this.markdown);const S=new r.$5P(d),k=f.ChatResponseMarkdownPart.from(S);return g(k),this},markdownWithVulnerabilities(d,S){m(this.markdown),S&&(0,h.$vH)(a.j,"chatParticipantAdditions");const k=new r.$6P(d,S),v=f.ChatResponseMarkdownWithVulnerabilitiesPart.from(k);return g(v),this},filetree(d,S){m(this.filetree);const k=new r.$9P(d,S),v=f.ChatResponseFilesPart.from(k);return g(v),this},anchor(d,S){m(this.anchor);const k=new r.$0P(d,S),v=f.ChatResponseAnchorPart.from(k);return g(v),this},button(d){m(this.anchor);const S=new r.$bQ(d),k=f.ChatResponseCommandButtonPart.from(S,a.m,a.n);return g(k),this},progress(d,S){m(this.progress);const k=new r.$_P(d,S),v=S?f.ChatTask.from(k):f.ChatResponseProgressPart.from(k);return g(v,S),this},warning(d){m(this.progress),(0,h.$vH)(a.j,"chatParticipantAdditions");const S=new r.$aQ(d),k=f.ChatResponseWarningPart.from(S);return g(k),this},reference(d,S){return this.reference2(d,S)},reference2(d,S,k){if(m(this.reference),typeof d=="object"&&"variableName"in d&&(0,h.$vH)(a.j,"chatParticipantAdditions"),typeof d=="object"&&"variableName"in d&&!d.value){const v=a.k.variables.variables.find(C=>C.name===d.variableName);if(v){let C;if(v.references?.length)C=v.references.map(T=>({kind:"reference",reference:{variableName:d.variableName,value:T.reference}}));else{const T=new r.$cQ(d,S,k);C=[f.ChatResponseReferencePart.from(T)]}return C.forEach(T=>g(T)),this}}else{const v=new r.$cQ(d,S,k),C=f.ChatResponseReferencePart.from(v);g(C)}return this},codeCitation(d,S,k){m(this.codeCitation),(0,h.$vH)(a.j,"chatParticipantAdditions");const v=new r.$dQ(d,S,k),C=f.ChatResponseCodeCitationPart.from(v);g(C)},textEdit(d,S){m(this.textEdit),(0,h.$vH)(a.j,"chatParticipantAdditions");const k=new r.$fQ(d,S),v=f.ChatResponseTextEditPart.from(k);return g(v),this},detectedParticipant(d,S){m(this.detectedParticipant),(0,h.$vH)(a.j,"chatParticipantAdditions");const k=new r.$7P(d,S),v=f.ChatResponseDetectedParticipantPart.from(k);return g(v),this},confirmation(d,S,k,v){m(this.confirmation),(0,h.$vH)(a.j,"chatParticipantAdditions");const C=new r.$8P(d,S,k,v),T=f.ChatResponseConfirmationPart.from(C);return g(T),this},push(d){if(m(this.push),(d instanceof r.$fQ||d instanceof r.$6P||d instanceof r.$7P||d instanceof r.$aQ||d instanceof r.$8P||d instanceof r.$dQ||d instanceof r.$eQ)&&(0,h.$vH)(a.j,"chatParticipantAdditions"),d instanceof r.$cQ)this.reference2(d.value,d.iconPath,d.options);else{const S=f.ChatResponsePart.from(d,a.m,a.n);g(S)}return this}}}return this.g}}class n extends O.$Xc{static{this.b=0}static{this.j=0}constructor(a,m,g,d){super(),this.t=m,this.u=g,this.w=d,this.c=new Map,this.m=new Map,this.n=this.B(new O.$7c),this.s=this.B(new O.$7c),this.g=a.getProxy(E.$3N.MainThreadChatAgents2)}transferActiveChat(a){this.g.$transferActiveChatSession(a)}createChatAgent(a,m,g){const d=n.b++,S=new t(a,m,this.g,d,g);return this.c.set(d,S),this.g.$registerAgent(d,a.identifier,m,{},void 0),S.apiAgent}createDynamicChatAgent(a,m,g,d){const S=n.b++,k=new t(a,m,this.g,S,d);return this.c.set(S,k),this.g.$registerAgent(S,a.identifier,m,{isSticky:!0},g),k.apiAgent}registerChatParticipantDetectionProvider(a){const m=n.j++;return this.m.set(m,a),this.g.$registerChatParticipantDetectionProvider(m),(0,O.$Vc)(()=>{this.m.delete(m),this.g.$unregisterChatParticipantDetectionProvider(m)})}async $detectChatParticipant(a,m,g,d,S){const{request:k,location:v,history:C}=await this.y(m,g),T=this.m.get(a);if(T)return T.provideParticipantDetection(f.ChatAgentRequest.to(k,v),{history:C},{participants:d.participants,location:f.ChatLocation.to(d.location)},S)}async y(a,m){const g=(0,p.$fi)(a),d=await this.z(g.agentId,m);let S;if(g.locationData?.type===c.ChatAgentLocation.Editor){const k=this.w.getDocument(g.locationData.document);S=new r.$iQ(k,f.Selection.to(g.locationData.selection),f.Range.to(g.locationData.wholeRange))}else if(g.locationData?.type===c.ChatAgentLocation.Notebook){const k=this.w.getDocument(g.locationData.sessionInputUri);S=new r.$jQ(k)}else g.locationData?.type,c.ChatAgentLocation.Terminal;return{request:g,location:S,history:d}}async $invokeAgent(a,m,g,d){const S=this.c.get(a);if(!S)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let k;try{const{request:v,location:C,history:T}=await this.y(m,g);let $=this.n.get(v.sessionId);$||($=new O.$Wc,this.n.set(v.sessionId,$)),k=new i(S.extension,v,this.g,this.u.converter,$);const w=S.invoke(f.ChatAgentRequest.to(v,C),{history:T},k.apiObject,d);return await(0,D.$wh)(Promise.resolve(w).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(L){const Z=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.t.error(`[${S.extension.identifier.value}] [@${S.id}] ${Z}`,S.extension),{errorDetails:{message:Z},timings:k?.timings,nextQuestion:M.nextQuestion}}let A;return M?.errorDetails&&(A={...M.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,h.$vH)(S.extension,"chatParticipantPrivate"),{errorDetails:A,timings:k?.timings,metadata:M?.metadata,nextQuestion:M?.nextQuestion}}),d)}catch(v){return this.t.error(v,S.extension),v instanceof r.$rQ&&v.cause&&(v=v.cause),{errorDetails:{message:(0,P.$tj)(v),responseIsIncomplete:!0}}}finally{k?.close()}}async z(a,m){const g=[];for(const d of m.history){const S=f.ChatAgentResult.to(d.result),k=a===d.request.agentId?S:{...S,metadata:void 0},v=d.request.variables.variables.filter(w=>!w.isTool).map(f.ChatPromptReference.to),C=d.request.variables.variables.filter(w=>w.isTool).map(f.ChatLanguageModelToolReference.to),T=new r.$gQ(d.request.message,d.request.command,v,d.request.agentId);T.toolReferences=C,g.push(T);const $=(0,y.$Jb)(d.response.map(w=>f.ChatResponsePart.toContent(w,this.u.converter)));g.push(new r.$hQ($,k,d.request.agentId,d.request.command))}return g}$releaseSession(a){this.n.deleteAndDispose(a)}async $provideFollowups(a,m,g,d,S){const k=this.c.get(m);if(!k)return Promise.resolve([]);const v=(0,p.$fi)(a),C=await this.z(k.id,d),T=f.ChatAgentResult.to(g);return(await k.provideFollowups(T,{history:C},S)).filter($=>{const w=!$.participant||R.Iterable.some(this.c.values(),M=>M.id===$.participant&&u.$un.equals(M.extension.identifier,k.extension.identifier));return w||this.t.warn(`[@${k.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),w}).map($=>f.ChatFollowup.from($,v))}$acceptFeedback(a,m,g,d){const S=this.c.get(a);if(!S)return;const k=f.ChatAgentResult.to(m);let v;switch(g){case l.ChatAgentVoteDirection.Down:v=r.ChatResultFeedbackKind.Unhelpful;break;case l.ChatAgentVoteDirection.Up:v=r.ChatResultFeedbackKind.Helpful;break}S.acceptFeedback(Object.freeze(d?{result:k,kind:v,reportIssue:d}:{result:k,kind:v}))}$acceptAction(a,m,g){const d=this.c.get(a);if(!d||g.action.kind==="vote")return;const S=f.ChatAgentUserActionEvent.to(m,g,this.u.converter);S&&d.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(a,m,g){const d=this.c.get(a);if(!d)return[];let S=this.s.get(a);return S?S.clear():(S=new O.$Wc,this.s.set(a,S)),(await d.invokeCompletionProvider(m,g)).map(v=>f.ChatAgentCompletionItem.from(v,this.u.converter,S))}async $provideWelcomeMessage(a,m,g){const d=this.c.get(a);if(d)return await d.provideWelcomeMessage(f.ChatLocation.to(m),g)}async $provideChatTitle(a,m,g){const d=this.c.get(a);if(!d)return;const S=await this.z(d.id,{history:m});return await d.provideTitle({history:S},g)}async $provideSampleQuestions(a,m,g){const d=this.c.get(a);if(d)return(await d.provideSampleQuestions(f.ChatLocation.to(m),g)).map(S=>f.ChatFollowup.from(S,void 0))}}e.$Mqc=n;class t{constructor(a,m,g,d,S){this.extension=a,this.id=m,this.w=g,this.x=d,this.y=S,this.l=new N.$oe,this.m=new N.$oe}acceptFeedback(a){this.l.fire(a)}acceptAction(a){this.m.fire(a)}async invokeCompletionProvider(a,m){return this.o?await this.o.provider.provideCompletionItems(a,m)??[]:[]}async provideFollowups(a,m,g){if(!this.b)return[];const d=await this.b.provideFollowups(a,m,g);return d?d.filter(S=>!(S&&"commandId"in S)).filter(S=>!(S&&"message"in S)):[]}async provideWelcomeMessage(a,m){if(!this.q)return[];const g=await this.q.provideWelcomeMessage(a,m);return g?g.map(d=>typeof d=="string"?d:f.MarkdownString.from(d)):[]}async provideTitle(a,m){if(this.s)return await this.s.provideChatTitle(a,m)??void 0}async provideSampleQuestions(a,m){if(!this.q||!this.q.provideSampleQuestions)return[];const g=await this.q.provideSampleQuestions(a,m);return g||[]}get apiAgent(){let a=!1,m=!1;const g=()=>{a||m||(m=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof b.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$4O?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:f.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:f.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),m=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(S){d.c=S,g()},get requestHandler(){return d.y},set requestHandler(S){(0,I.$rg)(typeof S=="function","Invalid request handler"),d.y=S},get followupProvider(){return d.b},set followupProvider(S){d.b=S,g()},get helpTextPrefix(){return(0,h.$vH)(d.extension,"defaultChatParticipant"),d.d},set helpTextPrefix(S){(0,h.$vH)(d.extension,"defaultChatParticipant"),d.d=S,g()},get helpTextVariablesPrefix(){return(0,h.$vH)(d.extension,"defaultChatParticipant"),d.g},set helpTextVariablesPrefix(S){(0,h.$vH)(d.extension,"defaultChatParticipant"),d.g=S,g()},get helpTextPostfix(){return(0,h.$vH)(d.extension,"defaultChatParticipant"),d.j},set helpTextPostfix(S){(0,h.$vH)(d.extension,"defaultChatParticipant"),d.j=S,g()},get isSecondary(){return(0,h.$vH)(d.extension,"defaultChatParticipant"),d.k},set isSecondary(S){(0,h.$vH)(d.extension,"defaultChatParticipant"),d.k=S,g()},get supportIssueReporting(){return(0,h.$vH)(d.extension,"chatParticipantPrivate"),d.n},set supportIssueReporting(S){(0,h.$vH)(d.extension,"chatParticipantPrivate"),d.n=S,g()},get onDidReceiveFeedback(){return d.l.event},set participantVariableProvider(S){if((0,h.$vH)(d.extension,"chatParticipantAdditions"),d.o=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,d.id,S.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x,d.id)},get participantVariableProvider(){return(0,h.$vH)(d.extension,"chatParticipantAdditions"),d.o},set welcomeMessageProvider(S){(0,h.$vH)(d.extension,"defaultChatParticipant"),d.q=S,g()},get welcomeMessageProvider(){return(0,h.$vH)(d.extension,"defaultChatParticipant"),d.q},set titleProvider(S){(0,h.$vH)(d.extension,"defaultChatParticipant"),d.s=S,g()},get titleProvider(){return(0,h.$vH)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,h.$uH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(S){d.t=S,g()},get requester(){return d.t},set supportsSlowReferences(S){(0,h.$vH)(d.extension,"chatParticipantPrivate"),d.u=S,g()},get supportsSlowReferences(){return(0,h.$vH)(d.extension,"chatParticipantPrivate"),d.u},dispose(){a=!0,d.b=void 0,d.l.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(a,m,g,d){return this.y(a,m,g,d)}}}),define(Re[233],Te([1,0,12,4,35,5,8,7,21]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0,R=qe(R),O=qe(O);class s{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(N.$3N.MainThreadChatVariables)}async $resolveVariable(u,E,f,r){const c=this.b.get(u);if(c)try{if(c.resolver.resolve2){(0,p.$vH)(c.extension,"chatParticipantAdditions");const l=new I(E,this.c),h=await c.resolver.resolve2(c.data.name,{prompt:f},l.apiObject,r);if(h&&h[0])return h[0].value}else{const l=await c.resolver.resolve(c.data.name,{prompt:f},r);if(l&&l[0])return l[0].value}}catch(l){(0,y.$3)(l)}}registerVariableResolver(u,E,f,r,c,l,h,i,n){const t=s.a++,o=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:u,data:{id:E,name:f,description:r,modelDescription:c,icon:o},resolver:h}),this.c.$registerVariable(t,{id:E,name:f,description:r,modelDescription:c,isSlow:l,fullName:i,icon:o}),(0,D.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Nqc=s;class I{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(u.a){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const u=this,f=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const c=new O.$$P(r),l=R.ChatResponseProgressPart.from(c);return f(l),this},reference(r){E(this.reference);const c=new O.$cQ(r),l=R.ChatResponseReferencePart.from(c);return f(l),this},push(r){return E(this.push),r instanceof O.$cQ?f(R.ChatResponseReferencePart.from(r)):r instanceof O.$$P&&f(R.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Re[234],Te([1,0,10,71,6,4,37,2,94,18,8,7,5,21]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=f,p=qe(p),I=qe(I),b=qe(b);function f(r,c,l){const h=r.getProxy(u.$3N.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$wn,c.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===R.MarshalledId.CommentController){const C=this.b.get(v.handle);return C?C.value:v}else if(v&&v.$mid===R.MarshalledId.CommentThread){const C=v,T=this.b.get(C.commentControlHandle);if(!T)return C;const $=T.getCommentThread(C.commentThreadHandle);return $?$.value:C}else if(v&&(v.$mid===R.MarshalledId.CommentThreadReply||v.$mid===R.MarshalledId.CommentThreadInstance)){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const T=C.getCommentThread(v.thread.commentThreadHandle);return T?v.$mid===R.MarshalledId.CommentThreadInstance?T.value:{thread:T.value,text:v.text}:v}else if(v&&v.$mid===R.MarshalledId.CommentNode){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const T=C.getCommentThread(v.thread.commentThreadHandle);if(!T)return v;const $=v.commentUniqueId,w=T.getCommentByUniqueId($);return w||v}else if(v&&v.$mid===R.MarshalledId.CommentThreadNode){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const T=C.getCommentThread(v.thread.commentThreadHandle);if(!T)return v;const $=v.text,w=v.commentUniqueId,M=T.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=$:M.body=new b.$wO($),M):v}return v}})}createCommentController(v,C,T){const $=i.a++,w=new t(v,$,C,T);this.b.set(w.handle,w);const M=this.c.get(v.identifier)||[];return M.push(w),this.c.set(v.identifier,M),w.value}async $createCommentThreadTemplate(v,C,T,$){const w=this.b.get(v);w&&w.$createCommentThreadTemplate(C,T,$)}async $setActiveComment(v,C){const T=this.b.get(v);T&&T.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(v,C,T){const $=this.b.get(v);$&&$.$updateCommentThreadTemplate(C,T)}$deleteCommentThread(v,C){this.b.get(v)?.$deleteCommentThread(C)}async $provideCommentingRanges(v,C,T){const $=this.b.get(v);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const w=await l.ensureDocumentData(O.URI.revive(C));return(0,y.$Ah)(async()=>{const M=await $.commentingRangeProvider.provideCommentingRanges(w.document,T);let A;return Array.isArray(M)?A={ranges:M,fileComments:!1}:M?A={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:A=M??void 0,A}).then(M=>{let A;return M&&(A={ranges:M.ranges.map(L=>I.Range.from(L)),fileComments:M.fileComments}),A})}$toggleReaction(v,C,T,$,w){const M=this.b.get(v);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,y.$Ah)(()=>{const A=M.getCommentThread(C);if(A){const L=A.getCommentByUniqueId($.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,m(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,E.$vH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,C,T,$,w,M,A,L,Z){this.m=C,this.n=T,this.o=$,this.p=w,this.q=M,this.extensionDescription=A,this.r=L,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$oe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Yc,this.l.value=new N.$Wc,this.n===void 0&&(this.n=`${v}.${this.handle}`),h.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(U=>o(this,U,this.k,this.extensionDescription)),A.identifier,this.r,Z),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{h.$deleteCommentThread(C,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(U){J.range=U},get comments(){return J.comments},set comments(U){J.comments=U},get collapsibleState(){return J.collapsibleState},set collapsibleState(U){J.collapsibleState=U},get canReply(){return J.canReply},set canReply(U){J.canReply=U},get contextValue(){return J.contextValue},set contextValue(U){J.contextValue=U},get label(){return J.label},set label(U){J.label=U},get state(){return J.state},set state(U){J.state=U},reveal:(U,V)=>J.reveal(U,V),hide:()=>J.hide(),dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Wc);const v=T=>Object.prototype.hasOwnProperty.call(this.b,T),C={};v("range")&&(C.range=I.Range.from(this.p)),v("label")&&(C.label=this.label),v("contextValue")&&(C.contextValue=this.contextValue??null),v("comments")&&(C.comments=this.q.map(T=>o(this,T,this.k,this.extensionDescription))),v("collapsibleState")&&(C.collapseState=g(this.g)),v("canReply")&&(C.canReply=this.canReply),v("state")&&(C.state=d(this.h)),v("applicability")&&(C.applicability=S(this.h)),v("isTemplate")&&(C.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(v){for(const C of this.k){const T=C[0],$=C[1];if(v===$)return T}}async reveal(v,C){(0,E.$vH)(this.extensionDescription,"commentReveal");let T;v&&v.body!==void 0?T=v:C=C??v;let $=T?this.k.get(T):void 0;$??=this.k.get(this.q[0]);let w=!0,M=!1;return C?.focus===b.CommentThreadFocus.Reply?(M=!0,w=!1):C?.focus===b.CommentThreadFocus.Comment&&(w=!1),h.$revealCommentThread(this.m,this.handle,$,{preserveFocus:w,focusReply:M})}async hide(){return h.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Ke([(0,D.$bi)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,E.$vH)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$vH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$vH)(this.h,"activeComment"),this.f?.value}constructor(v,C,T,$){this.h=v,this.i=C,this.j=T,this.k=$,this.a=new Map,h.$registerCommentController(this.handle,T,$,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,A,L){return w.createCommentThread(M,A,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(v,C,T){C===void 0&&(0,E.$vH)(this.h,"fileComments");const $=new n(this.id,this.handle,void 0,v,C,T,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const C=this.a.get(v.commentThreadHandle);C&&(this.e=v.uniqueIdInThread?C.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(v,C,T){const $=new n(this.id,this.handle,void 0,O.URI.revive(v),I.Range.to(C),[],this.h,!0,T);return $.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(v,C){const T=this.a.get(v);T&&(T.range=I.Range.to(C))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function o(k,v,C,T){let $=C.get(v);return $||($=++k.commentHandle,C.set(v,$)),v.state!==void 0&&(0,E.$vH)(T,"commentsDraftState"),v.reactions?.some(w=>w.reactors!==void 0)&&(0,E.$vH)(T,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:$,body:typeof v.body=="string"?v.body:I.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(w=>a(w)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function a(k){return{label:k.label,iconPath:k.iconPath?I.$CQ(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(v=>v.name):k.reactors}}function m(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?O.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(v=>({name:v}))}}function g(k){if(k!==void 0)switch(k){case b.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case b.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function d(k){let v;if(typeof k=="object"?v=k.resolved:v=k,v!==void 0)switch(v){case b.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case b.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function S(k){let v;if(typeof k=="object"&&(v=k.applicability),v!==void 0)switch(v){case b.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case b.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Re[235],Te([1,0,19,76,4,15,24,2,8,67,80,5,7]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,p=qe(p),b=qe(b),u=qe(u);class E{constructor(a,m){this.document=a,this.b=m,this.a=1,this.c=new I.$xqc("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,m){await this.f(a).undo(),m||this.disposeBackup()}async redo(a,m){await this.f(a).redo(),m||this.disposeBackup()}disposeEdits(a){for(const m of a)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=t(this.document.uri)+this.a++;return(0,R.$jh)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const m=this.c.get(a,0);if(!m)throw new Error("No edit found");return m}}class f{constructor(){this.a=new Map}get(a,m){return this.a.get(this.b(a,m))}add(a,m,g){const d=this.b(a,m.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${a} resource:${m.uri}`);const S=new E(m,g);return this.a.set(d,S),S}delete(a,m){const g=this.b(a,m.uri);this.a.delete(g)}b(a,m){return`${a}@@@${m}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class c{constructor(){this.a=new Map}addTextProvider(a,m,g){return this.b(a,{type:r.Text,extension:m,provider:g})}addCustomProvider(a,m,g){return this.b(a,{type:r.Custom,extension:m,provider:g})}get(a){return this.a.get(a)}b(a,m){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,m),new u.$5N(()=>this.a.delete(a))}}class l{constructor(a,m,g,d,S){this.d=m,this.f=g,this.g=d,this.h=S,this.b=new c,this.c=new f,this.a=a.getProxy(b.$3N.MainThreadCustomEditors)}registerCustomEditorProvider(a,m,g,d){const S=new P.$Wc;return i(g)?(S.add(this.b.addTextProvider(m,a,g)),this.a.$registerTextEditorProvider((0,s.$7qc)(a),m,d.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,s.$5qc)(a))):(S.add(this.b.addCustomProvider(m,a,g)),h(g)&&S.add(g.onDidChangeCustomDocument(k=>{const v=this.i(m,k.document.uri);if(n(k)){const C=v.addEdit(k);this.a.$onDidEdit(k.document.uri,m,C,k.label)}else this.a.$onContentChange(k.document.uri,m)})),this.a.$registerCustomEditorProvider((0,s.$7qc)(a),m,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,s.$5qc)(a))),u.$5N.from(S,new u.$5N(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(a,m,g,d,S){const k=this.b.get(m);if(!k)throw new Error(`No provider found for '${m}'`);if(k.type!==r.Custom)throw new Error(`Invalid provide type for '${m}'`);const v=O.URI.revive(a),C=await k.provider.openCustomDocument(v,{backupId:g,untitledDocumentData:d?.buffer},S);let T;return h(k.provider)&&this.f&&(T=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(m,C,T),{editable:h(k.provider)}}async $disposeCustomDocument(a,m){const g=this.b.get(m);if(!g)throw new Error(`No provider found for '${m}'`);if(g.type!==r.Custom)throw new Error(`Invalid provider type for '${m}'`);const d=O.URI.revive(a),{document:S}=this.i(m,d);this.c.delete(m,S),S.dispose()}async $resolveCustomEditor(a,m,g,d,S,k){const v=this.b.get(g);if(!v)throw new Error(`No provider found for '${g}'`);const C=p.ViewColumn.to(S),T=this.g.createNewWebview(m,d.contentOptions,v.extension),$=this.h.createNewWebviewPanel(m,g,d.title,C,d.options,T,d.active),w=O.URI.revive(a);switch(v.type){case r.Custom:{const{document:M}=this.i(g,w);return v.provider.resolveCustomEditor(M,$,k)}case r.Text:{const M=this.d.getDocument(w);return v.provider.resolveCustomTextEditor(M,$,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,m,g){this.i(m,a).disposeEdits(g)}async $onMoveCustomEditor(a,m,g){const d=this.b.get(g);if(!d)throw new Error(`No provider found for '${g}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const S=this.h.getWebviewPanel(a);if(!S)throw new Error("No webview found");const k=O.URI.revive(m),v=this.d.getDocument(k);await d.provider.moveCustomTextEditor(v,S,y.CancellationToken.None)}async $undo(a,m,g,d){return this.i(m,a).undo(g,d)}async $redo(a,m,g,d){return this.i(m,a).redo(g,d)}async $revert(a,m,g){const d=this.i(m,a);await this.j(m).revertCustomDocument(d.document,g),d.disposeBackup()}async $onSave(a,m,g){const d=this.i(m,a);await this.j(m).saveCustomDocument(d.document,g),d.disposeBackup()}async $onSaveAs(a,m,g,d){const S=this.i(m,a);return this.j(m).saveCustomDocumentAs(S.document,O.URI.revive(g),d)}async $backup(a,m,g){const d=this.i(m,a),k=await this.j(m).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},g);return d.updateBackup(k),k.id}i(a,m){const g=this.c.get(a,O.URI.revive(m));if(!g)throw new Error("No custom document found");return g}j(a){const g=this.b.get(a)?.provider;if(!g||!h(g))throw new Error("Custom document is not editable");return g}}e.$0qc=l;function h(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const a=o.scheme===N.Schemas.file||o.scheme===N.Schemas.untitled?o.fsPath:o.toString();return(0,D.$wj)(a)+""}}),define(Re[236],Te([1,0,9,108,2,5,7,8,6,11,27,50]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0,O=qe(O);class E{#e;#t;#i;constructor(c,l,h,i,n,t,o,a){this.d=c,this.e=l,this.f=h,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,h),this.#i=new I.$Dc(m=>t.getComparisonKey(m)),this.#e=o,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,l){if(!c){this.clear();return}this.j();let h=[];if(P.URI.isUri(c)){if(!l){this.delete(c);return}this.#i.set(c,l.slice()),h=[c]}else if(Array.isArray(c)){h=[];let t;c=[...c].sort(E.k);for(const o of c){const[a,m]=o;if((!t||a.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=a,h.push(a),this.#i.set(a,[])),m)this.#i.get(a)?.push(...m);else{const g=this.#i.get(a);g&&(g.length=0)}}}if(this.#t.fire(h),!this.#e)return;const i=[];let n=0;for(const t of h){let o=[];const a=this.#i.get(t);if(a)if(a.length>this.g){o=[];const m=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const d of a)if(d.severity===m[g]&&o.push({...O.Diagnostic.from(d),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:D.MarkerSeverity.Info,message:(0,y.localize)(2698,null,a.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=a.map(m=>({...O.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,o]),n+=o.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,l){this.j();for(const[h,i]of this)c.call(l,h,i,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const l=this.#i.get(c);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,l){return c[0].toString()<l[0].toString()?-1:c[0].toString()>l[0].toString()?1:0}}e.$Eqc=E;let f=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(c){const l=new I.$Dc;for(const h of c)l.set(h,h);return{uris:Object.freeze(Array.from(l.values()))}}constructor(c,l,h,i){this.j=l,this.k=h,this.l=i,this.g=new Map,this.h=new p.$se({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=c.getProxy(N.$3N.MainThreadDiagnostics)}createDiagnosticCollection(c,l){const{g:h,f:i,h:n,j:t,k:o,l:a}=this,m=new class{$changeMany(S,k){i.$changeMany(S,k),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,S,k.length===0?"CLEARING":k)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,S)}dispose(){i.dispose()}};let g;if(!l)l="_generated_diagnostic_collection_name_#"+u.c++,g=l;else if(!h.has(l))g=l;else{this.j.warn(`DiagnosticCollection with name '${l}' does already exist.`);do g=l+u.c++;while(h.has(g))}return new class extends E{constructor(){super(l,g,u.e,u.d,S=>a.getDocument(S)?.version,o.extUri,m,n),h.set(g,this)}dispose(){super.dispose(),h.delete(g)}}}getDiagnostics(c){if(c)return this.m(c);{const l=new Map,h=[];for(const i of this.g.values())i.forEach((n,t)=>{let o=l.get(n.toString());typeof o>"u"&&(o=h.length,l.set(n.toString(),o),h.push([n,[]])),h[o][1]=h[o][1].concat(...t)});return h}}m(c){let l=[];for(const h of this.g.values())h.has(c)&&(l=l.concat(h.get(c)));return l}$acceptMarkersChange(c){if(!this.n){const l="_generated_mirror",h=new E(l,l,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(l,h),this.n=h}for(const[l,h]of c)this.n.set(P.URI.revive(l),h.map(O.Diagnostic.to))}};e.$Fqc=f,e.$Fqc=f=u=Ke([We(1,s.$dk),We(2,b.$Dqc)],f)}),define(Re[237],Te([1,0,2,12,7,8,171,39]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=void 0;class p{constructor(I,b,u,E={timeout:1500,errors:3}){this.c=I,this.d=b,this.f=u,this.g=E,this.a=new R.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(b,u,E)=>{const r={dispose:this.a.push([b,u,I])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(I,b){const u=y.URI.revive(I);let E=!1;const f=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const c of[...this.a]){if(E)break;const l=this.d.getDocument(u),h=await this.h(c,{document:l,reason:N.TextDocumentSaveReason.to(b)});r.push(h)}}finally{clearTimeout(f)}return r}h([I,b,u],E){const f=this.b.get(I);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(u,I,b,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const c=this.b.get(I);this.b.set(I,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,b,u,E){const f=[],r=Date.now(),{document:c,reason:l}=E,{version:h}=c,i=Object.freeze({document:c,reason:l,waitUntil(n){if(Object.isFrozen(f))throw(0,D.$0)("waitUntil can not be called async");f.push(Promise.resolve(n))}});try{b.apply(u,[i])}catch(n){return Promise.reject(n)}return Object.freeze(f),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(f).then(a=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(a)}).catch(a=>{clearTimeout(o),t(a)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(a=>a instanceof P.$bO))for(const{newText:a,newEol:m,range:g}of o)t.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:g&&N.Range.from(g),text:a,eol:m&&N.EndOfLine.from(m)}});if(t.edits.length!==0)return h===c.version?this.f.$tryApplyWorkspaceEdit(new O.$4w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Src=p}),define(Re[238],Te([1,0,6,4,2,5,125,8,14,25,7]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0,O=qe(O);class b{constructor(E,f){this.a=new y.$oe,this.b=new y.$oe,this.c=new y.$oe,this.d=new y.$oe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Wc,this.h=new Map,this.f=E.getProxy(N.$3N.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const c of r)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const c of r)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const f=this.g.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this.g.getDocument(E);if(f)return Promise.resolve(f);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(c=>{this.h.delete(E.toString());const l=P.URI.revive(c);return(0,p.$sg)(this.g.getDocument(l))},c=>(this.h.delete(E.toString()),Promise.reject(c))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(E,f){const r=P.URI.revive(E),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(f),this.a.fire(c.document)}$acceptModelSaved(E){const f=P.URI.revive(E),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,f){const r=P.URI.revive(E),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(f),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,r){const c=P.URI.revive(E),l=this.g.getDocument(c);if(!l)throw new Error("unknown document");l._acceptIsDirty(r),l.onEvents(f);let h;f.isUndoing?h=I.TextDocumentChangeReason.Undo:f.isRedoing&&(h=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$io)({document:l.document,contentChanges:f.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(E,f){(0,R.$FQ)(E,f)}}e.$Gqc=b}),define(Re[70],Te([1,0,239,6,14,2,3,5,16,8,7]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=e.$$qc=void 0,s=qe(s),e.$$qc=(0,R.$Ii)("IExtHostEditorTabs");class b{constructor(c,l,h){this.e=h,this.d=l,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,l={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new I.$SP(N.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new I.$TP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new I.$UP(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new I.$VP(N.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new I.$WP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new I.$XP(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new I.$YP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new I.$ZP;case O.TabInputKind.InteractiveEditorInput:return new I.$1P(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new I.$2P;case O.TabInputKind.MultiDiffEditorInput:return new I.$3P(this.b.input.diffEditors.map(c=>new I.$TP(N.URI.revive(c.original),N.URI.revive(c.modified))));default:return}}}class u{constructor(c,l){this.c=[],this.d="",this.b=c,this.e=l;for(const h of c.tabs)h.isActive&&(this.d=h.id),this.c.push(new b(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,l={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return s.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(h=>h.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(h=>h.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===O.TabModelOperationKind.TAB_OPEN){const h=new b(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,h),c.tabDto.isActive&&(this.d=h.tabId),h}else if(c.kind===O.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(c.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(c.kind===O.TabModelOperationKind.TAB_MOVE){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(c.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,h),h}const l=this.c.find(h=>h.tabId===c.tabDto.id);if(!l)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(c.tabDto),l}activeTabId(){return this.d}}let E=class{constructor(c){this.b=new D.$oe,this.c=new D.$oe,this.e=[],this.a=c.getProxy(O.$3N.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,l={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(h=>h.apiObject))},get activeTabGroup(){const h=c.d;return(0,P.$sg)(c.e.find(n=>n.groupId===h)?.apiObject)},close:async(h,i)=>{const n=Array.isArray(h)?h:[h];return n.length?f(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(c){const l=new Set(this.e.map(m=>m.groupId)),h=new Set(c.map(m=>m.groupId)),i=(0,y.$d)(l,h),n=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],o=[];this.e=c.map(m=>{const g=new u(m,()=>this.d);return i.added.includes(g.groupId)?t.push(g.apiObject):o.push(g.apiObject),g});const a=(0,P.$sg)(c.find(m=>m.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(c){const l=this.e.find(h=>h.groupId===c.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const l=this.e.find(i=>i.groupId===c.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const h=l.acceptTabOperation(c);switch(c.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(c){for(const l of this.e)for(const h of l.tabs)if(h.apiObject===c)return h}h(c){return this.e.find(l=>l.apiObject===c)}async i(c,l){const h=[];for(const i of c){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");h.push(n.tabId)}return this.a.$closeTab(h,l)}async j(c,l){const h=[];for(const i of c){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");h.push(n.groupId)}return this.a.$closeGroup(h,l)}};e.$_qc=E,e.$_qc=E=Ke([We(0,p.$DQ)],E);function f(r){return r.tabs!==void 0}}),define(Re[240],Te([1,0,2,5,28,4,7,8,285,13,30,20,21,59]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0,P=qe(P),O=qe(O);class f{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const h=this.a.indexOf(l);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),h=[];let i,n,t=p.State.LastKnownState,o=p.State.LastKnownState;for(const a of l){let m=i?(0,s.$Kf)(i,a):0;for(m===0?n=p.State.Start:n=o;m<a.length;m++)m+1===a.length?(t=o,o=p.State.BeforeColon):o+=1,h.push([n,a.toUpperCase().charCodeAt(m),o]),h.push([n,a.toLowerCase().charCodeAt(m),o]),n=o;i=a,o=t}h.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$34(h)}}provideDocumentLinks(l){this.c();const h=[],i=p.$44.computeLinks({getLineContent(n){return l.lineAt(n-1).text},getLineCount(){return l.lineCount}},this.b);for(const n of i){const t=O.DocumentLink.to(n);t.target&&h.push(t)}return h}}class r{constructor(l,h){this.i=h,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(D.$3N.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,h,i,n={}){if(r.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const t=this.h++;this.b.add(h),this.d.add(h),this.c.set(t,i);let o=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$vH)(l,"fsChunks"),o+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let a;n.isReadonly&&(0,E.$9k)(n.isReadonly)&&n.isReadonly.value!==""&&(a={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,h,o,a).catch(g=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${h}`),console.error(g)});const m=i.onDidChangeFile(g=>{const d=[];for(const S of g){const{uri:k,type:v}=S;if(k.scheme!==h)continue;let C;switch(v){case R.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case R.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:k,type:C})}this.a.$onFileSystemChange(t,d)});return(0,N.$Vc)(()=>{m.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:h,ctime:i,mtime:n,size:t,permissions:o}=l;return{type:h,ctime:i,mtime:n,size:t,permissions:o}}$stat(l,h){return Promise.resolve(this.l(l).stat(y.URI.revive(h))).then(i=>r.k(i))}$readdir(l,h){return Promise.resolve(this.l(l).readDirectory(y.URI.revive(h)))}$readFile(l,h){return Promise.resolve(this.l(l).readFile(y.URI.revive(h))).then(i=>b.$Qe.wrap(i))}$writeFile(l,h,i,n){return Promise.resolve(this.l(l).writeFile(y.URI.revive(h),i.buffer,n))}$delete(l,h,i){return Promise.resolve(this.l(l).delete(y.URI.revive(h),i))}$rename(l,h,i,n){return Promise.resolve(this.l(l).rename(y.URI.revive(h),y.URI.revive(i),n))}$copy(l,h,i,n){const t=this.l(l);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(y.URI.revive(h),y.URI.revive(i),n))}$mkdir(l,h){return Promise.resolve(this.l(l).createDirectory(y.URI.revive(h)))}$watch(l,h,i,n){const t=this.l(l).watch(y.URI.revive(i),n);this.f.set(h,t)}$unwatch(l,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(l,h,i){const n=this.l(l);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(h),i))}$close(l,h){const i=this.l(l);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(l,h,i,n){const t=this.l(l);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=b.$Qe.alloc(n);return Promise.resolve(t.read(h,i,o.buffer,0,n)).then(a=>o.slice(0,a))}$write(l,h,i,n){const t=this.l(l);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(h,i,n.buffer,0,n.byteLength))}l(l){const h=this.c.get(l);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$Vrc=r}),define(Re[241],Te([1,0,6,41,2,5,8,7,28,51]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0,R=qe(R);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(f,r,c,l,h,i){this.a=Math.random(),this.b=new y.$oe,this.c=new y.$oe,this.d=new y.$oe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,D.$Dk)(h),t=typeof h=="string",o=i?.correlate,a=l(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(o&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const g of m.created){const d=P.URI.revive(g);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const g of m.changed){const d=P.URI.revive(g);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const g of m.deleted){const d=P.URI.revive(g);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=O.$5N.from(this.i(f,c,h,i,i?.correlate),this.b,this.c,this.d,a)}i(f,r,c,l,h){const i=O.$5N.from();if(typeof c=="string"||l?.ignoreChangeEvents&&l?.ignoreCreateEvents&&l?.ignoreDeleteEvents)return i;const n=f.getProxy(N.$3N.MainThreadFileSystemEventService);let t=!1;(c.pattern.includes(D.$zk)||c.pattern.includes(D.$Ak))&&(t=!0);let o;return h&&(l?.ignoreChangeEvents||l?.ignoreCreateEvents||l?.ignoreDeleteEvents)&&(o=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,l?.ignoreChangeEvents&&(o&=~p.FileChangeFilter.UPDATED),l?.ignoreCreateEvents&&(o&=~p.FileChangeFilter.ADDED),l?.ignoreDeleteEvents&&(o&=~p.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,c.baseUri,{recursive:t,excludes:l?.excludes??[],filter:o},!!h),O.$5N.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class b{constructor(f){this.a=f,this.session=this.a.session,this.b=new s.$W(()=>this.a.created.map(P.URI.revive)),this.c=new s.$W(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$W(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(f,r,c){this.j=f,this.k=r,this.l=c,this.a=new y.$oe,this.b=new y.$oe,this.c=new y.$oe,this.d=new y.$oe,this.g=new y.$qe,this.h=new y.$qe,this.i=new y.$qe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(f,r,c,l){return new I(this.j,f,r,this.a.event,R.GlobPattern.from(c),l)}$onFileEvent(f){this.a.fire(new b(f))}$onDidRunFileOperation(f,r){switch(f){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(c=>({oldUri:P.URI.revive(c.source),newUri:P.URI.revive(c.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(c=>P.URI.revive(c.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(c=>P.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(f){return this.m(f,this.g)}getOnWillCreateFileEvent(f){return this.m(f,this.h)}getOnWillDeleteFileEvent(f){return this.m(f,this.i)}m(f,r){return(c,l,h)=>{const i=function(t){c.call(l,t)};return i.extension=f,r.event(i,void 0,h)}}async $onWillRunFileOperation(f,r,c,l){switch(f){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},c,l);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>P.URI.revive(h.target))},c,l);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>P.URI.revive(h.target))},c,l)}}async n(f,r,c,l){const h=new Set,i=[];if(await f.fireAsync(r,l,async(t,o)=>{const a=Date.now(),m=await Promise.resolve(t);m instanceof O.$eO&&(i.push([o.extension,m]),h.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-a>c&&this.k.warn("SLOW file-participant",o.extension.identifier)}),l.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:a=>this.l.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(h)}}}e.$Wrc=u}),define(Re[242],Te([1,0,17,10,19,12,97,4,25,69,13,14,2,32,286,94,104,9,18,8,7,21,80,5]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0,r=qe(r),i=qe(i),a=qe(a);class m{constructor(B,j){this.d=B,this.e=j}async provideDocumentSymbols(B,j){const H=this.d.getDocument(B),G=await this.e.provideDocumentSymbols(H,j);if(!(0,y.$Mb)(G))return G[0]instanceof n.$oO?G.map(i.DocumentSymbol.from):m.f(G)}static f(B){B=B.slice(0).sort((G,re)=>{let ge=G.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(G.location.range.end)),ge});const j=[],H=[];for(const G of B){const re={name:G.name||"!!MISSING: name!!",kind:i.SymbolKind.from(G.kind),tags:G.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:i.Range.from(G.location.range),selectionRange:i.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(re),j.push(re);break}const ge=H[H.length-1];if(E.$Tt.containsRange(ge.range,re.range)&&!E.$Tt.equalsRange(ge.range,re.range)){ge.children?.push(re),H.push(re);break}H.pop()}}return j}}class g{constructor(B,j,H,G,re,ge){this.f=B,this.g=j,this.h=H,this.j=G,this.k=re,this.l=ge,this.d=new o.$xqc("CodeLens"),this.e=new Map}async provideCodeLenses(B,j){const H=this.f.getDocument(B),G=await this.h.provideCodeLenses(H,j);if(!G||j.isCancellationRequested)return;const re=this.d.add(G),ge=new O.$Wc;this.e.set(re,ge);const Ee={cacheId:re,lenses:[]};for(let Ue=0;Ue<G.length;Ue++)Ee.lenses.push({cacheId:[re,Ue],range:i.Range.from(G[Ue].range),command:this.g.toInternal(G[Ue].command,ge)});return Ee}async resolveCodeLens(B,j){const H=B.cacheId&&this.d.get(...B.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,j),G||(G=H),j.isCancellationRequested)return;const re=B.cacheId&&this.e.get(B.cacheId[0]);if(re){if(!G.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return B.command=this.g.toInternal(G.command,re),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function d(Le){return Array.isArray(Le)?Le.map(i.DefinitionLink.from):Le?[i.DefinitionLink.from(Le)]:[]}class S{constructor(B,j){this.d=B,this.e=j}async provideDefinition(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideDefinition(G,re,H);return d(ge)}}class k{constructor(B,j){this.d=B,this.e=j}async provideDeclaration(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideDeclaration(G,re,H);return d(ge)}}class v{constructor(B,j){this.d=B,this.e=j}async provideImplementation(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideImplementation(G,re,H);return d(ge)}}class C{constructor(B,j){this.d=B,this.e=j}async provideTypeDefinition(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideTypeDefinition(G,re,H);return d(ge)}}class T{static{this.f=10}constructor(B,j){this.g=B,this.h=j,this.d=0,this.e=new Map}async provideHover(B,j,H,G){const re=this.g.getDocument(B),ge=i.Position.to(j);let Ee;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,at=this.e.get(tt);if(!at)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:at};Ee=await this.h.provideHover(re,ge,G,it)}else Ee=await this.h.provideHover(re,ge,G);if(!Ee||(0,y.$Mb)(Ee.contents))return;Ee.range||(Ee.range=re.getWordRangeAtPosition(ge)),Ee.range||(Ee.range=new n.$7N(ge,ge));const Ue=i.Hover.from(Ee),Je=this.d;if(this.e.size===T.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Je,Ee),this.d+=1,{...Ue,id:Je}}releaseHover(B){this.e.delete(B)}}class ${constructor(B,j){this.d=B,this.e=j}async provideEvaluatableExpression(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideEvaluatableExpression(G,re,H);if(ge)return i.EvaluatableExpression.from(ge)}}class w{constructor(B,j){this.d=B,this.e=j}async provideInlineValues(B,j,H,G){const re=this.d.getDocument(B),ge=await this.e.provideInlineValues(re,i.Range.to(j),i.InlineValueContext.to(H),G);if(Array.isArray(ge))return ge.map(Ee=>i.InlineValue.from(Ee))}}class M{constructor(B,j){this.d=B,this.e=j}async provideDocumentHighlights(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideDocumentHighlights(G,re,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class A{constructor(B,j){this.d=B,this.e=j}async provideMultiDocumentHighlights(B,j,H,G){const re=this.d.getDocument(B),ge=H.map(Je=>this.d.getDocument(Je)),Ee=i.Position.to(j),Ue=await this.e.provideMultiDocumentHighlights(re,Ee,ge,G);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class L{constructor(B,j){this.d=B,this.e=j}async provideLinkedEditingRanges(B,j,H){const G=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideLinkedEditingRanges(G,re,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,y.$Jb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class Z{constructor(B,j){this.d=B,this.e=j}async provideReferences(B,j,H,G){const re=this.d.getDocument(B),ge=i.Position.to(j),Ee=await this.e.provideReferences(re,ge,H,G);if(Array.isArray(Ee))return Ee.map(i.location.from)}}class J{static{this.d=1e3}constructor(B,j,H,G,re,ge,Ee){this.g=B,this.h=j,this.j=H,this.k=G,this.l=re,this.m=ge,this.n=Ee,this.e=new o.$xqc("CodeAction"),this.f=new Map}async provideCodeActions(B,j,H,G){const re=this.g.getDocument(B),ge=f.$Vt.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ee=[];for(const it of this.j.getDiagnostics(B))if(ge.intersection(it.range)&&Ee.push(it)>J.d)break;const Ue={diagnostics:Ee,only:H.only?new n.$qO(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Je=await this.k.provideCodeActions(re,ge,Ue,G);if(!(0,y.$Nb)(Je)||G.isCancellationRequested)return;const _e=this.e.add(Je),tt=new O.$Wc;this.f.set(_e,tt);const at=[];for(let it=0;it<Je.length;it++){const ot=Je[it];if(ot)if(J.o(ot))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:ot.title,command:this.h.toInternal(ot,tt)});else{Ue.only&&(ot.kind?Ue.only.contains(ot.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${ot.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const vt=ot.ranges??[];at.push({cacheId:[_e,it],title:ot.title,command:ot.command&&this.h.toInternal(ot.command,tt),diagnostics:ot.diagnostics&&ot.diagnostics.map(i.Diagnostic.from),edit:ot.edit&&i.WorkspaceEdit.from(ot.edit,void 0),kind:ot.kind&&ot.kind.value,isPreferred:ot.isPreferred,isAI:(0,t.$uH)(this.m,"codeActionAI")?ot.isAI:!1,ranges:(0,t.$uH)(this.m,"codeActionRanges")?(0,y.$Jb)(vt.map(i.Range.from)):void 0,disabled:ot.disabled?.reason})}}return{cacheId:_e,actions:at}}async resolveCodeAction(B,j){const[H,G]=B,re=this.e.get(H,G);if(!re||J.o(re))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(re,j)??re;let Ee;ge.edit&&(Ee=i.WorkspaceEdit.from(ge.edit,void 0));let Ue;if(ge.command){const Je=this.f.get(H);Je&&(Ue=this.h.toInternal(ge.command,Je))}return{edit:Ee,command:Ue}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class U{constructor(B,j,H,G,re){this.e=B,this.f=j,this.g=H,this.h=G,this.j=re,this.d=new o.$xqc("DocumentPasteEdit")}async prepareDocumentPaste(B,j,H,G){if(!this.g.prepareDocumentPaste)return;const re=this.f.getDocument(B),ge=j.map(Je=>i.Range.to(Je)),Ee=i.DataTransfer.toDataTransfer(H,()=>{throw new N.$ab});if(await this.g.prepareDocumentPaste(re,ge,Ee,G),G.isCancellationRequested)return;const Ue=Array.from(Ee).filter(([,Je])=>!(Je instanceof n.$WO));return i.DataTransfer.from(Ue)}async providePasteEdits(B,j,H,G,re,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ee=this.f.getDocument(j),Ue=H.map(at=>i.Range.to(at)),Je=i.DataTransfer.toDataTransfer(G,async at=>(await this.e.$resolvePasteFileData(this.h,B,at)).buffer),_e=await this.g.provideDocumentPasteEdits(Ee,Ue,Je,{only:re.only?new n.$2O(re.only):void 0,triggerKind:re.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((at,it)=>({_cacheId:[tt,it],title:at.title??(0,l.localize)(2701,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(ot=>ot.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,j){const[H,G]=B,re=this.d.get(H,G);if(!re||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class V{constructor(B,j){this.d=B,this.e=j}async provideDocumentFormattingEdits(B,j,H){const G=this.d.getDocument(B),re=await this.e.provideDocumentFormattingEdits(G,j,H);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class Q{constructor(B,j){this.d=B,this.e=j}async provideDocumentRangeFormattingEdits(B,j,H,G){const re=this.d.getDocument(B),ge=i.Range.to(j),Ee=await this.e.provideDocumentRangeFormattingEdits(re,ge,H,G);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,j,H,G){(0,b.$rg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(B),ge=j.map(i.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(re,ge,H,G);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}}class ne{constructor(B,j){this.d=B,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,j,H,G,re){const ge=this.d.getDocument(B),Ee=i.Position.to(j),Ue=await this.e.provideOnTypeFormattingEdits(ge,Ee,H,G,re);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class ue{constructor(B,j){this.e=B,this.f=j,this.d=new o.$xqc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,j){const H=await this.e.provideWorkspaceSymbols(B,j);if(!(0,y.$Nb)(H))return{symbols:[]};const G=this.d.add(H),re={cacheId:G,symbols:[]};for(let ge=0;ge<H.length;ge++){const Ee=H[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}re.symbols.push({...i.WorkspaceSymbol.from(Ee),cacheId:[G,ge]})}return re}async resolveWorkspaceSymbol(B,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this.d.get(...B.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,j);return G&&(0,p.$ko)(B,i.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class _{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,j,H){this.d=B,this.e=j,this.f=H}async provideRenameEdits(B,j,H,G){const re=this.d.getDocument(B),ge=i.Position.to(j);try{const Ee=await this.e.provideRenameEdits(re,ge,H,G);return Ee?i.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Ue=_.g(Ee);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(B,j,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(B),re=i.Position.to(j);try{const ge=await this.e.prepareRename(G,re,H);let Ee,Ue;if(n.$7N.isRange(ge)?(Ee=ge,Ue=G.getText(ge)):(0,b.$jg)(ge)&&(Ee=ge.range,Ue=ge.placeholder),!Ee||!Ue)return;if(Ee.start.line>re.line||Ee.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ee),text:Ue}}catch(ge){const Ee=_.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ae{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(B,j,H){this.e=B,this.f=j,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,j,H,G){const re=this.e.getDocument(B),ge=i.Range.to(j);try{const Ee=ae.d[H],Ue=await this.f.provideNewSymbolNames(re,ge,Ee,G);return Ue?Ue.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ee){this.g.error(ae.h(Ee)??JSON.stringify(Ee,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class se{constructor(B,j){this.resultId=B,this.tokens=j}}class ce{constructor(B,j){this.f=B,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,j,H){const G=this.f.getDocument(B),re=j!==0?this.d.get(j):null;let ge=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,re.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return re&&this.d.delete(j),ge?(ge=ce.h(ge),this.o(ce.n(re,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ce.j(B)?ce.k(B)?B:new n.$pP(new Uint32Array(B.data),B.resultId):ce.l(B)?ce.m(B)?B:new n.$rP(B.edits.map(j=>new n.$qP(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const j of B.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(B,j){if(!ce.j(j)||!B||!B.tokens)return j;const H=B.tokens,G=H.length,re=j.data,ge=re.length;let Ee=0;const Ue=Math.min(G,ge);for(;Ee<Ue&&H[Ee]===re[Ee];)Ee++;if(Ee===G&&Ee===ge)return new n.$rP([],j.resultId);let Je=0;const _e=Ue-Ee;for(;Je<_e&&H[G-Je-1]===re[ge-Je-1];)Je++;return new n.$rP([{start:Ee,deleteCount:G-Ee-Je,data:re.subarray(Ee,ge-Je)}],j.resultId)}o(B,j){if(ce.j(B)){const H=this.e++;return this.d.set(H,new se(B.resultId,B.data)),(0,c.$oeb)({id:H,type:"full",data:B.data})}if(ce.l(B)){const H=this.e++;return ce.j(j)?this.d.set(H,new se(j.resultId,j.data)):this.d.set(H,new se(B.resultId)),(0,c.$oeb)({id:H,type:"delta",deltas:(B.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class x{constructor(B,j){this.d=B,this.e=j}async provideDocumentRangeSemanticTokens(B,j,H){const G=this.d.getDocument(B),re=await this.e.provideDocumentRangeSemanticTokens(G,i.Range.to(j),H);return re?this.f(re):null}f(B){return(0,c.$oeb)({id:0,type:"full",data:B.data})}}class we{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,j,H,G,re){this.f=B,this.g=j,this.h=H,this.j=G,this.k=re,this.d=new o.$xqc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,j,H,G){const re=this.f.getDocument(B),ge=i.Position.to(j),Ee=re.getWordRangeAtPosition(ge)||new n.$7N(ge,ge),Ue=Ee.with({end:ge}),Je=new s.$ie,_e=await this.h.provideCompletionItems(re,ge,G,i.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$DO(_e):_e,at=we.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new O.$Wc;this.e.set(at,it);const ot=[],vt={x:at,[a.ISuggestResultDtoField.completions]:ot,[a.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ee),insert:i.Range.from(Ue)},[a.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[a.ISuggestResultDtoField.duration]:Je.elapsed()};for(let Ye=0;Ye<tt.items.length;Ye++){const he=tt.items[Ye],pe=this.l(he,[at,Ye],Ue,Ee);ot.push(pe)}return vt}async resolveCompletionItem(B,j){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...B);if(!H)return;const G=this.l(H,B),re=await this.h.resolveCompletionItem(H,j);if(!re)return;const ge=this.l(re,B);return(G[a.ISuggestDataDtoField.insertText]!==ge[a.ISuggestDataDtoField.insertText]||G[a.ISuggestDataDtoField.insertTextRules]!==ge[a.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G[a.ISuggestDataDtoField.commandIdent]!==ge[a.ISuggestDataDtoField.commandIdent]||G[a.ISuggestDataDtoField.commandId]!==ge[a.ISuggestDataDtoField.commandId]||!(0,p.$lo)(G[a.ISuggestDataDtoField.commandArguments],ge[a.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,[a.ISuggestDataDtoField.documentation]:ge[a.ISuggestDataDtoField.documentation],[a.ISuggestDataDtoField.detail]:ge[a.ISuggestDataDtoField.detail],[a.ISuggestDataDtoField.additionalTextEdits]:ge[a.ISuggestDataDtoField.additionalTextEdits],[a.ISuggestDataDtoField.insertText]:ge[a.ISuggestDataDtoField.insertText],[a.ISuggestDataDtoField.insertTextRules]:ge[a.ISuggestDataDtoField.insertTextRules],[a.ISuggestDataDtoField.commandIdent]:ge[a.ISuggestDataDtoField.commandIdent],[a.ISuggestDataDtoField.commandId]:ge[a.ISuggestDataDtoField.commandId],[a.ISuggestDataDtoField.commandArguments]:ge[a.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,j,H,G){const re=this.e.get(j[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,re),Ee={x:j,[a.ISuggestDataDtoField.label]:B.label,[a.ISuggestDataDtoField.kind]:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,[a.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(i.CompletionItemTag.from),[a.ISuggestDataDtoField.detail]:B.detail,[a.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),[a.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[a.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[a.ISuggestDataDtoField.preselect]:B.preselect||void 0,[a.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[a.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[a.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),[a.ISuggestDataDtoField.commandIdent]:ge?.$ident,[a.ISuggestDataDtoField.commandId]:ge?.id,[a.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee[a.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?Ee[a.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof n.$fO&&(Ee[a.ISuggestDataDtoField.insertText]=B.insertText.value,Ee[a.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return B.textEdit?Ue=B.textEdit.range:B.range&&(Ue=B.range),n.$7N.isRange(Ue)?Ee[a.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!H?.isEqual(Ue.inserting)||!G?.isEqual(Ue.replacing))&&(Ee[a.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Ee}}class Ie{async provideInlineCompletions(B,j,H,G){}async provideInlineEdits(B,j,H,G){}disposeCompletions(B){}handleDidShowCompletionItem(B,j,H){}handlePartialAccept(B,j,H,G){}}class Y extends Ie{constructor(B,j,H,G){super(),this.f=B,this.g=j,this.h=H,this.j=G,this.d=new ie,this.e=(0,t.$uH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$uH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,j,H,G){const re=this.g.getDocument(B),ge=i.Position.to(j),Ee=await this.h.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Ee||G.isCancellationRequested)return;const Ue=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((it,ot)=>{let vt;it.command&&(tt||(tt=new O.$Wc),vt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:vt,idx:ot,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new O.$Wc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(B,j,H,G){if(!this.h.provideInlineEdits)return;(0,t.$vH)(this.f,"inlineCompletionsAdditions");const re=this.g.getDocument(B),ge=i.Range.to(j),Ee=await this.h.provideInlineEdits(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},G);if(!Ee||G.isCancellationRequested)return;const Ue=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((it,ot)=>{let vt;it.command&&(tt||(tt=new O.$Wc),vt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:vt,idx:ot,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new O.$Wc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,j,H){const G=this.d.get(B)?.items[j];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(B,j,H,G){const re=this.d.get(B)?.items[j];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(re,H),this.h.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(G)))}}class q{async provideInlineEdits(B,j,H){const G=this.f.getDocument(B),re=await this.g.provideInlineEdit(G,{triggerKind:this.e[j.triggerKind]},H);if(!re||H.isCancellationRequested)return;let ge;const Ee=this.d.createReferenceId({dispose(){ge?.dispose()},item:re});let Ue;re.accepted&&(ge||(ge=new O.$Wc),Ue=this.h.toInternal(re.accepted,ge));let Je;return re.rejected&&(ge||(ge=new O.$Wc),Je=this.h.toInternal(re.rejected,ge)),{pid:Ee,text:re.text,range:i.Range.from(re.range),accepted:Ue,rejected:Je}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,j,H,G){this.f=j,this.g=H,this.h=G,this.d=new ie,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const j=this.e++;return this.d.set(j,B),j}disposeReferenceId(B){const j=this.d.get(B);return this.d.delete(B),j}get(B){return this.d.get(B)}}class ve{constructor(B,j){this.e=B,this.f=j,this.d=new o.$xqc("SignatureHelp")}async provideSignatureHelp(B,j,H,G){const re=this.e.getDocument(B),ge=i.Position.to(j),Ee=this.g(H),Ue=await this.f.provideSignatureHelp(re,ge,G,Ee);if(Ue){const Je=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Je}}}g(B){let j;if(B.activeSignatureHelp){const H=i.SignatureHelp.to(B.activeSignatureHelp),G=this.d.get(B.activeSignatureHelp.id,0);G?(j=G,j.activeSignature=H.activeSignature,j.activeParameter=H.activeParameter):j=H}return{...B,activeSignatureHelp:j}}releaseSignatureHelp(B){this.d.delete(B)}}class Pe{constructor(B,j,H,G,re){this.f=B,this.g=j,this.h=H,this.j=G,this.k=re,this.d=new o.$xqc("InlayHints"),this.e=new Map}async provideInlayHints(B,j,H){const G=this.f.getDocument(B),re=i.Range.to(j),ge=await this.h.provideInlayHints(G,re,H);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(H.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new O.$Wc);const Ue={hints:[],cacheId:Ee};for(let Je=0;Je<ge.length;Je++)this.l(ge[Je],re)&&Ue.hints.push(this.m(ge[Je],[Ee,Je]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ue}async resolveInlayHint(B,j){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...B);if(!H)return;const G=await this.h.resolveInlayHint(H,j);if(G&&this.l(G))return this.m(G,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,j){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(j&&!j.contains(B.position))}m(B,j){const H=this.e.get(j[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")G.label=B.label;else{const re=[];G.label=re;for(const ge of B.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$gO.isLocation(ge.location)&&(Ee.location=i.location.from(ge.location)),ge.command&&(Ee.command=this.g.toInternal(ge.command,H)),re.push(Ee)}}return G}}class Fe{constructor(B,j){this.e=B,this.f=j,this.d=new o.$xqc("DocumentLink")}async provideLinks(B,j){const H=this.e.getDocument(B),G=await this.f.provideDocumentLinks(H,j);if(!(!Array.isArray(G)||G.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(Fe.g).map(i.DocumentLink.from)};{const re=this.d.add(G),ge={links:[],cacheId:re};for(let Ee=0;Ee<G.length;Ee++){if(!Fe.g(G[Ee]))continue;const Ue=i.DocumentLink.from(G[Ee]);Ue.cacheId=[re,Ee],ge.links.push(Ue)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,j){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...B);if(!H)return;const G=await this.f.resolveDocumentLink(H,j);if(!(!G||!Fe.g(G)))return i.DocumentLink.from(G)}releaseLinks(B){this.d.delete(B)}}class Be{constructor(B,j){this.d=B,this.e=j}async provideColors(B,j){const H=this.d.getDocument(B),G=await this.e.provideDocumentColors(H,j);return Array.isArray(G)?G.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(B,j,H){const G=this.d.getDocument(B),re=i.Range.to(j.range),ge=i.Color.to(j.color),Ee=await this.e.provideColorPresentations(ge,{document:G,range:re},H);if(Array.isArray(Ee))return Ee.map(i.ColorPresentation.from)}}class xe{constructor(B,j){this.d=B,this.e=j}async provideFoldingRanges(B,j,H){const G=this.d.getDocument(B),re=await this.e.provideFoldingRanges(G,j,H);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class nt{constructor(B,j,H){this.d=B,this.e=j,this.f=H}async provideSelectionRanges(B,j,H){const G=this.d.getDocument(B),re=j.map(i.Position.to),ge=await this.e.provideSelectionRanges(G,re,H);if(!(0,y.$Nb)(ge))return[];if(ge.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Ue=0;Ue<re.length;Ue++){const Je=[];Ee.push(Je);let _e=re[Ue],tt=ge[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ee}}class ut{constructor(B,j){this.f=B,this.g=j,this.d=new R.$IQ(""),this.e=new Map}async prepareSession(B,j,H){const G=this.f.getDocument(B),re=i.Position.to(j),ge=await this.g.prepareCallHierarchy(G,re,H);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Ee,Ue)):[this.h(Ee,ge)]}async provideCallsTo(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(G,H);if(re)return re.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}async provideCallsFrom(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(re)return re.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}releaseSession(B){this.e.delete(B)}h(B,j){const H=this.e.get(B),G=i.CallHierarchyItem.from(j,B,H.size.toString(36));return H.set(G._itemId,j),G}j(B,j){return this.e.get(B)?.get(j)}}class pt{constructor(B,j){this.f=B,this.g=j,this.d=new R.$IQ(""),this.e=new Map}async prepareSession(B,j,H){const G=this.f.getDocument(B),re=i.Position.to(j),ge=await this.g.prepareTypeHierarchy(G,re,H);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Ee,Ue)):[this.h(Ee,ge)]}async provideSupertypes(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(G,H);if(re)return re.map(ge=>this.h(B,ge))}async provideSubtypes(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(G,H);if(re)return re.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,j){const H=this.e.get(B),G=i.TypeHierarchyItem.from(j,B,H.size.toString(36));return H.set(G._itemId,j),G}j(B,j){return this.e.get(B)?.get(j)}}class lt{constructor(B,j,H,G,re){this.e=B,this.f=j,this.g=H,this.h=G,this.j=re,this.d=new o.$xqc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,j,H,G,re){const ge=this.f.getDocument(j),Ee=i.Position.to(H),Ue=i.DataTransfer.toDataTransfer(G,async at=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,at)).buffer),Je=await this.g.provideDocumentDropEdits(ge,Ee,Ue,re);if(!Je)return;const _e=(0,y.$4b)(Je),tt=this.d.add(_e);return _e.map((at,it)=>({_cacheId:[tt,it],title:at.title??(0,l.localize)(2702,null,this.j.displayName||this.j.name),kind:at.kind?.value,yieldTo:at.yieldTo?.map(ot=>ot.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,j){const[H,G]=B,re=this.d.get(H,G);if(!re||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class et{constructor(B,j){this.d=B,this.e=j}async provideMappedEdits(B,j,H,G){const re=u.URI.revive(B),ge=this.d.getDocument(re),Ee=H.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(at=>i.Range.to(at))}))),Ue={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(ge,j,Ue,G);return Je?i.WorkspaceEdit.from(Je):null}}class Ne{constructor(B,j){this.adapter=B,this.extension=j}}class Me{static{this.d=0}constructor(B,j,H,G,re,ge,Ee,Ue){this.g=j,this.h=H,this.j=G,this.k=re,this.l=ge,this.m=Ee,this.n=Ue,this.f=new Map,this.e=B.getProxy(a.$3N.MainThreadLanguageFeatures)}o(B,j){return i.DocumentSelector.from(B,this.g,j)}p(B){return new n.$5N(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Me.d++}async s(B,j,H,G,re,ge=!1){const Ee=this.f.get(B);if(!Ee||!(Ee.adapter instanceof j))return G;const Ue=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Je=H(Ee.adapter,Ee.extension);return Promise.resolve(Je).catch(_e=>{(0,N.$6)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),P.CancellationToken.isCancellationToken(re)?(0,D.$xh)(Je,re):Je}t(B,j){const H=this.q();return this.f.set(H,new Ne(B,j)),H}static u(B){return B.displayName||B.name}static w(B){return B.identifier.value}registerDocumentSymbolProvider(B,j,H,G){const re=this.t(new m(this.h,H),B),ge=G&&G.label||Me.u(B);return this.e.$registerDocumentSymbolProvider(re,this.o(j,B),ge),this.p(re)}$provideDocumentSymbols(B,j,H){return this.s(B,m,G=>G.provideDocumentSymbols(u.URI.revive(j),H),void 0,H)}registerCodeLensProvider(B,j,H){const G=this.q(),re=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Ne(new g(this.h,this.j.converter,H,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(G,this.o(j,B),re);let ge=this.p(G);if(re!==void 0){const Ee=H.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(re));ge=n.$5N.from(ge,Ee)}return ge}$provideCodeLenses(B,j,H){return this.s(B,g,G=>G.provideCodeLenses(u.URI.revive(j),H),void 0,H)}$resolveCodeLens(B,j,H){return this.s(B,g,G=>G.resolveCodeLens(j,H),void 0,void 0)}$releaseCodeLenses(B,j){this.s(B,g,H=>Promise.resolve(H.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(B,j,H){const G=this.t(new S(this.h,H),B);return this.e.$registerDefinitionSupport(G,this.o(j,B)),this.p(G)}$provideDefinition(B,j,H,G){return this.s(B,S,re=>re.provideDefinition(u.URI.revive(j),H,G),[],G)}registerDeclarationProvider(B,j,H){const G=this.t(new k(this.h,H),B);return this.e.$registerDeclarationSupport(G,this.o(j,B)),this.p(G)}$provideDeclaration(B,j,H,G){return this.s(B,k,re=>re.provideDeclaration(u.URI.revive(j),H,G),[],G)}registerImplementationProvider(B,j,H){const G=this.t(new v(this.h,H),B);return this.e.$registerImplementationSupport(G,this.o(j,B)),this.p(G)}$provideImplementation(B,j,H,G){return this.s(B,v,re=>re.provideImplementation(u.URI.revive(j),H,G),[],G)}registerTypeDefinitionProvider(B,j,H){const G=this.t(new C(this.h,H),B);return this.e.$registerTypeDefinitionSupport(G,this.o(j,B)),this.p(G)}$provideTypeDefinition(B,j,H,G){return this.s(B,C,re=>re.provideTypeDefinition(u.URI.revive(j),H,G),[],G)}registerHoverProvider(B,j,H,G){const re=this.t(new T(this.h,H),B);return this.e.$registerHoverProvider(re,this.o(j,B)),this.p(re)}$provideHover(B,j,H,G,re){return this.s(B,T,ge=>ge.provideHover(u.URI.revive(j),H,G,re),void 0,re)}$releaseHover(B,j){this.s(B,T,H=>Promise.resolve(H.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(B,j,H,G){const re=this.t(new $(this.h,H),B);return this.e.$registerEvaluatableExpressionProvider(re,this.o(j,B)),this.p(re)}$provideEvaluatableExpression(B,j,H,G){return this.s(B,$,re=>re.provideEvaluatableExpression(u.URI.revive(j),H,G),void 0,G)}registerInlineValuesProvider(B,j,H,G){const re=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new w(this.h,H),B);this.e.$registerInlineValuesProvider(ge,this.o(j,B),re);let Ee=this.p(ge);if(re!==void 0){const Ue=H.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(re));Ee=n.$5N.from(Ee,Ue)}return Ee}$provideInlineValues(B,j,H,G,re){return this.s(B,w,ge=>ge.provideInlineValues(u.URI.revive(j),H,G,re),void 0,re)}registerDocumentHighlightProvider(B,j,H){const G=this.t(new M(this.h,H),B);return this.e.$registerDocumentHighlightProvider(G,this.o(j,B)),this.p(G)}registerMultiDocumentHighlightProvider(B,j,H){const G=this.t(new A(this.h,H),B);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(j,B)),this.p(G)}$provideDocumentHighlights(B,j,H,G){return this.s(B,M,re=>re.provideDocumentHighlights(u.URI.revive(j),H,G),void 0,G)}$provideMultiDocumentHighlights(B,j,H,G,re){return this.s(B,A,ge=>ge.provideMultiDocumentHighlights(u.URI.revive(j),H,G.map(Ee=>u.URI.revive(Ee)),re),void 0,re)}registerLinkedEditingRangeProvider(B,j,H){const G=this.t(new L(this.h,H),B);return this.e.$registerLinkedEditingRangeProvider(G,this.o(j,B)),this.p(G)}$provideLinkedEditingRanges(B,j,H,G){return this.s(B,L,async re=>{const ge=await re.provideLinkedEditingRanges(u.URI.revive(j),H,G);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Me.y(ge.wordPattern):void 0}},void 0,G)}registerReferenceProvider(B,j,H){const G=this.t(new Z(this.h,H),B);return this.e.$registerReferenceSupport(G,this.o(j,B)),this.p(G)}$provideReferences(B,j,H,G,re){return this.s(B,Z,ge=>ge.provideReferences(u.URI.revive(j),H,G,re),void 0,re)}registerCodeActionProvider(B,j,H,G){const re=new O.$Wc,ge=this.t(new J(this.h,this.j.converter,this.k,H,this.l,B,this.m),B);return this.e.$registerCodeActionSupport(ge,this.o(j,B),{providedKinds:G?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:G?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,re)}))},Me.u(B),Me.w(B),!!H.resolveCodeAction),re.add(this.p(ge)),re}$provideCodeActions(B,j,H,G,re){return this.s(B,J,ge=>ge.provideCodeActions(u.URI.revive(j),H,G,re),void 0,re)}$resolveCodeAction(B,j,H){return this.s(B,J,G=>G.resolveCodeAction(j,H),{},void 0)}$releaseCodeActions(B,j){this.s(B,J,H=>Promise.resolve(H.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(B,j,H){const G=this.t(new V(this.h,H),B);return this.e.$registerDocumentFormattingSupport(G,this.o(j,B),B.identifier,B.displayName||B.name),this.p(G)}$provideDocumentFormattingEdits(B,j,H,G){return this.s(B,V,re=>re.provideDocumentFormattingEdits(u.URI.revive(j),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(B,j,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",re=this.t(new Q(this.h,H),B);return this.e.$registerRangeFormattingSupport(re,this.o(j,B),B.identifier,B.displayName||B.name,G),this.p(re)}$provideDocumentRangeFormattingEdits(B,j,H,G,re){return this.s(B,Q,ge=>ge.provideDocumentRangeFormattingEdits(u.URI.revive(j),H,G,re),void 0,re)}$provideDocumentRangesFormattingEdits(B,j,H,G,re){return this.s(B,Q,ge=>ge.provideDocumentRangesFormattingEdits(u.URI.revive(j),H,G,re),void 0,re)}registerOnTypeFormattingEditProvider(B,j,H,G){const re=this.t(new ne(this.h,H),B);return this.e.$registerOnTypeFormattingSupport(re,this.o(j,B),G,B.identifier),this.p(re)}$provideOnTypeFormattingEdits(B,j,H,G,re,ge){return this.s(B,ne,Ee=>Ee.provideOnTypeFormattingEdits(u.URI.revive(j),H,G,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,j){const H=this.t(new ue(j,this.l),B);return this.e.$registerNavigateTypeSupport(H,typeof j.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(B,j,H){return this.s(B,ue,G=>G.provideWorkspaceSymbols(j,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,j,H){return this.s(B,ue,G=>G.resolveWorkspaceSymbol(j,H),void 0,void 0)}$releaseWorkspaceSymbols(B,j){this.s(B,ue,H=>H.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(B,j,H){const G=this.t(new _(this.h,H,this.l),B);return this.e.$registerRenameSupport(G,this.o(j,B),_.supportsResolving(H)),this.p(G)}$provideRenameEdits(B,j,H,G,re){return this.s(B,_,ge=>ge.provideRenameEdits(u.URI.revive(j),H,G,re),void 0,re)}$resolveRenameLocation(B,j,H,G){return this.s(B,_,re=>re.resolveRenameLocation(u.URI.revive(j),H,G),void 0,G)}registerNewSymbolNamesProvider(B,j,H){const G=this.t(new ae(this.h,H,this.l),B);return this.e.$registerNewSymbolNamesProvider(G,this.o(j,B)),this.p(G)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,ae,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,j,H,G,re){return this.s(B,ae,ge=>ge.provideNewSymbolNames(u.URI.revive(j),H,G,re),void 0,re)}registerDocumentSemanticTokensProvider(B,j,H,G){const re=this.t(new ce(this.h,H),B),ge=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(j,B),G,ge);let Ee=this.p(re);if(ge){const Ue=H.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=n.$5N.from(Ee,Ue)}return Ee}$provideDocumentSemanticTokens(B,j,H,G){return this.s(B,ce,re=>re.provideDocumentSemanticTokens(u.URI.revive(j),H,G),null,G)}$releaseDocumentSemanticTokens(B,j){this.s(B,ce,H=>H.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,j,H,G){const re=this.t(new x(this.h,H),B);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(j,B),G),this.p(re)}$provideDocumentRangeSemanticTokens(B,j,H,G){return this.s(B,x,re=>re.provideDocumentRangeSemanticTokens(u.URI.revive(j),H,G),null,G)}registerCompletionItemProvider(B,j,H,G){const re=this.t(new we(this.h,this.j.converter,H,this.m,B),B);return this.e.$registerCompletionsProvider(re,this.o(j,B),G,we.supportsResolving(H),B.identifier),this.p(re)}$provideCompletionItems(B,j,H,G,re){return this.s(B,we,ge=>ge.provideCompletionItems(u.URI.revive(j),H,G,re),void 0,re)}$resolveCompletionItem(B,j,H){return this.s(B,we,G=>G.resolveCompletionItem(j,H),void 0,H)}$releaseCompletionItems(B,j){this.s(B,we,H=>H.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(B,j,H,G){const re=new Y(B,this.h,H,this.j.converter),ge=this.t(re,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(j,B),re.supportsHandleEvents,h.$un.toKey(B.identifier.value),G?.yieldTo?.map(Ee=>h.$un.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(B,j,H,G,re){return this.s(B,Ie,ge=>ge.provideInlineCompletions(u.URI.revive(j),H,G,re),void 0,re)}$provideInlineEdits(B,j,H,G,re){return this.s(B,Ie,ge=>ge.provideInlineEdits(u.URI.revive(j),H,G,re),void 0,re)}$handleInlineCompletionDidShow(B,j,H,G){this.s(B,Ie,async re=>{re.handleDidShowCompletionItem(j,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,j,H,G,re){this.s(B,Ie,async ge=>{ge.handlePartialAccept(j,H,G,re)},void 0,void 0)}$freeInlineCompletionsList(B,j){this.s(B,Ie,async H=>{H.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(B,j,H){const G=new q(B,this.h,H,this.j.converter),re=this.t(G,B);return this.e.$registerInlineEditProvider(re,this.o(j,B),B.identifier),this.p(re)}$provideInlineEdit(B,j,H,G){return this.s(B,q,re=>re.provideInlineEdits(u.URI.revive(j),H,G),void 0,G)}$freeInlineEdit(B,j){this.s(B,q,async H=>{H.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(B,j,H,G){const re=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,ge=this.t(new ve(this.h,H),B);return this.e.$registerSignatureHelpProvider(ge,this.o(j,B),re),this.p(ge)}$provideSignatureHelp(B,j,H,G,re){return this.s(B,ve,ge=>ge.provideSignatureHelp(u.URI.revive(j),H,G,re),void 0,re)}$releaseSignatureHelp(B,j){this.s(B,ve,H=>H.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(B,j,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new Pe(this.h,this.j.converter,H,this.l,B),B);this.e.$registerInlayHintsProvider(re,this.o(j,B),typeof H.resolveInlayHint=="function",G,Me.u(B));let ge=this.p(re);if(G!==void 0){const Ee=H.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(G));ge=n.$5N.from(ge,Ee)}return ge}$provideInlayHints(B,j,H,G){return this.s(B,Pe,re=>re.provideInlayHints(u.URI.revive(j),H,G),void 0,G)}$resolveInlayHint(B,j,H){return this.s(B,Pe,G=>G.resolveInlayHint(j,H),void 0,H)}$releaseInlayHints(B,j){this.s(B,Pe,H=>H.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(B,j,H){const G=this.t(new Fe(this.h,H),B);return this.e.$registerDocumentLinkProvider(G,this.o(j,B),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(B,j,H){return this.s(B,Fe,G=>G.provideLinks(u.URI.revive(j),H),void 0,H,j.scheme==="output")}$resolveDocumentLink(B,j,H){return this.s(B,Fe,G=>G.resolveLink(j,H),void 0,void 0,!0)}$releaseDocumentLinks(B,j){this.s(B,Fe,H=>H.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(B,j,H){const G=this.t(new Be(this.h,H),B);return this.e.$registerDocumentColorProvider(G,this.o(j,B)),this.p(G)}$provideDocumentColors(B,j,H){return this.s(B,Be,G=>G.provideColors(u.URI.revive(j),H),[],H)}$provideColorPresentations(B,j,H,G){return this.s(B,Be,re=>re.provideColorPresentations(u.URI.revive(j),H,G),void 0,G)}registerFoldingRangeProvider(B,j,H){const G=this.q(),re=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Ne(new xe(this.h,H),B)),this.e.$registerFoldingRangeProvider(G,this.o(j,B),B.identifier,re);let ge=this.p(G);if(re!==void 0){const Ee=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));ge=n.$5N.from(ge,Ee)}return ge}$provideFoldingRanges(B,j,H,G){return this.s(B,xe,re=>re.provideFoldingRanges(u.URI.revive(j),H,G),void 0,G)}registerSelectionRangeProvider(B,j,H){const G=this.t(new nt(this.h,H,this.l),B);return this.e.$registerSelectionRangeProvider(G,this.o(j,B)),this.p(G)}$provideSelectionRanges(B,j,H,G){return this.s(B,nt,re=>re.provideSelectionRanges(u.URI.revive(j),H,G),[],G)}registerCallHierarchyProvider(B,j,H){const G=this.t(new ut(this.h,H),B);return this.e.$registerCallHierarchyProvider(G,this.o(j,B)),this.p(G)}$prepareCallHierarchy(B,j,H,G){return this.s(B,ut,re=>Promise.resolve(re.prepareSession(u.URI.revive(j),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(B,j,H,G){return this.s(B,ut,re=>re.provideCallsTo(j,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(B,j,H,G){return this.s(B,ut,re=>re.provideCallsFrom(j,H,G),void 0,G)}$releaseCallHierarchy(B,j){this.s(B,ut,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(B,j,H){const G=this.t(new pt(this.h,H),B);return this.e.$registerTypeHierarchyProvider(G,this.o(j,B)),this.p(G)}$prepareTypeHierarchy(B,j,H,G){return this.s(B,pt,re=>Promise.resolve(re.prepareSession(u.URI.revive(j),H,G)),void 0,G)}$provideTypeHierarchySupertypes(B,j,H,G){return this.s(B,pt,re=>re.provideSupertypes(j,H,G),void 0,G)}$provideTypeHierarchySubtypes(B,j,H,G){return this.s(B,pt,re=>re.provideSubtypes(j,H,G),void 0,G)}$releaseTypeHierarchy(B,j){this.s(B,pt,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(B,j,H,G){const re=this.q();return this.f.set(re,new Ne(new lt(this.e,this.h,H,re,B),B)),this.e.$registerDocumentOnDropEditProvider(re,this.o(j,B),(0,t.$uH)(B,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(re)}$provideDocumentOnDropEdits(B,j,H,G,re,ge){return this.s(B,lt,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(j,u.URI.revive(H),G,re,ge)),void 0,void 0)}$resolveDropEdit(B,j,H){return this.s(B,lt,G=>G.resolveDropEdit(j,H),{},void 0)}$releaseDocumentOnDropEdits(B,j){this.s(B,lt,H=>Promise.resolve(H.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(B,j,H){const G=this.t(new et(this.h,H),B);return this.e.$registerMappedEditsProvider(G,this.o(j,B),B.displayName??B.name),this.p(G)}$provideMappedEdits(B,j,H,G,re){return this.s(B,et,ge=>Promise.resolve(ge.provideMappedEdits(j,H,G,re)),null,re)}registerDocumentPasteEditProvider(B,j,H,G){const re=this.q();return this.f.set(re,new Ne(new U(this.e,this.h,H,re,B),B)),this.e.$registerPasteEditProvider(re,this.o(j,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(B,j,H,G,re){return this.s(B,U,ge=>ge.prepareDocumentPaste(u.URI.revive(j),H,G,re),void 0,re)}$providePasteEdits(B,j,H,G,re,ge,Ee){return this.s(B,U,Ue=>Ue.providePasteEdits(j,u.URI.revive(H),G,re,ge,Ee),void 0,Ee)}$resolvePasteEdit(B,j,H){return this.s(B,U,G=>G.resolvePasteEdit(j,H),{},void 0)}$releasePasteEdits(B,j){this.s(B,U,H=>Promise.resolve(H.releasePasteEdits(j)),void 0,void 0)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:Me.y(B.decreaseIndentPattern),increaseIndentPattern:Me.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Me.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Me.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:Me.y(B.beforeText),afterText:B.afterText?Me.y(B.afterText):void 0,previousLineText:B.previousLineText?Me.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(Me.B)}static D(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(j=>n.SyntaxTokenType.toString(j)):void 0}}static E(B){return B.map(Me.D)}setLanguageConfiguration(B,j,H){const{wordPattern:G}=H;if(G&&(0,I.$uf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(j,G):this.h.setWordDefinitionFor(j,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const re=this.q(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Me.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Me.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Me.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Me.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(re,j,ge),this.p(re)}$setWordDefinitions(B){for(const j of B)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$Hqc=Me}),define(Re[243],Te([1,0,4,33,5,8]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=void 0,N=qe(N);class R{constructor(p){this.a=new Map,this.c=new Map,this.b=p.getProxy(P.$3N.MainThreadLanguageModelTools),this.b.$getTools().then(s=>{for(const I of s)this.c.set(I.id,(0,D.$fi)(I))})}async invokeTool(p,s,I){const b=await this.b.$invokeTool(p,s,I);return N.LanguageModelToolResult.to(b)}async $acceptToolDelta(p){p.added&&this.c.set(p.added.id,p.added),p.removed&&this.c.delete(p.removed)}get tools(){return Array.from(this.c.values()).map(p=>N.LanguageModelToolDescription.to(p))}async $invokeTool(p,s,I){const b=this.a.get(p);if(!b)throw new Error(`Unknown tool ${p}`);const u=await b.tool.invoke(s,I);return N.LanguageModelToolResult.from(u)}registerTool(p,s,I){return this.a.set(s,{extension:p,tool:I}),this.b.$registerTool(s),(0,y.$Vc)(()=>{this.a.delete(s),this.b.$unregisterTool(s)})}}e.$esc=R}),define(Re[95],Te([1,0,10,19,42,12,6,40,4,9,18,3,11,77,5,91,16,8,7,119,21]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=e.$orc=void 0,l=qe(l),h=qe(h),e.$orc=(0,b.$Ii)("IExtHostLanguageModels");class o{constructor(d,S){this.option=d,this.stream=new y.$_h,this.stream=S??new y.$_h}}class a{constructor(){this.a=new Map,this.b=new y.$_h,this.c=!1;const d=this;this.apiObject={get stream(){return d.b.asyncIterable},get text(){return y.$9h.map(d.b.asyncIterable,S=>{if(S instanceof h.$nQ)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;let S=this.a.get(d.index);S||(this.a.size===0?S=new o(d.index,this.b):S=new o(d.index),this.a.set(d.index,S));let k;d.part.type==="text"?k=new h.$nQ(d.part.value):k=new h.$mQ(d.part.name,d.part.parameters),S.stream.emitOne(k)}reject(d){this.c=!0;for(const S of this.d())S.reject(d)}resolve(){this.c=!0;for(const d of this.d())d.resolve()}}let m=class{static{t=this}static{this.a=1}constructor(d,S,k){this.j=S,this.k=k,this.c=new R.$oe,this.d=new R.$oe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$wn,this.i=new Map,this.s=new Set,this.b=d.getProxy(f.$3N.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,S,k,v){const C=t.a++;this.f.set(C,{extension:d.identifier,provider:k,languageModelId:S});let T;v.auth&&(T={providerLabel:d.displayName||d.name,accountLabel:typeof v.auth=="object"?v.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$un.toKey(d.identifier)}/${C}/${S}`,{extension:d.identifier,id:S,vendor:v.vendor??I.$un.toKey(d.identifier),name:v.name??"",family:v.family??"",version:v.version,maxInputTokens:v.maxInputTokens,maxOutputTokens:v.maxOutputTokens,auth:T,targetExtensions:v.extensions});const $=k.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:M,tokenCount:A})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$un(w),M,A)});return(0,p.$Vc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),$?.dispose()})}async $startChatRequest(d,S,k,v,C,T){const $=this.f.get(d);if(!$)throw new Error("Provider not found");const w=new E.$Fw(async A=>{if(T.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(A.part instanceof h.$mQ?L={type:"function_use",name:A.part.name,parameters:A.part.parameters}:A.part instanceof h.$nQ&&(L={type:"text",value:A.part.value}),!L){this.j.warn(`[CHAT](${$.extension.value}) UNKNOWN part ${JSON.stringify(A)}`);return}this.b.$reportResponsePart(S,{index:A.index,part:L})});let M;if($.provider.provideLanguageModelResponse2)M=Promise.resolve($.provider.provideLanguageModelResponse2(v.map(l.LanguageModelChatMessage.to),C,I.$un.toKey(k),w,T));else{const A=new E.$Fw(async L=>{w.report({index:L.index,part:new h.$nQ(L.part)})});M=Promise.resolve($.provider.provideLanguageModelResponse(v.map(l.LanguageModelChatMessage.to),C?.modelOptions??{},I.$un.toKey(k),A,T))}M.then(()=>{this.b.$reportResponseDone(S,void 0)},A=>{this.b.$reportResponseDone(S,(0,N.$4)(A))})}$provideTokenLength(d,S,k){const v=this.f.get(d);return v?Promise.resolve(v.provider.provideTokenCount(S,k)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:S,metadata:k}of d.added)this.g.set(S,{metadata:k,apiObjects:new I.$wn});if(d.removed)for(const S of d.removed){this.g.delete(S);for(const[k,v]of this.i)v.languageModelId===S&&(v.res.reject(new N.$7),this.i.delete(k))}d.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,S){const k=await this.b.$selectChatModels({...S,extension:d.identifier}),v=[],C=this;for(const T of k){const $=this.g.get(T);if(!$)continue;this.o(d.identifier,$.metadata)&&await this.q($.metadata);let w=$.apiObjects.get(d.identifier);w||(w={id:T,vendor:$.metadata.vendor,family:$.metadata.family,version:$.metadata.version,name:$.metadata.name,maxInputTokens:$.metadata.maxInputTokens,countTokens(M,A){if(!C.g.has(T))throw h.$rQ.NotFound(T);return C.r(T,M,A??D.CancellationToken.None)},sendRequest(M,A,L){if(!C.g.has(T))throw h.$rQ.NotFound(T);return C.l(d,T,M,A??{},L??D.CancellationToken.None)}},Object.freeze(w),$.apiObjects.set(d.identifier,w)),v.push(w)}return v}async l(d,S,k,v,C){const T=this.m(d,k),$=d.identifier,w=this.g.get(S)?.metadata;if(!w||!this.g.has(S))throw h.$rQ.NotFound(`Language model '${S}' is unknown.`);if(this.o($,w)&&(!await this.n(d,{identifier:w.extension,displayName:w.auth.providerLabel},v.justification,!1)||!this.h.get($)?.has(w.extension)))throw h.$rQ.NoPermissions(`Language model '${S}' cannot be used by '${$.value}'.`);try{const M=Math.random()*1e6|0,A=new a;this.i.set(M,{languageModelId:S,res:A});try{await this.b.$tryStartChatRequest($,S,M,T,v,C)}catch(L){throw this.i.delete(M),L}return A.apiObject}catch(M){throw M.name===h.$rQ.name?M:new h.$rQ(`Language model '${S}' errored: ${(0,P.$tj)(M)}`,"Unknown",M)}}m(d,S){const k=[];for(const v of S)v.role===h.LanguageModelChatMessageRole.System&&(0,n.$vH)(d,"languageModelSystem"),v.content2 instanceof h.$kQ&&(0,n.$vH)(d,"lmTools"),k.push(l.LanguageModelChatMessage.from(v));return k}async $acceptResponsePart(d,S){const k=this.i.get(d);k&&k.res.handleFragment(S)}async $acceptResponseDone(d,S){const k=this.i.get(d);k&&(this.i.delete(d),S?k.res.reject((0,N.$5)(S)):k.res.resolve())}async n(d,S,k,v){const C=i.$4M+S.identifier.value;if(await this.k.getSession(d,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0;if(v)return!1;try{const $=k?(0,s.localize)(2703,null,S.displayName,k):void 0;return await this.k.getSession(d,C,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(d,S){return!!S.auth&&!I.$un.equals(S.extension,d)}async q(d){if(d.auth)for(const S of this.s)try{await this.n(S,{identifier:d.extension,displayName:""},void 0,!0)}catch(k){this.j.error("Fake Auth request failed"),this.j.error(k)}}async r(d,S,k){if(!this.g.get(d))throw h.$rQ.NotFound(`Language model '${d}' is unknown.`);const C=O.Iterable.find(this.f.values(),T=>T.languageModelId===d);return C?C.provider.provideTokenCount(S,k):this.b.$countTokens(d,typeof S=="string"?S:l.LanguageModelChatMessage.from(S),k)}$updateModelAccesslist(d){const S=new Array;for(const{from:k,to:v,enabled:C}of d){const T=this.h.get(k)??new I.$vn;if(T.has(v)!==C){C?T.add(v):T.delete(v),this.h.set(k,T);const w={from:k,to:v};S.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(d){this.s.add(d);const S=this,k=R.Event.signal(R.Event.filter(this.c.event,C=>I.$un.equals(C.from,d.identifier))),v=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(k,v)},canSendRequest(C){let T;e:for(const[w,M]of S.g)for(const A of M.apiObjects.values())if(A===C){T=M.metadata;break e}if(!T)return;if(!S.o(d.identifier,T))return!0;const $=S.h.get(d.identifier);if($)return $.has(T.extension)}}}};e.$prc=m,e.$prc=m=t=Ke([We(0,c.$DQ),We(1,u.$dk),We(2,r.$Jqc)],m)});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[244],Te([1,0,5,8,7,36,10,4,21]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsc=void 0,D=qe(D),N=si(N);class s{constructor(b,u,E,f){this.c=u,this.d=E,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=b.getProxy(y.$3N.MainThreadLanguages)}$acceptLanguageIds(b){this.b=b}async getLanguages(){return this.b.slice(0)}async changeLanguage(b,u){await this.a.$changeLanguage(b,u);const E=this.c.getDocumentData(b);if(!E)throw new Error(`document '${b.toString()}' NOT found`);return E.document}async tokenAtPosition(b,u){const E=b.version,f=D.Position.from(u),r=await this.a.$tokensAtPosition(b.uri,f),c={type:P.StandardTokenType.Other,range:b.getWordRangeAtPosition(u)??new P.$7N(u.line,u.character,u.line,u.character)};if(!r)return c;const l={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!l.range.contains(u)||E!==b.version?c:l}createLanguageStatusItem(b,u,E){const f=this.f++,r=this.a,c=this.g,l=`${b.identifier.value}/${u}`;if(c.has(l))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);c.add(l);const h={selector:E,id:u,name:b.displayName??b.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new O.$Wc,t=()=>{if(i?.dispose(),!c.has(l)){console.warn(`LanguageStatusItem (${u}) from ${b.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Kh)(()=>{n.clear(),this.a.$setLanguageStatus(f,{id:l,name:h.name??b.displayName??b.name,source:b.displayName??b.name,selector:D.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===P.LanguageStatusSeverity.Error?N.default.Error:h.severity===P.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:h.command&&this.d.toInternal(h.command,n),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(f),c.delete(l)},get id(){return h.id},get name(){return h.name},set name(a){h.name=a,t()},get selector(){return h.selector},set selector(a){h.selector=a,t()},get text(){return h.text},set text(a){h.text=a,t()},set text2(a){(0,p.$vH)(b,"languageStatusText"),h.text=a,t()},get text2(){return(0,p.$vH)(b,"languageStatusText"),h.text},get detail(){return h.detail},set detail(a){h.detail=a,t()},get severity(){return h.severity},set severity(a){h.severity=a,t()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(a){h.accessibilityInformation=a,t()},get command(){return h.command},set command(a){h.command=a,t()},get busy(){return h.busy},set busy(a){h.busy=a,t()}};return t(),o}}e.$fsc=s}),define(Re[245],Te([1,0,15,2,8,7,90]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0,P=qe(P),R=qe(R);class O{constructor(b,u,E,f){this.start=b,this.deletedCount=u,this.deletedItems=E,this.items=f}asApiEvent(){return{range:new N.$wP(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1}}constructor(b,u,E){this.notebook=b,this.h=u,this.j=E,this.handle=E.handle,this.uri=D.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const b=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return b.g},set mime(f){b.g=f},get outputs(){return b.a.slice(0)},get metadata(){return b.b},get executionSummary(){return b.d}};this.f=Object.freeze(E)}return this.f}setOutputs(b){this.a=b.map(P.NotebookCellOutput.to)}setOutputItems(b,u,E){const f=E.map(P.NotebookCellOutputItem.to),r=this.a.find(c=>c.id===b);if(r&&(u||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(c=>R.$4L(c.mime)))){const c=new Map,l=[];r.items.forEach(h=>{let i;c.has(h.mime)?i=c.get(h.mime):(i=[],c.set(h.mime,i),l.push(h.mime)),i.push(h.data)}),r.items.length=0,l.forEach(h=>{const i=R.$5L(c.get(h));r.items.push({mime:h,data:i.data.buffer})})}}setMetadata(b){this.b=Object.freeze(b)}setInternalMetadata(b){this.e=b,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.$Xrc=p;class s{static{this.a=0}constructor(b,u,E,f,r){this.k=b,this.l=u,this.m=E,this.uri=f,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const b=this,u={get uri(){return b.uri},get version(){return b.g},get notebookType(){return b.d},get isDirty(){return b.h},get isUntitled(){return b.uri.scheme===y.Schemas.untitled},get isClosed(){return b.j},get metadata(){return b.f},get cellCount(){return b.b.length},cellAt(E){return E=b.n(E),b.b[E].apiCell},getCells(E){return(E?b.p(E):b.b).map(r=>r.apiCell)},save(){return b.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(b){b.metadata&&(this.f=Object.freeze({...this.f,...b.metadata}))}acceptDirty(b){this.h=b}acceptModelChanged(b,u,E){this.g=b.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const f={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const l of b.rawEvents)l.kind===R.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===R.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===R.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),r.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===R.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),r.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),r.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),r.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),r.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const c=new Map;for(let l=0;l<r.length;l++){const h=r[l],i=c.get(h.cell);if(i===void 0){const n=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});c.set(h.cell,n-1)}else f.cellChanges[i]={...f.cellChanges[i],...h}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(b){return b=b|0,b<0?0:b>=this.b.length?this.b.length-1:b}o(b){let u=b.start|0,E=b.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),b.with({start:u,end:E})}p(b){b=this.o(b);const u=[];for(let E=b.start;E<b.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(b,u,E){if(this.j)return;const f=[],r=[],c=[];if(b.reverse().forEach(l=>{const i=l[2].map(o=>{const a=new p(this,this.l,o);return u||r.push(p.asModelAddData(o)),a}),n=new O(l[0],l[1],[],i),t=this.b.splice(l[0],l[1],...i);for(const o of t)c.push(o.uri),n.deletedItems.push(o.apiCell);f.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:c}),E)for(const l of f)E.push(l.asApiEvent())}s(b,u,E,f){const r=this.b.splice(b,u);this.b.splice(E,0,...r);const c=[new O(b,u,r.map(l=>l.apiCell),[]),new O(E,0,[],r)];for(const l of c)f.push(l.asApiEvent())}t(b,u){this.b[b].setOutputs(u)}u(b,u,E,f){this.b[b].setOutputItems(u,E,f)}v(b,u){const E=this.b[b];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(b,u){const E=this.b[b];E.apiCell.mime=u}x(b,u){this.b[b].setMetadata(u)}y(b,u){this.b[b].setInternalMetadata(u)}getCellFromApiCell(b){return this.b.find(u=>u.apiCell===b)}getCellFromIndex(b){return this.b[b]}getCell(b){return this.b.find(u=>u.handle===b)}getCellIndex(b){return this.b.indexOf(b)}}e.$Yrc=s}),define(Re[246],Te([1,0,6,2,8,7,39]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0;class O{constructor(s,I,b,u={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=b,this.f=u,this.a=new y.$qe}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,b,u)=>{const E=function(r){I.call(b,r)};return E.extension=s,this.a.event(E,void 0,u)}}async $participateInSave(s,I,b){const u=D.URI.revive(s),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},b,async(c,l)=>{const h=Date.now(),i=await await Promise.resolve(c);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier),!b.isCancellationRequested&&i&&(i instanceof N.$eO?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier,"ignored due to invalid data"))}),b.isCancellationRequested)return!1;if(f.length===0)return!0;const r={edits:[]};for(const c of f){const{edits:l}=P.WorkspaceEdit.from(c);r.edits=r.edits.concat(l)}return this.d.$tryApplyWorkspaceEdit(new R.$4w(r))}}e.$hsc=O}),define(Re[126],Te([1,0,12,8,7]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0,D=qe(D),P=qe(P);class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,p,s,I,b,u){this.id=O,this.f=p,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=b,this.b=I,this.c=u}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(p){this.selections=[p]},get selections(){return O.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$wP.isNotebookRange))throw(0,y.$9)("selections");O.a=p,O.g(p)},get visibleRanges(){return O.b},revealRange(p,s){O.f.$tryRevealRange(O.id,D.NotebookRange.from(p),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(D.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$Zrc=N}),define(Re[247],Te([1,0,6,11,8]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsc=void 0,P=qe(P);let N=class{constructor(O,p){this.c=O,this.d=p,this.a=new y.$oe,this.b=new y.$oe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,p);const s=this.d.getEditorById(O);p.visibleRanges&&s._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&s._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const p in O)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(O[p]))}};e.$jsc=N,e.$jsc=N=Ke([We(0,D.$dk)],N)}),define(Re[248],Te([1,0,6,5,126]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0;class N{constructor(O,p){this.c=p,this.a=new Map,this.b=O.getProxy(D.$3N.MainThreadNotebookRenderers)}$postRendererMessage(O,p,s){const I=this.c.getEditorById(O);this.a.get(p)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(O,p){if(!O.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,b,u)=>this.d(p).event(I,b,u),postMessage:(I,b)=>{P.$Zrc.apiEditorsToExtHost.has(I)&&([I,b]=[b,I]);const u=b&&P.$Zrc.apiEditorsToExtHost.get(b);return this.b.$postMessage(u?.id,p,I)}}}d(O){let p=this.a.get(O);return p||(p=new y.$oe({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(O)}}),this.a.set(O,p),p)}}e.$msc=N}),define(Re[249],Te([1,0,8,77,19,71,12]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0;class O{constructor(b){this.b=0,this.c=new Map,this.a=b}async withProgress(b,u,E){const f=this.b++,{title:r,location:c,cancellable:l}=u,h={label:b.displayName||b.name,id:b.identifier.value};return this.a.$startProgress(f,{location:y.ProgressLocation.from(c),title:r,source:h,cancellable:l},b.isUnderDevelopment?void 0:b.identifier.value).catch(R.$3),this.d(f,E,!!l)}d(b,u,E){let f;E&&(f=new P.$ze,this.c.set(b,f));const r=l=>{this.a.$progressEnd(l),this.c.delete(l),f?.dispose()};let c;try{c=u(new s(this.a,b),E&&f?f.token:P.CancellationToken.None)}catch(l){throw r(b),l}return c.then(l=>r(b),l=>r(b)),c}$acceptProgressCanceled(b){const u=this.c.get(b);u&&(u.cancel(),this.c.delete(b))}}e.$qsc=O;function p(I,b){return I.message=b.message,typeof b.increment=="number"&&(typeof I.increment=="number"?I.increment+=b.increment:I.increment=b.increment),I}class s extends D.$Fw{constructor(b,u){super(E=>this.throttledReport(E)),this.c=b,this.d=u}throttledReport(b){this.c.$progressReport(this.d,b)}}Ke([(0,N.$ci)(100,(I,b)=>p(I,b),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Re[250],Te([1,0,2,5,10,8]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=void 0;class R{static{this.a=0}constructor(p,s){this.d=s,this.c=new Map,this.b=p.getProxy(D.$3N.MainThreadQuickDiff)}$provideOriginalResource(p,s,I){const b=y.URI.revive(s),u=this.c.get(p);return u?(0,P.$Ah)(()=>u.provideOriginalResource(b,I)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,s,I,b){const u=R.a++;return this.c.set(u,s),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(p,this.d),I,b),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$rsc=R});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[251],Te([1,0,19,6,4,5,2,7,12,17,36,35,21,8]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssc=f,I=si(I);function f(r,c,l){const h=r.getProxy(N.$3N.MainThreadQuickOpen);class i{constructor(k,v){this.e=new Map,this.f=0,this.a=k,this.b=v}showQuickPick(k,v,C,T=y.CancellationToken.None){this.c=void 0;const $=Promise.resolve(v),w=++this.f,M=h.$show(w,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},T),A={},L=M.then(()=>A);return Promise.race([L,$]).then(Z=>{if(Z===A)return;const J=(0,u.$uH)(k,"quickPickItemTooltip");return $.then(U=>{const V=[];for(let Q=0;Q<U.length;Q++){const ne=U[Q];if(typeof ne=="string")V.push({label:ne,handle:Q});else if(ne.kind===O.QuickPickItemKind.Separator)V.push({type:"separator",label:ne.label});else{ne.tooltip&&!J&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ue=ne.iconPath?m(ne.iconPath):void 0;V.push({label:ne.label,iconPath:ue?.iconPath,iconClass:ue?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:J?E.MarkdownString.fromStrict(ne.tooltip):void 0,handle:Q})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=Q=>{C.onDidSelectItem(U[Q])}),h.$setItems(w,V),M.then(Q=>{if(typeof Q=="number")return U[Q];if(Array.isArray(Q))return Q.map(ne=>U[ne])})})}).then(void 0,Z=>{if(!(0,p.$6)(Z))return h.$setError(w,Z),Promise.reject(Z)})}$onItemSelected(k){this.c?.(k)}showInput(k,v=y.CancellationToken.None){return this.d=k?.validateInput,h.$input(k,typeof this.d=="function",v).then(void 0,C=>{if(!(0,p.$6)(C))return Promise.reject(C)})}async $validateInput(k){if(!this.d)return;const v=await this.d(k);if(!v||typeof v=="string")return v;let C;switch(v.severity){case O.InputBoxValidationSeverity.Info:C=I.default.Info;break;case O.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case O.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=v.message?I.default.Error:I.default.Ignore;break}return{content:v.message,severity:C}}async showWorkspaceFolderPick(k,v=y.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!C)return;const T=await this.a.getWorkspaceFolders2();if(T)return T.find($=>$.uri.toString()===C.uri.toString())}createQuickPick(k){const v=new g(k,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}createInputBox(k){const v=new d(k,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}$onDidChangeValue(k,v){this.e.get(k)?._fireDidChangeValue(v)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,v){const C=this.e.get(k);C instanceof g&&C._fireDidChangeActive(v)}$onDidChangeSelection(k,v){const C=this.e.get(k);C instanceof g&&C._fireDidChangeSelection(v)}$onDidTriggerButton(k,v){this.e.get(k)?._fireDidTriggerButton(v)}$onDidTriggerItemButton(k,v,C){const T=this.e.get(k);T instanceof g&&T._fireDidTriggerItemButton(v,C)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,v){this.x=k,this.y=v,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$oe,this.q=new D.$oe,this.r=new D.$oe,this.s=new D.$oe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){const v=(0,u.$uH)(this.x,"quickInputButtonLocation");!v&&k.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=k.slice(),this.o.clear(),k.forEach((C,T)=>{const $=C===O.$tP.Back?-1:T;this.o.set($,C)}),this.z({buttons:k.map((C,T)=>({...m(C.iconPath),tooltip:C.tooltip,handle:C===O.$tP.Back?-1:T,location:v?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const v=this.o.get(k);v&&this.r.fire(v)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(k){if(!this.v){for(const v of Object.keys(k)){const C=k[v];this.u[v]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof O.$4O)return{id:S.id};const k=a(S),v=o(S);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof v=="string"?R.URI.file(v):v}}function o(S){return typeof S=="object"&&"light"in S?S.light:S}function a(S){return typeof S=="object"&&"dark"in S?S.dark:S}function m(S){const k=t(S);let v,C;return"id"in k?C=b.ThemeIcon.asClassName(k):v=k,{iconPath:v,iconClass:C}}class g extends n{constructor(k,v){super(k,v),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$oe,this.L=[],this.M=new D.$oe,this.N=new D.$oe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((T,$)=>{this.C.set($,T),this.D.set(T,$)});const v=(0,u.$uH)(this.x,"quickPickItemTooltip"),C=[];for(let T=0;T<k.length;T++){const $=k[T];if($.kind===O.QuickPickItemKind.Separator)C.push({type:"separator",label:$.label});else{$.tooltip&&!v&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=$.iconPath?m($.iconPath):void 0;C.push({handle:T,label:$.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,tooltip:v?E.MarkdownString.fromStrict($.tooltip):void 0,buttons:$.buttons?.map((M,A)=>({...m(M.iconPath),tooltip:M.tooltip,handle:A}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(v=>this.D.has(v)),this.z({activeItems:this.J.map(v=>this.D.get(v))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(v=>this.D.has(v)),this.z({selectedItems:this.L.map(v=>this.D.get(v))})}_fireDidChangeActive(k){const v=(0,s.$Jb)(k.map(C=>this.C.get(C)));this.J=v,this.K.fire(v)}_fireDidChangeSelection(k){const v=(0,s.$Jb)(k.map(C=>this.C.get(C)));this.L=v,this.M.fire(v)}_fireDidTriggerItemButton(k,v){const C=this.C.get(k);if(!C||!C.buttons||!C.buttons.length)return;const T=C.buttons[v];T&&this.N.fire({button:T,item:C})}}class d extends n{constructor(k,v){super(k,v),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(c,l)}}),define(Re[252],Te([1,0,2,6,71,4,10,5,17,146,11,18,37,35,8,21,15,23]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=e.$tsc=void 0;function i(A){return A instanceof y.URI}function n(A,L){return A.scheme===c.Schemas.file&&L.scheme===c.Schemas.file&&l.$l?A.toString()===L.toString():A.toString().toLowerCase()===L.toString().toLowerCase()}function t(A){if(A)return typeof A.iconPath=="string"?y.URI.file(A.iconPath):y.URI.isUri(A.iconPath)||E.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function o(A){if(A){if(y.URI.isUri(A))return A;if(E.ThemeIcon.isThemeIcon(A))return A;{const L=A;return{light:L.light,dark:L.dark}}}else return}function a(A){const L=o(A.icon),Z=A.labels?.map(J=>({title:J.title,icon:o(J.icon)}));return{...A,icon:L,labels:Z}}function m(A,L){if(!A.iconPath&&!L.iconPath)return 0;if(A.iconPath){if(!L.iconPath)return 1}else return-1;const Z=typeof A.iconPath=="string"?A.iconPath:y.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,J=typeof L.iconPath=="string"?L.iconPath:y.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,s.$Pr)(Z,J)}function g(A,L){let Z=0;if(A.strikeThrough!==L.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==L.faded)return A.faded?1:-1;if(A.tooltip!==L.tooltip)return(A.tooltip||"").localeCompare(L.tooltip||"");if(Z=m(A,L),Z!==0)return Z;if(A.light&&L.light)Z=m(A.light,L.light);else{if(A.light)return 1;if(L.light)return-1}if(Z!==0)return Z;if(A.dark&&L.dark)Z=m(A.dark,L.dark);else{if(A.dark)return 1;if(L.dark)return-1}return Z}function d(A,L){if(A.command!==L.command)return A.command<L.command?-1:1;if(A.title!==L.title)return A.title<L.title?-1:1;if(A.tooltip!==L.tooltip){if(A.tooltip!==void 0&&L.tooltip!==void 0)return A.tooltip<L.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(A.arguments===L.arguments)return 0;if(A.arguments)if(L.arguments){if(A.arguments.length!==L.arguments.length)return A.arguments.length-L.arguments.length}else return 1;else return-1;for(let Z=0;Z<A.arguments.length;Z++){const J=A.arguments[Z],U=L.arguments[Z];if(J!==U&&!(i(J)&&i(U)&&n(J,U)))return J<U?-1:1}return 0}function S(A,L){let Z=(0,s.$Pr)(A.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(Z!==0)return Z;if(A.command&&L.command)Z=d(A.command,L.command);else{if(A.command)return 1;if(L.command)return-1}if(Z!==0)return Z;if(A.decorations&&L.decorations)Z=g(A.decorations,L.decorations);else{if(A.decorations)return 1;if(L.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)Z=(0,s.$Pr)(A.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)Z=(0,s.$Pr)(A.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return Z}function k(A,L){for(let Z=0;Z<A.length;Z++)if(A[Z]!==L[Z])return!1;return!0}function v(A,L){return A.command===L.command&&A.title===L.title&&A.tooltip===L.tooltip&&(A.arguments&&L.arguments?k(A.arguments,L.arguments):A.arguments===L.arguments)}function C(A,L){return(0,p.$wb)(A,L,v)}class T{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,r.$vH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,r.$vH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,r.$vH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,Z,J,U,V){this.k=L,this.m=U,this.n=V,this.d="",this.e=new D.$oe,this.f="",this.h=!0,this.j=!0,this.#t=Z,this.#e=J}showValidationMessage(L,Z){(0,r.$vH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,Z)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$tsc=T;class ${static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,Z,J,U,V,Q,ne){this.s=L,this.t=Z,this.u=J,this.v=U,this.w=V,this.multiDiffEditorEnableViewChanges=Q,this.x=ne,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$oe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new D.$oe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=$.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,Z){const J=this.h.get(L);return J?(0,R.$Ah)(()=>this.t.executeCommand(J.command,...J.arguments||[],Z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(S),J=(0,p.$Fb)(this.p,L,S).map(Q=>{const ne=Q.toInsert.map(ue=>{const _=this.e++;this.g.set(_,ue);const ae=ue.resourceUri;let se;if(ue.command)if(ue.command.command==="vscode.open"||ue.command.command==="vscode.diff"||ue.command.command==="vscode.changes"){const nt=new N.$Wc;se=this.t.converter.toInternal(ue.command,nt),this.j.set(_,nt)}else this.h.set(_,ue.command);const ce=(0,r.$uH)(this.x,"scmMultiDiffEditor"),x=ce?ue.multiDiffEditorOriginalUri:void 0,we=ce?ue.multiFileDiffEditorModifiedUri:void 0,Ie=t(ue.decorations),Y=ue.decorations&&t(ue.decorations.light)||Ie,q=ue.decorations&&t(ue.decorations.dark)||Ie,ie=[Y,q],ve=ue.decorations&&ue.decorations.tooltip||"",Pe=ue.decorations&&!!ue.decorations.strikeThrough,Fe=ue.decorations&&!!ue.decorations.faded,Be=ue.contextValue||"";return{rawResource:[_,ae,ie,ve,Pe,Fe,Be,se,x,we],handle:_}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:ne}}),U=J.map(({start:Q,deleteCount:ne,toInsert:ue})=>[Q,ne,ue.map(_=>_.rawResource)]),V=J.reverse();for(const{start:Q,deleteCount:ne,toInsert:ue}of V){const _=ue.map(se=>se.handle),ae=this.o.splice(Q,ne,..._);for(const se of ae)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.p=L,U}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let Z;(0,r.$uH)(this.y,"quickDiffProvider")&&(Z=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:Z})}get historyProvider(){return(0,r.$vH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,r.$vH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new N.$Wc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new N.$Wc,this.p=L;const Z=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:Z})}get actionButton(){return(0,r.$vH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,r.$vH)(this.y,"scmActionButton"),this.q.value=new N.$Wc,this.s=L;const Z=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(J=>J.map(U=>this.z.converter.toInternal(U,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:Z??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&C(this.u,L))return;this.t.value=new N.$Wc,this.u=L;const Z=(L||[]).map(J=>this.z.converter.toInternal(J,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:Z})}get selected(){return this.v}constructor(L,Z,J,U,V,Q,ne){this.y=L,this.z=U,this.A=V,this.B=Q,this.C=ne,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Yc,this.n=void 0,this.o=new N.$Yc,this.p=void 0,this.q=new N.$Yc,this.t=new N.$Yc,this.u=void 0,this.v=!1,this.w=new D.$oe,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=J;const ue=y.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${V}/scm${this.x}/input`,query:ne?`rootUri=${encodeURIComponent(ne.toString())}`:void 0});this.f=new T(L,Z,this.#e,this.x,ue),this.#e.$registerSourceControl(this.x,V,Q,ne,ue)}createResourceGroup(L,Z,J){const U=(0,r.$uH)(this.y,"scmMultiDiffEditor")&&J?.multiDiffEditorEnableViewChanges===!0,V=new $(this.#e,this.z,this.x,L,Z,U,this.y),Q=D.Event.once(V.onDidDispose)(()=>this.D.delete(V));return this.D.set(V,Q),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const L=[],Z=[];for(const[J,U]of this.D){U.dispose();const V=J.onDidUpdateResourceStates(()=>{this.E.add(J),this.eventuallyUpdateResourceStates()});D.Event.once(J.onDidDispose)(()=>{this.E.delete(J),V.dispose(),this.e.delete(J.handle),this.#e.$unregisterGroup(this.x,J.handle)}),L.push([J.handle,J.id,J.label,J.features,J.multiDiffEditorEnableViewChanges]);const Q=J._takeResourceStateSnapshot();Q.length>0&&Z.push([J.handle,Q]),this.e.set(J.handle,J)}this.#e.$registerGroups(this.x,L,Z),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(Z=>{const J=Z._takeResourceStateSnapshot();J.length!==0&&L.push([Z.handle,J])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$bi)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$bi)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,Z,J,U){this.m=Z,this.n=J,this.o=U,this.g=new Map,this.h=new b.$wn,this.j=new D.$oe,this.e=L.getProxy(O.$3N.MainThreadSCM),this.f=L.getProxy(O.$3N.MainThreadTelemetry),Z.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===u.MarshalledId.ScmResource){const Q=this.g.get(V.sourceControlHandle);if(!Q)return V;const ne=Q.getResourceGroup(V.groupHandle);return ne?ne.getResourceState(V.handle):V}else if(V&&V.$mid===u.MarshalledId.ScmResourceGroup){const Q=this.g.get(V.sourceControlHandle);return Q?Q.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===u.MarshalledId.ScmProvider){const Q=this.g.get(V.handle);return Q||V}return V}})}createSourceControl(L,Z,J,U){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,Z,J,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const V=h.d++,Q=new w(L,this.n,this.e,this.m,Z,J,U);this.g.set(V,Q);const ne=this.h.get(L.identifier)||[];return ne.push(Q),this.h.set(L.identifier,ne),Q}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const Z=this.h.get(L.identifier),J=Z&&Z[Z.length-1];return J&&J.inputBox}$provideOriginalResource(L,Z,J){const U=y.URI.revive(Z);this.o.trace("ExtHostSCM#$provideOriginalResource",L,U.toString());const V=this.g.get(L);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ah)(()=>V.quickDiffProvider.provideOriginalResource(U,J)).then(Q=>Q||null)}$onInputBoxValueChange(L,Z){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const J=this.g.get(L);return J&&J.inputBox.$onInputBoxValueChange(Z),Promise.resolve(void 0)}$executeResourceCommand(L,Z,J,U){this.o.trace("ExtHostSCM#$executeResourceCommand",L,Z,J);const V=this.g.get(L);if(!V)return Promise.resolve(void 0);const Q=V.getResourceGroup(Z);return Q?Q.$executeResourceCommand(J,U):Promise.resolve(void 0)}$validateInput(L,Z,J){this.o.trace("ExtHostSCM#$validateInput",L);const U=this.g.get(L);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ah)(()=>U.inputBox.validateInput(Z,J)).then(V=>{if(!V)return Promise.resolve(void 0);const Q=f.MarkdownString.fromStrict(V.message);return Q?Promise.resolve([Q,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,Z,J,U){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(Z,J,U)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,Z,J){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(Z,J)??void 0}async $provideHistoryItems(L,Z,J,U){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(Z,J,U))?.map(ne=>a(ne))??void 0}async $provideHistoryItems2(L,Z,J){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(Z,J))?.map(Q=>a(Q))??void 0}async $provideHistoryItemSummary(L,Z,J,U){const V=this.g.get(L)?.historyProvider;if(typeof V?.provideHistoryItemSummary!="function")return;const Q=await V.provideHistoryItemSummary(Z,J,U);return Q?a(Q):void 0}async $provideHistoryItemChanges(L,Z,J,U){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(Z,J,U)??void 0}};e.$usc=M,e.$usc=M=h=Ke([We(3,I.$dk)],M)}),define(Re[253],Te([1,0,5,8,2]),function($e,e,y,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vsc=void 0;class N{static{this.a=0}constructor(O,p){this.d=p,this.c=new Map,this.b=O.getProxy(y.$3N.MainThreadShare)}async $provideShare(O,p,s){return await this.c.get(O)?.provideShare({selection:D.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},s)??void 0}registerShareProvider(O,p){const s=N.a++;return this.c.set(s,p),this.b.$registerShareProvider(s,D.DocumentSelector.from(O,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$vsc=N}),define(Re[254],Te([1,0,7,5,9,4,8,14]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysc=e.$xsc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$5O("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$5O("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,f,r,c,l=y.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new N.$Wc,this.#e=u,this.#t=E,c&&r){this.c=(0,y.$GO)(r.identifier,c);const i=f.get(this.c);i&&(l=i.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,h=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=c,this.g=l,this.h=this.u(h)}u(u){if((0,O.$lg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Wc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,P.localize)(2709,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=p.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,r,this.r?.internal,f,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$xsc=p;class s{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(2710,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new y.$5N(()=>{const f=this.b.indexOf(E);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,E){this.e=new Map,this.a=u.getProxy(D.$3N.MainThreadStatusBar),this.b=E,this.c=new s(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,f,r){return new p(this.a,this.b,this.e,u,E,f,r)}setStatusBarMessage(u,E){const f=this.c.setMessage(u);let r;return typeof E=="number"?r=setTimeout(()=>f.dispose(),E):typeof E<"u"&&E.then(()=>f.dispose(),()=>f.dispose()),new y.$5N(()=>{f.dispose(),clearTimeout(r)})}}e.$ysc=I}),define(Re[127],Te([1,0,32,118,54,82,55,8,2]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=e.$PQ=void 0,y=qe(y),O=qe(O);const s=(i,n,t,o)=>{let a=n;return{enumerable:!0,configurable:!1,get(){return a},set(m){if(!t(a,m)){const g=a;a=m,i.listener?.(o(m,g))}}}},I=(i,n)=>i===n,b={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},u=i=>n=>({op:N.TestItemEventOp.SetProp,update:i(n)}),E=(i,n)=>({range:(()=>{let t;const o=u(a=>({range:y.$Tt.lift(O.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return t},set(a){i.listener?.({op:N.TestItemEventOp.DocumentSynced}),b.range(t,a)||(t=a,i.listener?.(o(a)))}}})(),label:s(i,n,b.label,u(t=>({label:t}))),description:s(i,void 0,b.description,u(t=>({description:t}))),sortText:s(i,void 0,b.sortText,u(t=>({sortText:t}))),canResolveChildren:s(i,!1,b.canResolveChildren,t=>({op:N.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,b.busy,u(t=>({busy:t}))),error:s(i,void 0,b.error,u(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],b.tags,(t,o)=>({op:N.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:o.map(O.TestTag.from)}))}),f=i=>{const n=P.$lJ.fromString(i.extId),t=new c(n.controllerId,n.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>O.TestTag.to({id:(0,R.$rJ)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=f(t.item);(0,D.$zQ)(o).parent=n,n=o}return n};e.$PQ=r;class c{constructor(n,t,o,a){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,D.$yQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof l?void 0:m.parent}},children:{value:(0,N.$xQ)(m,D.$zQ,c),enumerable:!0,writable:!1},...E(m,o)})}}e.$QQ=c;class l extends c{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$RQ=l;class h extends N.$tQ{constructor(n,t,o){super({controllerId:n,getDocumentVersion:a=>a&&o.getDocument(a)?.version,getApiFor:D.$zQ,getChildren:a=>a.children,root:new l(n,t),toITestItem:O.TestItem.from})}}e.$SQ=h}),define(Re[34],Te([1,0,14,7,8,25,5,17,11,33,32,102,2,4,3,16,127,20,39,42,69,63,66,38]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=void 0,D=qe(D),P=qe(P);let m=class{#e;#t;#i;constructor(C,T,$){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$3N.MainThreadCommands),this.d=T,this.#i=$,this.#t=C.getProxy(R.$3N.MainThreadTelemetry),this.converter=new g(this,w=>{const M=this.c.get(w);return M?.result===S.Void?M:void 0},T),this.f=[{processArgument(w){return(0,s.$fi)(w)}},{processArgument(w){return(0,N.$jo)(w,function(M){if(I.$Tt.isIRange(M))return P.Range.to(M);if(b.$St.isIPosition(M))return P.Position.to(M);if(I.$Tt.isIRange(M.range)&&u.URI.isUri(M.uri))return P.location.to(M);if(M instanceof l.$Qe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const T=this.registerCommand(!1,C.id,async(...$)=>{const w=C.args.map((A,L)=>{if(!A.validate($[L]))throw new Error(`Invalid argument '${A.name}' when running '${C.id}', received: ${typeof $[L]=="object"?JSON.stringify($[L],null,"	"):$[L]} `);return A.convert($[L])}),M=await this.executeCommand(C.internalId,...w);return C.result.convert(M,$,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new D.$5N(()=>{T.dispose(),this.c.delete(C.id)})}registerCommand(C,T,$,w,M,A){if(this.d.trace("ExtHostCommands#registerCommand",T),!T.trim().length)throw new Error("invalid id");if(this.b.has(T))throw new Error(`command '${T}' already exists`);return this.b.set(T,{callback:$,thisArg:w,metadata:M,extension:A}),C&&this.#e.$registerCommand(T),new D.$5N(()=>{this.b.delete(T)&&C&&this.#e.$unregisterCommand(T)})}executeCommand(C,...T){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,T,!0)}async g(C,T,$){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,T,!1);{let w=!1;const M=(0,N.$jo)(T,function(A){if(A instanceof D.$6N)return P.Position.from(A);if(A instanceof D.$7N)return P.Range.from(A);if(A instanceof D.$gO)return P.location.from(A);if(D.$wP.isNotebookRange(A))return P.NotebookRange.from(A);if(A instanceof ArrayBuffer)return w=!0,l.$Qe.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return w=!0,l.$Qe.wrap(A);if(A instanceof l.$Qe)return w=!0,A;if(!Array.isArray(A))return A});try{const A=await this.#e.$executeCommand(C,w?new h.$4w(M):M,$);return(0,s.$fi)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(C,T,!1);throw A}}}async h(C,T,$){const w=this.b.get(C);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:A,metadata:L}=w;if(L?.args)for(let J=0;J<L.args.length;J++)try{(0,y.$yg)(T[J],L.args[J].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[J].name}' - ${L.args[J].description}`)}const Z=n.$ie.create();try{return await M.apply(A,T)}catch(J){if(C===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...T);U&&(C=U.command)}if(this.d.error(J,C,w.extension?.identifier),!$)throw J;if(w.extension?.identifier){const U=this.#i.onExtensionError(w.extension.identifier,J);this.d.trace("forwarded error to extension?",U,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$tj)(J)),this.id=C,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,C,Z.elapsed())}}j(C,T,$){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$Ap(T),duration:$})}$executeContributedCommand(C,...T){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const $=this.b.get(C);return $?(T=T.map(w=>this.f.reduce((M,A)=>A.processArgument(M,$.extension?.identifier),w)),this.h(C,T,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(T=>(C&&(T=T.filter($=>$[0]!=="_")),T))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[T,$]of this.b){const{metadata:w}=$;w&&(C[T]=w)}return Promise.resolve(C)}};e.$YQ=m,e.$YQ=m=Ke([We(0,r.$DQ),We(1,p.$dk),We(2,o.$XQ)],m),e.$ZQ=(0,f.$Ii)("IExtHostCommands");class g{constructor(C,T,$){this.d=C,this.f=T,this.g=$,this.delegatingCommandId=`__vsc${(0,a.$5g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,T){if(!C)return;const $={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return $;const w=this.f(C.command);if(w)$.id=w.internalId,$.arguments=w.args.map((M,A)=>M.convert(C.arguments&&C.arguments[A]));else if((0,O.$Nb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),T.add((0,E.$Vc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),$.$ident=M,$.id=this.delegatingCommandId,$.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return $}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const T=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],T?T.command:"MISSING"),T?this.d.executeCommand(T.command,...T.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$1Q=g;class d{static{this.Uri=new d("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new d("position","A position in a text document",C=>D.$6N.isPosition(C),P.Position.from)}static{this.Range=new d("range","A range in a text document",C=>D.$7N.isRange(C),P.Range.from)}static{this.Selection=new d("selection","A selection in a text document",C=>D.$8N.isSelection(C),P.Selection.from)}static{this.Number=new d("number","",C=>typeof C=="number",C=>C)}static{this.String=new d("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=d.Arr(d.String)}static Arr(C){return new d(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,T=>Array.isArray(T)&&T.every($=>C.validate($)),T=>T.map($=>C.convert($)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",C=>C instanceof D.$sO,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",C=>C instanceof D.$RP,P.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",C=>C instanceof c.$QQ,P.TestItem.from)}constructor(C,T,$,w){this.name=C,this.description=T,this.validate=$,this.convert=w}optional(){return new d(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,T){return new d(C??this.name,T??this.description,this.validate,this.convert)}}e.$2Q=d;class S{static{this.Void=new S("no result",C=>C)}constructor(C,T){this.description=C,this.convert=T}}e.$3Q=S;class k{constructor(C,T,$,w,M){this.id=C,this.internalId=T,this.description=$,this.args=w,this.result=M}}e.$4Q=k}),define(Re[255],Te([1,0,17,15,2,94,104,31,34,8,7]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0,N=qe(N),s=qe(s),I=qe(I);const b=[new p.$4Q("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of DocumentHighlight-instances.",E(s.DocumentHighlight.to))),new p.$4Q("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,c)=>{if((0,y.$Mb)(r))return;class l extends I.$nO{static to(i){const n=new l(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$gO(c[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(l.to):[],n}}return r.map(l.to)})),new p.$4Q("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$2Q.Uri,new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$2Q.Uri,p.$2Q.Range,new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$2Q.Uri,p.$2Q.Position,new p.$2Q("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new p.$4Q("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new p.$4Q("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new p.$4Q("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new p.$4Q("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$2Q.Uri,new p.$2Q("position","A position in a text document",r=>Array.isArray(r)&&r.every(c=>I.$6N.isPosition(c)),r=>r.map(s.Position.from))],new p.$3Q("A promise that resolves to an array of ranges.",r=>r.map(c=>{let l;for(const h of c.reverse())l=new I.$rO(s.Range.to(h),l);return l}))),new p.$4Q("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$2Q.String.with("query","Search string")],new p.$3Q("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new p.$4Q("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new p.$4Q("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$2Q.CallHierarchyItem],new p.$3Q("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new p.$4Q("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$2Q.CallHierarchyItem],new p.$3Q("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new p.$4Q("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new p.$4Q("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("newName","The new symbol name")],new p.$3Q("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new p.$4Q("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$2Q.Uri,p.$2Q.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$3Q("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new p.$4Q("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$2Q.Uri],new p.$3Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$nP(r.tokenTypes,r.tokenModifiers)})),new p.$4Q("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$2Q.Uri],new p.$3Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,R.$peb)(r);if(c.type==="full")return new I.$pP(c.data,void 0)})),new p.$4Q("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$2Q.Uri,p.$2Q.Range.optional()],new p.$3Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$nP(r.tokenTypes,r.tokenModifiers)})),new p.$4Q("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$2Q.Uri,p.$2Q.Range],new p.$3Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,R.$peb)(r);if(c.type==="full")return new I.$pP(c.data,void 0)})),new p.$4Q("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$2Q.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$3Q("A promise that resolves to a CompletionList-instance.",(r,c,l)=>{if(!r)return new I.$DO([]);const h=r.suggestions.map(i=>s.CompletionItem.to(i,l));return new I.$DO(h,r.incomplete)})),new p.$4Q("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$3Q("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new p.$4Q("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$2Q.Uri,p.$2Q.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$3Q("A promise that resolves to an array of CodeLens-instances.",(r,c,l)=>E(h=>new I.$vO(s.Range.to(h.range),h.command&&l.fromInternal(h.command)))(r))),new p.$4Q("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$2Q.Uri,new p.$2Q("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$7N.isRange(r),r=>I.$8N.isSelection(r)?s.Selection.from(r):s.Range.from(r)),p.$2Q.String.with("kind","Code action kind to return code actions for").optional(),p.$2Q.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$3Q("A promise that resolves to an array of Command-instances.",(r,c,l)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(h.command)}else{const i=new I.$pO(h.title,h.kind?new I.$qO(h.kind):void 0);return h.edit&&(i.edit=s.WorkspaceEdit.to(h.edit)),h.command&&(i.command=l.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(r))),new p.$4Q("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(c=>new I.$JO(s.Range.to(c.range),s.Color.to(c.color))):[])),new p.$4Q("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$2Q("color","The color to show and insert",r=>r instanceof I.$IO,s.Color.from),new p.$2Q("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new p.$3Q("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new p.$4Q("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$2Q.Uri,p.$2Q.Range],new p.$3Q("A promise that resolves to an array of Inlay objects",(r,c,l)=>r.map(s.InlayHint.to.bind(void 0,l)))),new p.$4Q("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of FoldingRange objects",(r,c)=>{if(r)return r.map(s.FoldingRange.to)})),new p.$4Q("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$3Q("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(c=>s.NotebookExclusiveDocumentPattern.to(c))})))),new p.$4Q("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$2Q.Uri,p.$2Q.Range,new p.$2Q("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$7N,r=>s.InlineValueContext.from(r))],new p.$3Q("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new p.$4Q("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$2Q("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,D.$Sg)(r,D.Schemas.http,D.Schemas.https),r=>r),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),p.$2Q.String.with("label","").optional()],p.$3Q.Void),new p.$4Q("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$2Q.Uri.with("resource","Resource to open"),p.$2Q.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],p.$3Q.Void),new p.$4Q("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$2Q.Uri.with("left","Left-hand side resource of the diff editor"),p.$2Q.Uri.with("right","Right-hand side resource of the diff editor"),p.$2Q.String.with("title","Human readable title for the diff editor").optional(),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],p.$3Q.Void),new p.$4Q("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$2Q.String.with("title","Human readable title for the changes editor"),new p.$2Q("resourceList","List of resources to compare",r=>{for(const c of r){if(c.length!==3)return!1;const[l,h,i]=c;if(!P.URI.isUri(l)||!P.URI.isUri(h)&&h!==void 0&&h!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.$3Q.Void),new p.$4Q("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$2Q.TypeHierarchyItem],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$2Q.TypeHierarchyItem],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$2Q.TestItem],p.$3Q.Void),new p.$4Q("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$2Q.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$3Q.Void),new p.$4Q("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$2Q.String.with("name","The context key name"),new p.$2Q("value","The context key value",()=>!0,r=>r)],p.$3Q.Void),new p.$4Q("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$2Q.Uri,p.$2Q.StringArray,new p.$2Q("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new p.$3Q("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new p.$4Q("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$2Q("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.$8N.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],p.$3Q.Void)];class u{static register(c){b.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",O.$Hj)}}e.$Iqc=u;function E(r){return c=>{if(Array.isArray(c))return c.map(r)}}function f(r){if(!Array.isArray(r))return;const c=[];for(const l of r)N.$Qu(l)?c.push(s.DefinitionLink.to(l)):c.push(s.location.to(l));return c}}),define(Re[256],Te([1,0,2,34]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;class P{constructor(R,O,p,s,I){this.a=O,this.b=p,this.c=s;const b=new D.$4Q("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$2Q("showOptions","Show Options",u=>!0,u=>u),new D.$2Q("resource","Interactive resource Uri",u=>!0,u=>u),new D.$2Q("controllerId","Notebook controller Id",u=>!0,u=>u),new D.$2Q("title","Interactive editor title",u=>!0,u=>u)],new D.$3Q("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(b)}$willAddInteractiveDocument(R,O,p,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$csc=P}),define(Re[257],Te([1,0,17,10,19,6,4,27,2,18,11,5,34,8,7,83,196,21,39,197]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=void 0,e.$lsc=d,E=qe(E);let n=class{constructor(k,v,C,T,$){this.m=v,this.n=C,this.o=T,this.q=$,this.b=new O.$Dc,this.c=new O.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$oe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(b.$3N.MainThreadNotebookKernels);const w=new u.$4Q("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$2Q("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const L=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:L}}else if(A&&"notebookEditor"in A){const L=this.n.getIdByEditor(A.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return A})],u.$3Q.Void),M=new u.$4Q("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$2Q.Uri],new u.$3Q("A promise that resolves to an array of variables",(A,L)=>A.map(Z=>({variable:{name:Z.name,value:Z.value,expression:Z.expression,type:Z.type,language:Z.language},hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(k,v,C,T,$,w){for(const x of this.j.values())if(x.controller.id===v&&s.$un.equals(k.identifier,x.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const M=this.k++,A=this;this.q.trace(`NotebookController[${M}], CREATED by ${k.identifier.value}, ${v}`);const L=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${k.identifier}'`);let Z=!1;const J=new N.$oe,U=new N.$oe,V={id:d(k.identifier,v),notebookType:C,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:T||k.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let Q=$??L,ne,ue;this.a.$addKernel(M,V).catch(x=>{console.log(x),Z=!0});let _=0;const ae=()=>{if(Z)return;const x=++_;Promise.resolve().then(()=>{x===_&&this.a.$updateKernel(M,V)})},se=new O.$Dc,ce={get id(){return v},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:J.event,get label(){return V.label},set label(x){V.label=x??k.displayName??k.name,ae()},get detail(){return V.detail??""},set detail(x){V.detail=x,ae()},get description(){return V.description??""},set description(x){V.description=x,ae()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(x){V.supportedLanguages=x,ae()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(x){V.supportsExecutionOrder=x,ae()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(x){Q=x??L},get interruptHandler(){return ne},set interruptHandler(x){ne=x,V.supportsInterrupt=!!x,ae()},set variableProvider(x){(0,l.$vH)(k,"notebookVariableProvider"),ue=x,V.hasVariableProvider=!!x,x?.onDidChangeVariables(we=>A.a.$variablesUpdated(we.uri)),ae()},get variableProvider(){return ue},createNotebookCellExecution(x){if(Z)throw new Error("notebook controller is DISPOSED");if(!se.has(x.notebook.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(se.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return A._createNotebookCellExecution(x,d(k.identifier,this.id))},createNotebookExecution(x){if((0,l.$vH)(k,"notebookExecution"),Z)throw new Error("notebook controller is DISPOSED");if(!se.has(x.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(se.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.uri.toString()}`);return A._createNotebookExecution(x,d(k.identifier,this.id))},dispose:()=>{Z||(this.q.trace(`NotebookController[${M}], DISPOSED`),Z=!0,this.j.delete(M),J.dispose(),U.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(x,we){we===f.NotebookControllerAffinity2.Hidden&&(0,l.$vH)(k,"notebookControllerAffinityHidden"),A.a.$updateNotebookPriority(M,x.uri,we)},onDidReceiveMessage:U.event,postMessage(x,we){return(0,l.$vH)(k,"notebookMessaging"),A.a.$postMessage(M,we&&A.n.getIdByEditor(we),x)},asWebviewUri(x){return(0,l.$vH)(k,"notebookMessaging"),(0,r.$eEb)(x,A.m.remote)}};return this.j.set(M,{extensionId:k.identifier,controller:ce,onDidReceiveMessage:U,onDidChangeSelection:J,associatedNotebooks:se}),ce}getIdByController(k){for(const[v,C]of this.j)if(C.controller===k)return d(C.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,v){const C=this.g++,T=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(C,v);const $={dispose:()=>{this.f.delete(C),T.a.$removeKernelDetectionTask(C)}};return this.f.set(C,$),$}registerKernelSourceActionProvider(k,v,C){const T=this.i++,$=typeof C.onDidChangeNotebookKernelSourceActions=="function"?T:void 0,w=this;this.h.set(T,C),this.q.trace(`NotebookKernelSourceActionProvider[${T}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(T,T,v);let M;return $!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(A=>this.a.$emitNotebookKernelSourceActionsChangeEvent($))),{dispose:()=>{this.h.delete(T),w.a.$removeKernelSourceActionProvider(T,T),M?.dispose()}}}async $provideKernelSourceActions(k,v){const C=this.h.get(k);if(C){const T=new R.$Wc;return(await C.provideNotebookKernelSourceActions(v)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.o.converter,T))}return[]}$acceptNotebookAssociation(k,v,C){const T=this.j.get(k);if(T){const $=this.n.getNotebookDocument(p.URI.revive(v));C?T.associatedNotebooks.set($.uri,!0):T.associatedNotebooks.delete($.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,$.uri.toString(),C),T.onDidChangeSelection.fire({selected:C,notebook:$.apiNotebook})}}async $executeCells(k,v,C){const T=this.j.get(k);if(!T)return;const $=this.n.getNotebookDocument(p.URI.revive(v)),w=[];for(const M of C){const A=$.getCell(M);A&&w.push(A.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,$.uri.toString(),w.length),await T.controller.executeHandler.call(T.controller,w,$.apiNotebook,T.controller)}catch(M){this.q.error(`NotebookController[${k}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(k,v,C){const T=this.j.get(k);if(!T)return;const $=this.n.getNotebookDocument(p.URI.revive(v));if(T.controller.interruptHandler)await T.controller.interruptHandler.call(T.controller,$.apiNotebook);else for(const w of C){const M=$.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(T.controller.interruptHandler){const w=this.c.get($.uri);this.c.delete($.uri),C.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(k,v,C,T,$,w,M){const A=this.j.get(k);if(!A)return;const L=this.n.getNotebookDocument(p.URI.revive(C)),Z=A.controller.variableProvider;if(!Z)return;let J;if(T!==void 0){if(J=this.s[T],!J)return}else this.s={};const U=$==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,V=Z.provideVariables(L.apiNotebook,J,U,w,M);let Q=0;for await(const ne of V){if(M.isCancellationRequested)return;const ue={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,interfaces:ne.variable.interfaces,language:ne.variable.language,expression:ne.variable.expression,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:A.extensionId.value};if(this.s[ue.id]=ne.variable,this.a.$receiveVariable(v,ue),Q++>=i.$eL)return}}$acceptKernelMessageFromRenderer(k,v,C){const T=this.j.get(k);if(!T)return;const $=this.n.getEditorById(v);T.onDidReceiveMessage.fire(Object.freeze({editor:$.apiEditor,message:C}))}$cellExecutionChanged(k,v,C){const $=this.n.getNotebookDocument(p.URI.revive(k)).getCell(v);if($){const w=C?E.NotebookCellExecutionState.to(C):f.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:$.apiCell,state:w})}}_createNotebookCellExecution(k,v){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const T=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!T)throw new Error("invalid cell");if(this.b.has(T.uri))throw new Error(`duplicate execution for ${T.uri}`);const $=new o(v,T,this.a);this.b.set(T.uri,$);const w=$.onDidChangeState(()=>{$.state===t.Resolved&&($.dispose(),w.dispose(),this.b.delete(T.uri))});return $.asApiObject()}_createNotebookExecution(k,v){const C=this.n.getNotebookDocument(k.uri),T=k.getCells().find(M=>{const A=C.getCellFromApiCell(M);return A&&this.b.has(A.uri)});if(T)throw new Error(`duplicate cell execution for ${T.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const $=new m(v,C,this.a),w=$.onDidChangeState(()=>{$.state===a.Resolved&&($.dispose(),w.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[$,w]),$.asApiObject()}};e.$ksc=n,e.$ksc=n=Ke([We(4,I.$dk)],n);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class o extends R.$Xc{static{this.a=0}get state(){return this.f}constructor(k,v,C){super(),this.m=v,this.n=C,this.b=o.a++,this.c=new N.$oe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$ze),this.h=new g(10,T=>this.s(T)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const v=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new h.$4w(v))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let v=this.m;if(k&&(v=this.m.notebook.getCellFromApiCell(k)),!v)throw new Error("INVALID cell");return v.handle}y(k){return k.map(v=>{const C=f.$AP.ensureUniqueMimeTypes(v.items,!0);return C===v.items?E.NotebookCellOutput.from(v):E.NotebookCellOutput.from({items:C,id:v.id,metadata:v.metadata})})}async z(k,v,C){const T=this.w(v),$=this.y((0,y.$4b)(k));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:T,append:C,outputs:$})}async C(k,v,C){return k=f.$AP.ensureUniqueMimeTypes((0,y.$4b)(k),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:k.map(E.NotebookCellOutputItem.from),outputId:v.id,append:C})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(C){k.j=C,k.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(C){if(k.f===t.Resolved||k.f===t.Started)throw new Error("Cannot call start again");k.f=t.Started,k.c.fire(),k.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,T,$){if(k.f===t.Resolved)throw new Error("Cannot call resolve twice");k.f=t.Resolved,k.c.fire(),k.h.flush();const w=$?{message:$.message,stack:$.stack,location:$?.location?{startLineNumber:$.location.start.line,startColumn:$.location.start.character,endLineNumber:$.location.end.line,endColumn:$.location.end.character}:void 0,uri:$.uri}:void 0;k.n.$completeExecution(k.b,new h.$4w({runEndTime:T,lastRunSuccess:C,error:w}))},clearOutput(C){return k.t(),k.z([],C,!1)},appendOutput(C,T){return k.t(),k.z(C,T,!0)},replaceOutput(C,T){return k.t(),k.z(C,T,!1)},appendOutputItems(C,T){return k.t(),k.C(C,T,!0)},replaceOutputItems(C,T){return k.t(),k.C(C,T,!1)}})}}var a;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(a||(a={}));class m extends R.$Xc{static{this.a=0}get state(){return this.f}constructor(k,v,C){super(),this.h=v,this.j=C,this.b=m.a++,this.c=new N.$oe,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new P.$ze),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class g{constructor(k,v){this.f=k,this.g=v,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new D.$6h,this.b=Date.now(),(0,D.$Jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>k.complete())}}function d(S,k){return`${S.value}/${k}`}}),define(Re[56],Te([1,0,6,5,3,2,16,4,7,9,12,179,19,38,180,181,35,10,8,34,37]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=e.$mrc=e.$lrc=e.$krc=void 0,e.$krc=(0,P.$Ii)("IExtHostTerminalService");class t extends O.$Xc{constructor($,w,M,A){super(),this.u=$,this._id=w,this.w=M,this.y=A,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new y.$oe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(Z=>this.g=Z);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(Z,J=!0){L.C(),L.u.$sendText(L._id,Z,J)},show(Z){L.C(),L.u.$show(L._id,Z)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??w?.cwd??void 0,env:$.env??void 0,icon:k($.iconPath)??void 0,color:c.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z($.location,w?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,w,M,A,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:A,color:c.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z($,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,w){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in $?{viewColumn:h.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,w){this.j=Object.freeze({code:$,reason:w})}setDimensions($,w){return $===this.f&&w===this.h||$===0||w===0?!1:(this.f=$,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(w=>{w!==$&&(this.b=Promise.resolve($))})}}e.$lrc=t;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new y.$oe,this.onProcessData=this.a.event,this.b=new y.$oe,this.d=new y.$oe,this.onDidChangeProperty=this.d.event,this.f=new y.$oe,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,w){this.g.setDimensions?.({columns:$,rows:w})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:f.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:f.ProcessPropertyType.Title,value:w})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,m=class extends O.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$oe,this.onDidCloseTerminal=this.H.event,this.I=new y.$oe,this.onDidOpenTerminal=this.I.event,this.J=new y.$oe,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$oe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$oe,this.onDidChangeTerminalState=this.M.event,this.N=new y.$oe,this.onDidChangeShell=this.N.event,this.O=new y.$oe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$oe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(D.$3N.MainThreadTerminalService),this.y=new r.$ryb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:A=>{const L=Z=>{const J=Z;return this.getTerminalById(J.instanceId)?.value};switch(A?.$mid){case n.MarshalledId.TerminalContext:return L(A);default:{if(Array.isArray(A))for(let Z=0;Z<A.length&&A[Z].$mid===n.MarshalledId.TerminalContext;Z++)A[Z]=L(A[Z]);return A}}}}),this.B({dispose:()=>{for(const[A,L]of this.g)L.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,w){const M=new t(this.a,(0,E.$5g)(),$,$.name),A=new o($.pty);return M.createExtensionTerminal($.location,w,this.R($,w).resolvedExtHostIdentifier,k($.iconPath),v($.color)).then(L=>{const Z=this.S(L,A);this.h[L]=Z}),this.f.push(M),M.value}R($,w){if(w=w||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const M=$.location.parentTerminal;if(M){const A=this.f.find(L=>L.value===M);A&&(w.resolvedExtHostIdentifier=A._id)}}else $.location&&typeof $.location!="object"?w.location=$.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal($,w){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const A=new o(w),L=this.S($,A);this.h[$]=L}async $acceptActiveTerminalChanged($){const w=this.b;if($===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById($);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,w){const M=this.getTerminalById($);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions($,w,M){const A=this.getTerminalById($);A&&A.setDimensions(w,M)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand($,w){const M=this.getTerminalById($);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions($,w,M){this.g.get($)?.resize(w,M)}async $acceptTerminalTitleChange($,w){const M=this.getTerminalById($);M&&(M.name=w)}async $acceptTerminalClosed($,w,M){const A=this.X(this.f,$);if(A!==null){const L=this.f.splice(A,1)[0];L.setExitStatus(w,M),this.H.fire(L.value)}}$acceptTerminalOpened($,w,M,A){if(w){const J=this.X(this.f,w);if(J!==null){this.f[J]._id=$,this.I.fire(this.terminals[J]),this.f[J].isOpen=!0;return}}const L={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:N.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},Z=new t(this.a,$,L,M);this.f.push(Z),this.I.fire(Z.value),Z.isOpen=!0}async $acceptTerminalProcessId($,w){this.getTerminalById($)?._setProcessId(w)}async $startExtensionTerminal($,w){const M=this.getTerminalById($);if(!M)return{message:(0,s.localize)(2712,null,$)};M.isOpen||await new Promise(L=>{const Z=this.onDidOpenTerminal(async J=>{J===M.value&&(Z.dispose(),L())})});const A=this.g.get($);A?A.startSendingEvents(w):this.j[$]={initialDimensions:w}}S($,w){const M=new O.$Wc;M.add(w.onProcessReady(L=>this.a.$sendProcessReady($,L.pid,L.cwd,L.windowsPty))),M.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty($,L))),this.y.startBuffering($,w.onProcessData),M.add(w.onProcessExit(L=>this.U($,L))),this.g.set($,w);const A=this.j[$];return A&&w instanceof o&&(w.startSendingEvents(A.initialDimensions),delete this.j[$]),M}$acceptProcessAckDataEvent($,w){this.g.get($)?.acknowledgeDataEvent(w)}$acceptProcessInput($,w){this.g.get($)?.input(w)}$acceptTerminalInteraction($){const w=this.getTerminalById($);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection($,w){this.getTerminalById($)?.setSelection(w)}$acceptProcessResize($,w,M){try{this.g.get($)?.resize(w,M)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown($,w){this.g.get($)?.shutdown(w)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(w=>this.a.$sendProcessProperty($,{type:f.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(w=>this.a.$sendProcessProperty($,{type:f.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new p.$5N(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,$.identifier.value),new p.$5N(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider($,w,M){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,M),this.a.$registerQuickFixProvider($,w),new p.$5N(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,w){const M=new u.$ze().token;if(M.isCancellationRequested)return;const A=this.D.get($);if(!A)return;const L=await A.provideTerminalQuickFixes(w,M);if(L===null||Array.isArray(L)&&L.length===0)return;const Z=new O.$Wc;if(this.w.value=Z,!Array.isArray(L))return L?h.TerminalQuickFix.from(L,this.Q.converter,Z):void 0;const J=[];for(const U of L){const V=h.TerminalQuickFix.from(U,this.Q.converter,Z);V&&J.push(V)}return J}async $createContributedProfileTerminal($,w){const M=new u.$ze().token;let A=await this.C.get($)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,w);return}this.createTerminalFromOptions(A.options,w)}}async $provideLinks($,w){const M=this.getTerminalById($);if(!M)return[];this.F.delete($),this.G.get($)?.dispose(!0);const L=new u.$ze;this.G.set($,L);const Z=[],J={terminal:M.value,line:w},U=[];for(const ne of this.z)U.push(l.Promises.withAsyncBody(async ue=>{L.token.onCancellationRequested(()=>ue({provider:ne,links:[]}));const _=await ne.provideTerminalLinks(J,L.token)||[];L.token.isCancellationRequested||ue({provider:ne,links:_})}));const V=await Promise.all(U);if(L.token.isCancellationRequested)return[];const Q=new Map;for(const ne of V)ne&&ne.links.length>0&&Z.push(...ne.links.map(ue=>{const _={id:a++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return Q.set(_.id,{provider:ne.provider,link:ue}),_}));return this.F.set($,Q),Z}$activateLink($,w){const M=this.F.get($)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U($,w){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const M=this.h[$];M&&(M.dispose(),delete this.h[$]),this.a.$sendProcessExit($,w)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const w=this.f.findIndex(M=>M.value===$);return w>=0?w:null}W($,w){const M=this.X($,w);return M!==null?$[M]:null}X($,w){const M=$.findIndex(A=>A._id===w);return M>=0?M:null}getEnvironmentVariableCollection($){let w=this.n.get($.identifier.value);return w||(w=this.B(new g),this.Z($.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y($,w){const M=(0,b.$Ks)(w.map),A=(0,b.$Ls)(w.descriptionMap);this.a.$setEnvironmentVariableCollection($,w.persistent,M.length===0?void 0:M,A)}$initEnvironmentVariableCollections($){$.forEach(w=>{const M=w[0],A=this.B(new g(w[1]));this.Z(M,A)})}$acceptDefaultProfile($,w){const M=this.s;this.s=$,this.u=w,M?.path!==$.path&&this.N.fire($.path)}Z($,w){this.n.set($,w),this.B(w.onDidChangeCollection(()=>{this.Y($,w)}))}};e.$mrc=m,e.$mrc=m=Ke([We(1,i.$ZQ),We(2,R.$DQ)],m);class g extends O.$Xc{get persistent(){return this.b}set persistent($){this.b=$,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor($){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new y.$oe,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const w=this.j($);let M=this.a.get(w);return M||(M=new d(this,$),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace($,w,M,A){this.g($,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:A})}append($,w,M,A){this.g($,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:A})}prepend($,w,M,A){this.g($,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:A})}g($,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h($,w.scope),A=this.map.get(M),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==w.value||A.type!==w.type||A.options?.applyAtProcessCreation!==L.applyAtProcessCreation||A.options?.applyAtShellIntegration!==L.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const Z=this.h($,w.scope),J={variable:$,...w,options:L};this.map.set(Z,J),this.f.fire()}}get($,w){const M=this.h($,w),A=this.map.get(M);return A?C(A):void 0}h($,w){const M=this.j(w);return M.length?`${$}:::${M}`:$}j($){return this.m($?.workspaceFolder)??""}m($){return $?$.uri.toString():void 0}getVariableMap($){const w=new Map;for(const[M,A]of this.map)this.j(A.scope)===this.j($)&&w.set(A.variable,C(A));return w}delete($,w){const M=this.h($,w);this.map.delete(M),this.f.fire()}clear($){if($?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(w);this.n($)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription($,w){const M=this.j(w),A=this.descriptionMap.get(M);if(!A||A.description!==$){let L;typeof $=="string"?L=$:L=$?.value.split(`

`)[0];const Z={description:L,scope:w};this.descriptionMap.set(M,Z),this.f.fire()}}getDescription($){const w=this.j($);return this.descriptionMap.get(w)?.description}n($){const w=this.j($);this.descriptionMap.delete(w)}}class d{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,w){this.b=$,this.d=w,this.a=new y.$oe}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,w,M){this.b.replace($,w,M,this.d)}append($,w,M){this.b.append($,w,M,this.d)}prepend($,w,M){this.b.prepend($,w,M,this.d)}get($){return this.b.get($,this.d)}forEach($,w){this.b.getVariableMap(this.d).forEach((M,A)=>$.call(w,A,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends m{constructor($,w){super(!1,$,w)}createTerminal($,w,M){throw new I.$bb}createTerminalFromOptions($,w){throw new I.$bb}};e.$nrc=S,e.$nrc=S=Ke([We(0,i.$ZQ),We(1,R.$DQ)],S);function k(T){if(!(!T||typeof T=="string"))return"id"in T?{id:T.id,color:T.color}:T}function v(T){return c.ThemeColor.isThemeColor(T)?T:void 0}function C(T){const $={...T};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Re[128],Te([1,0,7,4,3,5,16,56,6,2,10]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=e.$Csc=void 0,e.$Csc=(0,P.$Ii)("IExtHostTerminalShellIntegration");let b=class extends D.$Xc{constructor(c,l){super(),this.h=l,this.b=new Map,this.c=new p.$oe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$oe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$oe,this.onDidEndTerminalShellExecution=this.g.event,this.a=c.getProxy(N.$3N.MainThreadTerminalShellIntegration),this.B((0,D.$Vc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(c){const l=this.h.getTerminalById(c);if(!l)return;const h=l.value;let i=this.b.get(c);i||(i=new u(l.value,this.f),this.b.set(c,i),i.store.add(l.onWillDispose(()=>this.b.get(c)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(c,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),l.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(c,l,h,i,n){this.b.has(c)||this.$shellIntegrationChange(c);const t={value:l,confidence:h,isTrusted:i};this.b.get(c)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(c,l,h,i,n){const t={value:l,confidence:h,isTrusted:i};this.b.get(c)?.endShellExecution(t,n)}$shellExecutionData(c,l){this.b.get(c)?.emitData(l)}$cwdChange(c,l){this.b.get(c)?.setCwd(s.URI.revive(l))}$closeTerminal(c){this.b.get(c)?.dispose(),this.b.delete(c)}};e.$Dsc=b,e.$Dsc=b=Ke([We(0,R.$DQ),We(1,O.$krc)],b);class u extends D.$Xc{get currentExecution(){return this.a}constructor(c,l){super(),this.j=c,this.m=l,this.b=!1,this.store=this.B(new D.$Wc),this.f=this.B(new p.$oe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$oe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$oe),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(t);const o={value:t,confidence:y.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},a=h.startShellExecution(o,h.c,!0).value;return h.b=!0,a}}}startShellExecution(c,l,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(c,l??this.c);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(c){this.currentExecution?.emitData(c)}endShellExecution(c,l){this.a&&(this.a.endExecution(c),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:l}),this.a=void 0)}setCwd(c){let l=!1;s.URI.isUri(this.c)?l=!s.URI.isUri(c)||this.c.toString()!==c.toString():this.c!==c&&(l=!0),l&&(this.c=c,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(c,l){this.c=c,this.cwd=l,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return I.$9h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(c){this.a?.emitData(c)}endExecution(c){c&&(this.c=c),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends D.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Hh);const c=this.a;return new I.$9h(async h=>{this.b.push(h),await c.wait()})}emitData(c){for(const l of this.b)l.emitOne(c)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[129],Te([1,0,61,12,97,8,7]),function($e,e,y,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=e.$KQ=void 0,N=qe(N);class O{static{this.c=new P.$IQ("TextEditorDecorationType")}constructor(u,E,f){const r=O.c.nextId();u.$registerTextEditorDecorationType(E.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$KQ=O;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let f=null;if(u instanceof R.$6N)f=new R.$7N(u,u);else if(u instanceof R.$7N)f=u;else throw new Error("Unrecognized location");this.l(f,E,!1)}insert(u,E){this.k(),this.l(new R.$7N(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof R.$7N)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,f){const r=this.c.validateRange(u);this.g.push({range:r,text:E,forceMoveMarkers:f})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,D.$9)("endOfLine");this.h=u}}class s{constructor(u,E,f,r){this.c=u,this.d=E,this._accept(f),this.e=r;const c=this;this.value={get tabSize(){return c.f},set tabSize(l){c.n(l)},get indentSize(){return c.g},set indentSize(l){c.p(l)},get insertSpaces(){return c.j},set insertSpaces(l){c.s(l)},get cursorStyle(){return c.k},set cursorStyle(l){c.t(l)},get lineNumbers(){return c.l},set lineNumbers(l){c.u(l)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let f=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(f=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,E.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(f=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,E.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(f=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,E.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,f=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,f=!0,E.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(f)})}}e.$LQ=s;class I{constructor(u,E,f,r,c,l,h,i){this.id=u,this.j=E,this.k=f,this.g=!1,this.h=new Set,this.c=c,this.d=new s(this.j,this.id,l,f),this.e=h,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new D.$$("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof R.$8N))throw(0,D.$9)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof R.$8N)))throw(0,D.$9)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new D.$$("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new D.$$("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new p(r.value,o);return t(a),n.m(a)},insertSnippet(t,o,a={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!o||Array.isArray(o)&&o.length===0)m=n.c.map(g=>N.Range.from(g));else if(o instanceof R.$6N){const{lineNumber:g,column:d}=N.Position.from(o);m=[{startLineNumber:g,startColumn:d,endLineNumber:g,endColumn:d}]}else if(o instanceof R.$7N)m=[N.Range.from(o)];else{m=[];for(const g of o)if(g instanceof R.$7N)m.push(N.Range.from(g));else{const{lineNumber:d,column:S}=N.Position.from(g);m.push({startLineNumber:d,startColumn:S,endLineNumber:d,endColumn:S})}}return E.$tryInsertSnippet(u,r.value.version,t.value,m,a)},setDecorations(t,o){const a=o.length===0;a&&!n.h.has(t.key)||(a?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(N.$AQ(o))return E.$trySetDecorations(u,t.key,N.$BQ(o));{const m=new Array(4*o.length);for(let g=0,d=o.length;g<d;g++){const S=o[g];m[4*g]=S.start.line+1,m[4*g+1]=S.start.character+1,m[4*g+2]=S.end.line+1,m[4*g+3]=S.end.character+1}return E.$trySetDecorationsFast(u,t.key,m)}}))},revealRange(t,o){n.n(()=>E.$tryRevealRange(u,N.Range.from(t),o||R.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(u,N.ViewColumn.from(t))},hide(){E.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(c=>c.range);f.sort((c,l)=>c.end.line===l.end.line?c.end.character===l.end.character?c.start.line===l.start.line?c.start.character-l.start.character:c.start.line-l.start.line:c.end.character-l.end.character:c.end.line-l.end.line);for(let c=0,l=f.length-1;c<l;c++){const h=f[c].end;if(f[c+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(c=>({range:N.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?N.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$MQ=I}),define(Re[57],Te([1,0,61,6,4,2,3,5,125,16,129,8,11,27,15,40,51]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=void 0,y=qe(y),b=qe(b);class l{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Dc,this.d=new D.$oe,this.e=new D.$oe,this.f=new D.$oe,this.g=new D.$oe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],a=[];if(n.removedDocuments)for(const m of n.removedDocuments){const g=N.URI.revive(m),d=this.c.get(g);d?.unref()&&(this.c.delete(g),t.push(d.value))}if(n.addedDocuments)for(const m of n.addedDocuments){const g=N.URI.revive(m.uri);let d=this.c.get(g);if(d&&g.scheme!==f.Schemas.vscodeNotebookCell&&g.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);d||(d=new l(new p.$GQ(this.h.getProxy(O.$3N.MainThreadDocuments),g,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(g,d),o.push(d.value)),d.ref()}if(n.removedEditors)for(const m of n.removedEditors){const g=this.b.get(m);this.b.delete(m),g&&a.push(g)}if(n.addedEditors)for(const m of n.addedEditors){const g=N.URI.revive(m.documentUri);y.ok(this.c.has(g),`document '${g}' does not exist`),y.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const d=this.c.get(g).value,S=new I.$MQ(m.id,this.h.getProxy(O.$3N.MainThreadTextEditors),this.i,new c.$W(()=>d.document),m.selections.map(b.Selection.to),m.options,m.visibleRanges.map(k=>b.Range.to(k)),typeof m.editorPosition=="number"?b.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,S)}n.newActiveEditor!==void 0&&(y.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Sc)(t),(0,P.$Sc)(a),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(o),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$NQ=h,e.$NQ=h=Ke([We(0,s.$DQ),We(1,u.$dk)],h),e.$OQ=(0,R.$Ii)("IExtHostDocumentsAndEditors")}),define(Re[96],Te([1,0,10,20,19,6,230,76,4,37,14,2,38,3,11,5,34,57,16,127,8,7,199,54,82,55,21]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=e.$Hrc=e.$Grc=e.$Frc=e.$Erc=void 0,n=qe(n);let S=0;const k=new WeakMap;e.$Erc=(0,E.$Ii)("IExtHostTesting");let v=class extends p.$Xc{constructor(_,ae,se,ce){super(),this.C=ae,this.D=se,this.F=ce,this.f=this.B(new N.$oe),this.g=new Map,this.w=this.B(new N.$oe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(r.$3N.MainThreadTesting),this.m=new J(this.h),this.j=new w(this.h,ae),se.registerArgumentProcessor({processArgument:x=>{switch(x?.$mid){case s.MarshalledId.TestItemContext:{const we=x,Ie=we.tests[we.tests.length-1].item.extId;return this.g.get(a.$lJ.root(Ie))?.collection.tree.get(Ie)?.actual??(0,i.$PQ)(x)}case s.MarshalledId.TestMessageMenuArgs:{const{test:we,message:Ie}=x,Y=we.item.extId;return{test:this.g.get(a.$lJ.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$PQ)({$mid:s.MarshalledId.TestItemContext,tests:[we]}),message:n.TestMessage.to(Ie)}}default:return x}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const x=await se.executeCommand(o.TestCommandId.GetExplorerSelection),we=Ie=>{const Y=this.g.get(a.$lJ.root(Ie));if(Y)return a.$lJ.isRoot(Ie)?Y.controller:Y.collection.tree.get(Ie)?.actual};return{include:x?.include.map(we).filter(I.$pg)||[],exclude:x?.exclude.map(we).filter(I.$pg)||[]}})}createTestController(_,ae,se,ce){if(this.g.has(ae))throw new Error(`Attempt to insert a duplicate controller with ID "${ae}"`);const x=new p.$Wc,we=x.add(new i.$SQ(ae,se,this.F));we.root.label=se;const Ie=new Map,Y=new Set,q=this.h,ie=()=>{let Fe=0;ce&&(Fe|=g.TestControllerCapability.Refresh);const Be=Pe.relatedCodeProvider;return Be&&(Be?.provideRelatedTests&&(Fe|=g.TestControllerCapability.TestRelatedToCode),Be?.provideRelatedCode&&(Fe|=g.TestControllerCapability.CodeRelatedToTest)),Fe},ve={items:we.root.children,get label(){return se},set label(Fe){se=Fe,we.root.label=Fe,q.$updateController(ae,{label:se})},get refreshHandler(){return ce},set refreshHandler(Fe){ce=Fe,q.$updateController(ae,{capabilities:ie()})},get id(){return ae},get relatedCodeProvider(){return Pe.relatedCodeProvider},set relatedCodeProvider(Fe){(0,d.$vH)(_,"testRelatedCode"),Pe.relatedCodeProvider=Fe,q.$updateController(ae,{capabilities:ie()})},createRunProfile:(Fe,Be,xe,nt,ut,pt)=>{let lt=(0,O.$wj)(Fe);for(;Ie.has(lt);)lt++;return new V(this.h,Ie,Y,this.w.event,ae,lt,Fe,Be,xe,nt,ut,pt)},createTestItem(Fe,Be,xe){return new i.$QQ(ae,Fe,Be,xe)},createTestRun:(Fe,Be,xe=!0)=>this.j.createTestRun(_,ae,we,Fe,Be,xe),invalidateTestResults:Fe=>{if(Fe===void 0)this.h.$markTestRetired(void 0);else{const Be=Fe instanceof Array?Fe:[Fe];this.h.$markTestRetired(Be.map(xe=>a.$lJ.fromExtHostTestItem(xe,ae).toString()))}},set resolveHandler(Fe){we.resolveHandler=Fe},get resolveHandler(){return we.resolveHandler},dispose:()=>{x.dispose()}},Pe={controller:ve,collection:we,profiles:Ie,extension:_,activeProfiles:Y};return q.$registerTestController(ae,se,ie()),x.add((0,p.$Vc)(()=>q.$unregisterTestController(ae))),this.g.set(ae,Pe),x.add((0,p.$Vc)(()=>this.g.delete(ae))),x.add(we.onDidGenerateDiff(Fe=>q.$publishDiff(ae,Fe.map(g.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(_,ae=P.CancellationToken.None){const se=M(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(se.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:Q[se.kind],targets:[{testIds:_.include?.map(x=>a.$lJ.fromExtHostTestItem(x,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map(x=>x.id)},ae)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}async $getTestsRelatedToCode(_,ae,se){const ce=this.F.getDocument(b.URI.revive(_));if(!ce)return[];const x=n.Position.to(ae),we=[];return await Promise.all([...this.g.values()].map(async Ie=>{let Y;try{Y=await Ie.relatedCodeProvider?.provideRelatedTests?.(ce.document,x,se)}catch(q){se.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Ie.controller.label}`,q)}if(Y){for(const q of Y)we.push(a.$lJ.fromExtHostTestItem(q,Ie.controller.id).toString());Ie.collection.flushDiff()}})),we}async $getCodeRelatedToTest(_,ae){const se=this.g.get(a.$lJ.root(_));if(!se)return[];const ce=se.collection.tree.get(_);return ce?(await se.relatedCodeProvider?.provideRelatedCode?.(ce.actual,ae))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,ae,se){return(await this.j.getCoverageDetails(_,ae,se))?.map(n.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,ae){this.g.get(_)?.profiles.get(ae)?.configureHandler?.()}$setDefaultRunProfiles(_){const ae=new Map;for(const[se,ce]of Object.entries(_)){const x=this.g.get(se);if(!x)continue;const we=new Map,Ie=ce.filter(q=>!x.activeProfiles.has(q)),Y=[...x.activeProfiles].filter(q=>!ce.includes(q));for(const q of Ie)we.set(q,!0),x.activeProfiles.add(q);for(const q of Y)we.set(q,!1),x.activeProfiles.delete(q);we.size&&ae.set(se,we)}this.w.fire(ae)}async $refreshTests(_,ae){await this.g.get(_)?.controller.refreshHandler?.(ae)}$publishTestResults(_){this.results=Object.freeze(_.map(ae=>{const se=n.TestResults.to(ae);return k.set(se,ae.id),se}).concat(this.results).sort((ae,se)=>se.completedAt-ae.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,ae){const se=this.g.get(a.$lJ.fromString(_).controllerId)?.collection;se&&(await se.expand(_,ae<0?1/0:ae),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(ae=>g.TestsDiffOp.deserialize({asCanonicalUri:se=>se},ae)))}async $runControllerTests(_,ae){return Promise.all(_.map(se=>this.G(se,!1,ae)))}async $startContinuousRun(_,ae){const se=new P.$ze(ae),ce=await Promise.all(_.map(x=>this.G(x,!0,se.token)));return!ae.isCancellationRequested&&!ce.some(x=>x.error)&&await new Promise(x=>ae.onCancellationRequested(x)),se.dispose(!0),ce}async $provideTestFollowups(_,ae){const se=this.results.find(we=>k.get(we)===_.resultId),ce=se&&ne(a.$lJ.fromString(_.extId),se?.results);if(!ce)return[];let x=[];return await Promise.all([...this.y].map(async we=>{try{const Ie=await we.provideFollowup(se,ce,_.taskIndex,_.messageIndex,ae);Ie&&(x=x.concat(Ie))}catch(Ie){this.C.error("Error thrown while providing followup for test message",Ie)}})),ae.isCancellationRequested?[]:x.map(we=>{const Ie=S++;return this.z.set(Ie,we),{title:we.title,id:Ie}})}$disposeTestFollowups(_){for(const ae of _)this.z.delete(ae)}$executeTestFollowup(_){const ae=this.z.get(_);return ae?this.D.executeCommand(ae.command,...ae.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_,ae){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_,ae)}getMetadataForRun(_){for(const ae of this.j.trackers){const se=ae.getTaskIdForRun(_);if(se)return{taskId:se,runId:ae.id}}}async G(_,ae,se){const ce=this.g.get(_.controllerId);if(!ce)return{};const{collection:x,profiles:we,extension:Ie}=ce,Y=we.get(_.profileId);if(!Y)return{};const q=_.testIds.map(Fe=>x.tree.get(Fe)).filter(I.$pg),ie=_.excludeExtIds.map(Fe=>ce.collection.tree.get(Fe)).filter(I.$pg).filter(Fe=>q.some(Be=>Be.fullId.compare(Fe.fullId)===a.TestPosition.IsChild));if(!q.length)return{};const ve=new t.$HP(q.some(Fe=>Fe.actual instanceof i.$RQ)?void 0:q.map(Fe=>Fe.actual),ie.map(Fe=>Fe.actual),Y,ae),Pe=(0,g.$oJ)(_)&&this.j.prepareForMainThreadTestRun(Ie,ve,A.fromInternal(_,ce.collection),Y,se);try{return await Y.runHandler(ve,se),{}}catch(Fe){return{error:String(Fe)}}finally{Pe&&Pe.hasRunningTasks&&!se.isCancellationRequested&&await N.Event.toPromise(Pe.onEnd)}}};e.$Frc=v,e.$Frc=v=Ke([We(0,h.$DQ),We(1,f.$dk),We(2,c.$ZQ),We(3,l.$OQ)],v);const C=1e4;var T;(function(ue){ue[ue.Running=0]="Running",ue[ue.Cancelling=1]="Cancelling",ue[ue.Ended=2]="Ended"})(T||(T={}));class $ extends p.$Xc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(_,ae,se,ce,x,we){super(),this.C=_,this.D=ae,this.F=se,this.G=ce,this.H=x,this.f=T.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new N.$oe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$ze(we));const Ie=this.B(new y.$Uh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Ie.schedule()));const Y=new N.$oe;this.y=Y.event,this.B((0,p.$Vc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(_){for(const[ae,{run:se}]of this.h)if(se===_)return ae}cancel(_){_?this.h.get(_)?.cts.cancel():this.f===T.Running?(this.m.cancel(),this.f=T.Cancelling):this.f===T.Cancelling&&this.I()}async getCoverageDetails(_,ae,se){const[,ce]=a.$lJ.fromString(_).path,x=this.z.get(_);if(!x)return[];const{report:we,extIds:Ie}=x,Y=this.h.get(ce);if(!Y)throw new Error("unreachable: run task was not found");let q;if(ae&&we instanceof t.$NP){const ve=Ie.indexOf(ae);if(ve===-1)return[];q=we.fromTests[ve]}return await(q?this.G?.loadDetailedCoverageForTest?.(Y.run,we,q,se):this.G?.loadDetailedCoverage?.(Y.run,we,se))??[]}createRun(_){const ae=this.C.id,se=this.C.controllerId,ce=(0,u.$5g)(),x=ie=>(ve,...Pe)=>{if(Ie){this.F.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.L(ve),ie(ve,...Pe)},we=(ie,ve)=>{const Pe=ve instanceof Array?ve.map(n.TestMessage.from):[n.TestMessage.from(ve)];if(ie.uri&&ie.range){const Fe={range:n.Range.from(ie.range),uri:ie.uri};for(const Be of Pe)Be.location=Be.location||Fe}this.D.$appendTestMessagesInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,se).toString(),Pe)};let Ie=!1;const Y=this.B(new P.$ze(this.m.token)),q={isPersisted:this.C.isPersisted,token:Y.token,name:_,onDidDispose:this.y,addCoverage:ie=>{if(Ie)return;const ve=ie instanceof t.$NP?ie.fromTests:[];if(ve.length){(0,d.$vH)(this.H,"attributableCoverage");for(const Be of ve)this.L(Be)}const Pe=ie.uri.toString(),Fe=new a.$lJ([ae,ce,Pe]).toString();this.z.set(Fe,{report:ie,extIds:ve.map(Be=>a.$lJ.fromExtHostTestItem(Be,se).toString())}),this.D.$appendCoverage(ae,ce,n.TestCoverage.fromFile(se,Fe,ie))},enqueued:x(ie=>{this.D.$updateTestStateInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,se).toString(),g.TestResultState.Queued)}),skipped:x(ie=>{this.D.$updateTestStateInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,se).toString(),g.TestResultState.Skipped)}),started:x(ie=>{this.D.$updateTestStateInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,se).toString(),g.TestResultState.Running)}),errored:x((ie,ve,Pe)=>{we(ie,ve),this.D.$updateTestStateInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,se).toString(),g.TestResultState.Errored,Pe)}),failed:x((ie,ve,Pe)=>{we(ie,ve),this.D.$updateTestStateInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,se).toString(),g.TestResultState.Failed,Pe)}),passed:x((ie,ve)=>{this.D.$updateTestStateInRun(ae,ce,a.$lJ.fromExtHostTestItem(ie,this.C.controllerId).toString(),g.TestResultState.Passed,ve)}),appendOutput:(ie,ve,Pe)=>{Ie||(Pe&&this.L(Pe),this.D.$appendOutputToRun(ae,ce,D.$Qe.fromString(ie),ve&&n.location.from(ve),Pe&&a.$lJ.fromExtHostTestItem(Pe,se).toString()))},end:()=>{Ie||(Ie=!0,this.D.$finishedTestRunTask(ae,ce),--this.g||this.J())}};return this.g++,this.h.set(ce,{run:q,cts:Y}),this.D.$startedTestRunTask(ae,{id:ce,ctrlId:this.C.controllerId,name:_||this.H.displayName||this.H.identifier.value,running:!0}),q}I(){for(const{run:_}of this.h.values())_.end()}J(){this.f!==T.Ended&&(this.f=T.Ended,this.w.fire())}L(_){if(!(_ instanceof i.$QQ))throw new m.$vQ(_.id);if(this.j.has(a.$lJ.fromExtHostTestItem(_,this.C.controllerId).toString()))return;const ae=[],se=this.C.colllection.root;for(;;){const ce=n.TestItem.from(_);if(ae.unshift(ce),this.j.has(ce.extId)||(this.j.add(ce.extId),_===se))break;_=_.parent||se}this.D.$addTestsToRun(this.C.controllerId,this.C.id,ae)}dispose(){this.J(),super.dispose()}}class w{get trackers(){return this.f.values()}constructor(_,ae){this.h=_,this.j=ae,this.f=new Map,this.g=new Map}getCoverageDetails(_,ae,se){const ce=a.$lJ.root(_);return this.g.get(ce)?.getCoverageDetails(_,ae,se)||[]}disposeTestRun(_){this.g.get(_)?.dispose(),this.g.delete(_);for(const[ae,{id:se}]of this.f)se===_&&this.f.delete(ae)}prepareForMainThreadTestRun(_,ae,se,ce,x){return this.k(ae,se,ce,_,x)}cancelRunById(_,ae){this.g.get(_)?.cancel(ae)}cancelAllRuns(){for(const _ of this.f.values())_.cancel()}createTestRun(_,ae,se,ce,x,we){const Ie=this.f.get(ce);if(Ie)return Ie.createRun(x);const Y=A.fromPublic(ae,se,ce,we),q=M(ce);this.h.$startedExtensionTestRun({controllerId:ae,continuous:!!ce.continuous,profile:q&&{group:Q[q.kind],id:q.profileId},exclude:ce.exclude?.map(ve=>a.$lJ.fromExtHostTestItem(ve,se.root.id).toString())??[],id:Y.id,include:ce.include?.map(ve=>a.$lJ.fromExtHostTestItem(ve,se.root.id).toString())??[se.root.id],preserveFocus:ce.preserveFocus??!0,persist:we});const ie=this.k(ce,Y,ce.profile,_);return N.Event.once(ie.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),ie.createRun(x)}k(_,ae,se,ce,x){const we=new $(ae,this.h,this.j,se,ce,x);return this.f.set(_,we),this.g.set(we.id,we),we}}e.$Grc=w;const M=ue=>{if(ue.profile){if(!(ue.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ue.profile}};class A{static fromPublic(_,ae,se,ce){return new A(_,(0,u.$5g)(),ce,ae)}static fromInternal(_,ae){return new A(_.controllerId,_.runId,!0,ae)}constructor(_,ae,se,ce){this.controllerId=_,this.id=ae,this.isPersisted=se,this.colllection=ce}}e.$Hrc=A;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(_){this.k=_,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(_){this.f.add(_)}update(_){Object.assign(_.revived,n.TestItem.toPlain(_.item)),this.f.has(_)||this.g.add(_)}remove(_){if(this.f.has(_)){this.f.delete(_);return}this.g.delete(_);const ae=a.$lJ.parentId(_.item.extId);if(ae&&this.j.has(ae.toString())){this.j.add(_.item.extId);return}this.h.add(_)}getChangeEvent(){const{f:_,g:ae,h:se}=this;return{get added(){return[..._].map(ce=>ce.revived)},get updated(){return[...ae].map(ce=>ce.revived)},get removed(){return[...se].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class Z extends g.$uJ{constructor(){super(...arguments),this.z=new N.$oe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(_){return this.g.get(_)}getMirroredTestDataByReference(_){return this.g.get(_.id)}y(_,ae){return{..._,revived:n.TestItem.toPlain(_.item),depth:ae?ae.depth+1:0,children:new Set}}x(){return new L(this.z)}}class J{constructor(_){this.g=_}checkout(){this.f||(this.f=this.h());const _=this.f;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(ae=>ae.revived)},dispose:(0,R.$fb)(()=>{--_.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(_){return this.f?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.f?.tests.apply(_)}h(){const _=new Z({asCanonicalUri:ae=>ae});return this.g.$subscribeToDiffs(),{observers:0,tests:_}}}const U=(ue,_,ae,se)=>{ae?Object.assign(ae,se):_.$updateTestRunConfig(ue.controllerId,ue.profileId,se)};class V{#e;#t;#i;#n;#s;get label(){return this.g}set label(_){_!==this.g&&(this.g=_,U(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(_){_!==this.h&&(this.h=_,U(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),U(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,U(this,this.#e,this.#n,{tag:_?n.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.f}set configureHandler(_){_!==this.f&&(this.f=_,U(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return N.Event.chain(this.#i,_=>_.map(ae=>ae.get(this.controllerId)?.get(this.profileId)).filter(I.$pg))}constructor(_,ae,se,ce,x,we,Ie,Y,q,ie=!1,ve=void 0,Pe=!1){this.controllerId=x,this.profileId=we,this.g=Ie,this.kind=Y,this.runHandler=q,this._tag=ve,this.h=Pe,this.#e=_,this.#s=ae,this.#t=se,this.#i=ce,ae.set(we,this);const Fe=Q[Y];if(typeof Fe!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);ie&&se.add(we),this.#n={profileId:we,controllerId:x,tag:ve?n.TestTag.namespace(this.controllerId,ve.id):null,label:Ie,group:Fe,isDefault:ie,hasConfigurationHandler:!1,supportsContinuousRun:Pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Irc=V;const Q={[t.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function ne(ue,_){for(let ae=0;ae<ue.path.length;ae++){const se=_.find(ce=>ce.id===ue.path[ae]);if(!se)return;if(ae===ue.path.length-1)return se;_=se.children}}}),define(Re[258],Te([1,0,17,6,4,5,129,8,7]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,y=qe(y),O=qe(O);class s extends P.$Xc{constructor(b,u){super(),this.m=u,this.a=new D.$oe,this.b=new D.$oe,this.c=new D.$oe,this.f=new D.$oe,this.g=new D.$oe,this.h=new D.$oe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=b.getProxy(N.$3N.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(b){const u=this.m.allEditors();return b?u:u.map(E=>E.value)}async showTextDocument(b,u,E){let f;typeof u=="number"?f={position:O.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?f={position:O.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?O.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:f={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(b.uri,f),c=r&&this.m.getEditor(r);if(c)return c.value;throw r?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}createTextEditorDecorationType(b,u){return new R.$KQ(this.j,b,u).value}$acceptEditorPropertiesChanged(b,u){const E=this.m.getEditor(b);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const f=u.selections.selections.map(O.Selection.to);E._acceptSelections(f)}if(u.visibleRanges){const f=y.$Jb(u.visibleRanges.map(O.Range.to));E._acceptVisibleRanges(f)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:O.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const f=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(O.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:f})}if(u.visibleRanges){const f=y.$Jb(u.visibleRanges.map(O.Range.to));this.c.fire({textEditor:E.value,visibleRanges:f})}}$acceptEditorPositionData(b){for(const u in b){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const f=O.ViewColumn.to(b[u]);E.value.viewColumn!==f&&(E._acceptViewColumn(f),this.f.fire({textEditor:E.value,viewColumn:f}))}}getDiffInformation(b){return Promise.resolve(this.j.$getDiffInformation(b))}}e.$Pqc=s}),define(Re[259],Te([1,0,2,3,5,4,7,8,18,37,14]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=e.$Fsc=void 0,e.$Fsc=(0,D.$Ii)("IExtHostTimeline");class b{constructor(f,r){this.b=new Map,this.c=new Map,this.a=f.getProxy(P.$3N.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(c,l)=>{if(c&&c.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(c.source)&&p.$un.equals(l,this.b.get(c.source)?.extension)){const h=c.uri===void 0?void 0:y.URI.revive(c.uri);return this.c.get(c.source)?.get(u(h))?.get(c.handle)}else return;return c}})}async $getTimeline(f,r,c,l){return this.b.get(f)?.provider.provideTimeline(y.URI.revive(r),c,l)}registerTimelineProvider(f,r,c,l){const h=new N.$Wc,i=this.d(r.id,l,h).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this.c;return this.f({...r,scheme:f,onDidChange:void 0,async provideTimeline(o,a,m){a?.resetCache&&(h.clear(),t.get(r.id)?.clear());const g=await r.provideTimeline(o,a,m);if(g==null)return;const d=i(o,a);return{...g,source:r.id,items:g.items.map(d)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),h.dispose()}},c)}d(f,r,c){return(l,h)=>{let i;if(h?.cacheResults){let n=this.c.get(f);n===void 0&&(n=new Map,this.c.set(f,n));const t=u(l);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,a=`${f}|${n.id??n.timestamp}`;i?.set(a,n);let m,g,d;n.iconPath&&(t instanceof R.$4O?d={id:t.id,color:t.color}:y.URI.isUri(t)?(m=t,g=t):{light:m,dark:g}=t);let S;return R.$wO.isMarkdownString(o.tooltip)?S=O.MarkdownString.from(o.tooltip):(0,I.$hg)(o.tooltip)?S=o.tooltip:R.$wO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=O.MarkdownString.from(o.detail)):(0,I.$hg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=o.detail),{...o,id:o.id??void 0,handle:a,source:f,command:n.command?r.toInternal(n.command,c):void 0,icon:m,iconDark:g,themeIcon:d,tooltip:S,accessibilityInformation:n.accessibilityInformation}}}}f(f,r){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,{provider:f,extension:r}),(0,N.$Vc)(()=>{for(const l of this.c.values())l.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.$Gsc=b;function u(E){return E?.toString()}}),define(Re[260],Te([1,0,9,24,2,6,4,191,10,7,14,17,8,59,19,163,21]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsc=void 0,s=qe(s);function l(n,t){if((0,I.$hg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class h extends R.$Xc{constructor(t,o,a){super(),this.f=t,this.g=o,this.h=a,this.a=new Map,this.b=new r.$cab;function m(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:g=>m(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(d=>m(d)?this.r(d):d):g})}registerTreeDataProvider(t,o,a){const m=this.createTreeView(t,{treeDataProvider:o},a);return{dispose:()=>m.dispose()}}createTreeView(t,o,a){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=o.dragAndDropController?.dropMimeTypes??[],g=o.dragAndDropController?.dragMimeTypes??[],d=!!o.dragAndDropController?.handleDrag,S=!!o.dragAndDropController?.handleDrop,k=this.m(t,o,a),v={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:m,dragMimeTypes:g,hasHandleDrag:d,hasHandleDrop:S,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,v),T={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,c.$vH)(a,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,c.$vH)(a,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message($){(0,E.$9k)($)&&(0,c.$vH)(a,"treeViewMarkdownMessage"),k.message=$},get title(){return k.title},set title($){k.title=$},get description(){return k.description},set description($){k.description=$},get badge(){return k.badge},set badge($){$!==void 0&&s.ViewBadge.isViewBadge($)?k.badge={value:Math.floor(Math.abs($.value)),tooltip:$.tooltip}:$===void 0&&(k.badge=void 0)},reveal:($,w)=>k.reveal($,w),dispose:async()=>{await C,this.a.delete(t),k.dispose()}};return this.B(T),T}$getChildren(t,o){const a=this.a.get(t);return a?a.getChildren(o):Promise.reject(new O.$PG(t))}async $handleDrop(t,o,a,m,g,d,S,k){const v=this.a.get(t);if(!v)return Promise.reject(new O.$PG(t));const C=u.DataTransfer.toDataTransfer(a,async T=>(await this.f.$resolveDropFileData(t,o,T)).buffer);return S===t&&k&&await this.j(C,v,k,g,d),v.onDrop(C,m,g)}async j(t,o,a,m,g){const d=this.b.removeDragOperationTransfer(g);if(d)(await d)?.forEach((S,k)=>{S&&t.set(k,S)});else if(g&&o.handleDrag){const S=o.handleDrag(a,t,m);this.b.addDragOperationTransfer(g,S),await S}return t}async $handleDrag(t,o,a,m){const g=this.a.get(t);if(!g)return Promise.reject(new O.$PG(t));const d=await this.j(new s.$ZO,g,o,m,a);if(!(!d||m.isCancellationRequested))return u.DataTransfer.from(d)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new O.$PG(t);return o.hasResolve}$resolve(t,o,a){const m=this.a.get(t);if(!m)throw new O.$PG(t);return m.resolveTreeItem(o,a)}$setExpanded(t,o,a){const m=this.a.get(t);if(!m)throw new O.$PG(t);m.setExpanded(o,a)}$setSelectionAndFocus(t,o,a){const m=this.a.get(t);if(!m)throw new O.$PG(t);m.setSelectionAndFocus(o,a)}$setVisible(t,o){const a=this.a.get(t);if(!a){if(!o)return;throw new O.$PG(t)}a.setVisible(o)}$changeCheckboxState(t,o){const a=this.a.get(t);if(!a)throw new O.$PG(t);a.setCheckboxState(o)}m(t,o,a){const m=this.B(new i(t,o,this.f,this.g.converter,this.h,a));return this.a.set(t,m),m}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$Hsc=h;class i extends R.$Xc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$qg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,a,m,g,d){if(super(),this.I=t,this.J=a,this.L=m,this.M=g,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$oe),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$oe),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$oe),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$oe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$oe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$oe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$oe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ze,d.contributes&&d.contributes.views)for(const C in d.contributes.views)for(const T of d.contributes.views[C])T.id===t&&(this.P=T.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,k;const v=N.Event.debounce(this.F.event,(C,T)=>(C||(C={message:!1,elements:[]}),T.element!==!1&&(S||(S=new Promise($=>k=$),this.G=this.G.then(()=>S)),Array.isArray(T.element)?C.elements.push(...T.element):C.elements.push(T.element)),T.message&&(C.message=!0),C),200,!0);this.B(v(({message:C,elements:T})=>{T.length&&(this.H=this.H.then(()=>{const $=k;return S=null,this.$(T).then(()=>$())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let a=this.X(t);return a||(a=await this.Y(o)),a?a.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const a=(0,I.$qg)(o.select)?!0:o.select,m=(0,I.$qg)(o.focus)?!1:o.focus,g=(0,I.$qg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(d=>this.W(t,d[d.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:d.map(k=>k.item)},{select:a,focus:m,expand:g})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:a,focus:m,expand:g})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const a=this.getExtensionElement(t);a&&(o?this.u.fire(Object.freeze({element:a})):this.w.fire(Object.freeze({element:a})))}setSelectionAndFocus(t,o){const a=!(0,b.$wb)(this.s,t);this.s=t;const m=this.t!==o;this.t=o,a&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async a=>{const m=this.getExtensionElement(a.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:a.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);o.forEach(a=>{a.treeItem.checkboxState=a.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(a=>[a.extensionItem,a.newState])})}async handleDrag(t,o,a){const m=[];for(const g of t){const d=this.getExtensionElement(g);d&&m.push(d)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,o,a),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,a){const m=o?this.getExtensionElement(o):void 0;if(!(!m&&o||!this.g?.handleDrop))return(0,p.$Ah)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const a=this.j.get(t);if(a){const m=this.m.get(a);if(m){const g=await this.f.resolveTreeItem(m.extensionItem,a,o)??m.extensionItem;return this.hb(g),m.item.tooltip=this.eb(g.tooltip),m.item.command=this.fb(m.disposableStore,g.command),m.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(a=>this.W(o,a[a.length-1]).then(m=>(a.push(m),a))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,p.$Ah)(()=>this.f.getParent(t))}W(t,o){const a=this.m.get(t);return a?Promise.resolve(a):(0,p.$Ah)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,o,!0)).then(m=>this.getChildren(o?o.item.handle:void 0).then(()=>{const g=this.getExtensionElement(m);if(g){const d=this.m.get(g);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const a=this.getExtensionElement(t);o=a?this.m.get(a):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new f.$ze(this.Z.token);try{const a=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const g=(0,b.$Jb)(m||[]),d=await Promise.all((0,b.$Jb)(g).map(k=>this.f.getTreeItem(k)));if(o.token.isCancellationRequested)return;const S=d.map((k,v)=>k?this.db(g[v],k,a):null);return(0,b.$Jb)(S)}finally{o.dispose()}}$(t){if(t.some(a=>!a))return this.Z.dispose(!0),this.Z=new f.$ze,this.tb(),this.J.$refresh(this.I);{const a=this.ab(t);if(a.length)return this.bb(a)}return Promise.resolve(void 0)}ab(t){const o=new Set,a=t.map(g=>this.m.get(g));for(const g of a)if(g&&!o.has(g.item.handle)){let d=g;for(;d&&d.parent&&a.findIndex(S=>d&&d.parent&&S&&S.item.handle===d.parent.item.handle)===-1;){const S=this.j.get(d.parent.item.handle);d=S?this.m.get(S):void 0}d&&!d.parent&&o.add(g.item.handle)}const m=[];return o.forEach(g=>{const d=this.j.get(g);if(d){const S=this.m.get(d);S&&(!S.parent||!o.has(S.parent.item.handle))&&m.push(g)}}),m}bb(t){const o={};return Promise.all(t.map(a=>this.cb(a).then(m=>{m&&(o[a]=m.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const a=this.m.get(o);if(a)return this.rb(o),(0,p.$Ah)(()=>this.f.getTreeItem(o)).then(m=>{if(m){const g=this.ib(o,m,a.parent);return this.pb(o,g,a,a.parent),a.dispose(),g}return null})}return Promise.resolve(null)}db(t,o,a){const m=this.ib(t,o,a);if(o.id&&this.j.has(m.item.handle))throw new Error((0,y.localize)(2713,null,o.id));return this.ob(t,m),this.qb(m,a),m}eb(t){return s.$wO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,a,m;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,a=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:m}}hb(t){if(!s.$UO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,a){this.hb(o);const m=this.B(new R.$Wc),g=this.kb(t,o,a),d=this.lb(o);return{item:{handle:g,parentHandle:a?a.item.handle:void 0,label:l(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(m,o.command),contextValue:o.contextValue,icon:d,iconDark:this.mb(o)||d,themeIcon:this.jb(o),collapsibleState:(0,I.$qg)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:a,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof s.$4O?t.iconPath:void 0}kb(t,{id:o,label:a,resourceUri:m},g,d){if(o)return`${i.b}/${o}`;const S=l(a,this.N),k=g?g.item.handle:i.a;let v=S?S.label:m?(0,D.$gh)(m):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,T=this.X(g)||[];let $,w=0;do{if($=`${k}/${w}:${v}`,d||!this.j.has($)||C===$)break;w++}while(w<=T.length);return $}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$4O))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$4O)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,a,m){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==a.item.handle&&this.j.delete(a.item.handle),this.ob(t,o);const g=this.X(m)||[],d=g.filter(S=>S.item.handle===a.item.handle)[0];d&&g.splice(g.indexOf(d),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const a of o.children){const m=this.j.get(a.item.handle);m&&this.sb(m)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const a of o.children){const m=this.j.get(a.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[261],Te([1,0,6,4,2,38,8,67,5,7]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0,R=qe(R),p=qe(p),s=qe(s);class I extends D.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(f,r,c,l){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new y.$oe),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$oe),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=c,this.#i=l.viewType,this.#s=l.panelOptions,this.#o=l.viewColumn,this.#r=l.title,this.#l=l.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,P.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(f){this.#u||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#l=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:R.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class b extends D.$Xc{static c(){return(0,N.$5g)()}constructor(f,r,c){super(),this.j=r,this.m=c,this.g=new Map,this.h=new Map,this.f=f.getProxy(p.$3N.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,c,l,h={}){const i=typeof l=="object"?l.viewColumn:l,n={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof l=="object"&&!!l.preserveFocus},t=(0,O.$5qc)(f),o=b.c();this.f.$createWebviewPanel((0,O.$7qc)(f),o,r,{title:c,panelOptions:u(h),webviewOptions:(0,O.$8qc)(f,this.m,h),serializeBuffersForPostMessage:t},n);const a=this.j.createNewWebview(o,h,f);return this.createNewWebviewPanel(o,r,c,i,h,a,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((c,l)=>{const h=f[c],i=f[l];return h.active?1:i.active?-1:+h.visible-+i.visible});for(const c of r){const l=this.getWebviewPanel(c);if(!l)continue;const h=f[c];l._updateViewState({active:h.active,visible:h.visible,viewColumn:R.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,c){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:c,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,O.$5qc)(f)}),new s.$5N(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,c,l){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=h,t=this.j.createNewWebview(f,c.webviewOptions,n),o=this.createNewWebviewPanel(f,r,c.title,l,c.panelOptions,t,c.active);await i.deserializeWebviewPanel(o,c.state)}createNewWebviewPanel(f,r,c,l,h,i,n){const t=new I(f,this.f,i,{viewType:r,title:c,viewColumn:l,panelOptions:h,active:n});return this.g.set(f,t),t}getWebviewPanel(f){return this.g.get(f)}}e.$9qc=b;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Re[262],Te([1,0,6,4,67,8,5,7]),function($e,e,y,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0,R=qe(R),O=qe(O);class p extends D.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(b,u,E,f,r,c){super(),this.#s=!1,this.#l=this.B(new y.$oe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new y.$oe),this.onDidDispose=this.#u.event,this.#i=E,this.#a=f,this.#e=b,this.#t=u,this.#n=r,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(b){this.a(),this.#a!==b&&(this.#a=b,this.#t.$setWebviewViewTitle(this.#e,b))}get description(){return this.a(),this.#o}set description(b){this.a(),this.#o!==b&&(this.#o=b,this.#t.$setWebviewViewDescription(this.#e,b))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(b){b===this.#r||this.#s||(this.#r=b,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(b){this.a(),!(b?.value===this.#c?.value&&b?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(b),this.#t.$setWebviewViewBadge(this.#e,b))}show(b){this.a(),this.#t.$show(this.#e,!!b)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(b,u){this.d=u,this.b=new Map,this.c=new Map,this.a=b.getProxy(R.$3N.MainThreadWebviewViews)}registerWebviewViewProvider(b,u,E,f){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:b}),this.a.$registerWebviewViewProvider((0,P.$7qc)(b),u,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$5qc)(b)}),new O.$5N(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(b,u,E,f,r){const c=this.b.get(u);if(!c)throw new Error(`No view provider found for '${u}'`);const{provider:l,extension:h}=c,i=this.d.createNewWebview(b,{},h),n=new p(b,this.a,u,E,i,!0);this.c.set(b,n),await l.resolveWebviewView(n,{state:f},r)}async $onDidChangeWebviewViewVisibility(b,u){this.e(b)._setVisible(u)}async $disposeWebviewView(b){const u=this.e(b);this.c.delete(b),u.dispose(),this.d.deleteWebview(b)}e(b){const u=this.c.get(b);if(!u)throw new Error("No webview found");return u}}e.$Ksc=s}),define(Re[263],Te([1,0,6,29,31,3]),function($e,e,y,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.OutputChannelUpdateMode=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=void 0,e.$0M="text/x-code-output",e.$$M="Log",e.$_M="text/x-code-log-output",e.$aN="log",e.$bN="workbench.panel.output",e.$cN=new P.$Zj("inOutput",!1),e.$dN=new P.$Zj("activeLogOutput",!1),e.$eN=new P.$Zj("activeLogOutput.levelSettable",!1),e.$fN=new P.$Zj("activeLogOutput.level",""),e.$gN=new P.$Zj("activeLogOutput.levelIsDefault",!1),e.$hN=new P.$Zj("outputView.scrollLock",!1),e.$iN=(0,N.$Ii)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$jN={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new y.$oe,this.onDidRegisterChannel=this.b.event,this.c=new y.$oe,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}D.$uo.add(e.$jN.OutputChannels,new O),e.$kN=new P.$Zj("activeOutputChannel","")}),define(Re[130],Te([1,0,5,3,16,18,11,263,68,26,50,165,20,14,28,6,4]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=e.$nsc=void 0;class l extends R.$jk{get disposed(){return this.n}constructor(t,o,a,m,g){super(),this.id=t,this.name=o,this.r=a,this.s=m,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Qe.fromString(o).byteLength,(0,R.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends l{appendLine(t){this.append(t)}}let i=class{constructor(t,o,a,m,g,d){this.i=o,this.j=a,this.k=m,this.l=g,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(y.$3N.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,b.$7m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,a]of this.g)a.visible=o===this.h}createOutputChannel(t,o,a){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof o=="object"&&o.log,g=(0,E.$hg)(o)?o:void 0;if((0,E.$hg)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const S=this.i.environment.extensionLogLevel?.find(([v])=>N.$un.equals(a.identifier,v))?.[1];S&&(d=(0,R.$uk)(S));const k=m?this.o(t,d,a):this.n(t,g,a);return k.then(v=>{this.g.set(v.id,v),v.visible=v.id===this.h}),m?this.r(t,d??this.m.getLevel(),k):this.q(t,k)}async n(t,o,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,g=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,g,o,a.identifier.value);return new l(S,t,d,this.a,a)}async o(t,o,a){const m=await this.p(a),g=t.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(m,`${g}.log`),S=`${a.identifier.value}.${g}`,k=this.l.createLogger(d,{id:S,name:t,logLevel:o,extensionId:a.identifier.value});return new h(S,t,k,this.a,a)}p(t){let o=this.d.get(t.identifier.value);if(!o){const a=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(a)}catch(m){if((0,f.$tl)(m)!==f.FileSystemProviderErrorCode.FileExists)throw m}return a})())}return o}q(t,o){let a=!1;const m=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return t},append(g){m(),o.then(d=>d.append(g))},appendLine(g){m(),o.then(d=>d.appendLine(g))},clear(){m(),o.then(g=>g.clear())},replace(g){m(),o.then(d=>d.replace(g))},show(g,d){m(),o.then(S=>S.show(g,d))},hide(){m(),o.then(g=>g.hide())},dispose(){a=!0,o.then(g=>g.dispose())}}}r(t,o,a){const m=new c.$Wc,g=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},d=m.add(new r.$oe);function S(k){o=k,d.fire(k)}return a.then(k=>{m.add(k),k.logLevel!==o&&S(k.logLevel),m.add(k.onDidChangeLogLevel(v=>S(v)))}),{...this.q(t,a),get logLevel(){return o},onDidChangeLogLevel:d.event,trace(k,...v){g(),a.then(C=>C.trace(k,...v))},debug(k,...v){g(),a.then(C=>C.debug(k,...v))},info(k,...v){g(),a.then(C=>C.info(k,...v))},warn(k,...v){g(),a.then(C=>C.warn(k,...v))},error(k,...v){g(),a.then(C=>C.error(k,...v))},dispose(){m.dispose()}}}};e.$nsc=i,e.$nsc=i=Ke([We(0,P.$DQ),We(1,s.$TQ),We(2,p.$1qc),We(3,I.$Dqc),We(4,R.$ek),We(5,R.$dk)],i),e.$osc=(0,D.$Ii)("IExtHostOutputService")}),define(Re[131],Te([1,0,3,10]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=void 0,e.$Zm=(0,y.$Ii)("remoteAgentService"),e.$1m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let N=1/0;for(let O=0;O<this.maxSampleCount;O++){const p=await P.getRoundTripTime();if(p===void 0)return;N=Math.min(N,p/2),await(0,D.$Jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((O,p)=>O+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((O,p)=>O+p,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[264],Te([1,0,9,53,29,49,43,4,6,131,23,25,10,115]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=void 0,e.$uL=Object.freeze({id:"application",order:100,title:(0,y.localize)(3973,null),type:"object"}),e.$vL=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(3974,null),type:"object"}),e.$wL=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,y.localize)(3975,null),type:"object",order:7}),e.$xL=Object.freeze({id:"problems",title:(0,y.localize)(3976,null),type:"object",order:101}),e.$yL=Object.freeze({id:"window",order:8,title:(0,y.localize)(3977,null),type:"object"}),e.$zL={ConfigurationMigration:"base.contributions.configuration.migration"};class f{constructor(){this.migrations=[],this.a=new p.$oe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new f;P.$uo.add(e.$zL.ConfigurationMigration,r);let c=class extends O.$Xc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const a of o.added)await this.f(a,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(o=>this.g(o,n?.uri))])}async g(n,t){const o=this.a.inspect(n.key,{resource:t}),a=this.b.getWorkbenchState()===N.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[m,g]of a){const d=o[m];if(!d)continue;const S=[];if(d.value!==void 0){const k=await this.h(n,m,d.value,t,void 0);for(const v of k??[])S.push([v,[]])}for(const{identifiers:k,value:v}of d.overrides??[])if(v!==void 0){const C=await this.h(n,m,v,t,k);for(const T of C??[])S.push([T,k])}S.length&&await Promise.allSettled(S.map(async([[k,v],C])=>this.a.updateValue(k,v.value,{resource:t,overrideIdentifiers:C},g)))}}async h(n,t,o,a,m){const g=S=>{const v=this.a.inspect(S,{resource:a})[t];if(v)return m?v.overrides?.find(({identifiers:C})=>(0,b.$lo)(C,m))?.value:v.value},d=await n.migrateFn(o,g);return Array.isArray(d)?d:[[n.key,d]]}};e.$AL=c,e.$AL=c=Ke([We(0,R.$cj),We(1,N.$Ri)],c);let l=class extends O.$Xc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$6h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$uo.as(D.$zo.Configuration).registerConfiguration({...e.$wL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(3978,null)},default:[],markdownDescription:(0,y.localize)(3979,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(3980,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$BL=l,e.$BL=l=Ke([We(0,s.$Zm)],l),e.$CL="window.newWindowProfile";let h=class extends O.$Xc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==R.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$CL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$uo.as(D.$zo.Configuration),t={...e.$yL,properties:{[e.$CL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,y.localize)(3981,null)],description:(0,y.localize)(3982,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$CL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$CL);if(!n)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$CL,t?.name)}};e.$DL=h,e.$DL=h=Ke([We(0,E.$Pl),We(1,R.$cj)],h)}),define(Re[265],Te([1,0,41,15,22,24,9,264,53,3,29]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$FL=e.$EL=void 0,e.$GL=r,e.$HL=c,y=qe(y),e.$EL=(0,s.$Ii)("editorResolverService"),e.$FL="workbench.editorAssociations";const b=I.$uo.as(p.$zo.Configuration),u={...O.$vL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(12213,null),additionalProperties:{type:"string"}}}};b.registerConfiguration(u);var E;(function(l){l.builtin="builtin",l.option="option",l.exclusive="exclusive",l.default="default"})(E||(e.RegisteredEditorPriority=E={}));var f;(function(l){l[l.ABORT=1]="ABORT",l[l.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(l){switch(l){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function c(l,h){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(h.scheme))return!1;const t=typeof l=="string"&&l.indexOf(P.$jc.sep)>=0?`${h.scheme}:${h.path}`:(0,N.$gh)(h);return y.$Ck(typeof l=="string"?l.toLowerCase():l,t.toLowerCase())}}),define(Re[266],Te([1,0,73,15,22,23,24,2,3,185,49,204,131]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=void 0,e.$CN=(0,p.$Ii)("pathService");let f=E=class{constructor(c,l,h,i){this.d=c,this.e=l,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??c})()}hasValidBasename(c,l,h){return typeof l=="string"||typeof l>"u"?this.a.then(i=>this.h(c,i,l)):this.h(c,l,h)}h(c,l,h){return c.scheme===D.Schemas.file||c.scheme===D.Schemas.vscodeRemote?(0,y.$Fg)(h??(0,R.$gh)(c),l===N.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,l){if(c.remoteAuthority)return D.Schemas.vscodeRemote;const h=(0,s.$zN)(l.getWorkspace());if(h)return h;const i=l.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=l.getWorkspace().configuration;return n?n.scheme:D.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===N.OperatingSystem.Windows?P.$ic:P.$jc)}async fileURI(c){let l="";if(await this.a===N.OperatingSystem.Windows&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const i=c.indexOf("/",2);i===-1?(l=c.substring(2),c="/"):(l=c.substring(2,i),c=c.substring(i)||"/")}return O.URI.from({scheme:D.Schemas.file,authority:l,path:c,query:"",fragment:""})}};e.$DN=f,e.$DN=f=E=Ke([We(1,u.$Zm),We(2,b.$lN),We(3,I.$Ri)],f)}),define(Re[58],Te([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$eM=e.$dM=e.$cM=e.$bM=void 0;class y{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new y(0,0)}with(s){return new y(0,0)}}e.$bM=y;class D{constructor(s,I,b,u){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(s,I),this.end=new y(b,u)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new D(0,0,0,0)}with(s){return new D(0,0,0,0)}}e.$cM=D;class P{constructor(s,I,b){this.uri=s,this.ranges=I,this.previewText=b}}e.$dM=P;class N{constructor(s,I,b){this.uri=s,this.text=I,this.lineNumber=b}}e.$eM=N;var R;(function(p){p[p.None=1]="None",p[p.FilesExclude=2]="FilesExclude",p[p.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(R||(e.ExcludeSettingOptions=R={}));var O;(function(p){p[p.Information=1]="Information",p[p.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(Re[44],Te([1,0,17,41,25,73,13,3,22,12,58,10]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=e.$CM=e.$vM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sM=e.$rM=e.$qM=e.$pM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.TextSearchCompleteMessageType=void 0,e.$mM=l,e.$nM=h,e.$oM=i,e.$tM=k,e.$uM=v,e.$wM=$,e.$xM=w,e.$yM=M,e.$zM=A,e.$AM=L,e.$BM=Z,e.$DM=U,e.$FM=ne,e.$GM=ue,e.$HM=ae,D=qe(D),P=qe(P),N=qe(N),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$fM="workbench.view.search",e.$gM="workbench.panel.search",e.$hM="workbench.view.search",e.$iM="search-result",e.$jM="search.exclude",e.$kM=2e4;const u="\u27EA ",E=" characters skipped \u27EB",f=(u.length+E.length+5)*2;e.$lM=(0,O.$Ii)("searchService");var r;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var c;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(c||(e.QueryType=c={}));function l(se){return!!se.rangeLocations&&!!se.previewText}function h(se){return!!se.resource}function i(se){return!!se.message}var n;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$pM=t;class o{constructor(ce,x,we,Ie){this.rangeLocations=[],this.webviewIndex=Ie;const Y=Array.isArray(x)?x:[x];if(we&&we.matchLines===1&&a(Y)){ce=(0,R.$ag)(ce,we.matchLines);let q="",ie=0,ve=0;const Pe=Math.floor(we.charsPerLine/5);for(const Fe of Y){const Be=Math.max(Fe.startColumn-Pe,0),xe=Fe.startColumn+we.charsPerLine;if(Be>ve+Pe+f){const nt=u+(Be-ve)+E;q+=nt+ce.slice(Be,xe),ie+=Be-(ve+nt.length)}else q+=ce.slice(ve,xe);ve=xe,this.rangeLocations.push({source:Fe,preview:new g(0,Fe.startColumn-ie,Fe.endColumn-ie)})}this.previewText=q}else{const q=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber,ie=(0,y.$3b)(x,ve=>({preview:new m(ve.startLineNumber-q,ve.startColumn,ve.endLineNumber-q,ve.endColumn),source:ve}));this.rangeLocations=Array.isArray(ie)?ie:[ie],this.previewText=ce}}}e.$qM=o;function a(se){const ce=se[0].startLineNumber;for(const x of se)if(x.startLineNumber!==ce||x.endLineNumber!==ce)return!1;return!0}class m{constructor(ce,x,we,Ie){this.startLineNumber=ce,this.startColumn=x,this.endLineNumber=we,this.endColumn=Ie}}e.$rM=m;class g extends m{constructor(ce,x,we){super(ce,x,ce,we)}}e.$sM=g;var d;(function(se){se.List="list",se.Tree="tree"})(d||(e.ViewMode=d={}));var S;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function k(se,ce=!0){const x=se&&se.files&&se.files.exclude,we=ce&&se&&se.search&&se.search.exclude;if(!x&&!we)return;if(!x||!we)return x||we||void 0;let Ie=Object.create(null);return Ie=P.$ko(Ie,P.$ho(x)),Ie=P.$ko(Ie,P.$ho(we),!0),Ie}function v(se,ce){return se.excludePattern&&D.$Ck(se.excludePattern,ce)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&D.$Ck(se.includePattern,ce)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(x=>{const we=x.folder.fsPath;if(N.$Hg(ce,we)){const Ie=p.$oc(we,ce);return!x.includePattern||!!D.$Ck(x.includePattern,Ie)}else return!1}):!1:!0}var C;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class T extends Error{constructor(ce,x){super(ce),this.code=x}}e.$vM=T;function $(se){const ce=se.message;if((0,s.$6)(se))return new T(ce,C.canceled);try{const x=JSON.parse(ce);return new T(x.message,x.code)}catch{return new T(ce,C.other)}}function w(se){const ce={message:se.message,code:se.code};return new Error(JSON.stringify(ce))}function M(se){return se.type==="error"?!0:se.type==="success"}function A(se){return se.type==="success"}function L(se){return!!se.path}function Z(se,ce,x=!0){const we=se.searchPath?se.searchPath:se.relativePath;return x?(0,R.$0f)(we,ce):D.$Ck(ce,we)}class J{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CM=J;function U(se,ce){const x={...se||{},...ce||{}};return Object.keys(x).filter(we=>{const Ie=x[we];return typeof Ie=="boolean"&&Ie})}class V{constructor(ce,x){this.c=null,this.a=x.excludePattern?.map(Ie=>({...ce.excludePattern||{},...Ie.pattern||{}}))??[],this.a.length===0&&(this.a=[ce.excludePattern||{}]),this.b=this.a.map(Ie=>D.$Dk(Ie));let we=ce.includePattern;x.includePattern&&(we?we={...we,...x.includePattern}:we=x.includePattern),we&&(this.c=D.$Dk(we))}d(ce,x,we){let Ie=null;for(const Y of this.b){const q=Y(ce,x,we);if(typeof q=="string"){Ie=q;break}}return Ie}matchesExcludesSync(ce,x,we){return!!(this.b&&this.d(ce,x,we))}includedInQuerySync(ce,x,we){return!(this.b&&this.d(ce,x,we)||this.c&&!this.c(ce,x,we))}includedInQuery(ce,x,we){const Ie=()=>this.c?!!this.c(ce,x,we):!0;return Promise.all(this.b.map(Y=>{const q=Y(ce,x,we);return(0,b.$uh)(q)?q.then(ie=>ie?!1:Ie()):Ie()})).then(Y=>Y.some(q=>!!q))}hasSiblingExcludeClauses(){return this.a.reduce((ce,x)=>Q(x)||ce,!1)}}e.$EM=V;function Q(se){for(const ce in se)if(typeof se[ce]!="boolean")return!0;return!1}function ne(se){if(!se)return;let ce;return x=>(ce||(ce=(se()||Promise.resolve([])).then(we=>we?_(we):{})),ce.then(we=>!!we[x]))}function ue(se){if(!se)return;let ce;return x=>{if(!ce){const we=se();ce=we?_(we):{}}return!!ce[x]}}function _(se){const ce={};for(const x of se)ce[x]=!0;return ce}function ae(se){return se.flatMap(ce=>ce.patterns.map(x=>ce.baseUri?{baseUri:ce.baseUri,pattern:x}:x))}}),define(Re[45],Te([1,0,17,10,19,6,4,48,15,141,24,13,2,9,28,3,11,173,49,50,26,16,8,7,65,44,5,33,58]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g,d,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=e.$Uqc=void 0;function v(Z,J,U){return new I.$$g(V=>w(V,U)).isEqual(Z,J)}function C(Z,J,U){return v(Z.uri,J.uri,U)?0:(0,b.$Bf)(Z.uri.toString(),J.uri.toString())}function T(Z,J,U){return Z.index!==J.index?Z.index<J.index?-1:1:v(Z.uri,J.uri,U)?(0,b.$Bf)(Z.name,J.name):(0,b.$Bf)(Z.uri.toString(),J.uri.toString())}function $(Z,J,U,V){const Q=Z.slice(0).sort((ue,_)=>U(ue,_,V)),ne=J.slice(0).sort((ue,_)=>U(ue,_,V));return(0,y.$Gb)(Q,ne,(ue,_)=>U(ue,_,V))}function w(Z,J){const U=J.getCapabilities(Z.scheme);return!(U&&U&f.FileSystemProviderCapabilities.PathCaseSensitive)}class M extends h.$2i{static toExtHostWorkspace(J,U,V,Q){if(!J)return{workspace:null,added:[],removed:[]};const{id:ne,name:ue,folders:_,configuration:ae,transient:se,isUntitled:ce}=J,x=[],we=U;U?_.forEach((ie,ve)=>{const Pe=u.URI.revive(ie.uri),Fe=M.o(V||U,Pe,Q);Fe?(Fe.name=ie.name,Fe.index=ie.index,x.push(Fe)):x.push({uri:Pe,name:ie.name,index:ve})}):x.push(..._.map(({uri:ie,name:ve,index:Pe})=>({uri:u.URI.revive(ie),name:ve,index:Pe}))),x.sort((ie,ve)=>ie.index<ve.index?-1:1);const Ie=new M(ne,ue,x,!!se,ae?u.URI.revive(ae):null,!!ce,ie=>w(ie,Q)),{added:Y,removed:q}=$(we?we.workspaceFolders:[],Ie.workspaceFolders,C,Q);return{workspace:Ie,added:Y,removed:q}}static o(J,U,V){for(let Q=0;Q<J.folders.length;Q++){const ne=J.workspaceFolders[Q];if(v(ne.uri,U,V))return ne}}constructor(J,U,V,Q,ne,ue,_){super(J,V.map(ae=>new h.$3i(ae)),Q,ne,_),this.t=U,this.u=ue,this.q=[],this.s=O.$Oi.forUris(_,()=>!0),V.forEach(ae=>{this.q.push(ae),this.s.set(ae.uri,ae)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(J,U){return U&&this.s.get(J)&&(J=(0,I.$ih)(J)),this.s.findSubstr(J)}resolveWorkspaceFolder(J){return this.s.get(J)}}let A=class{constructor(J,U,V,Q,ne){this.c=new N.$oe,this.onDidChangeWorkspace=this.c.event,this.g=new N.$oe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$qe,this.C=new Map,this.h=Q,this.s=V,this.t=ne,this.j=new s.$Qm,this.k=new D.$Hh,this.o=J.getProxy(d.$3N.MainThreadWorkspace),this.q=J.getProxy(d.$3N.MainThreadMessageService);const ue=U.workspace;this.l=ue?new M(ue.id,ue.name,[],!!ue.transient,ue.configuration?u.URI.revive(ue.configuration):null,!!ue.isUntitled,_=>w(_,V)):void 0}$initializeWorkspace(J,U){this.v=U,this.$acceptWorkspaceData(J),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,I.$gh)((0,I.$ih)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(J,U,V,...Q){const ne=[];if(Array.isArray(Q)&&Q.forEach(ce=>{u.URI.isUri(ce.uri)&&!ne.some(x=>v(x.uri,ce.uri,this.s))&&ne.push({uri:ce.uri,name:ce.name||(0,I.$fh)(ce.uri)})}),this.n||[U,V].some(ce=>typeof ce!="number"||ce<0)||V===0&&ne.length===0)return!1;const ue=this.x?this.x.workspaceFolders:[];if(U+V>ue.length)return!1;const _=ue.slice(0);_.splice(U,V,...ne.map(ce=>({uri:ce.uri,name:ce.name||(0,I.$fh)(ce.uri),index:void 0})));for(let ce=0;ce<_.length;ce++){const x=_[ce];if(_.some((we,Ie)=>Ie!==ce&&v(x.uri,we.uri,this.s)))return!1}_.forEach((ce,x)=>ce.index=x);const{added:ae,removed:se}=$(ue,_,T,this.s);if(ae.length===0&&se.length===0)return!1;if(this.o){const ce=J.displayName||J.name;this.o.$updateWorkspaceFolders(ce,U,V,ne).then(void 0,x=>{this.n=void 0;const we={source:{identifier:J.identifier,label:J.displayName||J.name}};this.q.$showMessage(l.Severity.Error,(0,E.localize)(2716,null,ce,x.toString()),we,[])})}return this.y(_),!0}getWorkspaceFolder(J,U){if(this.x)return this.x.getWorkspaceFolder(J,U)}async getWorkspaceFolder2(J,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(J,U)}async resolveWorkspaceFolder(J){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(J)}getPath(){if(!this.x)return;const{folders:J}=this.x;if(J.length!==0)return J[0].uri.fsPath}getRelativePath(J,U){let V,Q="";if(typeof J=="string"?(V=u.URI.file(J),Q=J):typeof J<"u"&&(V=J,Q=J.fsPath),!V)return Q;const ne=this.getWorkspaceFolder(V,!0);if(!ne)return Q;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ue=(0,I.$lh)(ne.uri,V);return U&&ne.name&&(ue=`${ne.name}/${ue}`),ue}y(J){this.x&&(this.n=M.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:J,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(J){const{workspace:U,added:V,removed:Q}=M.toExtHostWorkspace(J,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:V,removed:Q}))}findFiles(J,U,V,Q,ne=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let ue="",_=!0;return U===null?_=!1:U!==void 0&&(typeof U=="string"?ue=U:ue=U.pattern),this.z(J,void 0,{exclude:ue,maxResults:V,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ne)}findFiles2(J,U={},V,Q=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${V.value}, entryPoint: findFiles2`),this.z(void 0,J,U,Q)}async z(J,U,V,Q=P.CancellationToken.None){if(Q&&Q.isCancellationRequested)return Promise.resolve([]);const ne=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,ue={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof V.useDefaultSearchExcludes=="boolean"?!V.useDefaultSearchExcludes:!1,maxResults:V.maxResults,excludePattern:ne?[{pattern:ne}]:void 0,shouldGlobSearch:typeof V.fuzzy=="boolean"?!V.fuzzy:!0,_reason:"startFileSearch"},_=L(o.GlobPattern.from(J??U)),ae=_?.folder;return J?ue.includePattern=_?.pattern:ue.filePattern=_?.pattern,this.o.$startFileSearch(ae??null,ue,Q).then(se=>Array.isArray(se)?se.map(ce=>u.URI.revive(ce)):[])}findTextInFilesNew(J,U,V,Q){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${U.value}, entryPoint: findTextInFilesNew`);const ue=(V?.include?.map(se=>{const ce=L(o.GlobPattern.from(se)),x=(V.exclude?.map(we=>{if(typeof we=="string")return{pattern:we,uri:void 0};{const Ie=L(we);return Ie?{pattern:Ie.pattern,uri:Ie.folder}:void 0}})??[]).filter(we=>!!we);return{options:{ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useIgnoreFiles?.global=="boolean"?!V.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof V.useIgnoreFiles?.parent=="boolean"?!V.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:V.previewOptions?{matchLines:V.previewOptions?.numMatchLines??100,charsPerLine:V.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:V.surroundingContext,includePattern:ce?.pattern,excludePattern:x},folder:ce?.folder}})??[]).filter(se=>!!se),_=Promise.resolve(void 0);return{results:new D.$9h(async se=>{const ce=(x,we)=>((0,g.$mM)(x)?se.emitOne(new k.$dM(we,x.rangeLocations.map(Ie=>({previewRange:new a.$7N(Ie.preview.startLineNumber,Ie.preview.startColumn,Ie.preview.endLineNumber,Ie.preview.endColumn),sourceRange:new a.$7N(Ie.source.startLineNumber,Ie.source.startColumn,Ie.source.endLineNumber,Ie.source.endColumn)})),x.previewText)):se.emitOne(new k.$eM(we,x.text,x.lineNumber)),x);await _.then(x=>this.findTextInFilesBase(J,ue,ce,Q))}),complete:_.then(se=>({limitHit:se?.limitHit??!1}))}}async findTextInFilesBase(J,U,V,Q=P.CancellationToken.None){const ne=this.j.getNext(),ue=!1;if(this.u[ne]=_=>{if(ue)return;const ae=u.URI.revive(_.resource);_.results.forEach(se=>{const ce=(0,S.$fi)(se);V(ce,ae)})},Q.isCancellationRequested)return{};try{const _=await Promise.all(U?.map(ae=>this.o.$startTextSearch(J,ae.folder??null,ae.options,ne,Q)||{})??[]);return delete this.u[ne],_.reduce((ae,se)=>({limitHit:ae?.limitHit||(se?.limitHit??!1),message:[ae?.message??[],se?.message??[]].flat()}),{})??{limitHit:!1}}catch(_){throw delete this.u[ne],_}}async findTextInFiles(J,U,V,Q,ne=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const ue=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,_=L(o.GlobPattern.from(U.include)),ae=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,se={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ue,surroundingContext:U.afterContext,includePattern:_?.pattern,excludePattern:ae?[{pattern:ae}]:void 0},ce=(x,we)=>{(0,g.$mM)(x)?V({uri:we,preview:{text:x.previewText,matches:(0,y.$3b)(x.rangeLocations,Ie=>new a.$7N(Ie.preview.startLineNumber,Ie.preview.startColumn,Ie.preview.endLineNumber,Ie.preview.endColumn))},ranges:(0,y.$3b)(x.rangeLocations,Ie=>new a.$7N(Ie.source.startLineNumber,Ie.source.startColumn,Ie.source.endLineNumber,Ie.source.endColumn))}):V({uri:we,text:x.text,lineNumber:x.lineNumber})};return this.findTextInFilesBase(J,[{options:se,folder:_?.folder}],ce,ne)}$handleTextSearchResult(J,U){this.u[U]?.(J)}async save(J){const U=await this.o.$save(J,{saveAs:!1});return u.URI.revive(U)}async saveAs(J){const U=await this.o.$save(J,{saveAs:!0});return u.URI.revive(U)}saveAll(J){return this.o.$saveAll(J)}resolveProxy(J){return this.o.$resolveProxy(J)}lookupAuthorization(J){return this.o.$lookupAuthorization(J)}lookupKerberosAuthorization(J){return this.o.$lookupKerberosAuthorization(J)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(J){return this.o.$requestWorkspaceTrust(J)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(J,U){if(this.w.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.w.set(J,U);const V=this.t.transformOutgoingScheme(J),Q=this.A++;return this.o.$registerEditSessionIdentityProvider(Q,V),(0,R.$Vc)(()=>{this.w.delete(J),this.o.$unregisterEditSessionIdentityProvider(Q)})}async $getEditSessionIdentifier(J,U){this.h.info("Getting edit session identifier for workspaceFolder",J);const V=await this.resolveWorkspaceFolder(u.URI.revive(J));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const Q=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!Q),!Q)return;const ne=await Q.provideEditSessionIdentity(V,U);if(this.h.info("Provider returned edit session identifier: ",ne),!!ne)return ne}async $provideEditSessionIdentityMatch(J,U,V,Q){this.h.info("Getting edit session identifier for workspaceFolder",J);const ne=await this.resolveWorkspaceFolder(u.URI.revive(J));if(!ne){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ne);const ue=this.w.get(ne.uri.scheme);if(this.h.info(`Provider for scheme ${ne.uri.scheme} is defined: `,!!ue),!ue)return;const _=await ue.provideEditSessionIdentityMatch?.(U,V,Q);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(J){return(U,V,Q)=>{const ne=function(_){U.call(V,_)};return ne.extension=J,this.B.event(ne,void 0,Q)}}async $onWillCreateEditSessionIdentity(J,U,V){const Q=await this.resolveWorkspaceFolder(u.URI.revive(J));if(Q===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:Q},U,async(ne,ue)=>{const _=Date.now();await Promise.resolve(ne),Date.now()-_>V&&this.h.warn("SLOW edit session create-participant",ue.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(J,U){if(this.C.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.C.set(J,U);const V=this.t.transformOutgoingScheme(J),Q=this.A++;return this.o.$registerCanonicalUriProvider(Q,V),(0,R.$Vc)(()=>{this.C.delete(J),this.o.$unregisterCanonicalUriProvider(Q)})}async provideCanonicalUri(J,U,V){const Q=this.C.get(J.scheme);if(!Q)return;const ne=await Q.provideCanonicalUri?.(u.URI.revive(J),U,V);if(ne)return ne}async $provideCanonicalUri(J,U,V){return this.provideCanonicalUri(u.URI.revive(J),{targetScheme:U},V)}};e.$Uqc=A,e.$Uqc=A=Ke([We(0,t.$DQ),We(1,n.$TQ),We(2,i.$Dqc),We(3,c.$dk),We(4,m.$Sqc)],A),e.$Vqc=(0,r.$Ii)("IExtHostWorkspace");function L(Z){let J,U;if(Z)return typeof Z=="string"?J=Z:(J=Z.pattern,U=u.URI.revive(Z.baseUri)),{pattern:J,folder:U}}}),define(Re[46],Te([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=e.$Xqc=e.$Wqc=void 0;function c(m,g){if(g){const d=g.split(".");let S=m;for(let k=0;S&&k<d.length;k++)S=S[d[k]];return S}}function l(m){return m instanceof r.URI}function h(m){return m&&m.uri instanceof r.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function n(m){return m&&m.uri instanceof r.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(l(m))return{resource:m};if(h(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(n(m))return{resource:m.uri};if(m===null)return{resource:null}}let o=class{constructor(g,d,S){this.a=g.getProxy(N.$3N.MainThreadConfiguration),this.c=d,this.b=S,this.d=new b.$Hh,this.e=null}getConfigProvider(){return this.d.wait().then(g=>this.e)}$initializeConfiguration(g){this.e=new a(this.a,this.c,g,this.b),this.d.open()}$acceptConfigurationChanged(g,d){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(g,d))}};e.$Wqc=o,e.$Wqc=o=Ke([We(0,E.$DQ),We(1,P.$Vqc),We(2,f.$dk)],o);class a{constructor(g,d,S,k){this.a=new D.$oe,this.b=g,this.f=k,this.c=d,this.e=p.$Uo.parse(S,k),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(g,d){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Uo.parse(g,this.f),this.d=this.k(g.configurationScopes),this.a.fire(this.j(d,S))}getConfiguration(g,d,S){const k=t(d)||{},v=this.g(g?c(this.e.getValue(void 0,k,this.c.workspace),g):this.e.getValue(void 0,k,this.c.workspace));g&&this.h(g,k,S?.identifier);function C($){if($==null)return null;if(typeof $=="boolean")return $?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch($){case R.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const T={has($){return typeof c(v,$)<"u"},get:($,w)=>{this.h(g?`${g}.${$}`:$,k,S?.identifier);let M=c(v,$);if(typeof M>"u")M=w;else{let A;const L=(Z,J)=>{if((0,I.$jg)(Z)){let U;const V=()=>{A=A||(0,y.$ho)(v),U=U||c(A,J)};return new Proxy(Z,{get:(Q,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return V(),()=>U;if(A)return U=U||c(A,J),U[ne];const ue=Q[ne];return typeof ne=="string"?L(ue,`${J}.${ne}`):ue},set:(Q,ne,ue)=>(V(),U&&(U[ne]=ue),!0),deleteProperty:(Q,ne)=>(V(),U&&delete U[ne],!0),defineProperty:(Q,ne,ue)=>(V(),U&&Object.defineProperty(U,ne,ue),!0)})}return Array.isArray(Z)?(0,y.$ho)(Z):Z};M=L(M,$)}return M},update:($,w,M,A)=>{$=g?`${g}.${$}`:$;const L=C(M);return w!==void 0?this.b.$updateConfigurationOption(L,$,w,k,A):this.b.$removeConfigurationOption(L,$,k,A)},inspect:$=>{$=g?`${g}.${$}`:$;const w=this.e.inspect($,k,this.c.workspace);if(w)return{key:$,defaultValue:(0,y.$ho)(w.policy?.value??w.default?.value),globalValue:(0,y.$ho)(w.user?.value??w.application?.value),workspaceValue:(0,y.$ho)(w.workspace?.value),workspaceFolderValue:(0,y.$ho)(w.workspaceFolder?.value),defaultLanguageValue:(0,y.$ho)(w.default?.override),globalLanguageValue:(0,y.$ho)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,y.$ho)(w.workspace?.override),workspaceFolderLanguageValue:(0,y.$ho)(w.workspaceFolder?.override),languageIds:(0,y.$ho)(w.overrideIdentifiers)}}};return typeof v=="object"&&(0,y.$ko)(T,v,!1),Object.freeze(T)}g(g){const d=S=>(0,I.$jg)(S)?new Proxy(S,{get:(k,v)=>d(k[v]),set:(k,v,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(k,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(k,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return d(g)}h(g,d,S){const k=s.$Jo.test(g)?s.ConfigurationScope.RESOURCE:this.d.get(g),v=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===k){typeof d?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${g}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===k){d?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${g}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(g,d){const S=new p.$Wo(g,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,v)=>S.affectsConfiguration(k,t(v))})}k(g){return g.reduce((d,S)=>(d.set(S[0],S[1]),d),new Map)}}e.$Xqc=a,e.$Yqc=(0,u.$Ii)("IExtHostConfiguration")}),define(Re[132],Te([1,0,2,10,6,5,7,45,57,46,19,56,16,26,3,15,23,11,85,208,12]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=e.$Asc=e.$zsc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=qe(R),c=qe(c);var t;(function(A){function L(J){if(J!=null)return J}A.from=L;function Z(J){if(J!=null)return J}A.to=Z})(t||(t={}));var o;(function(A){function L(J){if(J!=null)return J}A.from=L;function Z(J){if(J!=null)return J}A.to=Z})(o||(o={}));var a;(function(A){function L(J){if(J!=null)return J}A.from=L;function Z(J){if(J!=null)return J}A.to=Z})(a||(a={}));var m;(function(A){function L(U){if(U){const V=U;return V&&!!V.process}else return!1}A.is=L;function Z(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=a.from(U.options)),V}A.from=Z;function J(U){if(U!=null)return new R.$QO(U.process,U.args,U.options)}A.to=J})(m||(m={}));var g;(function(A){function L(J){if(J!=null)return J}A.from=L;function Z(J){if(J!=null)return J}A.to=Z})(g||(g={}));var d;(function(A){function L(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}A.is=L;function Z(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=g.from(U.options)),V}A.from=Z;function J(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.$RO(U.commandLine,U.options):new R.$RO(U.command,U.args?U.args:[],U.options)}A.to=J})(d||(d={}));var S;(function(A){function L(U){if(U){const V=U;return V&&V.customExecution==="customExecution"}else return!1}A.is=L;function Z(U){return{customExecution:"customExecution"}}A.from=Z;function J(U,V){return V.get(U)}A.to=J})(S||(e.CustomExecutionDTO=S={}));var k;(function(A){function L(Z,J){let U;return Z.scope!==void 0&&typeof Z.scope!="number"?U=Z.scope.uri:Z.scope!==void 0&&typeof Z.scope=="number"&&(Z.scope===R.TaskScope.Workspace&&J&&J.workspaceFile?U=J.workspaceFile:U=i.$aJ),{id:Z._id,workspaceFolder:U}}A.from=L})(k||(e.TaskHandleDTO=k={}));var v;(function(A){function L(Z){if(Z!=null)return{_id:Z.id,isDefault:Z.isDefault}}A.from=L})(v||(v={}));var C;(function(A){function L(U,V){if(U==null)return[];const Q=[];for(const ne of U){const ue=Z(ne,V);ue&&Q.push(ue)}return Q}A.fromMany=L;function Z(U,V){if(U==null)return;let Q;U.execution instanceof R.$QO?Q=m.from(U.execution):U.execution instanceof R.$RO?Q=d.from(U.execution):U.execution&&U.execution instanceof R.$SO&&(Q=S.from(U.execution));const ne=t.from(U.definition);let ue;return U.scope?typeof U.scope=="number"?ue=U.scope:ue=U.scope.uri:ue=R.TaskScope.Workspace,!ne||!ue?void 0:{_id:U._id,definition:ne,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:ue},execution:Q,isBackground:U.isBackground,group:v.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}A.from=Z;async function J(U,V,Q){if(U==null)return;let ne;m.is(U.execution)?ne=m.to(U.execution):d.is(U.execution)?ne=d.to(U.execution):S.is(U.execution)&&(ne=S.to(U._id,Q));const ue=t.to(U.definition);let _;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?_=U.source.scope:_=await V.resolveWorkspaceFolder(y.URI.revive(U.source.scope)):_=R.TaskScope.Workspace),!ue||!_)return;const ae=new R.$TO(ue,_,U.name,U.source.label,ne,U.problemMatchers);return U.isBackground!==void 0&&(ae.isBackground=U.isBackground),U.group!==void 0&&(ae.group=R.$PO.from(U.group._id),ae.group&&U.group.isDefault&&(ae.group=new R.$PO(ae.group.id,ae.group.label),U.group.isDefault===!0&&(ae.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ae.presentationOptions=o.to(U.presentationOptions)),U._id&&(ae._id=U._id),U.detail&&(ae.detail=U.detail),ae}A.to=J})(C||(e.TaskDTO=C={}));var T;(function(A){function L(J){return J}A.from=L;function Z(J){if(J)return Object.assign(Object.create(null),J)}A.to=Z})(T||(T={}));class ${#e;constructor(L,Z,J){this._id=Z,this.a=J,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,Z,J,U,V,Q,ne,ue){this.q=new P.$oe,this.r=new P.$oe,this.s=new P.$oe,this.u=new P.$oe,this.a=L.getProxy(N.$3N.MainThreadTask),this.b=J,this.c=U,this.d=V,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=ue,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,Z,J){if(!J)return new R.$5N(()=>{});const U=this.x();return this.j.set(U,{type:Z,provider:J,extension:L}),this.a.$registerTaskProvider(U,Z),new R.$5N(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(L,Z){this.a.$registerTaskSystem(L,Z)}fetchTasks(L){return this.a.$fetchTasks(T.from(L)).then(async Z=>{const J=[];for(const U of Z){const V=await C.to(U,this.b,this.m);V&&J.push(V)}return J})}get taskExecutions(){const L=[];return this.k.forEach(Z=>L.push(Z)),L}terminateTask(L){if(!(L instanceof $))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,Z,J){const U=this.m.get(L.id);U&&(this.o.set(L.id,U),this.e.attachPtyToTerminal(Z,await U.callback(J))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const Z=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:Z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const Z=await this.z(L.id);this.s.fire({execution:Z,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const Z=await this.z(L.id);this.u.fire({execution:Z,exitCode:L.exitCode})}$provideTasks(L,Z){const J=this.j.get(L);if(!J)return Promise.reject(new Error("no handler found"));const U=[],V=(0,D.$Ah)(()=>J.provider.provideTasks(I.CancellationToken.None)).then(Q=>this.v(Z,U,J,Q));return new Promise(Q=>{V.then(ne=>{Promise.all(U).then(()=>{Q(ne)})})})}async $resolveTask(L,Z){const J=this.j.get(L);if(!J)return Promise.reject(new Error("no handler found"));if(Z.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${Z.definition.type}] cannot be resolved by provider of type [${J.type}].`);const U=await C.to(Z,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await J.provider.resolveTask(U,I.CancellationToken.None);if(!V)return;this.A(V,J);const Q=C.from(V,J.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(Q.execution)&&await this.y(Q,V,!0),await this.w(Q)}x(){return this.h++}async y(L,Z,J){const U=await this.a.$createTaskId(L);!J&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,Z.execution)),this.m.set(U,Z.execution)}async z(L,Z){if(typeof L=="string"){const V=this.l.get(L);if(!V)throw new n.$db("Unexpected: The specified task is missing an execution");return V}const J=this.l.get(L.id);if(J)return J;let U;return Z?U=Promise.resolve(new $(this,L.id,Z)):U=C.to(L.task,this.b,this.m).then(V=>{if(!V)throw new n.$db("Unexpected: Task does not exist.");return new $(this,L.id,V)}),this.l.set(L.id,U),U.then(V=>(this.k.set(L.id,V),V))}A(L,Z){L._deprecated&&this.g.report("Task.constructor",Z.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const J=this.n.values();let U=J.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=J.next()}};e.$zsc=w,e.$zsc=w=Ke([We(0,u.$DQ),We(1,E.$TQ),We(2,O.$Vqc),We(3,p.$OQ),We(4,s.$Yqc),We(5,b.$krc),We(6,l.$dk),We(7,h.$zqc)],w);let M=class extends w{constructor(L,Z,J,U,V,Q,ne,ue){super(L,Z,J,U,V,Q,ne,ue),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:c.$i(c.Platform.Web)})}async executeTask(L,Z){if(!Z.execution)throw new Error("Tasks to execute must include an execution");const J=C.from(Z,L);if(J===void 0)throw new Error("Task is not valid");if(S.is(J.execution))await this.y(J,Z,!1);else throw new n.$bb;const U=await this.z(await this.a.$getTaskExecution(J),Z);return this.a.$executeTask(J).catch(V=>{throw new Error(V)}),U}v(L,Z,J,U){const V=[];if(U)for(const Q of U){if(this.A(Q,J),!Q.definition||!L[Q.definition.type]){const ue=Q.source?Q.source:"No task source";this.f.warn(`The task [${ue}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=C.from(Q,J.extension);ne&&S.is(ne.execution)?(V.push(ne),Z.push(this.y(ne,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:J.extension}}async w(L){if(S.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,Z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,Z,J){}};e.$Asc=M,e.$Asc=M=Ke([We(0,u.$DQ),We(1,E.$TQ),We(2,O.$Vqc),We(3,p.$OQ),We(4,s.$Yqc),We(5,b.$krc),We(6,l.$dk),We(7,h.$zqc)],M),e.$Bsc=(0,f.$Ii)("IExtHostTask")}),define(Re[267],Te([1,0,44,32]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$NM=P,e.$PM=N;function P(R){return"cellResults"in R}e.$OM="rawCell#";function N(R,O){let p=-1;const s=[];let I=[];return R.forEach(u=>{u.range.startLineNumber!==p&&I.length>0&&(s.push([...I]),I=[]),I.push(u),p=u.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(u=>{const E=[],f=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let c=f;c<=r;c++)E.push(O.getLineContent(c));return new y.$qM(E.join(`
`)+`
`,u.map(c=>new D.$Tt(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}}),define(Re[268],Te([1,0,9,20,6,4,27,37,13,14,2,28,80,5,34,8,7,39,245,126,25,15,44,198,267,265]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=void 0,b=qe(b),r=qe(r),c=qe(c);class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,v,C,T,$,w,M){this.q=C,this.r=T,this.s=$,this.t=w,this.u=M,this.f=new Map,this.g=new R.$Dc,this.h=new Map,this.j=new P.$oe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$oe,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$oe,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$oe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$xqc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(E.$3N.MainThreadNotebook),this.c=k.getProxy(E.$3N.MainThreadNotebookDocuments),this.d=k.getProxy(E.$3N.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===O.MarshalledId.NotebookCellActionContext){const L=A.notebookEditor?.notebookUri,Z=A.cell.handle,U=this.g.get(L)?.getCell(Z);if(U)return U.apiCell}if(A&&A.$mid===O.MarshalledId.NotebookActionContext){const L=A.uri,Z=this.g.get(L);if(Z)return Z.apiNotebook}return A}}),d.C(v)}getEditorById(k){const v=this.h.get(k);if(!v)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(k){for(const[v,C]of this.h)if(C.apiEditor===k)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,v){const C=this.g.get(k);if(!C&&!v)throw new Error(`NO notebook document for '${k}'`);return C}static w(k,v){if(!v)return;const C=v.filenamePattern.map(T=>r.NotebookExclusiveDocumentPattern.from(T)).filter(T=>T!==void 0);if(v.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:v.displayName,filenamePattern:C,priority:v.exclusive?g.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(k,v,C){const T=d.a++,$=typeof C.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(T,C),this.b.$registerNotebookCellStatusBarItemProvider(T,$,v);let w;return $!==void 0&&(w=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent($))),new c.$5N(()=>{this.f.delete(T),this.b.$unregisterNotebookCellStatusBarItemProvider(T,$),w?.dispose()})}async createNotebookDocument(k){const v=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&r.NotebookData.from(k.content)});return I.URI.revive(v)}async openNotebookDocument(k){const v=this.g.get(k);if(v)return v.apiNotebook;const C=await this.c.$tryOpenNotebook(k),T=this.g.get(I.URI.revive(C));return(0,s.$sg)(T?.apiNotebook)}async showNotebookDocument(k,v){let C;typeof v=="object"?C={position:r.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(r.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0,label:v?.label}:C={preserveFocus:!1,pinned:!0};const T=v?.asRepl?"repl":k.notebookType,$=await this.d.$tryShowNotebookDocument(k.uri,T,C),w=$&&this.h.get($)?.apiEditor;if(w)return w;throw $?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,v,C,T){const $=this.f.get(k),w=I.URI.revive(v),M=this.g.get(w);if(!M||!$)return;const A=M.getCellFromIndex(C);if(!A)return;const L=await $.provideCellStatusBarItems(A.apiCell,T);if(!L)return;const Z=new N.$Wc,J=this.p.add([Z]),V=(Array.isArray(L)?L:[L]).map(Q=>r.NotebookStatusBarItem.from(Q,this.i,Z));return{cacheId:J,items:V}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,v,C,T,$){if((0,p.$ff)(v))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:v,serializer:C,options:T}),this.b.$registerNotebookSerializer(w,{id:k.identifier,location:k.extensionLocation},v,r.NotebookDocumentContentOptions.from(T),d.w(k,$)),(0,N.$Vc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(k,v,C){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const $=await T.serializer.deserializeNotebook(v.buffer,C);return new l.$4w(r.NotebookData.from($))}async $notebookToData(k,v,C){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const $=await T.serializer.serializeNotebook(r.NotebookData.to(v.value),C);return D.$Qe.wrap($)}async $saveNotebook(k,v,C,T,$){const w=I.URI.revive(v),M=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${C}, ${w.toString()})`),!M)throw new Error("NO serializer found");const A=this.g.get(w);if(!A)throw new Error("Document NOT found");if(A.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new b.$yl((0,y.localize)(2707,null,this.A(w)),b.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,n.$po)(A.apiNotebook.metadata,Q=>!(M.options?.transientDocumentMetadata??{})[Q]),cells:[]};for(const Q of A.apiNotebook.getCells()){const ne=new c.$xP(Q.kind,Q.document.getText(),Q.document.languageId,Q.mime,M.options?.transientOutputs?[]:[...Q.outputs],Q.metadata,Q.executionSummary);ne.metadata=(0,n.$po)(Q.metadata,ue=>!(M.options?.transientCellMetadata??{})[ue]),L.cells.push(ne)}if(await this.z(w,T),$.isCancellationRequested)throw new Error("canceled");const Z=await M.serializer.serializeNotebook(L,$);if($.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${w.toString()}`),await this.s.value.writeFile(w,Z),this.D(`Finished write versionId: ${C} ${w.toString()}`);const J=this.s.getFileSystemProviderExtUri(w.scheme),U=await this.s.value.stat(w),V={name:J.basename(w),isFile:(U.type&b.FileType.File)!==0,isDirectory:(U.type&b.FileType.Directory)!==0,isSymbolicLink:(U.type&b.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&b.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((U.permissions??0)&b.FilePermission.Locked),etag:b.$Jl({mtime:U.mtime,size:U.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${w.toString()})`),V}async $searchInNotebooks(k,v,C,T,$){const w=this.y.get(k)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new R.$Ec;await(async(U,V,Q)=>{await Promise.all(U.map(async ne=>await Promise.all(ne.filenamePatterns.map(ue=>{const _={_reason:Q._reason,folderQueries:Q.folderQueries,includePattern:Q.includePattern,excludePattern:Q.excludePattern,maxResults:Q.maxResults,type:o.QueryType.File,filePattern:ue};return this.t.doInternalFileSearchWithCustomCallback(_,V,ae=>{ae.forEach(se=>{M.has(se)||T.some(x=>ne.isFromSettings&&!x.isFromSettings?!1:x.filenamePatterns.some(we=>(0,g.$HL)(we,se)))||M.add(se)})}).catch(ae=>{if(ae.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ae})}))))})(C,$,v);const L=new R.$Dc;let Z=!1;const J=Array.from(M).map(async U=>{const V=[];try{if($.isCancellationRequested)return;if(v.maxResults&&[...L.values()].reduce((_,ae)=>_+ae.cellResults.length,0)>v.maxResults){Z=!0;return}const Q=[],ne=this.g.get(U);if(ne)ne.apiNotebook.getCells().forEach(ae=>Q.push({input:ae.document.getText(),outputs:ae.outputs.flatMap(se=>se.items.map(ce=>ce.data.toString()))}));else{const _=await this.s.value.readFile(U),ae=D.$Qe.fromString(_.toString()),se=await w.deserializeNotebook(ae.buffer,$);if($.isCancellationRequested)return;r.NotebookData.from(se).cells.forEach(x=>Q.push({input:x.source,outputs:x.outputs.flatMap(we=>we.items.map(Ie=>Ie.valueBytes.toString()))}))}if($.isCancellationRequested)return;Q.forEach((_,ae)=>{const se=v.contentPattern.pattern,ce=new a.$t2b(_.input,void 0,_.outputs),x=ce.findInInputs(se),we=ce.findInOutputs(se),Ie=we.flatMap(Y=>(0,m.$PM)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(x.length>0||we.length>0){const Y={index:ae,contentResults:(0,m.$PM)(x,ce.inputTextBuffer),webviewResults:Ie};V.push(Y)}});const ue={resource:U,cellResults:V};L.set(U,ue);return}catch{return}});return await Promise.all(J),{limitHit:Z,results:[...L.values()]}}async z(k,v){const C=await this.s.value.stat(k);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==b.$Il&&typeof C.mtime=="number"&&typeof C.size=="number"&&v.mtime<C.mtime&&v.etag!==b.$Jl({mtime:v.mtime,size:C.size}))throw new b.$yl((0,y.localize)(2708,null),b.FileOperationResult.FILE_MODIFIED_SINCE,v)}A(k){return k.scheme===t.Schemas.file?k.fsPath:k.toString()}B(k,v,C){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const T=new i.$Zrc(v,this.d,k,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(v,T)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const C of k.value.removedDocuments){const T=I.URI.revive(C),$=this.g.get(T);$&&($.dispose(),this.g.delete(T),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire($.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===T.toString()&&this.h.delete(w.id)}if(k.value.addedDocuments){const C=[];for(const T of k.value.addedDocuments){const $=I.URI.revive(T.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const w=new h.$Yrc(this.c,this.q,this.r,$,T);C.push(...T.cells.map(M=>h.$Xrc.asModelAddData(M))),this.g.get($)?.dispose(),this.g.set($,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(w.apiNotebook)}}if(k.value.addedEditors)for(const C of k.value.addedEditors){if(this.h.has(C.id))return;const T=I.URI.revive(C.documentUri),$=this.g.get(T);$&&this.B($,C.id,C)}const v=[];if(k.value.removedEditors)for(const C of k.value.removedEditors){const T=this.h.get(C);T&&(this.h.delete(C),this.k?.id===T.id&&(this.k=void 0),v.push(T))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(T=>this.h.get(T)).filter(T=>!!T);const C=new Set;this.l.forEach(T=>C.add(T.id));for(const T of this.h.values()){const $=C.has(T.id);T._acceptVisibility($)}this.l=[...this.h.values()].map(T=>T).filter(T=>T.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const v=f.$2Q.String.with("notebookType","A notebook type"),C=new f.$4Q("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new f.$2Q("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>D.$Qe.wrap($))],new f.$3Q("Notebook Data",$=>r.NotebookData.to($.value))),T=new f.$4Q("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new f.$2Q("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new l.$4w(r.NotebookData.from($)))],new f.$3Q("Bytes",$=>$.buffer));k.registerApiCommand(C),k.registerApiCommand(T)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$bsc=d}),define(Re[269],Te([1,0,22,19,42,41,24,69,44,48]),function($e,e,y,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rc=void 0,y=qe(y),N=qe(N),R=qe(R);class I{constructor(E,f,r){this.l=E,this.o=f,this.p=r,this.f=!1,this.g=0,this.h=!1,this.a=E.filePattern,this.b=E.includePattern&&N.$Dk(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.j=new Set,this.k=E.excludePattern&&N.$Dk(E.excludePattern)}cancel(){this.h=!0,this.j.forEach(E=>E.cancel()),this.j=new Set}search(E){const f=this.l.folderQueries||[];return new Promise((r,c)=>{const l=h=>{this.g++,E(h)};if(this.h)return r({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(h=>{const i=h.toString(),n=y.$qc(i);this.k&&this.k(i,n)||this.w(l,{base:h,basename:n})}),this.q(f,l).then(h=>{r({limitHit:this.f,stats:h||void 0})},h=>{c(new Error((0,P.$tj)(h)))})})}async q(E,f){const r=new D.$ze,l={folderOptions:E.map(n=>this.r(n)),maxResults:this.l.maxResults??p.$kM,session:this.p},h=s.$Oi.forUris();E.forEach(n=>{const t=new p.$EM(this.l,n),o=!t.hasSiblingExcludeClauses();h.set(n.folder,{queryTester:t,noSiblingsClauses:o,folder:n.folder,tree:this.s()})});let i;try{this.j.add(r),i=O.$ie.create();const n=await this.o.provideFileSearchResults(this.l.filePattern||"",l,r.token),t=i.elapsed(),o=O.$ie.create();return this.h&&!this.f||(n&&n.forEach(a=>{const m=h.findSubstr(a),g=y.$jc.relative(m.folder.path,a.path);if(m.noSiblingsClauses){const d=y.$qc(a.path);this.w(f,{base:m.folder,relativePath:g,basename:d});return}this.u(m.tree,m.folder,g,f)}),this.h&&!this.f)?null:(h.forEach(a=>{this.v(a.tree,a.queryTester,f)}),{providerTime:t,postProcessTime:o.elapsed()})}finally{r.dispose(),this.j.delete(r)}}r(E){const f=(0,p.$DM)(this.l.includePattern,E.includePattern);let r=E.excludePattern?.map(l=>({folder:l.folder,patterns:(0,p.$DM)(this.l.excludePattern,l.pattern)}));r?.length||(r=[{folder:void 0,patterns:(0,p.$DM)(this.l.excludePattern,void 0)}]);const c=(0,p.$HM)(r);return{folder:E.folder,excludes:c,includes:f,useIgnoreFiles:{local:!E.disregardIgnoreFiles,parent:!E.disregardParentIgnoreFiles,global:!E.disregardGlobalIgnoreFiles},followSymlinks:!E.ignoreSymlinks}}s(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}u({pathToEntries:E},f,r,c){if(r===this.a){const h=y.$qc(this.a);this.w(c,{base:f,relativePath:this.a,basename:h})}function l(h){const i=y.$qc(h),n=y.$pc(h);let t=E[n];t||(t=E[n]=[],l(n)),t.push({base:f,relativePath:h,basename:i})}l(r)}v({rootEntries:E,pathToEntries:f},r,c){const l=this,h=this.a;function i(n){const t=(0,p.$GM)(()=>n.map(o=>o.basename));for(let o=0,a=n.length;o<a;o++){const m=n[o],{relativePath:g,basename:d}=m;if(r.matchesExcludesSync(g,d,h!==d?t:void 0))continue;const S=f[g];if(S)i(S);else{if(g===h)continue;l.w(c,m)}if(l.f)break}}i(E)}w(E,f){(!this.b||f.relativePath&&this.b(f.relativePath,f.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||E(f))}}class b{constructor(){this.b=new Map}static{this.a=512}fileSearch(E,f,r,c){const l=this.c(E.cacheKey),h=new I(E,f,l&&l.token);let i=0;const n=t=>{i+=t.length,r(t.map(o=>this.d(o)))};return this.f(h,b.a,n,c).then(t=>({limitHit:t.limitHit,stats:t.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:t.stats}:void 0,messages:[]}))}clearCache(E){this.c(E)?.cancel()}c(E){if(E)return this.b.has(E)||this.b.set(E,new D.$ze),this.b.get(E)}d(E){return E.relativePath?{resource:R.$jh(E.base,E.relativePath)}:{resource:E.base}}f(E,f,r,c){const l=c.onCancellationRequested(()=>{E.cancel()}),h=n=>{n&&(i.push(n),f>0&&i.length>=f&&(r(i),i=[]))};let i=[];return E.search(h).then(n=>(i.length&&r(i),l.dispose(),n),n=>(i.length&&r(i),l.dispose(),Promise.reject(n)))}}e.$1rc=b}),define(Re[270],Te([1,0,17,239,41,100,27,15,22,24,13,14,2,103,9,43,11,114,49,120,266,44]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0,e.$EN=o,e.$FN=a,e.$HN=$,y=qe(y),D=qe(D),P=qe(P),p=qe(p),I=qe(I),f=qe(f);function o(w){return typeof w=="object"&&"uri"in w&&"pattern"in w}function a(w){return typeof w=="string"?{pattern:w}:{pattern:w.pattern,uri:w.baseUri}}let m=class{constructor(M,A,L,Z,J,U){this.a=M,this.b=A,this.c=L,this.d=Z,this.f=J,this.g=U}text(M,A,L={}){M=this.h(M,L);const Z=this.a.getValue(),J=A&&A.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.j(A?.map(h.$4i),L),type:t.QueryType.Text,contentPattern:M,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:Z.search.usePCRE2||J||!1,surroundingContext:L.surroundingContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}h(M,A){const L=this.a.getValue();M.isRegExp&&(M.pattern=M.pattern.replace(/\r?\n/g,"\\n"));const Z={...M,wordSeparators:L.editor.wordSeparators};return this.l(M,A)&&(Z.isCaseSensitive=!0),this.m(M)&&(Z.isMultiline=!0),A.notebookSearchConfig?.includeMarkupInput&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookMarkdownInput=A.notebookSearchConfig.includeMarkupInput),A.notebookSearchConfig?.includeMarkupPreview&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookMarkdownPreview=A.notebookSearchConfig.includeMarkupPreview),A.notebookSearchConfig?.includeCodeInput&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookCellInput=A.notebookSearchConfig.includeCodeInput),A.notebookSearchConfig?.includeOutput&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookCellOutput=A.notebookSearchConfig.includeOutput),Z}file(M,A={}){return{...this.j(M,A),type:t.QueryType.File,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey,shouldGlobMatchFilePattern:A.shouldGlobSearch}}i(M,A){if(!M)return{};if(Array.isArray(M)){if(M=M.filter(L=>L.length>0).map(v),!M.length)return{}}else M=v(M);return A?this.parseSearchPaths(M):{pattern:d(...Array.isArray(M)?M:[M])}}j(M=[],A={}){const L=Array.isArray(A.excludePattern)?A.excludePattern.map(ue=>ue.pattern).flat():A.excludePattern,Z=this.i(A.includePattern,A.expandPatterns),J=this.i(L,A.expandPatterns),U=M.length>1,V=(Z.searchPaths&&Z.searchPaths.length?Z.searchPaths.map(ue=>this.t(ue,A,J)):M.map(ue=>this.u(ue,A,J,U))).filter(ue=>!!ue),Q={_reason:A._reason,folderQueries:V,usingSearchPaths:!!(Z.searchPaths&&Z.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:J.pattern,includePattern:Z.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const ue=y.$Jb(this.c.groups.flatMap(se=>se.editors.map(ce=>ce.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(ue));const _=ue.filter(se=>(0,t.$uM)(Q,se.fsPath)),ae=this.k(_);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...Q,...ae}}const ne=A.extraFileResources&&A.extraFileResources.filter(ue=>(0,t.$uM)(Q,ue.fsPath));return Q.extraFileResources=ne&&ne.length?ne:void 0,Q}k(M){const A=[],L=new R.$Dc,Z={};let J=!1;return M.forEach(U=>{if(U.scheme===O.Schemas.walkThrough)return;if((0,s.$nh)(U)){const Q=this.b.getWorkspaceFolder(U)?.uri??this.g.extUri.dirname(U);let ne=L.get(Q);ne||(J=!0,ne={folder:Q,includePattern:{}},A.push(ne),L.set(Q,ne));const ue=p.$oc(Q.fsPath,U.fsPath);(0,b.$sg)(ne.includePattern)[ue.replace(/\\/g,"/")]=!0}else U.fsPath&&(J=!0,Z[U.fsPath]=!0)}),{folderQueries:A,includePattern:Z,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}l(M,A){if(A.isSmartCase){if(M.isRegExp){if(I.$$f(M.pattern,!0))return!0}else if(I.$$f(M.pattern))return!0}return!!M.isCaseSensitive}m(M){return M.isMultiline||M.isRegExp&&(0,E.$vD)(M.pattern)||M.pattern.indexOf(`
`)>=0?!0:!!M.isMultiline}parseSearchPaths(M){const A=_=>p.$lc(_)||/^\.\.?([\/\\]|$)/.test(_),Z=(Array.isArray(M)?M:S(M)).map(_=>{const ae=this.f.resolvedUserHome;return ae?(0,N.$9w)(_,ae.scheme===O.Schemas.file?ae.fsPath:ae.path):_}),J=D.$c(Z,_=>A(_)?"searchPaths":"exprSegments"),U=(J.exprSegments||[]).map(_=>I.$qf(_,"/")).map(_=>I.$qf(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),k(_))),V={},Q=this.o(J.searchPaths||[]);Q&&Q.length&&(V.searchPaths=Q);const ne=U.flat(),ue=d(...ne);return ue&&(V.pattern=ue),V}n(M,A){return A.disregardExcludeSettings?void 0:(0,t.$tM)(M,!A.disregardSearchExcludeSettings)}o(M){if(!M||!M.length)return[];const A=M.flatMap(Z=>{let{pathPortion:J,globPortion:U}=g(Z);return U&&(U=C(U)),this.q(J).flatMap(Q=>this.r(Q,U))}),L=new Map;return A.forEach(Z=>{const J=Z.searchPath.toString(),U=L.get(J);U?Z.pattern&&(U.pattern=U.pattern||{},U.pattern[Z.pattern]=!0):L.set(J,{searchPath:Z.searchPath,pattern:Z.pattern?d(Z.pattern):void 0})}),Array.from(L.values())}q(M){if(p.$lc(M)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==O.Schemas.file?[{searchPath:A[0].uri.with({path:M})}]:[{searchPath:u.URI.file(p.$kc(M))}]}if(this.b.getWorkbenchState()===h.WorkbenchState.FOLDER){const A=this.b.getWorkspace().folders[0].uri;if(M=v(M),M.startsWith("../")||M===".."){const Z=p.$jc.resolve(A.path,M);return[{searchPath:A.with({path:Z})}]}const L=C(M);return[{searchPath:A,pattern:L}]}else{if(M==="./"||M===".\\")return[];{const A=M.replace(/^\.[\/\\]/,""),Z=this.b.getWorkspace().folders.map(J=>{const U=A.match(new RegExp(`^${I.$kf(J.name)}(?:/(.*)|$)`));return U?{match:U,folder:J}:null}).filter(b.$pg);if(Z.length)return Z.map(J=>{const U=J.match[1];return{searchPath:J.folder.uri,pattern:U&&C(U)}});{const J=M.match(/\.[\/\\](.+)[\/\\]?/),U=J?J[1]:M,V=f.localize(12606,null,U);throw new Error(V)}}}}r(M,A){const L=M.pattern&&A?`${M.pattern}/${A}`:M.pattern||A,Z=[{searchPath:M.searchPath,pattern:L}];return L&&!L.endsWith("**")&&Z.push({searchPath:M.searchPath,pattern:L+"/**"}),Z}t(M,A,L){const Z=this.u((0,h.$4i)(M.searchPath),A,L,!1);return Z?{...Z,includePattern:M.pattern}:null}u(M,A,L,Z){let J;const U=u.URI.isUri(M)?M:M.uri;let V=A.excludePattern?.map(se=>{const ce=A.excludePattern&&o(se)?se.uri:void 0;return!ce||!(u.URI.isUri(M)&&this.g.extUri.isEqual(M,ce))?ce:void 0});if(V?.length||(V=[void 0]),L.searchPaths){const se=L.searchPaths.filter(ce=>(0,s.$ch)(ce.searchPath,U))[0];if(se&&!se.pattern)return null;se&&(J=se.pattern)}const Q=this.a.getValue({resource:U}),ue={...this.n(Q,A)||{},...J||{}},_=u.URI.isUri(M)?(0,s.$gh)(M):M.name,ae=V.map(se=>Object.keys(ue).length>0?{folder:se,pattern:ue}:void 0).filter(se=>se);return{folder:U,folderName:Z?_:void 0,excludePattern:ae,fileEncoding:Q.files&&Q.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!Q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!Q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!Q.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!Q.search.followSymlinks}}};e.$GN=m,e.$GN=m=Ke([We(0,r.$cj),We(1,h.$Ri),We(2,i.$IE),We(3,c.$dk),We(4,n.$CN),We(5,l.$Nl)],m);function g(w){const M=w.match(/[\*\{\}\(\)\[\]\?]/);if(M){const A=M.index,L=w.substr(0,A).match(/[/|\\][^/\\]*$/);if(L){let Z=w.substr(0,L.index);return Z.match(/[/\\]/)||(Z+="/"),{pathPortion:Z,globPortion:w.substr((L.index||0)+1)}}}return{pathPortion:w}}function d(...w){return w.length?w.reduce((M,A)=>(M[A]=!0,M),Object.create(null)):void 0}function S(w){return P.$Bk(w,",").map(M=>M.trim()).filter(M=>!!M.length)}function k(w){return[`**/${w}/**`,`**/${w}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function v(w){return w.replace(/\\/g,"/")}function C(w){return v(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function T(w){return w.replace(/([?*[\]])/g,"[$1]")}function $(w,M){w=y.$Ob(w,Z=>Z.toString());const A=[],L=M.getWorkspace();return w&&w.forEach(Z=>{let J;if(M.getWorkbenchState()===h.WorkbenchState.FOLDER)J=(0,s.$lh)(L.folders[0].uri,Z),J&&J!=="."&&(J="./"+J);else{const U=M.getWorkspaceFolder(Z);if(U){const V=U.name;if(L.folders.filter(ne=>ne.name===V).length===1){const ne=(0,s.$lh)(U.uri,Z);ne===""?J=`./${U.name}`:J=`./${U.name}/${ne}`}else J=Z.fsPath}}J&&A.push(T(J))}),A}}),define(Re[271],Te([1,0,24,2,19,12,3,270,44,49,10]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0yb=u,e.$$yb=r,y=qe(y),N=qe(N);const b=7e3;function u(c,l){const h=l.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],n=[];for(const d of h)if(/^workspaceContains:/.test(d)){const S=d.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||c.forceUsingSearch?n.push(S):i.push(S)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$Bh)(),a=d=>o({activationEvent:d}),m=Promise.all(i.map(d=>E(c,d,a))).then(()=>{}),g=f(c,l.identifier,n,a);return Promise.all([m,g]).then(()=>{o(void 0)}),t}async function E(c,l,h){for(const i of c.folders)if(await c.exists(y.$jh(D.URI.revive(i),l))){h(`workspaceContains:${l}`);return}}async function f(c,l,h,i){if(h.length===0)return Promise.resolve(void 0);const n=new P.$ze,t=c.checkExists(c.folders,h,n.token),o=setTimeout(async()=>{n.cancel(),c.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},b);let a=!1;try{a=await t}catch(m){N.$6(m)||N.$2(m)}n.dispose(),clearTimeout(o),a&&i(`workspaceContains:${h.join(",")}`)}function r(c,l,h,i){const n=c.get(R.$Hi),t=c.get(p.$lM),a=n.createInstance(O.$GN).file(l.map(m=>(0,s.$4i)(D.URI.revive(m))),{_reason:"checkExists",includePattern:h,exists:!0});return t.fileSearch(a,i).then(m=>!!m.limitHit,m=>N.$6(m)?!1:Promise.reject(m))}}),define(Re[47],Te([1,0,9,22,64,24,10,4,48,2,11,5,46,205,89,45,21,121,12,18,20,188,7,110,3,26,92,16,75,93,56,95,6,271,88,190,15,86,69,23,87]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g,d,S,k,v,C,T,$,w,M,A,L,Z,J,U,V){"use strict";var Q;Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=e.$Arc=e.$zrc=e.$yrc=e.$xrc=void 0,y=qe(y),D=qe(D),P=qe(P),h=qe(h),e.$xrc=(0,m.$Ii)("IHostUtils");let ne=Q=class extends O.$Xc{constructor(Y,q,ie,ve,Pe,Fe,Be,xe,nt,ut,pt,lt,et){super(),this.Y=lt,this.Z=et,this.a=this.B(new $.$oe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=ie,this.f=Be,this.j=ve,this.m=Pe,this.s=Fe,this.t=nt,this.u=ut,this.w=pt,this.y=this.g.getProxy(b.$3N.MainThreadWorkspace),this.z=this.g.getProxy(b.$3N.MainThreadTelemetry),this.C=this.g.getProxy(b.$3N.MainThreadExtensionService),this.D=new R.$Hh,this.F=new R.$Hh,this.G=new R.$Hh,this.H=new R.$Hh,this.I=new we(this.f.extensions.activationEvents),this.L=new l.$Oec(this.I,this.f.extensions.allExtensions);const Ne=new i.$vn(this.f.extensions.myExtensions);this.J=new l.$Oec(this.I,ce(this.L,Ne)),U.$u&&(this.s.info(`Creating extension host with the following global extensions: ${ae(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ae(this.J)}`)),this.M=new f.$grc(this.g,this.s),this.N=new M.$qrc(this.g),this.O=xe,this.h=this.q.add(Y.createChild(new k.$Gi([f.$hrc,this.M],[M.$rrc,this.N]))),this.P=this.B(new E.$frc(this.J,this.L,{onExtensionActivationError:(Me,Le,B)=>{this.C.$onExtensionActivationError(Me,h.$4(Le),B)},actualActivateExtension:async(Me,Le)=>{if(l.$Oec.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,Le),new E.$erc;const B=this.J.getExtensionDescription(Me);return this.fb(B,Le)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){h.$2(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Pe=>Pe.identifier).filter(Pe=>this.isActivated(Pe)).map(Pe=>this.eb(Pe))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const ie=this.$();Promise.race([(0,R.$Jh)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$un(q.identifier.value),extensionLocation:s.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const ie=this.P.getActivatedExtension(Y);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const ie=await this.R.get(q);return s.URI.file(ie)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new x(Y))),this.Q}async db(Y){const q=p.$Oi.forUris(ie=>N.$ah.ignorePathCasing(ie));return await Promise.all(Y.map(async ie=>{if(this.wb(ie)){const ve=await this.cb(ie.extensionLocation);q.set(ve,ie)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const ie=this.P.getActivatedExtension(Y);if(!ie)return q;try{typeof ie.module.deactivate=="function"&&(q=Promise.resolve(ie.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{ie.disposable.dispose()}catch(ve){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(ie=>{const ve=ie.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(Y,q,"success",ve),ie},ie=>{throw this.gb(Y,q,"failure"),ie})}gb(Y,q,ie,ve){const Pe=_(Y,q);this.z.$publicLog2("extensionActivationTimes",{...Pe,...ve||{},outcome:ie})}hb(Y,q){const ie=_(Y,q);this.z.$publicLog2("activatePlugin",ie);const ve=this.wb(Y);if(!ve)return Promise.resolve(new E.$drc(E.$arc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const Pe=new O.$Wc,Fe=new E.$brc(q.startup);return Promise.all([this.xb(Y,(0,N.$jh)(Y.extensionLocation,ve),Fe),this.ib(Y,Pe)]).then(Be=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Q.jb(this.s,Y.identifier,Be[0],Be[1],Pe,Fe))).then(Be=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Be))}ib(Y,q){const ie=this.Z.createLanguageModelAccessInformation(Y),ve=q.add(new t.$jrc(Y,this.M)),Pe=q.add(new t.$irc(Y.identifier.value,!1,this.M)),Fe=q.add(new A.$src(Y,this.N)),Be=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,xe=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ve.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const nt=this;let ut,pt;const lt=(0,c.$uH)(Y,"ipc")?this.f.messagePorts?.get(i.$un.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Pe,secrets:Fe,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(et){return D.$mc(Y.extensionLocation.fsPath,et)},get storagePath(){return nt.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return nt.O.globalValue(Y).fsPath},get logPath(){return D.$mc(nt.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return s.URI.joinPath(nt.f.logsLocation,Y.identifier.value)},get storageUri(){return nt.O.workspaceValue(Y)},get globalStorageUri(){return nt.O.globalValue(Y)},get extensionMode(){return Be},get extension(){return ut===void 0&&(ut=new se(nt,Y.identifier,Y,xe,!1)),ut},get extensionRuntime(){return(0,c.$vH)(Y,"extensionRuntime"),nt.extensionRuntime},get environmentVariableCollection(){return nt.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!pt){if(!lt)return;const et=$.Event.buffer($.Event.fromDOMEventEmitter(lt,"message",Ne=>Ne.data));lt.start(),pt={onDidReceiveMessage:et,postMessage:lt.postMessage.bind(lt)}}return pt}})})}static jb(Y,q,ie,ve,Pe,Fe){return ie=ie||{activate:void 0,deactivate:void 0},this.kb(Y,q,ie,ve,Fe).then(Be=>new E.$crc(!1,null,Fe.build(),ie,Be,(0,O.$Vc)(()=>{Pe.dispose(),(0,O.$Sc)(ve.subscriptions)})))}static kb(Y,q,ie,ve,Pe){if(typeof ie.activate=="function")try{Pe.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Fe=typeof global=="object"?global:self,Be=ie.activate.apply(Fe,[ve]);return Pe.activateCallStop(),Pe.activateResolveStart(),Promise.resolve(Be).then(xe=>(Pe.activateResolveStop(),xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ie)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,ie=>{this.s.error(ie)})}mb(Y,q=0){const ve=Date.now();(0,U.$C)(()=>{for(let Pe=q;Pe<Y.length;Pe+=1){const Fe=Y[Pe];for(const Be of Fe.activationEvents??[])if(Be==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,Pe);break}else this.lb(Fe,Be)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(q)this.mb(ie);else for(const ve of ie)if(ve.activationEvents)for(const Pe of ve.activationEvents)Pe==="onStartupFinished"&&this.lb(ve,Pe)})}ob(){const Y=this.ab("*",!0).then(void 0,Fe=>{this.s.error(Fe)});this.B(this.j.onDidChangeWorkspace(Fe=>this.pb(Fe.added)));const q=this.j.workspace?this.j.workspace.folders:[],ie=this.pb(q),ve=this.rb(),Pe=Promise.all([ve,Y,ie]).then(()=>{});return Promise.race([Pe,(0,R.$Jh)(1e4)]).then(()=>{this.nb()}),Pe}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(Fe=>Fe.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Fe=>this.c.fsExists(Fe.fsPath),checkExists:(Fe,Be,xe)=>this.y.$checkExists(Fe,Be,xe)},Pe=await(0,w.$0yb)(ve,q);if(Pe)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Pe.activationEvent}).then(void 0,Fe=>this.s.error(Fe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(y.localize(2699,null));const ie=await this.xb(null,q,new E.$brc(!1));if(!ie||typeof ie.run!="function")throw new Error(y.localize(2700,null,q.toString()));return new Promise((ve,Pe)=>{const Fe=(nt,ut)=>{nt?(U.$u&&this.s.error("Test runner called back with error",nt),Pe(nt)):(U.$u&&(ut?this.s.info(`Test runner called back with ${ut} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof ut=="number"&&ut>0?1:0))},Be=(0,N.$0g)(q),xe=ie.run(Be,Fe);xe&&xe.then&&xe.then(()=>{U.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(nt=>{U.$u&&this.s.error("Test runner finished with error",nt),Pe(nt instanceof Error&&nt.stack?nt.stack:String(nt))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,O.$Vc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new o.$aO("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.S[ie]}}async $resolveAuthority(Y,q){const ie=J.$ie.create(!1),ve=()=>`[resolveAuthority(${(0,a.$Yl)(Y)},${q})][${ie.elapsed()}ms] `,Pe=j=>this.s.info(`${ve()}${j}`),Fe=j=>this.s.warn(`${ve()}${j}`),Be=(j,H=void 0)=>this.s.error(`${ve()}${j}`,H),xe=j=>{if(j instanceof o.$aO)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},nt=async j=>{Pe(`activating resolver for ${j}...`);const{resolver:H,authorityPrefix:G}=await this.ub(j);if(!H)throw Be(`no resolver for ${G}`),new o.$aO(`No remote extension installed to resolve ${G}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:j}},ut=Y.split(/@|%40/g).reverse();Pe(`activating remote resolvers ${ut.join(" -> ")}`);let pt;try{pt=await Promise.all(ut.map(nt)).catch(async j=>{if(!(j instanceof o.$aO)||j._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return Fe(`resolving nested authorities failed: ${j.message}`),[await nt(Y)]})}catch(j){return xe(j)}const lt=new R.$Th;lt.cancelAndSet(()=>Pe("waiting..."),1e3);let et,Ne;for(const[j,{authorityPrefix:H,resolver:G,remoteAuthority:re}]of pt.entries())try{if(j===pt.length-1)Pe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),et=await G.resolve(re,{resolveAttempt:q,execServer:Ne}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),Pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,o.$_N.isManagedResolvedAuthority(et)?et:void 0));else{if(Pe(`invoking resolveExecServer() for ${re}`),P.mark(`code/extHost/willResolveExecServer/${H}`),Ne=await G.resolveExecServer?.(re,{resolveAttempt:q,execServer:Ne}),!Ne)throw new o.$aO(`Exec server was not available for ${re}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),Be("returned an error",ge),lt.dispose(),xe(ge)}lt.dispose();const Me={environmentTunnels:et.environmentTunnels,features:et.tunnelFeatures?{elevation:et.tunnelFeatures.elevation,privacyOptions:et.tunnelFeatures.privacyOptions,protocol:et.tunnelFeatures.protocol===void 0?!0:et.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:et.extensionHostEnv,isTrusted:et.isTrusted,authenticationSession:et.authenticationSessionForInitializingExtensions?{id:et.authenticationSessionForInitializingExtensions.id,providerId:et.authenticationSessionForInitializingExtensions.providerId}:void 0};Pe(`returned ${o.$_N.isManagedResolvedAuthority(et)?"managed authority":`${et.host}:${et.port}`}`);let B;if(o.$_N.isManagedResolvedAuthority(et)){const j=q;this.Y.setFactory(j,et.makeConnection),B={authority:Y,connectTo:new a.$Vl(j),connectionToken:et.connectionToken}}else B={authority:Y,connectTo:new a.$Wl(et.host,et.port),connectionToken:et.connectionToken};return{type:"ok",value:{authority:B,options:Le,tunnelInformation:Me}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,a.$Yl)(Y)})`);const{resolver:ie}=await this.ub(Y);if(!ie)return null;const ve=s.URI.revive(q);if(typeof ie.getCanonicalURI>"u")return ve;const Pe=await(0,R.$Ah)(()=>ie.getCanonicalURI(ve));return Pe||ve}async $startExtensionHost(Y){Y.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:q,myExtensions:ie}=ue(this.I,this.L,this.J,Y),ve=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ie),U.$u&&(this.s.info(`$startExtensionHost: global extensions: ${ae(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ae(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===c.ActivationKind.Immediate?this.D.wait().then(ie=>this.ab(Y,!1)):this.G.wait().then(ie=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:q,myExtensions:ie}=ue(this.I,this.L,this.J,Y),ve=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ie),U.$u&&(this.s.info(`$deltaExtensions: global extensions: ${ae(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ae(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=n.$Qe.alloc(Y),ie=Math.random()%256;for(let ve=0;ve<Y;ve++)q.writeUInt8(ie,ve);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$yrc=ne,e.$yrc=ne=Q=Ke([We(0,m.$Hi),We(1,e.$xrc),We(2,S.$DQ),We(3,r.$Vqc),We(4,u.$Yqc),We(5,I.$dk),We(6,g.$TQ),We(7,d.$2qc),We(8,v.$TGb),We(9,C.$krc),We(10,Z.$urc),We(11,V.$vrc),We(12,T.$orc)],ne);function ue(Ie,Y,q,ie){Ie.addActivationEvents(ie.addActivationEvents);const ve=new l.$Oec(Ie,Y.getAllExtensionDescriptions());ve.deltaExtensions(ie.toAdd,ie.toRemove);const Pe=new i.$vn(q.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of ie.myToRemove)Pe.delete(Be);for(const Be of ie.myToAdd)Pe.add(Be);const Fe=ce(ve,Pe);return{globalRegistry:ve,myExtensions:Fe}}function _(Ie,Y){return{id:Ie.identifier.value,name:Ie.name,extensionVersion:Ie.version,publisherDisplayName:Ie.publisher,activationEvents:Ie.activationEvents?Ie.activationEvents.join(","):null,isBuiltin:Ie.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function ae(Ie){return Ie.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$zrc=(0,m.$Ii)("IExtHostExtensionService");class se{#e;#t;#i;constructor(Y,q,ie,ve,Pe){this.#e=Y,this.#t=q,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=D.$kc((0,N.$0g)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=ve,this.isFromDifferentExtensionHost=Pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Arc=se;function ce(Ie,Y){return Ie.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class x{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Brc=x;class we{constructor(Y){this.a=new i.$wn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Re[272],Te([1,0,64,2,5,46,21,18,16,26,3,47,11,13]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsc=void 0,y=qe(y);let r=class{constructor(n,t,o,a,m,g,d){this.c=n,this.d=t,this.e=o,this.f=a,this.g=m,this.h=g,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new l(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$Rsc=r,e.$Rsc=r=Ke([We(2,I.$Hi),We(3,N.$Yqc),We(4,b.$zrc),We(5,s.$TQ),We(6,u.$dk)],r);let c=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&f.a.size){const t=(0,E.$kf)(this.c(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",a=`@${o}+\\/${o}+|${o}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,o,a,m]=t,g=f.a.get(a);if(g!==void 0)return console.warn(`${a} as been renamed to ${g}, please update your imports`),o+g+m}c(n){return n.replace(/\\/g,"/")}};c=f=Ke([We(0,s.$TQ)],c);class l{constructor(n,t,o,a,m){this.c=n,this.d=t,this.e=o,this.f=a,this.g=m,this.nodeModuleName="vscode",this.a=new O.$wn}load(n,t){const o=this.d.findSubstr(t);if(o){let a=this.a.get(o.identifier);return a||(a=this.c(o,this.e,this.f),this.a.set(o.identifier,a)),a}if(!this.b){let a="";this.d.forEach((m,g)=>a+=`	${g} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${a}`),this.b=this.c(R.$pH,this.e,this.f)}return this.b}}let h=class{constructor(n,t,o){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(P.$3N.MainThreadTelemetry);const a=o.getProxy(P.$3N.MainThreadWindow);this.c=(m,g)=>{const d=D.URI.parse(m);return g?this.g(m,g):d.scheme==="http"||d.scheme==="https"?a.$openUri(d,m,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?a.$openUri(d,m,{}):this.g(m,g)}}load(n,t,o){const a=this.e.findSubstr(t);return a&&(this.a=a.identifier.value,this.h()),this.b=o(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=Ke([We(2,p.$DQ)],h)}),define(Re[133],Te([1,0,51,4,22,79,3,57,70,47,7,45,202,46]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=void 0,P=qe(P),N=qe(N),e.$Crc=(0,R.$Ii)("IExtHostVariableResolverProvider");class f extends u.$HR{constructor(l,h,i,n,t,o,a){function m(){if(i){const g=i.activeEditor();if(g)return g.document.uri;const d=n.tabGroups.all.find(S=>S.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof I.$TP||d.input instanceof I.$YP)return d.input.modified;if(d.input instanceof I.$SP||d.input instanceof I.$XP||d.input instanceof I.$VP)return d.input.uri}}}super({getFolderUri:g=>{const d=o.folders.filter(S=>S.name===g);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(g,d)=>t.getConfiguration(void 0,g).get(d),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=m();if(g)return P.$kc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const g=m();if(g){const d=h.getWorkspaceFolder(g);if(d)return P.$kc(d.uri.fsPath)}}},getSelectedText:()=>{if(i){const g=i.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(i){const g=i.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>l.getExtension(g)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(N.env))}}let r=class extends D.$Xc{constructor(l,h,i,n,t){super(),this.b=l,this.c=h,this.g=i,this.h=n,this.j=t,this.a=new y.$W(async()=>{const o=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,o,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$Drc=r,e.$Drc=r=Ke([We(0,s.$zrc),We(1,b.$Vqc),We(2,O.$OQ),We(3,E.$Yqc),We(4,p.$$qc)],r)}),define(Re[134],Te([1,0,10,6,2,4,18,3,5,70,47,16,7,45,194,81,195,46,133,35,34,8,17,96]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=e.$Mrc=e.$Lrc=e.$Krc=e.$Jrc=void 0,t=qe(t),e.$Jrc=(0,O.$Ii)("IExtHostDebugService");let m=class extends N.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(T,$,w,M,A,L,Z,J){super(),this.Y=$,this.Z=w,this.$=M,this.ab=A,this.bb=L,this.cb=Z,this.db=J,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new D.$oe),this.z=this.B(new D.$oe),this.C=this.B(new D.$oe),this.F=this.B(new D.$oe),this.u=T.getProxy(p.$3N.MainThreadDebugService),this.I=this.B(new D.$oe),this.L=this.B(new D.$oe),this.G=new d(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(U=>{this.B(U.onDidChange(V=>{this.fb(U)})),this.fb(U)})}async $getVisualizerTreeItem(T,$){const w=this.gb($);if(!w)return;const M=await this.Q.get(T)?.getTreeItem?.(w);return M?this.eb(T,M):void 0}registerDebugVisualizationTree(T,$,w){const M=R.$un.toKey(T.identifier),A=this.ub(M,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.Q.set(A,w),this.u.$registerDebugVisualizerTree(A,!!w.editItem),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(A),this.Q.delete($)})}async $getVisualizerTreeItemChildren(T,$){const w=this.S.get($)?.item;return w?(await this.Q.get(T)?.getChildren?.(w))?.map(A=>this.eb(T,A))||[]:[]}async $editVisualizerTreeItem(T,$){const w=this.S.get(T);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,$);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(T){const $=this.S.get(T);if(!$)return;const w=[$.children];for(const M of w)if(M)for(const A of M)w.push(this.S.get(A)?.children),this.S.delete(A)}eb(T,$){let w=this.R.get($);return w||(w=this.O++,this.R.set($,w),this.S.set(w,{provider:T,item:$})),t.DebugTreeItem.from($,w)}asDebugSourceUri(T,$){const w=T;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,A="?";return $&&(M+=`${A}session=${encodeURIComponent($.id)}`,A="&"),M+=`${A}ref=${w.sourceReference}`,P.URI.parse(M)}else{if(w.path)return P.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(T){const $=[];for(const w of T.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const A of M)(0,c.$qI)(A)&&$.push(A.type)}this.u.$registerDebugTypes($)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const T=[];return this.H.forEach($=>T.push($)),T}async $resolveDebugVisualizer(T,$){const w=this.W.get(T);if(!w)throw new Error(`No debug visualizer found with id '${T}'`);let{v:M,provider:A,extensionId:L}=w;if(M.visualization||(M=await A.resolveDebugVisualization?.(M,$)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${A}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(T){const $=this.W.get(T);if(!$)throw new Error(`No debug visualizer found with id '${T}'`);const w=$.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(T){const $=this.w.get(T.sessionId);return $&&{session:$.api,variable:T.variable,containerId:T.containerId,frameId:T.frameId,threadId:T.threadId}}async $provideDebugVisualizers(T,$,w,M){const A=this.gb(w),L=this.ub(T,$),Z=this.P.get(L);if(!A||!Z)return[];const J=await Z.provideDebugVisualization(A,M);return J?J.map(U=>{const V=++this.X;this.W.set(V,{v:U,provider:Z,extensionId:T});const Q=U.iconPath?this.wb(U.iconPath):void 0;return{id:V,name:U.name,iconClass:Q?.iconClass,iconPath:Q?.iconPath,visualization:this.vb(T,U.visualization)}}):[]}$disposeDebugVisualizers(T){for(const $ of T)this.W.delete($)}registerDebugVisualizationProvider(T,$,w){if(!T.contributes?.debugVisualizers?.some(L=>L.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const M=R.$un.toKey(T.identifier),A=this.ub(M,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.P.set(A,w),this.u.$registerDebugVisualizer(M,$),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizer(M,$),this.P.delete($)})}addBreakpoints(T){const $=T.filter(A=>{const L=A.id;return this.H.has(L)?!1:(this.H.set(L,A),!0)});this.rb($,[],[]);const w=[],M=new Map;for(const A of $)if(A instanceof u.$9O){let L=M.get(A.location.uri.toString());L||(L={type:"sourceMulti",uri:A.location.uri,lines:[]},M.set(A.location.uri.toString(),L),w.push(L)),L.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character,mode:A.mode})}else A instanceof u.$0O&&w.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName,mode:A.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(T){const $=T.filter(L=>this.H.delete(L.id));this.rb([],$,[]);const w=$.filter(L=>L instanceof u.$9O).map(L=>L.id),M=$.filter(L=>L instanceof u.$0O).map(L=>L.id),A=$.filter(L=>L instanceof u.$$O).map(L=>L.id);return this.u.$unregisterBreakpoints(w,M,A)}startDebugging(T,$,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(T?T.uri:void 0,$,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(T){return this.u.$stopDebugging(T?T.id:void 0)}registerDebugConfigurationProvider(T,$,w){if(!$)return new u.$5N(()=>{});const M=this.f++;return this.g.push({type:T,handle:M,provider:$}),this.u.$registerDebugConfigurationProvider(T,w,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$5N(()=>{this.g=this.g.filter(A=>A.provider!==$),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(T,$,w){if(!w)return new u.$5N(()=>{});if(!this.nb(T,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.kb($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:$,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory($,M),new u.$5N(()=>{this.j=this.j.filter(A=>A.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(T,$){if(!$)return new u.$5N(()=>{});const w=this.m++;return this.n.push({type:T,handle:w,factory:$}),new u.$5N(()=>{this.n=this.n.filter(M=>M.factory!==$)})}async $runInTerminal(T,$){return Promise.resolve(void 0)}async $substituteVariables(T,$){let w;const M=await this.tb(T);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,$)}hb(T,$){if(T.type==="implementation")return new k(T.implementation)}ib(){}async $startDASession(T,$){const w=this,M=await this.sb($);return this.pb(this.kb(M.type),M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(A),Z=this.hb(L,M);if(!Z)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const J=Z;return this.M.set(T,J),this.ob(M).then(U=>(U&&this.N.set(T,U),J.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const Q=V,ne={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ue=await this.U.sign(Q.arguments.value);ne.body={signature:ue},J.sendResponse(ne)}else throw new Error("no signer")}catch(ue){ne.success=!1,ne.message=ue.message,J.sendResponse(ne)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(V),V=(0,c.$vI)(V,!0),w.u.$acceptDAMessage(T,V)}),J.onError(V=>{U&&U.onError&&U.onError(V),this.u.$acceptDAError(T,V.name,V.message,V.stack)}),J.onExit(V=>{U&&U.onExit&&U.onExit(V??void 0,void 0),this.u.$acceptDAExit(T,V??void 0,void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),J.startSession()))})}$sendDAMessage(T,$){$=(0,c.$uI)($,!1);const w=this.N.get(T);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage($),this.M.get(T)?.sendMessage($)}$stopDASession(T){const $=this.N.get(T);this.N.delete(T),$&&$.onWillStopSession&&$.onWillStopSession();const w=this.M.get(T);return this.M.delete(T),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(T){const $=[],w=[],M=[];if(T.added)for(const A of T.added){const L=A.id;if(L&&!this.H.has(L)){let Z;if(A.type==="function")Z=new u.$0O(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode);else if(A.type==="data")Z=new u.$$O(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage,A.mode);else{const J=P.URI.revive(A.uri);Z=new u.$9O(new u.$gO(J,new u.$6N(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode)}(0,u.$7O)(Z,L),this.H.set(L,Z),$.push(Z)}}if(T.removed)for(const A of T.removed){const L=this.H.get(A);L&&(this.H.delete(A),w.push(L))}if(T.changed){for(const A of T.changed)if(A.id){const L=this.H.get(A.id);if(L){if(L instanceof u.$0O&&A.type==="function"){const Z=L;Z.enabled=A.enabled,Z.condition=A.condition,Z.hitCondition=A.hitCondition,Z.logMessage=A.logMessage,Z.functionName=A.functionName}else if(L instanceof u.$9O&&A.type==="source"){const Z=L;Z.enabled=A.enabled,Z.condition=A.condition,Z.hitCondition=A.hitCondition,Z.logMessage=A.logMessage,Z.location=new u.$gO(P.URI.revive(A.uri),new u.$6N(A.line,A.character))}M.push(L)}}}this.rb($,w,M)}async $acceptStackFrameFocus(T){let $;if(T){const w=await this.sb(T.sessionId);T.kind==="thread"?$=new u.$eP(w.api,T.threadId):$=new u.$dP(w.api,T.threadId,T.frameId)}this.J=$,this.L.fire(this.J)}$provideDebugConfigurations(T,$,w){return(0,y.$Ah)(async()=>{const M=this.mb(T);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.tb($);return M.provideDebugConfigurations(A,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(T,$,w,M){return(0,y.$Ah)(async()=>{const A=this.mb(T);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb($);return A.resolveDebugConfiguration(L,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(T,$,w,M){return(0,y.$Ah)(async()=>{const A=this.mb(T);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb($);return A.resolveDebugConfigurationWithSubstitutedVariables(L,w,M)})}async $provideDebugAdapter(T,$){const w=this.lb(T);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb($);return this.pb(w,M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(A)})}async $acceptDebugSessionStarted(T){const $=await this.sb(T);this.y.fire($.api)}async $acceptDebugSessionTerminated(T){const $=await this.sb(T);$&&(this.z.fire($.api),this.w.delete($.id))}async $acceptDebugSessionActiveChanged(T){this.D=T?await this.sb(T):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(T,$){(await this.sb(T))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(T,$){const M={session:(await this.sb(T)).api,event:$.event,body:$.body};this.F.fire(M)}jb(T){if(T instanceof u.$_O)return{type:"executable",command:T.command,args:T.args,options:T.options};if(T instanceof u.$aP)return{type:"server",port:T.port,host:T.host};if(T instanceof u.$bP)return{type:"pipeServer",path:T.path};if(T instanceof u.$cP)return{type:"implementation",implementation:T.implementation};throw new Error("convertToDto unexpected type")}kb(T){const $=this.j.filter(w=>w.type===T);if($.length>0)return $[0].factory}lb(T){const $=this.j.filter(w=>w.handle===T);if($.length>0)return $[0].factory}mb(T){const $=this.g.filter(w=>w.handle===T);if($.length>0)return $[0].provider}nb(T,$){if(T.contributes){const w=T.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===$)return!0}}return!1}ob(T){const w=T.configuration.type,M=this.n.filter(A=>A.type===w||A.type==="*").map(A=>(0,y.$Ah)(()=>A.factory.createDebugAdapterTracker(T.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(A=>{const L=(0,o.$Jb)(A);if(L.length>0)return new S(L)}),new Promise(A=>setTimeout(()=>A(void 0),1e3))]).catch(A=>{})}async pb(T,$){const w=$.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new u.$aP(w));if(T){const A=await this.Z.getExtensionRegistry();return(0,y.$Ah)(()=>T.createDebugAdapterDescriptor($.api,this.qb($,A))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb($,M))}qb(T,$){}rb(T,$,w){(T.length>0||$.length>0||w.length>0)&&this.I.fire(Object.freeze({added:T,removed:$,changed:w}))}async sb(T){if(T)if(typeof T=="string"){const $=this.w.get(T);if($)return $}else{let $=this.w.get(T.id);if(!$){const w=await this.tb(T.folderUri),M=T.parent?this.w.get(T.parent):void 0;$=new g(this.u,T.id,T.type,T.name,w,T.configuration,M?.api),this.w.set($.id,$),this.u.$sessionCached($.id)}return $}throw new Error("cannot find session")}tb(T){if(T){const $=P.URI.revive(T);return this.Y.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}ub(T,$){return`${T}\0${$}`}vb(T,$){if($){if("title"in $&&"command"in $)return{type:r.DebugVisualizationType.Command};if("treeId"in $)return{type:r.DebugVisualizationType.Tree,id:`${T}\0${$.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(T){const $=this.xb(T);let w,M;return"id"in $?M=i.ThemeIcon.asClassName($):w=$,{iconPath:w,iconClass:M}}xb(T){if(T instanceof u.$4O)return{id:T.id};const $=typeof T=="object"&&"dark"in T?T.dark:T,w=typeof T=="object"&&"light"in T?T.light:T;return{dark:typeof $=="string"?P.URI.file($):$,light:typeof w=="string"?P.URI.file(w):w}}};e.$Krc=m,e.$Krc=m=Ke([We(0,b.$DQ),We(1,E.$Vqc),We(2,I.$zrc),We(3,l.$Yqc),We(4,s.$$qc),We(5,h.$Crc),We(6,n.$ZQ),We(7,a.$Erc)],m);class g{constructor(T,$,w,M,A,L,Z){this.f=T,this.g=$,this.h=w,this.j=M,this.k=A,this.l=L,this.m=Z}get api(){const T=this;return this.d??=Object.freeze({id:T.g,type:T.h,get name(){return T.j},set name($){T.j=$,T.f.$setDebugSessionName(T.g,$)},parentSession:T.m,workspaceFolder:T.k,configuration:T.l,customRequest($,w){return T.f.$customDebugAdapterRequest(T.g,$,w)},getDebugProtocolBreakpoint($){return T.f.$getDebugProtocolBreakpoint(T.g,$.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(T){this.j=T}get configuration(){return this.l}}e.$Lrc=g;class d{constructor(T){this.value=Object.freeze({append($){T.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$Mrc=d;class S{constructor(T){this.d=T}onWillStartSession(){this.d.forEach(T=>T.onWillStartSession?T.onWillStartSession():void 0)}onWillReceiveMessage(T){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(T):void 0)}onDidSendMessage(T){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(T):void 0)}onWillStopSession(){this.d.forEach(T=>T.onWillStopSession?T.onWillStopSession():void 0)}onError(T){this.d.forEach($=>$.onError?$.onError(T):void 0)}onExit(T,$){this.d.forEach(w=>w.onExit?w.onExit(T,$):void 0)}}class k extends f.$Dub{constructor(T){super(),this.h=T,T.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(T){this.h.handleMessage(T)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends m{constructor(T,$,w,M,A,L,Z,J){super(T,$,w,M,A,L,Z,J)}};e.$Nrc=v,e.$Nrc=v=Ke([We(0,b.$DQ),We(1,E.$Vqc),We(2,I.$zrc),We(3,l.$Yqc),We(4,s.$$qc),We(5,h.$Crc),We(6,n.$ZQ),We(7,a.$Erc)],v)}),define(Re[273],Te([1,0,12,64,2,5,223,11,60,75,26,170,16,65,47,66]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=e.$Ssc=void 0,y=qe(y),D=qe(D);class c{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(O.$dk),o=i.get(u.$DQ).getProxy(N.$3N.MainThreadErrors);y.setUnexpectedErrorHandler(a=>{n.error(a);const m=y.$4(a);o.$onUnexpectedError(m)})}static async installFullHandler(i){const n=i.get(O.$dk),t=i.get(u.$DQ),o=i.get(f.$zrc),a=i.get(r.$XQ),m=t.getProxy(N.$3N.MainThreadExtensionService),g=t.getProxy(N.$3N.MainThreadErrors),d=await o.getExtensionPathIndex(),S=new WeakMap;function k(T,$){if(S.has(T))return S.get(T).stack;let w="",M,A;for(const Z of $)w+=`
	at ${Z.toString()}`,A=Z.getFileName(),!M&&A&&(M=d.findSubstr(P.URI.file(A)));const L=`${T.name||"Error"}: ${T.message||""}${w}`;return S.set(T,{extensionIdentifier:M?.identifier,stack:L}),L}const v=Symbol("prepareStackTrace wrapped");let C=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(T){if(T===k||!T||T[v]){C=T||k;return}C=function($,w){return k($,w),T.call(Error,$,w)},Object.assign(C,{[v]:!0})}}),y.setUnexpectedErrorHandler(T=>{n.error(T);const $=y.$4(T),w=S.get(T);if(!w?.extensionIdentifier){g.$onUnexpectedError($);return}m.$onExtensionRuntimeError(w.extensionIdentifier,$);const M=a.onExtensionError(w.extensionIdentifier,T);n.trace("forwarded error to extension?",M,w)})}}e.$Ssc=c;class l{constructor(i,n,t,o,a){this.a=t,this.b=new R.$Wec(i,null,o),n=l.e(n,this.b);const m=new s.$Gi(...(0,p.$Xs)());m.set(I.$TQ,{_serviceBrand:void 0,...n,messagePorts:a}),m.set(u.$DQ,new u.$EQ(this.b)),m.set(E.$Sqc,new E.$Tqc(o)),m.set(f.$xrc,t);const g=new b.$Br(m,!0);g.invokeFunction(c.installEarlyHandler),this.d=g.invokeFunction(d=>d.get(O.$dk)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=g.invokeFunction(d=>d.get(f.$zrc)),this.c.initialize(),g.invokeFunction(c.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(N.$3N.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=P.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>P.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$Tsc=l}),define(Re[274],Te([1,0,17,58]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=e.$8rc=e.$5rc=void 0,e.$6rc=p,e.$7rc=s,e.$0rc=E;function P(f){return"uri"in f&&"ranges"in f&&"preview"in f}function N(f){return f.folderOptions.map(r=>({folder:r.folder,excludes:r.excludes.map(c=>typeof c=="string"?c:c.pattern),includes:r.includes,useGlobalIgnoreFiles:r.useIgnoreFiles.global,useIgnoreFiles:r.useIgnoreFiles.local,useParentIgnoreFiles:r.useIgnoreFiles.parent,followSymlinks:r.followSymlinks,maxResults:f.maxResults,session:f.session}))}class R{constructor(r){this.a=r}provideFileSearchResults(r,c,l){return(async()=>{const i=N(c);return Promise.all(i.map(n=>this.a.provideFileSearchResults({pattern:r},n,l)))})().then(i=>(0,y.$Jb)(i).flat())}}e.$5rc=R;function O(f){return f.folderOptions.map(r=>({folder:r.folder,excludes:r.excludes.map(c=>typeof c=="string"?c:c.pattern),includes:r.includes,useGlobalIgnoreFiles:r.useIgnoreFiles.global,useIgnoreFiles:r.useIgnoreFiles.local,useParentIgnoreFiles:r.useIgnoreFiles.parent,followSymlinks:r.followSymlinks,maxResults:f.maxResults,previewOptions:p(f.previewOptions),maxFileSize:f.maxFileSize,encoding:r.encoding,afterContext:f.surroundingContext,beforeContext:f.surroundingContext}))}function p(f){if(!(!f||f.matchLines===void 0&&f.charsPerLine===void 0))return{matchLines:f.matchLines??100,charsPerLine:f.charsPerLine??1e4}}function s(f){if(P(f)){const r=(0,y.$4b)(f.ranges).map((c,l)=>{const i=(0,y.$4b)(f.preview.matches)[l];return{sourceRange:c,previewRange:i}});return new D.$dM(f.uri,r,f.preview.text)}else return new D.$eM(f.uri,f.text,f.lineNumber)}class I{constructor(r){this.a=r}provideTextSearchResults(r,c,l,h){const i=o=>{u(o)&&l.report(s(o))};return(async()=>(0,y.$Jb)(await Promise.all(O(c).map(o=>this.a.provideTextSearchResults(r,o,{report:a=>i(a)},h)))).reduce((o,a)=>({limitHit:o.limitHit||a.limitHit}),{limitHit:!1}))().then(o=>({limitHit:o.limitHit,message:(0,y.$Jb)((0,y.$4b)(o.message))}))}}e.$8rc=I;class b{constructor(r){this.a=r}provideAITextSearchResults(r,c,l,h){const i=o=>{u(o)&&l.report(s(o))};return(async()=>(0,y.$Jb)(await Promise.all(O(c).map(o=>this.a.provideAITextSearchResults(r,o,{report:a=>i(a)},h)))).reduce((o,a)=>({limitHit:o.limitHit||a.limitHit}),{limitHit:!1}))().then(o=>({limitHit:o.limitHit,message:(0,y.$Jb)((0,y.$4b)(o.message))}))}}e.$9rc=b;function u(f){if(E(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function E(f){return!!f.preview}}),define(Re[275],Te([1,0,10,19,42,15,22,24,48,2,44,58]),function($e,e,y,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=e.$3rc=e.$2rc=void 0,R=qe(R),O=qe(O);class u{constructor(h,i,n){this.f=h,this.g=i,this.h=n,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(h,i){const n=this.j.folderQueries||[],t=new D.$ze(i);return new Promise((o,a)=>{this.b=new f(h);let m=!1;const g=(d,S)=>{if(!m&&!this.c){const k=this.l(d);d instanceof b.$dM&&typeof this.j.maxResults=="number"&&this.d+k>this.j.maxResults&&(this.c=!0,m=!0,t.cancel(),d=this.m(d,this.j.maxResults-this.d));const v=this.l(d);this.d+=v;const C=d instanceof b.$dM;(v>0||!C)&&this.b.add(d,S)}};this.n(n,g,t.token).then(d=>{t.dispose(),this.b.flush(),o({limitHit:this.c||d?.limitHit,messages:this.k(d),stats:{type:this.h}})},d=>{t.dispose();const S=(0,P.$tj)(d);a(new Error(S))})})}k(h){return h?.message?Array.isArray(h.message)?h.message:[h.message]:[]}l(h){return h instanceof b.$dM?Array.isArray(h.ranges)?h.ranges.length:1:0}m(h,i){return new b.$dM(h.uri,h.ranges.slice(0,i),h.previewText)}async n(h,i,n){const t=p.$Oi.forUris();h.forEach((S,k)=>{const v=new I.$EM(this.j,S);t.set(S.folder,{queryTester:v,folder:S.folder,folderIdx:k})});const o=[],a={report:S=>{const k=t.findSubstr(S.uri),v=k.folder.scheme===N.Schemas.file?(0,I.$FM)(()=>this.g.readdir(O.$ih(S.uri))):void 0,C=O.$lh(k.folder,S.uri);if(C){const T=k.queryTester.includedInQuery(C,R.$qc(C),v);(0,y.$uh)(T)?o.push(T.then($=>{$&&i(S,k.folderIdx)})):T&&i(S,k.folderIdx)}}},g={folderOptions:h.map(S=>this.o(S)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$kM,previewOptions:this.j.previewOptions,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(g.usePCRE2=this.j.usePCRE2);let d;return this.f.query.type===I.QueryType.aiText?d=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,g,a,n):d=await this.f.provider.provideTextSearchResults(E(this.f.query.contentPattern),g,a,n),o.length&&await Promise.all(o),d}o(h){const i=(0,I.$DM)(this.j.includePattern,h.includePattern);let n=h.excludePattern?.map(a=>({folder:a.folder,patterns:(0,I.$DM)(this.j.excludePattern,a.pattern)}));(!n||n.length===0)&&(n=[{folder:void 0,patterns:(0,I.$DM)(this.j.excludePattern,void 0)}]);const t=(0,I.$HM)(n);return{folder:s.URI.from(h.folder),excludes:t,includes:i,useIgnoreFiles:{local:!h.disregardIgnoreFiles,parent:!h.disregardParentIgnoreFiles,global:!h.disregardGlobalIgnoreFiles},followSymlinks:!h.ignoreSymlinks,encoding:(h.fileEncoding&&this.g.toCanonicalName(h.fileEncoding))??""}}}e.$2rc=u;function E(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class f{constructor(h){this.g=h,this.c=-1,this.f=null,this.b=new c(512,i=>this.j(i))}add(h,i){this.f&&(this.c!==i||!O.$ch(this.d,h.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:h.uri,results:[]}),this.f.results.push(r(h))}h(){const h=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,h)}flush(){this.h(),this.b.flush()}j(h){this.g(h)}}e.$3rc=f;function r(l){return l instanceof b.$dM?{previewText:l.previewText,rangeLocations:l.ranges.map(h=>({preview:{startLineNumber:h.previewRange.start.line,startColumn:h.previewRange.start.character,endLineNumber:h.previewRange.end.line,endColumn:h.previewRange.end.character},source:{startLineNumber:h.sourceRange.start.line,startColumn:h.sourceRange.start.character,endLineNumber:h.sourceRange.end.line,endColumn:h.sourceRange.end.character}}))}:{text:l.text,lineNumber:l.lineNumber}}class c{static{this.b=4e3}static{this.c=50}constructor(h,i){this.j=h,this.k=i,this.d=0,this.f=[],this.g=0}addItem(h,i){h&&this.l(h,i)}addItems(h,i){h&&this.m(h,i)}l(h,i){this.f.push(h),this.g+=i,this.n()}m(h,i){this.f=this.f.concat(h),this.g+=i,this.n()}n(){this.d<c.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},c.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$4rc=c}),define(Re[135],Te([1,0,4,5,3,269,16,65,11,2,275,33,274]),function($e,e,y,D,P,N,R,O,p,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=e.$$rc=void 0,e.$asc=f,e.$$rc=(0,P.$Ii)("IExtHostSearch");let E=class{constructor(l,h,i){this.n=l,this.o=h,this.q=i,this.c=this.n.getProxy(D.$3N.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$1rc}s(l){return this.o.transformOutgoingScheme(l)}registerTextSearchProviderOld(l,h){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const i=this.d++;return this.e.set(i,new u.$8rc(h)),this.c.$registerTextSearchProvider(i,this.s(l)),(0,y.$Vc)(()=>{this.g.delete(l),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(l,h){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const i=this.d++;return this.e.set(i,h),this.c.$registerTextSearchProvider(i,this.s(l)),(0,y.$Vc)(()=>{this.g.delete(l),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(l,h){if(this.i.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this.i.add(l);const i=this.d++;return this.h.set(i,new u.$9rc(h)),this.c.$registerAITextSearchProvider(i,this.s(l)),(0,y.$Vc)(()=>{this.i.delete(l),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(l,h){if(this.i.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this.i.add(l);const i=this.d++;return this.h.set(i,h),this.c.$registerAITextSearchProvider(i,this.s(l)),(0,y.$Vc)(()=>{this.i.delete(l),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(l,h){if(this.k.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.k.add(l);const i=this.d++;return this.j.set(i,new u.$5rc(h)),this.c.$registerFileSearchProvider(i,this.s(l)),(0,y.$Vc)(()=>{this.k.delete(l),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(l,h){if(this.k.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.k.add(l);const i=this.d++;return this.j.set(i,h),this.c.$registerFileSearchProvider(i,this.s(l)),(0,y.$Vc)(()=>{this.k.delete(l),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(l,h,i,n){const t=f(i),o=this.j.get(l);if(o)return this.l.fileSearch(t,o,a=>{this.c.$handleFileMatch(l,h,a.map(m=>m.resource))},n);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,h,i){return{messages:[]}}$clearCache(l){return this.l.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,h,i,n){const t=this.e.get(l);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${l}`);const o=f(i);return this.t(o,t).search(m=>this.c.$handleTextMatch(l,h,m),n)}$provideAITextSearchResults(l,h,i,n){const t=this.h.get(l);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${l}`);const o=f(i);return this.v(o,t).search(m=>this.c.$handleTextMatch(l,h,m),n)}$enableExtensionHostSearch(){}t(l,h){return new I.$2rc({query:l,provider:h},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(l,h){return new I.$2rc({query:l,provider:h},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$_rc=E,e.$_rc=E=Ke([We(0,R.$DQ),We(1,O.$Sqc),We(2,p.$dk)],E);function f(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(r),extraFileResources:c.extraFileResources&&c.extraFileResources.map(l=>s.URI.revive(l))}}function r(c){return(0,b.$fi)(c)}});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Re[276],Te([1,0,19,12,6,4,15,36,2,106,157,158,52,18,28,11,62,63,184,5,226,255,85,91,231,232,233,210,200,34,234,46,235,134,124,236,212,227,237,238,57,70,213,228,47,240,68,241,50,26,256,214,242,243,95,244,86,87,216,268,246,189,247,257,248,130,217,249,250,251,16,252,135,88,253,218,254,89,92,132,66,56,128,96,258,229,259,260,93,8,7,219,65,220,67,261,262,123,45,81,84,21,58]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g,d,S,k,v,C,T,$,w,M,A,L,Z,J,U,V,Q,ne,ue,_,ae,se,ce,x,we,Ie,Y,q,ie,ve,Pe,Fe,Be,xe,nt,ut,pt,lt,et,Ne,Me,Le,B,j,H,G,re,ge,Ee,Ue,Je,_e,tt,at,it,ot,vt,Ye,he,pe,ye,Ce,fe,be,X,W,de,je,Qe,st,ht,gt,Rt,At,Qt,_t,Ze,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=Ut,D=qe(D),O=si(O),b=qe(b),f=qe(f),X=qe(X),W=qe(W);function Ut($t){const Pt=$t.get(we.$TQ),ei=$t.get(x.$Dqc),ti=$t.get(se.$1qc),Ht=$t.get(_.$zrc),wt=$t.get(At.$Vqc),Nt=$t.get(ot.$XQ),ai=$t.get(T.$Yqc),Zt=$t.get(je.$Sqc),Ge=$t.get(G.$DQ),ii=$t.get(tt.$hrc),ci=$t.get(at.$2qc),ui=$t.get(r.$ek),Et=$t.get(r.$dk),jt=$t.get(be.$TGb),Lt=$t.get(o.$zqc),Bt=$t.get(Rt.$Msc),oi=$t.get(Ee.$rrc),ni=$t.get(Q.$$qc),ri=$t.get(Be.$vrc),Kt=$t.get(a.$Jqc),Gt=$t.get(ve.$orc);Ge.set(i.$4N.ExtHostFileSystemInfo,ei),Ge.set(i.$4N.ExtHostLogLevelServiceShape,ui),Ge.set(i.$4N.ExtHostWorkspace,wt),Ge.set(i.$4N.ExtHostConfiguration,ai),Ge.set(i.$4N.ExtHostExtensionService,Ht),Ge.set(i.$4N.ExtHostStorage,ii),Ge.set(i.$4N.ExtHostTunnelService,jt),Ge.set(i.$4N.ExtHostWindow,Bt),Ge.set(i.$4N.ExtHostSecretState,oi),Ge.set(i.$4N.ExtHostTelemetry,Nt),Ge.set(i.$4N.ExtHostEditorTabs,ni),Ge.set(i.$4N.ExtHostManagedSockets,ri),Ge.set(i.$4N.ExtHostAuthentication,Kt),Ge.set(i.$4N.ExtHostChatProvider,Gt);const li=Ge.set(i.$4N.ExtHostDecorations,$t.get(M.$Prc)),Mt=Ge.set(i.$4N.ExtHostDocumentsAndEditors,$t.get(V.$OQ)),Dt=Ge.set(i.$4N.ExtHostCommands,$t.get(v.$ZQ)),bt=Ge.set(i.$4N.ExtHostTerminalService,$t.get(vt.$krc)),Jt=Ge.set(i.$4N.ExtHostTerminalShellIntegration,$t.get(Ye.$Csc)),St=Ge.set(i.$4N.ExtHostDebugService,$t.get(w.$Jrc)),hi=Ge.set(i.$4N.ExtHostSearch,$t.get(ge.$$rc)),Xt=Ge.set(i.$4N.ExtHostTask,$t.get(it.$Bsc)),Mi=Ge.set(i.$4N.ExtHostOutputService,$t.get(Me.$osc)),di=Ge.set(i.$4N.ExtHostLocalization,$t.get(Fe.$urc)),yi=Ge.set(i.$4N.ExtHostUrls,new Qe.$Jsc(Ge)),qt=Ge.set(i.$4N.ExtHostDocuments,new U.$Gqc(Ge,Mt)),fi=Ge.set(i.$4N.ExtHostDocumentContentProviders,new Z.$Rrc(Ge,Mt,Et)),Fi=Ge.set(i.$4N.ExtHostDocumentSaveParticipant,new J.$Src(Et,qt,Ge.getProxy(i.$3N.MainThreadBulkEdits))),Ct=Ge.set(i.$4N.ExtHostNotebook,new nt.$bsc(Ge,Dt,Mt,qt,ti,hi,Et)),Si=Ge.set(i.$4N.ExtHostNotebookDocuments,new pt.$isc(Ct)),Ai=Ge.set(i.$4N.ExtHostNotebookEditors,new lt.$jsc(Et,Ct)),gi=Ge.set(i.$4N.ExtHostNotebookKernels,new et.$ksc(Ge,Pt,Ct,Dt,Et)),zi=Ge.set(i.$4N.ExtHostNotebookRenderers,new Ne.$msc(Ge,Ct)),ji=Ge.set(i.$4N.ExtHostNotebookDocumentSaveParticipant,new ut.$hsc(Et,Ct,Ge.getProxy(i.$3N.MainThreadBulkEdits))),zt=Ge.set(i.$4N.ExtHostEditors,new pe.$Pqc(Ge,Mt)),Pi=Ge.set(i.$4N.ExtHostTreeViews,new fe.$Hsc(Ge.getProxy(i.$3N.MainThreadTreeViews),Dt,Et)),Di=Ge.set(i.$4N.ExtHostEditorInsets,new k.$Qqc(Ge.getProxy(i.$3N.MainThreadEditorInsets),zt,Pt.remote)),wi=Ge.set(i.$4N.ExtHostDiagnostics,new A.$Fqc(Ge,Et,ei,Mt)),bi=Ge.set(i.$4N.ExtHostLanguages,new Pe.$fsc(Ge,qt,Dt.converter,Zt)),me=Ge.set(i.$4N.ExtHostLanguageFeatures,new q.$Hqc(Ge,Zt,qt,Dt,wi,Et,Lt,Nt)),De=Ge.set(i.$4N.ExtHostFileSystem,new ae.$Vrc(Ge,me)),oe=Ge.set(i.$4N.ExtHostFileSystemEventService,new ce.$Wrc(Ge,Et,Mt)),K=Ge.set(i.$4N.ExtHostQuickOpen,(0,H.$ssc)(Ge,wt,Dt)),ke=Ge.set(i.$4N.ExtHostSCM,new re.$usc(Ge,Dt,qt,Et)),ze=Ge.set(i.$4N.ExtHostQuickDiff,new j.$rsc(Ge,Zt)),Xe=Ge.set(i.$4N.ExtHostShare,new Ue.$vsc(Ge,Zt)),Ve=Ge.set(i.$4N.ExtHostComments,(0,C.$Rqc)(Ge,Dt,qt)),ft=Ge.set(i.$4N.ExtHostProgress,new B.$qsc(Ge.getProxy(i.$3N.MainThreadProgress))),Tt=Ge.set(i.$4N.ExtHostLabelService,new Y.$dsc(Ge)),Yt=Ge.set(i.$4N.ExtHostTheming,new ye.$Esc(Ge)),Vt=Ge.set(i.$4N.ExtHostTimeline,new Ce.$Gsc(Ge,Dt)),Wt=Ge.set(i.$4N.ExtHostWebviews,new st.$6qc(Ge,Pt.remote,wt,Et,Lt)),Ni=Ge.set(i.$4N.ExtHostWebviewPanels,new ht.$9qc(Ge,Wt,wt)),en=Ge.set(i.$4N.ExtHostCustomEditors,new $.$0qc(Ge,qt,ci,Wt,Ni)),Vi=Ge.set(i.$4N.ExtHostWebviewViews,new gt.$Ksc(Ge,Wt)),Ei=Ge.set(i.$4N.ExtHostTesting,$t.get(he.$Erc)),tn=Ge.set(i.$4N.ExtHostUriOpeners,new de.$Isc(Ge)),nn=Ge.set(i.$4N.ExtHostProfileContentHandlers,new Le.$psc(Ge));Ge.set(i.$4N.ExtHostInteractive,new Ie.$csc(Ge,Ct,Mt,Dt,Et));const Ui=Ge.set(i.$4N.ExtHostChatAgents2,new g.$Mqc(Ge,Et,Dt,qt)),rn=Ge.set(i.$4N.ExtHostChatVariables,new d.$Nqc(Ge)),Bi=Ge.set(i.$4N.ExtHostLanguageModelTools,new ie.$esc(Ge)),Qi=Ge.set(i.$4N.ExtHostAiRelatedInformation,new n.$yqc(Ge)),sn=Ge.set(i.$4N.ExtHostAiEmbeddingVector,new ue.$Urc(Ge)),on=Ge.set(i.$4N.ExtHostStatusBar,new _e.$ysc(Ge,Dt.converter)),wn=Ge.set(i.$4N.ExtHostSpeech,new Je.$wsc(Ge)),Ci=Ge.set(i.$4N.ExtHostEmbeddings,new ne.$Trc(Ge)),Hi=Object.values(i.$4N);Ge.assertRegistered(Hi);const bn=new m.$Lqc(Ge,Mt),vn=new S.$Oqc(Ge),Wi=new xe.$gsc(Ge,Et),an=new L.$Qrc(Ge);return t.$Iqc.register(Dt),function(Ae,mi,Ki){function ct(ee){return(le,Oe,dt)=>{const It=ee(Ft=>{try{le.call(Oe,Ft)}catch(Ti){D.$3(new Error(`[ExtensionListenerError] Extension '${Ae.identifier.value}' FAILED to handle event: ${Ti.toString()}`,{cause:Ti})),Nt.onExtensionError(Ae.identifier,Ti)}});return dt?.push(It),It}}const kt=function(){let ee=!Ae.isUnderDevelopment;function le(){ee||(Et.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Oe(dt){if(Array.isArray(dt))dt.forEach(Oe);else if(typeof dt=="string")le();else{const It=dt;typeof It.scheme>"u"&&le(),typeof It.exclusive=="boolean"&&(0,Ze.$vH)(Ae,"documentFiltersExclusive")}return dt}}(),yn={getSession(ee,le,Oe){return typeof Oe?.forceNewSession=="object"&&Oe.forceNewSession.learnMore&&(0,Ze.$vH)(Ae,"authLearnMore"),Kt.getSession(Ae,ee,le,Oe)},getAccounts(ee){return Kt.getAccounts(ee)},async hasSession(ee,le){return(0,Ze.$vH)(Ae,"authSession"),!!await Kt.getSession(Ae,ee,le,{silent:!0})},get onDidChangeSessions(){return ct(Kt.onDidChangeSessions)},registerAuthenticationProvider(ee,le,Oe,dt){return Kt.registerAuthenticationProvider(ee,le,Oe,dt)}},Gi={registerCommand(ee,le,Oe){return Dt.registerCommand(!0,ee,le,Oe,void 0,Ae)},registerTextEditorCommand(ee,le,Oe){return Dt.registerCommand(!0,ee,(...dt)=>{const It=zt.getActiveTextEditor();if(!It){Et.warn("Cannot execute "+ee+" because there is no active text editor.");return}return It.edit(Ft=>{le.apply(Oe,[It,Ft,...dt])}).then(Ft=>{Ft||Et.warn("Edits from command "+ee+" were not applied.")},Ft=>{Et.warn("An error occurred while running command "+ee,Ft)})},void 0,void 0,Ae)},registerDiffInformationCommand:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"diffCommand"),Dt.registerCommand(!0,ee,async(...dt)=>{const It=Mt.activeEditor(!0);if(!It){Et.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(It.id);le.apply(Oe,[Ft,...dt])},void 0,void 0,Ae)),executeCommand(ee,...le){return Dt.executeCommand(ee,...le)},getCommands(ee=!1){return Dt.getCommands(ee)}},Ji={get machineId(){return Pt.telemetryInfo.machineId},get sessionId(){return Pt.telemetryInfo.sessionId},get language(){return Pt.environment.appLanguage},get appName(){return Pt.environment.appName},get appRoot(){return Pt.environment.appRoot?.fsPath??""},get appHost(){return Pt.environment.appHost},get uriScheme(){return Pt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ct(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$vH)(Ae,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$vH)(Ae,"telemetry"),ct(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$WQ)(Pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,le){return ot.$VQ.validateSender(ee),Nt.instantiateLogger(Ae,ee,le)},openExternal(ee,le){return Bt.openUri(ee,{allowTunneling:!!Pt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===Pt.environment.appUriScheme)return yi.createAppUri(ee);try{return await Bt.asExternalUri(ee,{allowTunneling:!!Pt.remote.authority})}catch(le){if((0,R.$Rg)(ee,R.Schemas.http)||(0,R.$Rg)(ee,R.Schemas.https))return ee;throw le}},get remoteName(){return(0,c.$ln)(Pt.remote.authority)},get remoteAuthority(){return(0,Ze.$vH)(Ae,"resolvers"),Pt.remote.authority},get uiKind(){return Pt.uiKind},get logLevel(){return Et.getLevel()},get onDidChangeLogLevel(){return ct(Et.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$vH)(Ae,"resolvers"),Pt.quality},get appCommit(){return(0,Ze.$vH)(Ae,"resolvers"),Pt.commit}};Pt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(ee,le,Oe){return Ei.createTestController(Ae,ee,le,Oe)},createTestObserver(){return(0,Ze.$vH)(Ae,"testObserver"),Ei.createTestObserver()},runTests(ee){return(0,Ze.$vH)(Ae,"testObserver"),Ei.runTests(ee)},registerTestFollowupProvider(ee){return(0,Ze.$vH)(Ae,"testObserver"),Ei.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Ze.$vH)(Ae,"testObserver"),ct(Ei.onResultsChanged)},get testResults(){return(0,Ze.$vH)(Ae,"testObserver"),Ei.results}},Ri=Pt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Sn={getExtension(ee,le){(0,Ze.$uH)(Ae,"extensionsAny")||(le=!1);const Oe=mi.mine.getExtensionDescription(ee);if(Oe)return new _.$Arc(Ht,Ae.identifier,Oe,Ri,!1);if(le){const dt=mi.all.getExtensionDescription(ee);if(dt)return new _.$Arc(Ht,Ae.identifier,dt,Ri,!0)}},get all(){const ee=[];for(const le of mi.mine.getAllExtensionDescriptions())ee.push(new _.$Arc(Ht,Ae.identifier,le,Ri,!1));return ee},get allAcrossExtensionHosts(){(0,Ze.$vH)(Ae,"extensionsAny");const ee=new E.$vn(mi.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),le=[];for(const Oe of mi.all.getAllExtensionDescriptions()){const dt=!ee.has(Oe.identifier);le.push(new _.$Arc(Ht,Ae.identifier,Oe,Ri,dt))}return le},get onDidChange(){return(0,Ze.$uH)(Ae,"extensionsAny")?ct(P.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ct(mi.mine.onDidChange)}},pi={createDiagnosticCollection(ee){return wi.createDiagnosticCollection(Ae.identifier,ee)},get onDidChangeDiagnostics(){return ct(wi.onDidChangeDiagnostics)},getDiagnostics:ee=>wi.getDiagnostics(ee),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(ee,le){return bi.changeLanguage(ee.uri,le)},match(ee,le){const Oe=X.LanguageSelector.from(ee);let dt;return(0,I.$Cu)(Oe)&&(dt=Ct.notebookDocuments.find(It=>It.apiNotebook.getCells().find(Ft=>Ft.document===le))?.apiNotebook),(0,I.$Bu)(Oe,le.uri,le.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ee,le,Oe){return me.registerCodeActionProvider(Ae,kt(ee),le,Oe)},registerDocumentPasteEditProvider(ee,le,Oe){return(0,Ze.$vH)(Ae,"documentPaste"),me.registerDocumentPasteEditProvider(Ae,kt(ee),le,Oe)},registerCodeLensProvider(ee,le){return me.registerCodeLensProvider(Ae,kt(ee),le)},registerDefinitionProvider(ee,le){return me.registerDefinitionProvider(Ae,kt(ee),le)},registerDeclarationProvider(ee,le){return me.registerDeclarationProvider(Ae,kt(ee),le)},registerImplementationProvider(ee,le){return me.registerImplementationProvider(Ae,kt(ee),le)},registerTypeDefinitionProvider(ee,le){return me.registerTypeDefinitionProvider(Ae,kt(ee),le)},registerHoverProvider(ee,le){return me.registerHoverProvider(Ae,kt(ee),le,Ae.identifier)},registerEvaluatableExpressionProvider(ee,le){return me.registerEvaluatableExpressionProvider(Ae,kt(ee),le,Ae.identifier)},registerInlineValuesProvider(ee,le){return me.registerInlineValuesProvider(Ae,kt(ee),le,Ae.identifier)},registerDocumentHighlightProvider(ee,le){return me.registerDocumentHighlightProvider(Ae,kt(ee),le)},registerMultiDocumentHighlightProvider(ee,le){return me.registerMultiDocumentHighlightProvider(Ae,kt(ee),le)},registerLinkedEditingRangeProvider(ee,le){return me.registerLinkedEditingRangeProvider(Ae,kt(ee),le)},registerReferenceProvider(ee,le){return me.registerReferenceProvider(Ae,kt(ee),le)},registerRenameProvider(ee,le){return me.registerRenameProvider(Ae,kt(ee),le)},registerNewSymbolNamesProvider(ee,le){return(0,Ze.$vH)(Ae,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Ae,kt(ee),le)},registerDocumentSymbolProvider(ee,le,Oe){return me.registerDocumentSymbolProvider(Ae,kt(ee),le,Oe)},registerWorkspaceSymbolProvider(ee){return me.registerWorkspaceSymbolProvider(Ae,ee)},registerDocumentFormattingEditProvider(ee,le){return me.registerDocumentFormattingEditProvider(Ae,kt(ee),le)},registerDocumentRangeFormattingEditProvider(ee,le){return me.registerDocumentRangeFormattingEditProvider(Ae,kt(ee),le)},registerOnTypeFormattingEditProvider(ee,le,Oe,...dt){return me.registerOnTypeFormattingEditProvider(Ae,kt(ee),le,[Oe].concat(dt))},registerDocumentSemanticTokensProvider(ee,le,Oe){return me.registerDocumentSemanticTokensProvider(Ae,kt(ee),le,Oe)},registerDocumentRangeSemanticTokensProvider(ee,le,Oe){return me.registerDocumentRangeSemanticTokensProvider(Ae,kt(ee),le,Oe)},registerSignatureHelpProvider(ee,le,Oe,...dt){return typeof Oe=="object"?me.registerSignatureHelpProvider(Ae,kt(ee),le,Oe):me.registerSignatureHelpProvider(Ae,kt(ee),le,typeof Oe>"u"?[]:[Oe,...dt])},registerCompletionItemProvider(ee,le,...Oe){return me.registerCompletionItemProvider(Ae,kt(ee),le,Oe)},registerInlineCompletionItemProvider(ee,le,Oe){return le.handleDidShowCompletionItem&&(0,Ze.$vH)(Ae,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$vH)(Ae,"inlineCompletionsAdditions"),Oe&&(0,Ze.$vH)(Ae,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Ae,kt(ee),le,Oe)},registerInlineEditProvider(ee,le){return(0,Ze.$vH)(Ae,"inlineEdit"),me.registerInlineEditProvider(Ae,kt(ee),le)},registerDocumentLinkProvider(ee,le){return me.registerDocumentLinkProvider(Ae,kt(ee),le)},registerColorProvider(ee,le){return me.registerColorProvider(Ae,kt(ee),le)},registerFoldingRangeProvider(ee,le){return me.registerFoldingRangeProvider(Ae,kt(ee),le)},registerSelectionRangeProvider(ee,le){return me.registerSelectionRangeProvider(Ae,ee,le)},registerCallHierarchyProvider(ee,le){return me.registerCallHierarchyProvider(Ae,ee,le)},registerTypeHierarchyProvider(ee,le){return me.registerTypeHierarchyProvider(Ae,ee,le)},setLanguageConfiguration:(ee,le)=>me.setLanguageConfiguration(Ae,ee,le),getTokenInformationAtPosition(ee,le){return(0,Ze.$vH)(Ae,"tokenInformation"),bi.tokenAtPosition(ee,le)},registerInlayHintsProvider(ee,le){return me.registerInlayHintsProvider(Ae,ee,le)},createLanguageStatusItem(ee,le){return bi.createLanguageStatusItem(Ae,ee,le)},registerDocumentDropEditProvider(ee,le,Oe){return me.registerDocumentOnDropEditProvider(Ae,ee,le,(0,Ze.$uH)(Ae,"documentPaste")?Oe:void 0)}},qi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,le,Oe){p.URI.isUri(ee)&&ee.scheme===R.Schemas.vscodeRemote&&!ee.authority&&Lt.report("workspace.showTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(p.URI.isUri(ee)?Promise.resolve(Zi.openTextDocument(ee)):Promise.resolve(ee));return zt.showTextDocument(dt,le,Oe)},createTextEditorDecorationType(ee){return zt.createTextEditorDecorationType(Ae,ee)},onDidChangeActiveTextEditor(ee,le,Oe){return ct(zt.onDidChangeActiveTextEditor)(ee,le,Oe)},onDidChangeVisibleTextEditors(ee,le,Oe){return ct(zt.onDidChangeVisibleTextEditors)(ee,le,Oe)},onDidChangeTextEditorSelection(ee,le,Oe){return ct(zt.onDidChangeTextEditorSelection)(ee,le,Oe)},onDidChangeTextEditorOptions(ee,le,Oe){return ct(zt.onDidChangeTextEditorOptions)(ee,le,Oe)},onDidChangeTextEditorVisibleRanges(ee,le,Oe){return ct(zt.onDidChangeTextEditorVisibleRanges)(ee,le,Oe)},onDidChangeTextEditorViewColumn(ee,le,Oe){return ct(zt.onDidChangeTextEditorViewColumn)(ee,le,Oe)},onDidCloseTerminal(ee,le,Oe){return ct(bt.onDidCloseTerminal)(ee,le,Oe)},onDidOpenTerminal(ee,le,Oe){return ct(bt.onDidOpenTerminal)(ee,le,Oe)},onDidChangeActiveTerminal(ee,le,Oe){return ct(bt.onDidChangeActiveTerminal)(ee,le,Oe)},onDidChangeTerminalDimensions(ee,le,Oe){return(0,Ze.$vH)(Ae,"terminalDimensions"),ct(bt.onDidChangeTerminalDimensions)(ee,le,Oe)},onDidChangeTerminalState(ee,le,Oe){return ct(bt.onDidChangeTerminalState)(ee,le,Oe)},onDidWriteTerminalData(ee,le,Oe){return(0,Ze.$vH)(Ae,"terminalDataWriteEvent"),ct(bt.onDidWriteTerminalData)(ee,le,Oe)},onDidExecuteTerminalCommand(ee,le,Oe){return(0,Ze.$vH)(Ae,"terminalExecuteCommandEvent"),ct(bt.onDidExecuteTerminalCommand)(ee,le,Oe)},onDidChangeTerminalShellIntegration(ee,le,Oe){return ct(Jt.onDidChangeTerminalShellIntegration)(ee,le,Oe)},onDidStartTerminalShellExecution(ee,le,Oe){return ct(Jt.onDidStartTerminalShellExecution)(ee,le,Oe)},onDidEndTerminalShellExecution(ee,le,Oe){return ct(Jt.onDidEndTerminalShellExecution)(ee,le,Oe)},get state(){return Bt.getState()},onDidChangeWindowState(ee,le,Oe){return ct(Bt.onDidChangeWindowState)(ee,le,Oe)},showInformationMessage(ee,...le){return Wi.showMessage(Ae,O.default.Info,ee,le[0],le.slice(1))},showWarningMessage(ee,...le){return Wi.showMessage(Ae,O.default.Warning,ee,le[0],le.slice(1))},showErrorMessage(ee,...le){return Wi.showMessage(Ae,O.default.Error,ee,le[0],le.slice(1))},showQuickPick(ee,le,Oe){return K.showQuickPick(Ae,ee,le,Oe)},showWorkspaceFolderPick(ee){return K.showWorkspaceFolderPick(ee)},showInputBox(ee,le){return K.showInput(ee,le)},showOpenDialog(ee){return an.showOpenDialog(Ae,ee)},showSaveDialog(ee){return an.showSaveDialog(ee)},createStatusBarItem(ee,le,Oe){let dt,It,Ft;return typeof ee=="string"?(dt=ee,It=le,Ft=Oe):(It=ee,Ft=le),on.createStatusBarEntry(Ae,dt,It,Ft)},setStatusBarMessage(ee,le){return on.setStatusBarMessage(ee,le)},withScmProgress(ee){return Lt.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),ft.withProgress(Ae,{location:W.ProgressLocation.SourceControl},(le,Oe)=>ee({report(dt){}}))},withProgress(ee,le){return ft.withProgress(Ae,ee,le)},createOutputChannel(ee,le){return Mi.createOutputChannel(ee,le,Ae)},createWebviewPanel(ee,le,Oe,dt){return Ni.createWebviewPanel(Ae,ee,le,Oe,dt)},createWebviewTextEditorInset(ee,le,Oe,dt){return(0,Ze.$vH)(Ae,"editorInsets"),Di.createWebviewEditorInset(ee,le,Oe,dt,Ae)},createTerminal(ee,le,Oe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,le,Oe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,le){return bt.registerProfileProvider(Ae,ee,le)},registerTerminalQuickFixProvider(ee,le){return(0,Ze.$vH)(Ae,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Ae.identifier.value,le)},registerTreeDataProvider(ee,le){return Pi.registerTreeDataProvider(ee,le,Ae)},createTreeView(ee,le){return Pi.createTreeView(ee,le,Ae)},registerWebviewPanelSerializer:(ee,le)=>Ni.registerWebviewPanelSerializer(Ae,ee,le),registerCustomEditorProvider:(ee,le,Oe={})=>en.registerCustomEditorProvider(Ae,ee,le,Oe),registerFileDecorationProvider(ee){return li.registerFileDecorationProvider(ee,Ae)},registerUriHandler(ee){return yi.registerUriHandler(Ae,ee)},createQuickPick(){return K.createQuickPick(Ae)},createInputBox(){return K.createInputBox(Ae)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(ee,le,Oe){return ct(Yt.onDidChangeActiveColorTheme)(ee,le,Oe)},registerWebviewViewProvider(ee,le,Oe){return Vi.registerWebviewViewProvider(Ae,ee,le,Oe?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,le,Oe){return ct(Ct.onDidChangeActiveNotebookEditor)(ee,le,Oe)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,le,Oe){return ct(Ai.onDidChangeNotebookEditorSelection)(ee,le,Oe)},onDidChangeNotebookEditorVisibleRanges(ee,le,Oe){return ct(Ai.onDidChangeNotebookEditorVisibleRanges)(ee,le,Oe)},showNotebookDocument(ee,le){return Ct.showNotebookDocument(ee,le)},registerExternalUriOpener(ee,le,Oe){return(0,Ze.$vH)(Ae,"externalUriOpener"),tn.registerExternalUriOpener(Ae.identifier,ee,le,Oe)},registerProfileContentHandler(ee,le){return(0,Ze.$vH)(Ae,"profileContentHandlers"),nn.registerProfileContentHandler(Ae,ee,le)},registerQuickDiffProvider(ee,le,Oe,dt){return(0,Ze.$vH)(Ae,"quickDiffProvider"),ze.registerQuickDiffProvider(kt(ee),le,Oe,dt)},get tabGroups(){return ni.tabGroups},registerShareProvider(ee,le){return(0,Ze.$vH)(Ae,"shareProvider"),Xe.registerShareProvider(kt(ee),le)}},Zi={get rootPath(){return Lt.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ee){throw new D.$$("rootPath")},getWorkspaceFolder(ee){return wt.getWorkspaceFolder(ee)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ee){throw new D.$$("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ee){throw new D.$$("workspaceFile")},updateWorkspaceFolders:(ee,le,...Oe)=>wt.updateWorkspaceFolders(Ae,ee,le||0,...Oe),onDidChangeWorkspaceFolders:function(ee,le,Oe){return ct(wt.onDidChangeWorkspace)(ee,le,Oe)},asRelativePath:(ee,le)=>wt.getRelativePath(ee,le),findFiles:(ee,le,Oe,dt)=>wt.findFiles(ee,le,Oe,Ae.identifier,dt),findFiles2:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"findFiles2"),wt.findFiles2(ee,le,Ae.identifier,Oe)),findFiles2New:(ee,le,Oe)=>{(0,Ze.$vH)(Ae,"findFiles2New");const dt={exclude:le?.exclude&&le.exclude.length>0?le.exclude[0]:void 0,useDefaultExcludes:!le?.useExcludeSettings||le?.useExcludeSettings===Ot.ExcludeSettingOptions.FilesExclude||le?.useExcludeSettings===Ot.ExcludeSettingOptions.SearchAndFilesExclude,useDefaultSearchExcludes:!le?.useExcludeSettings||le?.useExcludeSettings===Ot.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:le?.maxResults,useIgnoreFiles:le?.useIgnoreFiles?.local,useGlobalIgnoreFiles:le?.useIgnoreFiles?.global,useParentIgnoreFiles:le?.useIgnoreFiles?.parent,followSymlinks:le?.followSymlinks};return wt.findFiles2(ee&&ee.length>0?ee[0]:void 0,dt,Ae.identifier,Oe)},findTextInFiles:(ee,le,Oe,dt)=>{(0,Ze.$vH)(Ae,"findTextInFiles");let It,Ft;return typeof le=="object"?(It=le,Ft=Oe):(It={},Ft=le,dt=Oe),wt.findTextInFiles(ee,It||{},Ft,Ae.identifier,dt)},findTextInFilesNew:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"findTextInFilesNew"),(0,Ze.$vH)(Ae,"textSearchProviderNew"),wt.findTextInFilesNew(ee,Ae.identifier,le||{},Oe)),save:ee=>wt.save(ee),saveAs:ee=>wt.saveAs(ee),saveAll:ee=>wt.saveAll(ee),applyEdit(ee,le){return bn.applyWorkspaceEdit(ee,Ae,le)},createFileSystemWatcher:(ee,le,Oe,dt)=>{let It;return typeof le=="boolean"?It={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!dt,correlate:!1}:le&&((0,Ze.$vH)(Ae,"createFileSystemWatcher"),It={...le,correlate:!0}),oe.createFileSystemWatcher(wt,Ae,ee,It)},get textDocuments(){return qt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new D.$$("textDocuments")},openTextDocument(ee){let le;const Oe=ee;if(typeof ee=="string")le=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))le=Promise.resolve(ee);else if(!Oe||typeof Oe=="object")le=qt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(dt=>(Et.trace(`openTextDocument from ${Ae.identifier}`),dt.scheme===R.Schemas.vscodeRemote&&!dt.authority&&Lt.report("workspace.openTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(dt).then(It=>It.document)))},onDidOpenTextDocument:(ee,le,Oe)=>ct(qt.onDidAddDocument)(ee,le,Oe),onDidCloseTextDocument:(ee,le,Oe)=>ct(qt.onDidRemoveDocument)(ee,le,Oe),onDidChangeTextDocument:(ee,le,Oe)=>ct(qt.onDidChangeDocument)(ee,le,Oe),onDidSaveTextDocument:(ee,le,Oe)=>ct(qt.onDidSaveDocument)(ee,le,Oe),onWillSaveTextDocument:(ee,le,Oe)=>ct(Fi.getOnWillSaveTextDocumentEvent(Ae))(ee,le,Oe),get notebookDocuments(){return Ct.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,le){let Oe;if(p.URI.isUri(ee))Oe=ee,await Ct.openNotebookDocument(ee);else if(typeof ee=="string")Oe=p.URI.revive(await Ct.createNotebookDocument({viewType:ee,content:le}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ee,le,Oe){return ct(Si.onDidSaveNotebookDocument)(ee,le,Oe)},onDidChangeNotebookDocument(ee,le,Oe){return ct(Si.onDidChangeNotebookDocument)(ee,le,Oe)},onWillSaveNotebookDocument(ee,le,Oe){return ct(ji.getOnWillSaveNotebookDocumentEvent(Ae))(ee,le,Oe)},get onDidOpenNotebookDocument(){return ct(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,le,Oe,dt){return Ct.registerNotebookSerializer(Ae,ee,le,Oe,(0,Ze.$uH)(Ae,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ee,le,Oe)=>ct(Ki.onDidChangeConfiguration)(ee,le,Oe),getConfiguration(ee,le){return le=arguments.length===1?void 0:le,Ki.getConfiguration(ee,le,Ae)},registerTextDocumentContentProvider(ee,le){return fi.registerTextDocumentContentProvider(ee,le)},registerTaskProvider:(ee,le)=>(Lt.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Xt.registerTaskProvider(Ae,ee,le)),registerFileSystemProvider(ee,le,Oe){return(0,N.$Uc)(De.registerFileSystemProvider(Ae,ee,le,Oe),ti.addFileSystemProvider(ee,le,Oe))},get fs(){return ti.value},registerFileSearchProvider:(ee,le)=>((0,Ze.$vH)(Ae,"fileSearchProvider"),hi.registerFileSearchProviderOld(ee,le)),registerTextSearchProvider:(ee,le)=>((0,Ze.$vH)(Ae,"textSearchProvider"),hi.registerTextSearchProviderOld(ee,le)),registerAITextSearchProvider:(ee,le)=>((0,Ze.$vH)(Ae,"aiTextSearchProvider"),(0,Ze.$vH)(Ae,"textSearchProvider"),hi.registerAITextSearchProviderOld(ee,le)),registerFileSearchProviderNew:(ee,le)=>((0,Ze.$vH)(Ae,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(ee,le)=>((0,Ze.$vH)(Ae,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(ee,le)=>((0,Ze.$vH)(Ae,"aiTextSearchProviderNew"),(0,Ze.$vH)(Ae,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(ee,le)=>((0,Ze.$vH)(Ae,"resolvers"),Ht.registerRemoteAuthorityResolver(ee,le)),registerResourceLabelFormatter:ee=>((0,Ze.$vH)(Ae,"resolvers"),Tt.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ze.$vH)(Ae,"resolvers"),Ht.getRemoteExecServer(ee)),onDidCreateFiles:(ee,le,Oe)=>ct(oe.onDidCreateFile)(ee,le,Oe),onDidDeleteFiles:(ee,le,Oe)=>ct(oe.onDidDeleteFile)(ee,le,Oe),onDidRenameFiles:(ee,le,Oe)=>ct(oe.onDidRenameFile)(ee,le,Oe),onWillCreateFiles:(ee,le,Oe)=>ct(oe.getOnWillCreateFileEvent(Ae))(ee,le,Oe),onWillDeleteFiles:(ee,le,Oe)=>ct(oe.getOnWillDeleteFileEvent(Ae))(ee,le,Oe),onWillRenameFiles:(ee,le,Oe)=>ct(oe.getOnWillRenameFileEvent(Ae))(ee,le,Oe),openTunnel:ee=>((0,Ze.$vH)(Ae,"tunnels"),jt.openTunnel(Ae,ee).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Ze.$vH)(Ae,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"tunnels"),ct(jt.onDidChangeTunnels)(ee,le,Oe)),registerPortAttributesProvider:(ee,le)=>((0,Ze.$vH)(Ae,"portsAttributes"),jt.registerPortsAttributesProvider(ee,le)),registerTunnelProvider:(ee,le)=>((0,Ze.$vH)(Ae,"tunnelFactory"),jt.registerTunnelProvider(ee,le)),registerTimelineProvider:(ee,le)=>((0,Ze.$vH)(Ae,"timeline"),Vt.registerTimelineProvider(ee,le,Ae.identifier,Dt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ee=>((0,Ze.$vH)(Ae,"workspaceTrust"),wt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,le,Oe)=>ct(wt.onDidGrantWorkspaceTrust)(ee,le,Oe),registerEditSessionIdentityProvider:(ee,le)=>((0,Ze.$vH)(Ae,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ee,le)),onWillCreateEditSessionIdentity:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"editSessionIdentityProvider"),ct(wt.getOnWillCreateEditSessionIdentityEvent(Ae))(ee,le,Oe)),registerCanonicalUriProvider:(ee,le)=>((0,Ze.$vH)(Ae,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ee,le)),getCanonicalUri:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"canonicalUriProvider"),wt.provideCanonicalUri(ee,le,Oe))},cn={get inputBox(){return Lt.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),ke.getLastInputBox(Ae)},createSourceControl(ee,le,Oe){return ke.createSourceControl(Ae,ee,le,Oe)}},ln={createCommentController(ee,le){return Ve.createCommentController(Ae,ee,le)}},un={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(ee,le){return(0,Ze.$vH)(Ae,"debugVisualization"),St.registerDebugVisualizationProvider(Ae,ee,le)},registerDebugVisualizationTreeProvider(ee,le){return(0,Ze.$vH)(Ae,"debugVisualization"),St.registerDebugVisualizationTree(Ae,ee,le)},onDidStartDebugSession(ee,le,Oe){return ct(St.onDidStartDebugSession)(ee,le,Oe)},onDidTerminateDebugSession(ee,le,Oe){return ct(St.onDidTerminateDebugSession)(ee,le,Oe)},onDidChangeActiveDebugSession(ee,le,Oe){return ct(St.onDidChangeActiveDebugSession)(ee,le,Oe)},onDidReceiveDebugSessionCustomEvent(ee,le,Oe){return ct(St.onDidReceiveDebugSessionCustomEvent)(ee,le,Oe)},onDidChangeBreakpoints(ee,le,Oe){return ct(St.onDidChangeBreakpoints)(ee,le,Oe)},onDidChangeActiveStackItem(ee,le,Oe){return ct(St.onDidChangeActiveStackItem)(ee,le,Oe)},registerDebugConfigurationProvider(ee,le,Oe){return St.registerDebugConfigurationProvider(ee,le,Oe||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,le){return St.registerDebugAdapterDescriptorFactory(Ae,ee,le)},registerDebugAdapterTrackerFactory(ee,le){return St.registerDebugAdapterTrackerFactory(ee,le)},startDebugging(ee,le,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?St.startDebugging(ee,le,{parentSession:Oe}):St.startDebugging(ee,le,Oe||{})},stopDebugging(ee){return St.stopDebugging(ee)},addBreakpoints(ee){return St.addBreakpoints(ee)},removeBreakpoints(ee){return St.removeBreakpoints(ee)},asDebugSourceUri(ee,le){return St.asDebugSourceUri(ee,le)}},En={registerTaskProvider:(ee,le)=>Xt.registerTaskProvider(Ae,ee,le),fetchTasks:ee=>Xt.fetchTasks(ee),executeTask:ee=>Xt.executeTask(Ae,ee),get taskExecutions(){return Xt.taskExecutions},onDidStartTask:(ee,le,Oe)=>ct(Xt.onDidStartTask)(ee,le,Oe),onDidEndTask:(ee,le,Oe)=>ct(Xt.onDidEndTask)(ee,le,Oe),onDidStartTaskProcess:(ee,le,Oe)=>ct(Xt.onDidStartTaskProcess)(ee,le,Oe),onDidEndTaskProcess:(ee,le,Oe)=>ct(Xt.onDidEndTaskProcess)(ee,le,Oe)},hn={createNotebookController(ee,le,Oe,dt,It){return gi.createNotebookController(Ae,ee,le,Oe,dt,(0,Ze.$uH)(Ae,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ee,le)=>Ct.registerNotebookCellStatusBarItemProvider(Ae,ee,le),createRendererMessaging(ee){return zi.createRendererMessaging(Ae,ee)},createNotebookControllerDetectionTask(ee){return(0,Ze.$vH)(Ae,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Ae,ee)},registerKernelSourceActionProvider(ee,le){return(0,Ze.$vH)(Ae,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Ae,ee,le)},onDidChangeNotebookCellExecutionState(ee,le,Oe){return(0,Ze.$vH)(Ae,"notebookCellExecutionState"),ct(gi.onDidChangeNotebookCellExecutionState)(ee,le,Oe)}},dn={t(...ee){if(typeof ee[0]=="string"){const le=ee.shift(),Oe=!ee||typeof ee[0]!="object"?ee:ee[0];return di.getMessage(Ae.identifier.value,{message:le,args:Oe})}return di.getMessage(Ae.identifier.value,ee[0])},get bundle(){return di.getBundle(Ae.identifier.value)},get uri(){return di.getBundleUri(Ae.identifier.value)}},kn={transferActiveChat(ee){return(0,Ze.$vH)(Ae,"interactive"),Ui.transferActiveChat(ee)}},In={getRelatedInformation(ee,le){return(0,Ze.$vH)(Ae,"aiRelatedInformation"),Qi.getRelatedInformation(Ae,ee,le)},registerRelatedInformationProvider(ee,le){return(0,Ze.$vH)(Ae,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ae,ee,le)},registerEmbeddingVectorProvider(ee,le){return(0,Ze.$vH)(Ae,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Ae,ee,le)}},fn={registerChatResponseProvider(ee,le,Oe){return(0,Ze.$vH)(Ae,"chatProvider"),Gt.registerLanguageModel(Ae,ee,le,Oe)},registerChatVariableResolver(ee,le,Oe,dt,It,Ft,Ti,Yi){return(0,Ze.$vH)(Ae,"chatVariableResolver"),rn.registerVariableResolver(Ae,ee,le,Oe,dt,It,Ft,Ti,Yi?.id)},registerMappedEditsProvider(ee,le){return(0,Ze.$vH)(Ae,"mappedEditsProvider"),me.registerMappedEditsProvider(Ae,ee,le)},createChatParticipant(ee,le){return Ui.createChatAgent(Ae,ee,le)},createDynamicChatParticipant(ee,le,Oe){return(0,Ze.$vH)(Ae,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Ae,ee,le,Oe)},registerChatParticipantDetectionProvider(ee){return(0,Ze.$vH)(Ae,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(ee)}},Xi={selectChatModels:ee=>Gt.selectLanguageModels(Ae,ee??{}),onDidChangeChatModels:(ee,le,Oe)=>Gt.onDidChangeProviders(ee,le,Oe),registerChatModelProvider:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"chatProvider"),Gt.registerLanguageModel(Ae,ee,le,Oe)),get embeddingModels(){return(0,Ze.$vH)(Ae,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ee,le,Oe)=>((0,Ze.$vH)(Ae,"embeddings"),Ci.onDidChange(ee,le,Oe)),registerEmbeddingsProvider(ee,le){return(0,Ze.$vH)(Ae,"embeddings"),Ci.registerEmbeddingsProvider(Ae,ee,le)},async computeEmbeddings(ee,le,Oe){return(0,Ze.$vH)(Ae,"embeddings"),Ci.computeEmbeddings(ee,le,Oe)},registerTool(ee,le){return(0,Ze.$vH)(Ae,"lmTools"),Bi.registerTool(Ae,ee,le)},invokeTool(ee,le,Oe){return(0,Ze.$vH)(Ae,"lmTools"),Bi.invokeTool(ee,le,Oe)},get tools(){return(0,Ze.$vH)(Ae,"lmTools"),Bi.tools}},gn={registerSpeechProvider(ee,le){return(0,Ze.$vH)(Ae,"speech"),wn.registerProvider(Ae.identifier,ee,le)}};return{version:Pt.version,ai:In,authentication:yn,commands:Gi,comments:ln,chat:fn,debug:un,env:Ji,extensions:Sn,interactive:kn,l10n:dn,languages:pi,lm:Xi,notebooks:hn,scm:cn,speech:gn,tasks:En,tests:ki,window:qi,workspace:Zi,Breakpoint:W.$8O,TerminalOutputAnchor:W.TerminalOutputAnchor,ChatResultFeedbackKind:W.ChatResultFeedbackKind,ChatVariableLevel:W.ChatVariableLevel,ChatCompletionItem:W.$4P,CallHierarchyIncomingCall:W.$tO,CallHierarchyItem:W.$sO,CallHierarchyOutgoingCall:W.$uO,CancellationError:D.$7,CancellationTokenSource:y.$ze,CandidatePortSource:i.CandidatePortSource,CodeAction:W.$pO,CodeActionKind:W.$qO,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.$vO,Color:W.$IO,ColorInformation:W.$JO,ColorPresentation:W.$KO,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CommentThreadApplicability:W.CommentThreadApplicability,CommentThreadFocus:W.CommentThreadFocus,CompletionItem:W.$CO,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.$DO,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.$SO,DebugAdapterExecutable:W.$_O,DebugAdapterInlineImplementation:W.$cP,DebugAdapterNamedPipeServer:W.$bP,DebugAdapterServer:W.$aP,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DebugVisualization:W.$sP,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.$iO,DiagnosticRelatedInformation:W.$hO,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.$5N,DocumentHighlight:W.$lO,DocumentHighlightKind:W.DocumentHighlightKind,MultiDocumentHighlight:W.$mO,DocumentLink:W.$HO,DocumentSymbol:W.$oO,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.$fP,InlineValueText:W.$gP,InlineValueVariableLookup:W.$hP,InlineValueEvaluatableExpression:W.$iP,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:P.$oe,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.$uP,FileDecoration2:W.$uP,FileSystemError:W.$lP,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:W.$mP,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.$0O,InlineCompletionItem:W.$EO,InlineCompletionList:W.$FO,Hover:W.$jO,VerboseHover:W.$kO,HoverVerbosityAction:W.HoverVerbosityAction,IndentAction:b.IndentAction,Location:W.$gO,MarkdownString:W.$wO,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:W.$xO,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.$6N,ProcessExecution:W.$QO,ProgressLocation:W.ProgressLocation,QuickInputButtonLocation:W.QuickInputButtonLocation,QuickInputButtons:W.$tP,Range:W.$7N,RelativePattern:W.$6O,Selection:W.$8N,SelectionRange:W.$rO,SemanticTokens:W.$pP,SemanticTokensBuilder:W.$oP,SemanticTokensEdit:W.$qP,SemanticTokensEdits:W.$rP,SemanticTokensLegend:W.$nP,ShellExecution:W.$RO,ShellQuoting:W.ShellQuoting,SignatureHelp:W.$zO,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.$yO,SnippetString:W.$fO,SourceBreakpoint:W.$9O,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.$nO,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.$TO,TaskGroup:W.$PO,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.$LO,TerminalQuickFixTerminalCommand:W.$NO,TerminalQuickFixOpener:W.$MO,TerminalLocation:W.TerminalLocation,TerminalProfile:W.$OO,TerminalExitReason:W.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:W.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.$bO,SnippetTextEdit:W.$dO,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,SyntaxTokenType:W.SyntaxTokenType,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.$5O,ThemeIcon:W.$4O,TreeItem:W.$UO,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.$RP,UIKind:_t.UIKind,Uri:p.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.$eO,DocumentPasteTriggerKind:W.DocumentPasteTriggerKind,DocumentDropEdit:W.$1O,DocumentDropOrPasteEditKind:W.$2O,DocumentPasteEdit:W.$3O,InlayHint:W.$BO,InlayHintLabelPart:W.$AO,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.$aO,ResolvedAuthority:W.$$N,ManagedResolvedAuthority:W.$_N,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.$EP,NotebookRange:W.$wP,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.$xP,NotebookData:W.$yP,NotebookRendererScript:W.$CP,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.$AP,NotebookCellOutputItem:W.$zP,NotebookCellStatusBarItem:W.$BP,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.$cO,NotebookKernelSourceAction:W.$DP,NotebookVariablesRequestKind:W.NotebookVariablesRequestKind,PortAttributes:W.$GP,LinkedEditingRanges:W.$FP,TestResultState:W.TestResultState,TestRunRequest:W.$HP,TestMessage:W.$IP,TestMessageStackFrame:W.$KP,TestTag:W.$JP,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:Ot.TextSearchCompleteMessageType,DataTransfer:W.$ZO,DataTransferItem:W.$VO,TestCoverageCount:W.$LP,FileCoverage:W.$NP,FileCoverage2:W.$NP,StatementCoverage:W.$OP,BranchCoverage:W.$PP,DeclarationCoverage:W.$QP,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.$SP,TabInputTextDiff:W.$TP,TabInputTextMerge:W.$UP,TabInputCustom:W.$VP,TabInputNotebook:W.$XP,TabInputNotebookDiff:W.$YP,TabInputWebview:W.$WP,TabInputTerminal:W.$ZP,TabInputInteractiveWindow:W.$1P,TabInputChat:W.$2P,TabInputTextMultiDiff:W.$3P,TelemetryTrustedValue:l.$Ap,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,ChatCopyKind:W.ChatCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,DebugStackFrame:W.$dP,DebugThread:W.$eP,RelatedInformationType:W.RelatedInformationType,SpeechToTextStatus:W.SpeechToTextStatus,TextToSpeechStatus:W.TextToSpeechStatus,PartialAcceptTriggerKind:W.PartialAcceptTriggerKind,KeywordRecognitionStatus:W.KeywordRecognitionStatus,ChatResponseMarkdownPart:W.$5P,ChatResponseFileTreePart:W.$9P,ChatResponseAnchorPart:W.$0P,ChatResponseProgressPart:W.$$P,ChatResponseProgressPart2:W.$_P,ChatResponseReferencePart:W.$cQ,ChatResponseReferencePart2:W.$cQ,ChatResponseCodeCitationPart:W.$dQ,ChatResponseWarningPart:W.$aQ,ChatResponseTextEditPart:W.$fQ,ChatResponseMarkdownWithVulnerabilitiesPart:W.$6P,ChatResponseCommandButtonPart:W.$bQ,ChatResponseDetectedParticipantPart:W.$7P,ChatResponseConfirmationPart:W.$8P,ChatResponseMovePart:W.$eQ,ChatResponseReferencePartStatusKind:W.ChatResponseReferencePartStatusKind,ChatRequestTurn:W.$gQ,ChatResponseTurn:W.$hQ,ChatLocation:W.ChatLocation,ChatRequestEditorData:W.$iQ,ChatRequestNotebookData:W.$jQ,LanguageModelChatMessageRole:W.LanguageModelChatMessageRole,LanguageModelChatMessage:W.$lQ,LanguageModelChatMessageFunctionResultPart:W.$kQ,LanguageModelChatResponseTextPart:W.$nQ,LanguageModelChatResponseFunctionUsePart:W.$mQ,LanguageModelError:W.$rQ,NewSymbolName:W.$kP,NewSymbolNameTag:W.NewSymbolNameTag,NewSymbolNameTriggerKind:W.NewSymbolNameTriggerKind,InlineEdit:W.$sQ,InlineEditTriggerKind:W.InlineEditTriggerKind,ExcludeSettingOptions:Ot.ExcludeSettingOptions,TextSearchContextNew:Ot.$eM,TextSearchMatchNew:Ot.$dM,TextSearchCompleteMessageTypeNew:Ot.TextSearchCompleteMessageType}}}}),define(Re[277],Te([1,0,60,130,45,124,46,34,57,56,132,134,135,89,93,85,123,68,50,88,66,70,215,11,133,86,87,91,95,128,96]),function($e,e,y,D,P,N,R,O,p,s,I,b,u,E,f,r,c,l,h,i,n,t,o,a,m,g,d,S,k,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Ws)(g.$urc,g.$trc,y.InstantiationType.Delayed),(0,y.$Ws)(a.$ek,o.$Osc,y.InstantiationType.Delayed),(0,y.$Ws)(r.$zqc,r.$Aqc,y.InstantiationType.Delayed),(0,y.$Ws)(O.$ZQ,O.$YQ,y.InstantiationType.Eager),(0,y.$Ws)(S.$Jqc,S.$Kqc,y.InstantiationType.Eager),(0,y.$Ws)(k.$orc,k.$prc,y.InstantiationType.Eager),(0,y.$Ws)(R.$Yqc,R.$Wqc,y.InstantiationType.Eager),(0,y.$Ws)(l.$1qc,l.$Zqc,y.InstantiationType.Eager),(0,y.$Ws)(C.$Erc,C.$Frc,y.InstantiationType.Eager),(0,y.$Ws)(b.$Jrc,b.$Nrc,y.InstantiationType.Eager),(0,y.$Ws)(N.$Prc,N.$Orc,y.InstantiationType.Eager),(0,y.$Ws)(p.$OQ,p.$NQ,y.InstantiationType.Eager),(0,y.$Ws)(d.$vrc,d.$wrc,y.InstantiationType.Eager),(0,y.$Ws)(h.$Dqc,h.$Cqc,y.InstantiationType.Eager),(0,y.$Ws)(D.$osc,D.$nsc,y.InstantiationType.Delayed),(0,y.$Ws)(u.$$rc,u.$_rc,y.InstantiationType.Eager),(0,y.$Ws)(E.$hrc,E.$grc,y.InstantiationType.Eager),(0,y.$Ws)(I.$Bsc,I.$Asc,y.InstantiationType.Eager),(0,y.$Ws)(s.$krc,s.$nrc,y.InstantiationType.Eager),(0,y.$Ws)(v.$Csc,v.$Dsc,y.InstantiationType.Eager),(0,y.$Ws)(f.$TGb,f.$UGb,y.InstantiationType.Eager),(0,y.$Ws)(c.$Msc,c.$Lsc,y.InstantiationType.Eager),(0,y.$Ws)(P.$Vqc,P.$Uqc,y.InstantiationType.Eager),(0,y.$Ws)(i.$rrc,i.$qrc,y.InstantiationType.Eager),(0,y.$Ws)(n.$XQ,n.$UQ,y.InstantiationType.Eager),(0,y.$Ws)(t.$$qc,t.$_qc,y.InstantiationType.Eager),(0,y.$Ws)(m.$Crc,m.$Drc,y.InstantiationType.Eager)}),define(Re[278],Te([1,0,276,47,2,272,7,10,222]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3uc=void 0;class s extends N.$Rsc{j(){}getModule(E,f){for(const r of this.b){const c=r(E);if(c){E=c;break}}if(this.a.has(E))return this.a.get(E).load(E,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends D.$yrc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$2uc);const E=this.h.invokeFunction(y.$Nsc);this.r=this.h.createInstance(s,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,f,r){f=f.with({path:b(f.path,".js")});const c=E?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const l=P.URI.revive(await this.C.$asBrowserUri(f)),h=await fetch(l.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),n=`${f.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(d){throw console.error(c?`Loading code for extension ${c} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${f.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}E&&await this.w.initializeLocalizedMessages(E);const a={},m={exports:a},g=d=>{const S=this.r.getModule(d,f);if(S===void 0)throw new Error(`Cannot load module '${d}'`);return S};try{return r.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),o(m,a,g),m.exports!==a?m.exports:a}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+E;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.$Jh)(10)}}e.$3uc=I;function b(u,E){return u.endsWith(E)?u:u+E}}),define(Re[279],Te([1,0,74,60,11,47,187,92,278]),function($e,e,y,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Ws)(P.$dk,new y.$Fi(R.$Qsc,[!0],!0)),(0,D.$Ws)(N.$zrc,p.$3uc,D.InstantiationType.Eager),(0,D.$Ws)(O.$2qc,O.$3qc,D.InstantiationType.Eager)}),define(Re[287],Te([1,0,20,6,84,273,224,22,64,15,2,277,279]),function($e,e,y,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,O=qe(O),p=qe(p);const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(o){return/^(file|vscode-remote):/i.test(o)}const f=fetch.bind(self);function r(o){self.fetch=async function(a,m){return a instanceof Request||E(String(a))&&(a=(await o(I.URI.parse(String(a)))).toString(!0)),f(a,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,m,g,d,S){(async()=>(E(m.toString())&&(m=(await o(I.URI.parse(m.toString()))).toString(!0)),super.open(a,m,g??!0,d,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(a,m){if(/^file:/i.test(a.toString()))a=s.$3g.uriToBrowserUri(I.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(C){function T(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const $=fetch.bind(self);self.fetch=function(M,A){return M instanceof Request?$(M,A):$(T(M),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,A,L,Z,J){return super.open(M,T(A),L??!0,Z,J)}};const w=importScripts.bind(self);self.importScripts=(...M)=>{w(...M.map(T))},w(C)}.toString()}('${a}'))`;m=m||{},m.name=`${name} -> ${m.name||O.$qc(a.toString())}`;const S=new Blob([d],{type:"application/javascript"}),k=URL.createObjectURL(S);return new o(k,m)}}else self.Worker=class extends R.$4uc{constructor(o,a){super(u,o,{name:O.$qc(o.toString()),...a})}};const c=new class{constructor(){this.pid=void 0}exit(o){b()}};class l{constructor(){const a=new MessageChannel,m=new D.$oe;let g=!1;u(a.port2,[a.port2]),a.port1.onmessage=d=>{const{data:S}=d;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const k=y.$Qe.wrap(new Uint8Array(S,0,S.byteLength));if((0,P.$Fn)(k,P.MessageType.Terminate)){g=!0,i("received terminate message from renderer");return}m.fire(k)},this.protocol={onMessage:m.event,send:d=>{if(!g){const S=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);a.port1.postMessage(S,[S])}}}}}function h(o){return new Promise(a=>{const m=o.onMessage(g=>{m.dispose();const d=JSON.parse(g.toString());o.send((0,P.$En)(P.MessageType.Initialized)),a({protocol:o,initData:d})});o.send((0,P.$En)(P.MessageType.Ready))})}let i=o=>b();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const o=new l;return{onmessage(a){n(a)&&h(o.protocol).then(m=>{p.mark("code/extHost/didWaitForInitData");const g=new N.$Tsc(m.protocol,m.initData,c,null,a.data);r(d=>g.asBrowserUri(d)),i=d=>g.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e1db90f81da28c0994b5d50dc2b51e964359e62d/core/vs/workbench/api/worker/extensionHostWorker.js.map
